Unidata NetCDF Fortran Library
========================================

Overview
--------


The Unidata network Common Data Form (netCDF) is an interface for scientific data access and a set of freely-distributed software libraries that provide an implementation of the interface.  The netCDF library also defines a machine-independent format for representing scientific data.  Together, the interface, library, and format support the creation, access, and sharing of scientific data.  This software package provides Fortran application interfaces for accessing netCDF data.  It depends on the netCDF C library, which must be installed first.  Other separate software distributions available from Unidata provide C Java, C++, and Python.  They have been tested on various common platforms.

NetCDF files are self-describing, network-transparent, directly accessible, and extendible.  `Self-describing` means that a netCDF file includes information about the data it contains.  `Network-transparent` means that a netCDF file is represented in a form that can be accessed by computers with different ways of storing integers, characters, and floating-point numbers.  `Direct-access` means that a small subset of a large dataset may be accessed efficiently, without first reading through all the preceding data.  `Extendible` means that data can be appended to a netCDF dataset without copying it or redefining its structure.

NetCDF is useful for supporting access to diverse kinds of scientific data in heterogeneous networking environments and for writing application software that does not depend on application-specific formats.  For information about a variety of analysis and display packages that have been developed to analyze and display data in netCDF form, see

* https://www.unidata.ucar.edu/netcdf/software.html

For more information about netCDF, see the netCDF Web page at

* https://www.unidata.ucar.edu/netcdf/

The netCDF Fortran libraries contain both F77 and F90 APIs. For documentation see

* https://docs.unidata.ucar.edu/netcdf-fortran/current/

Requirements
-------------
* NetCDF-C v4.9.3+

Getting NetCDF
--------------

You can obtain a copy of the latest released versions of netCDF software from

* https://github.com/Unidata/netcdf-c
* https://github.com/Unidata/netcdf-fortran
* https://github.com/Unidata/netcdf-cxx4
* https://github.com/Unidata/netcdf4-python

Copyright and licensing information can be found here, as well as in the COPYRIGHT file accompanying the software

* https://www.unidata.ucar.edu/software/netcdf/copyright.html

To install this package, please see the document:

* https://docs.unidata.ucar.edu/netcdf-c/current/building_netcdf_fortran.html

Mailing List
------------

A mailing list, netcdfgroup@unidata.ucar.edu, exists for discussion of the netCDF interface and announcements about netCDF bugs, fixes, and enhancements.  For information about how to subscribe, see the URL

* https://www.unidata.ucar.edu/netcdf/mailing-lists.html

We appreciate feedback from users of this package.  Please send comments, suggestions, and bug reports to <support-netcdf@unidata.ucar.edu>.  Please identify the version of the package.

 These test programs are modified versions of test programs from
 a previous nf_test. There purpose is to test the use of the Fortran
 2003 modules supplied as replacements for the netcdf and netcdf4 include
 files

  ! Library version, error string
  public :: nf90_inq_libvers, nf90_strerror
  
  ! Control routines 
  public :: nf90_create, nf90_open, nf90_set_base_pe, nf90_inq_base_pe, &
            nf90_set_fill, nf90_redef, nf90_enddef,                     &
            nf90_create_mp, nf90_open_mp,                               &
            nf90_sync, nf90_abort, nf90_close, nf90_delete
            
  ! File level inquiry
  public :: nf90_inquire, nf90_inq_path
  
  ! Dimension routines
  public :: nf90_def_dim, nf90_inq_dimid, nf90_rename_dim, nf90_inquire_dimension
  
  ! attribute routines
  public :: nf90_copy_att, nf90_rename_att, nf90_del_att, nf90_inq_attname, &
            nf90_inquire_attribute
  ! overloaded functions
  public :: nf90_put_att, nf90_get_att
  
  ! Variable routines
  public :: nf90_def_var, nf90_inq_varid, nf90_rename_var, nf90_inquire_variable 
  ! overloaded functions
  public :: nf90_put_var, nf90_get_var

  ! Library version, error string
  public :: nf90_inq_libvers, nf90_strerror
  
  ! Control routines 
  public :: nf90_create, nf90_open, nf90_set_base_pe, nf90_inq_base_pe, &
            nf90_set_fill, nf90_redef, nf90_enddef,                     &
            nf90_create_mp, nf90_open_mp,                               &
            nf90_sync, nf90_abort, nf90_close, nf90_delete
            
  ! File level inquiry
  public :: nf90_inquire, nf90_inq_path, nf90_inq_format
  
  ! Dimension routines
  public :: nf90_def_dim, nf90_inq_dimid, nf90_rename_dim, nf90_inquire_dimension
  
  ! attribute routines
  public :: nf90_copy_att, nf90_rename_att, nf90_del_att, nf90_inq_attname, &
            nf90_inquire_attribute
  ! overloaded functions
  public :: nf90_put_att, nf90_get_att
  
  ! Variable routines
  public :: nf90_def_var, nf90_inq_varid, nf90_rename_var, nf90_inquire_variable 
  ! overloaded functions
  public :: nf90_put_var, nf90_get_var

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program simple_xy_wr.f90.
      
! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_rd
  use netcdf
  implicit none

  ! This is the name of the data file and variable.
  character (len = *), parameter :: FILE_NAME = "simple_xy_nc4.nc"
  character (len = *), parameter :: VAR_NAME = "data"

  ! We are reading 2D data, a 12 x 6 grid. 
  integer, parameter :: NX = 6, NY = 12, MAX_DIMS = 2
  integer :: data_in(NY, NX)

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! Information we will read about the variable.
  character (len = nf90_max_name) :: name
  integer :: xtype, ndims, dimids(MAX_DIMS), natts
  integer :: chunksizes(MAX_DIMS), deflate_level, endianness
  logical :: contiguous, shuffle, fletcher32

  ! Loop indexes, and error handling.
  integer :: x, y

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access
  ! to the file.
  call check( nf90_open(FILE_NAME, NF90_NOWRITE, ncid) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, VAR_NAME, varid) )

  ! Learn about the variable. This uses all optional parameters.
  call check( nf90_inquire_variable(ncid, varid, name, xtype, ndims, &
       dimids, natts, contiguous = contiguous, chunksizes = chunksizes, &
       deflate_level = deflate_level, shuffle = shuffle, &
       fletcher32 = fletcher32, endianness = endianness) )

  ! Make sure we got the correct answers. These depend on what was set
  ! when creating the file in simple_xy_nc4_wr.f90. Endianness will be
  ! whatever is native for the machine that's building this example.
  if (name .ne. VAR_NAME .or. xtype .ne. NF90_INT .or. ndims .ne. 2 .or. &
       natts .ne. 0 .or. contiguous .or. .not. shuffle .or. &
       deflate_level .ne. 1 .or. fletcher32) stop 3

  ! Read the data.
  call check( nf90_get_var(ncid, varid, data_in) )

  ! Check the data.
  do x = 1, NX
     do y = 1, NY
        if (data_in(y, x) /= (x - 1) * NY + (y - 1)) then
           print *, "data_in(", y, ", ", x, ") = ", data_in(y, x)
           stop "Stopped"
        end if
     end do
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_rd

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 variable functions from fortran.

!     Ed Hartnett, 2009

program f90tst_vars3
  use typeSizes
  use netcdf
  implicit none
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_vars3.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 6, NY = 12
  integer :: data_out(NY, NX), data_in(NY, NX)
  integer :: data_out_1d(NX), data_in_1d(NX)

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid1, varid2, varid3, varid4, varid5, dimids(MAX_DIMS)
  integer :: chunksizes(MAX_DIMS), chunksizes_in(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer, parameter :: DEFAULT_CACHE_NELEMS = 10000, DEFAULT_CACHE_SIZE = 1000000
  integer, parameter :: DEFAULT_CACHE_PREEMPTION = 22
  integer, parameter :: DEFLATE_LEVEL = 4
  integer (kind = EightByteInt), parameter :: TOE_SAN_VALUE = 2147483648_EightByteInt
  character (len = *), parameter :: VAR1_NAME = "Chon-Ji"
  character (len = *), parameter :: VAR2_NAME = "Tan-Gun"
  character (len = *), parameter :: VAR3_NAME = "Toe-San"
  character (len = *), parameter :: VAR4_NAME = "Won-Hyo"
  character (len = *), parameter :: VAR5_NAME = "Yul-Guk"
  integer, parameter :: CACHE_SIZE = 8, CACHE_NELEMS = 571, CACHE_PREEMPTION = 66

  ! Information read back from the file to check correctness.
  integer :: varid1_in, varid2_in, varid3_in, varid4_in, varid5_in
  integer :: xtype_in, ndims_in, natts_in, dimids_in(MAX_DIMS)
  character (len = nf90_max_name) :: name_in
  integer :: endianness_in, deflate_level_in
  logical :: shuffle_in, fletcher32_in, contiguous_in
  integer (kind = EightByteInt) :: toe_san_in
  integer :: cache_size_in, cache_nelems_in, cache_preemption_in

  print *, ''
  print *,'*** Testing definition of netCDF-4 vars from Fortran 90.'

  ! Create some pretend data.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do
  do x = 1, NX
        data_out_1d(x) = x
  end do

  ! Create the netCDF file. 
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid, cache_nelems = DEFAULT_CACHE_NELEMS, &
       cache_size = DEFAULT_CACHE_SIZE, cache_preemption = DEFAULT_CACHE_PREEMPTION))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define some variables. 
  chunksizes = (/ NY, NX /)
  call check(nf90_def_var(ncid, VAR1_NAME, NF90_INT, dimids, varid1, chunksizes = chunksizes, &
       shuffle = .TRUE., fletcher32 = .TRUE., endianness = nf90_endian_big, deflate_level = DEFLATE_LEVEL))
  call check(nf90_def_var(ncid, VAR2_NAME, NF90_INT, dimids, varid2, contiguous = .TRUE.))
  call check(nf90_def_var(ncid, VAR3_NAME, NF90_INT64, varid3))
  call check(nf90_def_var(ncid, VAR4_NAME, NF90_INT, x_dimid, varid4, contiguous = .TRUE.))
  call check(nf90_def_var(ncid, VAR5_NAME, NF90_INT, dimids, varid5, chunksizes = chunksizes, &
       deflate_level = DEFLATE_LEVEL, cache_size = CACHE_SIZE, cache_nelems = CACHE_NELEMS, &
       cache_preemption = CACHE_PREEMPTION))

  call check(nf90_inquire_variable(ncid, varid1, cache_size = cache_size_in, &
       cache_nelems = cache_nelems_in, cache_preemption = cache_preemption_in))
!  if (cache_size_in .ne. DEFAULT_CACHE_SIZE .or. cache_nelems_in .ne. &
!       DEFAULT_CACHE_NELEMS .or. cache_preemption_in .ne. DEFAULT_CACHE_PREEMPTION) stop 101
  call check(nf90_inquire_variable(ncid, varid5, cache_size = cache_size_in, &
       cache_nelems = cache_nelems_in, cache_preemption = cache_preemption_in))
  if (cache_size_in .ne. CACHE_SIZE .or. cache_nelems_in .ne. &
       CACHE_NELEMS .or. cache_preemption_in .ne. CACHE_PREEMPTION) stop 1

  ! Write the pretend data to the file.
  call check(nf90_put_var(ncid, varid1, data_out))
  call check(nf90_put_var(ncid, varid2, data_out))
  call check(nf90_put_var(ncid, varid3, TOE_SAN_VALUE))
  call check(nf90_put_var(ncid, varid4, data_out_1d))
  call check(nf90_put_var(ncid, varid5, data_out))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the file.
  call check(nf90_open(FILE_NAME, nf90_nowrite, ncid))
  
  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 5 .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4) stop 2

  ! Get varids.
  call check(nf90_inq_varid(ncid, VAR1_NAME, varid1_in))
  call check(nf90_inq_varid(ncid, VAR2_NAME, varid2_in))
  call check(nf90_inq_varid(ncid, VAR3_NAME, varid3_in))
  call check(nf90_inq_varid(ncid, VAR4_NAME, varid4_in))
  call check(nf90_inq_varid(ncid, VAR5_NAME, varid5_in))

  ! Check variable 1.
  call check(nf90_inquire_variable(ncid, varid1_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, chunksizes = chunksizes_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR1_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. MAX_DIMS .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1) .or. dimids_in(2) .ne. dimids(2)) stop 3
  if (chunksizes_in(1) /= chunksizes(1) .or. chunksizes_in(2) /= chunksizes(2)) &
       stop 4
  if (endianness_in .ne. nf90_endian_big) stop 5

  ! Check variable 2.
  call check(nf90_inquire_variable(ncid, varid2_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR2_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. MAX_DIMS .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1) .or. dimids_in(2) .ne. dimids(2)) stop 6
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 7

  ! Check variable 3.
  call check(nf90_inquire_variable(ncid, varid3_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR3_NAME .or. xtype_in .ne. NF90_INT64 .or. ndims_in .ne. 0 .or. &
       natts_in .ne. 0) stop 8
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 9
  
  ! Check variable 4.
  call check(nf90_inquire_variable(ncid, varid4_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR4_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. 1 .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. x_dimid) stop 10
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 11

  ! Check the data.
  call check(nf90_get_var(ncid, varid1_in, data_in))
  do x = 1, NX
     do y = 1, NY
        if (data_out(y, x) .ne. data_in(y, x)) stop 12
     end do
  end do
  call check(nf90_get_var(ncid, varid2_in, data_in))
  do x = 1, NX
     do y = 1, NY
        if (data_out(y, x) .ne. data_in(y, x)) stop 13
     end do
  end do
  call check(nf90_get_var(ncid, varid3_in, toe_san_in))
  if (toe_san_in .ne. TOE_SAN_VALUE) stop 14
  call check(nf90_get_var(ncid, varid4_in, data_in_1d))
  do x = 1, NX
     if (data_out_1d(x) .ne. data_in_1d(x)) stop 15
  end do
  call check(nf90_get_var(ncid, varid5_in, data_in))
  do x = 1, NX
     do y = 1, NY
        if (data_out(y, x) .ne. data_in(y, x)) stop 12
     end do
  end do

  ! Close the file. 
  call check(nf90_close(ncid))

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_vars3

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some surface pressure and
! temperatures. The data file read by this program is produced
! comapnion program sfc_pres_temp_wr.f90. It is intended to illustrate
! the use of the netCDF fortran 90 API.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program sfc_pres_temp_rd
  use netcdf
  implicit none

  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are reading 2D data, a 12 x 6 lon-lat grid.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"

  ! For the lat lon coordinate netCDF variables.
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid

  ! We will read surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME = "pressure"
  character (len = *), parameter :: TEMP_NAME = "temperature"
  integer :: pres_varid, temp_varid

  ! To check the units attributes.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"
  integer, parameter :: MAX_ATT_LEN = 80
  integer :: att_len
  character*(MAX_ATT_LEN) :: pres_units_in, temp_units_in
  character*(MAX_ATT_LEN) :: lat_units_in, lon_units_in

  ! Read the data into these arrays.
  real, dimension(:,:), allocatable :: pres_in
  real, dimension(:,:), allocatable :: temp_in

  ! These are used to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! We will learn about the data file and store results in these
  ! program variables.
  integer :: ndims_in, nvars_in, ngatts_in, unlimdimid_in

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS))
  allocate(temp_in(NLONS, NLATS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! There are a number of inquiry functions in netCDF which can be
  ! used to learn about an unknown netCDF file. NF90_INQ tells how many
  ! netCDF variables, dimensions, and global attributes are in the
  ! file; also the dimension id of the unlimited dimension, if there
  ! is one.
  call check( nf90_inquire(ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in) )

  ! In this case we know that there are 2 netCDF dimensions, 4 netCDF
  ! variables, no global attributes, and no unlimited dimension.
  if (ndims_in /= 2 .or. nvars_in /= 4 .or. ngatts_in /= 0 &
       .or. unlimdimid_in /= -1) stop 2

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )

  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read the surface pressure and temperature data from the file.
  ! Since we know the contents of the file we know that the data
  ! arrays in this program are the correct size to hold all the data.
  call check( nf90_get_var(ncid, pres_varid, pres_in) )
  call check( nf90_get_var(ncid, temp_varid, temp_in) )

  ! Check the data. It should be the same as the data we wrote.
  do lon = 1, NLONS
     do lat = 1, NLATS
        if (pres_in(lon, lat) /= SAMPLE_PRESSURE + &
             (lon - 1) * NLATS + (lat - 1)) stop 2
        if (temp_in(lon, lat) /= SAMPLE_TEMP + &
             .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
     end do
  end do

  ! Each of the netCDF variables has a "units" attribute. Let's read
  ! them and check them.
  call check( nf90_get_att(ncid, lat_varid, UNITS, lat_units_in) )
  call check( nf90_inquire_attribute(ncid, lat_varid, UNITS, len = att_len) )
  if (lat_units_in(1:att_len) /= LAT_UNITS) stop 2

  call check( nf90_get_att(ncid, lon_varid, UNITS, lon_units_in) )
  call check( nf90_inquire_attribute(ncid, lon_varid, UNITS, len = att_len) )
  if (lon_units_in(1:att_len) /= LON_UNITS) stop 2

  call check( nf90_get_att(ncid, pres_varid, UNITS, pres_units_in) )
  call check( nf90_inquire_attribute(ncid, pres_varid, UNITS, len = att_len) )
  if (pres_units_in(1:att_len) /= PRES_UNITS) stop 2

  call check( nf90_get_att(ncid, temp_varid, UNITS, temp_units_in) )
  call check( nf90_inquire_attribute(ncid, temp_varid, UNITS, len = att_len) )
  if (temp_units_in(1:att_len) /= TEMP_UNITS) stop 2

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_rd

! This is part of the netCDF F90 API, or. Copyright 2006 UCAR. See COPYRIGHT file
! for details.

! This file contains the netcdf-3 file open and create functions.

! $Id: netcdf4_constants.f90,v 1.14 2010/05/25 13:53:00 ed Exp $
! -------
function nf90_open(path, mode, ncid, chunksize)
  character (len = *), intent(in   ) :: path
  integer,             intent(in   ) :: mode
  integer,             intent(  out) :: ncid
  integer, optional,   intent(inout) :: chunksize
  integer                            :: nf90_open

  if(present(chunksize)) then
     nf90_open = nf__open(path, mode, chunksize, ncid)
  else
     nf90_open = nf_open(path, mode, ncid)
  end if
end function nf90_open
! -------
function nf90_create(path, cmode, ncid, initialsize, chunksize)
  character (len = *), intent(in   ) :: path
  integer,             intent(in   ) :: cmode
  integer,             intent(  out) :: ncid
  integer, optional,   intent(in   ) :: initialsize
  integer, optional,   intent(inout) :: chunksize
  integer                            :: nf90_create

  integer :: fileSize, chunk

  if(.not. (present(initialsize) .or. present(chunksize)) ) then
     nf90_create = nf_create(path, cmode, ncid)
  else
     ! Default values per man page
     filesize = 0; chunk = nf90_sizehint_default
     if(present(initialsize)) filesize = initialsize
     if(present(chunksize  )) chunk    = chunksize
     nf90_create = nf__create(path, cmode, filesize, chunk, ncid)
     ! Pass back the value actually used
     if(present(chunksize  )) chunksize = chunk
  end if
end function nf90_create

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is a very simple example which writes a 2D array of
C     sample data. To handle this in netCDF we create two shared
C     dimensions, "x" and "y", and a netCDF variable, called "data".

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program simple_xy_wr
      implicit none
      include 'netcdf.inc'

      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy_nc4.nc')
      integer NDIMS
      parameter (NDIMS = 2)
      integer NX, NY
      parameter (NX = 60, NY = 120)
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid
      integer data_out(NY, NX)
      integer x, y, retval
      integer chunks(2)
      integer contiguous, shuffle, deflate, deflate_level

C     Create some pretend data. If this wasn't an example program, we
C     would have some real data to write, for example, model output.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

C     Create the netCDF file. The nf_netcdf4  tells netCDF to
C     create a netCDF-4/HDF5 file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the IDs of the dimensions of
C     the variables. Note that in fortran arrays are stored in
C     column-major format.
      dimids(2) = x_dimid
      dimids(1) = y_dimid

C     Define the variable. 
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Set up chunking and compression.
      contiguous = 0
      chunks(1) = NY
      chunks(2) = NX
      shuffle = 1
      deflate = 1
      deflate_level = 4

      retval = nf_def_var_chunking(ncid, varid, contiguous, chunks)
      if (retval .ne. nf_noerr) call handle_err(retval)

      retval = nf_def_var_deflate(ncid, varid, shuffle, deflate,
     &     deflate_level)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS writing example file simple_xy_nc4.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is a very simple example which writes a 2D array of
C     sample data. To handle this in netCDF we create two shared
C     dimensions, "x" and "y", and a netCDF variable, called "data".

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program simple_xy_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy.nc')

C     We are writing 2D data, a 12 x 6 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     When we create netCDF files, variables and dimensions, we get back
C     an ID for each one.
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid

C     This is the data array we will write. It will just be filled with
C     a progression of integers for this example.
      integer data_out(NY, NX)

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data. If this wasn't an example program, we
C     would have some real data to write, for example, model output.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

C     Always check the return code of every netCDF function call. In
C     this example program, any retval which is not equal to nf_noerr
C     (0) will call handle_err, which prints a netCDF error message, and
C     then exits with a non-zero return code.

C     Create the netCDF file. The nf_clobber parameter tells netCDF to
C     overwrite this file, if it already exists.
      retval = nf_create(FILE_NAME, NF_CLOBBER, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions. NetCDF will hand back an ID for each. 
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the IDs of the dimensions of
C     the variables. Note that in fortran arrays are stored in
C     column-major format.
      dimids(2) = x_dimid
      dimids(1) = y_dimid

C     Define the variable. The type of the variable in this case is
C     NF_INT (4-byte integer).
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode. This tells netCDF we are done defining metadata.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data to the file. Although netCDF supports
C     reading and writing subsets of data, in this case we write all the
C     data in one operation.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file. This frees up any internal netCDF resources
C     associated with the file, and flushes any buffers.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS writing example file simple_xy.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF package.  Copyright 2006 University
! Corporation for Atmospheric Research/Unidata.  See COPYRIGHT file
! for conditions of use.

! This is a very simple example which writes a 2D array of sample
! data. To handle this in netCDF we create two shared dimensions, "x"
! and "y", and a netCDF variable, called "data".

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "simple_xy.nc"

  ! We are writing 2D data, a 12 x 6 grid. 
  integer, parameter :: NDIMS = 2
  integer, parameter :: NX = 6, NY = 12

  ! When we create netCDF files, variables and dimensions, we get back
  ! an ID for each one.
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid
  
  ! This is the data array we will write. It will just be filled with
  ! a progression of integers for this example.
  integer, dimension(:,:), allocatable :: data_out

  ! Loop indexes, and error handling.
  integer :: x, y

  ! Allocate memory for data.
  allocate(data_out(NY, NX))

  ! Create some pretend data. If this wasn't an example program, we
  ! would have some real data to write, for example, model output.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Always check the return code of every netCDF function call. In
  ! this example program, wrapping netCDF calls with "call check()"
  ! makes sure that any return which is not equal to nf90_noerr (0)
  ! will print a netCDF error message and exit.

  ! Create the netCDF file. The nf90_clobber parameter tells netCDF to
  ! overwrite this file, if it already exists.
  call check( nf90_create(FILE_NAME, NF90_CLOBBER, ncid) )

  ! Define the dimensions. NetCDF will hand back an ID for each. 
  call check( nf90_def_dim(ncid, "x", NX, x_dimid) )
  call check( nf90_def_dim(ncid, "y", NY, y_dimid) )

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer).
  call check( nf90_def_var(ncid, "data", NF90_INT, dimids, varid) )

  ! End define mode. This tells netCDF we are done defining metadata.
  call check( nf90_enddef(ncid) )

  ! Write the pretend data to the file. Although netCDF supports
  ! reading and writing subsets of data, in this case we write all the
  ! data in one operation.
  call check( nf90_put_var(ncid, varid, data_out) )

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  print *, "*** SUCCESS writing example file simple_xy.nc! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_wr

!     This is part of the netCDF package. Copyright 2011 University
!     Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
!     for conditions of use.

!     This program tests netCDF-4 parallel I/O from fortran. This
!     variation of the test was contributed by Dan at NASA. Thanks Dan!

      program ftst_parallel_nasa
      implicit none
      include 'netcdf.inc'
      include 'mpif.h'

      integer mode_flag ! file create mode
      integer p, my_rank, ierr

      call MPI_Init(ierr)
      call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
      call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

      if (my_rank .eq. 0) then
         print *, ' '
         print *, '*** Testing netCDF-4 parallel I/O from F77 again.'
      endif

!     There must be 4 procs for this test.
      if (p .ne. 4) then
         print *, 'This test program must be run on 4 processors.'
         stop 2
      endif

#ifdef NF_HAS_PNETCDF
      mode_flag = IOR(nf_clobber, nf_mpiio)
      call parallel_io(mode_flag)
#endif

#ifdef NF_HAS_PARALLEL4
      mode_flag = IOR(nf_netcdf4, nf_classic_model)
      mode_flag = IOR(mode_flag, nf_clobber)
      mode_flag = IOR(mode_flag, nf_mpiio)
      call parallel_io(mode_flag)
#endif

      call MPI_Finalize(ierr)

      if (my_rank .eq. 0) print *,'*** SUCCESS!'

      end program ftst_parallel_nasa

      subroutine parallel_io(mode_flag)
      implicit none
      include 'netcdf.inc'
      include 'mpif.h'

      integer mode_flag ! file create mode
      character*(*) FILE_NAME
      parameter (FILE_NAME = 'ftst_parallel_nasa.nc')

      integer MAX_DIMS
      parameter (MAX_DIMS = 2)
      integer NX, NY
      parameter (NX = 16)
      parameter (NY = 16)
      integer NUM_PROC
      parameter (NUM_PROC = 4)
      integer ncid, varid, dimids(MAX_DIMS)
      integer x_dimid, y_dimid
      real data_out(NY / 2, NX / 2), data_in(NY / 2, NX / 2)
      integer x, y, retval
      integer my_rank, ierr
      integer start(MAX_DIMS), count(MAX_DIMS)

      call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)

!     Create some pretend data.
      do x = 1, NX / 2
         do y = 1, NY / 2
            data_out(y, x) = real(my_rank)
         end do
      end do

!     Create the netCDF file.
      retval = nf_create_par(FILE_NAME, mode_flag, MPI_COMM_WORLD,
     $     MPI_INFO_NULL, ncid)
      if (retval .ne. nf_noerr) stop 3

!     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) stop 4
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) stop 5
      dimids(1) = x_dimid
      dimids(2) = y_dimid

!     Define the variable.
      retval = nf_def_var(ncid, "data", NF_FLOAT, MAX_DIMS, dimids,
     $     varid)
      if (retval .ne. nf_noerr) stop 6

!     With classic model netCDF-4 file, enddef must be called.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) stop 7

!     Determine what part of the variable will be written for this
!     processor. It's a checkerboard decomposition.
      count(1) = NX / 2
      count(2) = NY / 2
      if (my_rank .eq. 0) then
         start(1) = 1
         start(2) = 1
      else if (my_rank .eq. 1) then
         start(1) = NX / 2 + 1
         start(2) = 1
      else if (my_rank .eq. 2) then
         start(1) = 1
         start(2) = NY / 2 + 1
      else if (my_rank .eq. 3) then
         start(1) = NX / 2 + 1
         start(2) = NY / 2 + 1
      endif

!     Write this processor's data.
      retval = nf_put_vara_real(ncid, varid, start, count, data_out)
      if (retval .ne. nf_noerr) then
         print*,'Error writing data ', retval
         print*, NF_STRERROR(retval)
         stop 8
      endif

!     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 9

!     Reopen the file.
      retval = nf_open_par(FILE_NAME, IOR(nf_nowrite, nf_mpiio),
     $     MPI_COMM_WORLD, MPI_INFO_NULL, ncid)
      if (retval .ne. nf_noerr) stop 10

!     Set collective access on this variable. This will cause all
!     reads/writes to happen together on every processor. Fairly
!     pointless, in this contexct, but I want to at least call this
!     function once in my testing.
      retval = nf_var_par_access(ncid, varid, nf_collective)
      if (retval .ne. nf_noerr) stop 11

!     Read this processor's data.
      retval = nf_get_vara_real(ncid, varid, start, count, data_in)
      if (retval .ne. nf_noerr) stop 12

!     Check the data.
      do x = 1, NX / 2
         do y = 1, NY / 2
            if (data_in(y, x) .ne. my_rank) then
               print*,data_in(y, x), ' NE ', my_rank
               stop 13
            endif
         end do
      end do

!     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 14
      end subroutine parallel_io

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This example writes some surface pressure and temperatures. It is
! intended to illustrate the use of the netCDF fortran 90 API. The
! companion program sfc_pres_temp_rd.f90 shows how to read the netCDF
! data file created by this program.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program sfc_pres_temp_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
  ! netCDF dimensions.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  integer :: lat_dimid, lon_dimid

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude netCDF variables which will hold the
  ! actual latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! We will write surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! It's good practice for each variable to carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! We will create some pressure and temperature data to write out.
  real, dimension(:,:), allocatable :: temp_out
  real, dimension(:,:), allocatable :: pres_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS))
  allocate(temp_out(NLONS, NLATS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  do lon = 1, NLONS
     do lat = 1, NLATS
        pres_out(lon, lat) = SAMPLE_PRESSURE + (lon - 1) * NLATS + (lat - 1)
        temp_out(lon, lat) = SAMPLE_TEMP + .25 * ((lon - 1) * NLATS + (lat - 1))
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, nf90_clobber, ncid) )

  ! Define the dimensions.
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )

  ! Define the coordinate variables. They will hold the coordinate
  ! information, that is, the latitudes and longitudes. A varid is
  ! returned for each.
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate var data. This attaches a
  ! text attribute to each of the coordinate variables, containing the
  ! units.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! Define the netCDF variables. The dimids array is used to pass the
  ! dimids of the dimensions of the netCDF variables.
  dimids = (/ lon_dimid, lat_dimid /)
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the pressure and temperature netCDF
  ! variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )

  ! End define mode.
  call check( nf90_enddef(ncid) )

  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays of data are the same size as
  ! the netCDF variables we have defined.
  call check( nf90_put_var(ncid, pres_varid, pres_out) )
  call check( nf90_put_var(ncid, temp_varid, temp_out) )

  ! Close the file.
  call check( nf90_close(ncid) )
   
  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS writing example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_wr

  ! ----- 
  ! Variable definitions and inquiry
  ! ----- 
  function nf90_def_var_Scalar(ncid, name, xtype, varid)
    integer,               intent( in) :: ncid
    character (len = *),   intent( in) :: name
    integer,               intent( in) :: xtype
    integer,               intent(out) :: varid
    integer                            :: nf90_def_var_Scalar
    
    ! Dummy - shouldn't get used
    integer, dimension(1) :: dimids
    
    nf90_def_var_Scalar = nf_def_var(ncid, name, xtype, 0, dimids, varid)
  end function nf90_def_var_Scalar
  ! ----- 
  function nf90_def_var_oneDim(ncid, name, xtype, dimids, varid)
    integer,               intent( in) :: ncid
    character (len = *),   intent( in) :: name
    integer,               intent( in) :: xtype
    integer,               intent( in) :: dimids
    integer,               intent(out) :: varid
    integer                            :: nf90_def_var_oneDim
    
    integer, dimension(1) :: dimidsA
    dimidsA(1) = dimids
    nf90_def_var_oneDim = nf_def_var(ncid, name, xtype, 1, dimidsA, varid)
  end function nf90_def_var_oneDim
  ! ----- 
  function nf90_def_var_ManyDims(ncid, name, xtype, dimids, varid)
    integer,               intent( in) :: ncid
    character (len = *),   intent( in) :: name
    integer,               intent( in) :: xtype
    integer, dimension(:), intent( in) :: dimids
    integer,               intent(out) :: varid
    integer                            :: nf90_def_var_ManyDims
    
    nf90_def_var_ManyDims = nf_def_var(ncid, name, xtype, size(dimids), dimids, varid)
  end function nf90_def_var_ManyDims
  ! ----- 
  function nf90_inq_varid(ncid, name, varid)
    integer,             intent( in) :: ncid
    character (len = *), intent( in) :: name
    integer,             intent(out) :: varid
    integer                          :: nf90_inq_varid
    
    nf90_inq_varid = nf_inq_varid(ncid, name, varid)
  end function nf90_inq_varid
  ! ----- 
  function nf90_inquire_variable(ncid, varid, name, xtype, ndims, dimids, nAtts)
    integer,                         intent( in) :: ncid, varid
    character (len = *),   optional, intent(out) :: name
    integer,               optional, intent(out) :: xtype, ndims 
    integer, dimension(:), optional, intent(out) :: dimids
    integer,               optional, intent(out) :: nAtts
    integer                                      :: nf90_inquire_variable
    
    ! Local variables
    character (len = nf90_max_name)       :: varName
    integer                               :: externalType, numDimensions
    integer, dimension(nf90_max_var_dims) :: dimensionIDs
    integer                               :: numAttributes
    
    nf90_inquire_variable = nf_inq_var(ncid, varid, varName, externalType, &
                                       numDimensions, dimensionIDs, numAttributes)
    if (nf90_inquire_variable == nf90_noerr) then
        if(present(name))   name                   = trim(varName)
        if(present(xtype))  xtype                  = externalType
        if(present(ndims))  ndims                  = numDimensions
        if(present(dimids)) then
            if (size(dimids) .ge. numDimensions) then
                dimids(:numDimensions) = dimensionIDs(:numDimensions)
            else
                nf90_inquire_variable = nf90_einval
            endif
        endif
        if(present(nAtts))  nAtts                  = numAttributes
    endif
  end function nf90_inquire_variable
  ! ----- 
  function nf90_rename_var(ncid, varid, newname)
    integer,             intent( in) :: ncid, varid
    character (len = *), intent( in) :: newname
    integer                          :: nf90_rename_var
    
    nf90_rename_var = nf_rename_var(ncid, varid, newname)
  end function nf90_rename_var
  ! ----- 

C     This is part of netCDF, Copyright 2006, UCAR

C     This test program uses the fortran 77 v2 API to create a simple
C     data file with some phony data in it. This program was originally
C     based on one contributed by Jeremy Kepner,
C     jvkepner@astro.Princeton.EDU.

C     Also test the char array bug reported in
C     https://github.com/Unidata/netcdf-fortran/issues/329.

C     This program will bail out in the event of a netcdf error.

C     Ed Hartnett, 2009

C     MODS
C     Leon Benjamin, 2022 -- Add test multi-dimensional char variables

      PROGRAM tst_f77_v2
      IMPLICIT NONE
      include 'netcdf.inc'

      INTEGER n_dim, x_dim, y_dim, z_dim
      PARAMETER(n_dim = 3, x_dim = 20, y_dim = 10, z_dim = 5)
      INTEGER dim_array(n_dim)
      INTEGER start(n_dim), count(n_dim)
      integer char_len
      parameter(char_len = 14)
      character*14 char_string(2)
      INTEGER start_1d(2), count_1d(2)      
      INTEGER ncid, errcode
      INTEGER x_id, y_id, z_id, arr_id, char_id, char_dim_id
      REAL array(x_dim,y_dim,z_dim)
      INTEGER i,j,k

      character*10 char_dim_name_in
      integer char_dim_size_in
      character*11 char_var_name_in
      integer var_type_in, nvdims_in
      integer vdims_in(3)
      integer natts_in
      character*14 char_string_in(2)
      integer char_len_in
      char_len_in = 14

C     Put something into the array.
      DO i=1,x_dim
         DO j=1,y_dim
            DO k=1,z_dim
               array(i,j,k) = (i-1) + x_dim*(j-1) + x_dim*y_dim*(k-1)
            ENDDO
         ENDDO
      ENDDO

C     Put something into the character string.      
      char_string(1) = 'dirty_old_town'
      char_string(2) = 'clean_new_town'

      print *, ''
      print *, ' *** Testing netCDF v2 api for F77.'

C     Create file.
      ncid = NCCRE('tst03_f77_v2.nc', NCCLOB, errcode)
      if (errcode .ne. 0) stop 2

C     Create Dimensions for floating point data.
      x_id = NCDDEF(ncid, 'X', x_dim, errcode)
      y_id = NCDDEF(ncid, 'Y', y_dim, errcode)
      z_id = NCDDEF(ncid, 'Z', z_dim, errcode)

C     Assign dimensions to array.
      dim_array(1) = z_id
      dim_array(2) = y_id
      dim_array(3) = x_id

C     Create a float variable.
      arr_id = NCVDEF(ncid, 'array', NCFLOAT, n_dim, dim_array, errcode)
      if (errcode .ne. 0) stop 2

C     Create Dimension for char array.
      char_dim_id = NCDDEF(ncid, 'string_len', char_len, errcode)
      if (errcode .ne. 0) stop 2
      dim_array(1) = char_dim_id
C     Create Dimension for char array.
      dim_array(2) = NCDDEF(ncid, 'list_size', 2, errcode)
      if (errcode .ne. 0) stop 2

      char_id = NCVDEF(ncid, 'Dublin_song', NCCHAR, 2, dim_array,
     &     errcode)
      if (errcode .ne. 0) stop 2
      
C     Leave define mode.
      CALL NCENDF(ncid, errcode)
      if (errcode .ne. 0) stop 2

C     Write float data to file.
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = z_dim
      count(2) = y_dim
      count(3) = x_dim
      CALL NCVPT(ncid, arr_id, start, count, array, errcode)
      if (errcode .ne. 0) stop 2

C     Write char data to file.
      start_1d(1) = 1
      count_1d(1) = char_len
      start_1d(2) = 1
      count_1d(2) = 2
      CALL NCVPTC(ncid, char_id, start_1d, count_1d, char_string,
     &     char_len*2, errcode)
      if (errcode .ne. 0) stop 2

C     Close the file.
      CALL NCCLOS(ncid, errcode)
      if (errcode .ne. 0) stop 2

C     Reopen the file.
      ncid = NCOPN('tst03_f77_v2.nc', NCNOWRIT, errcode)
      if (errcode .ne. 0) stop 2

      
C     Learn about char array dimension.
      call NCDINQ(NCID, 4, char_dim_name_in, char_dim_size_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_dim_size_in .ne. char_len) stop 3
      if (char_dim_name_in .ne. 'string_len') stop 4

C     Learn about the char array data.
      call NCVINQ(NCID, 2, char_var_name_in, var_type_in, nvdims_in,
     &     vdims_in, natts_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_var_name_in .ne. 'Dublin_song') stop 5
      if (var_type_in .ne. NCCHAR) stop 6
      if (nvdims_in .ne. 2) stop 7
      if (vdims_in(1) .ne. 4) stop 8
      if (natts_in .ne. 0) stop 9

C     Read the data in the char array.
      start_1d(1) = 1
      count_1d(1) = char_len
      start_1d(2) = 1
      count_1d(2) = 2
      char_len_in = char_len*2
      CALL NCVGTC(ncid, char_id, start_1d, count_1d, char_string_in,
     &     char_len_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_string_in(1) .ne. 'dirty_old_town') stop 10
      if (char_string_in(2) .ne. 'clean_new_town') stop 11
      
C     Close the file.
      CALL NCCLOS(ncid, errcode)
      if (errcode .ne. 0) stop 2

      print *, ' *** SUCCESS!'

      END

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some 4D pressure and
C     temperatures. The data file read by this program is produced by
C     the companion program pres_temp_4D_wr.f. It is intended to
C     illustrate the use of the netCDF Fortran 77 API.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program pres_temp_4D_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='pres_temp_4D.nc')
      integer ncid

C     We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')

C     The start and count arrays will tell the netCDF library where to
C     read our data.
      integer start(NDIMS), count(NDIMS)

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude variables which will hold the actual
C     latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will read surface temperature and pressure fields. In netCDF
C     terminology these are called "variables."
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will read in. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_in(NLONS, NLATS, NLVLS)
      real temp_in(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to calculate the values we expect to find.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read 1 record of NLONS*NLATS*NLVLS values, starting at the
C     beginning of the record (the (1, 1, 1, rec) element in the netCDF
C     file).
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Read the surface pressure and temperature data from the file, one
C     record at a time.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_get_vara_real(ncid, pres_varid, start, count,
     $        pres_in)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_get_vara_real(ncid, temp_varid, start, count,
     $        temp_in)
         if (retval .ne. nf_noerr) call handle_err(retval)

         i = 0
         do lvl = 1, NLVLS
            do lat = 1, NLATS
               do lon = 1, NLONS
                  if (pres_in(lon, lat, lvl) .ne. SAMPLE_PRESSURE + i) 
     $                 stop 2
                  if (temp_in(lon, lat, lvl) .ne. SAMPLE_TEMP + i)
     $                 stop 2
                  i = i + 1
               end do
            end do
         end do
C     next record
      end do
         
C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file pres_temp_4D.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     Copyright 1996, UCAR/Unidata
C     See netcdf/COPYRIGHT file for copying and redistribution conditions.

C     Steve Emmerson, Ed Hartnett

C
C     Use for logging error messages
C
      subroutine error(msg)
      implicit none
#include "tests.inc"
      character*(*)   msg

      nfails = nfails + 1
      if (nfails .le. max_nmpt) print *, msg
      end


C
C     Use for logging error conditions
C
      subroutine errori(msg, i)
      implicit none
#include "tests.inc"
      character*(*)   msg
      integer         i

      nfails = nfails + 1
      if (nfails .le. max_nmpt) print *, msg, i
      end


C
C     Use for logging error conditions
C
      subroutine errord(msg, d)
      implicit none
#include "tests.inc"
      character*(*)   msg
      doubleprecision d

      nfails = nfails + 1
      if (nfails .le. max_nmpt) print *, msg, d
      end


C
C     Use for logging error conditions
C
      subroutine errorc(msg, string)
      implicit none
#include "tests.inc"
      character*(*)   msg
      character*(*)   string

      nfails = nfails + 1
      if (nfails .le. max_nmpt) print *, msg,
     +     string(1:len_trim(string))
      end


C
C     Use for logging error conditions
C
      subroutine errore(msg, err)
      implicit none
#include "tests.inc"
      character*(*)   msg
      integer         err

      call errorc(msg, nf_strerror(err))
      end

Module netcdf_nf_interfaces

! Explicit interfaces for Netcdf FORTRAN 2003 nf FORTRAN interface routines
! Generic interfaces are provided for routines that process text data to
! handle the case where you are using this interface module and are passing
! an array of single characters (ala C) instead of a character string.

! We choose not to provide explicit interfaces for the V2 routines and
! newer functions for netCDF4 that pass data of any type to/from void
! pointers in C using a C_CHAR string array. We do provide external
! statements for the V2 functions as done in netcdf2.inc

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu


! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1. Sept. 2005 - Initial Cray X1 version
! Version 2. May, 2006  - Updated to support g95
! Version 3. April 2009 - Updated for netCDF 4.0.1
! Version 4. April 2010 - Updated for netCDF 4.1.1
! Version 5. Feb.  2013 - Added nf_inq_path support for fortran 4.4
! Version 6. Jan.  2016 - General code cleanup, added interface for
!                         nf_open_mem function
         
! Most legacy programs don't need to use this module. However, I've created
! it to support FORTRAN programmers who like to provide explicit interfaces
! for all subroutines and functions in their codes. Therefore, this module is
! is primarily for people writting new programs.

 Implicit NONE

!-------------------- Explicit Interfaces for nf routines ------------------

! Misc functions first
!-------------------------------- nf_inq_libvers -------------------------------
Interface
 Function nf_inq_libvers() RESULT(vermsg)

 Character(LEN=80) :: vermsg

 End Function nf_inq_libvers
End Interface
!-------------------------------- nf_strerror ---------------------------------
Interface
 Function nf_strerror(nerr) RESULT(errmsg)

 Integer, Intent(IN) :: nerr

 Character(LEN=80)   :: errmsg

 End Function nf_strerror
End Interface
!-------------------------------- nf_issyserr ---------------------------------
Interface
 Function nf_issyserr(nerr) RESULT(status)

 Integer, Intent(IN) :: nerr
 Logical             :: status

 End Function nf_issyserr
End Interface

! Control routines
!-------------------------------- nf_create -----------------------------------
Interface
 Function nf_create(path, cmode, ncid) RESULT (status)

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode
 Integer,          Intent(OUT) :: ncid
 Integer                       :: status

 End Function nf_create
End Interface
!-------------------------------- nf_create_par -------------------------------
Interface
 Function nf_create_par (path, cmode, comm, info, ncid) RESULT(status)

 Integer,          Intent(IN)  :: cmode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid
 Integer                       :: status

 End Function nf_create_par
End Interface
!-------------------------------- nf__create ----------------------------------
Interface
 Function nf__create(path, cmode, initialsz, chunksizehintp, ncid) &
                        RESULT(status)

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode, initialsz, chunksizehintp
 Integer,          Intent(OUT) :: ncid
 Integer                       :: status

 End Function nf__create
End Interface
!-------------------------------- nf__create_mp -------------------------------
Interface
 Function nf__create_mp(path, cmode, initialsz, basepe, chunksizehintp, ncid) &
                        RESULT(status)

 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(IN)  :: cmode, initialsz, chunksizehintp, basepe
 Integer,          Intent(OUT) :: ncid
 Integer                       :: status

 End Function nf__create_mp
End Interface
!-------------------------------- nf_open -------------------------------------
Interface
 Function nf_open(path, mode, ncid) RESULT (status)

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode
 Integer,          Intent(INOUT) :: ncid
 Integer                         :: status

 End Function nf_open
End Interface
!-------------------------------- nf_open_par --------------------------------
Interface
 Function nf_open_par (path, mode, comm, info, ncid) RESULT(status)

 Integer,          Intent(IN)  :: mode, comm, info
 Character(LEN=*), Intent(IN)  :: path
 Integer,          Intent(OUT) :: ncid
 Integer                       :: status

 End Function nf_open_par
End Interface
!-------------------------------- nf__open ------------------------------------
Interface
 Function nf__open(path, mode, chunksizehintp, ncid) RESULT (status)

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode, chunksizehintp
 Integer,          Intent(INOUT) :: ncid
 Integer                         :: status

 End Function nf__open
End Interface
!-------------------------------- nf__open_mp ---------------------------------
Interface
 Function nf__open_mp(path, mode, basepe, chunksizehintp, ncid) RESULT (status)

 Character(LEN=*), Intent(IN)    :: path
 Integer,          Intent(IN)    :: mode, chunksizehintp, basepe
 Integer,          Intent(INOUT) :: ncid
 Integer                         :: status

 End Function nf__open_mp
End Interface
!-------------------------------- nf_open_mem ---------------------------------
Interface nf90_open_mem
 Function nf_open_mem(path, mode, size, memory, ncid) RESULT (status)

 USE ISO_C_BINDING, ONLY : C_CHAR

 Character(LEN=*),       Intent(IN)           :: path
 Integer,                Intent(IN)           :: mode
 Integer,                Intent(IN)           :: size 
 Character(KIND=C_CHAR), Intent(IN),   TARGET :: memory(*)
 Integer,                Intent(INOUT)        :: ncid

 Integer                               :: status

 End Function nf_open_mem
End Interface
!-------------------------------- nf_var_par_access -------------------------
Interface
 Function nf_var_par_access( ncid, varid, iaccess) RESULT (status)

 Integer, Intent(IN) :: ncid, varid, iaccess
 Integer             :: status

 End Function nf_var_par_access
End Interface
!-------------------------------- nf_inq_path ---------------------------------
Interface
 Function nf_inq_path(ncid, pathlen, path) RESULT (status)

 Integer,          Intent(IN)    :: ncid
 Integer,          Intent(INOUT) :: pathlen
 Character(LEN=*), Intent(INOUT) :: path
 Integer                         :: status

 End Function nf_inq_path
End Interface
!-------------------------------- nf_set_fill ---------------------------------
Interface
 Function nf_set_fill(ncid, fillmode, old_mode) RESULT(status)

 Integer, Intent(IN)  :: ncid, fillmode
 Integer, Intent(OUT) :: old_mode
 Integer              :: status

 End Function nf_set_fill
End Interface
!-------------------------------- nf_set_default_format -----------------------
Interface
 Function nf_set_default_format(newform, old_format) RESULT(status)

 Integer, Intent(IN)  :: newform
 Integer, Intent(OUT) :: old_format
 Integer              :: status

 End Function nf_set_default_format
End Interface
!-------------------------------- nf_redef -----------------------------------
Interface
 Function nf_redef(ncid) RESULT(status)

 Integer, Intent(IN) :: ncid
 Integer             :: status

 End Function nf_redef
End Interface
!-------------------------------- nf_enddef -----------------------------------
Interface
 Function nf_enddef(ncid) RESULT(status)

 Integer, Intent(IN) :: ncid
 Integer             :: status

 End Function nf_enddef
End Interface
!-------------------------------- nf__enddef ---------------------------------
Interface
 Function nf__enddef(ncid, h_minfree, v_align, v_minfree, r_align) &
                        RESULT(status)

 Integer, Intent(IN) :: ncid, h_minfree, v_align, v_minfree, r_align
 Integer             :: status

 End Function nf__enddef
End Interface

!-------------------------------- nf_sync -------------------------------------
Interface
 Function nf_sync(ncid) RESULT(status)

 Integer, Intent(IN) :: ncid
 Integer             :: status

 End Function nf_sync
End Interface
!-------------------------------- nf_abort -----------------------------------
Interface
 Function nf_abort(ncid) RESULT(status)

 Integer, Intent(IN) :: ncid
 Integer             :: status

 End Function nf_abort
End Interface
!-------------------------------- nf_close -------------------------------------
Interface
 Function nf_close(ncid) RESULT(status)

 Integer, Intent(IN) :: ncid
 Integer             :: status

 End Function nf_close
End Interface
!-------------------------------- nf_delete -----------------------------------
Interface
 Function nf_delete(path) RESULT(status)

 Character(LEN=*), Intent(IN) :: path
 Integer                      :: status

 End Function nf_delete
End Interface
!-------------------------------- nf_delete_mp ---------------------------------
Interface
 Function nf_delete_mp(path, pe) RESULT(status)

 Character(LEN=*), Intent(IN) :: path
 Integer,          Intent(IN) :: pe
 Integer                      :: status

 End Function nf_delete_mp
End Interface
!-------------------------------- nf_set_base_pe ------------------------------
Interface
 Function nf_set_base_pe(ncid, pe) RESULT(status)

 Integer, Intent(IN) :: ncid, pe
 Integer             :: status

 End Function nf_set_base_pe
End Interface
!-------------------------------- nf_inq_base_pe ------------------------------
Interface
 Function nf_inq_base_pe(ncid, pe) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: pe
 Integer              :: status

 End Function nf_inq_base_pe
End Interface

! Dimension definition and inquiry functions

!-------------------------------- nf_def_dim ----------------------------------
Interface
 Function nf_def_dim(ncid, name, dlen, dimid) RESULT (status)

 Integer,          Intent(IN)  :: ncid, dlen
 Integer,          Intent(OUT) :: dimid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_def_dim
End Interface
!-------------------------------- nf_inq_dim ----------------------------------
Interface
 Function nf_inq_dim(ncid, dimid, name, dlen) RESULT (status)

 Integer,          Intent(IN)   :: ncid, dimid
 Integer,          Intent(OUT)  :: dlen
 Character(LEN=*), Intent(OUT)  :: name
 Integer                        :: status

 End Function nf_inq_dim
End Interface
!-------------------------------- nf_inq_dimid --------------------------------
Interface
 Function nf_inq_dimid(ncid, name, dimid) RESULT (status)

 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: dimid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_dimid
End Interface
!-------------------------------- nf_inq_dimlen -------------------------------
Interface
 Function nf_inq_dimlen(ncid, dimid, dlen) RESULT (status)

 Integer, Intent(IN)  :: ncid, dimid
 Integer, Intent(OUT) :: dlen
 Integer              :: status

 End Function nf_inq_dimlen
End Interface
!-------------------------------- nf_inq_dimname ------------------------------
Interface
 Function nf_inq_dimname (ncid, dimid, name) RESULT (status)

 Integer,          Intent(IN)   :: ncid, dimid
 Character(LEN=*), Intent(OUT)  :: name
 Integer                        :: status

 End Function nf_inq_dimname
End Interface
!-------------------------------- nf_rename_dim --------------------------------
Interface
 Function nf_rename_dim(ncid, dimid, name) RESULT (status)

 Integer,          Intent(IN)  :: ncid, dimid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_rename_dim
End Interface

! General inquiry functions

!-------------------------------- nf_inq --------------------------------------
Interface
 Function nf_inq(ncid, ndims, nvars, ngatts, unlimdimid) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ndims, nvars, ngatts, unlimdimid
 Integer              :: status

 End Function nf_inq
End Interface
!-------------------------------- nf_inq_ndims --------------------------------
Interface
 Function nf_inq_ndims(ncid, ndims) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ndims
 Integer              :: status

 End Function nf_inq_ndims
End Interface
!-------------------------------- nf_inq_nvars --------------------------------
Interface
 Function nf_inq_nvars(ncid, nvars) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: nvars
 Integer              :: status

 End Function nf_inq_nvars
End Interface
!-------------------------------- nf_inq_natts --------------------------------
Interface
 Function nf_inq_natts(ncid, ngatts) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: ngatts
 Integer              :: status

 End Function nf_inq_natts
End Interface
!-------------------------------- nf_inq_unlimdim -----------------------------
Interface
 Function nf_inq_unlimdim(ncid, unlimdimid) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: unlimdimid
 Integer              :: status

 End Function nf_inq_unlimdim
End Interface
!-------------------------------- nf_inq_format -------------------------------
Interface
 Function nf_inq_format(ncid, format_type) RESULT(status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: format_type
 Integer              :: status

 End Function nf_inq_format
End Interface

! General variable functions

!-------------------------------- nf_def_var -----------------------------------
Interface
 Function nf_def_var(ncid, name, xtype, nvdims, vdims, varid) RESULT (status)

 Integer,          Intent(IN)  :: ncid, xtype, nvdims
 Integer,          Intent(IN)  :: vdims(*)
 Integer,          Intent(OUT) :: varid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_def_var
End Interface
!-------------------------------- nf_inq_varndims -----------------------------
Interface
 Function nf_inq_varndims(ncid, varid, vndims) RESULT (status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: vndims
 Integer              :: status

 End Function nf_inq_varndims
End Interface
!-------------------------------- nf_inq_var ----------------------------------
Interface
 Function nf_inq_var(ncid, varid, name, xtype, ndims, dimids, natts) &
                        RESULT (status)

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: dimids(*)
 Integer,          Intent(OUT) :: ndims, xtype, natts
 Integer                       :: status

 End Function nf_inq_var
End Interface
!-------------------------------- nf_inq_vardimid -----------------------------
Interface
 Function nf_inq_vardimid(ncid, varid, dimids) RESULT (status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: dimids(*)
 Integer              :: status

 End Function nf_inq_vardimid
End Interface
!-------------------------------- nf_inq_varid --------------------------------
Interface
 Function nf_inq_varid(ncid, name, varid) RESULT (status)

 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: varid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_varid
End Interface
!-------------------------------- nf_inq_varname ------------------------------
Interface
 Function nf_inq_varname (ncid, varid, name) RESULT (status)

 Integer,          Intent(IN)   :: ncid, varid
 Character(LEN=*), Intent(OUT)  :: name
 Integer                        :: status

 End Function nf_inq_varname
End Interface
!-------------------------------- nf_inq_vartype ------------------------------
Interface
 Function nf_inq_vartype(ncid, varid, xtype) RESULT(status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: xtype
 Integer              :: status

 End Function nf_inq_vartype
End Interface
!-------------------------------- nf_inq_varnatts -----------------------------
Interface
 Function nf_inq_varnatts(ncid, varid, nvatts) RESULT(status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: nvatts
 Integer              :: status

 End Function nf_inq_varnatts
End Interface
!-------------------------------- nf_rename_var -------------------------------
Interface
 Function nf_rename_var(ncid, varid, name) RESULT (status)

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: name
 Integer                      :: status

 End Function nf_rename_var
End Interface
!-------------------------------- nf_copy_var ---------------------------------
Interface
 Function nf_copy_var(ncid_in, varid, ncid_out) RESULT(status)

 Integer, Intent(IN) :: ncid_in, varid, ncid_out
 Integer             :: status

 End Function nf_copy_var
End Interface

! General attribute functions

!-------------------------------- nf_inq_att ----------------------------------
Interface
 Function nf_inq_att(ncid, varid, name, xtype, nlen) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: nlen, xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_att
End Interface
!-------------------------------- nf_inq_atttype ---------------------------
Interface
 Function nf_inq_atttype(ncid, varid, name, xtype) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_atttype
End Interface
!-------------------------------- nf_inq_attlen -------------------------------
Interface
 Function nf_inq_attlen(ncid, varid, name, nlen) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: nlen
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_attlen
End Interface
!-------------------------------- nf_inq_attid --------------------------------
Interface
 Function nf_inq_attid(ncid, varid, name, attnum) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(OUT) :: attnum
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_inq_attid
End Interface
!-------------------------------- nf_inq_attname ------------------------------
Interface
 Function nf_inq_attname(ncid, varid, attnum, name) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid, attnum
 Character(LEN=*), Intent(OUT) :: name
 Integer                       :: status

 End Function nf_inq_attname
End Interface
!-------------------------------- nf_copy_att ---------------------------------
Interface
 Function nf_copy_att(ncid_in, varid_in, name, ncid_out, varid_out) &
                         RESULT(status)

 Integer,          Intent(IN)  :: ncid_in, varid_in, ncid_out, varid_out
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_copy_att
End Interface
!-------------------------------- nf_rename_att -------------------------------
Interface
 Function nf_rename_att(ncid, varid, name, newname) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: name, newname
 Integer                      :: status

 End Function nf_rename_att
End Interface
!-------------------------------- nf_del_att ----------------------------------
Interface
 Function nf_del_att(ncid, varid, name) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: name
 Integer                      :: status

 End Function nf_del_att
End Interface

! var1 put and get functions

!--------------------------------- nf_put_var1_text ---------------------------
Interface
 Function nf_put_var1_text(ncid, varid, ndex, chval) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: ndex(*)
 Character(LEN=1), Intent(IN) :: chval
 Integer                      :: status

 End Function nf_put_var1_text
End Interface
!--------------------------------- nf_put_var1_int1 ------------------------
Interface
 Function nf_put_var1_int1(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: ndex(*)
 Integer(NFINT1), Intent(IN) :: ival
 Integer                     :: status

 End Function nf_put_var1_int1
End Interface
!--------------------------------- nf_put_var1_int2 ------------------------
Interface
 Function nf_put_var1_int2(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: ndex(*)
 Integer(NFINT2), Intent(IN) :: ival
 Integer                     :: status

 End Function nf_put_var1_int2
End Interface
!--------------------------------- nf_put_var1_int -------------------------
Interface
 Function nf_put_var1_int(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT
 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: ndex(*)
 Integer(NFINT), Intent(IN) :: ival
 Integer                    :: status

 End Function nf_put_var1_int
End Interface
!--------------------------------- nf_put_var1_real ------------------------
Interface
 Function nf_put_var1_real(ncid, varid, ndex, rval) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: ndex(*)
 Real(NFREAL), Intent(IN) :: rval
 Integer                  :: status

 End Function nf_put_var1_real
End Interface
!--------------------------------- nf_put_var1_double ----------------------
Interface
 Function nf_put_var1_double(ncid, varid, ndex, dval) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: ndex(*)
 Real(RK8), Intent(IN) :: dval
 Integer               :: status

 End Function nf_put_var1_double
End Interface
!--------------------------------- nf_get_var1_text ------------------------
Interface
 Function nf_get_var1_text(ncid, varid, ndex, chval) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: ndex(*)
 Character(LEN=1), Intent(OUT) :: chval
 Integer                       :: status

 End Function nf_get_var1_text
End Interface
!--------------------------------- nf_get_var1_int1 ------------------------
Interface
 Function nf_get_var1_int1(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: ndex(*)
 Integer(NFINT1), Intent(OUT) :: ival
 Integer                      :: status

 End Function nf_get_var1_int1
End Interface
!--------------------------------- nf_get_var1_int2 ------------------------
Interface
 Function nf_get_var1_int2(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: ndex(*)
 Integer(NFINT2), Intent(OUT) :: ival
 Integer                      :: status

 End Function nf_get_var1_int2
End Interface
!--------------------------------- nf_get_var1_int -------------------------
Interface
 Function nf_get_var1_int(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT
 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: ndex(*)
 Integer(NFINT), Intent(OUT) :: ival
 Integer                     :: status

 End Function nf_get_var1_int
End Interface
!--------------------------------- nf_get_var1_real ------------------------
Interface
 Function nf_get_var1_real(ncid, varid, ndex, rval) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: ndex(*)
 Real(NFREAL), Intent(OUT) :: rval
 Integer                   :: status

 End Function nf_get_var1_real
End Interface
!--------------------------------- nf_get_var1_double ----------------------
Interface
 Function nf_get_var1_double(ncid, varid, ndex, rval) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: ndex(*)
 Real(RK8), Intent(OUT) :: rval
 Integer                :: status

 End Function nf_get_var1_double
End Interface

! var put and get functions

!--------------------------------- nf_put_var_text -------------------------
Interface nf_put_var_text
 Function nf_put_var_text(ncid, varid, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=*), Intent(IN) :: text
 Integer                      :: status

 End Function nf_put_var_text
! Array of characters
 Function nf_put_var_text_a(ncid, varid, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Character(LEN=1), Intent(IN) :: text(*)
 Integer                      :: status

 End Function nf_put_var_text_a
End Interface
!--------------------------------- nf_put_var_int1 -------------------------
Interface
 Function nf_put_var_int1(ncid, varid, i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN) :: ncid, varid
 Integer(NFINT1), Intent(IN) :: i1vals(*)
 Integer                     :: status

 End Function nf_put_var_int1
End Interface
!--------------------------------- nf_put_var_int2 -------------------------
Interface
 Function nf_put_var_int2(ncid, varid, i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN) :: ncid, varid
 Integer(NFINT2), Intent(IN) :: i2vals(*)
 Integer                     :: status

 End Function nf_put_var_int2
End Interface
!--------------------------------- nf_put_var_int --------------------------
Interface
 Function nf_put_var_int(ncid, varid, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN) :: ncid, varid
 Integer(NFINT), Intent(IN) :: ivals(*)
 Integer             :: status

 End Function nf_put_var_int
End Interface
!--------------------------------- nf_put_var_real -------------------------
Interface
 Function nf_put_var_real(ncid, varid, rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN) :: ncid, varid
 Real(NFREAL), Intent(IN) :: rvals(*)
 Integer                  :: status

 End Function nf_put_var_real
End Interface
!--------------------------------- nf_put_var_double -----------------------
Interface
 Function nf_put_var_double(ncid, varid, dvals) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN) :: ncid, varid
 Real(RK8), Intent(IN) :: dvals(*)
 Integer               :: status

 End Function nf_put_var_double
End Interface
!--------------------------------- nf_get_var_text ------------------------
Interface nf_get_var_text
 Function nf_get_var_text(ncid, varid, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(OUT) :: text
 Integer                       :: status

 End Function nf_get_var_text
! array of characters
 Function nf_get_var_text_a(ncid, varid, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=1), Intent(OUT) :: text(*)
 Integer                       :: status

 End Function nf_get_var_text_a
End Interface
!--------------------------------- nf_get_var_int1 -------------------------
Interface
 Function nf_get_var_int1(ncid, varid, i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN)  :: ncid, varid
 Integer(NFINT1), Intent(OUT) :: i1vals(*)
 Integer                      :: status

 End Function nf_get_var_int1
End Interface
!--------------------------------- nf_get_var_int2 -------------------------
Interface
 Function nf_get_var_int2(ncid, varid, i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN)  :: ncid, varid
 Integer(NFINT2), Intent(OUT) :: i2vals(*)
 Integer                      :: status

 End Function nf_get_var_int2
End Interface
!--------------------------------- nf_get_var_int --------------------------
Interface
 Function nf_get_var_int(ncid, varid, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT
 
 Integer,        Intent(IN)  :: ncid, varid
 Integer(NFINT), Intent(OUT) :: ivals(*)
 Integer                     :: status

 End Function nf_get_var_int
End Interface
!--------------------------------- nf_get_var_real -------------------------
Interface
 Function nf_get_var_real(ncid, varid, rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN)  :: ncid, varid
 Real(NFREAL), Intent(OUT) :: rvals(*)
 Integer                   :: status

 End Function nf_get_var_real
End Interface
!--------------------------------- nf_get_var_double -----------------------
Interface
 Function nf_get_var_double(ncid, varid, dvals) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN)  :: ncid, varid
 Real(RK8), Intent(OUT) :: dvals(*)
 Integer                :: status

 End Function nf_get_var_double
End Interface

! vars put and get functions

!--------------------------------- nf_put_vars_text ------------------------
Interface nf_put_vars_text
 Function nf_put_vars_text(ncid, varid, start, counts, strides, text) &
                              RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*)
 Character(LEN=*), Intent(IN) :: text
 Integer                      :: status

 End Function nf_put_vars_text
! array of characters
 Function nf_put_vars_text_a(ncid, varid, start, counts, strides, text) &
                              RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*)
 Character(LEN=1), Intent(IN) :: text(*)
 Integer                      :: status

 End Function nf_put_vars_text_a
End Interface
!--------------------------------- nf_put_vars_int1 ------------------------
Interface
 Function nf_put_vars_int1(ncid, varid, start, counts, strides, i1vals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT1), Intent(IN) :: i1vals(*)
 Integer                     :: status

 End Function nf_put_vars_int1
End Interface
!--------------------------------- nf_put_vars_int2 ------------------------
Interface
 Function nf_put_vars_int2(ncid, varid, start, counts, strides, i2vals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT2), Intent(IN) :: i2vals(*)
 Integer                     :: status

 End Function nf_put_vars_int2
End Interface
!--------------------------------- nf_put_vars_int -------------------------
Interface
 Function nf_put_vars_int(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*), strides(*)
 Integer(NFINT), Intent(IN) :: ivals(*)
 Integer                    :: status

 End Function nf_put_vars_int
End Interface
!--------------------------------- nf_put_vars_real ------------------------
Interface
 Function nf_put_vars_real(ncid, varid, start, counts, strides, rvals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*)
 Real(NFREAL), Intent(IN) :: rvals(*)
 Integer                  :: status

 End Function nf_put_vars_real
End Interface
!--------------------------------- nf_put_vars_double ----------------------
Interface
 Function nf_put_vars_double(ncid, varid, start, counts, strides, dvals) &
                                RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*), strides(*)
 Real(RK8), Intent(IN) :: dvals(*)
 Integer               :: status

 End Function nf_put_vars_double
End Interface
!--------------------------------- nf_get_vars_text ------------------------
Interface nf_get_vars_text
 Function nf_get_vars_text(ncid, varid, start, counts, strides, text) &
                                RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*)
 Character(LEN=*), Intent(OUT) :: text
 Integer                       :: status

 End Function nf_get_vars_text
! array of characters
 Function nf_get_vars_text_a(ncid, varid, start, counts, strides, text) &
                                RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*)
 Character(LEN=1), Intent(OUT) :: text(*)
 Integer                       :: status

 End Function nf_get_vars_text_a
End Interface
!--------------------------------- nf_get_vars_int1 ------------------------
Interface
 Function nf_get_vars_int1(ncid, varid, start, counts, strides, i1vals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT1), Intent(OUT) :: i1vals(*)
 Integer                      :: status

 End Function nf_get_vars_int1
End Interface
!--------------------------------- nf_get_vars_int2 ------------------------
Interface
 Function nf_get_vars_int2(ncid, varid, start, counts, strides, i2vals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT2), Intent(OUT) :: i2vals(*)
 Integer                      :: status

 End Function nf_get_vars_int2
End Interface
!--------------------------------- nf_get_vars_int -------------------------
Interface
 Function nf_get_vars_int(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)
 Integer                     :: status

 End Function nf_get_vars_int
End Interface
!--------------------------------- nf_get_vars_real ------------------------
Interface
 Function nf_get_vars_real(ncid, varid, start, counts, strides, rvals) &
                              RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)
 Integer                   :: status

 End Function nf_get_vars_real
End Interface
!--------------------------------- nf_get_vars_double ----------------------
Interface
 Function nf_get_vars_double(ncid, varid, start, counts, strides, dvals) &
                                RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*), strides(*)
 Real(RK8), Intent(OUT) :: dvals(*)
 Integer                :: status

 End Function nf_get_vars_double
End Interface

! varm put and get functions

!--------------------------------- nf_put_varm_text ------------------------
Interface nf_put_varm_text
 Function nf_put_varm_text(ncid, varid, start, counts, strides, maps, &
                                text) RESULT(status)



 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=*), Intent(IN) :: text
 Integer                      :: status

 End Function nf_put_varm_text
! array of characters
 Function nf_put_varm_text_a(ncid, varid, start, counts, strides, maps, &
                                text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=1), Intent(IN) :: text(*)
 Integer                      :: status

 End Function nf_put_varm_text_a
End Interface
!--------------------------------- nf_put_varm_int1 ------------------------
Interface
 Function nf_put_varm_int1(ncid, varid, start, counts, strides, maps, &
                              i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT1), Intent(IN) :: i1vals(*)
 Integer                     :: status

 End Function nf_put_varm_int1
End Interface
!--------------------------------- nf_put_varm_int2 ------------------------
Interface
 Function nf_put_varm_int2(ncid, varid, start, counts, strides, maps, &
                              i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT2), Intent(IN) :: i2vals(*)
 Integer                     :: status

 End Function nf_put_varm_int2
End Interface
!--------------------------------- nf_put_varm_int -------------------------
Interface
 Function nf_put_varm_int(ncid, varid, start, counts, strides, maps, &
                             ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT), Intent(IN) :: ivals(*)
 Integer                    :: status

 End Function nf_put_varm_int
End Interface

!--------------------------------- nf_put_varm_real ------------------------
Interface
 Function nf_put_varm_real(ncid, varid, start, counts, strides, maps, &
                              rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Real(NFREAL), Intent(IN) :: rvals(*)
 Integer                  :: status

 End Function nf_put_varm_real
End Interface
!--------------------------------- nf_put_varm_double ----------------------
Interface
 Function nf_put_varm_double(ncid, varid, start, counts, strides, maps, &
                                dvals) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Real(RK8), Intent(IN) :: dvals(*)
 Integer               :: status

 End Function nf_put_varm_double
End Interface
!--------------------------------- nf_get_varm_text ------------------------
Interface nf_get_varm_text
 Function nf_get_varm_text(ncid, varid, start, counts, strides, maps, &
                                text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=*), Intent(OUT) :: text
 Integer                       :: status

 End Function nf_get_varm_text
! array of characters
 Function nf_get_varm_text_a(ncid, varid, start, counts, strides, maps, &
                                text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Character(LEN=1), Intent(OUT) :: text(*)
 Integer                       :: status

 End Function nf_get_varm_text_a
End Interface
!--------------------------------- nf_get_varm_int1 ------------------------
Interface
 Function nf_get_varm_int1(ncid, varid, start, counts, strides, maps, &
                              i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT1), Intent(OUT) :: i1vals(*)
 Integer                      :: status

 End Function nf_get_varm_int1
End Interface
!--------------------------------- nf_get_varm_int2 ------------------------
Interface
 Function nf_get_varm_int2(ncid, varid, start, counts, strides, maps, &
                              i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT2), Intent(OUT) :: i2vals(*)
 Integer                      :: status

 End Function nf_get_varm_int2
End Interface
!--------------------------------- nf_get_varm_int -------------------------
Interface
 Function nf_get_varm_int(ncid, varid, start, counts, strides, maps, &
                             ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)
 Integer                     :: status

 End Function nf_get_varm_int
End Interface
!--------------------------------- nf_get_varm_real ------------------------
Interface
 Function nf_get_varm_real(ncid, varid, start, counts, strides, maps, &
                              rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)
 Integer                   :: status

 End Function nf_get_varm_real
End Interface
!--------------------------------- nf_get_varm_double ----------------------
Interface
 Function nf_get_varm_double(ncid, varid, start, counts, strides, maps, &
                             dvals) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Real(RK8), Intent(OUT) :: dvals(*)
 Integer                :: status

 End Function nf_get_varm_double
End Interface

! vara put and get routines

!--------------------------------- nf_put_vara_text ------------------------
Interface nf_put_vara_text
 Function nf_put_vara_text(ncid, varid, start, counts, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*)
 Character(LEN=*), Intent(IN) :: text
 Integer                      :: status

 End Function nf_put_vara_text
! array of characters
 Function nf_put_vara_text_a(ncid, varid, start, counts, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid
 Integer,          Intent(IN) :: start(*), counts(*)
 Character(LEN=1), Intent(IN) :: text(*)
 Integer                      :: status

 End Function nf_put_vara_text_a
End Interface
!--------------------------------- nf_put_vara_int1 ------------------------
Interface
 Function nf_put_vara_int1(ncid, varid, start, counts, i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*)
 Integer(NFINT1), Intent(IN) :: i1vals(*)
 Integer                     :: status

 End Function nf_put_vara_int1
End Interface
!--------------------------------- nf_put_vara_int2 ------------------------
Interface
 Function nf_put_vara_int2(ncid, varid, start, counts, i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*)
 Integer(NFINT2), Intent(IN) :: i2vals(*)
 Integer                     :: status

 End Function nf_put_vara_int2
End Interface
!--------------------------------- nf_put_vara_int -------------------------
Interface
 Function nf_put_vara_int(ncid, varid, start, counts, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN) :: ncid, varid
 Integer,        Intent(IN) :: start(*), counts(*)
 Integer(NFINT), Intent(IN) :: ivals(*)
 Integer                    :: status

 End Function nf_put_vara_int
End Interface
!--------------------------------- nf_put_vara_int64 ------------------------
Interface
 Function nf_put_vara_int64(ncid, varid, start, counts, i8vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT8

 Integer,         Intent(IN) :: ncid, varid
 Integer,         Intent(IN) :: start(*), counts(*)
 Integer(NFINT8), Intent(IN) :: i8vals(*)
 Integer                     :: status

 End Function nf_put_vara_int64
End Interface
!--------------------------------- nf_put_vara_real ------------------------
Interface
 Function nf_put_vara_real(ncid, varid, start, counts, rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*)
 Real(NFREAL), Intent(IN) :: rvals(*)
 Integer                  :: status

 End Function nf_put_vara_real
End Interface
!--------------------------------- nf_put_vara_double ----------------------
Interface
 Function nf_put_vara_double(ncid, varid, start, counts, dvals) &
                                RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN) :: ncid, varid
 Integer,   Intent(IN) :: start(*), counts(*)
 Real(RK8), Intent(IN) :: dvals(*)
 Integer               :: status

 End Function nf_put_vara_double
End Interface
!--------------------------------- nf_get_vara_text ------------------------
Interface nf_get_vara_text
 Function nf_get_vara_text(ncid, varid, start, counts, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*)
 Character(LEN=*), Intent(OUT) :: text
 Integer                       :: status

 End Function nf_get_vara_text
! array of characters
 Function nf_get_vara_text_a(ncid, varid, start, counts, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Integer,          Intent(IN)  :: start(*), counts(*)
 Character(LEN=1), Intent(OUT) :: text(*)
 Integer                       :: status

 End Function nf_get_vara_text_a
End Interface
!--------------------------------- nf_get_vara_int1 ------------------------
Interface
 Function nf_get_vara_int1(ncid, varid, start, counts, i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*)
 Integer(NFINT1), Intent(OUT) :: i1vals(*)
 Integer                      :: status

 End Function nf_get_vara_int1
End Interface
!--------------------------------- nf_get_vara_int2 ------------------------
Interface
 Function nf_get_vara_int2(ncid, varid, start, counts, i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*)
 Integer(NFINT2), Intent(OUT) :: i2vals(*)
 Integer                      :: status

 End Function nf_get_vara_int2
End Interface
!--------------------------------- nf_get_vara_int -------------------------
Interface
 Function nf_get_vara_int(ncid, varid, start, counts, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,        Intent(IN)  :: ncid, varid
 Integer,        Intent(IN)  :: start(*), counts(*)
 Integer(NFINT), Intent(OUT) :: ivals(*)
 Integer                     :: status

 End Function nf_get_vara_int
End Interface
!--------------------------------- nf_get_vara_int64 ------------------------
Interface
 Function nf_get_vara_int64(ncid, varid, start, counts, i8vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT8

 Integer,         Intent(IN)  :: ncid, varid
 Integer,         Intent(IN)  :: start(*), counts(*)
 Integer(NFINT8), Intent(OUT) :: i8vals(*)
 Integer                      :: status

 End Function nf_get_vara_int64
End Interface
!--------------------------------- nf_get_vara_real ------------------------
Interface
 Function nf_get_vara_real(ncid, varid, start, counts, rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*)
 Real(NFREAL), Intent(OUT) :: rvals(*)
 Integer                   :: status

 End Function nf_get_vara_real
End Interface
!--------------------------------- nf_get_vara_double ----------------------
Interface
 Function nf_get_vara_double(ncid, varid, start, counts, dvals) &
                                RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,   Intent(IN)  :: ncid, varid
 Integer,   Intent(IN)  :: start(*), counts(*)
 Real(RK8), Intent(OUT) :: dvals(*)
 Integer                :: status

 End Function nf_get_vara_double
End Interface
!--------------------------------- nf_put_att_text -------------------------
Interface nf_put_att_text
 Function nf_put_att_text(ncid, varid, name, nlen, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid, nlen
 Character(LEN=*), Intent(IN) :: name, text
 Integer                      :: status

 End Function nf_put_att_text
! array of characters
 Function nf_put_att_text_a(ncid, varid, name, nlen, text) RESULT(status)

 Integer,          Intent(IN) :: ncid, varid, nlen
 Character(LEN=*), Intent(IN) :: name
 Character(LEN=1), Intent(IN) :: text(*)
 Integer                      :: status

 End Function nf_put_att_text_a
End Interface
!--------------------------------- nf_put_att_int1 -------------------------
Interface
 Function nf_put_att_int1(ncid, varid, name, xtype, nlen, i1vals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Integer(NFINT1),  Intent(IN) :: i1vals(*)
 Integer                      :: status

 End Function nf_put_att_int1
End Interface
!--------------------------------- nf_put_att_int2 -------------------------
Interface
 Function nf_put_att_int2(ncid, varid, name, xtype, nlen, i2vals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Integer(NFINT2),  Intent(IN) :: i2vals(*)
 Integer                      :: status

 End Function nf_put_att_int2
End Interface
!--------------------------------- nf_put_att_int --------------------------
Interface
 Function nf_put_att_int(ncid, varid, name, xtype, nlen, ivals) &
                            RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Integer(NFINT),   Intent(IN) :: ivals(*)
 Integer                      :: status

 End Function nf_put_att_int
End Interface
!--------------------------------- nf_put_att_int64 -------------------------
Interface
 Function nf_put_att_int64(ncid, varid, name, xtype, nlen, i8vals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT8

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Integer(NFINT8),  Intent(IN) :: i8vals(*)
 Integer                      :: status

 End Function nf_put_att_int64
End Interface
!--------------------------------- nf_put_att_real -------------------------
Interface
 Function nf_put_att_real(ncid, varid, name, xtype, nlen, rvals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Real(NFREAL),     Intent(IN) :: rvals(*)
 Integer                      :: status

 End Function nf_put_att_real
End Interface
!--------------------------------- nf_put_att_double -----------------------
Interface
 Function nf_put_att_double(ncid, varid, name, xtype, nlen, dvals) &
                               RESULT(status)

 USE netcdf_nf_data, ONLY: RK8

 Integer,          Intent(IN) :: ncid, varid, nlen, xtype
 Character(LEN=*), Intent(IN) :: name
 Real(RK8),        Intent(IN) :: dvals(*)
 Integer                      :: status

 End Function nf_put_att_double
End Interface
!--------------------------------- nf_get_att_text -------------------------
Interface nf_get_att_text
 Function nf_get_att_text(ncid, varid, name, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Character(LEN=*), Intent(OUT) :: text
 Integer                       :: status

 End Function nf_get_att_text
! Array of characters
 Function nf_get_att_text_a(ncid, varid, name, text) RESULT(status)

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Character(LEN=1), Intent(OUT) :: text(*)
 Integer                       :: status

 End Function nf_get_att_text_a
End Interface
!--------------------------------- nf_get_att_int1 -------------------------
Interface
 Function nf_get_att_int1(ncid, varid, name, i1vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT1

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer(NFINT1),  Intent(OUT) :: i1vals(*)
 Integer                       :: status

 End Function nf_get_att_int1
End Interface
!--------------------------------- nf_get_att_int2 -------------------------
Interface
 Function nf_get_att_int2(ncid, varid, name, i2vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT2

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer(NFINT2),  Intent(OUT) :: i2vals(*)
 Integer                       :: status

 End Function nf_get_att_int2
End Interface
!--------------------------------- nf_get_att_int --------------------------
Interface
 Function nf_get_att_int(ncid, varid, name, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer(NFINT),   Intent(OUT) :: ivals(*)
 Integer                       :: status

 End Function nf_get_att_int
End Interface
!--------------------------------- nf_get_att_int64 -------------------------
Interface
 Function nf_get_att_int64(ncid, varid, name, i8vals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFINT8

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Integer(NFINT8),  Intent(OUT) :: i8vals(*)
 Integer                       :: status

 End Function nf_get_att_int64
End Interface
!--------------------------------- nf_get_att_real -------------------------
Interface
 Function nf_get_att_real(ncid, varid, name, rvals) RESULT(status)

 USE netcdf_nf_data, ONLY: NFREAL

 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Real(NFREAL),     Intent(OUT) :: rvals(*)
 Integer                       :: status

 End Function nf_get_att_real
End Interface
!--------------------------------- nf_get_att_double -----------------------
Interface
 Function nf_get_att_double(ncid, varid, name, dvals) RESULT(status)

 USE netcdf_nf_data, ONLY: RK8


 Integer,          Intent(IN)  :: ncid, varid
 Character(LEN=*), Intent(IN)  :: name
 Real(RK8),        Intent(OUT) :: dvals(*)
 Integer                       :: status

 End Function nf_get_att_double
End Interface

! Externals for functions that use C_CHAR arrays to pass data to void
! pointers

 Integer, External :: nf_put_var1
 Integer, External :: nf_get_var1
 Integer, External :: nf_put_vars
 Integer, External :: nf_get_vars
 Integer, External :: nf_put_vara
 Integer, External :: nf_get_vara
! Integer, External :: nf_open_mem

#ifndef NO_NETCDF_2
! External definitons for Netcdf2 functions 
 Integer, External :: nccre 
 Integer, External :: ncopn 
 Integer, External :: ncddef
 Integer, External :: ncdid
 Integer, External :: ncvdef
 Integer, External :: ncvid
 Integer, External :: nctlen
 Integer, External :: ncsfil
#endif

!--------------------------- End Module netcdf_nf_interfaces - ----------------
End Module netcdf_nf_interfaces

! This is part of the netCDF package.
! Copyright 2008 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program
! simple_xy_par_wr.f90. The data are read using parallel I/O.
      
! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_par_rd
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will read. 
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! These will tell where in the data file this processor should
  ! write.
  integer, parameter :: NDIMS = 2
  integer :: start(NDIMS), count(NDIMS)
  
  ! We will read data into this array.
  integer, allocatable :: data_in(:)

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Allocate space to read in data.
  allocate(data_in(p), stat = stat)
  if (stat .ne. 0) stop 3

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
  ! the file.
  call check( nf90_open(FILE_NAME, IOR(NF90_NOWRITE, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, "data", varid) )

  ! Read the data.
  start = (/ 1, my_rank + 1/)
  count = (/ p, 1 /)
  call check( nf90_get_var(ncid, varid, data_in, &
       start = start, count = count) )

  ! Check the data.
  do x = 1, p
     if (data_in(x) .ne. my_rank) then
        print *, "data_in(", x, ") = ", data_in(x)
        stop "Stopped"
     endif
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_in)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_rd

!     This is part of the netCDF package.
!     Copyright 2020 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 parallel I/O with compression. It
!     was added to resolve this issue:
!     https://github.com/Unidata/netcdf-fortran/issues/264
!     This code matches the code here:
!     https://github.com/NOAA-EMC/fv3atm/blob/develop/io/module_write_netcdf_parallel.F90

!     Ed Hartnett, 6/16/20
!     Ward Fisher, 7/29/22 - Explicity assign values to an array, avoiding a
!                            platform-specific failure. 

program f90tst_parallel_compressed
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'

  ! File info.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel_compressed.nc"
  integer :: ncid, oldMode

  ! Dimensions
  integer, parameter :: NUM_DIMS = 5
  character (len = *), parameter :: dim_name(NUM_DIMS) = &
       (/ 'grid_xt', 'grid_yt', 'pfull  ', 'phalf  ', 'time   ' /)
  integer, dimension(NUM_DIMS) :: dim_len = (/ 3072, 1536, 127, 128, 1 /)
  integer :: dimid(NUM_DIMS)

  ! Variables.
  integer, parameter :: NUM_VARS = 8
  character (len = *), parameter :: var_name(NUM_VARS) = &
       (/ 'grid_xt', 'lon    ', 'grid_yt', 'lat    ', 'pfull  ', 'phalf  ', 'time   ', 'clwmr  ' /)
  integer ::varid(NUM_VARS)
  integer :: var_type(NUM_VARS) = (/ nf90_double, nf90_double, nf90_double, &
       nf90_double, nf90_float, nf90_float, nf90_double, nf90_float /)
  integer :: var_ndims(NUM_VARS) = (/ 1, 2, 1, 2, 1, 1, 1, 4 /)
  integer :: ideflate = 4
  real*8 :: value_time = 2.0, value_time_in
  real, allocatable :: value_clwmr(:,:,:,:)
  integer :: phalf_loc_size, phalf_start
  real, allocatable :: value_phalf_loc(:), value_phalf_loc_in(:)
  integer :: pfull_loc_size, pfull_start
  real, allocatable :: value_pfull_loc(:), value_pfull_loc_in(:)
  integer :: grid_xt_loc_size, grid_xt_start
  real, allocatable :: value_grid_xt_loc(:), value_grid_xt_loc_in(:)
  integer :: grid_yt_loc_size, grid_yt_start
  real, allocatable :: value_grid_yt_loc(:), value_grid_yt_loc_in(:)
  integer :: lon_xt_loc_size, lon_xt_start, lon_yt_loc_size, lon_yt_start
  real, allocatable :: value_lon_loc(:,:), value_lon_loc_in(:,:)
  integer :: lat_xt_loc_size, lat_xt_start, lat_yt_loc_size, lat_yt_start
  real, allocatable :: value_lat_loc(:,:), value_lat_loc_in(:,:)
  real, allocatable :: value_clwmr_loc(:,:,:,:), value_clwmr_loc_in(:,:,:,:)
  
  ! These are for checking file contents.
  character (len = 128) :: name_in
  integer :: dim_len_in, xtype_in, ndims_in
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y, v
  integer :: npes, my_rank, i, j, k, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, npes, ierr)

  if (my_rank .eq. 0) then
     print *, '*** Testing compressed data writes with parallel I/O.'
  endif

  ! There must be 4 procs for this test.
  if (npes .ne. 4) then
     print *, 'Sorry, this test program must be run on 4 processors.'
     stop 1
  endif

  ! Size of local (i.e. for this pe) grid_xt data.
  grid_xt_loc_size = dim_len(1)/npes;
  grid_xt_start = my_rank * grid_xt_loc_size + 1
  if (my_rank .eq. npes - 1) then
     grid_xt_loc_size = grid_xt_loc_size + mod(dim_len(1), npes)
  endif
  !print *, my_rank, 'grid_xt', dim_len(3), grid_xt_start, grid_xt_loc_size

  ! Size of local (i.e. for this pe) grid_yt data.
  grid_yt_loc_size = dim_len(2)/npes;
  grid_yt_start = my_rank * grid_yt_loc_size + 1
  if (my_rank .eq. npes - 1) then
     grid_yt_loc_size = grid_yt_loc_size + mod(dim_len(2), npes)
  endif
  !print *, my_rank, 'grid_yt', dim_len(3), grid_yt_start, grid_yt_loc_size

  ! Size of local (i.e. for this pe) pfull data.
  pfull_loc_size = dim_len(3)/npes;
  pfull_start = my_rank * pfull_loc_size + 1
  if (my_rank .eq. npes - 1) then
     pfull_loc_size = pfull_loc_size + mod(dim_len(3), npes)
  endif
  !print *, my_rank, 'pfull', dim_len(3), pfull_start, pfull_loc_size
  
  ! Size of local (i.e. for this pe) phalf data.
  phalf_loc_size = dim_len(4)/npes;
  phalf_start = my_rank * phalf_loc_size + 1
  if (my_rank .eq. npes - 1) then
     phalf_loc_size = phalf_loc_size + mod(dim_len(4), npes)
  endif
  !print *, my_rank, 'phalf', dim_len(4), phalf_start, phalf_loc_size

  ! Size of local arrays (i.e. for this pe) lon and lat data. This is
  ! specific to 4 pes.
  lon_xt_loc_size = 1536
  lat_xt_loc_size = 1536
  if (my_rank .eq. 0 .or. my_rank .eq. 2) then
     lon_xt_start = 1
     lat_xt_start = 1
  else
     lon_xt_start = 1537
     lat_xt_start = 1537
  endif
  lon_yt_loc_size = 768
  lat_yt_loc_size = 768
  if (my_rank .eq. 0 .or. my_rank .eq. 1) then
     lon_yt_start = 1
     lat_yt_start = 1
  else
     lon_yt_start = 769
     lat_yt_start = 769
  endif
  !  print *, my_rank, 'lon_xt_start', lon_xt_start, 'lon_yt_start', lon_yt_start
  !  print *, my_rank, 'lon_xt_loc_size', lon_xt_loc_size, 'lon_yt_loc_size', lon_yt_loc_size

  ! Allocate space on this pe to hold the data for this pe.
  allocate(value_grid_xt_loc(grid_xt_loc_size))
  allocate(value_grid_xt_loc_in(grid_xt_loc_size))
  allocate(value_grid_yt_loc(grid_yt_loc_size))
  allocate(value_grid_yt_loc_in(grid_yt_loc_size))
  allocate(value_pfull_loc(pfull_loc_size))
  allocate(value_pfull_loc_in(pfull_loc_size))
  allocate(value_phalf_loc(phalf_loc_size))
  allocate(value_phalf_loc_in(phalf_loc_size))
  allocate(value_lon_loc(lon_xt_loc_size, lon_yt_loc_size))
  allocate(value_lon_loc_in(lon_xt_loc_size, lon_yt_loc_size))
  allocate(value_lat_loc(lat_xt_loc_size, lat_yt_loc_size))
  allocate(value_lat_loc_in(lat_xt_loc_size, lat_yt_loc_size))
  allocate(value_clwmr_loc(lat_xt_loc_size, lat_yt_loc_size, pfull_loc_size, 1))
  allocate(value_clwmr_loc_in(lat_xt_loc_size, lat_yt_loc_size, pfull_loc_size, 1))
  
  ! Some fake data for this pe to write.
  do i = 1, grid_xt_loc_size
     value_grid_xt_loc(i) = i;
  end do 
  do i = 1, pfull_loc_size
     value_pfull_loc(i) = my_rank * 100 + i;
  end do
  do i = 1, phalf_loc_size
     value_phalf_loc(i) = my_rank * 100 + i;
  end do
  do i = 1, lon_xt_loc_size
     do j = 1, lon_yt_loc_size
        value_lon_loc(i, j) = my_rank * 100 + i +j
        value_lat_loc(i, j) = my_rank * 100 + i +j
        do k = 1, pfull_loc_size
           value_clwmr_loc(i, j, k, 1) = my_rank * 100 + i + j + k
        end do
     end do
  end do

  ! Create the netCDF file using parallel I/O.
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Turn off fill mode.
  call check(nf90_set_fill(ncid, NF90_NOFILL, oldMode))

  ! Define dimension grid_xt.
  call check(nf90_def_dim(ncid, trim(dim_name(1)), dim_len(1), dimid(1)))

  ! Define dimension grid_yt.
  call check(nf90_def_dim(ncid, trim(dim_name(2)), dim_len(2), dimid(2)))

  ! Define variable grid_xt.
  call check(nf90_def_var(ncid, trim(var_name(1)), var_type(1), dimids=(/dimid(1)/), varid=varid(1)))
  call check(nf90_var_par_access(ncid, varid(1), NF90_INDEPENDENT))

  ! Define variable lon.
  call check(nf90_def_var(ncid, trim(var_name(2)), var_type(2), dimids=(/dimid(1),  dimid(2)/), varid=varid(2)))
!  call check(nf90_var_par_access(ncid, varid(2), NF90_INDEPENDENT))

  ! Define variable grid_yt.
  call check(nf90_def_var(ncid, trim(var_name(3)), var_type(3), dimids=(/dimid(2)/), varid=varid(3)))
  call check(nf90_var_par_access(ncid, varid(3), NF90_INDEPENDENT))

  ! Define variable lat.
  call check(nf90_def_var(ncid, trim(var_name(4)), var_type(4), dimids=(/dimid(1), dimid(2)/), varid=varid(4)))
  call check(nf90_var_par_access(ncid, varid(4), NF90_INDEPENDENT))

  ! Define dimension pfull.
  call check(nf90_def_dim(ncid, trim(dim_name(3)), dim_len(3), dimid(3)))

  ! Define variable pfull and write data.
  call check(nf90_def_var(ncid, trim(var_name(5)), var_type(5), dimids=(/dimid(3)/), varid=varid(5)))
  call check(nf90_var_par_access(ncid, varid(5), NF90_INDEPENDENT))
  call check(nf90_enddef(ncid))
  call check(nf90_put_var(ncid, varid(5), start=(/pfull_start/), count=(/pfull_loc_size/), values=value_pfull_loc))
  call check(nf90_redef(ncid))

  ! Define dimension phalf.
  call check(nf90_def_dim(ncid, trim(dim_name(4)), dim_len(4), dimid(4)))

  ! Define variable phalf and write data.
  call check(nf90_def_var(ncid, trim(var_name(6)), var_type(6), dimids=(/dimid(4)/), varid=varid(6)))
  call check(nf90_var_par_access(ncid, varid(6), NF90_INDEPENDENT))
  call check(nf90_enddef(ncid))
  call check(nf90_put_var(ncid, varid(6), start=(/phalf_start/), count=(/phalf_loc_size/), values=value_phalf_loc))
  call check(nf90_redef(ncid))

  ! Define dimension time.
  call check(nf90_def_dim(ncid, trim(dim_name(5)), dim_len(5), dimid(5)))

  ! Define variable time and write data.
  call check(nf90_def_var(ncid, trim(var_name(7)), var_type(7), dimids=(/dimid(5)/), varid=varid(7)))
  call check(nf90_var_par_access(ncid, varid(7), NF90_INDEPENDENT))
  call check(nf90_enddef(ncid))
  ! In NOAA code, do all processors write the single time value?
  if (my_rank .eq. 0) then
     call check(nf90_put_var(ncid, varid(7), values=value_time))
  endif
  call check(nf90_redef(ncid))

  ! Write variable grid_xt data.
  call check(nf90_enddef(ncid))
  call check(nf90_put_var(ncid, varid(1), start=(/grid_xt_start/), count=(/grid_xt_loc_size/), values=value_grid_xt_loc))  
  call check(nf90_redef(ncid))

  ! Write lon data.
  call check(nf90_enddef(ncid))
  call check(nf90_put_var(ncid, varid(2), start=(/lon_xt_start, lon_yt_start/), count=(/lon_xt_loc_size, lon_yt_loc_size/), &
       values=value_lon_loc))  
  call check(nf90_redef(ncid))

  ! Write grid_yt data.
  call check(nf90_enddef(ncid))
  value_grid_yt_loc = 0.0
  call check(nf90_put_var(ncid, varid(3), start=(/grid_yt_start/), count=(/grid_yt_loc_size/), values=value_grid_yt_loc))  
  call check(nf90_redef(ncid))

  ! Write lat data.
  call check(nf90_enddef(ncid))
  call check(nf90_put_var(ncid, varid(4), start=(/lat_xt_start, lat_yt_start/), count=(/lat_xt_loc_size, lat_yt_loc_size/), &
       values=value_lat_loc))  
  call check(nf90_redef(ncid))

  ! Define variable clwmr and write data (?)
  call check(nf90_def_var(ncid, trim(var_name(8)), var_type(8), dimids=(/dimid(1), dimid(2), dimid(3), dimid(5)/), &
       varid=varid(8), shuffle=.true., deflate_level=ideflate))
  call check(nf90_var_par_access(ncid, varid(8), NF90_COLLECTIVE))
  call check(nf90_enddef(ncid))
!  call check(nf90_put_var(ncid, varid(8), values=value_clwmr))  
  call check(nf90_put_var(ncid, varid(8), start=(/lat_xt_start, lat_yt_start, pfull_start, 1/), &
       count=(/lat_xt_loc_size, lat_yt_loc_size, pfull_loc_size, 1/), values=value_clwmr_loc))  
  call check(nf90_redef(ncid))

  ! Close the file.
  call check(nf90_close(ncid))

  ! Reopen the file.
  call check(nf90_open(FILE_NAME, nf90_nowrite, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= NUM_DIMS) stop 20

  ! Check the dimensions for correctness.
  do i = 1, NUM_DIMS
     call check(nf90_inquire_dimension(ncid, i, name_in, dim_len_in))
     if (name_in .ne. trim(dim_name(i))) stop 101
     if (dim_len_in .ne. dim_len(i)) stop 102
  end do

  ! Check the variables for correctness.
  do i = 1, NUM_VARS
     call check(nf90_inquire_variable(ncid, i, name_in, xtype=xtype_in, ndims=ndims_in))
     if (name_in .ne. trim(var_name(i))) stop 110
     if (xtype_in .ne. var_type(i)) stop 111
     if (ndims_in .ne. var_ndims(i)) stop 112
  end do

  ! Check the grid_xt data.
  call check(nf90_get_var(ncid, varid(1), start=(/grid_xt_start/), count=(/grid_xt_loc_size/), values=value_grid_xt_loc_in))
  do i = 1, grid_xt_loc_size
     !print *, value_grid_xt_loc_in(i), value_grid_xt_loc(i)
     if (value_grid_xt_loc_in(i) .ne. value_grid_xt_loc(i)) stop 170
  end do

  ! Check the lon data.
  call check(nf90_get_var(ncid, varid(2), start=(/lon_xt_start, lon_yt_start/), count=(/lon_xt_loc_size, lon_yt_loc_size/), &
       values=value_lon_loc_in))  
  do i = 1, lon_xt_loc_size
     do j = 1, lon_yt_loc_size
        if (value_lon_loc_in(i, j) .ne. value_lon_loc(i, j)) stop 180
     end do
  end do
  
  ! Check the grid_yt data.
  call check(nf90_get_var(ncid, varid(3), start=(/grid_yt_start/), count=(/grid_yt_loc_size/), values=value_grid_yt_loc_in))
  do i = 1, grid_yt_loc_size
     !print *, value_grid_yt_loc_in(i), value_grid_yt_loc(i)
     if (value_grid_yt_loc_in(i) .ne. value_grid_yt_loc(i)) stop 181
  end do

  ! Check the lon data.
  call check(nf90_get_var(ncid, varid(4), start=(/lat_xt_start, lat_yt_start/), count=(/lat_xt_loc_size, lat_yt_loc_size/), &
       values=value_lat_loc_in))  
  do i = 1, lat_xt_loc_size
     do j = 1, lat_yt_loc_size
        if (value_lat_loc_in(i, j) .ne. value_lat_loc(i, j)) stop 180
     end do
  end do

  ! Check the pfull data.
  call check(nf90_get_var(ncid, varid(5), start=(/pfull_start/), count=(/pfull_loc_size/), values=value_pfull_loc_in))
  do i = 1, pfull_loc_size
     !print *, value_pfull_loc_in(i), value_pfull_loc(i)
     if (value_pfull_loc_in(i) .ne. value_pfull_loc(i)) stop 185
  end do

  ! Check the phalf data.
  call check(nf90_get_var(ncid, varid(6), start=(/phalf_start/), count=(/phalf_loc_size/), values=value_phalf_loc_in))
  do i = 1, phalf_loc_size
     if (value_phalf_loc_in(i) .ne. value_phalf_loc(i)) stop 200
  end do

  ! Check the time value.
  call check(nf90_get_var(ncid, varid(7), values=value_time_in))
  if (value_time_in .ne. value_time) stop 300

  ! Check the clwmr value.
  call check(nf90_get_var(ncid, varid(8), start=(/lat_xt_start, lat_yt_start, pfull_start, 1/), &
       count=(/lat_xt_loc_size, lat_yt_loc_size, pfull_loc_size, 1/), values=value_clwmr_loc_in))  
  do i = 1, lat_xt_loc_size
     do j = 1, lat_yt_loc_size
        do k = 1, pfull_loc_size
           if (value_clwmr_loc_in(i, j, k, 1) .ne. value_clwmr_loc(i, j, k, 1)) stop 300
        end do
     end do
  end do

  ! Close the file.
  call check(nf90_close(ncid))

  ! Free resources.
  deallocate(value_grid_xt_loc)
  deallocate(value_grid_xt_loc_in)
  deallocate(value_grid_yt_loc)
  deallocate(value_grid_yt_loc_in)
  deallocate(value_pfull_loc)
  deallocate(value_pfull_loc_in)
  deallocate(value_phalf_loc)
  deallocate(value_phalf_loc_in)
  deallocate(value_lon_loc)
  deallocate(value_lon_loc_in)
  deallocate(value_lat_loc)
  deallocate(value_lat_loc_in)
  deallocate(value_clwmr_loc)
  deallocate(value_clwmr_loc_in)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

  call MPI_Finalize(ierr)

contains
  !     This subroutine handles errors by printing an error message and
  !     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 99
    endif
  end subroutine check

end program f90tst_parallel_compressed

C     Copyright 1996-2019, UCAR/Unidata
C     See netcdf/COPYRIGHT file for copying and redistribution conditions.

C     Steve Emmerson, Ed Hartnett

C     Test nf_strerror.
C     Try on a bad error status.
C     Test for each defined error status.
C
      subroutine test_nf_strerror()
      implicit none
#include "tests.inc"
      integer         number_of_messages
      parameter       (number_of_messages = 27)

      integer         i
      integer         status(number_of_messages)
      character*80    message
      character*80    msg(number_of_messages)

      data    status(1)  / NF_NOERR/
      data    status(2)  / NF_EBADID /
      data    status(3)  / NF_EEXIST /
      data    status(4)  / NF_EINVAL /
      data    status(5)  / NF_EPERM /
      data    status(6)  / NF_ENOTINDEFINE /
      data    status(7)  / NF_EINDEFINE /
      data    status(8)  / NF_EINVALCOORDS /
      data    status(9)  / NF_EMAXDIMS /
      data    status(10) / NF_ENAMEINUSE /
      data    status(11) / NF_ENOTATT /
      data    status(12) / NF_EMAXATTS /
      data    status(13) / NF_EBADTYPE /
      data    status(14) / NF_EBADDIM /
      data    status(15) / NF_EUNLIMPOS /
      data    status(16) / NF_EMAXVARS /
      data    status(17) / NF_ENOTVAR /
      data    status(18) / NF_EGLOBAL /
      data    status(19) / NF_ENOTNC /
      data    status(20) / NF_ESTS /
      data    status(21) / NF_EMAXNAME /
      data    status(22) / NF_EUNLIMIT /
      data    status(23) / NF_ENORECVARS /
      data    status(24) / NF_ECHAR /
      data    status(25) / NF_EEDGE /
      data    status(26) / NF_ESTRIDE /
      data    status(27) / NF_EBADNAME /

      data msg(1)  / 'No error' /
      data msg(2)  / 'NetCDF: Not a valid ID' /
      data msg(3)  / 'NetCDF: File exists && NC_NOCLOBBER' /
      data msg(4)  / 'NetCDF: Invalid argument' /
      data msg(5)  / 'NetCDF: Write to read only' /
      data msg(6)  / 'NetCDF: Operation not allowed in data mode' /
      data msg(7)  / 'NetCDF: Operation not allowed in define mode' /
      data msg(8)  / 'NetCDF: Index exceeds dimension bound' /
      data msg(9)  / 'NetCDF: NC_MAX_DIMS exceeded' /
      data msg(10) / 'NetCDF: String match to name in use' /
      data msg(11) / 'NetCDF: Attribute not found' /
      data msg(12) / 'NetCDF: NC_MAX_ATTRS exceeded' /
      data msg(13)
     +  / 'NetCDF: Not a valid data type or _FillValue type mismatch' /
      data msg(14) / 'NetCDF: Invalid dimension ID or name' /
      data msg(15) / 'NetCDF: NC_UNLIMITED in the wrong index' /
      data msg(16) / 'NetCDF: NC_MAX_VARS exceeded' /
      data msg(17) / 'NetCDF: Variable not found' /
      data msg(18) / 'NetCDF: Action prohibited on NC_GLOBAL varid' /
      data msg(19) / 'NetCDF: Unknown file format' /
      data msg(20) / 'NetCDF: In Fortran, string too short' /
      data msg(21) / 'NetCDF: NC_MAX_NAME exceeded' /
      data msg(22) / 'NetCDF: NC_UNLIMITED size already in use' /
      data msg(23)
     +     / 'NetCDF: nc_rec op when there are no record vars' /
      data msg(24)
     +     /'NetCDF: Attempt to convert between text & numbers'/
      data msg(25) / 'NetCDF: Start+count exceeds dimension bound' /
      data msg(26) / 'NetCDF: Illegal stride' /
      data msg(27) / 'NetCDF: Name contains illegal characters' /

C     /* Try on a bad error status */
      message = nf_strerror(-666) !/* should fail */
      if (message(1:13) .ne. 'Unknown Error')
     +     call errorc('nf_strerror on bad error status returned: ',
     +     message)

C     /* Try on each legitimate error status */
      do 1, i=1, number_of_messages
         message = nf_strerror(status(i))
         if (message .ne. msg(i))
     +        call error('nf_strerror() should return "' // msg(i) //
     +        '"')
 1    continue
      end


C     Test nf_open.
C     If in read-only section of tests,
C     Try to open a non-existent netCDF file, check error return.
C     Open a file that is not a netCDF file, check error return.
C     Open a netCDF file with a bad mode argument, check error return.
C     Open a netCDF file with NF_NOWRITE mode, try to write, check error.
C     Try to open a netcdf twice, check whether returned netcdf ids different.
C     If in writable section of tests,
C     Open a netCDF file with NF_WRITE mode, write something, close it.
C     On exit, any open netCDF files are closed.
      subroutine test_nf_open()
      implicit none
#include "tests.inc"
      integer err
      integer ncid
      integer ncid2
      character TEMPFILE*8
      integer unit51
C     /* Create a non-netCDF file named 'temp.tmp' */
      unit51 = 51
      TEMPFILE = 'temp.tmp'
      OPEN(unit51, FILE=TEMPFILE)
      WRITE(51,*) 'text'
      CLOSE(51)

C     /* Try to open a nonexistent file */
      err = nf_open('tooth-fairy.nc', NF_NOWRITE, ncid) !/* should fail */
      if (err .eq. NF_NOERR)
     +     call error('nf_open of nonexistent file should have failed')
      if (.not. NF_ISSYSERR(err))
     +   call error(
     +  'nf_open of nonexistent file should have returned system error')

C     /* Open a file that is not a netCDF file. */
      err = nf_open(TEMPFILE, NF_NOWRITE, ncid) !/* should fail */
      if (err .ne. NF_ENOTNC)
     +     call errore('nf_open of non-netCDF file: ', err)

C     /* Open a netCDF file in read-only mode, check that write fails */
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_redef(ncid)      !/* should fail */
      if (err .ne. NF_EPERM)
     +     call error('nf_redef of read-only file should fail')
C     /* Opened OK, see if can open again and get a different netCDF ID */
      err = nf_open(testfile, NF_NOWRITE, ncid2)
      if (err .ne. 0) then
         call errore('nf_open: ', err)
      else
         err = nf_close(ncid2)
      end if
      if (ncid2 .eq. ncid)
     +     call error(
     +   'netCDF IDs for first and second nf_open calls should differ')

      if (.not. readonly) then  !/* tests using netCDF scratch file */
         err = nf_create(scratch, NF_NOCLOBBER, ncid2)
         if (err .ne. 0) then
            call errore('nf_create: ', err)
         else
            err = nf_close(ncid2)
         end if
         err = nf_open(scratch, NF_WRITE, ncid2)
         if (err .ne. 0) then
            call errore('nf_open: ', err)
         else
            err = nf_close(ncid2)
         end if
         err = nf_delete(scratch)
         if (err .ne. 0)
     +        call errorc('delete of scratch file failed', scratch)
      end if

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


C
C     Test nf_close.
C     Try to close a netCDF file twice, check whether second close fails.
C     Try on bad handle, check error return.
C     Try in define mode and data mode.
C     /
      subroutine test_nf_close()
      implicit none
#include "tests.inc"
      integer ncid
      integer err

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

C     /* Close a netCDF file twice, second time should fail */
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close failed: ', err)
      err = nf_close(ncid)
      if (err .ne. NF_EBADID)
     +     call error('nf_close of closed file should have failed')

C     /* Try with a bad netCDF ID */
      err = nf_close(BAD_ID)    !/* should fail */
      if (err .ne. NF_EBADID)
     +     call errore(
     +     'nf_close with bad netCDF ID returned wrong error: ',
     +     err)

C     /* Close in data mode */
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close in data mode failed: ', err)

      if (.not. readonly) then  !/* tests using netCDF scratch file */
         err = nf_create(scratch, NF_NOCLOBBER, ncid)
         if (err .ne. 0)
     +        call errore('nf_create: ', err)
         err = nf_close(ncid)
         if (err .ne. 0)
     +        call errore('nf_close in define mode: ', err)
         err = nf_delete(scratch)
         if (err .ne. 0)
     +        call errorc('delete of scratch file failed: ',
     +        scratch)
      end if
      end


C     Test nf_inq.
C     Try on bad handle, check error return.
C     Try in data mode, check returned values.
C     Try asking for subsets of info.
C     If in writable section of tests,
C     Try in define mode, after adding an unlimited dimension, variable.
C     On exit, any open netCDF files are closed.
      subroutine test_nf_inq()
      implicit none
#include "tests.inc"
      integer ncid
      integer ncid2             !/* for scratch netCDF dataset */
      integer ndims1             !/* number of dimensions */
      integer nvars1             !/* number of variables */
      integer ngatts1            !/* number of global attributes */
      integer recdim1            !/* id of unlimited dimension */
      integer err
      integer ndims0
      integer nvars0
      integer ngatts0
      integer recdim0
      integer did
      integer vid

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

C     /* Try on bad handle */
      err = nf_inq(BAD_ID, ndims1, nvars1, ngatts1, recdim1)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

      err = nf_inq(ncid, ndims1, nvars1, ngatts1, recdim1)
      if (err .ne. 0) then
         call errore('nf_inq: ', err)
      else if (ndims1 .ne. NDIMS) then
         call errori('nf_inq: wrong number of dimensions returned: ',
     +        ndims1)
      else if (nvars1 .ne. NVARS) then
         call errori('nf_inq: wrong number of variables returned: ',
     +        nvars1)
      else if (ngatts1 .ne. NGATTS) then
         call errori(
     +        'nf_inq: wrong number of global atts returned: ',
     +        ngatts1)
      else if (recdim1 .ne. RECDIM) then
         call errori('nf_inq: wrong record dimension ID returned: ',
     +        recdim1)
      end if

      if (.not. readonly) then  !/* tests using netCDF scratch file */
         err = nf_create(scratch, NF_NOCLOBBER, ncid2)
         if (err .ne. 0) then
            call errore('nf_create: ', err)
         else                   !/* add dim, var, gatt, check inq */
            err = nf_enddef(ncid2) !/* enter data mode */
            err = nf_inq(ncid2, ndims0, nvars0, ngatts0, recdim0)
            if (err .ne. 0)
     +           call errore('nf_inq: ', err)
            err = nf_redef(ncid2) !/* enter define mode */
C     /* Check that inquire still works in define mode */
            err = nf_inq(ncid2, ndims1, nvars1, ngatts1, recdim1)
            if (err .ne. 0) then
               call errore('nf_inq in define mode: ', err)
            else if (ndims1 .ne. ndims0) then
               call errori('nf_inq in define mode: ndims1 wrong, ',
     +              ndims1)
            else if (nvars1 .ne. nvars0) then
               call errori('nf_inq in define mode: nvars1 wrong, ',
     +              nvars1)
            else if (ngatts1 .ne. ngatts0) then
               call errori(
     +              'nf_inq in define mode: ngatts wrong, ', ngatts1)
            else if (recdim1 .ne. recdim0) then
               call errori('nf_inq in define mode: recdim1 wrong, ',
     +              recdim1)
            end if

C     /* Add dim, var, global att */
            err = nf_def_dim(ncid2, 'inqd', 1, did)
            if (err .ne. 0)
     +           call errore('nf_def_dim: ', err)
            err = nf_def_var(ncid2, 'inqv', NF_FLOAT, 0, (/0/), vid)
            if (err .ne. 0)
     +           call errore('nf_def_var: ', err)

            err = nf_put_att_text(ncid2, NF_GLOBAL, 'inqa',
     +           len('stuff'), 'stuff')
            if (err .ne. 0)
     +           call errore('nf_put_att_text: ', err)

C     /* Make sure nf_inq sees the additions while in define mode */
            err = nf_inq(ncid2, ndims1, nvars1, ngatts1, recdim1)
            if (err .ne. 0) then
               call errore('nf_inq in define mode: ', err)
            else if (ndims1 .ne. ndims0 + 1) then
               call errori('nf_inq in define mode: ndims1 wrong, ',
     +              ndims1)
            else if (nvars1 .ne. nvars0 + 1) then
               call errori('nf_inq in define mode: nvars wrong, ',
     +              nvars1)
            else if (ngatts1 .ne. ngatts0 + 1) then
               call errori('nf_inq in define mode: ngatts1 wrong, ',
     +              ngatts1)
            end if
            err = nf_enddef(ncid2)
            if (err .ne. 0)
     +           call errore('nf_enddef: ', err)

C     /* Make sure nf_inq stills sees additions in data mode */
            err = nf_inq(ncid2, ndims1, nvars1, ngatts1, recdim1)
            if (err .ne. 0) then
               call errore('nf_inq failed in data mode: ',err)
            else if (ndims1 .ne. ndims0 + 1) then
               call errori('nf_inq in define mode: ndims1 wrong, ',
     +              ndims1)
            else if (nvars1 .ne. nvars0 + 1) then
               call errori('nf_inq in define mode: nvars wrong, ',
     +              nvars1)
            else if (ngatts1 .ne. ngatts0 + 1) then
               call errori('nf_inq in define mode: ngatts1 wrong, ',
     +              ngatts1)
            end if
            err = nf_close(ncid2)
            err = nf_delete(scratch)
            if (err .ne. 0)
     +           call errorc('delete of scratch file failed:',
     +           scratch)
         end if
      end if

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_natts()
      implicit none
#include "tests.inc"
      integer ncid
      integer ngatts1            !/* number of global attributes */
      integer err

      err = nf_inq_natts(BAD_ID, ngatts1)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_natts(ncid, ngatts1)
      if (err .ne. 0) then
         call errore('nf_inq_natts: ', err)
      else if (ngatts1 .ne. NGATTS) then
         call errori(
     +        'nf_inq_natts: wrong number of global atts returned, ',
     +        ngatts1)
      end if
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_ndims()
      implicit none
#include "tests.inc"
      integer ncid
      integer ndims1
      integer err

      err = nf_inq_ndims(BAD_ID, ndims1)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_ndims(ncid, ndims1)
      if (err .ne. 0) then
         call errore('nf_inq_ndims: ', err)
      else if (ndims1 .ne. NDIMS) then
         call errori('nf_inq_ndims: wrong number returned, ', ndims1)
      end if
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_nvars()
      implicit none
#include "tests.inc"
      integer ncid
      integer nvars1
      integer err

      err = nf_inq_nvars(BAD_ID, nvars1)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_nvars(ncid, nvars1)
      if (err .ne. 0) then
         call errore('nf_inq_nvars: ', err)
      else if (nvars1 .ne. NVARS) then
         call errori('nf_inq_nvars: wrong number returned, ', nvars1)
      end if
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_unlimdim()
      implicit none
#include "tests.inc"
      integer ncid
      integer unlimdim
      integer err

      err = nf_inq_unlimdim(BAD_ID, unlimdim)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_unlimdim(ncid, unlimdim)
      if (err .ne. 0) then
         call errore('nf_inq_unlimdim: ', err)
      else if (unlimdim .ne. RECDIM) then
         call errori('nf_inq_unlimdim: wrong number returned, ',
     +        unlimdim)
      end if
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_format()
      implicit none
#include "tests.inc"
      integer ncid
      integer nformat
      integer err

      err = nf_inq_format(BAD_ID, nformat)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_format(ncid, nformat)
      if (err .ne. 0) then
         call errore('nf_inq_format: ', err)
      else if (nformat .ne. nf_format_classic .and.
#ifdef ENABLE_CDF5
     +        nformat .ne. nf_format_cdf5 .and.
#endif
#ifdef USE_NETCDF4
     +        nformat .ne. nf_format_netcdf4 .and.
#endif
     +        nformat .ne. nf_format_64bit) then
         call errori('nf_inq_format: wrong format number returned, ',
     +        nformat)
      end if
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_dimid()
      implicit none
#include "tests.inc"
      integer ncid
      integer dimid
      integer i
      integer err

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_dimid(ncid, 'noSuch', dimid)
      if (err .ne. NF_EBADDIM)
     +     call errore('bad dim name: ', err)
      do 1, i = 1, NDIMS
         err = nf_inq_dimid(BAD_ID, dim_name(i), dimid)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_dimid(ncid, dim_name(i), dimid)
         if (err .ne. 0) then
            call errore('nf_inq_dimid: ', err)
         else if (dimid .ne. i) then
            call errori('expected ', i)
            call errori('got ', dimid)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_dim()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      character*(NF_MAX_NAME) name
      integer length

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NDIMS
         err = nf_inq_dim(BAD_ID, i, name, length)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_dim(ncid, BAD_DIMID, name, length)
         if (err .ne. NF_EBADDIM)
     +        call errore('bad dimid: ', err)
         err = nf_inq_dim(ncid, i, name, length)
         if (err .ne. 0) then
            call errore('nf_inq_dim: ', err)
         else if (dim_name(i) .ne. name)  then
            call errorc('name unexpected: ', name)
         else if (dim_len(i) .ne. length) then
            call errori('size unexpected: ', length)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_dimlen()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      integer length

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NDIMS
         err = nf_inq_dimlen(BAD_ID, i, length)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_dimlen(ncid, BAD_DIMID, length)
         if (err .ne. NF_EBADDIM)
     +        call errore('bad dimid: ', err)
         err = nf_inq_dimlen(ncid, i, length)
         if (err .ne. 0) then
            call errore('nf_inq_dimlen: ', err)
         else if (dim_len(i) .ne. length) then
            call errori('size unexpected: ', length)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_dimname()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      character*(NF_MAX_NAME)  name

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NDIMS
         err = nf_inq_dimname(BAD_ID, i, name)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_dimname(ncid, BAD_DIMID, name)
         if (err .ne. NF_EBADDIM)
     +        call errore('bad dimid: ', err)
         err = nf_inq_dimname(ncid, i, name)
         if (err .ne. 0) then
            call errore('nf_inq_dimname: ', err)
         else if (dim_name(i) .ne. name)  then
            call errorc('name unexpected: ', name)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_varid()
      implicit none
#include "tests.inc"
      integer ncid
      integer vid
      integer i
      integer err

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      err = nf_inq_varid(ncid, 'noSuch', vid)
      if (err .ne. NF_ENOTVAR)
     +     call errore('bad ncid: ', err)

      do 1, i = 1, NVARS
         err = nf_inq_varid(BAD_ID, var_name(i), vid)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_varid(ncid, var_name(i), vid)
         if (err .ne. 0) then
            call errore('nf_inq_varid: ', err)
         else if (vid .ne. i) then
            call errori('varid unexpected: ', vid)
         endif
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_var()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      character*(NF_MAX_NAME) name
      integer datatype
      integer ndims1
      integer dimids(MAX_RANK)
      integer na

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NVARS
         err = nf_inq_var(BAD_ID, i, name, datatype, ndims1, dimids,
     +        na)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_var(ncid,BAD_VARID,name,datatype,ndims1,dimids,
     +        na)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_var(ncid, i, name, datatype, ndims1, dimids,
     +        na)
         if (err .ne. 0) then
            call errore('nf_inq_var: ', err)
         else if (var_name(i) .ne. name)  then
            call errorc('name unexpected: ', name)
         else if (var_type(i) .ne. datatype) then
            call errori('type unexpected: ', datatype)
         else if (var_rank(i) .ne. ndims1) then
            call errori('ndims1 expected: ', ndims1)
         else if (.not.int_vec_eq(var_dimid(1,i),dimids,ndims1)) then
            call error('unexpected dimid')
         else if (var_natts(i) .ne. na) then
            call errori('natts unexpected: ', na)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_vardimid()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      integer dimids(MAX_RANK)

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NVARS
         err = nf_inq_vardimid(BAD_ID, i, dimids)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_vardimid(ncid, BAD_VARID, dimids)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_vardimid(ncid, i, dimids)
         if (err .ne. 0) then
            call errore('nf_inq_vardimid: ', err)
         else if (.not.int_vec_eq(var_dimid(1,i), dimids,
     +           var_rank(i))) then
            call error('unexpected dimid')
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_varname()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      character*(NF_MAX_NAME) name

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NVARS
         err = nf_inq_varname(BAD_ID, i, name)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_varname(ncid, BAD_VARID, name)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_varname(ncid, i, name)
         if (err .ne. 0) then
            call errore('nf_inq_varname: ', err)
         else if (var_name(i) .ne. name)  then
            call errorc('name unexpected: ', name)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_varnatts()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      integer na

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 0, NVARS	! start with global attributes
         err = nf_inq_varnatts(BAD_ID, i, na)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_varnatts(ncid, BAD_VARID, na)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_varnatts(ncid, VARID(i), na)
         if (err .ne. 0) then
            call errore('nf_inq_varnatts: ', err)
         else if (NATTS(i) .ne. na) then ! works for global attributes
            call errori('natts unexpected: ', na)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_varndims()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      integer ndims1

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NVARS
         err = nf_inq_varndims(BAD_ID, i, ndims1)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_varndims(ncid, BAD_VARID, ndims1)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_varndims(ncid, i, ndims1)
         if (err .ne. 0) then
            call errore('nf_inq_varndims: ', err)
         else if (var_rank(i) .ne. ndims1) then
            call errori('ndims1 unexpected: ', ndims1)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_vartype()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer err
      integer datatype

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 1, i = 1, NVARS
         err = nf_inq_vartype(BAD_ID, i, datatype)
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_inq_vartype(ncid, BAD_VARID, datatype)
         if (err .ne. NF_ENOTVAR)
     +        call errore('bad var id: ', err)
         err = nf_inq_vartype(ncid, i, datatype)
         if (err .ne. 0) then
            call errore('nf_inq_vartype: ', err)
         else if (var_type(i) .ne. datatype) then
            call errori('type unexpected: ', datatype)
         end if
 1    continue
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_att()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer j
      integer err
      integer t
      integer n

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 1, i = 0, NVARS
         do 2, j = 1, NATTS(i)
            err = nf_inq_att(BAD_ID, i, ATT_NAME(j,i), t, n)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_inq_att(ncid, BAD_VARID, ATT_NAME(j,i), t, n)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad var id: ', err)
            err = nf_inq_att(ncid, i, 'noSuch', t, n)
            if (err .ne. NF_ENOTATT)
     +           call errore('Bad attribute name: ', err)
            err = nf_inq_att(ncid, i, ATT_NAME(j,i), t, n)
            if (err .ne. 0) then
               call error(nf_strerror(err))
            else
               if (t .ne. ATT_TYPE(j,i))
     +              call error('type not that expected')
               if (n .ne. ATT_LEN(j,i))
     +              call error('length not that expected')
            end if
 2       continue
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_attlen()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer j
      integer err
      integer len

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 1, i = 0, NVARS
         err = nf_inq_attlen(ncid, i, 'noSuch', len)
         if (err .ne. NF_ENOTATT)
     +        call errore('Bad attribute name: ', err)
         do 2, j = 1, NATTS(i)
            err = nf_inq_attlen(BAD_ID, i, ATT_NAME(j,i), len)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_inq_attlen(ncid, BAD_VARID, ATT_NAME(j,i), len)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad varid: ', err)
            err = nf_inq_attlen(ncid, i, ATT_NAME(j,i), len)
            if (err .ne. 0) then
               call error(nf_strerror(err))
            else
               if (len .ne. ATT_LEN(j,i))
     +              call error('len not that expected')
            end if
 2       continue
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_atttype()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer j
      integer err
      integer datatype

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 1, i = 0, NVARS
         err = nf_inq_atttype(ncid, i, 'noSuch', datatype)
         if (err .ne. NF_ENOTATT)
     +        call errore('Bad attribute name: ', err)
         do 2, j = 1, NATTS(i)
            err = nf_inq_atttype(BAD_ID, i, ATT_NAME(j,i), datatype)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_inq_atttype(ncid, BAD_VARID, ATT_NAME(j,i),
     +           datatype)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad varid: ', err)
            err = nf_inq_atttype(ncid, i, ATT_NAME(j,i), datatype)
            if (err .ne. 0) then
               call error(nf_strerror(err))
            else
               if (datatype .ne. ATT_TYPE(j,i))
     +              call error('type not that expected')
            end if
 2       continue
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_attname()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer j
      integer err
      character*(NF_MAX_NAME) name

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 1, i = 0, NVARS
         err = nf_inq_attname(ncid, i, BAD_ATTNUM, name)
         if (err .ne. NF_ENOTATT)
     +        call errore('Bad attribute number: ', err)
         err = nf_inq_attname(ncid, i, NATTS(i)+1, name)
         if (err .ne. NF_ENOTATT)
     +        call errore('Bad attribute number: ', err)
         do 2, j = 1, NATTS(i)
            err = nf_inq_attname(BAD_ID, i, j, name)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_inq_attname(ncid, BAD_VARID, j, name)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad var id: ', err)
            err = nf_inq_attname(ncid, i, j, name)
            if (err .ne. 0) then
               call error(nf_strerror(err))
            else
               if (ATT_NAME(j,i) .ne. name)
     +              call error('name not that expected')
            end if
 2       continue
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end


      subroutine test_nf_inq_attid()
      implicit none
#include "tests.inc"
      integer ncid
      integer i
      integer j
      integer err
      integer attnum

      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 1, i = 0, NVARS
         err = nf_inq_attid(ncid, i, 'noSuch', attnum)
         if (err .ne. NF_ENOTATT)
     +        call errore('Bad attribute name: ', err)
         do 2, j = 1, NATTS(i)
            err = nf_inq_attid(BAD_ID, i, ATT_NAME(j,i), attnum)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_inq_attid(ncid, BAD_VARID, ATT_NAME(j,i),
     +           attnum)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad varid: ', err)
            err = nf_inq_attid(ncid, i, ATT_NAME(j,i), attnum)
            if (err .ne. 0) then
               call error(nf_strerror(err))
            else
               if (attnum .ne. j)
     +              call error('attnum not that expected')
            end if
 2       continue
 1    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example program which writes some 4D pressure and
C     temperatures. It is intended to illustrate the use of the netCDF
C     fortran 77 API. The companion program pres_temp_4D_rd.f shows how
C     to read the netCDF data file created by this program.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program pres_temp_4D_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME = 'pres_temp_4D.nc')
      integer ncid

C     We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')
      integer lvl_dimid, lon_dimid, lat_dimid, rec_dimid

C     The start and count arrays will tell the netCDF library where to
C     write our data.
      integer start(NDIMS), count(NDIMS)

C     These program variables hold the latitudes and longitudes.
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will create two netCDF variables, one each for temperature and
C     pressure fields.
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will write out. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_out(NLONS, NLATS, NLVLS)
      real temp_out(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to construct some latitude and longitude data for this
C     example.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Create pretend data. If this wasn't an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      i = 0
      do lvl = 1, NLVLS
         do lat = 1, NLATS
            do lon = 1, NLONS
               pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
               temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
               i = i + 1
            end do
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions. The record dimension is defined to have
C     unlimited length - it can grow as needed. In this example it is
C     the time dimension.
      retval = nf_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, REC_NAME, NF_UNLIMITED, rec_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. We will only define coordinate
C     variables for lat and lon.  Ordinarily we would need to provide
C     an array of dimension IDs for each variable's dimensions, but
C     since coordinate variables only have one dimension, we can
C     simply provide the address of that dimension ID (lat_dimid) and
C     similarly for (lon_dimid).
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate variables.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the dimids of the dimensions of
C     the netCDF variables. Both of the netCDF variables we are creating
C     share the same four dimensions. In Fortran, the unlimited
C     dimension must come last on the list of dimids.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      dimids(3) = lvl_dimid
      dimids(4) = rec_dimid

C     Define the netCDF variables for the pressure and temperature data.
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the netCDF variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     These settings tell netcdf to write one timestep of data. (The
C     setting of start(4) inside the loop below tells netCDF which
C     timestep to write.)
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays only hold one timestep worth
C     of data. We will just rewrite the same data for each timestep. In
C     a real application, the data would change between timesteps.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_put_vara_real(ncid, pres_varid, start, count, 
     +        pres_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_put_vara_real(ncid, temp_varid, start, count,
     +        temp_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
      end do

C     Close the file. This causes netCDF to flush all buffers and make
C     sure your data are really written to disk.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
      print *,'*** SUCCESS writing example file', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

Module netcdf4_f03

! Module to provide inheritance of Netcdf4 data and interfaces from nf_data
! and nf_interfaces modules. Not really needed by netCDF but provided for
! folks writing new code or updating old code who would prefer using
! modules instead of the old netcdf.inc include file.

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu
          

! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.0 - April 2009 - Separate module for netcdf 4 for now to
!                            to simplify build process

! This module can be used as a replacement for an include to netcdf.inc
! The module is named netcdf4_f03 to differentiate it from the
! netcdf_f03 module


 USE netcdf_nf_data        ! Brings in the nf interface error flags etc. 
 USE netcdf_nf_interfaces  ! Brings in explicit interfaces to nf_ routines
 USE netcdf4_nf_interfaces ! Bring in netcdf4 interfaces

 Implicit NONE

!------------------------------- End of Module netcdf4_f03 ---------------------
 End Module netcdf4_f03

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     checking fill value handling.

C     Ed Hartnett, 2009

      program ftst_vars6
      USE netcdf4_f03
      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_vars6.nc')
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 2)
      integer check_file

      integer ncid, varid(NVARS), dimids(NDIMS)
      integer data_len_in, offset
      parameter (offset = 20)
      integer data1(data_len), data1_in(data_len)
      character*(4) var_name(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer NO_FILL, MY_FILL_VALUE
      parameter (NO_FILL = 1)
      parameter (MY_FILL_VALUE = 42)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing fill values.'

C     Prepare some data to write.
      do x = 1, data_len
         data1(x) = x
      end do

C     Set up var names.
      var_name(1) = 'var1'
      var_name(2) = 'var2'
      var_name(3) = 'var3'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create a few integer variables.
      do x = 1, NVARS      
         retval = nf_def_var(ncid, var_name(x), NF_INT, NDIMS, dimids,
     $        varid(x))
         if (retval .ne. nf_noerr) stop 1
      end do

C     Set no fill mode for the second variable.
      retval = nf_def_var_fill(ncid, varid(2), NO_FILL, 88)
      if (retval .ne. 0) stop 2

C     Set an alternative fill value for the third variable.
      retval = nf_def_var_fill(ncid, varid(3), 0, MY_FILL_VALUE)
      if (retval .ne. 0) stop 3

C     Check it out. 
c      retval = check_file(ncid, var_name, dim_name)
c      if (retval .ne. 0) stop 2

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Check it out. 
      retval = check_file(ncid, var_name, dim_name)
      if (retval .ne. 0) stop 4

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, dim_name)
      USE netcdf4_f03
      implicit none

C     I need these in both here and the main program.
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 2)
      integer MY_FILL_VALUE
      parameter (MY_FILL_VALUE = 42)

C     Parameters
      integer ncid
      character*(4) var_name(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer xtype_in, dimids_in(NDIMS), natts_in
      integer varid_in(NVARS), dimid_in, no_fill_in, fill_value_in
      character*(4) var_name_in
      integer int_data_in(DIM_LEN)

      integer x, retval

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 5

C     Get the varids and the dimid.
      do x = 1, NVARS      
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 1
         if (varid_in(x) .ne. x) stop 6
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (dimid_in .ne. 1) stop 7

C     These things are the same for all three variables, except
C     natts_in..
      do x = 1, NVARS      
         retval = nf_inq_var(ncid, varid_in(x), var_name_in, xtype_in,
     $        ndims_in, dimids_in, natts_in)
         if (retval .ne. nf_noerr) stop 1
         if (ndims_in .ne. 1 .or. xtype_in .ne. NF_INT .or. dimids_in(1)
     $        .ne. dimid_in) stop 8
         if (x .eq. 3 .and. natts_in .ne. 1) stop 9
         if (x .lt. 3 .and. natts_in .ne. 0) stop 10
      end do

C     Check the fill value for the first var. Nothing was set, so
C     no_fill should be off, and fill_value should be the default fill
C     value for this type.
      retval = nf_inq_var_fill(ncid, varid_in(1), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 0 .or. fill_value_in .ne. nf_fill_int) stop 11

C     Check that no_fill mode is on for the second variable.
      retval = nf_inq_var_fill(ncid, varid_in(2), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 1 .or. fill_value_in .ne. nf_fill_int) stop 12

C     Check that a non-default fill value is in use for the third variable.
      retval = nf_inq_var_fill(ncid, varid_in(3), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 0 .or. fill_value_in .ne. MY_FILL_VALUE) stop
     $     2

C     Get the data in var1. It will be all the default fill value.
      retval = nf_get_var_int(ncid, varid_in(1), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. nf_fill_int) stop 13
      end do

C     Get the data in var2. What will it be?
      retval = nf_get_var_int(ncid, varid_in(2), int_data_in)
      if (retval .ne. nf_noerr) stop 1
C$$$      do x = 1, DIM_LEN
C$$$         print *, int_data_in(x)
C$$$      end do

C     Get the data in var3. It will be all the default fill value.
      retval = nf_get_var_int(ncid, varid_in(3), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
C         print *, int_data_in(x)
         if (int_data_in(x) .ne. MY_FILL_VALUE) stop 14
      end do

      check_file = 0
      end 

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing chunking and deflate settings.

C     $Id: ftst_vars.F,v 1.19 2009/09/27 21:25:23 ed Exp $

      program ftst_vars
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars.nc')

C     We are writing 2D data, a 6 x 12 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid

C     This is the data array we will write, and a place to store it when
C     we read it back in.
      integer data_out(NY, NX), data_in(NY, NX)

C     For checking our data file to make sure it's correct.
      integer chunks(NDIMS), chunks_in(NDIMS)
      integer shuffle, deflate, deflate_level, checksum, contiguous
      integer endianness

C     Cache size stuff.
      integer CACHE_SIZE, CACHE_NELEMS, CACHE_PREEMPTION
      parameter (CACHE_SIZE = 8000, CACHE_NELEMS = 500)
      parameter (CACHE_PREEMPTION = 50)
      integer cache_size_in, cache_nelems_in, cache_preemption_in

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = 2147483646 + x * y
         end do
      end do

      print *, ''
      print *,'*** Testing definition of netCDF-4 vars from Fortran 77.'

C     Change the cache size for the files created/opened in this program.
      retval = nf_set_chunk_cache(CACHE_SIZE, CACHE_NELEMS, 
     &     CACHE_PREEMPTION)
      if (retval .ne. nf_noerr) stop 1

C     Check chunk cache sizes.
      retval = nf_get_chunk_cache(cache_size_in, cache_nelems_in, 
     &     cache_preemption_in)
      if (retval .ne. nf_noerr) stop 1
      if (cache_size_in .ne. CACHE_SIZE .or. 
     &     cache_nelems_in .ne. CACHE_NELEMS .or. 
     &     cache_preemption_in .ne. CACHE_PREEMPTION) stop 4

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) stop 1

C     Define the variable. 
      dimids(1) = y_dimid
      dimids(2) = x_dimid
      retval = nf_def_var(ncid, "data", NF_INT64, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) stop 1

C     Turn on chunking.
      chunks(1) = NY
      chunks(2) = NX
      retval = nf_def_var_chunking(ncid, varid, 0, chunks)
      if (retval .ne. nf_noerr) stop 1

C     Set variable to big-endian (default is whatever is native to
C     writing machine).
      retval = nf_def_var_endian(ncid, varid, NF_ENDIAN_BIG)
      if (retval .ne. nf_noerr) stop 1

C     Turn on deflate, fletcher32.
      retval = nf_def_var_deflate(ncid, varid, 0, 1, 4)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_var_fletcher32(ncid, varid, NF_FLETCHER32)
      if (retval .ne. nf_noerr) stop 1

C     Is everything set that is supposed to be?
      retval = nf_inq_var_deflate(ncid, varid, shuffle, deflate, 
     +     deflate_level)
      if (retval .ne. nf_noerr) stop 1
      if (shuffle .ne. 0 .or. deflate .ne. 1 .or. 
     +     deflate_level .ne. 4) stop 2
      retval = nf_inq_var_fletcher32(ncid, varid, checksum)
      if (retval .ne. nf_noerr) stop 1
      if (checksum .ne. NF_FLETCHER32) stop 2
      retval = nf_inq_var_chunking(ncid, varid, contiguous, chunks_in)
      if (retval .ne. nf_noerr) stop 1
      if (contiguous .ne. 0) stop 2
      if (chunks(1) .ne. chunks_in(1) .or.
     +     chunks(2) .ne. chunks_in(2)) stop 2
      retval = nf_inq_var_endian(ncid, varid, endianness)
      if (retval .ne. nf_noerr) stop 1
      if (endianness .ne. NF_ENDIAN_BIG) stop 2

C     Since this is a classic model file, we must call enddef
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find our variable.
      retval = nf_inq_varid(ncid, "data", varid)
      if (retval .ne. nf_noerr) stop 1
      if (varid .ne. 1) stop 2

C     Check the deflate, fletcher32, chunking, and endianness.
      retval = nf_inq_var_deflate(ncid, varid, shuffle, deflate, 
     +     deflate_level)
      if (retval .ne. nf_noerr) stop 1
      if (shuffle .ne. 0 .or. deflate .ne. 1 .or. 
     +     deflate_level .ne. 4) stop 2
      retval = nf_inq_var_fletcher32(ncid, varid, checksum)
      if (retval .ne. nf_noerr) stop 1
      if (checksum .ne. NF_FLETCHER32) stop 2
      retval = nf_inq_var_chunking(ncid, varid, contiguous, chunks_in)
      if (retval .ne. nf_noerr) stop 1
      if (contiguous .ne. 0) stop 2
      if (chunks(1) .ne. chunks_in(1) .or.
     +     chunks(2) .ne. chunks_in(2)) stop 2
      retval = nf_inq_var_endian(ncid, varid, endianness)
      if (retval .ne. nf_noerr) stop 1
      if (endianness .ne. NF_ENDIAN_BIG) stop 2

C     Read the data and check it.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. data_out(y, x)) stop 2
         end do
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example program which writes some 4D pressure and
! temperatures. It is intended to illustrate the use of the netCDF
! fortran 90 API. The companion program pres_temp_4D_rd.f shows how
! to read the netCDF data file created by this program.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program pres_temp_4D_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "pres_temp_4D.nc"
  integer :: ncid

  ! We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"
  integer :: lvl_dimid, lon_dimid, lat_dimid, rec_dimid

  ! The start and count arrays will tell the netCDF library where to
  ! write our data.
  integer :: start(NDIMS), count(NDIMS)

  ! These program variables hold the latitudes and longitudes.
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will create two netCDF variables, one each for temperature and
  ! pressure fields.
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will write out. We will only
  ! need enough space to hold one timestep of data; one record.
  real, dimension(:,:,:), allocatable :: pres_out
  real, dimension(:,:,:), allocatable :: temp_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to construct some latitude and longitude data for this
  ! example.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS, NLVLS))
  allocate(temp_out(NLONS, NLATS, NLVLS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  i = 0
  do lvl = 1, NLVLS
     do lat = 1, NLATS
        do lon = 1, NLONS
           pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
           temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
           i = i + 1
        end do
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, nf90_clobber, ncid) )
  
  ! Define the dimensions. The record dimension is defined to have
  ! unlimited length - it can grow as needed. In this example it is
  ! the time dimension.
  call check( nf90_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid) )
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )
  call check( nf90_def_dim(ncid, REC_NAME, NF90_UNLIMITED, rec_dimid) )

  ! Define the coordinate variables. We will only define coordinate
  ! variables for lat and lon.  Ordinarily we would need to provide
  ! an array of dimension IDs for each variable's dimensions, but
  ! since coordinate variables only have one dimension, we can
  ! simply provide the address of that dimension ID (lat_dimid) and
  ! similarly for (lon_dimid).
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate variables.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! The dimids array is used to pass the dimids of the dimensions of
  ! the netCDF variables. Both of the netCDF variables we are creating
  ! share the same four dimensions. In Fortran, the unlimited
  ! dimension must come last on the list of dimids.
  dimids = (/ lon_dimid, lat_dimid, lvl_dimid, rec_dimid /)

  ! Define the netCDF variables for the pressure and temperature data.
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the netCDF variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )
  
  ! End define mode.
  call check( nf90_enddef(ncid) )
  
  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )
  
  ! These settings tell netcdf to write one timestep of data. (The
  ! setting of start(4) inside the loop below tells netCDF which
  ! timestep to write.)
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays only hold one timestep worth
  ! of data. We will just rewrite the same data for each timestep. In
  ! a real :: application, the data would change between timesteps.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_put_var(ncid, pres_varid, pres_out, start = start, &
                              count = count) )
     call check( nf90_put_var(ncid, temp_varid, temp_out, start = start, &
                              count = count) )
  end do
  
  ! Close the file. This causes netCDF to flush all buffers and make
  ! sure your data are really written to disk.
  call check( nf90_close(ncid) )
  
  print *,"*** SUCCESS writing example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program pres_temp_4D_wr

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 fill values.

!     Russ Rew, 2009

program f90tst_fill
  use typeSizes
  use netcdf
  implicit none
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_fill2.nc"
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: HALF_NX = NX / 2, HALF_NY = NY / 2
  integer, parameter :: ZERO_COUNT = 0
  integer, parameter :: NUM_VARS = 8
  character (len = *), parameter :: var_name(NUM_VARS) = &
       (/ 'byte  ', 'short ', 'int   ', 'float ', 'double', 'ubyte ', &
          'ushort', 'uint  ' /)
  integer :: ncid, varid(NUM_VARS), dimids(MAX_DIMS)
  integer :: var_type(NUM_VARS) = (/ nf90_byte, nf90_short, nf90_int, &
       nf90_float, nf90_double, nf90_ubyte, nf90_ushort, nf90_uint /)
  integer :: x_dimid, y_dimid
  integer :: byte_out(HALF_NY, HALF_NX), byte_in(NY, NX)
  integer :: short_out(HALF_NY, HALF_NX), short_in(NY, NX)
  integer :: int_out(HALF_NY, HALF_NX), int_in(NY, NX)
  real :: areal_out(HALF_NY, HALF_NX), areal_in(NY, NX)
  real :: double_out(HALF_NY, HALF_NX), double_in(NY, NX)
  integer :: ubyte_out(HALF_NY, HALF_NX), ubyte_in(NY, NX)
  integer :: ushort_out(HALF_NY, HALF_NX), ushort_in(NY, NX)
  integer (kind = EightByteInt) :: uint_out(HALF_NY, HALF_NX), uint_in(NY, NX)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y, v
  integer :: start_out(MAX_DIMS), count_out(MAX_DIMS)
  integer :: start_in(MAX_DIMS), count_in(MAX_DIMS)

  print *
  print *, '*** Testing netCDF-4 fill values with unlimited dimension.'

  ! Create some pretend data.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        byte_out(y, x) = -1
        short_out(y, x) =  -2
        int_out(y, x) = -4
        areal_out(y, x) = 2.5
        double_out(y, x) = -4.5
        ubyte_out(y, x) = 1
        ushort_out(y, x) = 2
        uint_out(y, x) = 4
     end do
  end do

  ! Create the netCDF file. 
  call handle_err(nf90_create(FILE_NAME, nf90_netcdf4, ncid))

  ! Define the dimensions.
  call handle_err(nf90_def_dim(ncid, "x", NF90_UNLIMITED, x_dimid))
  call handle_err(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variables. 
  do v = 1, NUM_VARS
     call handle_err(nf90_def_var(ncid, var_name(v), var_type(v), dimids, varid(v)))
  end do

  ! Write one-quarter of the data.
  count_out = (/ HALF_NX, HALF_NY /)
  start_out = (/ HALF_NX + 1, HALF_NY + 1 /)
  call handle_err(nf90_put_var(ncid, varid(1), byte_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(2), short_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(3), int_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(4), areal_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(5), double_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(6), ubyte_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(7), ushort_out, start = start_out, count = count_out))
  call handle_err(nf90_put_var(ncid, varid(8), uint_out, start = start_out, count = count_out))

  ! Test when one dimension of count is 0
  count_out = (/ HALF_NX, ZERO_COUNT /)
  call handle_err(nf90_put_var(ncid, varid(3), int_out, start = start_out, count = count_out))
  count_out = (/ HALF_NX, HALF_NY /)

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid))
  
  ! Check some stuff out.
  call handle_err(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= NUM_VARS .or. ngatts /= 0 .or. unlimdimid /= 1 .or. &
       file_format /= nf90_format_netcdf4) stop 2

  ! Read all the data.
  start_in = (/ 1, 1 /)
  count_in = (/ NX, NY /)
  call handle_err(nf90_get_var(ncid, varid(1), byte_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(2), short_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(3), int_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(4), areal_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(5), double_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(6), ubyte_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(7), ushort_in, start = start_in, count = count_in))
  call handle_err(nf90_get_var(ncid, varid(8), uint_in, start = start_in, count = count_in))

  ! Check the data. All the data except the third quadrant are fill
  ! value.
  do x = 1, NX
     do y = 1, NY
        if ((x .gt. HALF_NX) .and. (y .gt. HALF_NY)) then
           if (byte_in(y, x) .ne. -1) stop 13
           if (short_in(y, x) .ne. -2) stop 14
           if (int_in(y, x) .ne. -4) stop 15
           if (areal_in(y, x) .ne. 2.5) stop 16
           if (double_in(y, x) .ne. -4.5) stop 17
           if (ubyte_in(y, x) .ne. 1) stop 18
           if (ushort_in(y, x) .ne. 2) stop 19
           if (uint_in(y, x) .ne. 4) stop 20
        else 
           if (byte_in(y, x) .ne. nf90_fill_byte) stop 3
           if (short_in(y, x) .ne. nf90_fill_short) stop 4
           if (int_in(y, x) .ne. nf90_fill_int) stop 5
           if (areal_in(y, x) .ne. nf90_fill_real) stop 6
           if (double_in(y, x) .ne. nf90_fill_double) stop 7
           if (ubyte_in(y, x) .ne. nf90_fill_ubyte) stop 8
           if (ushort_in(y, x) .ne. nf90_fill_ushort) stop 9
           if (uint_in(y, x) .ne. nf90_fill_uint) stop 10
        endif
     end do
  end do

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 99
    endif
  end subroutine handle_err
end program f90tst_fill

! This is part of the netCDF package.  Copyright 2006 University
! Corporation for Atmospheric Research/Unidata.  See COPYRIGHT file
! for conditions of use.

! This is a very simple example which writes a 2D array of sample
! data. To handle this in netCDF we create two shared dimensions, "x"
! and "y", and a netCDF variable, called "data". It uses parallel I/O
! to write the file from all processors at the same time.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_par_wr
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! We are writing 2D data.
  integer, parameter :: NDIMS = 2

  ! When we create netCDF files, variables and dimensions, we get back
  ! an ID for each one.
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid

  ! These will tell where in the data file this processor should
  ! write.
  integer :: start(NDIMS), count(NDIMS)
  
  ! This is the data array we will write. It will just be filled with
  ! the rank of this processor.
  integer, allocatable :: data_out(:)

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Create some pretend data. We just need one row.
  allocate(data_out(p), stat = stat)
  if (stat .ne. 0) stop 3
  do x = 1, p
     data_out(x) = my_rank
  end do

  ! Create the netCDF file. The NF90_NETCDF4 flag causes a
  ! HDF5/netCDF-4 file to be created. The comm and info parameters
  ! cause parallel I/O to be enabled. Use either NF90_MPIIO or
  ! NF90_MPIPOSIX to select between MPI/IO and MPI/POSIX.
  call check(nf90_create(FILE_NAME, IOR(NF90_NETCDF4, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Define the dimensions. NetCDF will hand back an ID for
  ! each. Metadata operations must take place on all processors.
  call check(nf90_def_dim(ncid, "x", p, x_dimid))
  call check(nf90_def_dim(ncid, "y", p, y_dimid))

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids = (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer).
  call check(nf90_def_var(ncid, "data", NF90_INT, dimids, varid))

  ! End define mode. This tells netCDF we are done defining
  ! metadata. This operation is collective and all processors will
  ! write their metadata to disk.
  call check(nf90_enddef(ncid))

  ! Write the pretend data to the file. Each processor writes one row.
  start = (/ 1, my_rank + 1/)
  count = (/ p, 1 /)
  call check(nf90_put_var(ncid, varid, data_out, start = start, &
       count = count))

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_out)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *, "*** SUCCESS writing example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_wr

  ! Overloaded variable functions
  interface nf90_def_var
    module procedure nf90_def_var_Scalar, nf90_def_var_oneDim, nf90_def_var_ManyDims
  end interface ! nf90_def_var

  ! Overloaded attribute functions
  interface nf90_put_att
    module procedure nf90_put_att_text,                                      &
                     nf90_put_att_OneByteInt,     nf90_put_att_TwoByteInt,   &
                     nf90_put_att_FourByteInt,    nf90_put_att_EightByteInt, &
                     nf90_put_att_FourByteReal,   nf90_put_att_EightByteReal
    module procedure nf90_put_att_one_OneByteInt,   nf90_put_att_one_TwoByteInt,   &
                     nf90_put_att_one_FourByteInt,  nf90_put_att_one_EightByteInt, &
                     nf90_put_att_one_FourByteReal, nf90_put_att_one_EightByteReal
  end interface !nf90_put_att
  interface nf90_get_att
    module procedure nf90_get_att_text,                                      &
                     nf90_get_att_OneByteInt,     nf90_get_att_TwoByteInt,   &
                     nf90_get_att_FourByteInt,    nf90_get_att_EightByteInt, &
                     nf90_get_att_FourByteReal,   nf90_get_att_EightByteReal
    module procedure nf90_get_att_one_OneByteInt,   nf90_get_att_one_TwoByteInt,   &
                     nf90_get_att_one_FourByteInt,  nf90_get_att_one_EightByteInt, &
                     nf90_get_att_one_FourByteReal, nf90_get_att_one_EightByteReal
  end interface ! nf90_get_att

  ! Overloaded variable functions
  interface nf90_put_var
    module procedure nf90_put_var_text,                                   &
                     nf90_put_var_OneByteInt, nf90_put_var_TwoByteInt,    &
                     nf90_put_var_FourByteInt, nf90_put_var_EightByteInt, &
                     nf90_put_var_FourByteReal, nf90_put_var_EightByteReal
    module procedure nf90_put_var_1D_text,                                      &
                     nf90_put_var_1D_OneByteInt, nf90_put_var_1D_TwoByteInt,    &
                     nf90_put_var_1D_FourByteInt, nf90_put_var_1D_EightByteInt, &
                     nf90_put_var_1D_FourByteReal, nf90_put_var_1D_EightByteReal
    module procedure nf90_put_var_2D_text,                                       &
                     nf90_put_var_2D_OneByteInt, nf90_put_var_2D_TwoByteInt,     &
                     nf90_put_var_2D_FourByteInt, nf90_put_var_2D_EightByteInt,  &
                     nf90_put_var_2D_FourByteReal, nf90_put_var_2D_EightByteReal
    module procedure nf90_put_var_3D_text,                                       &
                     nf90_put_var_3D_OneByteInt, nf90_put_var_3D_TwoByteInt,     &
                     nf90_put_var_3D_FourByteInt, nf90_put_var_3D_EightByteInt,  &
                     nf90_put_var_3D_FourByteReal, nf90_put_var_3D_EightByteReal
    module procedure nf90_put_var_4D_text,                                       &
                     nf90_put_var_4D_OneByteInt, nf90_put_var_4D_TwoByteInt,     &
                     nf90_put_var_4D_FourByteInt, nf90_put_var_4D_EightByteInt,  &
                     nf90_put_var_4D_FourByteReal, nf90_put_var_4D_EightByteReal
    module procedure nf90_put_var_5D_text,                                       &
                     nf90_put_var_5D_OneByteInt, nf90_put_var_5D_TwoByteInt,     &
                     nf90_put_var_5D_FourByteInt, nf90_put_var_5D_EightByteInt,  &
                     nf90_put_var_5D_FourByteReal, nf90_put_var_5D_EightByteReal
    module procedure nf90_put_var_6D_text,                                       &
                     nf90_put_var_6D_OneByteInt, nf90_put_var_6D_TwoByteInt,     &
                     nf90_put_var_6D_FourByteInt, nf90_put_var_6D_EightByteInt,  &
                     nf90_put_var_6D_FourByteReal, nf90_put_var_6D_EightByteReal
    module procedure nf90_put_var_7D_text,                                       &
                     nf90_put_var_7D_OneByteInt, nf90_put_var_7D_TwoByteInt,     &
                     nf90_put_var_7D_FourByteInt, nf90_put_var_7D_EightByteInt,  &
                     nf90_put_var_7D_FourByteReal, nf90_put_var_7D_EightByteReal
  end interface ! nf90_put_var

  interface nf90_get_var
    module procedure nf90_get_var_text,                                   &
                     nf90_get_var_OneByteInt, nf90_get_var_TwoByteInt,    &
                     nf90_get_var_FourByteInt, nf90_get_var_EightByteInt, &
                     nf90_get_var_FourByteReal, nf90_get_var_EightByteReal
    module procedure nf90_get_var_1D_text,                                      &
                     nf90_get_var_1D_OneByteInt, nf90_get_var_1D_TwoByteInt,    &
                     nf90_get_var_1D_FourByteInt, nf90_get_var_1D_EightByteInt, &
                     nf90_get_var_1D_FourByteReal, nf90_get_var_1D_EightByteReal
    module procedure nf90_get_var_2D_text,                                      &
                     nf90_get_var_2D_OneByteInt, nf90_get_var_2D_TwoByteInt,    &
                     nf90_get_var_2D_FourByteInt, nf90_get_var_2D_EightByteInt, &
                     nf90_get_var_2D_FourByteReal, nf90_get_var_2D_EightByteReal
    module procedure nf90_get_var_3D_text,                                      &
                     nf90_get_var_3D_OneByteInt, nf90_get_var_3D_TwoByteInt,    &
                     nf90_get_var_3D_FourByteInt, nf90_get_var_3D_EightByteInt, &
                     nf90_get_var_3D_FourByteReal, nf90_get_var_3D_EightByteReal
    module procedure nf90_get_var_4D_text,                                      &
                     nf90_get_var_4D_OneByteInt, nf90_get_var_4D_TwoByteInt,    &
                     nf90_get_var_4D_FourByteInt, nf90_get_var_4D_EightByteInt, &
                     nf90_get_var_4D_FourByteReal, nf90_get_var_4D_EightByteReal
    module procedure nf90_get_var_5D_text,                                      &
                     nf90_get_var_5D_OneByteInt, nf90_get_var_5D_TwoByteInt,    &
                     nf90_get_var_5D_FourByteInt, nf90_get_var_5D_EightByteInt, &
                     nf90_get_var_5D_FourByteReal, nf90_get_var_5D_EightByteReal
    module procedure nf90_get_var_6D_text,                                      &
                     nf90_get_var_6D_OneByteInt, nf90_get_var_6D_TwoByteInt,    &
                     nf90_get_var_6D_FourByteInt, nf90_get_var_6D_EightByteInt, &
                     nf90_get_var_6D_FourByteReal, nf90_get_var_6D_EightByteReal
    module procedure nf90_get_var_7D_text,                                      &
                     nf90_get_var_7D_OneByteInt, nf90_get_var_7D_TwoByteInt,    &
                     nf90_get_var_7D_FourByteInt, nf90_get_var_7D_EightByteInt, &
                     nf90_get_var_7D_FourByteReal, nf90_get_var_7D_EightByteReal
  end interface ! nf90_get_var

Module netcdf4_nf_interfaces

! Explicit interfaces for Netcdf4 FORTRAN 2003 nf FORTRAN interface routines

! We exclude functions for netCDF4 that pass data of any type to/from void
! pointers in C using a C_CHAR string array. We do provide external statements
! for these routines 

! Written by: Richard Weed, Ph.D.
!             Center for Advanced Vehicular Systems 
!             Mississippi State University
!             rweed@cavs.msstate.edu
!
! The author grants to the University Center for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1. April 2009 - Initial module based on netCDF 4.0.1 interfaces
!                         A separate module is required to avoid a
!                         module dependency problem
! Version 2. April 2010 - Updated to Netcdf 4.1.1
! Version 3. Aug.  2013 - Made nf_def_var_fill and nf_inq_var_fill external
!                         to support new nf90_ non-integer fill characters
!                         Added interface for new nf_rename_grp function 
!                         Changed interface type defs to USE netcdf_nf_data
! Version 4. Jan.   2016  General code cleanup

! Most legacy programs don't need to use this module. However, I've created
! it to support FORTRAN programmers who like to provide explicit interfaces
! for all subroutines and functions in their codes. Therefore, this module is
! is primarily for people writing new programs.

!           Explicit interfaces to netCDF 4 specific FORTRAN functions

!-------------------------------- nf_inq_ncid ---------------------------------
Interface
 Function nf_inq_ncid( ncid, name, groupid) RESULT (status)

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: groupid
 Integer                       :: status

 End Function nf_inq_ncid
End Interface
!-------------------------------- nf_inq_grps ---------------------------------
Interface
 Function nf_inq_grps( ncid, numgrps, ncids) RESULT (status)

 Integer, Intent(IN)    :: ncid
 Integer, Intent(OUT)   :: numgrps
 Integer, Intent(INOUT) :: ncids(*)
 Integer                :: status

 End Function nf_inq_grps
End Interface
!-------------------------------- nf_inq_grpname ------------------------------
Interface
 Function nf_inq_grpname( ncid, name) RESULT (status)

 Integer,          Intent(IN)  :: ncid
 Character(LEN=*), Intent(OUT) :: name
 Integer                       :: status

 End Function nf_inq_grpname
End Interface
!-------------------------------- nf_inq_grpname_full -------------------------
Interface
 Function nf_inq_grpname_full( ncid, nlen, name) RESULT (status)

 Integer,          Intent(IN)  :: ncid
 Integer,          Intent(OUT) :: nlen 
 Character(LEN=*), Intent(OUT) :: name
 Integer                       :: status

 End Function nf_inq_grpname_full
End Interface
!-------------------------------- nf_inq_grpname_len -------------------------
Interface
 Function nf_inq_grpname_len( ncid, nlen) RESULT (status)

 Integer, Intent(IN)  :: ncid
 Integer, Intent(OUT) :: nlen 
 Integer              :: status

 End Function nf_inq_grpname_len
End Interface
!-------------------------------- nf_inq_grp_parent ---------------------------
Interface
 Function nf_inq_grp_parent( ncid,parent_ncid) RESULT (status)

 Integer, Intent(IN)    :: ncid
 Integer, Intent(INOUT) :: parent_ncid
 Integer                :: status

 End Function nf_inq_grp_parent
End Interface
!-------------------------------- nf_inq_grp_full_ncid ------------------------
Interface
 Function nf_inq_grp_full_ncid( ncid, grp_name, grp_ncid) RESULT (status)

 Integer,          Intent(IN)    :: ncid
 Character(LEN=*), Intent(IN)    :: grp_name
 Integer,          Intent(INOUT) :: grp_ncid
 Integer                         :: status

 End Function nf_inq_grp_full_ncid
End Interface
!-------------------------------- nf_inq_grp_ncid -----------------------------
Interface
 Function nf_inq_grp_ncid( ncid, grp_name, parent_ncid) RESULT (status)

 Integer,          Intent(IN)    :: ncid
 Character(LEN=*), Intent(IN)    :: grp_name
 Integer,          Intent(INOUT) :: parent_ncid
 Integer                         :: status

 End Function nf_inq_grp_ncid
End Interface
!-------------------------------- nf_inq_varids -------------------------------
Interface
 Function nf_inq_varids( ncid, nvars, varids) RESULT (status)

 Integer, Intent(IN)    :: ncid
 Integer, Intent(OUT)   :: nvars 
 Integer, Intent(INOUT) :: varids(*)
 Integer                :: status

 End Function nf_inq_varids
End Interface
!-------------------------------- nf_inq_dimids -------------------------------
Interface
 Function nf_inq_dimids( ncid, ndims, dimids, include_parents) RESULT (status)

 Integer, Intent(IN)    :: ncid, include_parents
 Integer, Intent(OUT)   :: ndims
 Integer, Intent(INOUT) :: dimids(*)
 Integer                :: status

 End Function nf_inq_dimids
End Interface
!-------------------------------- nf_inq_typeids ------------------------------
Interface
 Function nf_inq_typeids( ncid, ntypes, typeids) RESULT (status)

 Integer, Intent(IN)    :: ncid
 Integer, Intent(OUT)   :: ntypes
 Integer, Intent(INOUT) :: typeids(*)
 Integer                :: status

 End Function nf_inq_typeids
End Interface
!-------------------------------- nf_inq_typeid ------------------------------
Interface
 Function nf_inq_typeid(ncid, name, typeid) RESULT (status)

 Integer,          Intent(IN)  :: ncid 
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: typeid
 Integer                       :: status

 End Function nf_inq_typeid
End Interface
!-------------------------------- nf_def_grp ---------------------------------
Interface
 Function nf_def_grp( parent_ncid, name, new_ncid) RESULT (status)

 Integer,          Intent(IN)  :: parent_ncid
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: new_ncid
 Integer                       :: status

 End Function nf_def_grp
End Interface
!-------------------------------- nf_rename_grp -------------------------------
Interface
 Function nf_rename_grp( grpid, name) RESULT (status)

! rename previously defined group

 USE netcdf4_nc_interfaces

 Implicit NONE

 Integer,          Intent(IN)  :: grpid
 Character(LEN=*), Intent(IN)  :: name
 Integer                       :: status

 End Function nf_rename_grp
End Interface
!-------------------------------- nf_def_compound -----------------------------
Interface
 Function nf_def_compound( ncid, isize, name, typeid) RESULT (status)

 Integer,          Intent(IN)  :: ncid, isize
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: typeid 
 Integer                       :: status

 End Function nf_def_compound
End Interface
!-------------------------------- nf_insert_compound --------------------------
Interface
 Function nf_insert_compound( ncid, xtype, name, offset, field_typeid) &
                              RESULT (status)

 Integer,          Intent(IN) :: ncid, xtype, field_typeid, offset 
 Character(LEN=*), Intent(IN) :: name
 Integer                      :: status

 End Function nf_insert_compound
End Interface
!-------------------------------- nf_insert_array_compound --------------------
Interface
 Function nf_insert_array_compound( ncid, xtype, name, offset, field_typeid, &
                                    ndims, dim_sizes) RESULT (status)

 Integer,          Intent(IN) :: ncid, xtype, field_typeid, offset, ndims
 Integer,          Intent(IN) :: dim_sizes(*)
 Character(LEN=*), Intent(IN) :: name
 Integer                      :: status

 End Function nf_insert_array_compound
End Interface
!-------------------------------- nf_inq_type ---------------------------------
Interface
 Function nf_inq_type( ncid, xtype, name, isize) RESULT (status)

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: isize
 Integer                       :: status

 End Function nf_inq_type
End Interface
!-------------------------------- nf_inq_compound -----------------------------
Interface
 Function nf_inq_compound( ncid, xtype, name, isize, nfields) RESULT (status)

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(INOUT) :: isize, nfields
 Integer                         :: status

 End Function nf_inq_compound
End Interface
!-------------------------------- nf_inq_compound_name ------------------------
Interface
 Function nf_inq_compound_name( ncid, xtype, name) RESULT (status)

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(OUT) :: name
 Integer                       :: status

 End Function nf_inq_compound_name
End Interface
!-------------------------------- nf_inq_compound_size -------------------------
Interface
 Function nf_inq_compound_size( ncid, xtype, isize) RESULT (status)

 Integer, Intent(IN)    :: ncid, xtype
 Integer, Intent(INOUT) :: isize
 Integer                :: status

 End Function nf_inq_compound_size
End Interface
!-------------------------------- nf_inq_compound_nfields ----------------------
Interface
 Function nf_inq_compound_nfields( ncid, xtype, nfields) RESULT (status)

 Integer, Intent(IN)    :: ncid, xtype
 Integer, Intent(INOUT) :: nfields
 Integer                :: status

 End Function nf_inq_compound_nfields
End Interface
!-------------------------------- nf_inq_compound_field -----------------------
Interface
 Function nf_inq_compound_field( ncid, xtype, fieldid, name, offset, &
                                field_typeid, ndims, dim_sizes) RESULT (status)

 Integer,          Intent(IN)  :: ncid, xtype, fieldid
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: offset, field_typeid, ndims
 Integer,          Intent(OUT) :: dim_sizes(*)
 Integer                       :: status

 End Function nf_inq_compound_field
End Interface
!-------------------------------- nf_inq_compound_fieldname -------------------
Interface
 Function nf_inq_compound_fieldname(ncid, xtype, fieldid, name) RESULT(status)

 Integer,          Intent(IN)  :: ncid, xtype, fieldid
 Character(LEN=*), Intent(OUT) :: name
 Integer                       :: status

 End Function nf_inq_compound_fieldname
End Interface
!-------------------------------- nf_inq_compound_fieldindex ------------------
Interface
 Function nf_inq_compound_fieldindex( ncid, xtype, name, fieldid) &
                                      RESULT (status)

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: fieldid
 Integer                       :: status

 End Function nf_inq_compound_fieldindex
End Interface
!-------------------------------- nf_inq_compound_fieldoffset ----------------
Interface
 Function nf_inq_compound_fieldoffset( ncid, xtype, fieldid, offset) &
                                      RESULT (status)

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: offset
 Integer              :: status

 End Function nf_inq_compound_fieldoffset
End Interface
!-------------------------------- nf_inq_compound_fieldtype -------------------
Interface
 Function nf_inq_compound_fieldtype( ncid, xtype, fieldid, field_typeid) &
                                     RESULT (status)

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: field_typeid
 Integer              :: status

 End Function nf_inq_compound_fieldtype
End Interface
!-------------------------------- nf_inq_compound_fieldndims ------------------
Interface
 Function nf_inq_compound_fieldndims( ncid, xtype, fieldid, ndims) &
                                      RESULT (status)

 Integer, Intent(IN)  :: ncid, xtype, fieldid
 Integer, Intent(OUT) :: ndims
 Integer              :: status

 End Function nf_inq_compound_fieldndims
End Interface
!-------------------------------- nf_inq_compound_fielddim_sizes --------------
Interface
 Function nf_inq_compound_fielddim_sizes( ncid, xtype, fieldid, dim_sizes) &
                                          RESULT (status)

 Integer, Intent(IN)    :: ncid, xtype, fieldid
 Integer, Intent(INOUT) :: dim_sizes(*)
 Integer                :: status

 End Function nf_inq_compound_fielddim_sizes
End Interface
!-------------------------------- nf_def_vlen ---------------------------------
Interface
 Function nf_def_vlen( ncid, name, base_typeid, xtype) RESULT (status)

 Integer,          Intent(IN)  :: ncid, base_typeid 
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: xtype
 Integer                       :: status

 End Function nf_def_vlen
End Interface
!-------------------------------- nf_inq_vlen ---------------------------------
Interface
 Function nf_inq_vlen( ncid, xtype, name, datum_size, base_type) RESULT(status) 

 Integer,          Intent(IN)  :: ncid, xtype
 Character(LEN=*), Intent(OUT) :: name
 Integer,          Intent(OUT) :: datum_size, base_type
 Integer                       :: status

 End Function nf_inq_vlen
End Interface
!-------------------------------- nf_inq_user_type ----------------------------
Interface
 Function nf_inq_user_type( ncid, xtype, name, isize, base_type, nfields, &
                            iclass) RESULT (status)

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(OUT)   :: isize, nfields, base_type, iclass
 Integer                         :: status

 End Function nf_inq_user_type
End Interface
!-------------------------------- nf_def_enum ---------------------------------
Interface
 Function nf_def_enum( ncid, base_typeid, name, typeid) RESULT (status)

 Integer,          Intent(IN)  :: ncid, base_typeid 
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: typeid
 Integer                       :: status

 End Function nf_def_enum
End Interface
!-------------------------------- nf_insert_enum -------------------------------
! Commented out for now since we pass to/from a void pointer using
! a C_CHAR string which will be non-compatible with different data
! types being passed
!Interface
! Function nf_insert_enum( ncid, xtype, name, value) RESULT (status)

! USE netcdf_nf_data

! Integer,                Intent(IN)         :: ncid, xtype
! Character(LEN=*),       Intent(IN)         :: name
! Character(KIND=C_CHAR), Intent(IN), TARGET :: value(*)
! Integer                                    :: status

! End Function nf_insert_enum
!End Interface
!-------------------------------- nf_inq_enum ---------------------------------
Interface
 Function nf_inq_enum( ncid, xtype, name, base_nf_type, base_size, &
                       num_members) RESULT (status)

! USE netcdf_nf_data

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(INOUT) :: base_nf_type, base_size, num_members
 Integer                         :: status

 End Function nf_inq_enum
End Interface
!-------------------------------- nf_inq_enum_member --------------------------
! Commented out for now since we pass to/from a void pointer using
! a C_CHAR string which will be non-compatible with different data
! types being passed
!Interface
! Function nf_inq_enum_member( ncid, xtype, idx, name, value) RESULT (status)

! USE netcdf_nf_data

! Integer,                Intent(IN)  :: ncid, xtype, idx
! Character(LEN=*),       Intent(OUT) :: name
! Character(KIND=C_CHAR), Intent(OUT) :: value(*)
! Integer                             :: status

! End Function nf_inq_enum_member
!End Interface
!-------------------------------- nf_inq_enum_ident --------------------------
Interface
 Function nf_inq_enum_ident( ncid, xtype, value, name) RESULT (status)

 Integer,          Intent(IN)    :: ncid, xtype, value 
 Character(LEN=*), Intent(INOUT) :: name
 Integer                         :: status

 End Function nf_inq_enum_ident
End Interface
!-------------------------------- nf_def_opaque -------------------------------
Interface
 Function nf_def_opaque( ncid, isize, name, xtype) RESULT (status)

 Integer,          Intent(IN)  :: ncid, isize
 Character(LEN=*), Intent(IN)  :: name
 Integer,          Intent(OUT) :: xtype
 Integer                       :: status

 End Function nf_def_opaque
End Interface
!-------------------------------- nf_inq_opaque -------------------------------
Interface
 Function nf_inq_opaque( ncid, xtype, name, isize) RESULT (status)

 Integer,          Intent(IN)    :: ncid, xtype
 Character(LEN=*), Intent(INOUT) :: name
 Integer,          Intent(OUT)   :: isize
 Integer                         :: status

 End Function nf_inq_opaque
End Interface
!-------------------------------- nf_def_var_chunking -------------------------
Interface
 Function nf_def_var_chunking( ncid, varid, contiguous, chunksizes) &
                               RESULT(status)

 Integer, Intent(IN) :: ncid, varid, contiguous
 Integer, Intent(IN) :: chunksizes(*)
 Integer             :: status

 End Function nf_def_var_chunking
End Interface
!-------------------------------- nf_inq_var_chunking -------------------------
Interface
 Function nf_inq_var_chunking( ncid, varid, contiguous, chunksizes) &
                               RESULT (status)

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: contiguous
 Integer, Intent(INOUT) :: chunksizes(*)
 Integer                :: status

 End Function nf_inq_var_chunking
End Interface
!-------------------------------- nf_def_var_deflate --------------------------
Interface
 Function nf_def_var_deflate( ncid, varid, shuffle, deflate, deflate_level) &
                               RESULT (status)

 Integer, Intent(IN) :: ncid, varid, shuffle, deflate, deflate_level
 Integer             :: status

 End Function nf_def_var_deflate
End Interface
!-------------------------------- nf_inq_var_deflate -------------------------
Interface
 Function nf_inq_var_deflate( ncid, varid, shuffle, deflate, deflate_level) &
                               RESULT (status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: shuffle, deflate, deflate_level
 Integer              :: status

 End Function nf_inq_var_deflate
End Interface
!-------------------------------- nf_def_var_szip --------------------------
Interface
 Function nf_def_var_szip( ncid, varid, options_mask, pixels_per_block) &
                               RESULT (status)

 Integer, Intent(IN) :: ncid, varid, options_mask, pixels_per_block
 Integer             :: status

 End Function nf_def_var_szip
End Interface
!-------------------------------- nf_inq_var_szip -----------------------------
Interface
 Function nf_inq_var_szip(ncid, varid, options_mask, pixels_per_block) RESULT(status)

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: options_mask, pixels_per_block
 Integer                :: status

 End Function nf_inq_var_szip
End Interface
!-------------------------------- nf_def_var_quantize --------------------------
Interface
 Function nf_def_var_quantize( ncid, varid, quantize_mode, nsd) &
                               RESULT (status)

 Integer, Intent(IN) :: ncid, varid, quantize_mode, nsd
 Integer             :: status

 End Function nf_def_var_quantize
End Interface
!-------------------------------- nf_inq_var_quantize -----------------------------
Interface
 Function nf_inq_var_quantize(ncid, varid, quantize_mode, nsd) RESULT(status)

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: quantize_mode, nsd
 Integer                :: status

 End Function nf_inq_var_quantize
End Interface
!-------------------------------- nf_def_var_zstandard --------------------------
Interface
 Function nf_def_var_zstandard( ncid, varid, zstandard_level) &
                               RESULT (status)

 Integer, Intent(IN) :: ncid, varid, zstandard_level
 Integer             :: status

 End Function nf_def_var_zstandard
End Interface
!-------------------------------- nf_inq_var_zstandard -----------------------------
Interface
 Function nf_inq_var_zstandard(ncid, varid, zstandard, zstandard_level) RESULT(status)

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: zstandard, zstandard_level
 Integer                :: status

 End Function nf_inq_var_zstandard
End Interface
!-------------------------------- nf_def_var_fletcher32 ------------------------
Interface
 Function nf_def_var_fletcher32( ncid, varid, fletcher32) RESULT(status)

 Integer, Intent(IN) :: ncid, varid, fletcher32
 Integer             :: status

 End Function nf_def_var_fletcher32
End Interface
!-------------------------------- nf_inq_var_fletcher32 ------------------------
Interface
 Function nf_inq_var_fletcher32( ncid, varid, fletcher32) RESULT(status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: fletcher32
 Integer              :: status

 End Function nf_inq_var_fletcher32
End Interface
!-------------------------------- nf_def_var_fill -----------------------------
!Interface
! Function nf_def_var_fill( ncid, varid, no_fill, fill_value) RESULT(status)

! Integer, Intent(IN)    :: ncid, varid, no_fill
! Integer, Intent(IN)    :: fill_value 
! Integer                :: status

! End Function nf_def_var_fill
!End Interface
!-------------------------------- nf_inq_var_fill -----------------------------
!Interface
! Function nf_inq_var_fill( ncid, varid, no_fill, fill_value) RESULT(status)

! Integer, Intent(IN)    :: ncid, varid
! Integer, Intent(OUT)   :: no_fill
! Integer, Intent(INOUT) :: fill_value 
! Integer                :: status

! End Function nf_inq_var_fill
!End Interface
!-------------------------------- nf_def_var_endian ---------------------------
Interface
 Function nf_def_var_endian( ncid, varid, endiann) RESULT(status)

 Integer, Intent(IN) :: ncid, varid, endiann
 Integer             :: status

 End Function nf_def_var_endian
End Interface
!-------------------------------- nf_inq_var_endian ---------------------------
Interface
 Function nf_inq_var_endian( ncid, varid, endiann) RESULT(status)

 Integer, Intent(IN)  :: ncid, varid
 Integer, Intent(OUT) :: endiann
 Integer              :: status

 End Function nf_inq_var_endian
End Interface
!------------------------------- nf_def_var_filter ------------------------
Interface
 Function nf_def_var_filter(ncid, varid, id, nparams, params) RESULT(status)

 Integer, Intent(IN) :: ncid, varid, id, nparams
 Integer, Intent(IN) :: params(*)
 Integer                :: status

 End Function nf_def_var_filter
End Interface
!------------------------------- nf_inq_var_filter ----------------------------------
Interface
 Function nf_inq_var_filter(ncid, varid, id, inparams, params) RESULT(status)

 Integer, Intent(IN)     :: ncid, varid
 Integer, Intent(INOUT)  :: id
 Integer, Intent(INOUT)  :: inparams
 Integer, Intent(INOUT)  :: params(*)
 Integer                :: status

 End Function nf_inq_var_filter
End Interface
!--------------------------------- nf_put_att --------------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_put_att(ncid, varid, name, xtype, nlen, value) RESULT(status)
 
! USE netcdf_nf_data

! Integer,                Intent(IN)         :: ncid, varid, nlen, xtype
! Character(LEN=*),       Intent(IN)         :: name
! Character(KIND=C_CHAR), Intent(IN), TARGET :: value(*)
! Integer                                    :: status

! End Function nf_put_att
!--------------------------------- nf_get_att --------------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_get_att(ncid, varid, name, value) RESULT(status)

! USE netcdf_nf_data

! Implicit NONE

! Integer,                Intent(IN)    :: ncid, varid
! Character(LEN=*),       Intent(IN)    :: name
! Character(KIND=C_CHAR), Intent(INOUT) :: value(*)
! Integer                               :: status

! End Function nf_get_att
!End Interface
!--------------------------------- nf_put_vlen_element ------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_put_vlen_element(ncid, xtype, vlen_element, nlen, value)&
!                               RESULT(status)

! USE netcdf_nf_data

! Integer,                Intent(IN)            :: ncid, xtype, nlen
! Character(LEN=*),       Intent(INOUT), TARGET :: vlen_element
! Character(KIND=C_CHAR), Intent(IN),    TARGET :: value(*)
! Integer                                       :: status

! End Function nf_put_vlen_element
!End Interface
!--------------------------------- nf_get_vlen_element ------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_get_vlen_element(ncid, xtype, vlen_element, nlen, value) &
!                              RESULT(status)

! USE netcdf_nf_data

! Implicit NONE

! Integer,                Intent(IN)            :: ncid, xtype
! Integer,                Intent(INOUT)         :: nlen
! Character(LEN=*),       Intent(INOUT), TARGET :: vlen_element
! Character(KIND=C_CHAR), Intent(INOUT)         :: value(*)
! Integer                                       :: status

! End Function nf_get_vlen_element
!End Interface
!--------------------------------- nf_free_vlenn -------------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_free_vlen(vl) RESULT(status)

! Character(KIND=C_CHAR), Intent(IN), TARGET :: vl(*)
! Integer                                    :: status

! End Function nf_free_vlen
!End Interface
!--------------------------------- nf_put_var ---------------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_put_var(ncid, varid, values) RESULT(status)

! USE netcdf_nf_data

! Integer,                Intent(IN)         :: ncid, varid
! Character(KIND=C_CHAR), Intent(IN), TARGET :: values(*)
! Integer                                    :: status

! End Function nf_put_var
!End Interface
!--------------------------------- nf_get_var ---------------------------------
! Commented out because we use C_CHAR array to pass data of different
! type to a C void pointer
!Interface
! Function nf_get_var(ncid, varid, values) RESULT(status)

! USE netcdf_nf_data

! Integer,                Intent(IN)         :: ncid, varid
! Character(KIND=C_CHAR), Intent(INOUT),     :: values(*)
! Integer                                    :: status

! End Function nf_get_var
!End Interface
!--------------------------------- nf_put_var1_int64 --------------------------
Interface
 Function nf_put_var1_int64(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: ndex(*)
 Integer(IK8), Intent(IN) :: ival
 Integer                  :: status

 End Function nf_put_var1_int64
End Interface
!--------------------------------- nf_put_vara_int64 --------------------------
Interface
 Function nf_put_vara_int64(ncid, varid, start, counts, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*)
 Integer(IK8), Intent(IN) :: ivals(*)
 Integer                  :: status

 End Function nf_put_vara_int64
End Interface
!--------------------------------- nf_put_vars_int64 --------------------------
Interface
 Function nf_put_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)
 
 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*)
 Integer(IK8), Intent(IN) :: ivals(*)
 Integer                  :: status

 End Function nf_put_vars_int64
End Interface
!--------------------------------- nf_put_varm_int64 -------------------------
Interface
 Function nf_put_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN) :: ncid, varid
 Integer,      Intent(IN) :: start(*), counts(*), strides(*), maps(*)
 Integer(IK8), Intent(IN) :: ivals(*)
 Integer                  :: status

 End Function nf_put_varm_int64
End Interface
!--------------------------------- nf_put_var_int64 --------------------------
Interface
 Function nf_put_var_int64(ncid, varid, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN) :: ncid, varid
 Integer(IK8), Intent(IN) :: ivals(*)
 Integer                  :: status

 End Function nf_put_var_int64
End Interface
!--------------------------------- nf_get_var1_int64 -------------------------
Interface
 Function nf_get_var1_int64(ncid, varid, ndex, ival) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: ndex(*)
 Integer(IK8), Intent(OUT) :: ival
 Integer                   :: status

 End Function nf_get_var1_int64
End Interface
!--------------------------------- nf_get_vara_int -------------------------
Interface
 Function nf_get_vara_int64(ncid, varid, start, counts, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*)
 Integer(IK8), Intent(OUT) :: ivals(*)
 Integer                   :: status

 End Function nf_get_vara_int64
End Interface
!--------------------------------- nf_get_vars_int64 --------------------------
Interface
 Function nf_get_vars_int64(ncid, varid, start, counts, strides, ivals) &
                             RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*)
 Integer(IK8), Intent(OUT) :: ivals(*)
 Integer                   :: status

 End Function nf_get_vars_int64
End Interface
!--------------------------------- nf_get_varm_int64 -------------------------
Interface
 Function nf_get_varm_int64(ncid, varid, start, counts, strides, maps, &
                            ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN)  :: ncid, varid
 Integer,      Intent(IN)  :: start(*), counts(*), strides(*), maps(*)
 Integer(IK8), Intent(OUT) :: ivals(*)
 Integer                   :: status

 End Function nf_get_varm_int64
End Interface
!--------------------------------- nf_get_var_int64 --------------------------
Interface
 Function nf_get_var_int64(ncid, varid, ivals) RESULT(status)

 USE netcdf_nf_data, ONLY: IK8

 Integer,      Intent(IN)  :: ncid, varid
 Integer(IK8), Intent(OUT) :: ivals(*)
 Integer                   :: status

 End Function nf_get_var_int64
End Interface
!--------------------------------- nf_set_chunk_cache -------------------------
Interface
 Function nf_set_chunk_cache(chunk_size, nelems, preemption) RESULT(status)

 Integer, Intent(IN) :: chunk_size, nelems, preemption
 Integer             :: status

 End Function nf_set_chunk_cache
End Interface
!--------------------------------- nf_get_chunk_cache -------------------------
Interface
 Function nf_get_chunk_cache(chunk_size, nelems, preemption) RESULT(status)

 Integer, Intent(INOUT) :: chunk_size, nelems, preemption
 Integer                :: status

 End Function nf_get_chunk_cache
End Interface
!--------------------------------- nf_set_var_chunk_cache ---------------------
Interface
 Function nf_set_var_chunk_cache(ncid, varid, chunk_size, nelems, preemption) RESULT(status)

! USE netcdf_nf_data

 Implicit NONE

 Integer, Intent(IN) :: ncid, varid, chunk_size, nelems, preemption
 Integer             :: status

 End Function nf_set_var_chunk_cache
End Interface
!--------------------------------- nf_get_var_chunk_cache ---------------------
Interface
 Function nf_get_var_chunk_cache(ncid, varid, chunk_size, nelems, preemption) RESULT(status)

! get chunk cache size. Note this follows the fort-nc4 version which uses
! uses nc_get_var_chunk_cache_ints to avoid size_t issues with fortran. 

! USE netcdf_nf_data

 Implicit NONE

 Integer, Intent(IN)    :: ncid, varid
 Integer, Intent(INOUT) :: chunk_size, nelems, preemption
 Integer                :: status

 End Function nf_get_var_chunk_cache
End Interface

! Declare external values for functions that use C_CHAR strings to pass
! data of different types

 Integer, External :: nf_insert_enum
 Integer, External :: nf_inq_enum_member
 Integer, External :: nf_put_att
 Integer, External :: nf_get_att
 Integer, External :: nf_put_vlen_element
 Integer, External :: nf_get_vlen_element
 Integer, External :: nf_free_vlen
 Integer, External :: nf_free_vlens
 Integer, External :: nf_free_string
 Integer, External :: nf_put_var
 Integer, External :: nf_get_var
 Integer, External :: nf_def_var_fill
 Integer, External :: nf_inq_var_fill

End Module netcdf4_nf_interfaces

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This example writes some surface pressure and temperatures. It is
C     intended to illustrate the use of the netCDF fortran 77 API. The
C     companion program sfc_pres_temp_rd.f shows how to read the netCDF
C     data file created by this program.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program sfc_pres_temp_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
C     netCDF dimensions.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')
      integer lon_dimid, lat_dimid

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude netCDF variables which will hold the
C     actual latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     We will write surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     It's good practice for each variable to carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     We will create some pressure and temperature data to write out.
      real pres_out(NLONS, NLATS), temp_out(NLONS, NLATS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Loop indices.
      integer lat, lon

C     Error handling.
      integer retval

C     Create pretend data. If this were not an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      do lon = 1, NLONS
         do lat = 1, NLATS
            pres_out(lon, lat) = SAMPLE_PRESSURE + 
     +           (lon - 1) * NLATS + (lat - 1)
            temp_out(lon, lat) = SAMPLE_TEMP + 
     +           .25 * ((lon - 1) * NLATS + (lat - 1))
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. They will hold the coordinate
C     information, that is, the latitudes and longitudes. A varid is
C     returned for each.
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate var data. This attaches a
C     text attribute to each of the coordinate variables, containing the
C     units.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the netCDF variables. The dimids array is used to pass the
C     dimids of the dimensions of the netCDF variables.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the pressure and temperature netCDF
C     variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays of data are the same size as
C     the netCDF variables we have defined.
      retval = nf_put_var_real(ncid, pres_varid, pres_out)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, temp_varid, temp_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS writing example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.
      
C     This is a simple example which reads a small dummy array, from a
C     netCDF data file created by the companion program simple_xy_wr.f.
      
C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program simple_xy_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read. 
      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy.nc')

C     We are reading 2D data, a 12 x 6 grid. 
      integer NX, NY
      parameter (NX = 6, NY = 12)
      integer data_in(NY, NX)

C     This will be the netCDF ID for the file and data variable.
      integer ncid, varid

C     Loop indexes, and error handling.
      integer x, y, retval

C     Open the file. NF_NOWRITE tells netCDF we want read-only access to
C     the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varid of the data variable, based on its name.
      retval = nf_inq_varid(ncid, 'data', varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the data.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data.
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. (x - 1) * NY + (y - 1)) then
               print *, 'data_in(', y, ', ', x, ') = ', data_in(y, x)
               stop 2
            end if
         end do
      end do

C     Close the file, freeing all resources.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS reading example file ', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some surface pressure and
! temperatures. The data file read by this program is produced
! comapnion program sfc_pres_temp_wr.f90. It is intended to illustrate
! the use of the netCDF fortran 90 API.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: sfc_pres_temp_rd.f90,v 1.10 2010/04/06 19:32:09 ed Exp $

program sfc_pres_temp_rd
  use netcdf
  implicit none

  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are reading 2D data, a 12 x 6 lon-lat grid.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"

  ! For the lat lon coordinate netCDF variables.
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid

  ! We will read surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME = "pressure"
  character (len = *), parameter :: TEMP_NAME = "temperature"
  integer :: pres_varid, temp_varid

  ! To check the units attributes.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"
  integer, parameter :: MAX_ATT_LEN = 80
  integer :: att_len
  character*(MAX_ATT_LEN) :: pres_units_in, temp_units_in
  character*(MAX_ATT_LEN) :: lat_units_in, lon_units_in

  ! Read the data into these arrays.
  real, dimension(:,:), allocatable :: pres_in
  real, dimension(:,:), allocatable :: temp_in

  ! These are used to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! We will learn about the data file and store results in these
  ! program variables.
  integer :: ndims_in, nvars_in, ngatts_in, unlimdimid_in

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS))
  allocate(temp_in(NLONS, NLATS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! There are a number of inquiry functions in netCDF which can be
  ! used to learn about an unknown netCDF file. NF90_INQ tells how many
  ! netCDF variables, dimensions, and global attributes are in the
  ! file; also the dimension id of the unlimited dimension, if there
  ! is one.
  call check( nf90_inquire(ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in) )

  ! In this case we know that there are 2 netCDF dimensions, 4 netCDF
  ! variables, no global attributes, and no unlimited dimension.
  if (ndims_in /= 2 .or. nvars_in /= 4 .or. ngatts_in /= 0 &
       .or. unlimdimid_in /= -1) stop 2

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )

  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read the surface pressure and temperature data from the file.
  ! Since we know the contents of the file we know that the data
  ! arrays in this program are the correct size to hold all the data.
  call check( nf90_get_var(ncid, pres_varid, pres_in) )
  call check( nf90_get_var(ncid, temp_varid, temp_in) )

  ! Check the data. It should be the same as the data we wrote.
  do lon = 1, NLONS
     do lat = 1, NLATS
        if (pres_in(lon, lat) /= SAMPLE_PRESSURE + &
             (lon - 1) * NLATS + (lat - 1)) stop 2
        if (temp_in(lon, lat) /= SAMPLE_TEMP + &
             .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
     end do
  end do

  ! Each of the netCDF variables has a "units" attribute. Let's read
  ! them and check them.
  call check( nf90_get_att(ncid, lat_varid, UNITS, lat_units_in) )
  call check( nf90_inquire_attribute(ncid, lat_varid, UNITS, len = att_len) )
  if (lat_units_in(1:att_len) /= LAT_UNITS) stop 2

  call check( nf90_get_att(ncid, lon_varid, UNITS, lon_units_in) )
  call check( nf90_inquire_attribute(ncid, lon_varid, UNITS, len = att_len) )
  if (lon_units_in(1:att_len) /= LON_UNITS) stop 2

  call check( nf90_get_att(ncid, pres_varid, UNITS, pres_units_in) )
  call check( nf90_inquire_attribute(ncid, pres_varid, UNITS, len = att_len) )
  if (pres_units_in(1:att_len) /= PRES_UNITS) stop 2

  call check( nf90_get_att(ncid, temp_varid, UNITS, temp_units_in) )
  call check( nf90_inquire_attribute(ncid, temp_varid, UNITS, len = att_len) )
  if (temp_units_in(1:att_len) /= TEMP_UNITS) stop 2

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_rd

!********************************************************************
!   Copyright 1993, UCAR/Unidata
!   See netcdf/COPYRIGHT file for copying and redistribution conditions.
!   Russ Rew 1993
!********************************************************************

!
!     program to test the netCDF-2 Fortran API
!
      program ftest

      use netcdf_f03

!     name of first test cdf
      character*31 name
!     name of second test cdf
      character*31 name2
      
!     Returned error code.
      integer iret 
!     netCDF ID
      integer ncid
!     ID of dimension lat
      integer  latdim
!     ID of dimension lon
      integer londim
!     ID of dimension level
      integer leveldim
!     ID of dimension time
      integer timedim
!     ID of dimension len
      integer lendim

!     Count the errors.
      integer nfails

!     variable used to control error-handling behavior
      integer ncopts
      integer dimsiz(MAXNCDIM)
!      allowable roundoff 
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      data name/'f03test_test.nc'/
      data name2/'f03test_copy.nc'/

      print *, ''
      print *,'*** Testing netCDF-2 Fortran 77 API.'

100   format(' *** testing ', a, ' ...')
!     set error-handling to verbose and non-fatal
      ncopts = NCVERBOS
      call ncpopt(ncopts)

!     This will be a count of how many failures we experience.
      nfails = 0

!     create a netCDF named 'test.nc'
      write(*,100) 'nccre'
      ncid = nccre(name, NCCLOB, iret)
      if (ncid .eq. -1) then nfails = nfails + 1

!     test ncddef
      write(*,100) 'ncddef'
      call tncddef(ncid, nfails)

!     test ncvdef
      write(*,100) 'ncvdef'
      call tncvdef(ncid, nfails)

!     test ncapt
      write(*, 100) 'ncapt, ncaptc'
      call tncapt(ncid, nfails)

!     close 'test.nc'
      write(*, 100) 'ncclos'
      call ncclos(ncid, iret)
      if (ncid .eq. -1) then nfails = nfails + 1

!     test ncvpt1
      write(*, 100) 'ncvpt1'
      call tncvpt1(name, nfails)

!     test ncvgt1
      write(*, 100) 'ncvgt1'
      call tncvgt1(name, nfails)

!     test ncvpt
      write(*, 100) 'ncvpt'
      call tncvpt(name, nfails)

!     test ncinq
      write(*, 100) 'ncopn, ncinq, ncdinq, ncvinq, ncanam, ncainq'
      call tncinq(name, nfails)

!     test ncvgt
      write(*, 100) 'ncvgt, ncvgtc'
      call tncvgt(name, nfails)

!     test ncagt
      write(*, 100) 'ncagt, ncagtc'
      call tncagt(name, nfails)

!     test ncredf
      write(*, 100) 'ncredf, ncdren, ncvren, ncaren, ncendf'
      call tncredf(name, nfails)

      call tncinq(name, nfails)

!     test ncacpy
      write(*, 100) 'ncacpy'
      call tncacpy(name, name2, nfails)

!     test ncadel
      write(*, 100) 'ncadel'
      call tncadel(name2, nfails)

!     test fill values
      write(*, 100) 'fill values'
      call tfills(nfails)

      print *,'Total number of failures: ', nfails
      if (nfails .ne. 0) stop 2

      print *,'*** SUCCESS!'

      end
!
!     subroutine to test ncacpy
!
      subroutine tncacpy(iname, oname, nfails)
      use netcdf_f03
      character*31 iname, oname
      integer ndims, nvars, natts, recdim, iret
      character*31 vname, attnam
      integer attype, attlen
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts
      integer lenstr
!     existing netCDF id
      integer incdf
!     netCDF id of the output netCDF file to which the attribute
!     will be copied
      integer outcdf

      integer mattlen
      parameter (mattlen = 80)
      character*80 charval
      doubleprecision doubval(2)
      real flval(2)
      integer lngval(2)
      NCSHORT_T shval(2)
      integer i, j, k
      character*31 varnam, attname(2,7), gattnam(2)
      NCBYTE_T bytval(2)
      common /atts/attname, gattnam
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)
      character*31 gavalue(2), cavalue(2)
      real epsilon

      data bvalidrg/-127,127/
      data svalidrg/-100,100/
      data lvalidrg/0,360/
      data rvalidrg/0.0, 5000.0/
      data dvalidrg/0D0,500D0/
      data gavalue/'NWS', '88/10/25 12:00:00'/
      data cavalue/'test string', 'a'/
      data lenstr/80/   
      data epsilon /.000001/

      incdf = ncopn(iname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1

      outcdf = nccre(oname, NCCLOB, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call tncddef(outcdf, nfails)
      call tncvdef(outcdf, nfails)
      call ncinq (incdf, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 5 j = 1, natts
         call ncanam (incdf, NCGLOBAL, j, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncacpy (incdf, NCGLOBAL, attnam, outcdf, NCGLOBAL, iret)
         if (iret .ne. 0) nfails = nfails + 1
 5    continue
      do 10 i = 1, nvars
         call ncvinq (incdf, i, vname, vartyp, nvdims,
     +        vdims, nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 20 k = 1, nvatts
            call ncanam (incdf, i, k, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncacpy (incdf, i, attnam, outcdf, i, iret)
            if (iret .ne. 0) nfails = nfails + 1
 20      continue
 10   continue
!     
!     get global attributes first
!     
      do 100 i = 1, natts
         call ncanam (outcdf, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncainq (outcdf, NCGLOBAL, attnam, attype, attlen,
     +        iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attlen .gt. mattlen) then
            write (*,*) 'global attribute too big!', attlen, mattlen
            stop 2
         else if (attype .eq. NCBYTE) then
            call ncagt (outcdf, NCBYTE, attnam, bytval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCCHAR) then
            call ncagtc (outcdf, NCGLOBAL, attnam, charval, 
     +           lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. gattnam(i)) write(*,*) 'error in ncagt G'
            if (charval .ne. gavalue(i))
     + write(*,*) 'error in ncagt G2', lenstr, charval, gavalue(i)
                  charval = ' '
         else if (attype .eq. NCSHORT) then
            call ncagt (outcdf, NCGLOBAL, attnam, shval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCLONG) then
            call ncagt (outcdf, NCGLOBAL, attnam, lngval, iret)            
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCFLOAT) then
            call ncagt (outcdf, NCGLOBAL, attnam, flval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else 
            call ncagt (outcdf, NCGLOBAL, attnam, doubval,iret)          
            if (iret .ne. 0) nfails = nfails + 1
         end if
 100   continue
!
!     get variable attributes
!
      do 200 i = 1, nvars
         call ncvinq (outcdf, i, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 250 j = 1, nvatts
            call ncanam (outcdf, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (outcdf, i, attnam, attype, attlen,
     +                   iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attlen .gt. mattlen) then
               write (*,*) 'variable ', i,  'attribute too big !'
               stop 2
            else 
               if (attype .eq. NCBYTE) then
                  call ncagt (outcdf, i, attnam, bytval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i))
     +               write(*,*) 'error in ncagt BYTE N'
                  if (bytval(j) .ne. bvalidrg(j)) write(*,*)
     + 'ncacpy: byte ', bytval(j), ' .ne. ', bvalidrg(j)
               else if (attype .eq. NCCHAR) then
                  call ncagtc (outcdf, i, attnam, charval, 
     +                 lenstr, iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt CHAR N'
                  if (charval .ne. cavalue(j)) 
     +               write(*,*) 'error in ncagt'
                  charval = ' '
               else if (attype .eq. NCSHORT) then
                  call ncagt (outcdf, i, attnam, shval, 
     +                 iret)  
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt SHORT N'
                  if (shval(j) .ne. svalidrg(j)) then
                     write(*,*) 'error in ncagt SHORT'
                  end if
               else if (attype .eq. NCLONG) then
                  call ncagt (outcdf, i, attnam, lngval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt LONG N'
                  if (lngval(j) .ne. lvalidrg(j)) 
     +               write(*,*) 'error in ncagt LONG'
               else if (attype .eq. NCFLOAT) then
                  call ncagt (outcdf, i, attnam, flval, 
     +                 iret)            
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt FLOAT N'
                  if (flval(j) .ne. rvalidrg(j)) 
     +               write(*,*) 'error in ncagt FLOAT'
               else if (attype .eq. NCDOUBLE) then
                  call ncagt (outcdf, i, attnam, doubval,
     +                 iret)          
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt DOUBLE N'
                  if ( abs(doubval(j) - dvalidrg(j)) .gt. epsilon)
     + write(*,*) 'error in ncagt DOUBLE'
               end if
            end if
 250     continue
 200   continue
      call ncclos(incdf, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos(outcdf, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end


      
!     
!     subroutine to test ncadel
!
      subroutine tncadel (cdfname, nfails)
      use netcdf_f03
      character*31 cdfname

      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer ncid, iret, i, j
      integer ndims, nvars, natts, recdim
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts
      character*31 varnam, attnam

      ncid = ncopn(cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     put cdf in define mode
      call ncredf (ncid,iret)
      if (iret .ne. 0) nfails = nfails + 1
!     get number of global attributes
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 10 i = natts, 1, -1
!     get name of global attribute
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
!     delete global attribute
         call ncadel (ncid, NCGLOBAL, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
 10   continue

      do 100 i = 1, nvars
!     get number of variable attributes
         call ncvinq (ncid, i, varnam, vartyp, nvdims, vdims,
     +        nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 200 j = nvatts, 1, -1
            call ncanam (ncid, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncadel (ncid, i, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
 200     continue
 100  continue
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (natts .ne. 0) write(*,*) 'error in ncadel'
!     put netCDF into data mode
      call ncendf (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

!
!     subroutine to test ncagt and ncagtc

      subroutine tncagt(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname
            
!     maximum length of an attribute
      integer mattlen
      parameter (mattlen = 80)
      integer ncid, ndims, nvars, natts, recdim
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer i, j
      integer attype, attlen, lenstr, iret
      character*31 attnam
      character*80 charval
      doubleprecision doubval(2)
      real flval(2)
      integer lngval(2)
      NCSHORT_T shval(2)
      NCBYTE_T bytval(2)
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts

      character*31 varnam, attname(2,7), gattnam(2)
      common /atts/attname, gattnam
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)
      character*31 gavalue(2), cavalue(2)
      real epsilon

      data bvalidrg/-127,127/
      data svalidrg/-100,100/
      data lvalidrg/0,360/
      data rvalidrg/0.0, 5000.0/
      data dvalidrg/0D0,500D0/
      data gavalue/'NWS', '88/10/25 12:00:00'/
      data cavalue/'test string', 'a'/
      data lenstr/80/   
      data epsilon /.000001/
      
      ncid = ncopn (cdfname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     
!     get global attributes first
!     
      do 10 i = 1, natts
!     get name of attribute
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
!     get attribute type and length
         call ncainq (ncid, NCGLOBAL, attnam, attype, attlen,
     +        iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attlen .gt. mattlen) then
            write (*,*) 'global attribute too big!'
            stop 2
         else if (attype .eq. NCBYTE) then
            call ncagt (ncid, NCBYTE, attnam, bytval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCCHAR) then
            call ncagtc (ncid, NCGLOBAL, attnam, charval, 
     +           lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. gattnam(i)) write(*,*) 'error in ncagt'
            if (charval .ne. gavalue(i)) write(*,*) 'error in ncagt'
            charval = '                                        '
         else if (attype .eq. NCSHORT) then
            call ncagt (ncid, NCGLOBAL, attnam, shval, iret) 
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCLONG) then
            call ncagt (ncid, NCGLOBAL, attnam, lngval, iret)            
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCFLOAT) then
            call ncagt (ncid, NCGLOBAL, attnam, flval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else 
            call ncagt (ncid, NCGLOBAL, attnam, doubval,iret)          
            if (iret .ne. 0) nfails = nfails + 1
         end if
 10   continue

!
!     get variable attributes
!
      do 20 i = 1, nvars
         call ncvinq (ncid, i, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 25 j = 1, nvatts
            call ncanam (ncid, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (ncid, i, attnam, attype, attlen,
     +                   iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attlen .gt. mattlen) then
               write (*,*) 'variable ', i,  'attribute too big !'
               stop 2
            else 
               if (attype .eq. NCBYTE) then
                  call ncagt (ncid, i, attnam, bytval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt BYTE name'
                  if (bytval(j) .ne. bvalidrg(j)) write(*,*)
     + 'ncacpy: byte ', bytval(j), ' .ne. ', bvalidrg(j)
               else if (attype .eq. NCCHAR) then
                  call ncagtc (ncid, i, attnam, charval, 
     +                 lenstr, iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt CHAR name'
                  if (charval .ne. cavalue(j)) 
     +               write(*,*) 'error in ncagt CHAR name'
                 charval = '                                        '
               else if (attype .eq. NCSHORT) then
                  call ncagt (ncid, i, attnam, shval, 
     +                 iret)  
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt SHORT name'
                  if (shval(j) .ne. svalidrg(j)) then
                     write(*,*) 'error in ncagt SHORT'
                  end if
               else if (attype .eq. NCLONG) then
                  call ncagt (ncid, i, attnam, lngval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt LONG name'
                  if (lngval(j) .ne. lvalidrg(j)) 
     +               write(*,*) 'error in ncagt LONG'
               else if (attype .eq. NCFLOAT) then
                  call ncagt (ncid, i, attnam, flval, 
     +                 iret)            
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt FLOAT name'
                  if (flval(j) .ne. rvalidrg(j)) 
     +               write(*,*) 'error in ncagt FLOAT'
               else if (attype .eq. NCDOUBLE) then
                  call ncagt (ncid, i, attnam, doubval,
     +                 iret)          
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt DOUBLE name'
                  if ( abs(doubval(j) - dvalidrg(j)) .gt. epsilon)
     + write(*,*) 'error in ncagt DOUBLE'
               end if
            end if
 25      continue
 20   continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!
!     subroutine to test ncapt
!
      subroutine tncapt (ncid, nfails)
      use netcdf_f03
      integer ncid, iret

! attribute vectors
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)

!     variable ids
      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

! assign attributes
      
!
!     byte
!
      
      bvalidrg(1) = -127
      bvalidrg(2) =  127
      call ncapt (ncid, bid, 'validrange', NCBYTE, 2,
     +bvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     short
!

      svalidrg(1) = -100
      svalidrg(2) = 100
      call ncapt (ncid, sid, 'validrange', NCSHORT, 2, 
     +svalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     long
!

      lvalidrg(1) = 0
      lvalidrg(2) = 360
      call ncapt (ncid, lid, 'validrange', NCLONG, 2,
     +lvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1
      
!
!     float
!

      rvalidrg(1) = 0.0
      rvalidrg(2) = 5000.0
      call ncapt (ncid, fid, 'validrange', NCFLOAT, 2,
     +rvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     double
!

      dvalidrg(1) = 0D0
      dvalidrg(2) = 500D0
      call ncapt (ncid, did, 'validrange', NCDOUBLE, 2,
     +dvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     global
!

      call ncaptc (ncid, NCGLOBAL, 'source', NCCHAR, 3, 
     +'NWS', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaptc (ncid, NCGLOBAL, 'basetime', NCCHAR, 17, 
     +'88/10/25 12:00:00', iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     char
!

      call ncaptc (ncid, chid, 'longname', NCCHAR, 11,
     +'test string', iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncaptc (ncid, chid, 'id', NCCHAR, 1,
     +'a', iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end

!
!     initialize variables in labelled common blocks
!
      block data
      common /cdims/ dimnam
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /varn/varnam
      common /atts/attname, gattnam
      integer  latdim, londim, leveldim, timedim, lendim

!     should use netcdf_f03 for MAXNCDIM, but it has EXTERNAL
!     declaration, which is not permitted in a BLOCK DATA unit.

      integer dimsiz(1024)
      character*31 dimnam(1024)
      character*31 varnam(7)
      character*31 attname(2,7)
      character*31 gattnam(2)

      data dimnam /'time', 'lat', 'lon', 'level',
     + 'length', 1019*'0'/
      data dimsiz /4, 5, 5, 4, 80, 1019*0/
      data varnam/'bytev', 'shortv', 'longv', 'floatv', 'doublev', 
     + 'chv', 'cv'/
      
      data attname/'validrange', '0', 'validrange', '0', 'validrange',
     + '0', 'validrange', '0', 'validrange', '0', 'longname', 'id',
     + '0', '0'/
      data gattnam/'source','basetime'/
      end


!
!     subroutine to test ncddef
!

      subroutine tncddef(ncid, nfails)
      use netcdf_f03
      integer ncid

!     sizes of dimensions of 'test.nc' and 'copy.nc'
      integer  ndims
      parameter(ndims=5)
! dimension ids
      integer  latdim, londim, leveldim, timedim, lendim
      integer iret
!     function to define a netCDF dimension
      integer dimsiz(MAXNCDIM)
      character*31 dimnam(MAXNCDIM)
      
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /cdims/ dimnam

! define dimensions
      timedim = ncddef(ncid, dimnam(1), NCUNLIM, iret)
      if (iret .ne. 0) nfails = nfails + 1
      latdim = ncddef(ncid, dimnam(2), dimsiz(2), iret)
      if (iret .ne. 0) nfails = nfails + 1
      londim = ncddef(ncid, dimnam(3), dimsiz(3), iret)
      if (iret .ne. 0) nfails = nfails + 1
      leveldim = ncddef(ncid, dimnam(4), dimsiz(4), iret)
      if (iret .ne. 0) nfails = nfails + 1
      lendim = ncddef(ncid, dimnam(5), dimsiz(5), iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!
!     subroutine to test ncinq, ncdinq, ncdid, ncvinq, ncanam
!     and ncainq
!
      subroutine tncinq(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname

!     netCDF id
      integer ncid
!     returned number of dimensions
      integer ndims
!     returned number of variables
      integer nvars
!     returned number of global attributes
      integer natts
!     returned id of the unlimited dimension
      integer recdim
!     returned error code
      integer iret
!     returned name of record dimension
      character*31 recnam
!     returned size of record dimension
      integer recsiz
!     loop control variables
      integer i, j, k
!     returned size of dimension
      integer dsize
!     returned dimension ID
      integer dimid
!     returned dimension name
      character*31 dname
!     returned variable name
      character*31 vname
!     returned attribute name
      character*31 attnam
!     returned netCDF datatype of variable
      integer vartyp
!     returned number of variable dimensions
      integer nvdims
!     returned number of variable attributes
      integer nvatts
!     returned vector of nvdims dimension IDS corresponding to the
!     variable dimensions
      integer vdims(MAXNCDIM)
!     returned attribute length
      integer attlen
!     returned attribute type
      integer attype
      character*31 dimnam(MAXNCDIM)
      character*31 varnam(7)
      character*31 attname(2,7)
      character*31 gattnam(2)
      integer vdlist(5,7), vtyp(7), vndims(7), vnatts(7)
      integer attyp(2,7),atlen(2,7),gattyp(2),gatlen(2)
      integer timedim,latdim,londim,leveldim,lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /varn/varnam
      common /atts/attname, gattnam
      common /cdims/ dimnam

      data vdlist/1,0,0,0,0,1,0,0,0,0,2,0,0,0,0,4,3,2,1,0,4,3,2,1,0,
     + 5,1,0,0,0,1,0,0,0,0/
      data vtyp/NCBYTE, NCSHORT, NCLONG, NCFLOAT, NCDOUBLE, NCCHAR,
     + NCCHAR/
      data vndims/1,1,1,4,4,2,1/
      data vnatts/1,1,1,1,1,2,0/
      data attyp/NCBYTE, 0, NCSHORT, 0, NCLONG, 0, NCFLOAT, 0,
     + NCDOUBLE, 0, NCCHAR, NCCHAR, 0, 0/
      data atlen/2,0,2,0,2,0,2,0,2,0,11,1, 0, 0/
      data gattyp/NCCHAR,NCCHAR/
      data gatlen/3,17/

      ncid = ncopn (cdfname, NCNOWRIT, iret)
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (ndims .ne. 5) write(*,*) 'error in ncinq or ncddef'
      if (nvars .ne. 7) write(*,*) 'error in ncinq or ncvdef'
      if (natts .ne. 2) write(*,*) 'error in ncinq or ncapt'
      call ncdinq (ncid, recdim, recnam, recsiz, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (recnam .ne. 'time') write(*,*) 'error: bad recdim from ncinq'
!
!     dimensions
!
      do 10 i = 1, ndims
         call ncdinq (ncid, i, dname, dsize, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (dname .ne. dimnam(i)) 
     +      write(*,*) 'error in ncdinq or ncddef, dname=', dname
         if (dsize .ne. dimsiz(i)) 
     +      write(*,*) 'error in ncdinq or ncddef, dsize=',dsize
         dimid = ncdid (ncid, dname, iret)
         if (dimid .ne. i) write(*,*)
     +      'error in ncdinq or ncddef, dimid=', dimid
 10   continue
!
!     variables
!
      do 30 i = 1, nvars
         call ncvinq (ncid, i, vname, vartyp, nvdims,
     +        vdims, nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (vname .ne. varnam(i)) 
     +      write(*,*) 'error: from ncvinq, wrong name returned: ', 
     +         vname, ' .ne. ', varnam(i)
         if (vartyp .ne. vtyp(i)) 
     +      write(*,*) 'error: from ncvinq, wrong type returned: ', 
     +         vartyp, ' .ne. ', vtyp(i)
         if (nvdims .ne. vndims(i)) 
     +      write(*,*) 'error: from ncvinq, wrong num dims returned: ', 
     +         vdims, ' .ne. ', vndims(i)
         do 35 j = 1, nvdims
            if (vdims(j) .ne. vdlist(j,i)) 
     +         write(*,*) 'error: from ncvinq wrong dimids: ',
     +            vdims(j), ' .ne. ', vdlist(j,i)
 35      continue
         if (nvatts .ne. vnatts(i)) 
     +      write(*,*) 'error in ncvinq or ncvdef'
!
!     attributes
!
         do 45 k = 1, nvatts
            call ncanam (ncid, i, k, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (ncid, i, attnam, attype, attlen, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. attname(k,i)) 
     +         write(*,*) 'error in ncanam or ncapt'
            if (attype .ne. attyp(k,i)) 
     +         write(*,*) 'error in ncainq or ncapt'
            if (attlen .ne. atlen(k,i)) 
     +         write(*,*) 'error in ncainq or ncapt'
 45      continue
 30   continue
      do 40 i = 1, natts
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncainq (ncid, NCGLOBAL, attnam, attype, attlen, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attnam .ne. gattnam(i)) 
     +      write(*,*) 'error in ncanam or ncapt'
         if (attype .ne. gattyp(i)) 
     +      write(*,*) 'error in ncainq or ncapt'
         if (attlen .ne. gatlen(i)) 
     +      write(*,*) 'error in ncainq or ncapt'
 40   continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
      
      
      
!     subroutine to test ncredf, ncdren, ncvren, ncaren, and 
!     ncendf

      subroutine tncredf(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname
      character*31 attname(2,7)
      character*31 gattnam(2)
      common /atts/attname, gattnam
      common /cdims/ dimnam
      character*31 dimnam(MAXNCDIM)
      character*31 varnam(7)
      common /varn/varnam
      integer ncid, iret, latid, varid

      dimnam(2) = 'latitude'
      varnam(4) = 'realv'
      attname(1,6) = 'stringname'
      gattnam(1) = 'agency'
      ncid = ncopn(cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncredf(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      latid = ncdid(ncid, 'lat', iret)
      call ncdren(ncid, latid, 'latitude', iret)
      if (iret .ne. 0) nfails = nfails + 1
      varid = ncvid(ncid, 'floatv', iret)
      call ncvren(ncid, varid, 'realv', iret)
      if (iret .ne. 0) nfails = nfails + 1
      varid = ncvid(ncid, 'chv', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaren(ncid, varid, 'longname', 'stringname', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaren(ncid, NCGLOBAL, 'source', 'agency', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncendf(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!     
!     subroutine to test ncvdef
!

      subroutine tncvdef(ncid, nfails)
      use netcdf_f03
      integer ncid

!     function to define a netCDF variable
      integer dimsiz(MAXNCDIM)
      integer  latdim, londim, leveldim, timedim, lendim
      common /dims/timedim, latdim, londim, leveldim, lendim, 
     + dimsiz

! variable ids
      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

! variable shapes
      integer  bdims(1), fdims(4), ddims(4), ldims(1), sdims(1) 
      integer chdims(2), cdims(1)

      integer iret
!
! define variables
!
!     byte
! 
      bdims(1) = timedim
      bid = ncvdef(ncid, 'bytev', NCBYTE, 1, bdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     short
!
      sdims(1) = timedim
      sid = ncvdef (ncid, 'shortv', NCSHORT, 1, sdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     long
!
      ldims(1) = latdim
      lid = ncvdef (ncid, 'longv', NCLONG, 1, ldims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     float
!
      fdims(4) = timedim
      fdims(1) = leveldim
      fdims(2) = londim
      fdims(3) = latdim
      fid = ncvdef (ncid, 'floatv', NCFLOAT, 4, fdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     double
!
      ddims(4) = timedim
      ddims(1) = leveldim
      ddims(2) = londim
      ddims(3) = latdim
      did = ncvdef (ncid, 'doublev', NCDOUBLE, 4, ddims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     char
!
      chdims(2) = timedim
      chdims(1) = lendim
      chid = ncvdef (ncid, 'chv', NCCHAR, 2, chdims, iret)
      if (iret .ne. 0) nfails = nfails + 1

      cdims(1) = timedim
      cid = ncvdef (ncid, 'cv', NCCHAR, 1, cdims, iret)
      if (iret .ne. 0) nfails = nfails + 1


      return
      end


!    
!     subroutine to test ncvgt and ncvgtc
!
      subroutine tncvgt(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname

      integer ndims, times, lats, lons, levels, lenstr
      parameter (times=4, lats=5, lons=5, levels=4)

      integer start(4), count(4)
      integer ncid, iret, i, m
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz

      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer itime, ilev, ilat, ilon

!     arrays of data values to be read
      NCBYTE_T barray(times), byval(times)
      NCSHORT_T sarray(times), shval(times)
      integer larray(lats)
      real farray(levels, lats, lons, times)
      doubleprecision darray(levels, lats, lons, times)
!     character array of data values to be read
      character*31 string
      character*31 varnam
      integer nvars, natts, recdim
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts

      data start/1,1,1,1/
      data count/levels, lats, lons, times/
      data byval /97, 98, 99, 100/
      data shval /10, 11, 12, 13/

      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     get number of variables in netCDF
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 5 m = 1, nvars-1
!     get variable name, datatype, number of dimensions
!     vector of dimension ids, and number of variable attributes
         call ncvinq (ncid, m, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (vartyp .eq. NCBYTE) then
!
!     byte
!
            count(1) = times
            call ncvgt (ncid, m, start, count, barray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 10 i = 1, times
               if (barray(i) .ne. byval(i)) then 
                  write(*,*) 'ncvgt of bytes, got ', barray(i), ' .ne. '
     +                       , byval(i)
               end if
 10         continue
         else if (vartyp .eq. NCSHORT) then
!
!     short
!
            count(1) = times
            call ncvgt (ncid, m, start, count, sarray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 20 i = 1, times
               if (sarray(i) .ne. shval(i)) then 
                  write(*,*) 'ncvgt of short, got ', sarray(i), ' .ne. '
     +                       , shval(i)
               end if
 20         continue
         else if (vartyp .eq. NCLONG) then
!     
!     long
!
            count(1) = lats
            call ncvgt (ncid, m, start, count, larray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 30 i = 1, lats
               if (larray(i) .ne. 1000) then 
                  write(*,*) 'long error in ncvgt'
               end if
 30         continue
         else if (vartyp .eq. NCFLOAT) then
!     
!     float
!
            count(1) = levels
            call ncvgt (ncid, m, start, count, farray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            i = 0
            do 40 itime = 1,times
               do 41 ilon = 1, lons
                  do 42 ilat = 1, lats
                     do 43 ilev = 1, levels
                        i = i + 1
                        if (farray(ilev, ilat, ilon, itime) .ne.
     + real(i)) then
                           write (*,*) 'float error in ncvgt'
                        end if
 43         continue
 42         continue
 41         continue
 40         continue
         else if (vartyp .eq. NCDOUBLE) then
!
!     double
!
            count(1) = levels
            call ncvgt (ncid, m, start, count, darray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            i = 0
            do 50 itime = 1, times
               do 51 ilon = 1, lons
                  do 52 ilat = 1, lats
                     do 53 ilev = 1, levels
                        i = i + 1
                        if (darray(ilev, ilat, ilon, itime) .ne.
     +                       real (i)) then
                           write(*,*) 'double error in ncvgt:', i,
     +              darray(ilev, ilat, ilon, itime), '.ne.', 
     +              real (i)
                        end if
 53         continue
 52         continue
 51         continue
 50         continue
         else 
!     
!     char
!
            count(1) = 3
            count(2) = 4
            lenstr = 31
            call ncvgtc (ncid, m, start, count, string, lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (string .ne. 'testhikin of') then 
               write(*,*) 'error in ncvgt, returned string =', string
            end if
         end if
 5    continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

      
      subroutine tncvgt1(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname

      integer ncid, iret
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz

      integer bindx(1), sindx(1), lindx(1), findx(4), dindx(4), cindx(1)

      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

      NCBYTE_T bvalue
      NCSHORT_T svalue
      integer lvalue
      real fvalue
      doubleprecision dvalue
      character*1 c
      real epsilon
      doubleprecision onethird

      data epsilon /.000001/
      data lindx/1/, bindx/1/, sindx/1/, findx/1,1,1,1/
     +dindx/1,1,1,1/, cindx/1/
      data onethird/0.3333333333D0/
      
      ncid = ncopn (cdfname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     test ncvgt1 for byte
!
      call ncvgt1 (ncid, bid, bindx, bvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (bvalue .ne. ichar('z')) write(*,*) 'error in ncvgt1 byte:',
     + bvalue, ' .ne.', ichar('z')
!
!     test ncvgt1 for short
!
      call ncvgt1 (ncid, sid, sindx, svalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (svalue .ne. 10) write(*,*) 'error in ncvgt1 short:',
     + svalue, ' .ne.', 10
!     
!     test ncvgt1 for long
!
      call ncvgt1 (ncid, lid, lindx, lvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (lvalue .ne. 1000) write(*,*) 'error in ncvgt1 long:',
     + lvalue,  ' .ne.', 1000
!
!     test ncvgt1 for float
!
      call ncvgt1 (ncid, fid, findx, fvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (abs(fvalue - 3.14159) .gt. epsilon) 
     +   write(*,*) 'error in ncvgt 1 float:', fvalue, 
     +      ' not close to', 3.14159
!
!     test ncvgt1 for double
!
      call ncvgt1 (ncid, did, dindx, dvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (abs(dvalue - onethird) .gt. epsilon) write(*,*)
     + 'error in ncvgt1 double:', dvalue, ' not close to',
     +     onethird
!
!     test ncvg1c for char
!
      call ncvg1c (ncid, cid, cindx, c, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (c .ne. 'a') write(*,*) 'error in ncvg1c'
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

      
      
!
!     subroutine to test ncvpt and ncvptc
!
      subroutine tncvpt(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname

!     size of dimensions
      integer times, lats, lons, levels
      parameter (times=4, lats=5, lons=5, levels=4)

      integer ncid, iret
!     loop control variables
      integer itime, ilev, ilon, ilat, i
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      integer lenstr
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

!     vector of integers specifying the corner of the  hypercube
!     where the first of the data values will be written
      integer start(4)
!     vector of integers specifying the edge lengths from the
!     corner of the hypercube where the first of the data values
!     will be written
      integer count(4)

!     arrays of data values to be written
      NCBYTE_T barray(times)
      NCSHORT_T sarray(times)
      integer larray(lats)
      real farray(levels, lats, lons, times)
      doubleprecision darray(levels, lats, lons, times)
      character*31 string

      data start/1,1,1,1/
      data count/levels, lats, lons, times/
      data barray /97, 98, 99, 100/
      data sarray /10, 11, 12, 13/

      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     byte
!
      count(1) = times
      call ncvpt (ncid, bid, start, count, barray, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     short
!
      count(1) = times
      call ncvpt (ncid, sid, start, count, sarray, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     long
!
      do 30 i = 1,lats
         larray(i) = 1000
 30   continue
      count(1) = lats
      call ncvpt (ncid, lid, start, count, larray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     float
!
      i = 0
      do 40 itime = 1,times
         do 41 ilon = 1, lons
            do 42 ilat = 1, lats
               do 43 ilev = 1, levels
                  i = i + 1
                  farray(ilev, ilat, ilon, itime) = real (i)
 43   continue
 42   continue
 41   continue
 40   continue
      count(1) = levels
      call ncvpt (ncid, fid, start, count, farray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     double
!
      i = 0
      do 50 itime = 1, times
         do 51 ilon = 1, lons
            do 52 ilat = 1, lats
               do 53 ilev = 1, levels
                  i = i + 1
                  darray(ilev, ilat, ilon, itime) = real (i)
 53   continue
 52   continue
 51   continue
 50   continue
      count(1) = levels
      call ncvpt (ncid, did, start, count, darray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     char
!
      start(1) = 1
      start(2) = 1
      count(1) = 4
      count(2) = 4
      lenstr = 31       
      string = 'testthiskind of '
      call ncvptc (ncid, chid,start, count, string, lenstr, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end


      subroutine tncvpt1(cdfname, nfails)
      use netcdf_f03
      character*31 cdfname


      integer iret, ncid
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim, 
     + dimsiz

      integer bindx(1), sindx(1), lindx(1), findx(4), dindx(4), cindx(1)

      integer lvalue
      NCSHORT_T svalue
      NCBYTE_T bvalue
      doubleprecision onethird
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      data lindx/1/, bindx/1/, sindx/1/, findx/1,1,1,1/
     +dindx/1,1,1,1/, cindx/1/
      data lvalue /1000/
      data svalue/10/
      data onethird/0.3333333333D0/

      bvalue = ichar('z')
      
      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for byte
!
      call ncvpt1 (ncid, bid, bindx, bvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for short
!
      call ncvpt1 (ncid, sid, sindx, svalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!     
!     test ncvpt1 for long
!
      call ncvpt1 (ncid, lid, lindx, lvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for float
!
      call ncvpt1 (ncid, fid, findx, 3.14159, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for double
!
      call ncvpt1 (ncid, did, dindx, onethird, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvp1c for char
!
      call ncvp1c (ncid, cid, cindx, 'a', iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncclos (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end

!
! subroutine to test default fill values
!
      subroutine tfills(nfails)
      use netcdf_f03
      integer ncid
      integer bid, sid, lid, fid, did
      integer ix(1)
      integer l
      NCSHORT_T s
      doubleprecision d
      real f
      NCBYTE_T b

      ncid = NCOPN('fills.nc', NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1

      bid = ncvid(ncid, 'b', iret)
      if (iret .ne. 0) nfails = nfails + 1

      sid = ncvid(ncid, 's', iret)
      if (iret .ne. 0) nfails = nfails + 1

      lid = ncvid(ncid, 'l', iret)
      if (iret .ne. 0) nfails = nfails + 1

      fid = ncvid(ncid, 'f', iret)
      if (iret .ne. 0) nfails = nfails + 1

      did = ncvid(ncid, 'd', iret)
      if (iret .ne. 0) nfails = nfails + 1


      ix(1) = 2
      call ncvgt1(ncid, bid, ix, b, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, sid, ix, s, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, lid, ix, l, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, fid, ix, f, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, did, ix, d, iret)
      if (iret .ne. 0) nfails = nfails + 1


      if (b .ne. FILBYTE) write(*,*) 'error in byte fill value'
      if (d .ne. FILDOUB) write(*,*) 'error in double fill value'
      if (f .ne. FILFLOAT) write(*,*) 'error in float fill value'
      if (l .ne. FILLONG) write(*,*) 'error in long fill value'
      if (s .ne. FILSHORT) write(*,*) 'error in short fill value'

      return
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some 4D pressure and
! temperatures. The data file read by this program is produced by
! the companion program pres_temp_4D_wr.f90. It is intended to
! illustrate the use of the netCDF Fortran 90 API.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs-fortran/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program pres_temp_4D_rd
  use netcdf
  implicit none
  
  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "pres_temp_4D.nc"
  integer :: ncid

  ! We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"

  ! The start and count arrays will tell the netCDF library where to
  ! read our data.
  integer :: start(NDIMS), count(NDIMS)

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude variables which will hold the actual
  ! latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will read surface temperature and pressure fields. In netCDF
  ! terminology these are called "variables."
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa", TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will read in. We will only
  ! need enough space to hold one timestep of data; one record.
  ! Allocate memory for data.
  real, dimension(:,:,:), allocatable :: pres_in
  real, dimension(:,:,:), allocatable :: temp_in
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS, NLVLS))
  allocate(temp_in(NLONS, NLATS, NLVLS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )
  
  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read 1 record of NLONS*NLATS*NLVLS values, starting at the beginning 
  ! of the record (the (1, 1, 1, rec) element in the netCDF file).
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Read the surface pressure and temperature data from the file, one
  ! record at a time.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_get_var(ncid, pres_varid, pres_in, start = start, &
                              count = count) )
     call check( nf90_get_var(ncid, temp_varid, temp_in, start, count) )
     
     i = 0
     do lvl = 1, NLVLS
        do lat = 1, NLATS
           do lon = 1, NLONS
              if (pres_in(lon, lat, lvl) /= SAMPLE_PRESSURE + i) stop 2
              if (temp_in(lon, lat, lvl) /= SAMPLE_TEMP + i) stop 2
              i = i + 1
           end do
        end do
     end do
     ! next record
  end do
         
  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program pres_temp_4D_rd

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some surface pressure and
C     temperatures. The data file read by this program is produced
C     comapnion program sfc_pres_temp_wr.f. It is intended to illustrate
C     the use of the netCDF fortran 77 API.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs-fortran/nc_f77_interface_guide.html

C     Ed Hartnett

      program sfc_pres_temp_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are reading 2D data, a 12 x 6 lon-lat grid.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')

C     For the lat lon coordinate netCDF variables.
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid

C     We will read surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid

C     To check the units attributes.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')
      integer MAX_ATT_LEN
      parameter (MAX_ATT_LEN = 80)
      character*(MAX_ATT_LEN) pres_units_in, temp_units_in
      character*(MAX_ATT_LEN) lat_units_in, lon_units_in
      integer att_len

C     Read the data into these arrays.
      real pres_in(NLONS, NLATS), temp_in(NLONS, NLATS)

C     These are used to calculate the values we expect to find.
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     We will learn about the data file and store results in these
C     program variables.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in

C     Loop indices
      integer lat, lon

C     Error handling
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     There are a number of inquiry functions in netCDF which can be
C     used to learn about an unknown netCDF file. NF_INQ tells how many
C     netCDF variables, dimensions, and global attributes are in the
C     file; also the dimension id of the unlimited dimension, if there
C     is one.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in, 
     +     unlimdimid_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     In this case we know that there are 2 netCDF dimensions, 4 netCDF
C     variables, no global attributes, and no unlimited dimension.
      if (ndims_in .ne. 2 .or. nvars_in .ne. 4 .or. ngatts_in .ne. 0 
     +     .or. unlimdimid_in .ne. -1) stop 2

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the surface pressure and temperature data from the file.
C     Since we know the contents of the file we know that the data
C     arrays in this program are the correct size to hold all the data.
      retval = nf_get_var_real(ncid, pres_varid, pres_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, temp_varid, temp_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data. It should be the same as the data we wrote.
      do lon = 1, NLONS
         do lat = 1, NLATS
             if (pres_in(lon, lat) .ne. SAMPLE_PRESSURE +
     +           (lon - 1) * NLATS + (lat - 1)) stop 2
             if (temp_in(lon, lat) .ne. SAMPLE_TEMP +
     +           .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
         end do
      end do

C     Each of the netCDF variables has a "units" attribute. Let's read
C     them and check them.

      retval = nf_get_att_text(ncid, lat_varid, UNITS, lat_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lat_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lat_units_in(1:att_len) .ne. LAT_UNITS) stop 2
 
      retval = nf_get_att_text(ncid, lon_varid, UNITS, lon_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lon_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lon_units_in(1:att_len) .ne. LON_UNITS) stop 2

      retval = nf_get_att_text(ncid, pres_varid, UNITS, pres_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, pres_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (pres_units_in(1:att_len) .ne. PRES_UNITS) stop 2

      retval = nf_get_att_text(ncid, temp_varid, UNITS, temp_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, temp_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (temp_units_in(1:att_len) .ne. TEMP_UNITS) stop 2

C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is a very simple example which writes a 2D array of
C     sample data. To handle this in netCDF we create two shared
C     dimensions, "x" and "y", and a netCDF variable, called "data".

C     This example demonstrates the netCDF Fortran 77 API. This is part
C     of the netCDF tutorial, which can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: simple_xy_nc4_wr.f,v 1.5 2008/02/19 22:01:49 ed Exp $

      program simple_xy_wr
      implicit none
      include 'netcdf.inc'

      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy_nc4.nc')
      integer NDIMS
      parameter (NDIMS = 2)
      integer NX, NY
      parameter (NX = 60, NY = 120)
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid
      integer data_out(NY, NX)
      integer x, y, retval
      integer chunks(2)
      integer contiguous, shuffle, deflate, deflate_level

C     Create some pretend data. If this wasn't an example program, we
C     would have some real data to write, for example, model output.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

C     Create the netCDF file. The nf_netcdf4  tells netCDF to
C     create a netCDF-4/HDF5 file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the IDs of the dimensions of
C     the variables. Note that in fortran arrays are stored in
C     column-major format.
      dimids(2) = x_dimid
      dimids(1) = y_dimid

C     Define the variable. 
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Set up chunking and compression.
      contiguous = 0
      chunks(1) = NY
      chunks(2) = NX
      shuffle = 1
      deflate = 1
      deflate_level = 4

      retval = nf_def_var_chunking(ncid, varid, contiguous, chunks)
      if (retval .ne. nf_noerr) call handle_err(retval)

      retval = nf_def_var_deflate(ncid, varid, shuffle, deflate,
     &     deflate_level)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS writing example file simple_xy_nc4.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program simple_xy_wr.f90.
      
! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_rd
  use netcdf
  implicit none

  ! This is the name of the data file and variable.
  character (len = *), parameter :: FILE_NAME = "simple_xy_nc4.nc"
  character (len = *), parameter :: VAR_NAME = "data"

  ! We are reading 2D data, a 12 x 6 grid. 
  integer, parameter :: NX = 6, NY = 12, MAX_DIMS = 2
  integer :: data_in(NY, NX)

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! Information we will read about the variable.
  character (len = nf90_max_name) :: name
  integer :: xtype, ndims, dimids(MAX_DIMS), natts
  integer :: chunksizes(MAX_DIMS), deflate_level, endianness
  logical :: contiguous, shuffle, fletcher32

  ! Loop indexes, and error handling.
  integer :: x, y

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access
  ! to the file.
  call check( nf90_open(FILE_NAME, NF90_NOWRITE, ncid) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, VAR_NAME, varid) )

  ! Learn about the variable. This uses all optional parameters.
  call check( nf90_inquire_variable(ncid, varid, name, xtype, ndims, &
       dimids, natts, contiguous = contiguous, chunksizes = chunksizes, &
       deflate_level = deflate_level, shuffle = shuffle, &
       fletcher32 = fletcher32, endianness = endianness) )

  ! Make sure we got the correct answers. These depend on what was set
  ! when creating the file in simple_xy_nc4_wr.f90. Endianness will be
  ! whatever is native for the machine that's building this example.
  if (name .ne. VAR_NAME .or. xtype .ne. NF90_INT .or. ndims .ne. 2 .or. &
       natts .ne. 0 .or. contiguous .or. .not. shuffle .or. &
       deflate_level .ne. 1 .or. fletcher32) stop 3

  ! Read the data.
  call check( nf90_get_var(ncid, varid, data_in) )

  ! Check the data.
  do x = 1, NX
     do y = 1, NY
        if (data_in(y, x) /= (x - 1) * NY + (y - 1)) then
           print *, "data_in(", y, ", ", x, ") = ", data_in(y, x)
           stop "Stopped"
        end if
     end do
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_rd

program EightBytIntTest
   use typeSizes
   implicit none

   integer (kind = EightByteInt) :: Eight
   integer                       :: defaultInt

   print *, "Kind parameter for EightByteInt is", EightByteInt
   print *, "Bit size of eight byte int is",      bit_size(Eight)
contains
   subroutine EightByteIntProcedure(input)
     integer (kind = EightByteInt), intent( in) :: input

     print *, int(input)
   end subroutine EightByteIntProcedure
end program EightBytIntTest

C     This is part of the netCDF package.
C     Copyright 2005 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is the error handling function for some of the F77
C     tests. This error handler comes from the netcdf tutorial.

C     $Id: handle_err.F,v 1.1 2009/06/07 13:17:26 ed Exp $

C     This subroutine handles errors by printing an error message and
C     exiting with a non-zero status.
      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some surface pressure and
! temperatures. The data file read by this program is produced
! comapnion program sfc_pres_temp_wr.f90. It is intended to illustrate
! the use of the netCDF fortran 90 API.

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program sfc_pres_temp_rd
  use netcdf
  implicit none

  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are reading 2D data, a 12 x 6 lon-lat grid.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"

  ! For the lat lon coordinate netCDF variables.
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid

  ! We will read surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME = "pressure"
  character (len = *), parameter :: TEMP_NAME = "temperature"
  integer :: pres_varid, temp_varid

  ! To check the units attributes.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"
  integer, parameter :: MAX_ATT_LEN = 80
  integer :: att_len
  character*(MAX_ATT_LEN) :: pres_units_in, temp_units_in
  character*(MAX_ATT_LEN) :: lat_units_in, lon_units_in

  ! Read the data into these arrays.
  real, dimension(:,:), allocatable :: pres_in
  real, dimension(:,:), allocatable :: temp_in

  ! These are used to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! We will learn about the data file and store results in these
  ! program variables.
  integer :: ndims_in, nvars_in, ngatts_in, unlimdimid_in

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS))
  allocate(temp_in(NLONS, NLATS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! There are a number of inquiry functions in netCDF which can be
  ! used to learn about an unknown netCDF file. NF90_INQ tells how many
  ! netCDF variables, dimensions, and global attributes are in the
  ! file; also the dimension id of the unlimited dimension, if there
  ! is one.
  call check( nf90_inquire(ncid, ndims_in, nvars_in, ngatts_in, unlimdimid_in) )

  ! In this case we know that there are 2 netCDF dimensions, 4 netCDF
  ! variables, no global attributes, and no unlimited dimension.
  if (ndims_in /= 2 .or. nvars_in /= 4 .or. ngatts_in /= 0 &
       .or. unlimdimid_in /= -1) stop 2

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )

  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read the surface pressure and temperature data from the file.
  ! Since we know the contents of the file we know that the data
  ! arrays in this program are the correct size to hold all the data.
  call check( nf90_get_var(ncid, pres_varid, pres_in) )
  call check( nf90_get_var(ncid, temp_varid, temp_in) )

  ! Check the data. It should be the same as the data we wrote.
  do lon = 1, NLONS
     do lat = 1, NLATS
        if (pres_in(lon, lat) /= SAMPLE_PRESSURE + &
             (lon - 1) * NLATS + (lat - 1)) stop 2
        if (temp_in(lon, lat) /= SAMPLE_TEMP + &
             .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
     end do
  end do

  ! Each of the netCDF variables has a "units" attribute. Let's read
  ! them and check them.
  call check( nf90_get_att(ncid, lat_varid, UNITS, lat_units_in) )
  call check( nf90_inquire_attribute(ncid, lat_varid, UNITS, len = att_len) )
  if (lat_units_in(1:att_len) /= LAT_UNITS) stop 2

  call check( nf90_get_att(ncid, lon_varid, UNITS, lon_units_in) )
  call check( nf90_inquire_attribute(ncid, lon_varid, UNITS, len = att_len) )
  if (lon_units_in(1:att_len) /= LON_UNITS) stop 2

  call check( nf90_get_att(ncid, pres_varid, UNITS, pres_units_in) )
  call check( nf90_inquire_attribute(ncid, pres_varid, UNITS, len = att_len) )
  if (pres_units_in(1:att_len) /= PRES_UNITS) stop 2

  call check( nf90_get_att(ncid, temp_varid, UNITS, temp_units_in) )
  call check( nf90_inquire_attribute(ncid, temp_varid, UNITS, len = att_len) )
  if (temp_units_in(1:att_len) /= TEMP_UNITS) stop 2

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_rd

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is a very simple example which writes a 2D array of
C     sample data. To handle this in netCDF we create two shared
C     dimensions, "x" and "y", and a netCDF variable, called "data".

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program simple_xy_wr
      implicit none
      include 'netcdf.inc'

      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy_nc4.nc')
      integer NDIMS
      parameter (NDIMS = 2)
      integer NX, NY
      parameter (NX = 60, NY = 120)
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid
      integer data_out(NY, NX)
      integer x, y, retval
      integer chunks(2)
      integer contiguous, shuffle, deflate, deflate_level

C     Create some pretend data. If this wasn't an example program, we
C     would have some real data to write, for example, model output.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

C     Create the netCDF file. The nf_netcdf4  tells netCDF to
C     create a netCDF-4/HDF5 file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the IDs of the dimensions of
C     the variables. Note that in fortran arrays are stored in
C     column-major format.
      dimids(2) = x_dimid
      dimids(1) = y_dimid

C     Define the variable. 
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Set up chunking and compression.
      contiguous = 0
      chunks(1) = NY
      chunks(2) = NX
      shuffle = 1
      deflate = 1
      deflate_level = 4

      retval = nf_def_var_chunking(ncid, varid, contiguous, chunks)
      if (retval .ne. nf_noerr) call handle_err(retval)

      retval = nf_def_var_deflate(ncid, varid, shuffle, deflate,
     &     deflate_level)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS writing example file simple_xy_nc4.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

    / *Macros for accessing attribute test data */
    /* varid is -1 for NF_GLOBAL so can do global atts in same loop */

      FUNCTION VARID(VID)
      IMPLICIT NONE
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 0) THEN
          VARID = NF_GLOBAL
      ELSE
          VARID = VID
      ENDIF
      end


      FUNCTION NATTS(VID)
      INTEGER VID
#include "tests.inc"
      IF (VID .LE. 0) THEN
          NATTS = NGATTS
      ELSE
          NATTS = VAR_NATTS(VID)
      ENDIF
      END


      FUNCTION ATT_NAME(J,VID)
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LE. 0) THEN
          ATT_NAME = GATT_NAME(J)
      ELSE
          ATT_NAME = ATTNAME(J,VID)
      ENDIF
      END


      FUNCTION ATT_TYPE(J,VID)
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LE. 0) THEN
          ATT_TYPE = GATT_TYPE(J)
      ELSE
          ATT_TYPE = ATTTYPE(J,VID)
      ENDIF
      END


      FUNCTION ATT_LEN(J,VID)
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LE. 0) THEN
          ATT_LEN = GATT_LEN(J)
      ELSE
          ATT_LEN = ATTLEN(J,VID)
      ENDIF
      END

! This is part of the netCDF package. Copyright 2006 University
! Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
! for conditions of use.

! This is a very simple example which writes a 2D array of sample
! data. To handle this in netCDF we create two shared dimensions, "x"
! and "y", and a netCDF variable, called "data". It uses parallel I/O
! to write the file from all processors at the same time.

! This example is like simple_xy_par_wr.f90, except:
! - added unlimited time dimension (3)
! - added chunk size for unlimited variable writes
! - use of MPI module instead of include file
! - exclude first process from writing data (test independent write). 
! - include first process for opening/metadata/closing file

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Russ Rew, Marshall Ward, Ed Hartnett

program simple_xy_par_wr2

  use netcdf
  use mpi

  implicit none
 
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! We are writing 2D data.
  integer, parameter :: NDIMS = 3

  ! When we create netCDF files, variables and dimensions, we get back
  ! an ID for each one.
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid, t_dimid

  ! add chunk size for unlimited variables
  integer :: chunk_size(NDIMS)

  ! These will tell where in the data file this processor should
  ! write.
  integer :: start(NDIMS), count(NDIMS)
  
  ! This is the data array we will write. It will just be filled with
  ! the rank of this processor.
  integer, allocatable :: data_out(:)

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Create some pretend data. We just need one row.
  allocate(data_out(p), stat = stat)
  if (stat .ne. 0) stop 3
  do x = 1, p
     data_out(x) = my_rank
  end do

  ! Create the netCDF file. The NF90_NETCDF4 flag causes a
  ! HDF5/netCDF-4 file to be created. The comm and info parameters
  ! cause parallel I/O to be enabled. Use either NF90_MPIIO or
  ! NF90_MPIPOSIX to select between MPI/IO and MPI/POSIX.
  call check(nf90_create(FILE_NAME, IOR(NF90_NETCDF4, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Define the dimensions. NetCDF will hand back an ID for
  ! each. Metadata operations must take place on all processors.
  call check(nf90_def_dim(ncid, "x", p, x_dimid))
  call check(nf90_def_dim(ncid, "y", p, y_dimid))
  call check(nf90_def_dim(ncid, "t", NF90_UNLIMITED, t_dimid))

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids = (/ y_dimid, x_dimid, t_dimid /)

  ! define the chunk size (1 along unlimited time dimension)
  chunk_size = (/ p, 1, 1 /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer).
  call check(nf90_def_var(ncid, "data", NF90_INT, dimids, varid, chunksizes=chunk_size))

  ! End define mode. This tells netCDF we are done defining
  ! metadata. This operation is collective and all processors will
  ! write their metadata to disk.
  call check(nf90_enddef(ncid))

  ! Write the pretend data to the file. Each processor writes one row.
  start = (/ 1, my_rank + 1, 1/)
  count = (/ p, 1, 1 /)

  ! Unlimited dimensions require collective writes
  call check(nf90_var_par_access(ncid, varid, nf90_collective))

  ! The unlimited axis prevents independent write tests
  ! Re-enable the rank test if independent writes are used in the future
  !if (my_rank.ne.0) &
  call check(nf90_put_var(ncid, varid, data_out, start = start, &
       count = count))

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_out)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *, "*** SUCCESS writing example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_wr2

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 variable functions from fortran.

!     Ed Hartnett, 2009

program f90tst_vars4
  use typeSizes
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_vars4.nc"

  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 40, NY = 4096
  integer :: data_out(NY, NX), data_in(NY, NX)

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid, dimids(MAX_DIMS), chunksizes(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: mode_flag
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer, parameter :: CACHE_SIZE = 1000000
  integer :: xtype_in, natts_in, dimids_in(MAX_DIMS), chunksizes_in(MAX_DIMS)
  logical :: contiguous_in, shuffle_in, fletcher32_in
  integer :: deflate_level_in, endianness_in
  character (len = NF90_MAX_NAME) :: name_in


  print *, ''
  print *,'*** Testing definition of netCDF-4 vars from Fortran 90.'

  ! Create some pretend data.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Create the netCDF file. 
  mode_flag = IOR(nf90_netcdf4, nf90_classic_model) 
  call handle_err(nf90_create(FILE_NAME, mode_flag, ncid, cache_size = CACHE_SIZE))

  ! Define the dimensions.
  call handle_err(nf90_def_dim(ncid, "x", NX, x_dimid))
  call handle_err(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. 
  chunksizes = (/ 256, 10 /)
  call handle_err(nf90_def_var(ncid, 'data', NF90_INT, dimids, & 
       varid, chunksizes = chunksizes, deflate_level = 4))

  ! With classic model netCDF-4 file, enddef must be called.
  call handle_err(nf90_enddef(ncid))

  ! Write the pretend data to the file.
  call handle_err(nf90_put_var(ncid, varid, data_out))

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid))
  
  ! Check some stuff out.
  call handle_err(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 1 .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4_classic) stop 3

  call handle_err(nf90_inquire_variable(ncid, varid, name_in, xtype_in, ndims, dimids_in, &
       natts_in, contiguous_in, chunksizes_in, deflate_level_in, shuffle_in, fletcher32_in, &
       endianness_in))
  if (name_in .ne. 'data' .or. xtype_in .ne. NF90_INT .or. ndims .ne. MAX_DIMS .or. &
       dimids_in(1) /= y_dimid .or. dimids_in(2) /= x_dimid .or. &
       natts_in .ne. 0 .or. contiguous_in .neqv. .false. .or. &
       chunksizes_in(1) /= chunksizes(1) .or. chunksizes_in(2) /= chunksizes(2) .or. &
       deflate_level_in .ne. 4 .or. shuffle_in .neqv. .false. .or. fletcher32_in .neqv. .false.) &
       stop 4

  ! Check the data.
  call handle_err(nf90_get_var(ncid, varid, data_in))
  do x = 1, NX
     do y = 1, NY
        if (data_out(y, x) .ne. data_in(y, x)) stop 3
     end do
  end do

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  print *,'*** SUCCESS!'


contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine handle_err
end program f90tst_vars4

C     This is part of the netCDF package. Copyright 2009-2019 University
C     Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
C     for conditions of use.

C     This program tests the fortran V2 API with netCDF-4.

C     Ed Hartnett 2009

      program ftst_v2
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_v2.nc')

      integer ncid, timedim, londim, latdim, lonid, latid
      character*(3) lat_name
      parameter (lat_name = 'lat')
      character*(3) lon_name
      parameter (lon_name = 'lon')
      character*(4) time_name
      parameter (time_name = 'time')
      integer LON_LEN, LAT_LEN
      parameter (LON_LEN = 3, LAT_LEN = 5)
      integer NDIMS, NVARS
      parameter (NDIMS = 3, NVARS = 2)
      integer ndims_in, nvars_in, ngatts_in, recdim_in
      integer dimsize_in, natts_in
      integer xtype_in, dimids_in(NDIMS)
      character*(128) name_in
      integer rc

      print *, ''
      print *,'*** Testing v2 fortran API with netCDF-4.'

C     Create the file.
      ncid = nccre(FILE_NAME, NF_NETCDF4, rc)
      timedim = ncddef(ncid, time_name, NCUNLIM, rc)
      londim = ncddef(ncid, lon_name, LON_LEN, rc)
      latdim = ncddef(ncid, lat_name, LAT_LEN, rc)
      lonid = ncvdef(ncid, lon_name, NCFLOAT, 1, londim, rc)
      latid = ncvdef(ncid, lat_name, NCFLOAT, 1, latdim, rc)

C     Check the file.
      call ncinq(ncid, ndims_in, nvars_in, ngatts_in, recdim_in, rc)
      if (ndims_in .ne. NDIMS) stop 2
      if (ndims_in .ne. NDIMS .or. nvars_in .ne. NVARS .or.
     $     ngatts_in .ne. 0 .or. recdim_in .ne. timedim) stop 2
      call ncdinq(ncid, timedim, name_in, dimsize_in, rc)
      if (name_in .ne. time_name .or. dimsize_in .ne. 0) stop 2
      call ncdinq(ncid, londim, name_in, dimsize_in, rc)
      if (name_in .ne. lon_name .or. dimsize_in .ne. LON_LEN) stop 2
      call ncdinq(ncid, latdim, name_in, dimsize_in, rc)
      if (name_in .ne. lat_name .or. dimsize_in .ne. LAT_LEN) stop 2
      call ncvinq(ncid, lonid, name_in, xtype_in, ndims_in, dimids_in, 
     $     natts_in, rc)
      if (name_in .ne. lon_name .or. xtype_in .ne. NCFLOAT .or.
     $     ndims_in .ne. 1 .or. dimids_in(1) .ne. londim) stop 2
      call ncvinq(ncid, latid, name_in, xtype_in, ndims_in, dimids_in, 
     $     natts_in, rc)
      if (name_in .ne. lat_name .or. xtype_in .ne. NCFLOAT .or.
     $     ndims_in .ne. 1 .or. dimids_in(1) .ne. latdim) stop 2

C     Close the file.
      call ncclos(ncid, rc)

C     Reopen, and check again.
      ncid = ncopn(FILE_NAME, NCNOWRIT, rc)
C     Check the file.
      call ncinq(ncid, ndims_in, nvars_in, ngatts_in, recdim_in, rc)
      if (ndims_in .ne. NDIMS) stop 2
      if (ndims_in .ne. NDIMS .or. nvars_in .ne. NVARS .or.
     $     ngatts_in .ne. 0 .or. recdim_in .ne. timedim) stop 2
      call ncdinq(ncid, timedim, name_in, dimsize_in, rc)
      if (name_in .ne. time_name .or. dimsize_in .ne. 0) stop 2
      call ncdinq(ncid, londim, name_in, dimsize_in, rc)
      if (name_in .ne. lon_name .or. dimsize_in .ne. LON_LEN) stop 2
      call ncdinq(ncid, latdim, name_in, dimsize_in, rc)
      if (name_in .ne. lat_name .or. dimsize_in .ne. LAT_LEN) stop 2
      call ncvinq(ncid, lonid, name_in, xtype_in, ndims_in, dimids_in, 
     $     natts_in, rc)
      if (name_in .ne. lon_name .or. xtype_in .ne. NCFLOAT .or.
     $     ndims_in .ne. 1 .or. dimids_in(1) .ne. londim) stop 2
      call ncvinq(ncid, latid, name_in, xtype_in, ndims_in, dimids_in, 
     $     natts_in, rc)
      if (name_in .ne. lat_name .or. xtype_in .ne. NCFLOAT .or.
     $     ndims_in .ne. 1 .or. dimids_in(1) .ne. latdim) stop 2

      call ncclos(ncid, rc)

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 fill values with parallel I/O. It
!     writes a checkerboard decomposition for a number of variables,
!     but task 0 (of 4) does not write. The resulting data has fill
!     value for the first quarter of each array.

!     Ed Hartnett, started 2009, finished 2019.

program f90tst_parallel_fill
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel_fill.nc"
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: HALF_NX = NX / 2, HALF_NY = NY / 2
  integer, parameter :: QUARTER_NX = NX / 4, QUARTER_NY = NY / 4
  integer, parameter :: NUM_VARS = 8
  character (len = *), parameter :: var_name(NUM_VARS) = &
       (/ 'byte__', 'short_', 'int___', 'float_', 'double', 'ubyte_', 'ushort', 'uint__' /)
  integer :: ncid, varid(NUM_VARS), dimids(MAX_DIMS)
  integer :: var_type(NUM_VARS) = (/ nf90_byte, nf90_short, nf90_int, &
       nf90_float, nf90_double, nf90_ubyte, nf90_ushort, nf90_uint /)
  integer :: x_dimid, y_dimid
  integer :: byte_out(HALF_NY, HALF_NX), byte_in(HALF_NY, HALF_NX)
  integer :: short_out(HALF_NY, HALF_NX), short_in(HALF_NY, HALF_NX)
  integer :: int_out(HALF_NY, HALF_NX), int_in(HALF_NY, HALF_NX)
  real :: areal_out(HALF_NY, HALF_NX), areal_in(HALF_NY, HALF_NX)
  real :: double_out(HALF_NY, HALF_NX), double_in(HALF_NY, HALF_NX)
  integer :: ubyte_out(HALF_NY, HALF_NX), ubyte_in(HALF_NY, HALF_NX)
  integer :: ushort_out(HALF_NY, HALF_NX), ushort_in(HALF_NY, HALF_NX)
  integer (kind = EightByteInt) :: uint_out(HALF_NY, HALF_NX), uint_in(HALF_NY, HALF_NX)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y, v
  integer :: start_out(MAX_DIMS), count_out(MAX_DIMS)
  integer :: start_in(MAX_DIMS), count_in(MAX_DIMS)
  integer :: mode
  integer :: p, my_rank, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  if (my_rank .eq. 0) then
     print *,
     print *, '*** Testing fill values with parallel I/O.'
  endif

  ! There must be 4 procs for this test.
  if (p .ne. 4) then
     print *, 'Sorry, this test program must be run on four processors.'
     stop 1
  endif

  ! Create some pretend data.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        byte_out(y, x) = -1
        short_out(y, x) =  -2
        int_out(y, x) = -4
        areal_out(y, x) = 2.5
        double_out(y, x) = -4.5
        ubyte_out(y, x) = 1
        ushort_out(y, x) = 2
        uint_out(y, x) = 4
     end do
  end do

  ! Create the netCDF file. nf90_mpiio flag not required starting with
  ! netcdf-c-4.6.1.
  mode = ior(nf90_netcdf4, nf90_mpiio)
  call check(nf90_create(FILE_NAME, mode, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variables. 
  do v = 1, NUM_VARS
     call check(nf90_def_var(ncid, var_name(v), var_type(v), dimids, varid(v)))
     call check(nf90_var_par_access(ncid, varid(v), nf90_collective))     
  end do

  ! This will be the last collective operation.
  call check(nf90_enddef(ncid))

  ! Determine what part of the variable will be written/read for this
  ! processor. It's a checkerboard decomposition. Only the third
  ! quadrant of data will be written, so each processor writes a
  ! quarter of the quadrant, or 1/16th of the total array. (And
  ! processor 0 doesn't write anyway.)
  count_out = (/ HALF_NX, HALF_NY /)
  if (my_rank .eq. 0) then
     start_out = (/ 1, 1 /)
     count_out = (/ 0, 0 /)
  else if (my_rank .eq. 1) then
     start_out = (/ HALF_NX + 1, 1 /)
  else if (my_rank .eq. 2) then
     start_out = (/ 1, HALF_NY + 1 /)
  else if (my_rank .eq. 3) then
     start_out = (/ HALF_NX + 1, HALF_NY + 1 /)
  endif
  ! print *, my_rank, start_out, count_out

  ! Write this processor's data, except for processor zero.
  call check(nf90_put_var(ncid, varid(1), byte_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(2), short_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(3), int_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(4), areal_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(5), double_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(6), ubyte_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(7), ushort_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(8), uint_out, start = start_out, count = count_out))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the file. nf90_mpiio flag not required starting with
  ! netcdf-c-4.6.1.
  mode = ior(nf90_nowrite, nf90_mpiio)
  call check(nf90_open(FILE_NAME, mode, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))
  
  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= NUM_VARS .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4) stop 2

  ! Now each processor will read one quarter of the whole array.
  count_in = (/ HALF_NX, HALF_NY /)
  if (my_rank .eq. 0) then
     start_in = (/ 1, 1 /)
  else if (my_rank .eq. 1) then
     start_in = (/ HALF_NX + 1, 1 /)
  else if (my_rank .eq. 2) then
     start_in = (/ 1, HALF_NY + 1 /)
  else if (my_rank .eq. 3) then
     start_in = (/ HALF_NX + 1, HALF_NY + 1 /)
  endif

  ! Read this processor's data.
  call check(nf90_get_var(ncid, varid(1), byte_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(2), short_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(3), int_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(4), areal_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(5), double_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(6), ubyte_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(7), ushort_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(8), uint_in, start = start_in, count = count_in))

  ! Check the data. All the data from the processor zero are fill
  ! value.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        if (my_rank .ne. 0) then
           if (byte_in(y, x) .ne. -1) stop 13
           if (short_in(y, x) .ne. -2) stop 14
           if (int_in(y, x) .ne. -4) stop 15
           if (areal_in(y, x) .ne. 2.5) stop 16
           if (double_in(y, x) .ne. -4.5) stop 17
           if (ubyte_in(y, x) .ne. 1) stop 18
           if (ushort_in(y, x) .ne. 2) stop 19
           if (uint_in(y, x) .ne. 4) stop 20
        else
           if (byte_in(y, x) .ne. nf90_fill_byte) stop 3
           if (short_in(y, x) .ne. nf90_fill_short) stop 4
           if (int_in(y, x) .ne. nf90_fill_int) stop 5
           if (areal_in(y, x) .ne. nf90_fill_real) stop 6
           if (double_in(y, x) .ne. nf90_fill_double) stop 7
           if (ubyte_in(y, x) .ne. nf90_fill_ubyte) stop 8
           if (ushort_in(y, x) .ne. nf90_fill_ushort) stop 9
           if (uint_in(y, x) .ne. nf90_fill_uint) stop 10
        endif
     end do
  end do

! Close the file.
  call check(nf90_close(ncid))

  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 99
    endif
  end subroutine check
end program f90tst_parallel_fill

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 variable functions from fortran.

!     Ed Hartnett, 2009

program f90tst_vars4
  use typeSizes
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_vars4.nc"

  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 40, NY = 4096
  integer, dimension(:,:), allocatable :: data_out, data_in

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid, dimids(MAX_DIMS), chunksizes(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: mode_flag
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer, parameter :: CACHE_SIZE = 1000000
  integer :: xtype_in, natts_in, dimids_in(MAX_DIMS), chunksizes_in(MAX_DIMS)
  logical :: contiguous_in, shuffle_in, fletcher32_in
  integer :: deflate_level_in, endianness_in
  character (len = NF90_MAX_NAME) :: name_in


  print *, ''
  print *,'*** Testing definition of netCDF-4 vars from Fortran 90.'

  allocate(data_out(NY, NX), data_in(NY, NX))

  ! Create some pretend data.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Create the netCDF file. 
  mode_flag = IOR(nf90_netcdf4, nf90_classic_model) 
  call handle_err(nf90_create(FILE_NAME, mode_flag, ncid, cache_size = CACHE_SIZE))

  ! Define the dimensions.
  call handle_err(nf90_def_dim(ncid, "x", NX, x_dimid))
  call handle_err(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. 
  chunksizes = (/ 256, 10 /)
  call handle_err(nf90_def_var(ncid, 'data', NF90_INT, dimids, & 
       varid, chunksizes = chunksizes, deflate_level = 4))

  ! With classic model netCDF-4 file, enddef must be called.
  call handle_err(nf90_enddef(ncid))

  ! Write the pretend data to the file.
  call handle_err(nf90_put_var(ncid, varid, data_out))

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid))
  
  ! Check some stuff out.
  call handle_err(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 1 .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4_classic) stop 3

  call handle_err(nf90_inquire_variable(ncid, varid, name_in, xtype_in, ndims, dimids_in, &
       natts_in, contiguous_in, chunksizes_in, deflate_level_in, shuffle_in, fletcher32_in, &
       endianness_in))
  if (name_in .ne. 'data' .or. xtype_in .ne. NF90_INT .or. ndims .ne. MAX_DIMS .or. &
       dimids_in(1) /= y_dimid .or. dimids_in(2) /= x_dimid .or. &
       natts_in .ne. 0 .or. contiguous_in .neqv. .false. .or. &
       chunksizes_in(1) /= chunksizes(1) .or. chunksizes_in(2) /= chunksizes(2) .or. &
       deflate_level_in .ne. 4 .or. shuffle_in .neqv. .false. .or. fletcher32_in .neqv. .false.) &
       stop 4

  ! Check the data.
  call handle_err(nf90_get_var(ncid, varid, data_in))
  do x = 1, NX
     do y = 1, NY
        if (data_out(y, x) .ne. data_in(y, x)) stop 3
     end do
  end do

  ! Close the file. 
  call handle_err(nf90_close(ncid))

  print *,'*** SUCCESS!'

  if (allocated(data_in)) deallocate(data_in)
  if (allocated(data_out)) deallocate(data_out)

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine handle_err
end program f90tst_vars4

!     This is part of the netCDF package.
!     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 int64 types from fortran 90.

!     Ed Hartnett, 2009

program f90tst_types2
  use typeSizes
  use netcdf
  implicit none
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_types2.nc"
  
  integer :: ncid, varid1, varid2, varid3, varid4, varid5, varid6, varid7
  integer :: dimid1, dimid2, dimid3, dimid4, dimid5, dimid6, dimid7
  integer :: dimids1(1), dimids2(2), dimids3(3), dimids4(4), dimids5(5), dimids6(6), dimids7(7)
  integer :: i1, i2, i3, i4, i5, i6, i7
  integer, parameter :: DLEN = 2
  integer (kind = EightByteInt) :: data1_in(DLEN), data1_out(DLEN)
  integer (kind = EightByteInt) :: data2_in(DLEN, DLEN), data2_out(DLEN, DLEN)
  integer (kind = EightByteInt) :: data3_in(DLEN, DLEN, DLEN), data3_out(DLEN, DLEN, DLEN)
  integer (kind = EightByteInt) :: data4_in(DLEN, DLEN, DLEN, DLEN), data4_out(DLEN, DLEN, DLEN, DLEN)
  integer (kind = EightByteInt) :: data5_in(DLEN, DLEN, DLEN, DLEN, DLEN), data5_out(DLEN, DLEN, DLEN, DLEN, DLEN)
  integer (kind = EightByteInt) :: data6_in(DLEN, DLEN, DLEN, DLEN, DLEN, DLEN), data6_out(DLEN, DLEN, DLEN, DLEN, DLEN, DLEN)
  integer (kind = EightByteInt) :: data7_in(DLEN, DLEN, DLEN, DLEN, DLEN, DLEN, DLEN), &
       data7_out(DLEN, DLEN, DLEN, DLEN, DLEN, DLEN, DLEN)
  integer (kind = EightByteInt), parameter :: REALLY_BIG = 9223372036854775807_EightByteInt

  print *, ''
  print *,'*** Testing netCDF-4 64-bit integer types from Fortran 90.'

  do i1 = 1, DLEN
     data1_out(i1) = REALLY_BIG
  end do
  do i2 = 1, DLEN
     do i1 = 1, DLEN
        data2_out(i1, i2) = REALLY_BIG - i1 - i2
     end do
  end do
  do i3 = 1, DLEN
     do i2 = 1, DLEN
        do i1 = 1, DLEN
           data3_out(i1, i2, i3) = REALLY_BIG - i1 - i2 - i3
        end do
     end do
  end do
  do i4 = 1, DLEN
     do i3 = 1, DLEN
        do i2 = 1, DLEN
           do i1 = 1, DLEN
              data4_out(i1, i2, i3, i4) = REALLY_BIG - i1 - i2 - i3 - i4
           end do
        end do
     end do
  end do
  do i5 = 1, DLEN
     do i4 = 1, DLEN
        do i3 = 1, DLEN
           do i2 = 1, DLEN
              do i1 = 1, DLEN
                 data5_out(i1, i2, i3, i4, i5) = REALLY_BIG - i1 - i2 - i3 - i4 - i5
              end do
           end do
        end do
     end do
  end do
  do i6 = 1, DLEN
     do i5 = 1, DLEN
        do i4 = 1, DLEN
           do i3 = 1, DLEN
              do i2 = 1, DLEN
                 do i1 = 1, DLEN
                    data6_out(i1, i2, i3, i4, i5, i6) = REALLY_BIG - i1 - i2 - i3 - i4 - i5 - i6
                 end do
              end do
           end do
        end do
     end do
  end do
  do i7 = 1, DLEN
     do i6 = 1, DLEN
        do i5 = 1, DLEN
           do i4 = 1, DLEN
              do i3 = 1, DLEN
                 do i2 = 1, DLEN
                    do i1 = 1, DLEN
                       data7_out(i1, i2, i3, i4, i5, i6, i7) = REALLY_BIG - i1 - i2 - i3 - i4 - i5 - i6 - i7
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do
  
  ! Create the netCDF file. 
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid))

  ! Define dimensions.
  call check(nf90_def_dim(ncid, "d1", DLEN, dimid1))
  call check(nf90_def_dim(ncid, "d2", DLEN, dimid2))
  call check(nf90_def_dim(ncid, "d3", DLEN, dimid3))
  call check(nf90_def_dim(ncid, "d4", DLEN, dimid4))
  call check(nf90_def_dim(ncid, "d5", DLEN, dimid5))
  call check(nf90_def_dim(ncid, "d6", DLEN, dimid6))
  call check(nf90_def_dim(ncid, "d7", DLEN, dimid7))

  ! Create some int64 variables, from 1 to 7D.
  dimids1(1) = dimid1
  call check(nf90_def_var(ncid, "v1", nf90_int64, dimids1, varid1))
  dimids2(1) = dimid1
  dimids2(2) = dimid2
  call check(nf90_def_var(ncid, "v2", nf90_int64, dimids2, varid2))
  dimids3(1) = dimid1
  dimids3(2) = dimid2
  dimids3(3) = dimid3
  call check(nf90_def_var(ncid, "v3", nf90_int64, dimids3, varid3))
  dimids4(1) = dimid1
  dimids4(2) = dimid2
  dimids4(3) = dimid3
  dimids4(4) = dimid4
  call check(nf90_def_var(ncid, "v4", nf90_int64, dimids4, varid4))
  dimids5(1) = dimid1
  dimids5(2) = dimid2
  dimids5(3) = dimid3
  dimids5(4) = dimid4
  dimids5(5) = dimid5
  call check(nf90_def_var(ncid, "v5", nf90_int64, dimids5, varid5))
  dimids6(1) = dimid1
  dimids6(2) = dimid2
  dimids6(3) = dimid3
  dimids6(4) = dimid4
  dimids6(5) = dimid5
  dimids6(6) = dimid6
  call check(nf90_def_var(ncid, "v6", nf90_int64, dimids6, varid6))
  dimids7(1) = dimid1
  dimids7(2) = dimid2
  dimids7(3) = dimid3
  dimids7(4) = dimid4
  dimids7(5) = dimid5
  dimids7(6) = dimid6
  dimids7(7) = dimid7
  call check(nf90_def_var(ncid, "v7", nf90_int64, dimids7, varid7))

  ! Write some large integers.
  call check(nf90_put_var(ncid, varid1, data1_out))
  call check(nf90_put_var(ncid, varid2, data2_out))
  call check(nf90_put_var(ncid, varid3, data3_out))
  call check(nf90_put_var(ncid, varid4, data4_out))
  call check(nf90_put_var(ncid, varid5, data5_out))
  call check(nf90_put_var(ncid, varid6, data6_out))
  call check(nf90_put_var(ncid, varid7, data7_out))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the netCDF file. 
  call check(nf90_open(FILE_NAME, 0, ncid))

  ! Read in the large numbers.
  call check(nf90_get_var(ncid, varid1, data1_in))
  call check(nf90_get_var(ncid, varid2, data2_in))
  call check(nf90_get_var(ncid, varid3, data3_in))
  call check(nf90_get_var(ncid, varid4, data4_in))
  call check(nf90_get_var(ncid, varid5, data5_in))
  call check(nf90_get_var(ncid, varid6, data6_in))
  call check(nf90_get_var(ncid, varid7, data7_in))

  ! Check the values for correctness.
  do i1 = 1, DLEN
     if (data1_in(i1) .ne. data1_out(i1)) stop 2
  end do
  do i2 = 1, DLEN
     do i1 = 1, DLEN
        if (data2_in(i1, i2) .ne. data2_out(i1, i2)) stop 2
     end do
  end do
  do i3 = 1, DLEN
     do i2 = 1, DLEN
        do i1 = 1, DLEN
           if (data3_in(i1, i2, i3) .ne. data3_out(i1, i2, i3)) stop 2
        end do
     end do
  end do
  do i4 = 1, DLEN
     do i3 = 1, DLEN
        do i2 = 1, DLEN
           do i1 = 1, DLEN
              if (data4_in(i1, i2, i3, i4) .ne. &
                   data4_out(i1, i2, i3, i4)) stop 2
           end do
        end do
     end do
  end do
  do i5 = 1, DLEN
     do i4 = 1, DLEN
        do i3 = 1, DLEN
           do i2 = 1, DLEN
              do i1 = 1, DLEN
                 if (data5_in(i1, i2, i3, i4, i5) .ne. &
                      data5_out(i1, i2, i3, i4, i5)) stop 2
              end do
           end do
        end do
     end do
  end do
  do i6 = 1, DLEN
     do i5 = 1, DLEN
        do i4 = 1, DLEN
           do i3 = 1, DLEN
              do i2 = 1, DLEN
                 do i1 = 1, DLEN
                    if (data6_in(i1, i2, i3, i4, i5, i6) .ne. &
                         data6_out(i1, i2, i3, i4, i5, i6)) stop 2
                 end do
              end do
           end do
        end do
     end do
  end do
  do i7 = 1, DLEN
     do i6 = 1, DLEN
        do i5 = 1, DLEN
           do i4 = 1, DLEN
              do i3 = 1, DLEN
                 do i2 = 1, DLEN
                    do i1 = 1, DLEN
                       if (data7_in(i1, i2, i3, i4, i5, i6, i7) .ne. &
                            data7_out(i1, i2, i3, i4, i5, i6, i7)) stop 2
                    end do
                 end do
              end do
           end do
        end do
     end do
  end do

  ! Close the file. 
  call check(nf90_close(ncid))
  
  print *,'*** SUCCESS!'

!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  

end program f90tst_types2

C********************************************************************
C   Copyright 1993, UCAR/Unidata
C   See netcdf/COPYRIGHT file for copying and redistribution conditions.
C   $Id: ftest.F,v 1.11 2009/01/25 14:33:45 ed Exp $
C********************************************************************

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable Filter support from fortran.

      program ftst_filter
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_filter.nc')

C     We are writing 2D data, a 6 x 12 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)
      integer DATAOFFSET
C      parameter (DATAOFFSET = 2147483646)
      parameter (DATAOFFSET = 0)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid

C     This is the data array we will write, and a place to store it when
C     we read it back in.
      integer data_out(NY, NX), data_in(NY, NX)

C     For checking our data file to make sure it's correct.
      integer chunks(NDIMS), chunks_in(NDIMS)
      integer filterid, nparams, params(1)

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = DATAOFFSET + x * y
         end do
      end do

      print *, ''
      print *,'*** Testing definition netCDF-4 Filters'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_CLOBBER+NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) stop 1

C     Define the variable. 
      dimids(1) = y_dimid
      dimids(2) = x_dimid
      retval = nf_def_var(ncid, "data", NF_INT64, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) stop 1

C     Turn on chunking.
      chunks(1) = NY
      chunks(2) = NX
      retval = nf_def_var_chunking(ncid, varid, 0, chunks)
      if (retval .ne. nf_noerr) stop 1

C     Set bzip filter on variable
      params(1) = 9
      retval = nf_def_var_filter(ncid, varid, 307, 1, params)
      if (retval .ne. nf_noerr) stop 1

      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find our variable.
      retval = nf_inq_varid(ncid, "data", varid)
      if (retval .ne. nf_noerr) stop 1
      if (varid .ne. 1) stop 2

C     Check the filter
      params(1) = -1
      retval = nf_inq_var_filter(ncid, varid, filterid, nparams, params)
      if (retval .ne. nf_noerr) stop 1
      if (filterid .ne. 307) stop 2
      if (nparams .ne. 1) stop 2
      if (params(1) .ne. 9) stop 2

C     Read the data and check it.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. data_out(y, x)) stop 2
         end do
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing VLEN types.

C     Ed Hartnett, 2009

      program ftst_vars4
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars4.nc')

C     NetCDF IDs.
      integer ncid, vlen_typeid

      integer max_types
      parameter (max_types = 1)

C     Need these to read type information.
      integer num_types, typeids(max_types)
      integer base_type, base_size, num_members, member_value
      character*80 type_name, member_name
      integer type_size, nfields, class

C     Information for the vlen type we will define.
      character*(*) vlen_type_name
      parameter (vlen_type_name = 'vlen_type')

C     Some data about and for the vlen.
      integer vlen_len, vlen_len_in
      parameter (vlen_len = 5)
      integer data1(vlen_len), data1_in(vlen_len)

C     These must be big enough to hold the struct nc_vlen in netcdf.h.
      integer*8 vlen(10), vlen_in(10)

C     Loop indexes, and error handling.
      integer x, retval, index(1)

      print *, ''
      print *,'*** Testing VLEN types.'

      do x = 1, vlen_len
         data1(x) = x
      end do

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create the vlen type.
      retval = nf_def_vlen(ncid, vlen_type_name, nf_int, vlen_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Set up the vlen with this helper function, since F77 can't deal
C     with pointers.
      retval = nf_put_vlen_element(ncid, vlen_typeid, vlen, 
     &     vlen_len, data1)
      if (retval .ne. nf_noerr) stop 1

C     Write the vlen attribute.
      retval = nf_put_att(ncid, NF_GLOBAL, 'att1', vlen_typeid, 1, vlen)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Get the typeids of all user defined types.
      retval = nf_inq_typeids(ncid, num_types, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (num_types .ne. max_types) stop 2

C     Use nf_inq_user_type to confirm this is an vlen type, with base
C     type NF_INT.
      retval = nf_inq_user_type(ncid, typeids(1), type_name, type_size, 
     &     base_type, nfields, class)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(vlen_type_name)) .ne. vlen_type_name .or.
     &     base_type .ne. nf_int .or.
     &     nfields .ne. 0 .or. class .ne. nf_vlen) stop 2

C     Use nf_inq_vlen and make sure we get the same answers as we did
C     with nf_inq_user_type.
      retval = nf_inq_vlen(ncid, typeids(1), type_name, base_size, 
     &     base_type)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(vlen_type_name)) .ne. vlen_type_name .or.
     &     base_type .ne. nf_int) stop 2

C     Read the vlen attribute.
      retval = nf_get_att(ncid, NF_GLOBAL, 'att1', vlen_in)
      if (retval .ne. nf_noerr) stop 1

C     Get the data from the vlen we just read.
      retval = nf_get_vlen_element(ncid, vlen_typeid, vlen_in, 
     &     vlen_len_in, data1_in)
      if (retval .ne. nf_noerr) stop 1
      if (vlen_len_in .ne. vlen_len) stop 2

C     Check the data
      do x = 1, vlen_len
         if (data1(x) .ne. data1_in(x)) stop 2
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 fill values with parallel I/O. It
!     writes a checkerboard decomposition for a number of variables,
!     but task 0 (of 4) does not write. The resulting data has fill
!     value for the first quarter of each array.

!     Ed Hartnett, started 2009, finished 2019.

program f90tst_parallel_fill
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel_fill.nc"
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: HALF_NX = NX / 2, HALF_NY = NY / 2
  integer, parameter :: QUARTER_NX = NX / 4, QUARTER_NY = NY / 4
  integer, parameter :: NUM_VARS = 8
  character (len = *), parameter :: var_name(NUM_VARS) = &
       (/ 'byte__', 'short_', 'int___', 'float_', 'double', 'ubyte_', 'ushort', 'uint__' /)
  integer :: ncid, varid(NUM_VARS), dimids(MAX_DIMS)
  integer :: var_type(NUM_VARS) = (/ nf90_byte, nf90_short, nf90_int, &
       nf90_float, nf90_double, nf90_ubyte, nf90_ushort, nf90_uint /)
  integer :: x_dimid, y_dimid
  integer :: byte_out(HALF_NY, HALF_NX), byte_in(HALF_NY, HALF_NX)
  integer :: short_out(HALF_NY, HALF_NX), short_in(HALF_NY, HALF_NX)
  integer :: int_out(HALF_NY, HALF_NX), int_in(HALF_NY, HALF_NX)
  real :: areal_out(HALF_NY, HALF_NX), areal_in(HALF_NY, HALF_NX)
  real :: double_out(HALF_NY, HALF_NX), double_in(HALF_NY, HALF_NX)
  integer :: ubyte_out(HALF_NY, HALF_NX), ubyte_in(HALF_NY, HALF_NX)
  integer :: ushort_out(HALF_NY, HALF_NX), ushort_in(HALF_NY, HALF_NX)
  integer (kind = EightByteInt) :: uint_out(HALF_NY, HALF_NX), uint_in(HALF_NY, HALF_NX)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y, v
  integer :: start_out(MAX_DIMS), count_out(MAX_DIMS)
  integer :: start_in(MAX_DIMS), count_in(MAX_DIMS)
  integer :: mode
  integer :: p, my_rank, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  if (my_rank .eq. 0) then
     print *, '*** Testing fill values with parallel I/O.'
  endif

  ! There must be 4 procs for this test.
  if (p .ne. 4) then
     print *, 'Sorry, this test program must be run on four processors.'
     stop 1
  endif

  ! Create some pretend data.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        byte_out(y, x) = -1
        short_out(y, x) =  -2
        int_out(y, x) = -4
        areal_out(y, x) = 2.5
        double_out(y, x) = -4.5
        ubyte_out(y, x) = 1
        ushort_out(y, x) = 2
        uint_out(y, x) = 4
     end do
  end do

  ! Create the netCDF file. nf90_mpiio flag not required starting with
  ! netcdf-c-4.6.1.
  mode = ior(nf90_netcdf4, nf90_mpiio)
  call check(nf90_create(FILE_NAME, mode, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variables.
  do v = 1, NUM_VARS
     call check(nf90_def_var(ncid, var_name(v), var_type(v), dimids, varid(v)))
     call check(nf90_var_par_access(ncid, varid(v), nf90_collective))
  end do

  ! This will be the last collective operation.
  call check(nf90_enddef(ncid))

  ! Determine what part of the variable will be written/read for this
  ! processor. It's a checkerboard decomposition. Only the third
  ! quadrant of data will be written, so each processor writes a
  ! quarter of the quadrant, or 1/16th of the total array. (And
  ! processor 0 doesn't write anyway.)
  count_out = (/ HALF_NX, HALF_NY /)
  if (my_rank .eq. 0) then
     start_out = (/ 1, 1 /)
     count_out = (/ 0, 0 /)
  else if (my_rank .eq. 1) then
     start_out = (/ HALF_NX + 1, 1 /)
  else if (my_rank .eq. 2) then
     start_out = (/ 1, HALF_NY + 1 /)
  else if (my_rank .eq. 3) then
     start_out = (/ HALF_NX + 1, HALF_NY + 1 /)
  endif
  ! print *, my_rank, start_out, count_out

  ! Write this processor's data, except for processor zero.
  call check(nf90_put_var(ncid, varid(1), byte_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(2), short_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(3), int_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(4), areal_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(5), double_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(6), ubyte_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(7), ushort_out, start = start_out, count = count_out))
  call check(nf90_put_var(ncid, varid(8), uint_out, start = start_out, count = count_out))

  ! Close the file.
  call check(nf90_close(ncid))

  ! Reopen the file. nf90_mpiio flag not required starting with
  ! netcdf-c-4.6.1.
  mode = ior(nf90_nowrite, nf90_mpiio)
  call check(nf90_open(FILE_NAME, mode, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= NUM_VARS .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4) stop 2

  ! Now each processor will read one quarter of the whole array.
  count_in = (/ HALF_NX, HALF_NY /)
  if (my_rank .eq. 0) then
     start_in = (/ 1, 1 /)
  else if (my_rank .eq. 1) then
     start_in = (/ HALF_NX + 1, 1 /)
  else if (my_rank .eq. 2) then
     start_in = (/ 1, HALF_NY + 1 /)
  else if (my_rank .eq. 3) then
     start_in = (/ HALF_NX + 1, HALF_NY + 1 /)
  endif

  ! Read this processor's data.
  call check(nf90_get_var(ncid, varid(1), byte_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(2), short_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(3), int_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(4), areal_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(5), double_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(6), ubyte_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(7), ushort_in, start = start_in, count = count_in))
  call check(nf90_get_var(ncid, varid(8), uint_in, start = start_in, count = count_in))

  ! Check the data. All the data from the processor zero are fill
  ! value.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        if (my_rank .ne. 0) then
           if (byte_in(y, x) .ne. -1) stop 13
           if (short_in(y, x) .ne. -2) stop 14
           if (int_in(y, x) .ne. -4) stop 15
           if (areal_in(y, x) .ne. 2.5) stop 16
           if (double_in(y, x) .ne. -4.5) stop 17
           if (ubyte_in(y, x) .ne. 1) stop 18
           if (ushort_in(y, x) .ne. 2) stop 19
           if (uint_in(y, x) .ne. 4) stop 20
        else
           if (byte_in(y, x) .ne. nf90_fill_byte) stop 3
           if (short_in(y, x) .ne. nf90_fill_short) stop 4
           if (int_in(y, x) .ne. nf90_fill_int) stop 5
           if (areal_in(y, x) .ne. nf90_fill_real) stop 6
           if (double_in(y, x) .ne. nf90_fill_double) stop 7
           if (ubyte_in(y, x) .ne. nf90_fill_ubyte) stop 8
           if (ushort_in(y, x) .ne. nf90_fill_ushort) stop 9
           if (uint_in(y, x) .ne. nf90_fill_uint) stop 10
        endif
     end do
  end do

! Close the file.
  call check(nf90_close(ncid))

  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 99
    endif
  end subroutine check
end program f90tst_parallel_fill

C     This is part of the netCDF package. Copyright 2006-2019 University
C     Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
C     for conditions of use.

C     Tests new nf_inq_path function
C     Mimics tests in C tst_files5.c code

C     Russ Rew, 2014

      program ftst_path
      implicit NONE
      include "netcdf.inc"

      character(len=*), parameter  :: FILE_NAME="ftst_path.nc"

      integer                      :: path_len, ncid
      character(LEN=NF_MAX_NAME+1) :: path_in

      path_in   = REPEAT(" ", LEN(path_in))
      path_len  = 0

      print *,''
      print *,'*** Testing netcdf file functions.'
      print *,'*** Checking the new inq_path function'

C Test with classic mode nf_create

      call check(nf_create(FILE_NAME, nf_classic_model, ncid))
      call check(nf_inq_path(ncid, path_len, path_in))

      if ((path_len /= LEN(FILE_NAME)) .OR.                             &
     &    (FILE_NAME /= TRIM(path_in)))                                 &
     &   call check(-1)
      call check(nf_close(ncid))

      path_in=REPEAT(" ", LEN(path_in))
      path_len=0

C Test with classic mode nf_open

      call check(nf_open(FILE_NAME, nf_classic_model, ncid))
      call check(nf_inq_path(ncid, path_len, path_in))

      if ((path_len /= LEN(FILE_NAME)) .OR.                             &
     &    (FILE_NAME /= TRIM(path_in)))                                 &
     &   call check(-1)
      call check(nf_close(ncid))

      path_in=REPEAT(" ", LEN(path_in))
      path_len=0


C Test with netcdf4 mode nf_create

      call check(nf_create(FILE_NAME, nf_netcdf4, ncid))
      call check(nf_inq_path(ncid, path_len, path_in))

      if ((path_len /= LEN(FILE_NAME)) .OR.                             &
     &    (FILE_NAME /= TRIM(path_in)))                                 &
     &  call check(-1)
      call check(nf_close(ncid))

      path_in=REPEAT(" ", LEN(path_in))
      path_len=0

C Test with netcdf4 mode nf_open

      call check(nf_open(FILE_NAME, nf_netcdf4, ncid))
      call check(nf_inq_path(ncid, path_len, path_in))

      if ((path_len /= LEN(FILE_NAME)) .OR.                             &
     &    (FILE_NAME /= TRIM(path_in)))                                 &
     &  call check(-1)
      call check(nf_close(ncid))

      path_in=REPEAT(" ", LEN(path_in))
      path_len=0

      print *,'*** SUCCESS! '

      contains
C       This subroutine handles errors by printing an error message and
C       exiting with a non-zero status.
      subroutine check(errcode)
        use netcdf
        implicit none
        integer, intent(in) :: errcode

        if(errcode /= nf_noerr) then
           print *, 'Error: ', trim(nf_strerror(errcode))
           stop 2
        endif
      end subroutine check

      end program ftst_path

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This example writes some surface pressure and temperatures. It is
! intended to illustrate the use of the netCDF fortran 90 API. The
! companion program sfc_pres_temp_rd.f90 shows how to read the netCDF
! data file created by this program.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: sfc_pres_temp_wr.f90,v 1.12 2010/04/06 19:32:09 ed Exp $

program sfc_pres_temp_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
  ! netCDF dimensions.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  integer :: lat_dimid, lon_dimid

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude netCDF variables which will hold the
  ! actual latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! We will write surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! It's good practice for each variable to carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! We will create some pressure and temperature data to write out.
  real, dimension(:,:), allocatable :: temp_out
  real, dimension(:,:), allocatable :: pres_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS))
  allocate(temp_out(NLONS, NLATS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  do lon = 1, NLONS
     do lat = 1, NLATS
        pres_out(lon, lat) = SAMPLE_PRESSURE + (lon - 1) * NLATS + (lat - 1)
        temp_out(lon, lat) = SAMPLE_TEMP + .25 * ((lon - 1) * NLATS + (lat - 1))
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, nf90_clobber, ncid) )

  ! Define the dimensions.
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )

  ! Define the coordinate variables. They will hold the coordinate
  ! information, that is, the latitudes and longitudes. A varid is
  ! returned for each.
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate var data. This attaches a
  ! text attribute to each of the coordinate variables, containing the
  ! units.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! Define the netCDF variables. The dimids array is used to pass the
  ! dimids of the dimensions of the netCDF variables.
  dimids = (/ lon_dimid, lat_dimid /)
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the pressure and temperature netCDF
  ! variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )

  ! End define mode.
  call check( nf90_enddef(ncid) )

  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays of data are the same size as
  ! the netCDF variables we have defined.
  call check( nf90_put_var(ncid, pres_varid, pres_out) )
  call check( nf90_put_var(ncid, temp_varid, temp_out) )

  ! Close the file.
  call check( nf90_close(ncid) )
   
  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS writing example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_wr

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example program which writes some 4D pressure and
! temperatures. It is intended to illustrate the use of the netCDF
! fortran 90 API. The companion program nc4_pres_temp_4D_rd.f shows how
! to read the netCDF data file created by this program.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: nc4_pres_temp_4D_wr.f90,v 1.10 2010/04/06 19:32:09 ed Exp $

program nc4_pres_temp_4D_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "nc4_pres_temp_4D.nc"
  integer :: ncid

  ! We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"
  integer :: lvl_dimid, lon_dimid, lat_dimid, rec_dimid

  ! The start and count arrays will tell the netCDF library where to
  ! write our data.
  integer :: start(NDIMS), count(NDIMS)

  ! These program variables hold the latitudes and longitudes.
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will create two netCDF variables, one each for temperature and
  ! pressure fields.
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will write out. We will only
  ! need enough space to hold one timestep of data; one record.
  real, dimension(:,:,:), allocatable :: pres_out
  real, dimension(:,:,:), allocatable :: temp_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to construct some latitude and longitude data for this
  ! example.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS, NLVLS))
  allocate(temp_out(NLONS, NLATS, NLVLS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  i = 0
  do lvl = 1, NLVLS
     do lat = 1, NLATS
        do lon = 1, NLONS
           pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
           temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
           i = i + 1
        end do
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, NF90_NETCDF4, ncid) )
  
  ! Define the dimensions. The record dimension is defined to have
  ! unlimited length - it can grow as needed. In this example it is
  ! the time dimension.
  call check( nf90_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid) )
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )
  call check( nf90_def_dim(ncid, REC_NAME, NF90_UNLIMITED, rec_dimid) )

  ! Define the coordinate variables. We will only define coordinate
  ! variables for lat and lon.  Ordinarily we would need to provide
  ! an array of dimension IDs for each variable's dimensions, but
  ! since coordinate variables only have one dimension, we can
  ! simply provide the address of that dimension ID (lat_dimid) and
  ! similarly for (lon_dimid).
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate variables.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! The dimids array is used to pass the dimids of the dimensions of
  ! the netCDF variables. Both of the netCDF variables we are creating
  ! share the same four dimensions. In Fortran, the unlimited
  ! dimension must come last on the list of dimids.
  dimids = (/ lon_dimid, lat_dimid, lvl_dimid, rec_dimid /)

  ! Define the netCDF variables for the pressure and temperature data.
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the netCDF variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )
  
  ! End define mode.
  call check( nf90_enddef(ncid) )
  
  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )
  
  ! These settings tell netcdf to write one timestep of data. (The
  ! setting of start(4) inside the loop below tells netCDF which
  ! timestep to write.)
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays only hold one timestep worth
  ! of data. We will just rewrite the same data for each timestep. In
  ! a real :: application, the data would change between timesteps.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_put_var(ncid, pres_varid, pres_out, start = start, &
                              count = count) )
     call check( nf90_put_var(ncid, temp_varid, temp_out, start = start, &
                              count = count) )
  end do
  
  ! Close the file. This causes netCDF to flush all buffers and make
  ! sure your data are really written to disk.
  call check( nf90_close(ncid) )
  
  print *,"*** SUCCESS writing example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program nc4_pres_temp_4D_wr

! Copyright 2007, UCAR/Unidata. See netcdf/COPYRIGHT file for copying
! and redistribution conditions.

! This program tests large files (> 4 GB) in netCDF-4. 

! Russ Rew, 2007
program f90tst_flarge
  use typeSizes
  use netcdf
  implicit none

  integer :: ncFileID, dimID, varID1, varID2 
  integer, parameter :: BIG_DIMENSION = 300000000
  character (len = *), parameter :: fileName = "f90tst_flarge.nc"
  character (len = *), parameter :: dimName = "really_big_dimension"
  character (len = *), parameter :: var1Name = "TweedleDum"
  character (len = *), parameter :: var2Name = "TweedleDee"
  double precision, parameter :: VAL1 = 42.5
  double precision, parameter :: VAL2 = -42.5
  double precision :: val1_in
  double precision :: val2_in

  print *,'*** Testing netCDF-4 large files from Fortran 90 API.'

  ! Create the file with 2 NF_DOUBLE vars, each with one really long dimension.
  call check(nf90_create(trim(fileName), nf90_netcdf4, ncFileID))
  call check(nf90_def_dim(ncFileID, dimName, BIG_DIMENSION, dimID))
  call check(nf90_def_var(ncFileID, var1Name, nf90_double, (/ dimID /), varID1) )
  call check(nf90_def_var(ncFileID, var2Name, nf90_double, (/ dimID /), varID2) )

!   ! Write a value in each variable.
  call check(nf90_put_var(ncFileID, VarID1, (/ 42.5 /), &
       start = (/ 1 /), count = (/ 1 /)) )
  call check(nf90_put_var(ncFileID, VarID2, (/ -42.5 /), &
       start = (/ BIG_DIMENSION /), count = (/ 1 /)) )

  call check(nf90_close(ncFileID))

  ! Now open the file to read and check a few values
  call check(nf90_open(trim(fileName), NF90_NOWRITE, ncFileID))
  call check(nf90_get_var(ncFileID, VarID1, val1_in, start = (/ 1 /)) )
  call check(nf90_get_var(ncFileID, VarID2, val2_in, start = (/ BIG_DIMENSION /)) )
  if(val1_in /= VAL1 .or. val2_in /= VAL2) then
     print *, 'Variable value not what was written'
     stop 2
  end if

  call check(nf90_close(ncFileID))
  OPEN (UNIT=5, FILE=fileName, STATUS="OLD")
  CLOSE (UNIT=5, STATUS="DELETE")
  print *,'*** SUCCESS!'

contains
  ! Internal subroutine - checks error status after each netcdf, prints out text message each time
  !   an error code is returned. 
  subroutine check(status)
    integer, intent ( in) :: status

    if(status /= nf90_noerr) then 
       print *, trim(nf90_strerror(status))
       stop 2
    end if
  end subroutine check
end program f90tst_flarge

C     This is part of the netCDF package.
C     Copyright 2020 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 szip compression. This test is only
C     run if nc_def_var_szip() is found in netcdf-c, and also the HDF5
C     instance upon which the netcdf-c depends was built with szip.

C     Ed Hartnett, 1/31/20

      program ftst_var_szip
      USE netcdf4_f03
      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_var_szip.nc')
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer check_file

      integer ncid, varid(NVARS), dimids(NDIMS)
      integer data_len_in, offset
      parameter (offset = 20)
      integer data1(DATA_LEN), data1_in(DATA_LEN)
      character*(4) var_name(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer NO_FILL, MY_FILL_VALUE
      parameter (NO_FILL = 1)
      parameter (MY_FILL_VALUE = 42)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing szip compression.'

C     Prepare some data to write.
      do x = 1, DATA_LEN
         data1(x) = x
      end do

C     Set up var names.
      var_name(1) = 'var1'
      var_name(2) = 'var2'
      var_name(3) = 'var3'

C      retval = nf_set_log_level(3)

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create a few integer variables.
      do x = 1, NVARS      
         retval = nf_def_var(ncid, var_name(x), NF_INT, NDIMS, dimids,
     $        varid(x))
         if (retval .ne. nf_noerr) stop 1
      end do

C     Set an alternative fill value for the third variable.
      retval = nf_def_var_fill(ncid, varid(3), 0, MY_FILL_VALUE)
      if (retval .ne. 0) stop 3

C     Turn on szip compression for var 1.
      retval = nf_def_var_szip(ncid, varid(1),
     $     nf_szip_ec_option_mask, 4)
      if (retval .ne. 0) stop 3

C     Turn on szip compression for var 3.
      retval = nf_def_var_szip(ncid, varid(3),
     $     nf_szip_nn_option_mask, 4)
      if (retval .ne. 0) stop 3

C     Write some data.
      retval = nf_put_var_int(ncid, varid(1), data1)
      if (retval .ne. nf_noerr) stop 1

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Check it out. 
      retval = check_file(ncid, var_name, dim_name)
      if (retval .ne. 0) stop 4

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, dim_name)
      USE netcdf4_f03
      implicit none

C     I need these in both here and the main program.
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer MY_FILL_VALUE
      parameter (MY_FILL_VALUE = 42)

C     Parameters
      integer ncid
      character*(4) var_name(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer xtype_in, dimids_in(NDIMS), natts_in
      integer varid_in(NVARS), dimid_in, no_fill_in, fill_value_in
      character*(4) var_name_in
      integer int_data_in(DIM_LEN)
      integer options_mask_in, pixels_per_block_in

      integer x, retval

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 5

C     Get the varids and the dimid.
      do x = 1, NVARS      
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 1
         if (varid_in(x) .ne. x) stop 6
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (dimid_in .ne. 1) stop 7

C     Get the data in var1. It will be values we have set.
      retval = nf_get_var_int(ncid, varid_in(1), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. x) stop 13
      end do

C     Get the szip settings for var1. H5Zszip code will sometimes bump
C     the bits_per_pixel from 32 to 64 and may add other flags to the
C     options_mask, so we don't check these values in this test.
      retval = nf_inq_var_szip(ncid, varid_in(1), options_mask_in,
     $     pixels_per_block_in)

C     Get the data in var2. It will be default fill value.
      retval = nf_get_var_int(ncid, varid_in(2), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. NF_FILL_INT) stop 13
      end do

C     Get the data in var3. It will be all the assigned fill value.
      retval = nf_get_var_int(ncid, varid_in(3), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. MY_FILL_VALUE) stop 14
      end do

      check_file = 0
      end 

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing enum and opaque types.

C     Ed Hartnett, 2009

      program ftst_vars3
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars3.nc')

C     We are writing an attribute, of length 3.
      integer NDIMS
      parameter (NDIMS = 1)
      integer NX
      parameter (NX = 3)

C     NetCDF IDs.
      integer ncid, varid, dimids(1)
      integer enum_typeid, opaque_typeid

C     This is the data array we will write as an enum attribute, and a
C     place to store it when we read it back in. Z is the fastest
C     varying dimension.
      integer data_out(NX), data_in(NX)

      integer max_types
      parameter (max_types = 2)

C     Need these to read type information.
      integer num_types, typeids(max_types)
      integer base_type, base_size, num_members, member_value
      character*80 type_name, member_name
      integer type_size, nfields, class

C     Information for the enum type we will define.
      character*(*) enum_type_name, one_name, zero_name
      parameter (enum_type_name = 'enum_type')
      parameter (zero_name = 'zero', one_name = 'one')
      integer one, zero

C     Information for the opaque type we will define.
      character*(*) opaque_type_name
      parameter (opaque_type_name = 'opaque_type')
      integer opaque_size
      parameter (opaque_size = 16)
      character*(opaque_size) opaque_data, opaque_data_in
      parameter (opaque_data = '0123456789012345')

C     Loop indexes, and error handling.
      integer x, retval, index(1)

C     Create some pretend data.
      do x = 1, NX
         data_out(x) = 0
      end do
      data_out(1) = 1

      print *, ''
      print *,'*** Testing enum and opaque types.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create the enum type.
      retval = nf_def_enum(ncid, NF_INT, enum_type_name, enum_typeid)
      if (retval .ne. nf_noerr) stop 1
      one = 1
      zero = 0
      retval = nf_insert_enum(ncid, enum_typeid, zero_name, zero)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_insert_enum(ncid, enum_typeid, one_name, one)
      if (retval .ne. nf_noerr) stop 1

C     Create the opaque type.
      retval = nf_def_opaque(ncid, opaque_size, opaque_type_name, 
     &     opaque_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, 'dim', 1, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create an opaque variable.
      retval = nf_def_var(ncid, 'var', opaque_typeid, 1, dimids, varid)
      if (retval .ne. nf_noerr) stop 1

C     Write the opaque scalar var. (Could also use nf_put_var).
      index(1) = 1
      retval = nf_put_var1(ncid, varid, index, opaque_data)
      if (retval .ne. nf_noerr) stop 1

C     Attach an enum attribute to the variable.
      retval = nf_put_att(ncid, varid, 'att', enum_typeid, NX, 
     &     data_out)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Get the typeids of all user defined types.
      retval = nf_inq_typeids(ncid, num_types, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (num_types .ne. max_types) stop 2

C     Use nf_inq_user_type to confirm this is an enum type.
      retval = nf_inq_user_type(ncid, typeids(1), type_name, type_size, 
     &     base_type, nfields, class)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(enum_type_name)) .ne. enum_type_name .or.
     &     type_size .ne. 4 .or. base_type .ne. NF_INT .or. 
     &     nfields .ne. 2 .or. class .ne. nf_enum) stop 2

C     Use nf_inq_enum and make sure we get the same answers as we did
C     with nf_inq_user_type.
      retval = nf_inq_enum(ncid, typeids(1), type_name, base_type, 
     &     base_size, num_members)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(enum_type_name)) .ne. enum_type_name .or.
     &     base_type .ne. NF_INT .or. num_members .ne. 2) stop 2

C     Check the members of the enum type.
      retval = nf_inq_enum_member(ncid, typeids(1), 1, member_name, 
     &     member_value)
      if (retval .ne. nf_noerr) stop 1
      if (member_name(1:len(zero_name)) .ne. zero_name .or.
     &     member_value .ne. 0) stop 2
      retval = nf_inq_enum_member(ncid, typeids(1), 2, member_name, 
     &     member_value)
      if (retval .ne. nf_noerr) stop 1
      if (member_name(1:len(one_name)) .ne. one_name .or.
     &     member_value .ne. 1) stop 2
      retval = nf_inq_enum_ident(ncid, typeids(1), 0, member_name)
      if (retval .ne. nf_noerr) stop 1
      if (member_name(1:len(zero_name)) .ne. zero_name) stop 2
      retval = nf_inq_enum_ident(ncid, typeids(1), 1, member_name)
      if (retval .ne. nf_noerr) stop 1
      if (member_name(1:len(one_name)) .ne. one_name) stop 2

C     Use nf_inq_user_type to confirm that the second typeid is an
C     opaque type.
      retval = nf_inq_user_type(ncid, typeids(2), type_name, type_size, 
     &     base_type, nfields, class)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(opaque_type_name)) .ne. opaque_type_name .or.
     &     type_size .ne. opaque_size .or. base_type .ne. 0 .or. 
     &     nfields .ne. 0 .or. class .ne. nf_opaque) stop 2

C     Use nf_inq_opaque and make sure we get the same answers as we did
C     with nf_inq_user_type.
      retval = nf_inq_opaque(ncid, typeids(2), type_name, base_size)
      if (retval .ne. nf_noerr) stop 1
      if (base_size .ne. opaque_size .or. 
     &     type_name(1:len(opaque_type_name)) .ne. opaque_type_name) 
     &     stop 2

C     Read the variable.
      index(1) = 1
      retval = nf_get_var1(ncid, varid, index, opaque_data_in)
      if (retval .ne. nf_noerr) stop 1
      if (opaque_data_in .ne. opaque_data) stop 2

C     Read the attribute.
      retval = nf_get_att(ncid, varid, 'att', data_in)
      if (retval .ne. nf_noerr) stop 1

C     Check the values.
      do x = 1, NX
         if (data_in(x) .ne. data_out(x)) stop 2
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of netCDF, Copyright 2006, UCAR

C     This test program uses the fortran 77 v2 API to create a simple
C     data file with some phony data in it. This program was originally
C     based on one contributed by Jeremy Kepner,
C     jvkepner@astro.Princeton.EDU.

C     Also test the char array bug reported in
C     https://github.com/Unidata/netcdf-fortran/issues/329.

C     This program will bail out in the event of a netcdf error.

C     Ed Hartnett, 2009

C     MODS
C     Leon Benjamin, 2022 -- Add test multi-dimensional char variables

      PROGRAM tst_f77_v2
      USE tests
      implicit none

      INTEGER n_dim, x_dim, y_dim, z_dim
      PARAMETER(n_dim = 3, x_dim = 20, y_dim = 10, z_dim = 5)
      INTEGER dim_array(n_dim)
      INTEGER start(n_dim), count(n_dim)
      integer char_len
      parameter(char_len = 14)
      character*14 char_string(2)
      INTEGER start_1d(2), count_1d(2)      
      INTEGER ncid, errcode
      INTEGER x_id, y_id, z_id, arr_id, char_id, char_dim_id
      REAL array(x_dim,y_dim,z_dim)
      INTEGER i,j,k

      character*10 char_dim_name_in
      integer char_dim_size_in
      character*11 char_var_name_in
      integer var_type_in, nvdims_in
      integer vdims_in(3)
      integer natts_in
      character*14 char_string_in(2)
      integer char_len_in
      char_len_in = 14

C     Put something into the array.
      DO i=1,x_dim
         DO j=1,y_dim
            DO k=1,z_dim
               array(i,j,k) = (i-1) + x_dim*(j-1) + x_dim*y_dim*(k-1)
            ENDDO
         ENDDO
      ENDDO

C     Put something into the character string.      
      char_string(1) = 'dirty_old_town'
      char_string(2) = 'clean_new_town'

      print *, ''
      print *, ' *** Testing netCDF v2 api for F77.'

C     Create file.
      ncid = NCCRE('tst03_f77_v2.nc', NCCLOB, errcode)
      if (errcode .ne. 0) stop 2

C     Create Dimensions for floating point data.
      x_id = NCDDEF(ncid, 'X', x_dim, errcode)
      y_id = NCDDEF(ncid, 'Y', y_dim, errcode)
      z_id = NCDDEF(ncid, 'Z', z_dim, errcode)

C     Assign dimensions to array.
      dim_array(1) = z_id
      dim_array(2) = y_id
      dim_array(3) = x_id

C     Create a float variable.
      arr_id = NCVDEF(ncid, 'array', NCFLOAT, n_dim, dim_array, errcode)
      if (errcode .ne. 0) stop 2

C     Create Dimension for char array.
      char_dim_id = NCDDEF(ncid, 'string_len', char_len, errcode)
      if (errcode .ne. 0) stop 2
      dim_array(1) = char_dim_id
C     Create Dimension for char array.
      dim_array(2) = NCDDEF(ncid, 'list_size', 2, errcode)
      if (errcode .ne. 0) stop 2

      char_id = NCVDEF(ncid, 'Dublin_song', NCCHAR, 2, dim_array,
     &     errcode)
      if (errcode .ne. 0) stop 2
      
C     Leave define mode.
      CALL NCENDF(ncid, errcode)
      if (errcode .ne. 0) stop 2

C     Write float data to file.
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = z_dim
      count(2) = y_dim
      count(3) = x_dim
      CALL NCVPT(ncid, arr_id, start, count, array, errcode)
      if (errcode .ne. 0) stop 2

C     Write char data to file.
      start_1d(1) = 1
      count_1d(1) = char_len
      start_1d(2) = 1
      count_1d(2) = 2
      CALL NCVPTC(ncid, char_id, start_1d, count_1d, char_string,
     &     char_len*2, errcode)
      if (errcode .ne. 0) stop 2

C     Close the file.
      CALL NCCLOS(ncid, errcode)
      if (errcode .ne. 0) stop 2

C     Reopen the file.
      ncid = NCOPN('tst03_f77_v2.nc', NCNOWRIT, errcode)
      if (errcode .ne. 0) stop 2

      
C     Learn about char array dimension.
      call NCDINQ(NCID, 4, char_dim_name_in, char_dim_size_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_dim_size_in .ne. char_len) stop 3
      if (char_dim_name_in .ne. 'string_len') stop 4

C     Learn about the char array data.
      call NCVINQ(NCID, 2, char_var_name_in, var_type_in, nvdims_in,
     &     vdims_in, natts_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_var_name_in .ne. 'Dublin_song') stop 5
      if (var_type_in .ne. NCCHAR) stop 6
      if (nvdims_in .ne. 2) stop 7
      if (vdims_in(1) .ne. 4) stop 8
      if (natts_in .ne. 0) stop 9

C     Read the data in the char array.
      start_1d(1) = 1
      count_1d(1) = char_len
      start_1d(2) = 1
      count_1d(2) = 2
      char_len_in = char_len*2
      CALL NCVGTC(ncid, char_id, start_1d, count_1d, char_string_in,
     &     char_len_in, errcode)
      if (errcode .ne. 0) stop 2
      if (char_string_in(1) .ne. 'dirty_old_town') stop 10
      if (char_string_in(2) .ne. 'clean_new_town') stop 11
      
C     Close the file.
      CALL NCCLOS(ncid, errcode)
      if (errcode .ne. 0) stop 2

      print *, ' *** SUCCESS!'

      END

program EightBytIntTest
   use typeSizes
   implicit none

   integer (kind = EightByteInt) :: Eight
   integer                       :: defaultInt

   print *, "Bit size of default int is",         bit_size(defaultInt)
   print *, "Kind parameter for EightByteInt is", EightByteInt
   print *, "Bit size of eight byte int is",      bit_size(Eight)
end program EightBytIntTest

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some 4D pressure and
C     temperatures. The data file read by this program is produced by
C     the companion program pres_temp_4D_wr.f. It is intended to
C     illustrate the use of the netCDF Fortran 77 API.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: pres_temp_4D_rd.f,v 1.12 2007/02/14 20:59:20 ed Exp $

      program pres_temp_4D_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='pres_temp_4D.nc')
      integer ncid

C     We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')
      integer lvl_dimid, lon_dimid, lat_dimid, rec_dimid

C     The start and count arrays will tell the netCDF library where to
C     read our data.
      integer start(NDIMS), count(NDIMS)

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude variables which will hold the actual
C     latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will read surface temperature and pressure fields. In netCDF
C     terminology these are called "variables."
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will read in. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_in(NLONS, NLATS, NLVLS)
      real temp_in(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to calculate the values we expect to find.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read 1 record of NLONS*NLATS*NLVLS values, starting at the
C     beginning of the record (the (1, 1, 1, rec) element in the netCDF
C     file).
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Read the surface pressure and temperature data from the file, one
C     record at a time.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_get_vara_real(ncid, pres_varid, start, count,
     $        pres_in)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_get_vara_real(ncid, temp_varid, start, count,
     $        temp_in)
         if (retval .ne. nf_noerr) call handle_err(retval)

         i = 0
         do lvl = 1, NLVLS
            do lat = 1, NLATS
               do lon = 1, NLONS
                  if (pres_in(lon, lat, lvl) .ne. SAMPLE_PRESSURE + i) 
     $                 stop 2
                  if (temp_in(lon, lat, lvl) .ne. SAMPLE_TEMP + i)
     $                 stop 2
                  i = i + 1
               end do
            end do
         end do
C     next record
      end do
         
C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file pres_temp_4D.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This example writes some surface pressure and temperatures. It is
! intended to illustrate the use of the netCDF fortran 90 API. The
! companion program sfc_pres_temp_rd.f90 shows how to read the netCDF
! data file created by this program.

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program sfc_pres_temp_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "sfc_pres_temp.nc"
  integer :: ncid

  ! We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
  ! netCDF dimensions.
  integer, parameter :: NDIMS = 2
  integer, parameter :: NLATS = 6, NLONS = 12
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  integer :: lat_dimid, lon_dimid

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude netCDF variables which will hold the
  ! actual latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lat_varid, lon_varid
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! We will write surface temperature and pressure fields. 
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! It's good practice for each variable to carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! We will create some pressure and temperature data to write out.
  real, dimension(:,:), allocatable :: temp_out
  real, dimension(:,:), allocatable :: pres_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Loop indices
  integer :: lat, lon

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS))
  allocate(temp_out(NLONS, NLATS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  do lon = 1, NLONS
     do lat = 1, NLATS
        pres_out(lon, lat) = SAMPLE_PRESSURE + (lon - 1) * NLATS + (lat - 1)
        temp_out(lon, lat) = SAMPLE_TEMP + .25 * ((lon - 1) * NLATS + (lat - 1))
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, nf90_clobber, ncid) )

  ! Define the dimensions.
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )

  ! Define the coordinate variables. They will hold the coordinate
  ! information, that is, the latitudes and longitudes. A varid is
  ! returned for each.
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate var data. This attaches a
  ! text attribute to each of the coordinate variables, containing the
  ! units.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! Define the netCDF variables. The dimids array is used to pass the
  ! dimids of the dimensions of the netCDF variables.
  dimids = (/ lon_dimid, lat_dimid /)
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the pressure and temperature netCDF
  ! variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )

  ! End define mode.
  call check( nf90_enddef(ncid) )

  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays of data are the same size as
  ! the netCDF variables we have defined.
  call check( nf90_put_var(ncid, pres_varid, pres_out) )
  call check( nf90_put_var(ncid, temp_varid, temp_out) )

  ! Close the file.
  call check( nf90_close(ncid) )
   
  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS writing example file sfc_pres_temp.nc!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program sfc_pres_temp_wr

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example program which writes some 4D pressure and
! temperatures. It is intended to illustrate the use of the netCDF
! fortran 90 API. The companion program nc4_pres_temp_4D_rd.f shows how
! to read the netCDF data file created by this program.

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program nc4_pres_temp_4D_wr
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "nc4_pres_temp_4D.nc"
  integer :: ncid

  ! We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"
  integer :: lvl_dimid, lon_dimid, lat_dimid, rec_dimid

  ! The start and count arrays will tell the netCDF library where to
  ! write our data.
  integer :: start(NDIMS), count(NDIMS)

  ! These program variables hold the latitudes and longitudes.
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will create two netCDF variables, one each for temperature and
  ! pressure fields.
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid
  integer :: dimids(NDIMS)

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa"
  character (len = *), parameter :: TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will write out. We will only
  ! need enough space to hold one timestep of data; one record.
  real, dimension(:,:,:), allocatable :: pres_out
  real, dimension(:,:,:), allocatable :: temp_out
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to construct some latitude and longitude data for this
  ! example.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_out(NLONS, NLATS, NLVLS))
  allocate(temp_out(NLONS, NLATS, NLVLS))

  ! Create pretend data. If this were not an example program, we would
  ! have some real data to write, for example, model output.
  do lat = 1, NLATS
     lats(lat) = START_LAT + (lat - 1) * 5.0
  end do
  do lon = 1, NLONS
     lons(lon) = START_LON + (lon - 1) * 5.0
  end do
  i = 0
  do lvl = 1, NLVLS
     do lat = 1, NLATS
        do lon = 1, NLONS
           pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
           temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
           i = i + 1
        end do
     end do
  end do

  ! Create the file. 
  call check( nf90_create(FILE_NAME, nf90_netcdf4, ncid) )
  
  ! Define the dimensions. The record dimension is defined to have
  ! unlimited length - it can grow as needed. In this example it is
  ! the time dimension.
  call check( nf90_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid) )
  call check( nf90_def_dim(ncid, LAT_NAME, NLATS, lat_dimid) )
  call check( nf90_def_dim(ncid, LON_NAME, NLONS, lon_dimid) )
  call check( nf90_def_dim(ncid, REC_NAME, NF90_UNLIMITED, rec_dimid) )

  ! Define the coordinate variables. We will only define coordinate
  ! variables for lat and lon.  Ordinarily we would need to provide
  ! an array of dimension IDs for each variable's dimensions, but
  ! since coordinate variables only have one dimension, we can
  ! simply provide the address of that dimension ID (lat_dimid) and
  ! similarly for (lon_dimid).
  call check( nf90_def_var(ncid, LAT_NAME, NF90_REAL, lat_dimid, lat_varid) )
  call check( nf90_def_var(ncid, LON_NAME, NF90_REAL, lon_dimid, lon_varid) )

  ! Assign units attributes to coordinate variables.
  call check( nf90_put_att(ncid, lat_varid, UNITS, LAT_UNITS) )
  call check( nf90_put_att(ncid, lon_varid, UNITS, LON_UNITS) )

  ! The dimids array is used to pass the dimids of the dimensions of
  ! the netCDF variables. Both of the netCDF variables we are creating
  ! share the same four dimensions. In Fortran, the unlimited
  ! dimension must come last on the list of dimids.
  dimids = (/ lon_dimid, lat_dimid, lvl_dimid, rec_dimid /)

  ! Define the netCDF variables for the pressure and temperature data.
  call check( nf90_def_var(ncid, PRES_NAME, NF90_REAL, dimids, pres_varid) )
  call check( nf90_def_var(ncid, TEMP_NAME, NF90_REAL, dimids, temp_varid) )

  ! Assign units attributes to the netCDF variables.
  call check( nf90_put_att(ncid, pres_varid, UNITS, PRES_UNITS) )
  call check( nf90_put_att(ncid, temp_varid, UNITS, TEMP_UNITS) )
  
  ! End define mode.
  call check( nf90_enddef(ncid) )
  
  ! Write the coordinate variable data. This will put the latitudes
  ! and longitudes of our data grid into the netCDF file.
  call check( nf90_put_var(ncid, lat_varid, lats) )
  call check( nf90_put_var(ncid, lon_varid, lons) )
  
  ! These settings tell netcdf to write one timestep of data. (The
  ! setting of start(4) inside the loop below tells netCDF which
  ! timestep to write.)
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Write the pretend data. This will write our surface pressure and
  ! surface temperature data. The arrays only hold one timestep worth
  ! of data. We will just rewrite the same data for each timestep. In
  ! a real :: application, the data would change between timesteps.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_put_var(ncid, pres_varid, pres_out, start = start, &
                              count = count) )
     call check( nf90_put_var(ncid, temp_varid, temp_out, start = start, &
                              count = count) )
  end do
  
  ! Close the file. This causes netCDF to flush all buffers and make
  ! sure your data are really written to disk.
  call check( nf90_close(ncid) )
  
  print *,"*** SUCCESS writing example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program nc4_pres_temp_4D_wr

C     This is part of the netCDF package.
C     Copyright 2020 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 compact variables. This is an
C     alternative to chunked or contiguous storage, which stores the
C     data in the HDF5 metadata. It is only allowed for small (64 KB or
C     less) vars with fixed dimensions.

C     Ed Hartnett, 2/24/20

      program ftst_var_compact
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_var_compact.nc')
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer check_file

      integer ncid, varid(NVARS), dimids(NDIMS)
      integer offset
      parameter (offset = 20)
      integer data1(DATA_LEN)
      character*(4) var_name(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer NO_FILL, MY_FILL_VALUE
      parameter (NO_FILL = 1)
      parameter (MY_FILL_VALUE = 42)
      integer storage_in
      integer chunksizes_in(NDIMS)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing compact vars.'

C     Prepare some data to write.
      do x = 1, DATA_LEN
         data1(x) = x
      end do

C     Set up var names.
      var_name(1) = 'var1'
      var_name(2) = 'var2'
      var_name(3) = 'var3'

C      retval = nf_set_log_level(3)

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create a few integer variables.
      do x = 1, NVARS      
         retval = nf_def_var(ncid, var_name(x), NF_INT, NDIMS, dimids,
     $        varid(x))
         if (retval .ne. nf_noerr) stop 1
      end do

C     Turn on compact storage for the first var.
      retval = nf_def_var_chunking(ncid, varid(1), nf_compact, 0)
      if (retval .ne. 0) stop 3

C     Check compact storage for the first var.
      retval = nf_inq_var_chunking(ncid, varid(1), storage_in,
     $     chunksizes_in)
      if (retval .ne. 0) stop 3
      if (storage_in .ne. nf_compact) stop 4

C     Set an alternative fill value for the third variable.
      retval = nf_def_var_fill(ncid, varid(3), 0, MY_FILL_VALUE)
      if (retval .ne. 0) stop 3

C     Write some data.
      retval = nf_put_var_int(ncid, varid(1), data1)
      if (retval .ne. nf_noerr) stop 1

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Check it out. 
      retval = check_file(ncid, var_name, dim_name)
      if (retval .ne. 0) stop 4

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, dim_name)
      implicit none
      include 'netcdf.inc'

C     I need these in both here and the main program.
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer MY_FILL_VALUE
      parameter (MY_FILL_VALUE = 42)

C     Parameters
      integer ncid
      character*(4) var_name(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer varid_in(NVARS), dimid_in
      integer int_data_in(DIM_LEN)
C      integer chunksizes_in(NDIMS)

      integer x, retval

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 5

C     Get the varids and the dimid.
      do x = 1, NVARS      
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 1
         if (varid_in(x) .ne. x) stop 6
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (dimid_in .ne. 1) stop 7

C     Check compact storage for the first var.
c$$$      retval = nf_inq_var_chunking(ncid, varid_in(1), storage_in,
c$$$     $     chunksizes_in)
c$$$      if (retval .ne. 0) stop 3
c$$$      if (storage_in .ne. nf_compact) stop 4

C     Get the data in var1. It will be values we have set.
      retval = nf_get_var_int(ncid, varid_in(1), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. x) stop 13
      end do

C     Get the data in var2. It will be default fill value.
      retval = nf_get_var_int(ncid, varid_in(2), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. NF_FILL_INT) stop 13
      end do

C     Get the data in var3. It will be all the assigned fill value.
      retval = nf_get_var_int(ncid, varid_in(3), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. MY_FILL_VALUE) stop 14
      end do

      check_file = 0
      end 

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing new netCDF-4 atomic types.

C     Ed Hartnett, 2010

      program ftst_vars2
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars2.nc')

C     We are writing 3D data, a 3 x 5 x 2 grid. Why do I use "x, y, z,"
C     and then do everything in order "z, y, x?" Because I am a C
C     programmer, and everything in Fortran seems backwards!
      integer NDIMS, NTYPES
      parameter (NDIMS = 3, NTYPES = 5)
      integer NX, NY, NZ
      parameter (NX = 3, NY = 5, NZ = 2)

C     These will be used to set the per-variable chunk cache.
      integer CACHE_SIZE, CACHE_NELEMS, CACHE_PREEMPTION
      parameter (CACHE_SIZE = 8, CACHE_NELEMS = 571)
      parameter (CACHE_PREEMPTION = 42)

C     These will be used to check the setting of the per-variable chunk
C     cache.
      integer cache_size_in, cache_nelems_in, cache_preemption_in

C     NetCDF IDs.
      integer ncid, varid(NTYPES), dimids(NDIMS), typeid(NTYPES)

C     Name of the variable is stored here.
      character*80 var_name

C     This is the data array we will write, and a place to store it when
C     we read it back in. Z is the fastest varying dimension.
      integer data_out(NZ, NY, NX), data_in(NZ, NY, NX)

C     Loop indexes, and error handling.
      integer i, x, y, z, retval

C     Create some pretend data.
      do x = 1, NX
         do y = 1, NY
            do z = 1, NZ
               data_out(z, y, x) = (x-1) * NY * NZ + (y-1) * NZ + (z-1)
            end do
         end do
      end do

      print *, ''
      print *,'*** Testing netCDF-4 vars from F77 with new types.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define the dimensions.
      retval = nf_def_dim(ncid, "z", NZ, dimids(3))
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "y", NY, dimids(2))
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "x", NX, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     These are the types of vars that will be written.
      typeid(1) = NF_UBYTE
      typeid(2) = NF_USHORT
      typeid(3) = NF_UINT
      typeid(4) = NF_INT64
      typeid(5) = NF_UINT64

C     Define the variables. 
      do i = 1, NTYPES
         write(var_name, 1001) i
 1001    format('var', I1)
         retval = nf_def_var(ncid, var_name, typeid(i), NDIMS, 
     &        dimids, varid(i))
         if (retval .ne. nf_noerr) stop 1

C        Set variable caches.
         retval = nf_set_var_chunk_cache(ncid, varid(i), CACHE_SIZE, 
     &        CACHE_NELEMS, CACHE_PREEMPTION)
         if (retval .ne. nf_noerr) stop 1
      end do

C     Check the per-variable cache to make sure it is what we think it
C     is.
      do i = 1, NTYPES
         retval = nf_get_var_chunk_cache(ncid, varid(i), cache_size_in, 
     &        cache_nelems_in, cache_preemption_in)
         if (retval .ne. nf_noerr) stop 1
         if (cache_size_in .ne. CACHE_SIZE .or. cache_nelems_in .ne. 
     &        CACHE_NELEMS .or. cache_preemption .ne. CACHE_PREEMPTION)
     &        stop 8
         
      end do

C     Write the pretend data to the file.
      do i = 1, NTYPES
         retval = nf_put_var_int(ncid, varid(i), data_out)
         if (retval .ne. nf_noerr) stop 1
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Read the data and check it.
      do i = 1, NTYPES
         retval = nf_get_var_int(ncid, varid(i), data_in)
         if (retval .ne. nf_noerr) stop 1
         do x = 1, NX
            do y = 1, NY
               do z = 1, NZ
                  if (data_in(z, y, x) .ne. data_out(z, y, x)) stop 2
               end do
            end do
         end do
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     Modified version of f90tst_grps to add test for rename_grps.

!     Russ Rew, 2014

program f90tst_rengrps
  use typeSizes
  use netcdf
  implicit none

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_rengrps.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 6, NY = 12
  integer :: chunksizes(MAX_DIMS)
  integer, parameter :: CACHE_NELEMS = 10000, CACHE_SIZE = 1000000
  integer, parameter :: DEFLATE_LEVEL = 4
  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid1, varid2, dimids(MAX_DIMS)
  integer :: x_dimid, y_dimid
  character (len = *), parameter :: VAR1_NAME = "VarName1"
  character (len = *), parameter :: VAR2_NAME = "VarName2"
  character (len = *), parameter :: GRP1_NAME = "Old_Grp1_name"
  character (len = *), parameter :: GRP2_NAME = "Old_Grp2_name"
  character (len = *), parameter :: NEW_GRP1_NAME = "new_Grp1_name"
  character (len = *), parameter :: NEW_GRP2_NAME = "new_Grp2_name"

  character (len = NF90_MAX_NAME) :: grp1_full_name
  integer :: ilen

  ! Information read back from the file to check correctness.
  integer :: grpid1, grpid2
  integer :: deflate_level_in, endianness_in
  logical :: shuffle_in, fletcher32_in
  integer :: xtype_in, ndims_in, natts_in, dimids_in(MAX_DIMS)
  character (len = nf90_max_name) :: name_in
  integer :: chunksizes_in(MAX_DIMS)

  print *, ''
  print *,'*** Testing netCDF-4 rename groups from Fortran 90.'

  ! Create the netCDF file. 
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define some nested groups.
  call check(nf90_def_grp(ncid, GRP1_NAME, grpid1))
  call check(nf90_def_grp(grpid1, GRP2_NAME, grpid2))

  ! Define some variables. 
  chunksizes = (/ NY, NX /)
  call check(nf90_def_var(ncid, VAR1_NAME, NF90_INT, dimids, varid1, chunksizes = chunksizes, &
       shuffle = .TRUE., fletcher32 = .TRUE., endianness = nf90_endian_big, deflate_level = DEFLATE_LEVEL))
  call check(nf90_def_var(grpid1, VAR2_NAME, NF90_INT, dimids, varid2, contiguous = .TRUE.))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the file.
  call check(nf90_open(FILE_NAME, nf90_write, ncid))
  
  ! Get the group ids for the newly reopened file.
  call check(nf90_inq_grp_ncid(ncid, GRP1_NAME, grpid1))
  call check(nf90_inq_grp_ncid(grpid1, GRP2_NAME, grpid2))

  ! Check for the groups with full group names. 
  write(grp1_full_name, '(A,A)') '/', GRP1_NAME
  call check(nf90_inq_grp_full_ncid(ncid, grp1_full_name, grpid1))
  call check(nf90_inq_grpname(grpid1, name_in))
  if (name_in .ne. GRP1_NAME) stop 61
  call check(nf90_inq_grpname_full(grpid1, ilen, name_in))
  if (name_in .ne. grp1_full_name) stop 62

  Call check(nf90_rename_grp(grpid1, NEW_GRP1_NAME))
  name_in=REPEAT(" ", LEN(name_in))
  Call check(nf90_inq_grpname(grpid1, name_in))
  If (name_in /= NEW_GRP1_NAME) Call check(-1)

  ! Check variable 1.
  call check(nf90_inquire_variable(ncid, varid1, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, chunksizes = chunksizes_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR1_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. MAX_DIMS .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1) .or. dimids_in(2) .ne. dimids(2)) stop 3
  if (chunksizes_in(1) /= chunksizes(1) .or. chunksizes_in(2) /= chunksizes(2)) &
       stop 4
  if (endianness_in .ne. nf90_endian_big) stop 5

  ! Close the file. 
  call check(nf90_close(ncid))

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_rengrps

!     Copyright 1996-2019, UCAR/Unidata
!     See netcdf/COPYRIGHT file for copying and redistribution conditions.

!     Steve Emmerson, Ed Hartnett

      SUBROUTINE PRINT_NOK(NOK)
      IMPLICIT  NONE
      INTEGER   NOK
#include "tests.inc"

      IF (VERBOSE .OR. NFAILS .GT. 0) PRINT *, ' '
      IF (VERBOSE) PRINT *, NOK, ' good comparisons.'
      END


!     Is value within external type range? */
      FUNCTION INRANGE(VALUE, DATATYPE)
      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
#include "tests.inc"

      DOUBLEPRECISION   MIN
      DOUBLEPRECISION   MAX

      IF (DATATYPE .EQ. NF_CHAR) THEN
         MIN = X_CHAR_MIN
         MAX = X_CHAR_MAX
      ELSE IF (DATATYPE .EQ. NF_BYTE) THEN
         MIN = X_BYTE_MIN
         MAX = X_BYTE_MAX
      ELSE IF (DATATYPE .EQ. NF_SHORT) THEN
         MIN = X_SHORT_MIN
         MAX = X_SHORT_MAX
      ELSE IF (DATATYPE .EQ. NF_INT) THEN
         MIN = X_INT_MIN
         MAX = X_INT_MAX
      ELSE IF (DATATYPE .EQ. NF_FLOAT) THEN
         MIN = X_FLOAT_MIN
         MAX = X_FLOAT_MAX
      ELSE IF (DATATYPE .EQ. NF_DOUBLE) THEN
         MIN = X_DOUBLE_MIN
         MAX = X_DOUBLE_MAX
      ELSE
         CALL UDABORT
      END IF

      INRANGE = (VALUE .GE. MIN) .AND. (VALUE .LE. MAX)
      END


      FUNCTION INRANGE_UCHAR(VALUE, DATATYPE)
      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
#include "tests.inc"

      IF (DATATYPE .EQ. NF_BYTE) THEN
         INRANGE_UCHAR = (VALUE .GE. 0) .AND. (VALUE .LE. 255)
      ELSE
         INRANGE_UCHAR = INRANGE(VALUE, DATATYPE)
      END IF
      END


      FUNCTION INRANGE_FLOAT(VALUE, DATATYPE)
      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
#include "tests.inc"

      DOUBLEPRECISION   MIN
      DOUBLEPRECISION   MAX
      REAL              FVALUE

      IF (DATATYPE .EQ. NF_CHAR) THEN
         MIN = X_CHAR_MIN
         MAX = X_CHAR_MAX
      ELSE IF (DATATYPE .EQ. NF_BYTE) THEN
         MIN = X_BYTE_MIN
         MAX = X_BYTE_MAX
      ELSE IF (DATATYPE .EQ. NF_SHORT) THEN
         MIN = X_SHORT_MIN
         MAX = X_SHORT_MAX
      ELSE IF (DATATYPE .EQ. NF_INT) THEN
         MIN = X_INT_MIN
         MAX = X_INT_MAX
      ELSE IF (DATATYPE .EQ. NF_FLOAT) THEN
         IF (internal_max(NFT_REAL) .LT. X_FLOAT_MAX) THEN
            MIN = -internal_max(NFT_REAL)
            MAX = internal_max(NFT_REAL)
         ELSE
            MIN = X_FLOAT_MIN
            MAX = X_FLOAT_MAX
         END IF
      ELSE IF (DATATYPE .EQ. NF_DOUBLE) THEN
         IF (internal_max(NFT_REAL) .LT. X_DOUBLE_MAX) THEN
            MIN = -internal_max(NFT_REAL)
            MAX = internal_max(NFT_REAL)
         ELSE
            MIN = X_DOUBLE_MIN
            MAX = X_DOUBLE_MAX
         END IF
      ELSE
         CALL UDABORT
      END IF

      IF (.NOT.((VALUE .GE. MIN) .AND. (VALUE .LE. MAX))) THEN
         INRANGE_FLOAT = .FALSE.
      ELSE
         FVALUE = VALUE
         INRANGE_FLOAT = (FVALUE .GE. MIN) .AND. (FVALUE .LE. MAX)
      END IF
      END


!     wrapper for inrange to handle special NF_BYTE/uchar adjustment */
      function inrange3(value, datatype, itype)
      implicit          none
      doubleprecision   value
      integer           datatype
      integer           itype
#include "tests.inc"

      if (itype .eq. NFT_REAL) then
         inrange3 = inrange_float(value, datatype)
      else
         inrange3 = inrange(value, datatype)
      end if
      end


!
!     Does x == y, where one is internal and other external (netCDF)?
!     Use tolerant comparison based on IEEE FLT_EPSILON or DBL_EPSILON.
!
      function equal(x, y, extType, itype)
      implicit  none
      doubleprecision   x
      doubleprecision   y
      integer           extType !!/* external data type */
      integer           itype
#include "tests.inc"

      doubleprecision   epsilon

      if ((extType .eq. NF_REAL) .or. (itype .eq. NFT_REAL)) then
         epsilon = 1.19209290E-07
      else
         epsilon = 2.2204460492503131E-16
      end if
      equal = abs(x-y) .le. epsilon * max( abs(x), abs(y))
      end


!     Test whether two int vectors are equal. If so return 1, else 0  */
      function int_vec_eq(v1, v2, n)
      implicit        none
      integer n
      integer v1(n)
      integer v2(n)
#include "tests.inc"

      integer i

      int_vec_eq = .true.

      if (n .le. 0)
     +     return

      do 1, i=1, n
         if (v1(i) .ne. v2(i)) then
            int_vec_eq = .false.
            return
         end if
 1    continue
      end


!
!     Generate random integer from 0 through n-1
!     Like throwing an n-sided dice marked 0, 1, 2, ..., n-1
!
      function roll(n)
      implicit  none
      integer   n
#include "tests.inc"

      doubleprecision   udrand
      external          udrand

 1    roll = (udrand(0) * (n-1)) + 0.5
      if (roll .ge. n) goto 1
      end


!
!     Convert an origin-1 cumulative index to a netCDF index vector.
!     Grosset dimension first; finest dimension last.
!
!     Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!     Steve Emmerson, (same place)
!
      function index2ncindexes(index, rank, base, indexes)
      implicit        none
      integer         index     !!/* index to be converted */
      integer         rank      !/* number of dimensions */
      integer         base(rank) !/* base(rank) ignored */
      integer         indexes(rank) !/* returned FORTRAN indexes */
#include "tests.inc"

      integer i
      integer offset

      if (rank .gt. 0) then
         offset = index - 1
         do 1, i = rank, 1, -1
            if (base(i) .eq. 0) then
               index2ncindexes = 1
               return
            end if
            indexes(i) = 1 + mod(offset, base(i))
            offset = offset / base(i)
 1       continue
      end if
      index2ncindexes = 0
      end


!
!     Convert an origin-1 cumulative index to a FORTRAN index vector.
!     Finest dimension first; grossest dimension last.
!
!     Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!     Steve Emmerson, (same place)
!
      function index2indexes(index, rank, base, indexes)
      implicit        none
      integer         index     !/* index to be converted */
      integer         rank      !/* number of dimensions */
      integer         base(rank) !/* base(rank) ignored */
      integer         indexes(rank) !/* returned FORTRAN indexes */
#include "tests.inc"

      integer i
      integer offset

      if (rank .gt. 0) then
         offset = index - 1
         do 1, i = 1, rank
            if (base(i) .eq. 0) then
               index2indexes = 1
               return
            end if
            indexes(i) = 1 + mod(offset, base(i))
            offset = offset / base(i)
 1       continue
      end if
      index2indexes = 0
      end


!
!     Convert a FORTRAN index vector to an origin-1 cumulative index.
!     Finest dimension first; grossest dimension last.
!
!     Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!     Steve Emmerson, (same place)
!
      function indexes2index(rank, indexes, base)
      implicit        none
      integer         rank      !/* number of dimensions */
      integer         indexes(rank) !/* FORTRAN indexes */
      integer         base(rank) !/* base(rank) ignored */
#include "tests.inc"

      integer i

      indexes2index = 0
      if (rank .gt. 0) then
         do 1, i = rank, 1, -1
            indexes2index = (indexes2index-1) * base(i) + indexes(i)
 1       continue
      end if
      end


#ifdef USE_EXTREME_NUMBERS
!     Generate data values as function of type, rank (-1 for attribute), index */
      function hash(type, rank, index) 
      implicit  none
      integer   type
      integer   rank
      integer   index(*)
#include "tests.inc"

      doubleprecision   base
      doubleprecision   result
      integer           d       !/* index of dimension */

!/* If vector then elements 1 & 2 are min & max. Elements 3 & 4 are */
!/* just < min & > max (except for NF_CHAR & NF_DOUBLE) */
      if (abs(rank) .eq. 1 .and. index(1) .le. 4) then
         if (index(1) .eq. 1) then
            if (type .eq. NF_CHAR) then
               hash = X_CHAR_MIN
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MIN
            else if (type .eq. NF_SHORT) then
               hash = X_SHORT_MIN
            else if (type .eq. NF_INT) then
               hash = X_INT_MIN
            else if (type .eq. NF_FLOAT) then
               hash = X_FLOAT_MIN
            else if (type .eq. NF_DOUBLE) then
               hash = X_DOUBLE_MIN
            else
               call udabort
            end if
         else if (index(1) .eq. 2) then
            if (type .eq. NF_CHAR) then
               hash = X_CHAR_MAX
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MAX
            else if (type .eq. NF_SHORT) then
               hash = X_SHORT_MAX
            else if (type .eq. NF_INT) then
               hash = X_INT_MAX
            else if (type .eq. NF_FLOAT) then
               hash = X_FLOAT_MAX
            else if (type .eq. NF_DOUBLE) then
               hash = X_DOUBLE_MAX
            else
               call udabort
            end if
         else if (index(1) .eq. 3) then
            if (type .eq. NF_CHAR) then
               hash = ichar('A')
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MIN-1.0
            else if (type .eq. NF_SHORT) then
               hash = X_SHORT_MIN-1.0
            else if (type .eq. NF_INT) then
               hash = X_INT_MIN
            else if (type .eq. NF_FLOAT) then
               hash = X_FLOAT_MIN
            else if (type .eq. NF_DOUBLE) then
               hash = -1.0
            else
               call udabort
            end if
         else if (index(1) .eq. 4) then
            if (type .eq. NF_CHAR) then
               hash = ichar('Z')
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MAX+1.0
            else if (type .eq. NF_SHORT) then
               hash = X_SHORT_MAX+1.0
            else if (type .eq. NF_INT) then
               hash = X_INT_MAX+1.0
            else if (type .eq. NF_FLOAT) then
               hash = X_FLOAT_MAX
            else if (type .eq. NF_DOUBLE) then
               hash = 1.0
            else
               call udabort
            end if
         end if
      else
         if (type .eq. NF_CHAR) then
            base = 2
         else if (type .eq. NF_BYTE) then
            base = -2
         else if (type .eq. NF_SHORT) then
            base = -5
         else if (type .eq. NF_INT) then
            base = -20
         else if (type .eq. NF_FLOAT) then
            base = -9
         else if (type .eq. NF_DOUBLE) then
            base = -10
         else
            stop 2
         end if

         if (rank .lt. 0) then
            result = base * 7
         else
            result = base * (rank + 1)
         end if

!     /*
!     * NB: Finest netCDF dimension assumed first.
!     */
         do 1, d = abs(rank), 1, -1
            result = base * (result + index(d) - 1)
 1       continue
         hash = result
      end if
      end
#else /* USE_EXTREME_NUMBERS */
#define SANE_SHORT 3333
#define SANE_INT 2222
#define SANE_FLOAT 300.0
#define SANE_DOUBLE 1000.0

!     Generate data values as function of type, rank (-1 for attribute), index */
      function hash(type, rank, index) 
      implicit  none
      integer   type
      integer   rank
      integer   index(*)
#include "tests.inc"

      doubleprecision   base
      doubleprecision   result
      integer           d       !/* index of dimension */

!/* If vector then elements 1 & 2 are min & max. Elements 3 & 4 are */
!/* just < min & > max (except for NF_CHAR & NF_DOUBLE) */
      if (abs(rank) .eq. 1 .and. index(1) .le. 4) then
         if (index(1) .eq. 1) then
            if (type .eq. NF_CHAR) then
               hash = X_CHAR_MIN
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MIN
            else if (type .eq. NF_SHORT) then
               hash = SANE_SHORT
            else if (type .eq. NF_INT) then
               hash = SANE_INT
            else if (type .eq. NF_FLOAT) then
               hash = SANE_FLOAT
            else if (type .eq. NF_DOUBLE) then
               hash = SANE_DOUBLE
            else
               call udabort
            end if
         else if (index(1) .eq. 2) then
            if (type .eq. NF_CHAR) then
               hash = X_CHAR_MAX
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MAX
            else if (type .eq. NF_SHORT) then
               hash = SANE_SHORT
            else if (type .eq. NF_INT) then
               hash = SANE_INT
            else if (type .eq. NF_FLOAT) then
               hash = SANE_FLOAT
            else if (type .eq. NF_DOUBLE) then
               hash = SANE_DOUBLE
            else
               call udabort
            end if
         else if (index(1) .eq. 3) then
            if (type .eq. NF_CHAR) then
               hash = ichar('A')
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MIN-1.0
            else if (type .eq. NF_SHORT) then
               hash = SANE_SHORT-1.0
            else if (type .eq. NF_INT) then
               hash = SANE_INT
            else if (type .eq. NF_FLOAT) then
               hash = SANE_FLOAT
            else if (type .eq. NF_DOUBLE) then
               hash = -1.0
            else
               call udabort
            end if
         else if (index(1) .eq. 4) then
            if (type .eq. NF_CHAR) then
               hash = ichar('Z')
            else if (type .eq. NF_BYTE) then
               hash = X_BYTE_MAX+1.0
            else if (type .eq. NF_SHORT) then
               hash = SANE_SHORT+1.0
            else if (type .eq. NF_INT) then
               hash = SANE_INT+1.0
            else if (type .eq. NF_FLOAT) then
               hash = SANE_FLOAT
            else if (type .eq. NF_DOUBLE) then
               hash = 1.0
            else
               call udabort
            end if
         end if
      else
         if (type .eq. NF_CHAR) then
            base = 2
         else if (type .eq. NF_BYTE) then
            base = -2
         else if (type .eq. NF_SHORT) then
            base = -5
         else if (type .eq. NF_INT) then
            base = -20
         else if (type .eq. NF_FLOAT) then
            base = -9
         else if (type .eq. NF_DOUBLE) then
            base = -10
         else
            stop 2
         end if

         if (rank .lt. 0) then
            result = base * 7
         else
            result = base * (rank + 1)
         end if

!     /*
!     * NB: Finest netCDF dimension assumed first.
!     */
         do 1, d = abs(rank), 1, -1
            result = base * (result + index(d) - 1)
 1       continue
         hash = result
      end if
      end
#endif

!     wrapper for hash to handle special NC_BYTE/uchar adjustment */
      function hash4(type, rank, index, itype)
      implicit  none
      integer   type
      integer   rank
      integer   index(*)
      integer   itype
#include "tests.inc"

      hash4 = hash( type, rank, index )
      if ((itype .eq. NFT_CHAR) .and. (type .eq. NF_BYTE) .and. 
     +     (hash4 .ge. -128) .and. (hash4 .lt. 0)) hash4 = hash4 + 256
      end


      integer function char2type(letter)
      implicit          none
      character*1       letter
#include "tests.inc"

      if (letter .eq. 'c') then
         char2type = NF_CHAR
      else if (letter .eq. 'b') then
         char2type = NF_BYTE
      else if (letter .eq. 's') then
         char2type = NF_SHORT
      else if (letter .eq. 'i') then
         char2type = NF_INT
      else if (letter .eq. 'f') then
         char2type = NF_FLOAT
      else if (letter .eq. 'd') then
         char2type = NF_DOUBLE
      else
         stop 2
      end if
      end


      subroutine init_dims(digit)
      implicit          none
      character*1       digit(NDIMS)
#include "tests.inc"

      integer   dimid           !/* index of dimension */
      do 1, dimid = 1, NDIMS
         if (dimid .eq. RECDIM) then
            dim_len(dimid) = NRECS
         else
            dim_len(dimid) = dimid - 1
         endif
         dim_name(dimid) = 'D' // digit(dimid)
 1    continue
      end


      subroutine init_gatts(type_letter)
      implicit          none
      character*1       type_letter(NTYPES)
#include "tests.inc"

      integer   attid
      integer   char2type

      do 1, attid = 1, NTYPES
         gatt_name(attid) = 'G' // type_letter(attid)
         gatt_len(attid) = attid
         gatt_type(attid) = char2type(type_letter(attid))
 1    continue
      end


      integer function prod(nn, sp)
      implicit  none
      integer   nn
      integer   sp(MAX_RANK)
#include "tests.inc"

      integer   i

      prod = 1
      do 1, i = 1, nn
         prod = prod * sp(i)
 1    continue
      end


!
!     define global variables:
!     dim_name, dim_len,
!     var_name, var_type, var_rank, var_shape, var_natts, var_dimid, var_nels
!     att_name, gatt_name, att_type, gatt_type, att_len, gatt_len
!
      subroutine init_gvars
      implicit        none
#include "tests.inc"

      integer         max_dim_len(MAX_RANK)
      character*1     type_letter(NTYPES)
      character*1     digit(10)

      integer rank
      integer vn                !/* var number */
      integer xtype             !/* index of type */
      integer an                !/* origin-0 cumulative attribute index */
      integer nvars
      integer jj
      integer ntypes
      integer tc
      integer tmp(MAX_RANK)
      integer ac                !/* attribute index */
      integer dn                !/* dimension number */
      integer prod              !/* function */
      integer char2type         !/* function */
      integer err

      data    max_dim_len     /0, MAX_DIM_LEN, MAX_DIM_LEN/
      data    type_letter     /'c', 'b', 's', 'i', 'f', 'd'/
      data    digit           /'r', '1', '2', '3', '4', '5',
     +     '6', '7', '8', '9'/

      max_dim_len(1) = MAX_DIM_LEN + 1

      call init_dims(digit)

      vn = 1
      xtype = 1
      an = 0

!     /* Loop over variable ranks */
      do 1, rank = 0, MAX_RANK
         nvars = prod(rank, max_dim_len)

!/* Loop over variable shape vectors */
         do 2, jj = 1, nvars    !/* 1, 5, 20, 80 */
!/* number types of this shape */
            if (rank .lt. 2) then
               ntypes = NTYPES  !/* 6 */
            else
               ntypes = 1
            end if

!/* Loop over external data types */
            do 3, tc = 1, ntypes !/* 6, 1 */
               var_name(vn) = type_letter(xtype)
               var_type(vn) = char2type(type_letter(xtype))
               var_rank(vn) = rank
               if (rank .eq. 0) then
                  var_natts(vn) = mod(vn - 1, MAX_NATTS + 1)
               else
                  var_natts(vn) = 0
               end if

               do 4, ac = 1, var_natts(vn)
                  attname(ac,vn) =
     +                 type_letter(1+mod(an, NTYPES))
                  attlen(ac,vn) = an
                  atttype(ac,vn) =
     +                 char2type(type_letter(1+mod(an, NTYPES)))
                  an = an + 1
 4             continue

!/* Construct initial shape vector */
               err = index2ncindexes(jj, rank, max_dim_len, tmp)
               do 5, dn = 1, rank
                  var_dimid(dn,vn) = tmp(1+rank-dn)
 5             continue

               var_nels(vn) = 1
               do 6, dn = 1, rank
                  if (dn .lt. rank) then
                     var_dimid(dn,vn) = var_dimid(dn,vn) + 1
                  end if
                  if (var_dimid(dn,vn) .gt. 9) then
                     stop 2
                  end if
                  var_name(vn)(rank+2-dn:rank+2-dn) =
     +                 digit(var_dimid(dn,vn))
                  if (var_dimid(dn,vn) .ne. RECDIM) then
                     var_shape(dn,vn) = var_dimid(dn,vn) - 1
                  else
                     var_shape(dn,vn) = NRECS
                  end if
                  var_nels(vn) = var_nels(vn) * var_shape(dn,vn)
 6             continue

               vn = vn + 1
               xtype = 1 + mod(xtype, NTYPES)
 3          continue
 2       continue
 1    continue

      call init_gatts(type_letter)
      end


!     define dims defined by global variables */
      subroutine def_dims(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      integer         err       !/* status */
      integer         i
      integer         dimid     !/* dimension id */

      do 1, i = 1, NDIMS
         if (i .eq. RECDIM) then
            err = nf_def_dim(ncid, dim_name(i), NF_UNLIMITED,
     +           dimid)
         else
            err = nf_def_dim(ncid, dim_name(i), dim_len(i),
     +           dimid)
         end if
         if (err .ne. 0) then
            call errore('nf_def_dim: ', err)
         end if
 1    continue
      end


!     define vars defined by global variables */
      subroutine def_vars(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      integer         err       !/* status */
      integer         i
      integer         var_id

      do 1, i = 1, NVARS
         err = nf_def_var(ncid, var_name(i), var_type(i),
     +        var_rank(i), var_dimid(1,i), var_id)
         if (err .ne. 0) then
            call errore('nf_def_var: ', err)
         end if
 1    continue
      end


!     put attributes defined by global variables */
      subroutine put_atts(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      integer                 err !/* netCDF status */
      integer                 i !/* variable index (0 => global
! * attribute */
      integer                 k !/* attribute index */
      integer                 j !/* index of attribute */
      integer                 ndx(1)
      logical                 allInRange
      doubleprecision         att(MAX_NELS)
      character*(MAX_NELS+2)  catt

      do 1, i = 0, NVARS        !/* var 0 => NF_GLOBAL attributes */
         do 2, j = 1, NATTS(i)
            if (NF_CHAR .eq. ATT_TYPE(j,i)) then
               catt = ' '
               do 3, k = 1, ATT_LEN(j,i)
                  ndx(1) = k
                  catt(k:k) = char(int(hash(ATT_TYPE(j,i), -1,
     +                 ndx)))
 3             continue
!     /*
!     * The following ensures that the text buffer doesn't
!     * start with 4 zeros (which is a CFORTRAN NULL pointer
!     * indicator) yet contains a zero (which causes the
!     * CFORTRAN interface to pass the address of the
!     * actual text buffer).
!     */
               catt(ATT_LEN(j,i)+1:ATT_LEN(j,i)+1) = char(1)
               catt(ATT_LEN(j,i)+2:ATT_LEN(j,i)+2) = char(0)

               err = nf_put_att_text(ncid, varid(i),
     +              ATT_NAME(j,i),
     +              ATT_LEN(j,i), catt)
               if (err .ne. 0) then
                  call errore('nf_put_att_text: ', err)
               end if
            else
               allInRange = .true.
               do 4, k = 1, ATT_LEN(j,i)
                  ndx(1) = k
                  att(k) = hash(ATT_TYPE(j,i), -1, ndx)
                  allInRange = allInRange .and.
     +                 inRange(att(k), ATT_TYPE(j,i))
 4             continue
               err = nf_put_att_double(ncid, varid(i),
     +              ATT_NAME(j,i),
     +              ATT_TYPE(j,i),
     +              ATT_LEN(j,i), att)
               if (allInRange) then
                  if (err .ne. 0) then
                     call errore('nf_put_att_double: ', err)
                  end if
               else
                  if (err .ne. NF_ERANGE) then
                     call errore(
     +                    'type-conversion range error: status = ',
     +                    err)
                  end if
               end if
            end if
 2       continue
 1    continue
      end


!     put variables defined by global variables */
      subroutine put_vars(ncid)
      implicit        none
      integer                 ncid
#include "tests.inc"

      integer                 start(MAX_RANK)
      integer                 index(MAX_RANK)
      integer                 err !/* netCDF status */
      integer                 i
      integer                 j
      doubleprecision         value(MAX_NELS)
      character*(MAX_NELS+2)  text
      logical                 allInRange

      do 1, j = 1, MAX_RANK
         start(j) = 1
 1    continue

      do 2, i = 1, NVARS
         allInRange = .true.
         do 3, j = 1, var_nels(i)
            err = index2indexes(j, var_rank(i), var_shape(1,i),
     +           index)
            if (err .ne. 0) then
               call errori(
     +              'Error calling index2indexes() for var ', j)
            end if
            if (var_name(i)(1:1) .eq. 'c') then
               text(j:j) =
     +              char(int(hash(var_type(i), var_rank(i), index)))
            else
               value(j)  = hash(var_type(i), var_rank(i), index)
               allInRange = allInRange .and.
     +              inRange(value(j), var_type(i))
            end if
 3       continue
         if (var_name(i)(1:1) .eq. 'c') then
!     /*
!     * The following statement ensures that the first 4
!     * characters in 'text' are not all zeros (which is
!     * a cfortran.h NULL indicator) and that the string
!     * contains a zero (which will cause the address of the
!     * actual string buffer to be passed).
!     */
            text(var_nels(i)+1:var_nels(i)+1) = char(1)
            text(var_nels(i)+2:var_nels(i)+2) = char(0)
            err = nf_put_vara_text(ncid, i, start, var_shape(1,i),
     +           text)
            if (err .ne. 0) then
               call errore('nf_put_vara_text: ', err)
            end if
         else
            err = nf_put_vara_double(ncid, i, start, var_shape(1,i),
     +           value)
            if (allInRange) then
               if (err .ne. 0) then
                  call errore('nf_put_vara_double: ', err)
               end if
            else
               if (err .ne. NF_ERANGE) then
                  call errore(
     +                 'type-conversion range error: status = ',
     +                 err)
               end if
            end if
         end if
 2    continue
      end


!     Create & write all of specified file using global variables */
      subroutine write_file(filename)
      implicit        none
      character*(*)   filename
#include "tests.inc"

      integer ncid              !/* netCDF id */
      integer err               !/* netCDF status */
      integer cmode

      cmode = IOR(NF_CLOBBER, FILE_CMODE)
      err = nf_create(filename, cmode, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
      end if

      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)
      err = nf_enddef(ncid)
      if (err .ne. 0) then
         call errore('nf_enddef: ', err)
      end if
      call put_vars(ncid)

      err = nf_close(ncid)
      if (err .ne. 0) then
         call errore('nf_close: ', err)
      end if
      end


!
!     check dimensions of specified file have expected name & length
!
      subroutine check_dims(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      character*(NF_MAX_NAME) name
      integer                 length
      integer                 i
      integer                 err !/* netCDF status */

      do 1, i = 1, NDIMS
         err = nf_inq_dim(ncid, i, name, length)
         if (err .ne. 0) then
            call errore('nf_inq_dim: ', err)
         end if
         if (name .ne. dim_name(i)) then
            call errori('Unexpected name of dimension ', i)
         end if
         if (length .ne. dim_len(i)) then
            call errori('Unexpected length of dimension ', i)
         end if
 1    continue
      end


!
!     check variables of specified file have expected name, type, shape & values
!
      subroutine check_vars(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      integer                 index(MAX_RANK)
      integer                 err !/* netCDF status */
      integer                 i
      integer                 j
      character*1             text
      doubleprecision         value
      integer                 datatype
      integer                 ndims
      integer                 natt
      integer                 dimids(MAX_RANK)
      logical                 isChar
      doubleprecision         expect
      character*(NF_MAX_NAME) name
      integer                 length
      integer                 nok !/* count of valid comparisons */

      nok = 0

      do 1, i = 1, NVARS
         isChar = var_type(i) .eq. NF_CHAR
         err = nf_inq_var(ncid, i, name, datatype, ndims, dimids,
     +        natt)
         if (err .ne. 0) then
            call errore('nf_inq_var: ', err)
         end if
         if (name .ne. var_name(i)) then
            call errori('Unexpected var_name for variable ', i)
         end if
         if (datatype .ne. var_type(i))  then
            call errori('Unexpected type for variable ', i)
         end if
         if (ndims .ne. var_rank(i))  then
            call errori('Unexpected rank for variable ', i)
         end if
         do 2, j = 1, ndims
            err = nf_inq_dim(ncid, dimids(j), name, length)
            if (err .ne. 0) then
               call errore('nf_inq_dim: ', err)
            end if
            if (length .ne. var_shape(j,i))  then
               call errori('Unexpected shape for variable ', i)
            end if
 2       continue
         do 3, j = 1, var_nels(i)
            err = index2indexes(j, var_rank(i), var_shape(1,i),
     +           index)
            if (err .ne. 0)  then
               call errori('error in index2indexes() 2, variable ',
     +              i)
            end if
            expect = hash(var_type(i), var_rank(i), index )
            if (isChar) then
               err = nf_get_var1_text(ncid, i, index, text)
               if (err .ne. 0) then
                  call errore('nf_get_var1_text: ', err)
               end if
               if (ichar(text) .ne. expect) then
                  call errori(
     +                 'Var value read not expected for variable ', i)
               else
                  nok = nok + 1
               end if
            else
               err = nf_get_var1_double(ncid, i, index, value)
               if (inRange(expect,var_type(i))) then
                  if (err .ne. 0) then
                     call errore('nf_get_var1_double: ', err)
                  else
                     if (.not. equal(value,expect,var_type(i),
     +                    NFT_DOUBLE)) then
                        call errori(
     +                       'Var value read not expected ', i)
                     else
                        nok = nok + 1
                     end if
                  end if
               end if
            end if
 3       continue
 1    continue
      call print_nok(nok)
      end


!
!     check attributes of specified file have expected name, type, length & values
!
      subroutine check_atts(ncid)
      implicit        none
      integer         ncid
#include "tests.inc"

      integer                 err !/* netCDF status */
      integer                 i
      integer                 j
      integer                 k
      integer                 vid !/* "variable" ID */
      integer                 datatype
      integer                 ndx(1)
      character*(NF_MAX_NAME) name
      integer                 length
      character*(MAX_NELS)    text
      doubleprecision         value(MAX_NELS)
      doubleprecision         expect
      integer                 nok !/* count of valid comparisons */

      nok = 0

      do 1, vid = 0, NVARS
         i = varid(vid)

         do 2, j = 1, NATTS(i)
            err = nf_inq_attname(ncid, i, j, name)
            if (err .ne. 0) then
               call errore('nf_inq_attname: ', err)
            end if
            if (name .ne. ATT_NAME(j,i)) then
               call errori(
     +              'nf_inq_attname: unexpected name for var ', i)
            end if
            err = nf_inq_att(ncid, i, name, datatype, length)
            if (err .ne. 0) then
               call errore('nf_inq_att: ', err)
            end if
            if (datatype .ne. ATT_TYPE(j,i)) then
               call errori('nf_inq_att: unexpected type for var ',
     +              i)
            end if
            if (length .ne. ATT_LEN(j,i)) then
               call errori(
     +              'nf_inq_att: unexpected length for var ', i)
            end if
            if (datatype .eq. NF_CHAR) then
               err = nf_get_att_text(ncid, i, name, text)
               if (err .ne. 0) then
                  call errore('nf_get_att_text: ', err)
               end if
               do 3, k = 1, ATT_LEN(j,i)
                  ndx(1) = k
                  if (ichar(text(k:k)) .ne. hash(datatype, -1,
     +                 ndx))
     +                 then
                     call errori(
     +                    'nf_get_att_text: unexpected value ', i)
                  else
                     nok = nok + 1
                  end if
 3             continue
            else
               err = nf_get_att_double(ncid, i, name, value)
               do 4, k = 1, ATT_LEN(j,i)
                  ndx(1) = k
                  expect = hash(datatype, -1, ndx)
                  if (inRange(expect,ATT_TYPE(j,i))) then
                     if (err .ne. 0) then
                        call errore('nf_get_att_double: ', err)
                     end if
                     if (.not. equal(value(k), expect,
     +                    ATT_TYPE(j,i), NFT_DOUBLE)) then
                        call errori(
     +                       'Att value read not expected for var ', i)
                     else
                        nok = nok + 1
                     end if
                  end if
 4             continue
            end if
 2       continue
 1    continue
      call print_nok(nok)
      end


!     Check file (dims, vars, atts) corresponds to global variables */
      subroutine check_file(filename)
      implicit        none
      character*(*)   filename
#include "tests.inc"

      integer ncid              !/* netCDF id */
      integer err               !/* netCDF status */

      err = nf_open(filename, NF_NOWRITE, ncid)
      if (err .ne. 0) then
         call errore('nf_open: ', err)
      else
         call check_dims(ncid)
         call check_vars(ncid)
         call check_atts(ncid)
         err = nf_close (ncid)
         if (err .ne. 0) then
            call errore('nf_close: ', err)
         end if
      end if
      end


!
!     Functions for accessing attribute test data.
!
!     NB: 'varid' is 0 for global attributes; thus, global attributes can
!     be handled in the same loop as variable attributes.
!

      FUNCTION VARID(VID)
      IMPLICIT NONE
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 1) THEN
         VARID = NF_GLOBAL
      ELSE
         VARID = VID
      ENDIF
      end


      FUNCTION NATTS(VID)
      IMPLICIT  NONE
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 1) THEN
         NATTS = NGATTS
      ELSE
         NATTS = VAR_NATTS(VID)
      ENDIF
      END


      FUNCTION ATT_NAME(J,VID)
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 1) THEN
         ATT_NAME = GATT_NAME(J)
      ELSE
         ATT_NAME = ATTNAME(J,VID)
      ENDIF
      END


      FUNCTION ATT_TYPE(J,VID)
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 1) THEN
         ATT_TYPE = GATT_TYPE(J)
      ELSE
         ATT_TYPE = ATTTYPE(J,VID)
      ENDIF
      END


      FUNCTION ATT_LEN(J,VID)
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
#include "tests.inc"
      IF (VID .LT. 1) THEN
         ATT_LEN = GATT_LEN(J)
      ELSE
         ATT_LEN = ATTLEN(J,VID)
      ENDIF
      END


!
!     Return the minimum value of an internal type.
!
      function internal_min(type)
      implicit        none
      integer         type
      doubleprecision	min_schar
      doubleprecision	min_short
      doubleprecision	min_int
      doubleprecision	min_long
      doubleprecision	max_float
      doubleprecision	max_double
#include "tests.inc"

      if (type .eq. NFT_CHAR) then
         internal_min = 0
      else if (type .eq. NFT_INT1) then
#if NF_INT1_IS_C_SIGNED_CHAR
         internal_min = min_schar()
#endif
#if NF_INT1_IS_C_SHORT
         internal_min = min_short()
#endif
#if NF_INT1_IS_C_INT
         internal_min = min_int()
#endif
#if NF_INT1_IS_C_LONG
         internal_min = min_long()
#endif
      else if (type .eq. NFT_INT2) then
#if NF_INT2_IS_C_SHORT
         internal_min = min_short()
#endif            
#if NF_INT2_IS_C_INT
         internal_min = min_int()
#endif            
#if NF_INT2_IS_C_LONG
         internal_min = min_long()
#endif
      else if (type .eq. NFT_INT) then
#if NF_INT_IS_C_INT
         internal_min = min_int()
#endif            
#if NF_INT_IS_C_LONG
         internal_min = min_long()
#endif
      else if (type .eq. NFT_REAL) then
#if NF_REAL_IS_C_FLOAT
         internal_min = -max_float()
#endif
#if NF_REAL_IS_C_DOUBLE
         internal_min = -max_double()
#endif
      else if (type .eq. NFT_DOUBLE) then
#if NF_DOUBLEPRECISION_IS_C_DOUBLE
         internal_min = -max_double()
#endif
#if NF_DOUBLEPRECISION_IS_C_FLOAT
         internal_min = -max_float()
#endif
      else
         stop 2
      end if
      end


!
!     Return the maximum value of an internal type.
!
      function internal_max(type)
      implicit        none
      integer         type
      doubleprecision	max_schar
      doubleprecision	max_short
      doubleprecision	max_int
      doubleprecision	max_long
      doubleprecision	max_float
      doubleprecision	max_double
#include "tests.inc"

      if (type .eq. NFT_CHAR) then
         internal_max = 255
      else if (type .eq. NFT_INT1) then
#if NF_INT1_IS_C_SIGNED_CHAR
         internal_max = max_schar()
#endif
#if NF_INT1_IS_C_SHORT
         internal_max = max_short()
#endif
#if NF_INT1_IS_C_INT
         internal_max = max_int()
#endif
#if NF_INT1_IS_C_LONG
         internal_max = max_long()
#endif
      else if (type .eq. NFT_INT2) then
#if NF_INT2_IS_C_SHORT
         internal_max = max_short()
#endif
#if NF_INT2_IS_C_INT
         internal_max = max_int()
#endif
#if NF_INT2_IS_C_LONG
         internal_max = max_long()
#endif
      else if (type .eq. NFT_INT) then
#if NF_INT_IS_C_INT
         internal_max = max_int()
#endif
#if NF_INT_IS_C_LONG
         internal_max = max_long()
#endif
      else if (type .eq. NFT_REAL) then
#if NF_REAL_IS_C_FLOAT
         internal_max = max_float()
#endif
#if NF_REAL_IS_C_DOUBLE
         internal_max = max_double()
#endif
      else if (type .eq. NFT_DOUBLE) then
#if NF_DOUBLEPRECISION_IS_C_DOUBLE
         internal_max = max_double()
#endif            
#if NF_DOUBLEPRECISION_IS_C_FLOAT
         internal_max = max_float()
#endif
      else
         stop 2
      end if
      end


!
!     Return the minimum value of an external type.
!
      function external_min(type)
      implicit        none
      integer         type
#include "tests.inc"

      if (type .eq. NF_BYTE) then
         external_min = X_BYTE_MIN
      else if (type .eq. NF_CHAR) then
         external_min = X_CHAR_MIN
      else if (type .eq. NF_SHORT) then
         external_min = X_SHORT_MIN
      else if (type .eq. NF_INT) then
         external_min = X_INT_MIN
      else if (type .eq. NF_FLOAT) then
         external_min = X_FLOAT_MIN
      else if (type .eq. NF_DOUBLE) then
         external_min = X_DOUBLE_MIN
      else
         stop 2
      end if
      end


!
!     Return the maximum value of an internal type.
!
      function external_max(type)
      implicit        none
      integer         type
#include "tests.inc"

      if (type .eq. NF_BYTE) then
         external_max = X_BYTE_MAX
      else if (type .eq. NF_CHAR) then
         external_max = X_CHAR_MAX
      else if (type .eq. NF_SHORT) then
         external_max = X_SHORT_MAX
      else if (type .eq. NF_INT) then
         external_max = X_INT_MAX
      else if (type .eq. NF_FLOAT) then
         external_max = X_FLOAT_MAX
      else if (type .eq. NF_DOUBLE) then
         external_max = X_DOUBLE_MAX
      else
         stop 2
      end if
      end


!
!     Indicate whether or not a value lies in the range of an internal type.
!
      function in_internal_range(itype, value)
      implicit        none
      integer         itype
      doubleprecision value
#include "tests.inc"

      in_internal_range = value .ge. internal_min(itype) .and.
     +     value .le. internal_max(itype)
      end


!
!     Return the length of a character variable minus any trailing blanks.
!
      function len_trim(string)
      implicit        none
      character*(*)   string
#include "tests.inc"

      do 1, len_trim = len(string), 1, -1
         if (string(len_trim:len_trim) .ne. ' ')
     +        goto 2
 1    continue

 2    return
      end

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     Tests new nf90_inq_path function
!     Mimics tests in C tst_files5.c code

!      Russ Rew

program f90tst_path
  use typeSizes
  use netcdf

  implicit NONE

  character(len=*), parameter :: FILE_NAME="f90tst_path.nc"

  integer                        :: path_len, ncid
  character(LEN=NF90_MAX_NAME+1) :: path_in

  path_in   = REPEAT(" ", LEN(path_in))
  path_len  = 0

  print *,''
  print *,'*** Testing netcdf file functions.'
  print *,'*** Checking the new inq_path function'

! Test with classic mode nf90_create

  call check(nf90_create(FILE_NAME, nf90_classic_model, ncid))
  call check(nf90_inq_path(ncid, path_len, path_in))

  if ((path_len /= LEN(FILE_NAME)) .OR. (FILE_NAME /= TRIM(path_in)))  &
    call check(-1)
  call check(nf90_close(ncid))

  path_in=REPEAT(" ", LEN(path_in))
  path_len=0

! Test with classic mode nf90_open

  call check(nf90_open(FILE_NAME, nf90_classic_model, ncid))
  call check(nf90_inq_path(ncid, path_len, path_in))

  if ((path_len /= LEN(FILE_NAME)) .OR. (FILE_NAME /= TRIM(path_in)))  &
    call check(-1)
  call check(nf90_close(ncid))

  path_in=REPEAT(" ", LEN(path_in))
  path_len=0


! Test with netcdf4 mode nf90_create

  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid))
  call check(nf90_inq_path(ncid, path_len, path_in))

  if ((path_len /= LEN(FILE_NAME)) .OR. (FILE_NAME /= TRIM(path_in)))  &
    call check(-1)
  call check(nf90_close(ncid))

  path_in=REPEAT(" ", LEN(path_in))
  path_len=0

! Test with netcdf4 mode nf90_open

  call check(nf90_open(FILE_NAME, nf90_netcdf4, ncid))
  call check(nf90_inq_path(ncid, path_len, path_in))

  if ((path_len /= LEN(FILE_NAME)) .OR. (FILE_NAME /= TRIM(path_in)))  &
    call check(-1)
  call check(nf90_close(ncid))

  path_in=REPEAT(" ", LEN(path_in))
  path_len=0

  Print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check

end program f90tst_path

C     Copyright 2026 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.
C
C     Test nf_set_meta_block_size and nf_get_meta_block_size.
C
C     Ward Fisher

      program ftst_meta_block_size
      implicit none
      include 'netcdf.inc'

      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_meta_block_size.nc')

      integer META_BLOCK_SIZE
      parameter (META_BLOCK_SIZE = 1048576)

      integer DIM_LEN
      parameter (DIM_LEN = 64)

      integer ncid, dimid, varid
      integer retrieved
      integer retval
      integer i
      real data_out(64), data_in(64)
      integer chunks(1)

      print *, ''
      print *, '*** Testing nf_set_meta_block_size and
     &nf_get_meta_block_size.'

C     Test 1: round-trip set/get.
      print *, '*** Test 1: round-trip nf_set/get_meta_block_size...'
      retval = nf_set_meta_block_size(META_BLOCK_SIZE)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_get_meta_block_size(retrieved)
      if (retval .ne. nf_noerr) stop 2
      if (retrieved .ne. META_BLOCK_SIZE) stop 3
      print *, '*** PASS'

C     Test 2: create a netCDF-4 file while override is set.
      print *, '*** Test 2: create file with meta_block_size set...'
      retval = nf_set_meta_block_size(META_BLOCK_SIZE)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_def_dim(ncid, 'd0', DIM_LEN, dimid)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_def_var(ncid, 'v0', NF_FLOAT, 1, dimid, varid)
      if (retval .ne. nf_noerr) stop 2
      chunks(1) = DIM_LEN
      retval = nf_def_var_chunking(ncid, varid, NF_CHUNKED, chunks)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) stop 2
      do i = 1, DIM_LEN
        data_out(i) = real(i - 1)
      end do
      retval = nf_put_var_real(ncid, varid, data_out)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 2
      print *, '*** PASS'

C     Test 3: data written with the override active is readable.
      print *, '*** Test 3: read back data from that file...'
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_inq_varid(ncid, 'v0', varid)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_get_var_real(ncid, varid, data_in)
      if (retval .ne. nf_noerr) stop 2
      do i = 1, DIM_LEN
        if (data_in(i) .ne. data_out(i)) stop 4
      end do
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 2
      print *, '*** PASS'

C     Test 4: setting size to 0 disables the override.
      print *, '*** Test 4: nf_set_meta_block_size(0) disables...'
      retval = nf_set_meta_block_size(0)
      if (retval .ne. nf_noerr) stop 2
      retval = nf_get_meta_block_size(retrieved)
      if (retval .ne. nf_noerr) stop 2
      if (retrieved .ne. 0) stop 3
      print *, '*** PASS'

      print *, '*** SUCCESS'
      end

! This is part of the netCDF package.
! Copyright 2009 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This program tests netCDF-4 vlen variable functions from fortran 90.

! $Id: f90tst_vars_vlen.f90,v 1.3 2009/02/02 19:31:25 ed Exp $

program f90tst_vars_vlen
  use typeSizes
  use netcdf
  implicit none
!  include 'netcdf.inc'

!   ! This is the name of the data file we will create.
!   character*(*) FILE_NAME
!   parameter (FILE_NAME='f90tst_vars_vlen.nc')

!   ! NetCDF IDs.
!   integer ncid, vlen_typeid

!   integer max_types
!   parameter (max_types = 1)

!   ! Need these to read type information.
!   integer num_types, typeids(max_types)
!   integer base_type, base_size
!   character*80 type_name
!   integer type_size, nfields, class

!   ! Information for the vlen type we will define.
!   character*(*) vlen_type_name
!   parameter (vlen_type_name = 'vlen_type')

!   ! Some data about and for the vlen.
!   integer vlen_len, vlen_len_in
!   parameter (vlen_len = 5)
!   integer data1(vlen_len), data1_in(vlen_len)

!   ! These must be big enough to hold the stuct nc_vlen in netcdf.h.
!   integer vlen(10), vlen_in(10)

!   ! Loop indexes, and error handling.
!   integer x, retval

!   print *, ''
!   print *,'*** Testing VLEN types.'

!   do x = 1, vlen_len
!      data1(x) = x
!   end do

!   ! Create the netCDF file.
!   retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Create the vlen type.
!   retval = nf_def_vlen(ncid, vlen_type_name, nf_int, vlen_typeid)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Set up the vlen with this helper function, since F77 can't deal
!   ! with pointers.
!   retval = nf_put_vlen_element(ncid, vlen_typeid, vlen, vlen_len, data1)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Write the vlen attribute.
!   retval = nf_put_att(ncid, NF_GLOBAL, 'att1', vlen_typeid, 1, vlen)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Close the file. 
!   retval = nf_close(ncid)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Reopen the file.
!   retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Get the typeids of all user defined types.
!   retval = nf_inq_typeids(ncid, num_types, typeids)
!   if (retval .ne. nf_noerr) call handle_err(retval)
!   if (num_types .ne. max_types) stop 2

!   ! Use nf_inq_user_type to confirm this is an vlen type, with vlen
!   ! size 16, base type NF_INT.
!   retval = nf_inq_user_type(ncid, typeids(1), type_name, type_size, &
!        base_type, nfields, class)
!   if (retval .ne. nf_noerr) call handle_err(retval)
!   if (type_name(1:len(vlen_type_name)) .ne. vlen_type_name .or. &
!         type_size .ne. 16 .or. base_type .ne. nf_int .or. &
!         nfields .ne. 0 .or. class .ne. nf_vlen) stop 3

!   ! Use nf_inq_vlen and make sure we get the same answers as we did
!   ! with nf_inq_user_type.
!   retval = nf_inq_vlen(ncid, typeids(1), type_name, base_size, base_type)
!   if (retval .ne. nf_noerr) call handle_err(retval)
!   if (type_name(1:len(vlen_type_name)) .ne. vlen_type_name .or. &
!        base_type .ne. nf_int .or. base_size .ne. 16) stop 4

!   ! Read the vlen attribute.
!   retval = nf_get_att(ncid, NF_GLOBAL, 'att1', vlen_in)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   ! Get the data from the vlen we just read.
!   retval = nf_get_vlen_element(ncid, vlen_typeid, vlen_in, &
!        vlen_len_in, data1_in)
!   if (retval .ne. nf_noerr) call handle_err(retval)
!   if (vlen_len_in .ne. vlen_len) stop 5

!   ! Check the data
!   do x = 1, vlen_len
!      if (data1(x) .ne. data1_in(x)) stop 6
!   end do

!   ! Close the file. 
!   retval = nf_close(ncid)
!   if (retval .ne. nf_noerr) call handle_err(retval)

!   print *,'*** SUCCESS!'
! contains
! !     This subroutine handles errors by printing an error message and
! !     exiting with a non-zero status.
!   subroutine handle_err(errcode)
!     use netcdf
!     implicit none
!     integer, intent(in) :: errcode
    
!     if(errcode /= nf90_noerr) then
!        print *, 'Error: ', trim(nf90_strerror(errcode))
!        stop 1
!     endif
!   end subroutine handle_err
end program f90tst_vars_vlen

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.
      
C     This is a simple example which reads a small dummy array, from a
C     netCDF data file created by the companion program simple_xy_wr.f.
      
C     This is intended to illustrate the use of the netCDF fortran 77
C     API. This example program is part of the netCDF tutorial, which can
C     be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: simple_xy_nc4_rd.f,v 1.1 2007/05/04 13:33:20 ed Exp $

      program simple_xy_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read. 
      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy_nc4.nc')

C     We are reading 2D data, a 12 x 6 grid. 
      integer NX, NY
      parameter (NX = 60, NY = 120)
      integer data_in(NY, NX)

C     This will be the netCDF ID for the file and data variable.
      integer ncid, varid

C     Loop indexes, and error handling.
      integer x, y, retval

C     Open the file. NF_NOWRITE tells netCDF we want read-only access to
C     the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varid of the data variable, based on its name.
      retval = nf_inq_varid(ncid, 'data', varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the data.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data.
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. (x - 1) * NY + (y - 1)) then
               print *, 'data_in(', y, ', ', x, ') = ', data_in(y, x)
               stop 2
            end if
         end do
      end do

C     Close the file, freeing all resources.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS reading example file ', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some 4D pressure and
C     temperatures. The data file read by this program is produced by
C     the companion program pres_temp_4D_wr.f. It is intended to
C     illustrate the use of the netCDF Fortran 77 API.

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program pres_temp_4D_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='pres_temp_4D.nc')
      integer ncid

C     We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')

C     The start and count arrays will tell the netCDF library where to
C     read our data.
      integer start(NDIMS), count(NDIMS)

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude variables which will hold the actual
C     latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will read surface temperature and pressure fields. In netCDF
C     terminology these are called "variables."
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will read in. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_in(NLONS, NLATS, NLVLS)
      real temp_in(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to calculate the values we expect to find.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read 1 record of NLONS*NLATS*NLVLS values, starting at the
C     beginning of the record (the (1, 1, 1, rec) element in the netCDF
C     file).
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Read the surface pressure and temperature data from the file, one
C     record at a time.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_get_vara_real(ncid, pres_varid, start, count,
     $        pres_in)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_get_vara_real(ncid, temp_varid, start, count,
     $        temp_in)
         if (retval .ne. nf_noerr) call handle_err(retval)

         i = 0
         do lvl = 1, NLVLS
            do lat = 1, NLATS
               do lon = 1, NLONS
                  if (pres_in(lon, lat, lvl) .ne. SAMPLE_PRESSURE + i) 
     $                 stop 2
                  if (temp_in(lon, lat, lvl) .ne. SAMPLE_TEMP + i)
     $                 stop 2
                  i = i + 1
               end do
            end do
         end do
C     next record
      end do
         
C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file pres_temp_4D.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

  function nf90_put_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_1D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_1D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_1D_EightByteInt


   function nf90_put_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_2D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_2D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_2D_EightByteInt


   function nf90_put_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_3D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_3D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_3D_EightByteInt


   function nf90_put_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_4D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_4D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_4D_EightByteInt


   function nf90_put_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_5D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_5D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_5D_EightByteInt


   function nf90_put_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_6D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_6D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_6D_EightByteInt


   function nf90_put_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_7D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_7D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_7D_EightByteInt


   function nf90_get_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_1D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_1D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_1D_EightByteInt


   function nf90_get_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_2D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_2D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_2D_EightByteInt


   function nf90_get_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_3D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_3D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_3D_EightByteInt


   function nf90_get_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_4D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_4D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_4D_EightByteInt


   function nf90_get_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_5D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_5D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_5D_EightByteInt


   function nf90_get_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_6D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_6D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_6D_EightByteInt


   function nf90_get_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter
     integer, dimension(size(values))      :: defaultIntArray
 
     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)
 
     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_7D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_7D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :, :) = reshape(defaultIntArray(:), shape(values))
   end function nf90_get_var_7D_EightByteInt


   function nf90_put_var_EightByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex
 
     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_put_var_EightByteInt = nf_put_var1_int(ncid, varid, localIndex, int(values))
   end function nf90_put_var_EightByteInt


   function nf90_get_var_EightByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_EightByteInt
 
     integer, dimension(nf90_max_var_dims) :: localIndex
     integer                               :: defaultInteger
     
     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)
 
     nf90_get_var_EightByteInt = nf_get_var1_int(ncid, varid, localIndex, defaultInteger)
     values = defaultInteger
   end function nf90_get_var_EightByteInt

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 parallel I/O functions from fortran.

!     We are writing 2D data, a 6 x 12 grid, on 4 processors. Each
!     processor will write it's rank to it's quarter of the array. The
!     result will be (in CDL):
!
! netcdf f90tst_parallel {
! dimensions:
! 	x = 16 ;
! 	y = 16 ;
! variables:
! 	int data(x, y) ;
! data:
!
!  data =
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
!   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3 ;
! }

!     Ed Hartnett

program f90tst_parallel
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag
  integer :: p, my_rank, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  if (my_rank .eq. 0) then
     print *, ' '
     print *, '*** Testing netCDF-4 parallel I/O from Fortran 90.'
  endif

  ! There must be 4 procs for this test.
  if (p .ne. 4) then
     print *, 'Sorry, this test program must be run on four processors.'
     stop 2
  endif

#ifdef NF_HAS_PNETCDF
  mode_flag = IOR(nf90_clobber, nf90_mpiio)
  call parallel_io(mode_flag)
#endif

#ifdef NF_HAS_PARALLEL4
  mode_flag = IOR(nf90_netcdf4, nf90_classic_model)
  mode_flag = IOR(mode_flag, nf90_clobber)
  mode_flag = IOR(mode_flag, nf90_mpiio)
  call parallel_io(mode_flag)
#endif

  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine handle_err

  subroutine parallel_io(mode_flag)
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel.nc"

  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: NUM_PROC = 4
  integer :: ncid, varid, dimids(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: data_out(NY / 2, NX / 2), data_in(NY / 2, NX / 2)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer :: my_rank, ierr
  integer :: start(MAX_DIMS), count(MAX_DIMS)

  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)

  ! Create some pretend data.
  do x = 1, NX / 2
     do y = 1, NY / 2
        data_out(y, x) = my_rank
     end do
  end do

  ! Create the netCDF file.
  call handle_err(nf90_create(FILE_NAME, mode_flag, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Define the dimensions.
  call handle_err(nf90_def_dim(ncid, "x", NX, x_dimid))
  call handle_err(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable.
  call handle_err(nf90_def_var(ncid, "data", NF90_INT, dimids, varid))

  ! With classic model netCDF-4 file, enddef must be called.
  call handle_err(nf90_enddef(ncid))

  ! Determine what part of the variable will be written for this
  ! processor. It's a checkerboard decomposition.
  count = (/ NX / 2, NY / 2 /)
  if (my_rank .eq. 0) then
     start = (/ 1, 1 /)
  else if (my_rank .eq. 1) then
     start = (/ NX / 2 + 1, 1 /)
  else if (my_rank .eq. 2) then
     start = (/ 1, NY / 2 + 1 /)
  else if (my_rank .eq. 3) then
     start = (/ NX / 2 + 1, NY / 2 + 1 /)
  endif

  ! Write this processor's data.
  call handle_err(nf90_put_var(ncid, varid, data_out, start = start, count = count))

  ! Close the file.
  call handle_err(nf90_close(ncid))

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, IOR(nf90_nowrite, nf90_mpiio), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Check some stuff out.
  call handle_err(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 1 .or. ngatts /= 0 .or. unlimdimid /= -1) stop 3

  if (IAND(mode_flag, nf90_netcdf4) .GT. 0) then
      if (file_format /= nf90_format_netcdf4_classic) stop 4
  else
      if (file_format /= nf90_format_classic) stop 5
  endif

  ! Set collective access on this variable. This will cause all
  ! reads/writes to happen together on every processor. Fairly
  ! pointless, in this contexct, but I want to at least call this
  ! function once in my testing.
  call handle_err(nf90_var_par_access(ncid, varid, nf90_collective))

  ! Read this processor's data.
  call handle_err(nf90_get_var(ncid, varid, data_in, start = start, count = count))

  ! Check the data.
  do x = 1, NX / 2
     do y = 1, NY / 2
        if (data_in(y, x) .ne. my_rank) stop 6
     end do
  end do

  ! Close the file.
  call handle_err(nf90_close(ncid))
  end subroutine parallel_io

end program f90tst_parallel

C     This is part of the netCDF package. Copyright 2006-2019 University
C     Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
C     for conditions of use.

C     This program tests netCDF-4 group functions in the F77 API.

C     Ed Hartnett, 2009

      program ftst_groups
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) file_name
      parameter (file_name='ftst_groups.nc')

C     Info about the groups we'll create.
      character*(*) group_name, sub_group_name
      parameter (group_name = 'grp', sub_group_name = 'sub')
      character*80 name_in, name_in2
      integer ngroups_in
      integer full_name_len

C     Dimensions and variables.
      character*(*) dim1_name, dim2_name
      parameter (dim1_name = 'd1', dim2_name = 'd2')
      character*(*) var1_name, var2_name
      parameter (var1_name = 'v1', var2_name = 'v2')
      integer nvars, ndims

C     NetCDF IDs.
      integer ncid, grpid, sub_grpid, subgrp_in
      integer grpids(1), grpid_in, dimids(2), varids(2)
      integer varids_in(2), dimids_in(2)

C     Error handling.
      integer retval

      print *, ''
      print *,'*** Testing netCDF-4 groups from F77.'

C     Create the netCDF file.
      retval = nf_create(file_name, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a group and a subgroup.
      retval = nf_def_grp(ncid, group_name, grpid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_grp(grpid, sub_group_name, sub_grpid)
      if (retval .ne. nf_noerr) stop 1

C     Create a two dims and two vars.
      retval = nf_def_dim(sub_grpid, dim1_name, 0, dimids(1))
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(sub_grpid, dim2_name, 0, dimids(2))
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_var(sub_grpid, var1_name, NF_UINT64, 2, dimids, 
     &     varids(1))
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_var(sub_grpid, var2_name, NF_UINT64, 2, dimids, 
     &     varids(2))
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(file_name, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1
      
C     Check the name of the root group.
      retval = nf_inq_grpname(ncid, name_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:1) .ne. '/') stop 2

C     Check the full name of the root group (also "/").
      retval = nf_inq_grpname_full(ncid, full_name_len, name_in)
      if (retval .ne. nf_noerr) stop 1
      if (full_name_len .ne. 1 .or. name_in(1:1) .ne. '/') stop 2

C     What groups are there from the root group?
      retval = nf_inq_grps(ncid, ngroups_in, grpids)
      if (retval .ne. nf_noerr) stop 1
      if (ngroups_in .ne. 1) stop 2

C     Check the name of this group.
      retval = nf_inq_grpname(grpids(1), name_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(group_name)) .ne. group_name) stop 2

C     Check the length of the full name.
      retval = nf_inq_grpname_len(grpids(1), full_name_len)
      if (retval .ne. nf_noerr) stop 1
      if (full_name_len .ne. len(group_name) + 1) stop 2

C     Check the full name.
      retval = nf_inq_grpname_full(grpids(1), full_name_len, name_in2)
      if (retval .ne. nf_noerr) stop 1
      if (name_in2(1:1) .ne. '/' .or. 
     &     name_in2(2:len(group_name)+1) .ne. group_name .or.
     &     full_name_len .ne. len(group_name) + 1) stop 2

C     Check getting the grpid by full name
      retval = nf_inq_grp_full_ncid(ncid, name_in, grpid_in)
      if (retval .ne. nf_noerr) stop 1
      if (grpid_in .ne. grpids(1)) stop 2

C     Check the parent ncid.
      retval = nf_inq_grp_parent(grpids(1), grpid_in)
      if (retval .ne. nf_noerr) stop 1
      if (grpid_in .ne. ncid) stop 2

C     Check getting the group by name
      retval = nf_inq_ncid(ncid, group_name, grpid_in)
      if (retval .ne. nf_noerr) stop 1
      if (grpid_in .ne. grpids(1)) stop 2

C     Check getting the group by name
      retval = nf_inq_ncid(ncid, group_name, grpid_in)
      if (retval .ne. nf_noerr) stop 1
      if (grpid_in .ne. grpids(1)) stop 2

C     Get the sub group id, using its name.
      retval = nf_inq_ncid(grpid_in, sub_group_name, subgrp_in)
      if (retval .ne. nf_noerr) stop 1

C     Check varids in subgroup.
      retval = nf_inq_varids(subgrp_in, nvars, varids_in)
      if (retval .ne. nf_noerr) stop 1
      if (nvars .ne. 2 .or. varids_in(1) .ne. varids(1) .or.
     &     varids_in(2) .ne. varids(2)) stop 2

C     Check dimids in subgroup.
      retval = nf_inq_dimids(subgrp_in, ndims, dimids_in, 0)
      if (retval .ne. nf_noerr) stop 1
      if (ndims .ne. 2 .or. dimids_in(1) .ne. dimids(1) .or.
     &     dimids_in(2) .ne. dimids(2)) stop 2

C     Check dimids including parents (will get same answers, since there
C     are no dims in parent group.
      retval = nf_inq_dimids(subgrp_in, ndims, dimids_in, 1)
      if (retval .ne. nf_noerr) stop 1
      if (ndims .ne. 2 .or. dimids_in(1) .ne. dimids(1) .or.
     &     dimids_in(2) .ne. dimids(2)) stop 2

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing some compound type behavior.

C     Ed Hartnett, 2009

      program ftst_vars5
      USE netcdf4_f03
      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_vars5.nc')

C     NetCDF IDs.
      integer ncid, cmp_typeid

      integer max_types
      parameter (max_types = 1)

C     Need these to read type information.
      integer num_types, typeids(max_types)
      integer base_type, type_size, num_members, member_value
      character*80 type_name, member_name
      integer nfields, class

C     Information for the compound type we will define.
      character*(*) cmp_type_name, int1_name, int2_name
      parameter (cmp_type_name = 'compound_type')
      parameter (int1_name = 'int1', int2_name = 'int2')
      integer compound_len, compound_len_in
      parameter (compound_len = 2)
      integer data1(compound_len), data1_in(compound_len)
      character*(4) att_name
      parameter (att_name = 'att1')

C     Loop indexes, and error handling.
      integer x, retval, index(1)

      print *, ''
      print *,'*** Testing compound types.'

C     Prepare some data to write.
      do x = 1, compound_len
         data1(x) = x
      end do

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create the compound type.
      retval = nf_def_compound(ncid, 8, cmp_type_name, 
     &     cmp_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Insert two integers.
      retval = nf_insert_compound(ncid, cmp_typeid, int1_name, 
     &     0, NF_INT)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_insert_compound(ncid, cmp_typeid, int2_name, 
     &     4, NF_INT)
      if (retval .ne. nf_noerr) stop 1

C     Write the compound attribute.
      retval = nf_put_att(ncid, NF_GLOBAL, att_name, cmp_typeid, 
     &     1, data1)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Get the typeids of all user defined types.
      retval = nf_inq_typeids(ncid, num_types, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (num_types .ne. max_types) stop 2

C     Use nf_inq_user_type to confirm this is an compound type
      retval = nf_inq_user_type(ncid, typeids(1), type_name, type_size, 
     &     base_type, nfields, class)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(cmp_type_name)) .ne. cmp_type_name .or.
     &     type_size .ne. 8 .or. base_type .ne. 0 .or.
     &     nfields .ne. 2 .or. class .ne. nf_compound) stop 2

C     Use nf_inq_compound and make sure we get the same answers as we did
C     with nf_inq_user_type.
      retval = nf_inq_compound(ncid, typeids(1), type_name, type_size, 
     &     nfields)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(cmp_type_name)) .ne. cmp_type_name .or.
     &     base_type .ne. 0 .or. type_size .ne. 8 .or.
     &     nfields .ne. 2) stop 2

C     Read the compound attribute.
      retval = nf_get_att(ncid, NF_GLOBAL, att_name, data1_in)
      if (retval .ne. nf_noerr) stop 1

C     Check the data
      do x = 1, compound_len
         if (data1(x) .ne. data1_in(x)) stop 2
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 parallel I/O and fill values from
!     fortran. It creates a file like this:

! netcdf f90tst_parallel3 {
! dimensions:
! 	x = 16 ;
! 	y = 16 ;
! variables:
! 	byte byte(x, y) ;
! 	short short(x, y) ;
! 	int int(x, y) ;
! 	float float(x, y) ;
! 	double double(x, y) ;
! 	ubyte ubyte(x, y) ;
! 	ushort ushort(x, y) ;
! 	uint uint(x, y) ;

!     Ed Hartnett

program f90tst_parallel3
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag, cmode
  integer :: p, my_rank, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  if (my_rank .eq. 0) then
     print *, ' '
     print *, '*** Testing netCDF-4 parallel I/O with fill values.'
  endif

  ! There must be 4 procs for this test.
  if (p .ne. 4) then
     print *, 'Sorry, this test program must be run on four processors.'
     stop 1
  endif

  cmode = IOR(nf90_clobber, nf90_mpiio)

#ifdef NF_HAS_PNETCDF
  ! test CDF-1 file
  call parallel_io(cmode)

  ! test CDF-2 file
  mode_flag = IOR(cmode, nf90_64bit_offset)
  call parallel_io(mode_flag)

#ifdef ENABLE_CDF5
  ! test CDF-5 file
  mode_flag = IOR(cmode, nf90_64bit_data)
  call parallel_io(mode_flag)
#endif
#endif

#ifdef NF_HAS_PARALLEL4
  mode_flag = IOR(cmode, nf90_netcdf4)
  call parallel_io(mode_flag)
#endif

  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 99
    endif
  end subroutine check

  subroutine parallel_io(mode_flag)
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel3.nc"
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: HALF_NX = NX/2, HALF_NY = NY/2
  integer, parameter :: NUM_PROC = 4
  integer, parameter :: CACHE_SIZE = 4194304, CACHE_NELEMS = 1013
  integer, parameter :: CACHE_PREEMPTION = 79
  integer, parameter :: NUM_VARS = 8
  character (len = *), parameter :: var_name(NUM_VARS) = &
       (/ 'byte__', 'short_', 'int___', 'float_', 'double', 'ubyte_', 'ushort', 'uint__' /)
  integer :: var_type(NUM_VARS) = (/ nf90_byte, nf90_short, nf90_int, &
       nf90_float, nf90_double, nf90_ubyte, nf90_ushort, nf90_uint /)
  integer :: ncid, varid(NUM_VARS), dimids(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: byte_out(HALF_NY, HALF_NX), byte_in(HALF_NY, HALF_NX)
  integer :: short_out(HALF_NY, HALF_NX), short_in(HALF_NY, HALF_NX)
  integer :: int_out(HALF_NY, HALF_NX), int_in(HALF_NY, HALF_NX)
  real :: areal_out(HALF_NY, HALF_NX), areal_in(HALF_NY, HALF_NX)
  real :: double_out(HALF_NY, HALF_NX), double_in(HALF_NY, HALF_NX)
  integer :: ubyte_out(HALF_NY, HALF_NX), ubyte_in(HALF_NY, HALF_NX)
  integer :: ushort_out(HALF_NY, HALF_NX), ushort_in(HALF_NY, HALF_NX)
  integer (kind = EightByteInt) :: uint_out(HALF_NY, HALF_NX), uint_in(HALF_NY, HALF_NX)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format, tst_nvars
  integer :: x, y, v
  integer :: my_rank, ierr, old_mode
  integer :: start(MAX_DIMS), count(MAX_DIMS)

  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)

  ! Create some pretend data.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        byte_out(y, x) = my_rank * (-1)
        short_out(y, x) =  my_rank * (-2)
        int_out(y, x) = my_rank * (-4)
        areal_out(y, x) = my_rank * 2.5
        double_out(y, x) = my_rank * (-4.5)
        ubyte_out(y, x) = my_rank
        ushort_out(y, x) = my_rank * 2
        uint_out(y, x) = my_rank * 4
     end do
  end do

  ! Create the netCDF file.
  call check(nf90_create(FILE_NAME, mode_flag, ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL, cache_size = CACHE_SIZE, &
       cache_nelems = CACHE_NELEMS, cache_preemption = CACHE_PREEMPTION))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  if (IAND(mode_flag, nf90_netcdf4) .GT. 0) then
      tst_nvars = 8
  else if (IAND(mode_flag, nf90_64bit_data) .GT. 0) then
      tst_nvars = 8
  else
      tst_nvars = 5
  end if

  ! Define the variables.
  do v = 1, tst_nvars
     call check(nf90_def_var(ncid, var_name(v), var_type(v), dimids, varid(v)))
  end do

  ! enable fill mode
  call check(nf90_set_fill(ncid, NF90_FILL, old_mode))

  ! This will be the last collective operation.
  call check(nf90_enddef(ncid))

  ! Determine what part of the variable will be written/read for this
  ! processor. It's a checkerboard decomposition.
  count = (/ HALF_NX, HALF_NY /)
  if (my_rank .eq. 0) then
     start = (/ 1, 1 /)
  else if (my_rank .eq. 1) then
     start = (/ HALF_NX + 1, 1 /)
  else if (my_rank .eq. 2) then
     start = (/ 1, HALF_NY + 1 /)
  else if (my_rank .eq. 3) then
     start = (/ HALF_NX + 1, HALF_NY + 1 /)
  endif

  ! Write this processor's data, except for processor zero.
  if (my_rank .ne. 0) then
     call check(nf90_put_var(ncid, varid(1), byte_out, start = start, count = count))
     call check(nf90_put_var(ncid, varid(2), short_out, start = start, count = count))
     call check(nf90_put_var(ncid, varid(3), int_out, start = start, count = count))
     call check(nf90_put_var(ncid, varid(4), areal_out, start = start, count = count))
     call check(nf90_put_var(ncid, varid(5), double_out, start = start, count = count))
     if (tst_nvars .GT. 5) then
        call check(nf90_put_var(ncid, varid(6), ubyte_out, start = start, count = count))
        call check(nf90_put_var(ncid, varid(7), ushort_out, start = start, count = count))
        call check(nf90_put_var(ncid, varid(8), uint_out, start = start, count = count))
     endif
  endif

  ! Close the file.
  call check(nf90_close(ncid))

  ! Reopen the file.
  call check(nf90_open(FILE_NAME, IOR(nf90_nowrite, nf90_mpiio), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= tst_nvars .or. ngatts /= 0 .or. unlimdimid /= -1) stop 2

  if (IAND(mode_flag, nf90_netcdf4) .GT. 0) then
      if (file_format /= nf90_format_netcdf4) stop 3
  else if (IAND(mode_flag, nf90_64bit_data) .GT. 0) then
      if (file_format /= nf90_format_cdf5) stop 4
  else if (IAND(mode_flag, nf90_64bit_offset) .GT. 0) then
      if (file_format /= nf90_format_64bit_offset) stop 5
  endif

  ! Read this processor's data.
  call check(nf90_get_var(ncid, varid(1), byte_in, start = start, count = count))
  call check(nf90_get_var(ncid, varid(2), short_in, start = start, count = count))
  call check(nf90_get_var(ncid, varid(3), int_in, start = start, count = count))
  call check(nf90_get_var(ncid, varid(4), areal_in, start = start, count = count))
  call check(nf90_get_var(ncid, varid(5), double_in, start = start, count = count))
  if (tst_nvars .GT. 5) then
      call check(nf90_get_var(ncid, varid(6), ubyte_in, start = start, count = count))
      call check(nf90_get_var(ncid, varid(7), ushort_in, start = start, count = count))
      call check(nf90_get_var(ncid, varid(8), uint_in, start = start, count = count))
  end if

  ! Check the data. All the data from the processor zero are fill
  ! value.
  do x = 1, HALF_NX
     do y = 1, HALF_NY
        if (my_rank .eq. 0) then
           if (byte_in(y, x) .ne. nf90_fill_byte) stop 6
           if (short_in(y, x) .ne. nf90_fill_short) stop 7
           if (int_in(y, x) .ne. nf90_fill_int) stop 8
           if (areal_in(y, x) .ne. nf90_fill_real) stop 9
           if (double_in(y, x) .ne. nf90_fill_double) stop 10
           if (tst_nvars .GT. 5) then
              if (ubyte_in(y, x) .ne. nf90_fill_ubyte) stop 11
              if (ushort_in(y, x) .ne. nf90_fill_ushort) stop 12
              if (uint_in(y, x) .ne. nf90_fill_uint) stop 13
           endif
        else
           if (byte_in(y, x) .ne. (my_rank * (-1))) stop 14
           if (short_in(y, x) .ne. (my_rank * (-2))) stop 15
           if (int_in(y, x) .ne. (my_rank * (-4))) stop 16
           if (areal_in(y, x) .ne. (my_rank * (2.5))) stop 17
           if (double_in(y, x) .ne. (my_rank * (-4.5))) stop 18
           if (tst_nvars .GT. 5) then
              if (ubyte_in(y, x) .ne. (my_rank * (1))) stop 19
              if (ushort_in(y, x) .ne. (my_rank * (2))) stop 20
              if (uint_in(y, x) .ne. (my_rank * (4))) stop 21
           endif
        endif
     end do
  end do

  ! Close the file.
  call check(nf90_close(ncid))
  end subroutine parallel_io

end program f90tst_parallel3

!     This is part of the netCDF package.  Copyright 2006 University
!     Corporation for Atmospheric Research/Unidata.  See COPYRIGHT
!     file for conditions of use.

!     This is a very simple example which writes a 2D array of sample
!     data. To handle this in netCDF we create two shared dimensions,
!     "x" and "y", and a netCDF variable, called "data".

!     This example demonstrates the netCDF Fortran 90 API. This is
!     part of the netCDF tutorial, which can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
!     Full documentation of the netCDF Fortran 90 API can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

!     $Id: simple_xy_nc4_wr.f90,v 1.6 2010/04/06 19:32:09 ed Exp $

program simple_xy_wr
  use netcdf
  implicit none

  character (len = *), parameter :: FILE_NAME = "simple_xy_nc4.nc"
  integer, parameter :: NDIMS = 2
  integer, parameter :: NX = 6, NY = 12
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid
  integer :: data_out(NY, NX)
  integer :: chunks(2)
  integer :: deflate_level
  integer :: x, y

  ! Create some pretend data. If this wasn't an example program, we
  ! would have some real data to write, for example, model output.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Always check the return code of every netCDF function call. In
  ! this example program, wrapping netCDF calls with "call check()"
  ! makes sure that any return which is not equal to nf90_noerr (0)
  ! will print a netCDF error message and exit.

  ! Create the netCDF file. The nf90_clobber parameter tells netCDF to
  ! overwrite this file, if it already exists.
  call check( nf90_create(FILE_NAME, nf90_netcdf4, ncid) )

  ! Define the dimensions. NetCDF will hand back an ID for each. 
  call check( nf90_def_dim(ncid, "x", NX, x_dimid) )
  call check( nf90_def_dim(ncid, "y", NY, y_dimid) )

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer). Optional parameters chunking, shuffle,
  ! and deflate_level are used.
  chunks(1) = NY
  chunks(2) = NX
  deflate_level = 1
  call check( nf90_def_var(ncid, "data", NF90_INT, dimids, varid, &
       chunksizes = chunks, shuffle = .TRUE., deflate_level = deflate_level) )

  ! End define mode. This tells netCDF we are done defining metadata.
  call check( nf90_enddef(ncid) )

  ! Write the pretend data to the file. Although netCDF supports
  ! reading and writing subsets of data, in this case we write all the
  ! data in one operation.
  call check( nf90_put_var(ncid, varid, data_out) )

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  print *, '*** SUCCESS writing example file ', FILE_NAME, '!'

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_wr

! This is part of the netCDF package.
! Copyright 2008 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program
! simple_xy_par_wr.f90. The data are read using parallel I/O.
      
! This is intended to illustrate the use of the netCDF fortran 90
! API. This example program is part of the netCDF tutorial, which can
! be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: simple_xy_par_rd.f90,v 1.2 2009/03/12 18:30:41 ed Exp $

program simple_xy_par_rd
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will read. 
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! These will tell where in the data file this processor should
  ! write.
  integer, parameter :: NDIMS = 2
  integer :: start(NDIMS), count(NDIMS)
  
  ! We will read data into this array.
  integer, allocatable :: data_in(:)

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Allocate space to read in data.
  allocate(data_in(p), stat = stat)
  if (stat .ne. 0) stop 3

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
  ! the file.
  call check( nf90_open(FILE_NAME, IOR(NF90_NOWRITE, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, "data", varid) )

  ! Read the data.
  start = (/ 1, my_rank + 1/)
  count = (/ p, 1 /)
  call check( nf90_get_var(ncid, varid, data_in, &
       start = start, count = count) )

  ! Check the data.
  do x = 1, p
     if (data_in(x) .ne. my_rank) then
        print *, "data_in(", x, ") = ", data_in(x)
        stop "Stopped"
     endif
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_in)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_rd

! Copyright 2007-2019, UCAR/Unidata. See netcdf/COPYRIGHT file for
! copying and redistribution conditions.

! This program tests io times with large files (> 4 GB) in
! netCDF-4. This is user-contributed code. This test creates a bunch
! of fort.* output files.

! Ed Hartnett, 2007
program f90tst_io
  use netcdf ! access to netcdf module
  implicit none
  integer, parameter :: prsz1 = 50, prsz2 = 50, &
       prsz3 = 50, prsz4 = 50, repct = 10
  integer :: i1, i2, i3, i4, ticksPerSec
  real :: psr
  integer :: clockRate
  integer :: start, now, wrint1, ncint1, wrint2, ncint2, &
       wrint3, iosb, size
  real, dimension (prsz1, prsz2, prsz3, prsz4) :: x
  character(len = *), parameter :: nclFilenm1 = 'f90tst_io1.nc', &
       nclFilenm2 = 'f90tst_io2.nc', nclFilenm3 = 'f90tst_io3.nc', &
       nclFilenm4 = 'f90tst_io4.nc', nclFilenm5 = 'f90tst_io5.nc', &
       nclFilenm6 = 'f90tst_io6.nc', nclFilenm7 = 'f90tst_io7.nc', &
       nclFilenm8 = 'f90tst_io8.nc', nclFilenm9 = 'f90tst_io9.nc', &
       nclFilenm10 = 'f90tst_io10.nc', nclFilenm11 = 'f90tst_io11.nc'
  ! needed for netcdf
  integer :: ncid, x1id, x2id, x3id, x4id, vrid

  psr = 1.7/real(prsz1)

  print *, "Starting data initialization."
  size = (prsz1 * prsz2 * prsz3 * prsz4 )/ 250000
  do i1 = 1, prsz1
     do i2 = 1, prsz2
        do i3 = 1, prsz3 ! Jackson Pollock it is not
           do i4 = 1, prsz4
              x(i1, i2, i3, i4) = sin(i1*psr)*(0.5 + cos(i2*psr))+(psr/i3)+ i4/(10.0*prsz4)
           enddo
        enddo
     enddo
  enddo
  call system_clock(start, ticksPerSec)
  clockRate = 1000/ticksPerSec
  print 5, size, 1000.0/real(ticksPerSec)
5 format("Array sizes =", i4, "MB. Clock resolution = ", f6.3, " ms."/)

  ! First the binary writes
  call system_clock(start, ticksPerSec)
  write(1, iostat = iosb) x
  call system_clock(now)
  wrint1 = now - start
  call check (iosb, 1)
  print 1, size, "MB","binary write = ", wrint1 * clockRate
1 format("Time for", i5, a, a26, i6, " msec. ")

  call system_clock(start)
  do i1 = 1, repct
     rewind (2, iostat = iosb)
     call check (iosb, 2)
     write(2, iostat = iosb) x
     call check (iosb, 3)
  enddo
  call system_clock(now)
  wrint2 = now - start
  call check (iosb, 4)
  close(2, iostat = iosb)
  call check (iosb, 5)
  print 2, size, "MB", repct, " binary rewind/writes = ", wrint2 * clockRate
2 format("Time for", i5, a, i3, a23, i6," msec. ", a, i6)
  close(1, iostat = iosb)

  call system_clock(start)
  write(13, iostat = iosb) x
  call check (iosb, 6)
  write(14, iostat = iosb) x
  call check (iosb, 7)
  write(15, iostat = iosb) x
  call check (iosb, 8)
  write(16, iostat = iosb) x
  call check (iosb, 9)
  write(17, iostat = iosb) x
  call check (iosb, 10)
  write(18, iostat = iosb) x
  call check (iosb, 11)
  write(19, iostat = iosb) x
  call check (iosb, 12)
  write(20, iostat = iosb) x
  call check (iosb, 13)
  call system_clock(now)
  wrint3 = now - start
  print 2, size, "MB", 8, " binary file writes = ", wrint3 * clockRate
  do i1 = 1, 8
     close(12 + i1, iostat = iosb)
     call check (iosb, 14)
  enddo

  ! Next the netCDF writes
  call setupNetCDF (nclFilenm1, ncid, vrid, x, prsz1, prsz2, prsz3, prsz4, &
       x1id, x2id, x3id, x4id, NF90_CLOBBER, 20)
  call system_clock(start)
  call check (NF90_PUT_VAR(ncid, vrid, x), 18)
  call system_clock(now)
  ncint1 = now - start
  print 3, size, "MB"," netcdf write = ", ncint1 * clockRate, &
       real(ncint1)/real (wrint1)
3 format("Time for", i5, a, a25, i7, " msec. Spd ratio = ", f5.2)

  call check (NF90_CLOSE(ncid), 14)

  call system_clock(start)
  do i1 = 1, repct
     call setupNetCDF (nclFilenm1, ncid, vrid, x, prsz1, prsz2, prsz3, prsz4, &
          x1id, x2id, x3id, x4id, NF90_CLOBBER, 130)
     call check (NF90_PUT_VAR(ncid, vrid, x), 23 + i1)
     call check (NF90_CLOSE(ncid), 15)
  enddo
  call system_clock(now)
  ncint2 = now - start
  print 4, size, repct, " repeated netcdf writes = ", ncint2 * clockRate, &
       real(ncint2)/real(wrint2);
4 format("Time for", i5, "MB", i3, a22, i7, " msec. Spd ratio = ", f5.2)

!   call system_clock(start)
!   call setupNetCDF (nclFilenm3, ncid, vrids, s, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 20)
!   call setupNetCDF (nclFilenm4, ncid, vridt, t, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 30)
!   call setupNetCDF (nclFilenm5, ncid, vridu, u, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 40)
!   call setupNetCDF (nclFilenm6, ncid, vridv, v, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 50)
!   call setupNetCDF (nclFilenm7, ncid, vridw, w, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 60)
!   call setupNetCDF (nclFilenm8, ncid, vridx, x, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 70)
!   call setupNetCDF (nclFilenm9, ncid, vridy, y, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 80)
!   call setupNetCDF (nclFilenm10, ncid, vridz, z, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 90)
!   call check (NF90_PUT_VAR(ncid, vrids, s), 118)
!   call check (NF90_PUT_VAR(ncid, vridt, t), 119)
!   call check (NF90_PUT_VAR(ncid, vridu, u), 120)
!   call check (NF90_PUT_VAR(ncid, vridv, v), 121)
!   call check (NF90_PUT_VAR(ncid, vridw, w), 122)
!   call check (NF90_PUT_VAR(ncid, vridx, x), 123)
!   call check (NF90_PUT_VAR(ncid, vridy, y), 124)
!   call check (NF90_PUT_VAR(ncid, vridz, z), 125)
!   call system_clock(now)
!   ncint3 = now - start
!   call check (NF90_CLOSE(ncid), 16)
!   print 4, size, 8, " netcdf file writes = ", ncint3 * clockRate, &
!        real(ncint3)/real(wrint3);

contains
  subroutine check (st, n) ! checks the return error code
    integer, intent (in) :: st, n
    if ((n < 10.and.st /= 0).or.(n > 10.and.st /= NF90_noerr))then
       print *, "I/O error at", n, " status = ", st
       stop 2
    endif
  end subroutine check

  subroutine setupNetCDF(fn, nc, vr, vrnam, d1, d2, d3, d4, do1, do2, &
       do3, do4, stat, deb)
    integer, intent(in) :: d1, d2, d3, d4, stat, deb
    integer, intent(out) :: do1, do2, do3, do4, vr
    integer, intent(inout) :: nc
    integer, dimension(4) :: dimids (4)

    character(len = *), intent(in) :: fn
    real, dimension (d1, d2, d3, d4), intent (in) :: vrnam

    call check (NF90_CREATE (fn, stat, nc), deb + 1)
    call check (NF90_DEF_DIM(nc, "d1", d1, do1), deb + 2)
    call check (NF90_DEF_DIM(nc, "d2", d2, do2), deb + 3)
    call check (NF90_DEF_DIM(nc, "d3", d3, do3), deb + 4)
    call check (NF90_DEF_DIM(nc, "d4", d4, do4), deb + 5)

    dimids = (/ do1, do2, do3, do4 /)
    call check (NF90_DEF_VAR(nc, "data", NF90_REAL, dimids, vr), deb + 6)
    call check (NF90_ENDDEF (nc), deb + 7)

  end subroutine setupNetCDF

end program f90tst_io

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing some compound type behavior.

C     Ed Hartnett, 2009

      program ftst_vars5
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars5.nc')

C     NetCDF IDs.
      integer ncid, cmp_typeid

      integer max_types
      parameter (max_types = 1)

C     Need these to read type information.
      integer num_types, typeids(max_types)
      integer base_type, type_size, num_members, member_value
      character*80 type_name, member_name
      integer nfields, class

C     Information for the compound type we will define.
      character*(*) cmp_type_name, int1_name, int2_name
      parameter (cmp_type_name = 'compound_type')
      parameter (int1_name = 'int1', int2_name = 'int2')
      integer compound_len, compound_len_in
      parameter (compound_len = 2)
      integer data1(compound_len), data1_in(compound_len)
      character*(4) att_name
      parameter (att_name = 'att1')

C     Loop indexes, and error handling.
      integer x, retval, index(1)

      print *, ''
      print *,'*** Testing compound types.'

C     Prepare some data to write.
      do x = 1, compound_len
         data1(x) = x
      end do

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create the compound type.
      retval = nf_def_compound(ncid, 8, cmp_type_name, 
     &     cmp_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Insert two integers.
      retval = nf_insert_compound(ncid, cmp_typeid, int1_name, 
     &     0, NF_INT)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_insert_compound(ncid, cmp_typeid, int2_name, 
     &     4, NF_INT)
      if (retval .ne. nf_noerr) stop 1

C     Write the compound attribute.
      retval = nf_put_att(ncid, NF_GLOBAL, att_name, cmp_typeid, 
     &     1, data1)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Get the typeids of all user defined types.
      retval = nf_inq_typeids(ncid, num_types, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (num_types .ne. max_types) stop 2

C     Use nf_inq_user_type to confirm this is an compound type
      retval = nf_inq_user_type(ncid, typeids(1), type_name, type_size, 
     &     base_type, nfields, class)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(cmp_type_name)) .ne. cmp_type_name .or.
     &     type_size .ne. 8 .or. base_type .ne. 0 .or.
     &     nfields .ne. 2 .or. class .ne. nf_compound) stop 2

C     Use nf_inq_compound and make sure we get the same answers as we did
C     with nf_inq_user_type.
      retval = nf_inq_compound(ncid, typeids(1), type_name, type_size, 
     &     nfields)
      if (retval .ne. nf_noerr) stop 1
      if (type_name(1:len(cmp_type_name)) .ne. cmp_type_name .or.
     &     base_type .ne. 0 .or. type_size .ne. 8 .or.
     &     nfields .ne. 2) stop 2

C     Read the compound attribute.
      retval = nf_get_att(ncid, NF_GLOBAL, att_name, data1_in)
      if (retval .ne. nf_noerr) stop 1

C     Check the data
      do x = 1, compound_len
         if (data1(x) .ne. data1_in(x)) stop 2
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2007 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 user defined types from fortran.

C     Ed Hartnett, 2009

      program ftst_types2
      USE netcdf4_f03
      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_types2.nc')

C     We are writing 2D data, a 3 x 2 grid. 
      integer NDIMS
      parameter (NDIMS = 2)
      integer dim_sizes(NDIMS)
      integer NX, NY
      parameter (NX = 3, NY = 2)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer cmp_typeid
      integer x_dimid, y_dimid
      integer typeids(1)

C     Info about the type we'll create.
      integer size_in, base_type_in, nfields_in, class_in
      character*80 name_in
      character*(*) type_name, ary_name
      parameter (type_name = 'cmp_w_ary', ary_name = 'A')
      integer ntypes
      integer cmp_size
      parameter (cmp_size = 24)
      integer offset_in, field_typeid_in, ndims_in, dim_sizes_in(NDIMS)

C     Loop indexes, and error handling.
      integer x, y, retval

      print *, ''
      print *,'*** Testing netCDF-4 compound types from F77 some more.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define a compound type.
      retval = nf_def_compound(ncid, cmp_size, type_name, 
     &     cmp_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Include an array.
      dim_sizes(1) = NX
      dim_sizes(2) = NY
      retval = nf_insert_array_compound(ncid, cmp_typeid, ary_name, 0, 
     &     NF_INT, NDIMS, dim_sizes)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find the type.
      retval = nf_inq_typeids(ncid, ntypes, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (ntypes .ne. 1 .or. typeids(1) .ne. cmp_typeid) stop 2
      
C     Check the type.
      retval = nf_inq_user_type(ncid, typeids(1), name_in, size_in, 
     &     base_type_in, nfields_in, class_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. cmp_size .or. nfields_in .ne. 1 .or. 
     &     class_in .ne. NF_COMPOUND) stop 2

C     Check the first field of the compound type.
      retval = nf_inq_compound_field(ncid, typeids(1), 1, name_in, 
     &     offset_in, field_typeid_in, ndims_in, dim_sizes_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(ary_name)) .ne. ary_name .or. 
     &     offset_in .ne. 0 .or. field_typeid_in .ne. NF_INT .or. 
     &     ndims_in .ne. NDIMS .or. 
     &     dim_sizes_in(1) .ne. dim_sizes(1) .or. 
     &     dim_sizes_in(2) .ne. dim_sizes(2)) stop 2

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 parallel I/O functions from fortran.

!     We are writing 2D data, a 6 x 12 grid, on 4 processors. We only
!     have half that amount of input data, because a stride is used so
!     that only every other value is written to the file. Each
!     processor will write it's rank to every other value in it's
!     quarter of the array. The result will be (in CDL):
!
! netcdf f90tst_parallel2 {
! dimensions:
! 	x = 16 ;
! 	y = 16 ;
! variables:
! 	int data(x, y) ;
! data:

!  data =
!   0, _, 0, _, 0, _, 0, _, 1, _, 1, _, 1, _, 1, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   0, _, 0, _, 0, _, 0, _, 1, _, 1, _, 1, _, 1, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   2, _, 2, _, 2, _, 2, _, 3, _, 3, _, 3, _, 3, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   2, _, 2, _, 2, _, 2, _, 3, _, 3, _, 3, _, 3, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
!   0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _, 0, _,
!   _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _ ;
! }

!     Ed Hartnett

program f90tst_parallel
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag, cmode
  integer :: p, my_rank, ierr

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  if (my_rank .eq. 0) then
     print *, ' '
     print *, '*** Testing netCDF-4 parallel I/O with strided access.'
  endif

  ! There must be 4 procs for this test.
  if (p .ne. 4) then
     print *, 'Sorry, this test program must be run on four processors.'
     stop 2
  endif

  cmode = IOR(nf90_clobber, nf90_mpiio)

#ifdef NF_HAS_PNETCDF
  ! test CDF-1 file
  call parallel_io(cmode)

  ! test CDF-2 file
  mode_flag = IOR(cmode, nf90_64bit_offset)
  call parallel_io(mode_flag)

#ifdef ENABLE_CDF5
  ! test CDF-5 file
  mode_flag = IOR(cmode, nf90_64bit_data)
  call parallel_io(mode_flag)
#endif
#endif

#ifdef NF_HAS_PARALLEL4
  mode_flag = IOR(cmode, nf90_netcdf4)
  mode_flag = IOR(mode_flag, nf90_classic_model)
  call parallel_io(mode_flag)
#endif

  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 9
    endif
  end subroutine handle_err

  subroutine parallel_io(mode_flag)
  use typeSizes
  use netcdf
  implicit none
  include 'mpif.h'

  integer :: mode_flag

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_parallel2.nc"

  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 16, NY = 16
  integer, parameter :: NUM_PROC = 4
  integer :: ncid, varid, dimids(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: data_out(NY / 4, NX / 4), data_in(NY / 4, NX / 4)
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer :: my_rank, ierr
  integer :: start(MAX_DIMS), count(MAX_DIMS), stride(MAX_DIMS)

  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)

  ! Create some pretend data.
  do x = 1, NX / 4
     do y = 1, NY / 4
        data_out(y, x) = my_rank
     end do
  end do

  ! Create the netCDF file.
  call handle_err(nf90_create(FILE_NAME, mode_flag, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Define the dimensions.
  call handle_err(nf90_def_dim(ncid, "x", NX, x_dimid))
  call handle_err(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable.
  call handle_err(nf90_def_var(ncid, "data", NF90_INT, dimids, varid))

  ! With classic model netCDF-4 file, enddef must be called.
  call handle_err(nf90_enddef(ncid))

  ! Determine what part of the variable will be written for this
  ! processor. It's a checkerboard decomposition.
  count = (/ NX / 4, NY / 4 /)
  stride = (/ 2, 2 /)
  if (my_rank .eq. 0) then
     start = (/ 1, 1 /)
  else if (my_rank .eq. 1) then
     start = (/ NX / 2 + 1, 1 /)
  else if (my_rank .eq. 2) then
     start = (/ 1, NY / 2 + 1 /)
  else if (my_rank .eq. 3) then
     start = (/ NX / 2 + 1, NY / 2 + 1 /)
  endif

  ! Write this processor's data.
  call handle_err(nf90_put_var(ncid, varid, data_out, start = start, &
       count = count, stride = stride))

  ! Close the file.
  call handle_err(nf90_close(ncid))

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, IOR(nf90_nowrite, nf90_mpiio), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Check some stuff out.
  call handle_err(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 1 .or. ngatts /= 0 .or. unlimdimid /= -1) stop 3

  if (IAND(mode_flag, nf90_netcdf4) .GT. 0) then
      if (file_format /= nf90_format_netcdf4_classic) stop 4
  else if (IAND(mode_flag, nf90_64bit_offset) .GT. 0) then
      if (file_format /= nf90_format_64bit_offset) stop 5
  else if (IAND(mode_flag, nf90_64bit_data) .GT. 0) then
      if (file_format /= nf90_format_64bit_data) stop 6
  else
      if (file_format /= nf90_format_classic) stop 7
  endif

  ! Set collective access on this variable. This will cause all
  ! reads/writes to happen together on every processor. Fairly
  ! pointless, in this contexct, but I want to at least call this
  ! function once in my testing.
  call handle_err(nf90_var_par_access(ncid, varid, nf90_collective))

  ! Read this processor's data.
  call handle_err(nf90_get_var(ncid, varid, data_in, start = start, count = count, &
       stride = stride))

  ! Check the data.
  do x = 1, NX / 4
     do y = 1, NY / 4
        if (data_in(y, x) .ne. my_rank) stop 8
     end do
  end do

  ! Close the file.
  call handle_err(nf90_close(ncid))
  end subroutine parallel_io

end program f90tst_parallel

! Copyright 2026 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
!
! Test nf90_set_meta_block_size and nf90_get_meta_block_size.
!
! Ward Fisher

program f90tst_meta_block_size
  use netcdf
  implicit none

  character(len=*), parameter :: FILE_NAME = 'f90tst_meta_block_size.nc'

  integer, parameter :: META_BLOCK_SIZE = 1048576
  integer, parameter :: DIM_LEN = 64

  integer :: ncid, dimid, varid
  integer :: retrieved
  integer :: i
  real    :: data_out(DIM_LEN), data_in(DIM_LEN)
  integer :: chunks(1)

  print *, ''
  print *, '*** Testing nf90_set_meta_block_size and nf90_get_meta_block_size.'

  ! Test 1: round-trip set/get.
  print *, '*** Test 1: round-trip nf90_set/get_meta_block_size...'
  if (nf90_set_meta_block_size(META_BLOCK_SIZE) .ne. nf90_noerr) stop 2
  if (nf90_get_meta_block_size(retrieved) .ne. nf90_noerr) stop 2
  if (retrieved .ne. META_BLOCK_SIZE) stop 3
  print *, '*** PASS'

  ! Test 2: create a netCDF-4 file while override is set.
  print *, '*** Test 2: create file with meta_block_size set...'
  if (nf90_set_meta_block_size(META_BLOCK_SIZE) .ne. nf90_noerr) stop 2
  if (nf90_create(FILE_NAME, NF90_NETCDF4, ncid) .ne. nf90_noerr) stop 2
  if (nf90_def_dim(ncid, 'd0', DIM_LEN, dimid) .ne. nf90_noerr) stop 2
  if (nf90_def_var(ncid, 'v0', NF90_FLOAT, dimid, varid) .ne. nf90_noerr) stop 2
  chunks(1) = DIM_LEN
  if (nf90_def_var_chunking(ncid, varid, NF90_CHUNKED, chunks) .ne. nf90_noerr) stop 2
  if (nf90_enddef(ncid) .ne. nf90_noerr) stop 2
  do i = 1, DIM_LEN
    data_out(i) = real(i - 1)
  end do
  if (nf90_put_var(ncid, varid, data_out) .ne. nf90_noerr) stop 2
  if (nf90_close(ncid) .ne. nf90_noerr) stop 2
  print *, '*** PASS'

  ! Test 3: data written with the override active is readable.
  print *, '*** Test 3: read back data from that file...'
  if (nf90_open(FILE_NAME, NF90_NOWRITE, ncid) .ne. nf90_noerr) stop 2
  if (nf90_inq_varid(ncid, 'v0', varid) .ne. nf90_noerr) stop 2
  if (nf90_get_var(ncid, varid, data_in) .ne. nf90_noerr) stop 2
  do i = 1, DIM_LEN
    if (data_in(i) .ne. data_out(i)) stop 4
  end do
  if (nf90_close(ncid) .ne. nf90_noerr) stop 2
  print *, '*** PASS'

  ! Test 4: setting size to 0 disables the override.
  print *, '*** Test 4: nf90_set_meta_block_size(0) disables...'
  if (nf90_set_meta_block_size(0) .ne. nf90_noerr) stop 2
  if (nf90_get_meta_block_size(retrieved) .ne. nf90_noerr) stop 2
  if (retrieved .ne. 0) stop 3
  print *, '*** PASS'

  print *, '*** SUCCESS'
end program f90tst_meta_block_size

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example program which writes some 4D pressure and
C     temperatures. It is intended to illustrate the use of the netCDF
C     fortran 77 API. The companion program pres_temp_4D_rd.f shows how
C     to read the netCDF data file created by this program.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: pres_temp_4D_wr.f,v 1.12 2007/02/14 20:59:20 ed Exp $

      program pres_temp_4D_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME = 'pres_temp_4D.nc')
      integer ncid

C     We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')
      integer lvl_dimid, lon_dimid, lat_dimid, rec_dimid

C     The start and count arrays will tell the netCDF library where to
C     write our data.
      integer start(NDIMS), count(NDIMS)

C     These program variables hold the latitudes and longitudes.
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will create two netCDF variables, one each for temperature and
C     pressure fields.
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will write out. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_out(NLONS, NLATS, NLVLS)
      real temp_out(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to construct some latitude and longitude data for this
C     example.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Create pretend data. If this wasn't an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      i = 0
      do lvl = 1, NLVLS
         do lat = 1, NLATS
            do lon = 1, NLONS
               pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
               temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
               i = i + 1
            end do
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions. The record dimension is defined to have
C     unlimited length - it can grow as needed. In this example it is
C     the time dimension.
      retval = nf_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, REC_NAME, NF_UNLIMITED, rec_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. We will only define coordinate
C     variables for lat and lon.  Ordinarily we would need to provide
C     an array of dimension IDs for each variable's dimensions, but
C     since coordinate variables only have one dimension, we can
C     simply provide the address of that dimension ID (lat_dimid) and
C     similarly for (lon_dimid).
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate variables.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the dimids of the dimensions of
C     the netCDF variables. Both of the netCDF variables we are creating
C     share the same four dimensions. In Fortran, the unlimited
C     dimension must come last on the list of dimids.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      dimids(3) = lvl_dimid
      dimids(4) = rec_dimid

C     Define the netCDF variables for the pressure and temperature data.
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the netCDF variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     These settings tell netcdf to write one timestep of data. (The
C     setting of start(4) inside the loop below tells netCDF which
C     timestep to write.)
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays only hold one timestep worth
C     of data. We will just rewrite the same data for each timestep. In
C     a real application, the data would change between timesteps.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_put_vara_real(ncid, pres_varid, start, count, 
     +        pres_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_put_vara_real(ncid, temp_varid, start, count,
     +        temp_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
      end do

C     Close the file. This causes netCDF to flush all buffers and make
C     sure your data are really written to disk.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
      print *,'*** SUCCESS writing example file', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.
      
C     This is a simple example which reads a small dummy array, from a
C     netCDF data file created by the companion program simple_xy_wr.f.
      
C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program simple_xy_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read. 
      character*(*) FILE_NAME
      parameter (FILE_NAME='simple_xy_nc4.nc')

C     We are reading 2D data, a 12 x 6 grid. 
      integer NX, NY
      parameter (NX = 60, NY = 120)
      integer data_in(NY, NX)

C     This will be the netCDF ID for the file and data variable.
      integer ncid, varid

C     Loop indexes, and error handling.
      integer x, y, retval

C     Open the file. NF_NOWRITE tells netCDF we want read-only access to
C     the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Get the varid of the data variable, based on its name.
      retval = nf_inq_varid(ncid, 'data', varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the data.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data.
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. (x - 1) * NY + (y - 1)) then
               print *, 'data_in(', y, ', ', x, ') = ', data_in(y, x)
               stop 2
            end if
         end do
      end do

C     Close the file, freeing all resources.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

      print *,'*** SUCCESS reading example file ', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

!********************************************************************
!   Copyright 1993, UCAR/Unidata
!   See netcdf/COPYRIGHT file for copying and redistribution conditions.
!   Russ Rew 1993
!********************************************************************

!
!     program to test the netCDF-2 Fortran API
!
      program ftest

      include 'netcdf.inc'

!     name of first test cdf
      character*31 name
!     name of second test cdf
      character*31 name2
      
!     Returned error code.
      integer iret 
!     netCDF ID
      integer ncid
!     ID of dimension lat
      integer  latdim
!     ID of dimension lon
      integer londim
!     ID of dimension level
      integer leveldim
!     ID of dimension time
      integer timedim
!     ID of dimension len
      integer lendim

!     Count the errors.
      integer nfails

!     variable used to control error-handling behavior
      integer ncopts
      integer dimsiz(MAXNCDIM)
!      allowable roundoff 
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      data name/'ftest.nc'/
      data name2/'fcopy.nc'/

      print *, ''
      print *,'*** Testing netCDF-2 Fortran 77 API.'

100   format(' *** testing ', a, ' ...')
!     set error-handling to verbose and non-fatal
      ncopts = NCVERBOS
      call ncpopt(ncopts)

!     This will be a count of how many failures we experience.
      nfails = 0

!     create a netCDF named 'test.nc'
      write(*,100) 'nccre'
      ncid = nccre(name, NCCLOB, iret)
      if (ncid .eq. -1) then nfails = nfails + 1

!     test ncddef
      write(*,100) 'ncddef'
      call tncddef(ncid, nfails)

!     test ncvdef
      write(*,100) 'ncvdef'
      call tncvdef(ncid, nfails)

!     test ncapt
      write(*, 100) 'ncapt, ncaptc'
      call tncapt(ncid, nfails)

!     close 'test.nc'
      write(*, 100) 'ncclos'
      call ncclos(ncid, iret)
      if (ncid .eq. -1) then nfails = nfails + 1

!     test ncvpt1
      write(*, 100) 'ncvpt1'
      call tncvpt1(name, nfails)

!     test ncvgt1
      write(*, 100) 'ncvgt1'
      call tncvgt1(name, nfails)

!     test ncvpt
      write(*, 100) 'ncvpt'
      call tncvpt(name, nfails)

!     test ncinq
      write(*, 100) 'ncopn, ncinq, ncdinq, ncvinq, ncanam, ncainq'
      call tncinq(name, nfails)

!     test ncvgt
      write(*, 100) 'ncvgt, ncvgtc'
      call tncvgt(name, nfails)

!     test ncagt
      write(*, 100) 'ncagt, ncagtc'
      call tncagt(name, nfails)

!     test ncredf
      write(*, 100) 'ncredf, ncdren, ncvren, ncaren, ncendf'
      call tncredf(name, nfails)

      call tncinq(name, nfails)

!     test ncacpy
      write(*, 100) 'ncacpy'
      call tncacpy(name, name2, nfails)

!     test ncadel
      write(*, 100) 'ncadel'
      call tncadel(name2, nfails)

!     test fill values
      write(*, 100) 'fill values'
      call tfills(nfails)

      print *,'Total number of failures: ', nfails
      if (nfails .ne. 0) stop 2

      print *,'*** SUCCESS!'

      end
!
!     subroutine to test ncacpy
!
      subroutine tncacpy(iname, oname, nfails)
      include 'netcdf.inc'
      character*31 iname, oname
      integer ndims, nvars, natts, recdim, iret
      character*31 vname, attnam
      integer attype, attlen
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts
      integer lenstr
!     existing netCDF id
      integer incdf
!     netCDF id of the output netCDF file to which the attribute
!     will be copied
      integer outcdf

      integer mattlen
      parameter (mattlen = 80)
      character*80 charval
      doubleprecision doubval(2)
      real flval(2)
      integer lngval(2)
      NCSHORT_T shval(2)
      integer i, j, k
      character*31 varnam, attname(2,7), gattnam(2)
      NCBYTE_T bytval(2)
      common /atts/attname, gattnam
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)
      character*31 gavalue(2), cavalue(2)
      real epsilon

      data bvalidrg/-127,127/
      data svalidrg/-100,100/
      data lvalidrg/0,360/
      data rvalidrg/0.0, 5000.0/
      data dvalidrg/0D0,500D0/
      data gavalue/'NWS', '88/10/25 12:00:00'/
      data cavalue/'test string', 'a'/
      data lenstr/80/   
      data epsilon /.000001/

      incdf = ncopn(iname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1

      outcdf = nccre(oname, NCCLOB, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call tncddef(outcdf, nfails)
      call tncvdef(outcdf, nfails)
      call ncinq (incdf, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 5 j = 1, natts
         call ncanam (incdf, NCGLOBAL, j, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncacpy (incdf, NCGLOBAL, attnam, outcdf, NCGLOBAL, iret)
         if (iret .ne. 0) nfails = nfails + 1
 5    continue
      do 10 i = 1, nvars
         call ncvinq (incdf, i, vname, vartyp, nvdims,
     +        vdims, nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 20 k = 1, nvatts
            call ncanam (incdf, i, k, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncacpy (incdf, i, attnam, outcdf, i, iret)
            if (iret .ne. 0) nfails = nfails + 1
 20      continue
 10   continue
!     
!     get global attributes first
!     
      do 100 i = 1, natts
         call ncanam (outcdf, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncainq (outcdf, NCGLOBAL, attnam, attype, attlen,
     +        iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attlen .gt. mattlen) then
            write (*,*) 'global attribute too big!', attlen, mattlen
            stop 2
         else if (attype .eq. NCBYTE) then
            call ncagt (outcdf, NCBYTE, attnam, bytval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCCHAR) then
            call ncagtc (outcdf, NCGLOBAL, attnam, charval, 
     +           lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. gattnam(i)) write(*,*) 'error in ncagt G'
            if (charval .ne. gavalue(i))
     + write(*,*) 'error in ncagt G2', lenstr, charval, gavalue(i)
                  charval = ' '
         else if (attype .eq. NCSHORT) then
            call ncagt (outcdf, NCGLOBAL, attnam, shval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCLONG) then
            call ncagt (outcdf, NCGLOBAL, attnam, lngval, iret)            
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCFLOAT) then
            call ncagt (outcdf, NCGLOBAL, attnam, flval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else 
            call ncagt (outcdf, NCGLOBAL, attnam, doubval,iret)          
            if (iret .ne. 0) nfails = nfails + 1
         end if
 100   continue
!
!     get variable attributes
!
      do 200 i = 1, nvars
         call ncvinq (outcdf, i, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 250 j = 1, nvatts
            call ncanam (outcdf, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (outcdf, i, attnam, attype, attlen,
     +                   iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attlen .gt. mattlen) then
               write (*,*) 'variable ', i,  'attribute too big !'
               stop 2
            else 
               if (attype .eq. NCBYTE) then
                  call ncagt (outcdf, i, attnam, bytval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i))
     +               write(*,*) 'error in ncagt BYTE N'
                  if (bytval(j) .ne. bvalidrg(j)) write(*,*)
     + 'ncacpy: byte ', bytval(j), ' .ne. ', bvalidrg(j)
               else if (attype .eq. NCCHAR) then
                  call ncagtc (outcdf, i, attnam, charval, 
     +                 lenstr, iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt CHAR N'
                  if (charval .ne. cavalue(j)) 
     +               write(*,*) 'error in ncagt'
                  charval = ' '
               else if (attype .eq. NCSHORT) then
                  call ncagt (outcdf, i, attnam, shval, 
     +                 iret)  
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt SHORT N'
                  if (shval(j) .ne. svalidrg(j)) then
                     write(*,*) 'error in ncagt SHORT'
                  end if
               else if (attype .eq. NCLONG) then
                  call ncagt (outcdf, i, attnam, lngval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt LONG N'
                  if (lngval(j) .ne. lvalidrg(j)) 
     +               write(*,*) 'error in ncagt LONG'
               else if (attype .eq. NCFLOAT) then
                  call ncagt (outcdf, i, attnam, flval, 
     +                 iret)            
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt FLOAT N'
                  if (flval(j) .ne. rvalidrg(j)) 
     +               write(*,*) 'error in ncagt FLOAT'
               else if (attype .eq. NCDOUBLE) then
                  call ncagt (outcdf, i, attnam, doubval,
     +                 iret)          
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt DOUBLE N'
                  if ( abs(doubval(j) - dvalidrg(j)) .gt. epsilon)
     + write(*,*) 'error in ncagt DOUBLE'
               end if
            end if
 250     continue
 200   continue
      call ncclos(incdf, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos(outcdf, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end


      
!     
!     subroutine to test ncadel
!
      subroutine tncadel (cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname

      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer ncid, iret, i, j
      integer ndims, nvars, natts, recdim
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts
      character*31 varnam, attnam

      ncid = ncopn(cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     put cdf in define mode
      call ncredf (ncid,iret)
      if (iret .ne. 0) nfails = nfails + 1
!     get number of global attributes
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 10 i = natts, 1, -1
!     get name of global attribute
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
!     delete global attribute
         call ncadel (ncid, NCGLOBAL, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
 10   continue

      do 100 i = 1, nvars
!     get number of variable attributes
         call ncvinq (ncid, i, varnam, vartyp, nvdims, vdims,
     +        nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 200 j = nvatts, 1, -1
            call ncanam (ncid, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncadel (ncid, i, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
 200     continue
 100  continue
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (natts .ne. 0) write(*,*) 'error in ncadel'
!     put netCDF into data mode
      call ncendf (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

!
!     subroutine to test ncagt and ncagtc

      subroutine tncagt(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname
            
!     maximum length of an attribute
      integer mattlen
      parameter (mattlen = 80)
      integer ncid, ndims, nvars, natts, recdim
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer i, j
      integer attype, attlen, lenstr, iret
      character*31 attnam
      character*80 charval
      doubleprecision doubval(2)
      real flval(2)
      integer lngval(2)
      NCSHORT_T shval(2)
      NCBYTE_T bytval(2)
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts

      character*31 varnam, attname(2,7), gattnam(2)
      common /atts/attname, gattnam
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)
      character*31 gavalue(2), cavalue(2)
      real epsilon

      data bvalidrg/-127,127/
      data svalidrg/-100,100/
      data lvalidrg/0,360/
      data rvalidrg/0.0, 5000.0/
      data dvalidrg/0D0,500D0/
      data gavalue/'NWS', '88/10/25 12:00:00'/
      data cavalue/'test string', 'a'/
      data lenstr/80/   
      data epsilon /.000001/
      
      ncid = ncopn (cdfname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     
!     get global attributes first
!     
      do 10 i = 1, natts
!     get name of attribute
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
!     get attribute type and length
         call ncainq (ncid, NCGLOBAL, attnam, attype, attlen,
     +        iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attlen .gt. mattlen) then
            write (*,*) 'global attribute too big!'
            stop 2
         else if (attype .eq. NCBYTE) then
            call ncagt (ncid, NCBYTE, attnam, bytval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCCHAR) then
            call ncagtc (ncid, NCGLOBAL, attnam, charval, 
     +           lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. gattnam(i)) write(*,*) 'error in ncagt'
            if (charval .ne. gavalue(i)) write(*,*) 'error in ncagt'
            charval = '                                        '
         else if (attype .eq. NCSHORT) then
            call ncagt (ncid, NCGLOBAL, attnam, shval, iret) 
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCLONG) then
            call ncagt (ncid, NCGLOBAL, attnam, lngval, iret)            
            if (iret .ne. 0) nfails = nfails + 1
         else if (attype .eq. NCFLOAT) then
            call ncagt (ncid, NCGLOBAL, attnam, flval, iret)
            if (iret .ne. 0) nfails = nfails + 1
         else 
            call ncagt (ncid, NCGLOBAL, attnam, doubval,iret)          
            if (iret .ne. 0) nfails = nfails + 1
         end if
 10   continue

!
!     get variable attributes
!
      do 20 i = 1, nvars
         call ncvinq (ncid, i, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         do 25 j = 1, nvatts
            call ncanam (ncid, i, j, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (ncid, i, attnam, attype, attlen,
     +                   iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attlen .gt. mattlen) then
               write (*,*) 'variable ', i,  'attribute too big !'
               stop 2
            else 
               if (attype .eq. NCBYTE) then
                  call ncagt (ncid, i, attnam, bytval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt BYTE name'
                  if (bytval(j) .ne. bvalidrg(j)) write(*,*)
     + 'ncacpy: byte ', bytval(j), ' .ne. ', bvalidrg(j)
               else if (attype .eq. NCCHAR) then
                  call ncagtc (ncid, i, attnam, charval, 
     +                 lenstr, iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt CHAR name'
                  if (charval .ne. cavalue(j)) 
     +               write(*,*) 'error in ncagt CHAR name'
                 charval = '                                        '
               else if (attype .eq. NCSHORT) then
                  call ncagt (ncid, i, attnam, shval, 
     +                 iret)  
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt SHORT name'
                  if (shval(j) .ne. svalidrg(j)) then
                     write(*,*) 'error in ncagt SHORT'
                  end if
               else if (attype .eq. NCLONG) then
                  call ncagt (ncid, i, attnam, lngval, 
     +                 iret)
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt LONG name'
                  if (lngval(j) .ne. lvalidrg(j)) 
     +               write(*,*) 'error in ncagt LONG'
               else if (attype .eq. NCFLOAT) then
                  call ncagt (ncid, i, attnam, flval, 
     +                 iret)            
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt FLOAT name'
                  if (flval(j) .ne. rvalidrg(j)) 
     +               write(*,*) 'error in ncagt FLOAT'
               else if (attype .eq. NCDOUBLE) then
                  call ncagt (ncid, i, attnam, doubval,
     +                 iret)          
                  if (iret .ne. 0) nfails = nfails + 1
                  if (attnam .ne. attname(j,i)) 
     +               write(*,*) 'error in ncagt DOUBLE name'
                  if ( abs(doubval(j) - dvalidrg(j)) .gt. epsilon)
     + write(*,*) 'error in ncagt DOUBLE'
               end if
            end if
 25      continue
 20   continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!
!     subroutine to test ncapt
!
      subroutine tncapt (ncid, nfails)
      include 'netcdf.inc'
      integer ncid, iret

! attribute vectors
      NCSHORT_T svalidrg(2)
      real rvalidrg(2)
      integer lvalidrg(2)
      doubleprecision dvalidrg(2)
      NCBYTE_T bvalidrg(2)

!     variable ids
      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

! assign attributes
      
!
!     byte
!
      
      bvalidrg(1) = -127
      bvalidrg(2) =  127
      call ncapt (ncid, bid, 'validrange', NCBYTE, 2,
     +bvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     short
!

      svalidrg(1) = -100
      svalidrg(2) = 100
      call ncapt (ncid, sid, 'validrange', NCSHORT, 2, 
     +svalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     long
!

      lvalidrg(1) = 0
      lvalidrg(2) = 360
      call ncapt (ncid, lid, 'validrange', NCLONG, 2,
     +lvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1
      
!
!     float
!

      rvalidrg(1) = 0.0
      rvalidrg(2) = 5000.0
      call ncapt (ncid, fid, 'validrange', NCFLOAT, 2,
     +rvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     double
!

      dvalidrg(1) = 0D0
      dvalidrg(2) = 500D0
      call ncapt (ncid, did, 'validrange', NCDOUBLE, 2,
     +dvalidrg, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     global
!

      call ncaptc (ncid, NCGLOBAL, 'source', NCCHAR, 3, 
     +'NWS', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaptc (ncid, NCGLOBAL, 'basetime', NCCHAR, 17, 
     +'88/10/25 12:00:00', iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     char
!

      call ncaptc (ncid, chid, 'longname', NCCHAR, 11,
     +'test string', iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncaptc (ncid, chid, 'id', NCCHAR, 1,
     +'a', iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end

!
!     initialize variables in labelled common blocks
!
      block data
      common /cdims/ dimnam
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /varn/varnam
      common /atts/attname, gattnam
      integer  latdim, londim, leveldim, timedim, lendim

!     should include 'netcdf.inc' for MAXNCDIM, but it has EXTERNAL
!     declaration, which is not permitted in a BLOCK DATA unit.

      integer dimsiz(1024)
      character*31 dimnam(1024)
      character*31 varnam(7)
      character*31 attname(2,7)
      character*31 gattnam(2)

      data dimnam /'time', 'lat', 'lon', 'level',
     + 'length', 1019*'0'/
      data dimsiz /4, 5, 5, 4, 80, 1019*0/
      data varnam/'bytev', 'shortv', 'longv', 'floatv', 'doublev', 
     + 'chv', 'cv'/
      
      data attname/'validrange', '0', 'validrange', '0', 'validrange',
     + '0', 'validrange', '0', 'validrange', '0', 'longname', 'id',
     + '0', '0'/
      data gattnam/'source','basetime'/
      end


!
!     subroutine to test ncddef
!

      subroutine tncddef(ncid, nfails)
      include 'netcdf.inc'
      integer ncid

!     sizes of dimensions of 'test.nc' and 'copy.nc'
      integer  ndims
      parameter(ndims=5)
! dimension ids
      integer  latdim, londim, leveldim, timedim, lendim
      integer iret
!     function to define a netCDF dimension
      integer dimsiz(MAXNCDIM)
      character*31 dimnam(MAXNCDIM)
      
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /cdims/ dimnam

! define dimensions
      timedim = ncddef(ncid, dimnam(1), NCUNLIM, iret)
      if (iret .ne. 0) nfails = nfails + 1
      latdim = ncddef(ncid, dimnam(2), dimsiz(2), iret)
      if (iret .ne. 0) nfails = nfails + 1
      londim = ncddef(ncid, dimnam(3), dimsiz(3), iret)
      if (iret .ne. 0) nfails = nfails + 1
      leveldim = ncddef(ncid, dimnam(4), dimsiz(4), iret)
      if (iret .ne. 0) nfails = nfails + 1
      lendim = ncddef(ncid, dimnam(5), dimsiz(5), iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!
!     subroutine to test ncinq, ncdinq, ncdid, ncvinq, ncanam
!     and ncainq
!
      subroutine tncinq(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname

!     netCDF id
      integer ncid
!     returned number of dimensions
      integer ndims
!     returned number of variables
      integer nvars
!     returned number of global attributes
      integer natts
!     returned id of the unlimited dimension
      integer recdim
!     returned error code
      integer iret
!     returned name of record dimension
      character*31 recnam
!     returned size of record dimension
      integer recsiz
!     loop control variables
      integer i, j, k
!     returned size of dimension
      integer dsize
!     returned dimension ID
      integer dimid
!     returned dimension name
      character*31 dname
!     returned variable name
      character*31 vname
!     returned attribute name
      character*31 attnam
!     returned netCDF datatype of variable
      integer vartyp
!     returned number of variable dimensions
      integer nvdims
!     returned number of variable attributes
      integer nvatts
!     returned vector of nvdims dimension IDS corresponding to the
!     variable dimensions
      integer vdims(MAXNCDIM)
!     returned attribute length
      integer attlen
!     returned attribute type
      integer attype
      character*31 dimnam(MAXNCDIM)
      character*31 varnam(7)
      character*31 attname(2,7)
      character*31 gattnam(2)
      integer vdlist(5,7), vtyp(7), vndims(7), vnatts(7)
      integer attyp(2,7),atlen(2,7),gattyp(2),gatlen(2)
      integer timedim,latdim,londim,leveldim,lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      common /varn/varnam
      common /atts/attname, gattnam
      common /cdims/ dimnam

      data vdlist/1,0,0,0,0,1,0,0,0,0,2,0,0,0,0,4,3,2,1,0,4,3,2,1,0,
     + 5,1,0,0,0,1,0,0,0,0/
      data vtyp/NCBYTE, NCSHORT, NCLONG, NCFLOAT, NCDOUBLE, NCCHAR,
     + NCCHAR/
      data vndims/1,1,1,4,4,2,1/
      data vnatts/1,1,1,1,1,2,0/
      data attyp/NCBYTE, 0, NCSHORT, 0, NCLONG, 0, NCFLOAT, 0,
     + NCDOUBLE, 0, NCCHAR, NCCHAR, 0, 0/
      data atlen/2,0,2,0,2,0,2,0,2,0,11,1, 0, 0/
      data gattyp/NCCHAR,NCCHAR/
      data gatlen/3,17/

      ncid = ncopn (cdfname, NCNOWRIT, iret)
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (ndims .ne. 5) write(*,*) 'error in ncinq or ncddef'
      if (nvars .ne. 7) write(*,*) 'error in ncinq or ncvdef'
      if (natts .ne. 2) write(*,*) 'error in ncinq or ncapt'
      call ncdinq (ncid, recdim, recnam, recsiz, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (recnam .ne. 'time') write(*,*) 'error: bad recdim from ncinq'
!
!     dimensions
!
      do 10 i = 1, ndims
         call ncdinq (ncid, i, dname, dsize, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (dname .ne. dimnam(i)) 
     +      write(*,*) 'error in ncdinq or ncddef, dname=', dname
         if (dsize .ne. dimsiz(i)) 
     +      write(*,*) 'error in ncdinq or ncddef, dsize=',dsize
         dimid = ncdid (ncid, dname, iret)
         if (dimid .ne. i) write(*,*)
     +      'error in ncdinq or ncddef, dimid=', dimid
 10   continue
!
!     variables
!
      do 30 i = 1, nvars
         call ncvinq (ncid, i, vname, vartyp, nvdims,
     +        vdims, nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (vname .ne. varnam(i)) 
     +      write(*,*) 'error: from ncvinq, wrong name returned: ', 
     +         vname, ' .ne. ', varnam(i)
         if (vartyp .ne. vtyp(i)) 
     +      write(*,*) 'error: from ncvinq, wrong type returned: ', 
     +         vartyp, ' .ne. ', vtyp(i)
         if (nvdims .ne. vndims(i)) 
     +      write(*,*) 'error: from ncvinq, wrong num dims returned: ', 
     +         vdims, ' .ne. ', vndims(i)
         do 35 j = 1, nvdims
            if (vdims(j) .ne. vdlist(j,i)) 
     +         write(*,*) 'error: from ncvinq wrong dimids: ',
     +            vdims(j), ' .ne. ', vdlist(j,i)
 35      continue
         if (nvatts .ne. vnatts(i)) 
     +      write(*,*) 'error in ncvinq or ncvdef'
!
!     attributes
!
         do 45 k = 1, nvatts
            call ncanam (ncid, i, k, attnam, iret)
            if (iret .ne. 0) nfails = nfails + 1
            call ncainq (ncid, i, attnam, attype, attlen, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (attnam .ne. attname(k,i)) 
     +         write(*,*) 'error in ncanam or ncapt'
            if (attype .ne. attyp(k,i)) 
     +         write(*,*) 'error in ncainq or ncapt'
            if (attlen .ne. atlen(k,i)) 
     +         write(*,*) 'error in ncainq or ncapt'
 45      continue
 30   continue
      do 40 i = 1, natts
         call ncanam (ncid, NCGLOBAL, i, attnam, iret)
         if (iret .ne. 0) nfails = nfails + 1
         call ncainq (ncid, NCGLOBAL, attnam, attype, attlen, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (attnam .ne. gattnam(i)) 
     +      write(*,*) 'error in ncanam or ncapt'
         if (attype .ne. gattyp(i)) 
     +      write(*,*) 'error in ncainq or ncapt'
         if (attlen .ne. gatlen(i)) 
     +      write(*,*) 'error in ncainq or ncapt'
 40   continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
      
      
      
!     subroutine to test ncredf, ncdren, ncvren, ncaren, and 
!     ncendf

      subroutine tncredf(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname
      character*31 attname(2,7)
      character*31 gattnam(2)
      common /atts/attname, gattnam
      common /cdims/ dimnam
      character*31 dimnam(MAXNCDIM)
      character*31 varnam(7)
      common /varn/varnam
      integer ncid, iret, latid, varid

      dimnam(2) = 'latitude'
      varnam(4) = 'realv'
      attname(1,6) = 'stringname'
      gattnam(1) = 'agency'
      ncid = ncopn(cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncredf(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      latid = ncdid(ncid, 'lat', iret)
      call ncdren(ncid, latid, 'latitude', iret)
      if (iret .ne. 0) nfails = nfails + 1
      varid = ncvid(ncid, 'floatv', iret)
      call ncvren(ncid, varid, 'realv', iret)
      if (iret .ne. 0) nfails = nfails + 1
      varid = ncvid(ncid, 'chv', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaren(ncid, varid, 'longname', 'stringname', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncaren(ncid, NCGLOBAL, 'source', 'agency', iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncendf(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end
!     
!     subroutine to test ncvdef
!

      subroutine tncvdef(ncid, nfails)
      include 'netcdf.inc'
      integer ncid

!     function to define a netCDF variable
      integer dimsiz(MAXNCDIM)
      integer  latdim, londim, leveldim, timedim, lendim
      common /dims/timedim, latdim, londim, leveldim, lendim, 
     + dimsiz

! variable ids
      integer  bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

! variable shapes
      integer  bdims(1), fdims(4), ddims(4), ldims(1), sdims(1) 
      integer chdims(2), cdims(1)

      integer iret
!
! define variables
!
!     byte
! 
      bdims(1) = timedim
      bid = ncvdef(ncid, 'bytev', NCBYTE, 1, bdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     short
!
      sdims(1) = timedim
      sid = ncvdef (ncid, 'shortv', NCSHORT, 1, sdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     long
!
      ldims(1) = latdim
      lid = ncvdef (ncid, 'longv', NCLONG, 1, ldims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     float
!
      fdims(4) = timedim
      fdims(1) = leveldim
      fdims(2) = londim
      fdims(3) = latdim
      fid = ncvdef (ncid, 'floatv', NCFLOAT, 4, fdims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     double
!
      ddims(4) = timedim
      ddims(1) = leveldim
      ddims(2) = londim
      ddims(3) = latdim
      did = ncvdef (ncid, 'doublev', NCDOUBLE, 4, ddims, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     char
!
      chdims(2) = timedim
      chdims(1) = lendim
      chid = ncvdef (ncid, 'chv', NCCHAR, 2, chdims, iret)
      if (iret .ne. 0) nfails = nfails + 1

      cdims(1) = timedim
      cid = ncvdef (ncid, 'cv', NCCHAR, 1, cdims, iret)
      if (iret .ne. 0) nfails = nfails + 1


      return
      end


!    
!     subroutine to test ncvgt and ncvgtc
!
      subroutine tncvgt(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname

      integer ndims, times, lats, lons, levels, lenstr
      parameter (times=4, lats=5, lons=5, levels=4)

      integer start(4), count(4)
      integer ncid, iret, i, m
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz

      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      integer itime, ilev, ilat, ilon

!     arrays of data values to be read
      NCBYTE_T barray(times), byval(times)
      NCSHORT_T sarray(times), shval(times)
      integer larray(lats)
      real farray(levels, lats, lons, times)
      doubleprecision darray(levels, lats, lons, times)
!     character array of data values to be read
      character*31 string
      character*31 varnam
      integer nvars, natts, recdim
      integer vartyp, nvdims, vdims(MAXVDIMS), nvatts

      data start/1,1,1,1/
      data count/levels, lats, lons, times/
      data byval /97, 98, 99, 100/
      data shval /10, 11, 12, 13/

      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1
!     get number of variables in netCDF
      call ncinq (ncid, ndims, nvars, natts, recdim, iret)
      if (iret .ne. 0) nfails = nfails + 1
      do 5 m = 1, nvars-1
!     get variable name, datatype, number of dimensions
!     vector of dimension ids, and number of variable attributes
         call ncvinq (ncid, m, varnam, vartyp, nvdims, vdims,
     +                nvatts, iret)
         if (iret .ne. 0) nfails = nfails + 1
         if (vartyp .eq. NCBYTE) then
!
!     byte
!
            count(1) = times
            call ncvgt (ncid, m, start, count, barray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 10 i = 1, times
               if (barray(i) .ne. byval(i)) then 
                  write(*,*) 'ncvgt of bytes, got ', barray(i), ' .ne. '
     +                       , byval(i)
               end if
 10         continue
         else if (vartyp .eq. NCSHORT) then
!
!     short
!
            count(1) = times
            call ncvgt (ncid, m, start, count, sarray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 20 i = 1, times
               if (sarray(i) .ne. shval(i)) then 
                  write(*,*) 'ncvgt of short, got ', sarray(i), ' .ne. '
     +                       , shval(i)
               end if
 20         continue
         else if (vartyp .eq. NCLONG) then
!     
!     long
!
            count(1) = lats
            call ncvgt (ncid, m, start, count, larray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            do 30 i = 1, lats
               if (larray(i) .ne. 1000) then 
                  write(*,*) 'long error in ncvgt'
               end if
 30         continue
         else if (vartyp .eq. NCFLOAT) then
!     
!     float
!
            count(1) = levels
            call ncvgt (ncid, m, start, count, farray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            i = 0
            do 40 itime = 1,times
               do 41 ilon = 1, lons
                  do 42 ilat = 1, lats
                     do 43 ilev = 1, levels
                        i = i + 1
                        if (farray(ilev, ilat, ilon, itime) .ne.
     + real(i)) then
                           write (*,*) 'float error in ncvgt'
                        end if
 43         continue
 42         continue
 41         continue
 40         continue
         else if (vartyp .eq. NCDOUBLE) then
!
!     double
!
            count(1) = levels
            call ncvgt (ncid, m, start, count, darray, iret)
            if (iret .ne. 0) nfails = nfails + 1
            i = 0
            do 50 itime = 1, times
               do 51 ilon = 1, lons
                  do 52 ilat = 1, lats
                     do 53 ilev = 1, levels
                        i = i + 1
                        if (darray(ilev, ilat, ilon, itime) .ne.
     +                       real (i)) then
                           write(*,*) 'double error in ncvgt:', i,
     +              darray(ilev, ilat, ilon, itime), '.ne.', 
     +              real (i)
                        end if
 53         continue
 52         continue
 51         continue
 50         continue
         else 
!     
!     char
!
            count(1) = 3
            count(2) = 4
            lenstr = 31
            call ncvgtc (ncid, m, start, count, string, lenstr, iret)
            if (iret .ne. 0) nfails = nfails + 1
            if (string .ne. 'testhikin of') then 
               write(*,*) 'error in ncvgt, returned string =', string
            end if
         end if
 5    continue
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

      
      subroutine tncvgt1(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname

      integer ncid, iret
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz

      integer bindx(1), sindx(1), lindx(1), findx(4), dindx(4), cindx(1)

      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

      NCBYTE_T bvalue
      NCSHORT_T svalue
      integer lvalue
      real fvalue
      doubleprecision dvalue
      character*1 c
      real epsilon
      doubleprecision onethird

      data epsilon /.000001/
      data lindx/1/, bindx/1/, sindx/1/, findx/1,1,1,1/
     +dindx/1,1,1,1/, cindx/1/
      data onethird/0.3333333333D0/
      
      ncid = ncopn (cdfname, NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     test ncvgt1 for byte
!
      call ncvgt1 (ncid, bid, bindx, bvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (bvalue .ne. ichar('z')) write(*,*) 'error in ncvgt1 byte:',
     + bvalue, ' .ne.', ichar('z')
!
!     test ncvgt1 for short
!
      call ncvgt1 (ncid, sid, sindx, svalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (svalue .ne. 10) write(*,*) 'error in ncvgt1 short:',
     + svalue, ' .ne.', 10
!     
!     test ncvgt1 for long
!
      call ncvgt1 (ncid, lid, lindx, lvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (lvalue .ne. 1000) write(*,*) 'error in ncvgt1 long:',
     + lvalue,  ' .ne.', 1000
!
!     test ncvgt1 for float
!
      call ncvgt1 (ncid, fid, findx, fvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (abs(fvalue - 3.14159) .gt. epsilon) 
     +   write(*,*) 'error in ncvgt 1 float:', fvalue, 
     +      ' not close to', 3.14159
!
!     test ncvgt1 for double
!
      call ncvgt1 (ncid, did, dindx, dvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (abs(dvalue - onethird) .gt. epsilon) write(*,*)
     + 'error in ncvgt1 double:', dvalue, ' not close to',
     +     onethird
!
!     test ncvg1c for char
!
      call ncvg1c (ncid, cid, cindx, c, iret)
      if (iret .ne. 0) nfails = nfails + 1
      if (c .ne. 'a') write(*,*) 'error in ncvg1c'
      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1
      return
      end

      
      
!
!     subroutine to test ncvpt and ncvptc
!
      subroutine tncvpt(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname

!     size of dimensions
      integer times, lats, lons, levels
      parameter (times=4, lats=5, lons=5, levels=4)

      integer ncid, iret
!     loop control variables
      integer itime, ilev, ilon, ilat, i
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim,
     + dimsiz
      integer lenstr
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid

!     vector of integers specifying the corner of the  hypercube
!     where the first of the data values will be written
      integer start(4)
!     vector of integers specifying the edge lengths from the
!     corner of the hypercube where the first of the data values
!     will be written
      integer count(4)

!     arrays of data values to be written
      NCBYTE_T barray(times)
      NCSHORT_T sarray(times)
      integer larray(lats)
      real farray(levels, lats, lons, times)
      doubleprecision darray(levels, lats, lons, times)
      character*31 string

      data start/1,1,1,1/
      data count/levels, lats, lons, times/
      data barray /97, 98, 99, 100/
      data sarray /10, 11, 12, 13/

      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     byte
!
      count(1) = times
      call ncvpt (ncid, bid, start, count, barray, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     short
!
      count(1) = times
      call ncvpt (ncid, sid, start, count, sarray, iret)
      if (iret .ne. 0) nfails = nfails + 1
!
!     long
!
      do 30 i = 1,lats
         larray(i) = 1000
 30   continue
      count(1) = lats
      call ncvpt (ncid, lid, start, count, larray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     float
!
      i = 0
      do 40 itime = 1,times
         do 41 ilon = 1, lons
            do 42 ilat = 1, lats
               do 43 ilev = 1, levels
                  i = i + 1
                  farray(ilev, ilat, ilon, itime) = real (i)
 43   continue
 42   continue
 41   continue
 40   continue
      count(1) = levels
      call ncvpt (ncid, fid, start, count, farray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     double
!
      i = 0
      do 50 itime = 1, times
         do 51 ilon = 1, lons
            do 52 ilat = 1, lats
               do 53 ilev = 1, levels
                  i = i + 1
                  darray(ilev, ilat, ilon, itime) = real (i)
 53   continue
 52   continue
 51   continue
 50   continue
      count(1) = levels
      call ncvpt (ncid, did, start, count, darray, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     char
!
      start(1) = 1
      start(2) = 1
      count(1) = 4
      count(2) = 4
      lenstr = 31       
      string = 'testthiskind of '
      call ncvptc (ncid, chid,start, count, string, lenstr, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncclos(ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end


      subroutine tncvpt1(cdfname, nfails)
      include 'netcdf.inc'
      character*31 cdfname


      integer iret, ncid
      integer  latdim, londim, leveldim, timedim, lendim
      integer dimsiz(MAXNCDIM)
      common /dims/timedim, latdim, londim, leveldim, lendim, 
     + dimsiz

      integer bindx(1), sindx(1), lindx(1), findx(4), dindx(4), cindx(1)

      integer lvalue
      NCSHORT_T svalue
      NCBYTE_T bvalue
      doubleprecision onethird
      integer bid, sid, lid, fid, did, cid, chid
      common /vars/bid, sid, lid, fid, did, cid, chid
      data lindx/1/, bindx/1/, sindx/1/, findx/1,1,1,1/
     +dindx/1,1,1,1/, cindx/1/
      data lvalue /1000/
      data svalue/10/
      data onethird/0.3333333333D0/

      bvalue = ichar('z')
      
      ncid = ncopn (cdfname, NCWRITE, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for byte
!
      call ncvpt1 (ncid, bid, bindx, bvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for short
!
      call ncvpt1 (ncid, sid, sindx, svalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!     
!     test ncvpt1 for long
!
      call ncvpt1 (ncid, lid, lindx, lvalue, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for float
!
      call ncvpt1 (ncid, fid, findx, 3.14159, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvpt1 for double
!
      call ncvpt1 (ncid, did, dindx, onethird, iret)
      if (iret .ne. 0) nfails = nfails + 1

!
!     test ncvp1c for char
!
      call ncvp1c (ncid, cid, cindx, 'a', iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncclos (ncid, iret)
      if (iret .ne. 0) nfails = nfails + 1

      return
      end

!
! subroutine to test default fill values
!
      subroutine tfills(nfails)
      include 'netcdf.inc'
      integer ncid
      integer bid, sid, lid, fid, did
      integer ix(1)
      integer l
      NCSHORT_T s
      doubleprecision d
      real f
      NCBYTE_T b

      ncid = NCOPN('fills.nc', NCNOWRIT, iret)
      if (iret .ne. 0) nfails = nfails + 1

      bid = ncvid(ncid, 'b', iret)
      if (iret .ne. 0) nfails = nfails + 1

      sid = ncvid(ncid, 's', iret)
      if (iret .ne. 0) nfails = nfails + 1

      lid = ncvid(ncid, 'l', iret)
      if (iret .ne. 0) nfails = nfails + 1

      fid = ncvid(ncid, 'f', iret)
      if (iret .ne. 0) nfails = nfails + 1

      did = ncvid(ncid, 'd', iret)
      if (iret .ne. 0) nfails = nfails + 1


      ix(1) = 2
      call ncvgt1(ncid, bid, ix, b, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, sid, ix, s, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, lid, ix, l, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, fid, ix, f, iret)
      if (iret .ne. 0) nfails = nfails + 1

      call ncvgt1(ncid, did, ix, d, iret)
      if (iret .ne. 0) nfails = nfails + 1


      if (b .ne. FILBYTE) write(*,*) 'error in byte fill value'
      if (d .ne. FILDOUB) write(*,*) 'error in double fill value'
      if (f .ne. FILFLOAT) write(*,*) 'error in float fill value'
      if (l .ne. FILLONG) write(*,*) 'error in long fill value'
      if (s .ne. FILSHORT) write(*,*) 'error in short fill value'

      return
      end

   function nf90_put_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_1D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_1D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_1D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_1D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_1D_EightByteInt


   function nf90_put_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_2D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_2D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_2D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_2D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_2D_EightByteInt


   function nf90_put_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_3D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_3D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_3D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_3D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_3D_EightByteInt


   function nf90_put_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_4D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_4D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_4D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_4D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_4D_EightByteInt


   function nf90_put_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_5D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_5D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_5D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_5D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_5D_EightByteInt


   function nf90_put_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_6D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_6D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_6D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_6D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_6D_EightByteInt


   function nf90_put_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_put_var_7D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter

     ! Set local arguments to default values
     numDims                 = size(shape(values))
     localStart (:         ) = 1
     localCount (:numDims  ) = shape(values)
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_put_var_7D_EightByteInt = &
          nf_put_varm_int(ncid, varid, localStart, localCount, localStride, localMap, int(values))
     else if(present(stride)) then
       nf90_put_var_7D_EightByteInt = &
          nf_put_vars_int(ncid, varid, localStart, localCount, localStride, int(values))
     else
       nf90_put_var_7D_EightByteInt = &
          nf_put_vara_int(ncid, varid, localStart, localCount, int(values))
     end if
   end function nf90_put_var_7D_EightByteInt


   function nf90_get_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_1D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(1)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_1D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_1D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_1D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_1D_EightByteInt


   function nf90_get_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_2D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(2)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_2D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_2D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_2D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_2D_EightByteInt


   function nf90_get_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_3D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(3)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_3D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_3D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_3D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_3D_EightByteInt


   function nf90_get_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_4D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(4)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_4D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_4D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_4D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_4D_EightByteInt


   function nf90_get_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_5D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(5)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_5D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_5D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_5D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_5D_EightByteInt


   function nf90_get_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_6D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(6)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_6D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_6D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_6D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_6D_EightByteInt


   function nf90_get_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), dimension(:, :, :, :, :, :, :), &
                                      intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start, count, stride, map
     integer                                      :: nf90_get_var_7D_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localStart, localCount, localStride, localMap
     integer                               :: numDims, counter, shapeValues(7)
     integer, dimension(:), allocatable    :: defaultIntArray

     allocate(defaultIntArray(size(values)))

     ! Set local arguments to default values
     shapeValues             = shape(values)
     numDims                 = size(shapeValues)
     localStart (:         ) = 1
     localCount (:numDims  ) = shapeValues
     localCount (numDims+1:) = 1
     localStride(:         ) = 1
     localMap   (:numDims  ) = (/ 1, (product(localCount(:counter)), counter = 1, numDims - 1) /)

     if(present(start))  localStart (:size(start) )  = start(:)
     if(present(count))  localCount (:size(count) )  = count(:)
     if(present(stride)) localStride(:size(stride)) = stride(:)
     if(present(map))  then
       localMap   (:size(map))    = map(:)
       nf90_get_var_7D_EightByteInt = &
          nf_get_varm_int(ncid, varid, localStart, localCount, localStride, localMap, defaultIntArray)
     else if(present(stride)) then
       nf90_get_var_7D_EightByteInt = &
          nf_get_vars_int(ncid, varid, localStart, localCount, localStride, defaultIntArray)
     else
       nf90_get_var_7D_EightByteInt = &
          nf_get_vara_int(ncid, varid, localStart, localCount, defaultIntArray)
     end if
     values(:, :, :, :, :, :, :) = reshape(defaultIntArray(:), shapeValues)
     if (allocated(defaultIntArray)) deallocate(defaultIntArray)
   end function nf90_get_var_7D_EightByteInt


   function nf90_put_var_EightByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), intent( in) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_put_var_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localIndex

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)

     nf90_put_var_EightByteInt = nf_put_var1_int(ncid, varid, localIndex, int(values))
   end function nf90_put_var_EightByteInt


   function nf90_get_var_EightByteInt(ncid, varid, values, start)
     integer,                         intent( in) :: ncid, varid
     integer (kind = EightByteInt), intent(out) :: values
     integer, dimension(:), optional, intent( in) :: start
     integer                                      :: nf90_get_var_EightByteInt

     integer, dimension(nf90_max_var_dims) :: localIndex
     integer                               :: defaultInteger

     ! Set local arguments to default values
     localIndex(:) = 1
     if(present(start)) localIndex(:size(start)) = start(:)

     nf90_get_var_EightByteInt = nf_get_var1_int(ncid, varid, localIndex, defaultInteger)
     values = defaultInteger
   end function nf90_get_var_EightByteInt

! This is part of the netCDF package.  Copyright 2006 University
! Corporation for Atmospheric Research/Unidata.  See COPYRIGHT file
! for conditions of use.

! This is a very simple example which writes a 2D array of sample
! data. To handle this in netCDF we create two shared dimensions, "x"
! and "y", and a netCDF variable, called "data".

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_wr
  use netcdf
  implicit none

  character (len = *), parameter :: FILE_NAME = "simple_xy_nc4.nc"
  integer, parameter :: NDIMS = 2
  integer, parameter :: NX = 6, NY = 12
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid
  integer :: data_out(NY, NX)
  integer :: chunks(2)
  integer :: deflate_level
  integer :: x, y

  ! Create some pretend data. If this wasn't an example program, we
  ! would have some real data to write, for example, model output.
  do x = 1, NX
     do y = 1, NY
        data_out(y, x) = (x - 1) * NY + (y - 1)
     end do
  end do

  ! Always check the return code of every netCDF function call. In
  ! this example program, wrapping netCDF calls with "call check()"
  ! makes sure that any return which is not equal to nf90_noerr (0)
  ! will print a netCDF error message and exit.

  ! Create the netCDF file. The nf90_clobber parameter tells netCDF to
  ! overwrite this file, if it already exists.
  call check( nf90_create(FILE_NAME, nf90_netcdf4, ncid) )

  ! Define the dimensions. NetCDF will hand back an ID for each. 
  call check( nf90_def_dim(ncid, "x", NX, x_dimid) )
  call check( nf90_def_dim(ncid, "y", NY, y_dimid) )

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids =  (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer). Optional parameters chunking, shuffle,
  ! and deflate_level are used.
  chunks(1) = NY
  chunks(2) = NX
  deflate_level = 1
  call check( nf90_def_var(ncid, "data", NF90_INT, dimids, varid, &
       chunksizes = chunks, shuffle = .TRUE., deflate_level = deflate_level) )

  ! End define mode. This tells netCDF we are done defining metadata.
  call check( nf90_enddef(ncid) )

  ! Write the pretend data to the file. Although netCDF supports
  ! reading and writing subsets of data, in this case we write all the
  ! data in one operation.
  call check( nf90_put_var(ncid, varid, data_out) )

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  print *, '*** SUCCESS writing example file ', FILE_NAME, '!'

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_wr

! This is part of the netCDF package.
! Copyright 2008 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program
! simple_xy_par_wr.f90. The data are read using parallel I/O.
      
! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program simple_xy_par_rd
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will read. 
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! These will tell where in the data file this processor should
  ! write.
  integer, parameter :: NDIMS = 2
  integer :: start(NDIMS), count(NDIMS)
  
  ! We will read data into this array.
  integer, allocatable :: data_in(:)

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Allocate space to read in data.
  allocate(data_in(p), stat = stat)
  if (stat .ne. 0) stop 3

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
  ! the file.
  call check( nf90_open(FILE_NAME, IOR(NF90_NOWRITE, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, "data", varid) )

  ! Read the data.
  start = (/ 1, my_rank + 1/)
  count = (/ p, 1 /)
  call check( nf90_get_var(ncid, varid, data_in, &
       start = start, count = count) )

  ! Check the data.
  do x = 1, p
     if (data_in(x) .ne. my_rank) then
        print *, "data_in(", x, ") = ", data_in(x)
        stop "Stopped"
     endif
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_in)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_rd

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 variable functions from fortran.

!     Ed Hartnett

program f90tst_grps
  use typeSizes
  use netcdf
  implicit none
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_grps.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: MAX_DIMS = 2
  integer, parameter :: NX = 6, NY = 12

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid1, varid2, varid3, varid4, dimids(MAX_DIMS)
  integer :: chunksizes(MAX_DIMS), chunksizes_in(MAX_DIMS)
  integer :: x_dimid, y_dimid
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer, parameter :: CACHE_NELEMS = 10000, CACHE_SIZE = 1000000
  integer, parameter :: DEFLATE_LEVEL = 4
  integer (kind = EightByteInt), parameter :: TOE_SAN_VALUE = 2147483648_EightByteInt
  character (len = *), parameter :: VAR1_NAME = "Payroll"
  character (len = *), parameter :: VAR2_NAME = "Spies"
  character (len = *), parameter :: VAR3_NAME = "Propaganda"
  character (len = *), parameter :: VAR4_NAME = "Arms"
  character (len = *), parameter :: GRP1_NAME = "Irish_Republican_Brotherhood"
  character (len = *), parameter :: GRP2_NAME = "Sinn_Fein"
  character (len = *), parameter :: GRP3_NAME = "Gaelic_Athletic_Association"
  character (len = *), parameter :: GRP4_NAME = "Provisional_Government"

  character (len = NF90_MAX_NAME) :: grp1_full_name
  integer :: len

  ! Information read back from the file to check correctness.
  integer :: varid1_in, varid2_in, varid3_in, varid4_in
  integer :: grpid1, grpid2, grpid3, grpid4
  integer :: xtype_in, ndims_in, natts_in, dimids_in(MAX_DIMS)
  character (len = nf90_max_name) :: name_in
  integer :: endianness_in, deflate_level_in
  logical :: shuffle_in, fletcher32_in, contiguous_in

  print *, ''
  print *,'*** Testing netCDF-4 groups from Fortran 90.'

  ! Create the netCDF file. 
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define some nested groups.
  call check(nf90_def_grp(ncid, GRP1_NAME, grpid1))
  call check(nf90_def_grp(grpid1, GRP2_NAME, grpid2))
  call check(nf90_def_grp(grpid2, GRP3_NAME, grpid3))
  call check(nf90_def_grp(grpid3, GRP4_NAME, grpid4))

  ! Define some variables. 
  chunksizes = (/ NY, NX /)
  call check(nf90_def_var(ncid, VAR1_NAME, NF90_INT, dimids, varid1, chunksizes = chunksizes, &
       shuffle = .TRUE., fletcher32 = .TRUE., endianness = nf90_endian_big, deflate_level = DEFLATE_LEVEL))
  call check(nf90_def_var(grpid1, VAR2_NAME, NF90_INT, dimids, varid2, contiguous = .TRUE.))
  call check(nf90_def_var(grpid2, VAR3_NAME, NF90_INT64, varid3))
  call check(nf90_def_var(grpid3, VAR4_NAME, NF90_INT, x_dimid, varid4, contiguous = .TRUE.))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the file.
  call check(nf90_open(FILE_NAME, nf90_nowrite, ncid))
  
  ! Check some stuff out.
  call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
  if (ndims /= 2 .or. nvars /= 1 .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
       file_format /= nf90_format_netcdf4) stop 21

  ! Get the group ids for the newly reopened file.
  call check(nf90_inq_grp_ncid(ncid, GRP1_NAME, grpid1))
  call check(nf90_inq_grp_ncid(grpid1, GRP2_NAME, grpid2))
  call check(nf90_inq_grp_ncid(grpid2, GRP3_NAME, grpid3))
  call check(nf90_inq_grp_ncid(grpid3, GRP4_NAME, grpid4))

  ! Check for the groups with full group names. 
  write(grp1_full_name, '(A,A)') '/', GRP1_NAME
  call check(nf90_inq_grp_full_ncid(ncid, grp1_full_name, grpid1))
  call check(nf90_inq_grpname(grpid1, name_in))
  if (name_in .ne. GRP1_NAME) stop 61
  call check(nf90_inq_grpname_full(grpid1, len, name_in))
  if (name_in .ne. grp1_full_name) stop 62

  ! Get varids.
  call check(nf90_inq_varid(ncid, VAR1_NAME, varid1_in))
  call check(nf90_inq_varid(grpid1, VAR2_NAME, varid2_in))
  call check(nf90_inq_varid(grpid2, VAR3_NAME, varid3_in))
  call check(nf90_inq_varid(grpid3, VAR4_NAME, varid4_in))

  ! Check variable 1.
  call check(nf90_inquire_variable(ncid, varid1_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, chunksizes = chunksizes_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR1_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. MAX_DIMS .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1) .or. dimids_in(2) .ne. dimids(2)) stop 3
  if (chunksizes_in(1) /= chunksizes(1) .or. chunksizes_in(2) /= chunksizes(2)) &
       stop 4
  if (endianness_in .ne. nf90_endian_big) stop 5

  ! Check variable 2.
  call check(nf90_inquire_variable(grpid1, varid2_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR2_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. MAX_DIMS .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1) .or. dimids_in(2) .ne. dimids(2)) stop 6
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 7

  ! Check variable 3.
  call check(nf90_inquire_variable(grpid2, varid3_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR3_NAME .or. xtype_in .ne. NF90_INT64 .or. ndims_in .ne. 0 .or. &
       natts_in .ne. 0) stop 8
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 9
  
  ! Check variable 4.
  call check(nf90_inquire_variable(grpid3, varid4_in, name_in, xtype_in, ndims_in, dimids_in, &
       natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
       deflate_level = deflate_level_in, shuffle = shuffle_in))
  if (name_in .ne. VAR4_NAME .or. xtype_in .ne. NF90_INT .or. ndims_in .ne. 1 .or. &
       natts_in .ne. 0 .or. dimids_in(1) .ne. x_dimid) stop 10
  if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 11

  ! Close the file. 
  call check(nf90_close(ncid))

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_grps

! Copyright 2007-2019, UCAR/Unidata. See netcdf/COPYRIGHT file for
! copying and redistribution conditions.

! This program tests io times with large files (> 4 GB) in
! netCDF-4. This is user-contributed code. This test creates a bunch
! of fort.* output files.

! Ed Hartnett, 2007
program f90tst_io
  use netcdf ! access to netcdf module
  implicit none
  integer, parameter :: prsz1 = 50, prsz2 = 50, &
       prsz3 = 50, prsz4 = 50, repct = 10
  integer :: i1, i2, i3, i4, ticksPerSec
  real :: psr
  integer :: clockRate
  integer :: start, now, wrint1, ncint1, wrint2, ncint2, &
       wrint3, iosb, size
  real, dimension (prsz1, prsz2, prsz3, prsz4) :: x
  character(len = *), parameter :: nclFilenm1 = 'f90tst_io1.nc', &
       nclFilenm2 = 'f90tst_io2.nc', nclFilenm3 = 'f90tst_io3.nc', &
       nclFilenm4 = 'f90tst_io4.nc', nclFilenm5 = 'f90tst_io5.nc', &
       nclFilenm6 = 'f90tst_io6.nc', nclFilenm7 = 'f90tst_io7.nc', &
       nclFilenm8 = 'f90tst_io8.nc', nclFilenm9 = 'f90tst_io9.nc', &
       nclFilenm10 = 'f90tst_io10.nc', nclFilenm11 = 'f90tst_io11.nc'
  ! needed for netcdf
  integer :: ncid, x1id, x2id, x3id, x4id, vrid

  psr = 1.7/real(prsz1)

  print *, "Starting data initialization."
  size = (prsz1 * prsz2 * prsz3 * prsz4 )/ 250000
  do i1 = 1, prsz1
     do i2 = 1, prsz2
        do i3 = 1, prsz3 ! Jackson Pollock it is not
           do i4 = 1, prsz4
              x(i1, i2, i3, i4) = sin(i1*psr)*(0.5 + cos(i2*psr))+(psr/i3)+ i4/(10.0*prsz4)
           enddo
        enddo
     enddo
  enddo
  call system_clock(start, ticksPerSec)
  clockRate = 1000/ticksPerSec
  print 5, size, 1000.0/real(ticksPerSec)
5 format("Array sizes =", i4, "MB. Clock resolution = ", f6.3, " ms."/)

  ! First the binary writes
  call system_clock(start, ticksPerSec)
  write(1, iostat = iosb) x
  call system_clock(now)
  wrint1 = now - start
  call check (iosb, 1)
  print 1, size, "MB","binary write = ", wrint1 * clockRate
1 format("Time for", i5, a, a26, i6, " msec. ")

  call system_clock(start)
  do i1 = 1, repct
     rewind (2, iostat = iosb)
     call check (iosb, 2)
     write(2, iostat = iosb) x
     call check (iosb, 3)
  enddo
  call system_clock(now)
  wrint2 = now - start
  call check (iosb, 4)
  close(2, iostat = iosb)
  call check (iosb, 5)
  print 2, size, "MB", repct, " binary rewind/writes = ", wrint2 * clockRate
2 format("Time for", i5, a, i3, a23, i6," msec. ", a, i6)
  close(1, iostat = iosb)

  call system_clock(start)
  write(13, iostat = iosb) x
  call check (iosb, 6)
  write(14, iostat = iosb) x
  call check (iosb, 7)
  write(15, iostat = iosb) x
  call check (iosb, 8)
  write(16, iostat = iosb) x
  call check (iosb, 9)
  write(17, iostat = iosb) x
  call check (iosb, 10)
  write(18, iostat = iosb) x
  call check (iosb, 11)
  write(19, iostat = iosb) x
  call check (iosb, 12)
  write(20, iostat = iosb) x
  call check (iosb, 13)
  call system_clock(now)
  wrint3 = now - start
  print 2, size, "MB", 8, " binary file writes = ", wrint3 * clockRate
  do i1 = 1, 8
     close(12 + i1, iostat = iosb)
     call check (iosb, 14)
  enddo

  ! Next the netCDF writes
  call setupNetCDF (nclFilenm1, ncid, vrid, prsz1, prsz2, prsz3, prsz4, &
       x1id, x2id, x3id, x4id, NF90_CLOBBER, 20)
  call system_clock(start)
  call check (NF90_PUT_VAR(ncid, vrid, x), 18)
  call system_clock(now)
  ncint1 = now - start
  print 3, size, "MB"," netcdf write = ", ncint1 * clockRate, &
       real(ncint1)/real (wrint1)
3 format("Time for", i5, a, a25, i7, " msec. Spd ratio = ", f5.2)

  call check (NF90_CLOSE(ncid), 14)

  call system_clock(start)
  do i1 = 1, repct
     call setupNetCDF (nclFilenm1, ncid, vrid, prsz1, prsz2, prsz3, prsz4, &
          x1id, x2id, x3id, x4id, NF90_CLOBBER, 130)
     call check (NF90_PUT_VAR(ncid, vrid, x), 23 + i1)
     call check (NF90_CLOSE(ncid), 15)
  enddo
  call system_clock(now)
  ncint2 = now - start
  print 4, size, repct, " repeated netcdf writes = ", ncint2 * clockRate, &
       real(ncint2)/real(wrint2);
4 format("Time for", i5, "MB", i3, a22, i7, " msec. Spd ratio = ", f5.2)

!   call system_clock(start)
!   call setupNetCDF (nclFilenm3, ncid, vrids, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 20)
!   call setupNetCDF (nclFilenm4, ncid, vridt, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 30)
!   call setupNetCDF (nclFilenm5, ncid, vridu, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 40)
!   call setupNetCDF (nclFilenm6, ncid, vridv, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 50)
!   call setupNetCDF (nclFilenm7, ncid, vridw, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 60)
!   call setupNetCDF (nclFilenm8, ncid, vridx, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 70)
!   call setupNetCDF (nclFilenm9, ncid, vridy, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 80)
!   call setupNetCDF (nclFilenm10, ncid, vridz, prsz1, prsz2, prsz3, prsz4, &
!        x1id, x2id, x3id, x4id, NF90_CLOBBER, 90)
!   call check (NF90_PUT_VAR(ncid, vrids, s), 118)
!   call check (NF90_PUT_VAR(ncid, vridt, t), 119)
!   call check (NF90_PUT_VAR(ncid, vridu, u), 120)
!   call check (NF90_PUT_VAR(ncid, vridv, v), 121)
!   call check (NF90_PUT_VAR(ncid, vridw, w), 122)
!   call check (NF90_PUT_VAR(ncid, vridx, x), 123)
!   call check (NF90_PUT_VAR(ncid, vridy, y), 124)
!   call check (NF90_PUT_VAR(ncid, vridz, z), 125)
!   call system_clock(now)
!   ncint3 = now - start
!   call check (NF90_CLOSE(ncid), 16)
!   print 4, size, 8, " netcdf file writes = ", ncint3 * clockRate, &
!        real(ncint3)/real(wrint3);

contains
  subroutine check (st, n) ! checks the return error code
    integer, intent (in) :: st, n
    if ((n < 10.and.st /= 0).or.(n > 10.and.st /= NF90_noerr))then
       print *, "I/O error at", n, " status = ", st
       stop 2
    endif
  end subroutine check

  subroutine setupNetCDF(fn, nc, vr, d1, d2, d3, d4, do1, do2, &
       do3, do4, stat, deb)
    integer, intent(in) :: d1, d2, d3, d4, stat, deb
    integer, intent(out) :: do1, do2, do3, do4, vr
    integer, intent(inout) :: nc
    integer, dimension(4) :: dimids (4)

    character(len = *), intent(in) :: fn

    call check (NF90_CREATE (fn, stat, nc), deb + 1)
    call check (NF90_DEF_DIM(nc, "d1", d1, do1), deb + 2)
    call check (NF90_DEF_DIM(nc, "d2", d2, do2), deb + 3)
    call check (NF90_DEF_DIM(nc, "d3", d3, do3), deb + 4)
    call check (NF90_DEF_DIM(nc, "d4", d4, do4), deb + 5)

    dimids = (/ do1, do2, do3, do4 /)
    call check (NF90_DEF_VAR(nc, "data", NF90_REAL, dimids, vr), deb + 6)
    call check (NF90_ENDDEF (nc), deb + 7)

  end subroutine setupNetCDF

end program f90tst_io

C     This program tests CDF-5 file format, with int64 data type

      subroutine check(err, message)
          implicit none
          include 'netcdf.inc'
          integer err
          character message*(*)

          if (err .NE. NF_NOERR) then
              write(6,*) message//' '//nf_strerror(err)
              stop 1
          end if
      end

      program tst_int64
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='tst_int64.nc')

C     We are writing 2D data, a 6 x 12 grid.
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     NetCDF IDs.
      integer ncid, varid(2), dimids(NDIMS)
      integer x_dimid, y_dimid
      integer xtype, attr_len, cmode
      integer start(2), count(2), stride(2), imap(2)

C     This is the data array we will write, and a place to store it when
C     we read it back in.
      integer*8 i64buf_out(NY, NX), i64buf_in(NY, NX), attr(1), twoG

C     Loop indexes, and error handling.
      integer x, y, err

      twoG = 2147483647
      twoG = twoG + 1

      print *, ''
      print *,'*** Testing NF_INT64 data type for CDF-5 file.'

C     Check error code NF_EBADTYPE

C     Create a CDF-2 netCDF file.
      cmode = IOR(NF_CLOBBER, NF_64BIT_OFFSET)
      err = nf_create(FILE_NAME, cmode, ncid)
      call check(err, 'In nf_create: ')

C     Put a global attribute. Expect NF_EBADTYPE.
      attr(1) = twoG + 123456789
      err = nf_put_att_int64(ncid, NF_GLOBAL, "gatt", NF_INT64, 1, attr)
      if (err .NE. NF_EBADTYPE) then
          write(6,*) 'Error: expect NF_EBADTYPE but got ', err
          stop 2
      end if

C     Write a data of type integer*8 to a global attribute of type NF_INT.
      attr(1) = 123456789
      err = nf_put_att_int64(ncid, NF_GLOBAL, "gatt", NF_INT, 1, attr)
      call check(err, 'In nf_put_att_int64: ')

C     Define the dimensions.
      err = nf_def_dim(ncid, "x", NX, x_dimid)
      call check(err, 'In nf_def_dim: ')
      err = nf_def_dim(ncid, "y", NY, y_dimid)
      call check(err, 'In nf_def_dim: ')

      dimids(1) = y_dimid
      dimids(2) = x_dimid

C     Define a variable of type NF_INT64 in a CDF-2 file. Expect NF_EBADTYPE.
      dimids(1) = x_dimid
      err = nf_def_var(ncid, "data", NF_INT64, 1, dimids, varid(1))
      if (err .NE. NF_EBADTYPE) then
          write(6,*) 'Error: expect NF_EBADTYPE but got ', err
          stop 3
      end if

C     Define a variable of type NF_INT.
      err = nf_def_var(ncid, "var_int", NF_INT, NDIMS, dimids, varid(1))
      call check(err, 'In nf_def_var: ')

C     Since this is a classic model file, we must call enddef
      err = nf_enddef(ncid)
      call check(err, 'In nf_enddef: ')

C     Initialize write buffer
      do x = 1, NX
         do y = 1, NY
            i64buf_out(y, x) = x * y
         end do
      end do

C     Set start(:) and count(:)
      start(1) = 2
      start(2) = 3
      count(1) = 2
      count(2) = 2
      stride(1) = 2
      stride(2) = 2
      imap(1) = NX
      imap(2) = 1

C     Write to the file using all kinds of put APIs.
      err = nf_put_var1_int64(ncid, varid(1), start, i64buf_out)
      call check(err, 'In nf_put_var1_int64: ')

      err = nf_put_vara_int64(ncid, varid(1), start, count, i64buf_out)
      call check(err, 'In nf_put_vara_int64: ')

      err = nf_put_vars_int64(ncid, varid(1), start, count, stride,
     +                        i64buf_out)
      call check(err, 'In nf_put_vars_int64: ')

      err = nf_put_varm_int64(ncid, varid(1), start, count, stride,
     +                        imap, i64buf_out)
      call check(err, 'In nf_put_varm_int64: ')

      err = nf_put_var_int64(ncid, varid(1), i64buf_out)
      call check(err, 'In nf_put_var_int64: ')

C     Close the CDF-2 file.
      err = nf_close(ncid)
      call check(err, 'In nf_close: ')

#ifdef ENABLE_CDF5
C     Create a CDF-5 netCDF file.
      cmode = IOR(NF_CLOBBER, NF_64BIT_DATA)
      err = nf_create(FILE_NAME, cmode, ncid)
      call check(err, 'In nf_create: ')

C     Put a value of type integer*8 to a global attribute of type NF_INT64.
      attr(1) = twoG + 123456789
      err = nf_put_att_int64(ncid, NF_GLOBAL, "gatt", NF_INT64, 1, attr)
      call check(err, 'In nf_put_att_int64: ')

C     Define the dimensions.
      err = nf_def_dim(ncid, "x", NX, x_dimid)
      call check(err, 'In nf_def_dim: ')
      err = nf_def_dim(ncid, "y", NY, y_dimid)
      call check(err, 'In nf_def_dim: ')

      dimids(1) = y_dimid
      dimids(2) = x_dimid

C     Define a variable of type NF_INT64.
      err = nf_def_var(ncid, "var_int64",NF_INT64,NDIMS,dimids,varid(1))
      call check(err, 'In nf_def_var: ')

C     Define a variable of type NF_INT.
      err = nf_def_var(ncid, "var_int", NF_INT, NDIMS, dimids, varid(2))
      call check(err, 'In nf_def_var: ')

C     Since this is a classic model file, we must call enddef
      err = nf_enddef(ncid)
      call check(err, 'In nf_enddef: ')

C     Write a buffer of type integer*8 to a variable of type NF_INT.
      err = nf_put_var_int64(ncid, varid(2), i64buf_out)
      call check(err, 'In nf_put_var_int64: ')

C     Use large values for write data.
      do x = 1, NX
         do y = 1, NY
            i64buf_out(y, x) = twoG + x * y
         end do
      end do

C     Write the data to the file using different kinds of put APIs.
      err = nf_put_var1_int64(ncid, varid(1), start, i64buf_out)
      call check(err, 'In nf_put_var1_int64: ')

      err = nf_put_vara_int64(ncid, varid(1), start, count, i64buf_out)
      call check(err, 'In nf_put_vara_int64: ')

      err = nf_put_vars_int64(ncid, varid(1), start, count, stride,
     +                        i64buf_out)
      call check(err, 'In nf_put_vars_int64: ')

      err = nf_put_varm_int64(ncid, varid(1), start, count, stride,
     +                        imap, i64buf_out)
      call check(err, 'In nf_put_varm_int64: ')

      err = nf_put_var_int64(ncid, varid(1), i64buf_out)
      call check(err, 'In nf_put_var_int64: ')

C     Close the CDF-5 file.
      err = nf_close(ncid)
      call check(err, 'In nf_close: ')

C     Reopen the CDF-5 file and check again.
      err = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      call check(err, 'In nf_open: ')

C     read the global attribute and check value
      err = nf_inq_att(ncid, NF_GLOBAL, "gatt", xtype, attr_len)
      call check(err, 'In nf_inq_att: ')

      if (xtype .NE. NF_INT64) then
          print *,'Error: unepected xtype ', xtype
      end if

      if (attr_len .NE. 1) then
          print *,'Error: unepected attribute length ', attr_len
      end if

      attr(1) = 0
      err = nf_get_att_int64(ncid, NF_GLOBAL, "gatt", attr)
      call check(err, 'In nf_get_att_int64: ')

      if (attr(1) .NE. twoG + 123456789) then
          print *,'Error: unepected attribute value ', attr(1)
      end if

C     Find variable ID.
      err = nf_inq_varid(ncid, "var_int64", varid(1))
      call check(err, 'In nf_inq_varid: ')
      if (varid(1) .ne. 1) stop 4

C     Read the data
      err = nf_get_var1_int64(ncid, varid(1), start, i64buf_in)
      call check(err, 'In nf_get_var1_int64: ')

      err = nf_get_vara_int64(ncid, varid(1), start, count, i64buf_in)
      call check(err, 'In nf_get_vara_int64: ')

      err = nf_get_vars_int64(ncid, varid(1), start, count, stride,
     +                        i64buf_in)
      call check(err, 'In nf_get_vars_int64: ')

      err = nf_get_varm_int64(ncid, varid(1), start, count, stride,
     +                        imap, i64buf_in)
      call check(err, 'In nf_get_varm_int64: ')

C     Read the whole data and check it.
      err = nf_get_var_int64(ncid, varid(1), i64buf_in)
      call check(err, 'In nf_get_var_int64: ')
      do x = 1, NX
         do y = 1, NY
            if (i64buf_in(y, x) .ne. i64buf_out(y, x)) stop 5
         end do
      end do

C     Find variable ID of type NF_INT.
      err = nf_inq_varid(ncid, "var_int", varid(2))
      call check(err, 'In nf_inq_varid: ')
      if (varid(2) .ne. 2) stop 6

C     Read the whole data of type NF_INT into a buffer of type integer*8.
      err = nf_get_var_int64(ncid, varid(2), i64buf_in)
      call check(err, 'In nf_get_var_int64: ')
      do x = 1, NX
         do y = 1, NY
            if (i64buf_in(y, x) .ne. x * y) stop 7
         end do
      end do

C     Close the file.
      err = nf_close(ncid)
      call check(err, 'In nf_close: ')
#endif
      print *,'*** SUCCESS!'
      end

  !
  ! Attribute routines:
  !
  ! -------
  function nf90_copy_att(ncid_in, varid_in, name, ncid_out, varid_out)
    integer,             intent( in) :: ncid_in,  varid_in
    character (len = *), intent( in) :: name
    integer,             intent( in) :: ncid_out, varid_out
    integer                          :: nf90_copy_att

    nf90_copy_att = nf_copy_att(ncid_in, varid_in, name, ncid_out, varid_out)
  end function nf90_copy_att
  ! -------
  function nf90_rename_att(ncid, varid, curname, newname)
    integer,             intent( in) :: ncid,  varid
    character (len = *), intent( in) :: curname, newname
    integer                          :: nf90_rename_att

    nf90_rename_att = nf_rename_att(ncid, varid, curname, newname)
  end function nf90_rename_att
  ! -------
  function nf90_del_att(ncid, varid, name)
    integer,             intent( in) :: ncid, varid
    character (len = *), intent( in) :: name
    integer                          :: nf90_del_att

    nf90_del_att = nf_del_att(ncid, varid, name)
  end function nf90_del_att
  ! -------
  ! Attribute inquiry functions
  ! -------
  function nf90_inq_attname(ncid, varid, attnum, name)
    integer,             intent( in) :: ncid, varid, attnum
    character (len = *), intent(out) :: name
    integer                          :: nf90_inq_attname

    nf90_inq_attname = nf_inq_attname(ncid, varid, attnum, name)
  end function nf90_inq_attname
  ! -------
  function nf90_inquire_attribute(ncid, varid, name, xtype, len, attnum)
    integer,             intent( in)           :: ncid, varid
    character (len = *), intent( in)           :: name
    integer,             intent(out), optional :: xtype, len, attnum
    integer                                    :: nf90_inquire_attribute

    integer                          :: local_xtype, local_len

    ! Do we need to worry about not saving the state from this call?
    if(present(attnum)) &
      nf90_inquire_attribute = nf_inq_attid(ncid, varid, name, attnum)
    nf90_inquire_attribute   = nf_inq_att  (ncid, varid, name, local_xtype, local_len)
    if(present(xtype)) xtype = local_xtype
    if(present(len  )) len   = local_len
  end function nf90_inquire_attribute
  ! -------
  ! Put and get functions; these will get overloaded
  ! -------
  ! Text
  ! -------
  function nf90_put_att_text(ncid, varid, name, values)
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    character(len = *),               intent( in) :: values
    integer                                       :: nf90_put_att_text

    nf90_put_att_text = nf_put_att_text(ncid, varid, name, len_trim(values), trim(values))
  end function nf90_put_att_text
  ! -------
  function nf90_get_att_text(ncid, varid, name, values)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_size_t, c_f_pointer, c_int
    implicit none
    integer,                          intent( in) :: ncid, varid
    character(len = *),               intent( in) :: name
    character(len = *),               intent(out) :: values
    integer                                       :: nf90_get_att_text
    interface
      integer(c_int) function nc_get_att_string(ncid, varid, name, pp) bind(c)
        use iso_c_binding , only : c_int , c_char , c_ptr
        integer(c_int) , value :: ncid , varid
        character(kind=c_char) , intent(in) :: name
        type(c_ptr), intent(out) :: pp
      end function nc_get_att_string
    end interface
    interface
      integer(c_size_t) function strlen(cs) bind(c, name='strlen')
         use, intrinsic :: iso_c_binding , only : c_size_t , c_ptr
         implicit none
         type(c_ptr), intent(in), value :: cs
      end function strlen
    end interface
    integer :: xtype , nlen , attid , i
    integer(c_int) :: c_ncid , c_varid , c_status , c_nlen
    type(c_ptr) :: c_str
    character(len_trim(name)+1) :: c_aname
    character , pointer :: f_str(:)
    nf90_get_att_text = nf90_inquire_attribute(ncid, varid, name, &
        xtype, nlen, attid)
    if ( nf90_get_att_text == nf90_noerr ) then
      if ( xtype == nf90_string .and. nlen == 1 ) then
        c_ncid = ncid
        c_varid = varid - 1
        c_aname = name//char(0)
        c_status = nc_get_att_string(c_ncid, c_varid, c_aname, c_str)
        nf90_get_att_text = c_status
        if ( nf90_get_att_text == nf90_noerr ) then
          call c_f_pointer(c_str,f_str,[strlen(c_str)])
          values = adjustl("")
          do i = 1, size(f_str)
            values(i:i) = f_str(i)
          end do
        end if
      else
        values = ' '  !! make sure result will be blank padded
        nf90_get_att_text = nf_get_att_text(ncid,varid,name,values)
      end if
    end if
  end function nf90_get_att_text
  ! -------
  ! Integer attributes
  ! -------
  function nf90_put_att_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_OneByteInt

    nf90_put_att_OneByteInt = nf_put_att_int1(ncid, varid, name, nf90_int1, size(values), values)
  end function nf90_put_att_OneByteInt
  ! -------
  function nf90_put_att_one_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_OneByteInt

    integer (kind =  OneByteInt), dimension(1)              :: valuesA
    valuesA(1) = values
    nf90_put_att_one_OneByteInt = nf_put_att_int1(ncid, varid, name, nf90_int1, 1, valuesA)
  end function nf90_put_att_one_OneByteInt
  ! -------
  function nf90_get_att_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_OneByteInt

    nf90_get_att_OneByteInt = nf_get_att_int1(ncid, varid, name, values)
  end function nf90_get_att_OneByteInt
  ! -------
  function nf90_get_att_one_OneByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  OneByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_OneByteInt

    integer (kind =  OneByteInt), dimension(1)              :: valuesA
    nf90_get_att_one_OneByteInt = nf_get_att_int1(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_OneByteInt
  ! -------
  function nf90_put_att_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_TwoByteInt

    nf90_put_att_TwoByteInt = nf_put_att_int2(ncid, varid, name, nf90_int2, size(values), values)
  end function nf90_put_att_TwoByteInt
  ! -------
  function nf90_put_att_one_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_TwoByteInt

    integer (kind =  TwoByteInt), dimension(1)              :: valuesA
    valuesA(1) = values
    nf90_put_att_one_TwoByteInt = nf_put_att_int2(ncid, varid, name, nf90_int2, 1, valuesA)
  end function nf90_put_att_one_TwoByteInt
  ! -------
  function nf90_get_att_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_TwoByteInt

    nf90_get_att_TwoByteInt = nf_get_att_int2(ncid, varid, name, values)
  end function nf90_get_att_TwoByteInt
  ! -------
  function nf90_get_att_one_TwoByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind =  TwoByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_TwoByteInt

    integer (kind =  TwoByteInt), dimension(1)              :: valuesA
    nf90_get_att_one_TwoByteInt = nf_get_att_int2(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_TwoByteInt
  ! -------
  function nf90_put_att_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt), dimension(:), intent( in) :: values
    integer                                                 :: nf90_put_att_FourByteInt

    nf90_put_att_FourByteInt = nf_put_att_int(ncid, varid, name, nf90_int, size(values), int(values))
  end function nf90_put_att_FourByteInt
  ! -------
  function nf90_put_att_one_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt),               intent( in) :: values
    integer                                                 :: nf90_put_att_one_FourByteInt

    integer (kind = FourByteInt), dimension(1)              :: valuesA
    valuesA(1) = int(values)
    nf90_put_att_one_FourByteInt = nf_put_att_int(ncid, varid, name, nf90_int, 1, int(valuesA))
  end function nf90_put_att_one_FourByteInt
  ! -------
  function nf90_get_att_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt), dimension(:), intent(out) :: values
    integer                                                 :: nf90_get_att_FourByteInt

    integer, dimension(size(values)) :: defaultInteger

    nf90_get_att_FourByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values(:) = defaultInteger(:)
  end function nf90_get_att_FourByteInt
  ! -------
  function nf90_get_att_one_FourByteInt(ncid, varid, name, values)
    integer,                                    intent( in) :: ncid, varid
    character(len = *),                         intent( in) :: name
    integer (kind = FourByteInt),               intent(out) :: values
    integer                                                 :: nf90_get_att_one_FourByteInt

    integer, dimension(1) :: defaultInteger

    nf90_get_att_one_FourByteInt = nf_get_att_int(ncid, varid, name, defaultInteger)
    values = defaultInteger(1)
  end function nf90_get_att_one_FourByteInt
  ! -------
  function nf90_put_att_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt), dimension(:), intent( in) :: values
    integer                                                  :: nf90_put_att_EightByteInt

    nf90_put_att_EightByteInt = nf_put_att_int64(ncid, varid, name, nf90_int64, size(values), values)
  end function nf90_put_att_EightByteInt
  ! -------
  function nf90_put_att_one_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt),               intent( in) :: values
    integer                                                  :: nf90_put_att_one_EightByteInt

    integer(kind=EightByteInt), dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_EightByteInt = nf_put_att_int64(ncid, varid, name, nf90_int64, 1, valuesA)
  end function nf90_put_att_one_EightByteInt
  ! -------
  function nf90_get_att_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt), dimension(:), intent(out) :: values
    integer                                                  :: nf90_get_att_EightByteInt

    nf90_get_att_EightByteInt = nf_get_att_int64(ncid, varid, name, values)
  end function nf90_get_att_EightByteInt
  ! -------
  function nf90_get_att_one_EightByteInt(ncid, varid, name, values)
    integer,                                     intent( in) :: ncid, varid
    character(len = *),                          intent( in) :: name
    integer (kind = EightByteInt),               intent(out) :: values
    integer                                                  :: nf90_get_att_one_EightByteInt

    integer(kind=EightByteInt), dimension(1) :: valuesA

    nf90_get_att_one_EightByteInt = nf_get_att_int64(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_EightByteInt
  ! -------
  ! Real attributes
  ! -------
  function nf90_put_att_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal), dimension(:), intent( in) :: values
    integer                                                :: nf90_put_att_FourByteReal

    nf90_put_att_FourByteReal = nf_put_att_real(ncid, varid, name, nf90_real4, size(values), values)
  end function nf90_put_att_FourByteReal
  ! -------
  function nf90_put_att_one_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal),               intent( in) :: values
    integer                                                :: nf90_put_att_one_FourByteReal

    real (kind =  FourByteReal), dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_FourByteReal = nf_put_att_real(ncid, varid, name, nf90_real4, 1, valuesA)
  end function nf90_put_att_one_FourByteReal
  ! -------
  function nf90_get_att_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal), dimension(:), intent(out) :: values
    integer                                                :: nf90_get_att_FourByteReal

    nf90_get_att_FourByteReal = nf_get_att_real(ncid, varid, name, values)
  end function nf90_get_att_FourByteReal
  ! -------
  function nf90_get_att_one_FourByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind =  FourByteReal),               intent(out) :: values
    integer                                                :: nf90_get_att_one_FourByteReal

    real (kind =  FourByteReal), dimension(1) :: valuesA
    nf90_get_att_one_FourByteReal = nf_get_att_real(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_FourByteReal
  ! -------
  function nf90_put_att_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal), dimension(:), intent( in) :: values
    integer                                                :: nf90_put_att_EightByteReal

    nf90_put_att_EightByteReal = nf_put_att_double(ncid, varid, name, nf90_real8, size(values), values)
  end function nf90_put_att_EightByteReal
  ! -------
  function nf90_put_att_one_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal),               intent( in) :: values
    integer                                                :: nf90_put_att_one_EightByteReal

    real (kind = EightByteReal), dimension(1) :: valuesA
    valuesA(1) = values
    nf90_put_att_one_EightByteReal = nf_put_att_double(ncid, varid, name, nf90_real8, 1, valuesA)
  end function nf90_put_att_one_EightByteReal
  ! -------
  function nf90_get_att_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal), dimension(:), intent(out) :: values
    integer                                                :: nf90_get_att_EightByteReal

    nf90_get_att_EightByteReal = nf_get_att_double(ncid, varid, name, values)
  end function nf90_get_att_EightByteReal
  ! -------
  function nf90_get_att_one_EightByteReal(ncid, varid, name, values)
    integer,                                   intent( in) :: ncid, varid
    character(len = *),                        intent( in) :: name
    real (kind = EightByteReal),               intent(out) :: values
    integer                                                :: nf90_get_att_one_EightByteReal

    real (kind = EightByteReal), dimension(1) :: valuesA
    nf90_get_att_one_EightByteReal = nf_get_att_double(ncid, varid, name, valuesA)
    values = valuesA(1)
  end function nf90_get_att_one_EightByteReal
  ! -------

!     This is part of the netCDF package.
!     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This is a very simple example which writes a 2D array of sample
!     data. To handle this in netCDF we create two shared dimensions,
!     "x" and "y", and a netCDF variable, called "data". It uses
!     parallel I/O to write the file from all processors at the same
!     time.

!     This example demonstrates the netCDF Fortran 90 API. This is part
!     of the netCDF tutorial, which can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
!     Full documentation of the netCDF Fortran 90 API can be found at:
!     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

!     $Id: simple_xy_par_wr.f90,v 1.3 2010/06/01 15:34:49 ed Exp $

program simple_xy_par_wr
  use netcdf
  implicit none
  include 'mpif.h'

  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "simple_xy_par.nc"

  ! We are writing 2D data.
  integer, parameter :: NDIMS = 2

  ! When we create netCDF files, variables and dimensions, we get back
  ! an ID for each one.
  integer :: ncid, varid, dimids(NDIMS)
  integer :: x_dimid, y_dimid

  ! These will tell where in the data file this processor should
  ! write.
  integer :: start(NDIMS), count(NDIMS)
  
  ! This is the data array we will write. It will just be filled with
  ! the rank of this processor.
  integer, allocatable :: data_out(:)

  ! MPI stuff: number of processors, rank of this processor, and error
  ! code.
  integer :: p, my_rank, ierr

  ! Loop indexes, and error handling.
  integer :: x, stat

  ! Initialize MPI, learn local rank and total number of processors.
  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, my_rank, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, p, ierr)

  ! Create some pretend data. We just need one row.
  allocate(data_out(p), stat = stat)
  if (stat .ne. 0) stop 3
  do x = 1, p
     data_out(x) = my_rank
  end do

  ! Create the netCDF file. The NF90_NETCDF4 flag causes a
  ! HDF5/netCDF-4 file to be created. The comm and info parameters
  ! cause parallel I/O to be enabled. Use either NF90_MPIIO or
  ! NF90_MPIPOSIX to select between MPI/IO and MPI/POSIX.
  call check(nf90_create(FILE_NAME, IOR(NF90_NETCDF4, NF90_MPIIO), ncid, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  ! Define the dimensions. NetCDF will hand back an ID for
  ! each. Metadata operations must take place on all processors.
  call check(nf90_def_dim(ncid, "x", p, x_dimid))
  call check(nf90_def_dim(ncid, "y", p, y_dimid))

  ! The dimids array is used to pass the IDs of the dimensions of
  ! the variables. Note that in fortran arrays are stored in
  ! column-major format.
  dimids = (/ y_dimid, x_dimid /)

  ! Define the variable. The type of the variable in this case is
  ! NF90_INT (4-byte integer).
  call check(nf90_def_var(ncid, "data", NF90_INT, dimids, varid))

  ! End define mode. This tells netCDF we are done defining
  ! metadata. This operation is collective and all processors will
  ! write their metadata to disk.
  call check(nf90_enddef(ncid))

  ! Write the pretend data to the file. Each processor writes one row.
  start = (/ 1, my_rank + 1/)
  count = (/ p, 1 /)
  call check(nf90_put_var(ncid, varid, data_out, start = start, &
       count = count))

  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file, and flushes any buffers.
  call check( nf90_close(ncid) )

  ! Free my local memory.
  deallocate(data_out)

  ! MPI library must be shut down.
  call MPI_Finalize(ierr)

  if (my_rank .eq. 0) print *, "*** SUCCESS writing example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_par_wr

!     This is part of the netCDF package. Copyright 2006-2022
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     This program tests zstandard compression.

!     Ed Hartnett 7/6/22

program f90tst_zstandard
  use typeSizes
  use netcdf
  implicit none
  include "netcdf.inc"
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_zstandard.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: NDIM1 = 1
  integer, parameter :: DIM_LEN_5 = 5
  integer start(NDIM1), count(NDIM1)
  real real_data(DIM_LEN_5)
  real*8 double_data(DIM_LEN_5)

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid1, varid2, varid3, varid4, varid5, dimids(NDIM1)
  integer :: chunksizes(NDIM1), chunksizes_in(NDIM1)
  integer :: x_dimid, y_dimid
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer, parameter :: DEFLATE_LEVEL = 4
  integer (kind = EightByteInt), parameter :: BAM_BAM_VALUE = 2147483648_EightByteInt
  character (len = *), parameter :: VAR1_NAME = "Fred_Flintstone"
  character (len = *), parameter :: VAR2_NAME = "Barney_Rubble"
  integer :: ierr

  ! Information read back from the file to check correctness.
  integer :: varid1_in, varid2_in, varid3_in, varid4_in, varid5_in
  integer :: xtype_in, ndims_in, natts_in, dimids_in(NDIM1)
  character (len = nf90_max_name) :: name_in
  integer :: endianness_in, deflate_level_in
  logical :: shuffle_in, fletcher32_in, contiguous_in
  integer (kind = EightByteInt) :: bam_bam_in
  integer :: quantize_mode_in, nsd_in
  integer :: zstandard_in, zstandard_level_in
  real real_data_in(DIM_LEN_5)
  real*8 double_data_in(DIM_LEN_5)
  real diff
  real, parameter :: EPSILON  = .01

  integer :: m, cflags, s
  logical :: shuffle
  
  print *, ''
  print *,'*** Testing use of zstandard feature on netCDF-4 vars from Fortran 90.'

  ! Create some pretend data.
  real_data(1) = 1.11111111
  real_data(2) = 1.0
  real_data(3) = 9.99999999
  real_data(4) = 12345.67
  real_data(5) = .1234567
  double_data(1) = 1.1111111
  double_data(2) = 1.0
  double_data(3) = 9.999999999
  double_data(4) = 1234567890.12345
  double_data(5) = 1234567890

  ! Check without and with shuffle.
  do s = 0, 1
     shuffle = .false.
     
     ! Check with and without nf90_classic_model flag.
     cflags = ior(nf90_netcdf4, nf90_clobber)
     do m = 1, 2
        if (m .eq. 2) cflags = ior(cflags, nf90_classic_model)

        ! Create the netCDF file.
        call check(nf90_create(FILE_NAME, cflags, ncid))

        ! Define the dimension.
        call check(nf90_def_dim(ncid, "x", DIM_LEN_5, x_dimid))
        dimids =  (/ x_dimid /)

        ! Define some variables.
#ifdef ENABLE_ZSTD
        if (s .eq. 1) shuffle = .true.
        call check(nf90_def_var(ncid, VAR1_NAME, NF90_FLOAT, dimids, varid1, &
             zstandard_level = 4, shuffle = shuffle))
#else
        ! This will fail because we don't have zstandard. But the var will
        ! be created, only without zstandard compression.
        ierr = nf90_def_var(ncid, VAR1_NAME, NF90_FLOAT, dimids, varid1, &
             zstandard_level = 4)
        if (ierr .ne. nf90_enotbuilt) stop 55
#endif
        call check(nf90_def_var(ncid, VAR2_NAME, NF90_DOUBLE, dimids, varid2))
        call check(nf90_enddef(ncid))

        ! Write the pretend data to the file.
        call check(nf90_put_var(ncid, varid1, real_data))
        call check(nf90_put_var(ncid, varid2, double_data))

        ! Close the file. 
        call check(nf90_close(ncid))

        ! Reopen the file.
        call check(nf90_open(FILE_NAME, nf90_nowrite, ncid))

        ! Check some stuff out.
        call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
        if (ndims /= 1 .or. nvars /= 2 .or. ngatts /= 0 .or. unlimdimid /= -1) stop 200
        if (m .eq. 1 .and. file_format /= nf90_format_netcdf4) stop 200
        if (m .eq. 2 .and. file_format /= nf90_format_netcdf4_classic) stop 200

        ! Get varids.
        call check(nf90_inq_varid(ncid, VAR1_NAME, varid1_in))
        call check(nf90_inq_varid(ncid, VAR2_NAME, varid2_in))

        ! Check variable 1.
        call check(nf90_inquire_variable(ncid, varid1_in, name_in, xtype_in, ndims_in, dimids_in, &
             natts_in, chunksizes = chunksizes_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
             deflate_level = deflate_level_in, shuffle = shuffle_in, &
             zstandard = zstandard_in, zstandard_level = zstandard_level_in))
#ifdef ENABLE_ZSTD
        if (zstandard_in .eq. 0 .or. zstandard_level_in .ne. 4) stop 4
#else
        if (zstandard_in .ne. 0) stop 4
#endif
        if (natts_in .ne. 0) stop 301
        if (name_in .ne. VAR1_NAME .or. xtype_in .ne. NF90_FLOAT .or. ndims_in .ne. NDIM1 .or. &
             dimids_in(1) .ne. dimids(1)) stop 302

        ! Check variable 2.
        call check(nf90_inquire_variable(ncid, varid2_in, name_in, xtype_in, ndims_in, dimids_in, &
             natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
             deflate_level = deflate_level_in, shuffle = shuffle_in, &
             quantize_mode = quantize_mode_in, nsd = nsd_in, zstandard = zstandard_in, &
             zstandard_level = zstandard_level_in))
        if (name_in .ne. VAR2_NAME .or. xtype_in .ne. NF90_DOUBLE .or. ndims_in .ne. NDIM1 .or. &
             natts_in .ne. 0 .or. dimids_in(1) .ne. dimids(1)) stop 6
        if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 7
        if (quantize_mode_in .ne. 0) stop 303
        if (zstandard_in .ne. 0) stop 14

        ! Check the data.
        call check(nf90_get_var(ncid, varid1_in, real_data_in))
        call check(nf90_get_var(ncid, varid2_in, double_data_in))

        ! Check the data. 
        do x = 1, DIM_LEN_5
           diff = abs(real_data_in(x) - real_data(x))
           if (diff .gt. EPSILON) stop 23
           diff = abs(double_data_in(x) - double_data(x))
           if (diff .gt. EPSILON) stop 24
        end do

        ! Close the file. 
        call check(nf90_close(ncid))
     end do
  end do
  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_zstandard

C     This is part of the netCDF package.
C     Copyright 2007 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 user defined types from fortran.

C     Ed Hartnett, 2009

      program ftst_types2
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_types2.nc')

C     We are writing 2D data, a 3 x 2 grid. 
      integer NDIMS
      parameter (NDIMS = 2)
      integer dim_sizes(NDIMS)
      integer NX, NY
      parameter (NX = 3, NY = 2)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer cmp_typeid
      integer x_dimid, y_dimid
      integer typeids(1)

C     Info about the type we'll create.
      integer size_in, base_type_in, nfields_in, class_in
      character*80 name_in
      character*(*) type_name, ary_name
      parameter (type_name = 'cmp_w_ary', ary_name = 'A')
      integer ntypes
      integer cmp_size
      parameter (cmp_size = 24)
      integer offset_in, field_typeid_in, ndims_in, dim_sizes_in(NDIMS)

C     Loop indexes, and error handling.
      integer x, y, retval

      print *, ''
      print *,'*** Testing netCDF-4 compound types from F77 some more.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define a compound type.
      retval = nf_def_compound(ncid, cmp_size, type_name, 
     &     cmp_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Include an array.
      dim_sizes(1) = NX
      dim_sizes(2) = NY
      retval = nf_insert_array_compound(ncid, cmp_typeid, ary_name, 0, 
     &     NF_INT, NDIMS, dim_sizes)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find the type.
      retval = nf_inq_typeids(ncid, ntypes, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (ntypes .ne. 1 .or. typeids(1) .ne. cmp_typeid) stop 2
      
C     Check the type.
      retval = nf_inq_user_type(ncid, typeids(1), name_in, size_in, 
     &     base_type_in, nfields_in, class_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. cmp_size .or. nfields_in .ne. 1 .or. 
     &     class_in .ne. NF_COMPOUND) stop 2

C     Check the first field of the compound type.
      retval = nf_inq_compound_field(ncid, typeids(1), 1, name_in, 
     &     offset_in, field_typeid_in, ndims_in, dim_sizes_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(ary_name)) .ne. ary_name .or. 
     &     offset_in .ne. 0 .or. field_typeid_in .ne. NF_INT .or. 
     &     ndims_in .ne. NDIMS .or. 
     &     dim_sizes_in(1) .ne. dim_sizes(1) .or. 
     &     dim_sizes_in(2) .ne. dim_sizes(2)) stop 2

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     checking the quantize and zstandard features.

C     Ed Hartnett, 9/3/21

      program ftst_vars7
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_vars7.nc')
      integer NDIM1
      parameter (NDIM1 = 1)
      integer DIM_LEN_5
      parameter (DIM_LEN_5 = 5)
      integer NVARS
      parameter (NVARS = 2)
      integer check_file
      integer NSD_3
      parameter (NSD_3 = 3)
      integer ZSTD_LEVEL
      parameter (ZSTD_LEVEL = 3)

      integer ncid, varid(NVARS), dimids(NDIM1)
      character*(10) var_name(NVARS)
      integer var_type(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer start(NDIM1), count(NDIM1)
      real real_data(DIM_LEN_5)
      real*8 double_data(DIM_LEN_5)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing quantize feature.'
#ifdef ENABLE_ZSTD
      print *,'*** (and zstandard compression)'
#endif

C     Set up var names.
      var_name(1) = 'var__float'
      var_type(1) = NF_FLOAT
      var_name(2) = 'var_double'
      var_type(2) = NF_DOUBLE

C     Set up data.
C     float real_data[DIM_LEN_5] = {1.11111111, 1.0, 9.99999999, 12345.67, .1234567};
C     double double_data[DIM_LEN_5] = {1.1111111, 1.0, 9.999999999, 1234567890.12345, 123456789012345.0};
      real_data(1) = 1.11111111
      real_data(2) = 1.0
      real_data(3) = 9.99999999
      real_data(4) = 12345.67
      real_data(5) = .1234567
      double_data(1) = 1.1111111
      double_data(2) = 1.0
      double_data(3) = 9.999999999
      double_data(4) = 1234567890.12345
      double_data(5) = 1234567890

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN_5, dimids(1))
      if (retval .ne. nf_noerr) stop 2

C     Create some variables.
      do x = 1, NVARS
         retval = nf_def_var(ncid, var_name(x), var_type(x), NDIM1,
     $        dimids, varid(x))
         if (retval .ne. nf_noerr) stop 3

C     Turn on quantize.
         retval = nf_def_var_quantize(ncid, varid(x),
     $        NF_QUANTIZE_BITGROOM, NSD_3)
         if (retval .ne. nf_noerr) stop 4


C     Turn on zstandard compression if available, zlib otherwise.
#ifdef ENABLE_ZSTD
         retval = nf_def_var_zstandard(ncid, varid(x), ZSTD_LEVEL)
         if (retval .ne. nf_noerr) then
            if (retval .eq. nf_enofilter) then
               print *, 'Zstandard filter not found.'
               print *, 'Set HDF5_PLUGIN_PATH and try again.'
            else
               print *, nf_strerror(retval)
            endif
            stop 5
         endif
#else
         retval = nf_def_var_deflate(ncid, varid(x), 0, 1, 1)
         if (retval .ne. nf_noerr) stop 6
#endif

      end do

C     Write some data (which automatically calls nf_enddef).
      start(1) = 1
      count(1) = DIM_LEN_5
      retval = nf_put_vara_real(ncid, varid(1), start, count,
     $     real_data)
      if (retval .ne. 0) stop 7
      retval = nf_put_vara_double(ncid, varid(2), start, count,
     $     double_data)
      if (retval .ne. 0) stop 8

C     Check it out.
      retval = check_file(ncid, var_name, var_type, dim_name)
      if (retval .ne. 0) stop 9

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 20

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 21

C     Check it out.
      retval = check_file(ncid, var_name, var_type, dim_name)
      if (retval .ne. 0) stop 22

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 23

      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, var_type, dim_name)
      implicit none
      include 'netcdf.inc'

C     I need these in both here and the main program.
      integer NDIM1
      parameter (NDIM1 = 1)
      integer DIM_LEN_5
      parameter (DIM_LEN_5 = 5)
      integer NVARS
      parameter (NVARS = 2)
      integer NSD_3
      parameter (NSD_3 = 3)
      real EPSILON
      parameter (EPSILON  = .01)

C     Parameters
      integer ncid
      character*(10) var_name(NVARS)
      integer var_type(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer xtype_in, dimids_in(NDIM1), natts_in
      integer varid_in(NVARS), dimid_in, quantize_mode_in, nsd_in
      integer zstandard, zstandard_level_in
      character*(10) var_name_in
      real real_data_in(DIM_LEN_5)
      real*8 double_data_in(DIM_LEN_5)
      real real_data_expected(DIM_LEN_5)
      real*8 double_data_expected(DIM_LEN_5)
      real diff
      real*8 diff8

      integer x, retval

C     What we expect to get back.
      real_data_expected(1) = 1.11084
      real_data_expected(2) = 1.000488
      real_data_expected(3) = 10
      real_data_expected(4) = 12348
      real_data_expected(5) = 0.1234436
      double_data_expected(1) = 1.11083984375
      double_data_expected(2) = 1.00048828125
      double_data_expected(3) = 10
      double_data_expected(4) = 1234698240
      double_data_expected(5) = 1234173952

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 30
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 31

C     Get the varids and the dimid.
      do x = 1, NVARS
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 32
         if (varid_in(x) .ne. x) stop 33
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 34
      if (dimid_in .ne. 1) stop 35

C     These things are the same for all variables, except natts_in is
C     different for quantize vars after the file is written, there is an
C     extra attribute.
      do x = 1, NVARS
C     Check quantize settings.
         retval = nf_inq_var(ncid, varid_in(x), var_name_in, xtype_in,
     $        ndims_in, dimids_in, natts_in)
         if (retval .ne. nf_noerr) stop 40
         if (ndims_in .ne. 1 .or. xtype_in .ne. var_type(x) .or.
     $        dimids_in(1).ne. dimid_in) stop 41
         retval = nf_inq_var_quantize(ncid, varid_in(x),
     $        quantize_mode_in, nsd_in)
         if (retval .ne. nf_noerr) stop 42
         if (quantize_mode_in .ne. nf_quantize_bitgroom) stop 43
         if (nsd_in .ne. NSD_3) stop 44

C     Check compression settings.
#ifdef ENABLE_ZSTD
         retval = nf_inq_var_zstandard(ncid, varid_in(x), zstandard,
     $        zstandard_level_in)
         if (retval .ne. nf_noerr) stop 50
         if (zstandard_level_in .ne. 3 .or. zstandard .eq. 0) stop 51
#endif

      end do

C     Get the data.
      retval = nf_get_var_real(ncid, varid_in(1), real_data_in)
      if (retval .ne. nf_noerr) stop 60
      retval = nf_get_var_double(ncid, varid_in(2), double_data_in)
      if (retval .ne. nf_noerr) stop 61

C     Check the data.
      do x = 1, DIM_LEN_5
         diff = abs(real_data_in(x) - real_data_expected(x))
         if (diff .gt. EPSILON) stop 70
         diff = abs(double_data_in(x) - double_data_expected(x))
c$$$  print *, double_data_in(x), double_data_expected(x)
c$$$  print *, 'x = ', x, ' diff = ', diff
         if (diff .gt. EPSILON) stop 71
      end do

      check_file = 0
      end

! This parallel test was contributed by Jim Edwards at UCAR. Thanks Jim!
program f90tst_nc4_par
  use netcdf
  use mpi
  implicit none

  integer :: ierr, my_task, nprocs, nmode

  call MPI_INIT(ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, my_task, ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)

  if(nprocs/=8)then
     stop 'requires 8 tasks'
  end if

#ifdef NF_HAS_PNETCDF
  nmode = IOR(nf90_clobber, nf90_mpiio)
  call parallel_io(nmode)
#endif

#ifdef NF_HAS_PARALLEL4
  nmode = ior(NF90_CLOBBER, NF90_NETCDF4)
  nmode = IOR(nmode, nf90_mpiio)
  call parallel_io(nmode)
#endif

  call MPI_Finalize(ierr)

contains
  !     This subroutine handles errors by printing an error message and
  !     exiting with a non-zero status.
  subroutine handle_err(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode

    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine handle_err

  subroutine parallel_io(nmode)
  use netcdf
  use mpi
  implicit none

  character (len = *), parameter :: FILE_NAME = "f90tst_nc4_par.nc"
  integer :: nmode, fill_mode, ierr, fh, my_task, i, varid
  integer :: dimid(3), start(3), count(3)
  real :: f(3)

  call MPI_COMM_RANK(MPI_COMM_WORLD, my_task, ierr)

  call handle_err(nf90_create(FILE_NAME, nmode, fh, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  call handle_err(nf90_set_fill(fh, NF90_NOFILL, fill_mode))

  call handle_err(nf90_def_dim(fh, 'dim1', 6, dimid(1)))
  call handle_err(nf90_def_dim(fh, 'dim2', 4, dimid(2)))
  call handle_err(nf90_def_dim(fh, 'dim3', 1, dimid(3)))

  call handle_err(nf90_def_var(fh, 'var1', NF90_DOUBLE, dimid, varid))
  call handle_err(nf90_enddef(fh))

  do i=1,3
     f(i) = my_task*3+i
  end do

  count = (/3,1,1/)
  start(1) = mod(my_task,2)*3+1
  start(2) = my_task/2+1
  start(3) = 1

  print *,my_task, start, count, f

  call handle_err(nf90_put_var(fh, varid, f,start=start,count=count))

  call handle_err(nf90_close(fh))

  ! Reopen the file and check it.
  call handle_err(nf90_open(FILE_NAME, NF90_MPIIO, fh, &
       comm = MPI_COMM_WORLD, info = MPI_INFO_NULL))

  call handle_err(nf90_get_var(fh, varid, f, start=start, count=count))
  do i=1,3
     if (f(i) .ne. my_task*3+i) stop 3
  end do

  call handle_err(nf90_close(fh))
  end subroutine parallel_io
end program f90tst_nc4_par

! FORTRAN interfaces to the C utilties defined in fortlib.c
!
! Written by: Richard Weed, Ph.D
!             Center for Advanced Vehicular Systems
!             Mississippi State University
!             rweed@cavs.msstate.edu




! License (and other Lawyer Language)
 
! This software is released under the Apache 2.0 Open Source License. The
! full text of the License can be viewed at :
!
!   http:www.apache.org/licenses/LICENSE-2.0.html
!
! The author grants to the University Corporation for Atmospheric Research
! (UCAR), Boulder, CO, USA the right to revise and extend the software
! without restriction. However, the author retains all copyrights and
! intellectual property rights explicitly stated in or implied by the
! Apache license

! Version 1.  June 2006
!             Unchanged for netCDF 4.1.1

!-------------------------------  udexit --------------------------------------
 Subroutine udexit(status)
!
 USE ISO_C_BINDING, ONLY: C_INT
 Implicit NONE

 
 Integer, Intent(IN) :: status
 Integer(KIND=C_INT) :: cstatus
 Interface
  Subroutine exit(status) BIND(C)
  USE ISO_C_BINDING, ONLY: C_INT
  Integer(KIND=C_INT), VALUE :: status  
  End Subroutine exit
 End Interface

 cstatus = status
 Call exit(cstatus)

 End Subroutine udexit
!-------------------------------  udabort --------------------------------------
 Subroutine udabort()
 USE ISO_C_BINDING
 Implicit NONE
 Interface
  Subroutine abort() BIND(C)
  End Subroutine abort
 End Interface

 Call abort()

 End Subroutine udabort
!-------------------------------  udrand -------------------------------------
 Function udrand(iflag) RESULT(rannum)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Integer, Intent(IN) :: iflag
 Real(RK8) :: rannum
 Integer(KIND=C_INT) :: ciflag
 Real(KIND=C_DOUBLE) :: crannum
 Interface
  Function myrand(iflag) BIND(C)
   USE ISO_C_BINDING, ONLY: C_INT, C_DOUBLE
   Integer(KIND=C_INT), VALUE :: iflag
   Real(KIND=C_DOUBLE) :: myrand
  End Function myrand
 End Interface

 ciflag = iflag
  
 crannum = myrand(ciflag)
 rannum = crannum

 End Function udrand
!-------------------------------  udshift -------------------------------------
 Function udshift(ivalue, amount) RESULT(shiftval)

 USE ISO_C_BINDING

 Implicit NONE

 Integer, Intent(IN) :: ivalue, amount
 Integer(KIND=C_INT) :: cvalue, camount 
 Integer :: shiftval 
 Integer(KIND=C_INT) :: cshiftval
 Interface
  Function myshift(cvalue, camount) BIND(C)
   USE ISO_C_BINDING, ONLY: C_INT
   Integer(KIND=C_INT), VALUE :: cvalue, camount 
   Integer(KIND=C_INT) :: myshift
  End Function myshift
 End Interface

 cvalue = ivalue
 camount = amount
  
 cshiftval = myshift(cvalue, camount)
 shiftval = cshiftval

 End Function udshift
!-------------------------------  ignorefpe  ----------------------------------
 Subroutine ignorefpe(idoit)

 USE ISO_C_BINDING

 Implicit NONE

 Integer, Intent(IN) :: idoit 
 Integer(KIND=C_INT) :: cdoit 
 Interface
  Subroutine nc_ignorefpe(cdoit) BIND(C)
   USE ISO_C_BINDING, ONLY: C_INT
   Integer(KIND=C_INT), VALUE :: cdoit 
  End Subroutine nc_ignorefpe 
 End Interface

 cdoit = idoit
 Call nc_ignorefpe(cdoit)

 End Subroutine ignorefpe
!-------------------------------  max_uchar  ----------------------------------
 Function max_uchar() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_uchar() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_uchar
  End Function cmax_uchar
 End Interface

 ccmax = cmax_uchar()
 cmax = ccmax

 End Function max_uchar
!-------------------------------  min_schar  ----------------------------------
 Function min_schar() RESULT(cmin)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmin
 Real(KIND=C_DOUBLE) :: ccmin
 Interface
  Function cmin_schar() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmin_schar
  End Function cmin_schar
 End Interface

 ccmin = cmin_schar()
 cmin = ccmin

 End Function min_schar
!-------------------------------  max_schar  ----------------------------------
 Function max_schar() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_schar() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_schar
  End Function cmax_schar
 End Interface

 ccmax = cmax_schar()
 cmax = ccmax

 End Function max_schar
!-------------------------------  min_short  ----------------------------------
 Function min_short() RESULT(cmin)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmin
 Real(KIND=C_DOUBLE) :: ccmin
 Interface
  Function cmin_short() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmin_short
  End Function cmin_short
 End Interface

 ccmin = cmin_short()
 cmin = ccmin

 End Function min_short
!-------------------------------  max_short  ----------------------------------
 Function max_short() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_short() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_short
  End Function cmax_short
 End Interface

 ccmax = cmax_short()
 cmax = ccmax

 End Function max_short
!-------------------------------  min_int  ----------------------------------
 Function min_int() RESULT(cmin)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmin
 Real(KIND=C_DOUBLE) :: ccmin
 Interface
  Function cmin_int() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmin_int
  End Function cmin_int
 End Interface

 ccmin = cmin_int()
 cmin = ccmin

 End Function min_int
!-------------------------------  max_int  ----------------------------------
 Function max_int() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_int() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_int
  End Function cmax_int
 End Interface

 ccmax = cmax_int()
 cmax = ccmax

 End Function max_int
!-------------------------------  min_long  ----------------------------------
 Function min_long() RESULT(cmin)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmin
 Real(KIND=C_DOUBLE) :: ccmin
 Interface
  Function cmin_long() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmin_long
  End Function cmin_long
 End Interface

 ccmin = cmin_long()
 cmin = ccmin

 End Function min_long
!-------------------------------  max_long  ----------------------------------
 Function max_long() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_long() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_long
  End Function cmax_long
 End Interface

 ccmax = cmax_long()
 cmax = ccmax

 End Function max_long
!-------------------------------  max_float  ----------------------------------
 Function max_float() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_float() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_float
  End Function cmax_float
 End Interface

 ccmax = cmax_float()
 cmax = ccmax

 End Function max_float
!-------------------------------  max_double  ----------------------------------
 Function max_double() RESULT(cmax)

 USE ISO_C_BINDING

 Implicit NONE
 Integer, Parameter :: RK8=SELECTED_REAL_KIND(P=13, R=307)  ! double
 Real(RK8) :: cmax
 Real(KIND=C_DOUBLE) :: ccmax
 Interface
  Function cmax_double() BIND(C)
   USE ISO_C_BINDING, ONLY: C_DOUBLE
   Real(KIND=C_DOUBLE) :: cmax_double
  End Function cmax_double
 End Interface

 ccmax = cmax_double()
 cmax = ccmax

 End Function max_double

C     This is part of the netCDF package.
C     Copyright 2008 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests prototype nf_open_mem and procedure for
C     creating an in memory netcdf file from an existing netcdf
C     file on a hard drive. The program will first use the logic
C     from f03tst_vars6.F to create a small netcdf file on
C     the hard drive. This file is then opened as a Fortran
C     unformatted, stream file and read into an allocatable
C     array of C_CHAR type. 

C     Dennis Heimbigner, 2018

      program ftst_open_mem
      use netcdf4_f03
      use iso_c_binding, ONLY : C_CHAR

      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_open_mem.nc')
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 2)
      integer check_file
C
C  *** Specify an allocatable array of KIND=C_CHAR with TARGET
C      attribute to hold in-memory NC file. This is the closest
C      we can get to in Fortran >= 2003 to an array of bytes
C      that C will understand

      Character(KIND=C_CHAR), ALLOCATABLE, TARGET :: memfile(:)

      integer ncid, varid(NVARS), dimids(NDIMS)
      integer data_len_in, offset, ncsize, iostat, mode
      parameter (offset = 20)
      integer data1(data_len), data1_in(data_len)
      character*(4) var_name(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer NO_FILL, MY_FILL_VALUE
      parameter (NO_FILL = 1)
      parameter (MY_FILL_VALUE = 42)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing fill values.'

C     Prepare some data to write.
      do x = 1, data_len
         data1(x) = x
      end do

C     Set up var names.
      var_name(1) = 'var1'
      var_name(2) = 'var2'
      var_name(3) = 'var3'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create a few integer variables.
      do x = 1, NVARS      
         retval = nf_def_var(ncid, var_name(x), NF_INT, NDIMS, dimids,
     $        varid(x))
         if (retval .ne. nf_noerr) stop 1
      end do

C     Set no fill mode for the second variable.
      retval = nf_def_var_fill(ncid, varid(2), NO_FILL, 88)
      if (retval .ne. 0) stop 2

C     Set an alternative fill value for the third variable.
      retval = nf_def_var_fill(ncid, varid(3), 0, MY_FILL_VALUE)
      if (retval .ne. 0) stop 3

C     Check it out. 
c      retval = check_file(ncid, var_name, dim_name)
c      if (retval .ne. 0) stop 2

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1
C
C *****   TESTING OF nf_open_mem ******
C

      Print *,''
      Print *,' testing nf_open_mem'
      Print *,''
C
C     First open external netcdf file with unformatted stream access
C     and get file size (hopefully in bytes) using INQUIRE intrinsic
C

      Open(7, FILE=FILE_NAME, STATUS="UNKNOWN", ACCESS="STREAM",         &
     & FORM="UNFORMATTED")
      INQUIRE(FILE=FILE_NAME,  SIZE=ncsize)

      Print *,''
      Print *,' FILE = ', TRIM(FILE_NAME), ' is ', ncsize, ' bytes'
      Print *,''

C For non-zero length files ALLOCATED memfile to size returned by INQUIRE
C Then do an unformatted read on file. If no read errors (iostat==0)
C then call nf_open_mem in NF_DISKLESS mode

      If (ncsize > 0) Then
        ALLOCATE(memfile(ncsize))
        Read(7, iostat=iostat) memfile(1:ncsize)
        If (iostat == 0) then
           Close(7)
           mode = NF_INMEMORY
           retval = nf_open_mem(FILE_NAME, mode, ncsize, memfile, ncid)
        Else
           retval = iostat
        EndIf
        if (retval .ne. 0) stop 41
      Else
        stop 42
      EndIf 
      retval = check_file(ncid, var_name, dim_name)
      if (retval .ne. 0) stop 4

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      If (ALLOCATED(memfile)) DEALLOCATE(memfile)
      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, dim_name)
      use netcdf4_f03
      implicit none

C     I need these in both here and the main program.
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 2)
      integer MY_FILL_VALUE
      parameter (MY_FILL_VALUE = 42)

C     Parameters
      integer ncid
      character*(4) var_name(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer xtype_in, dimids_in(NDIMS), natts_in
      integer varid_in(NVARS), dimid_in, no_fill_in, fill_value_in
      character*(4) var_name_in
      integer int_data_in(DIM_LEN)

      integer x, retval

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 5

C     Get the varids and the dimid.
      do x = 1, NVARS      
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 1
         if (varid_in(x) .ne. x) stop 6
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (dimid_in .ne. 1) stop 7

C     These things are the same for all three variables, except
C     natts_in..
      do x = 1, NVARS      
         retval = nf_inq_var(ncid, varid_in(x), var_name_in, xtype_in,
     $        ndims_in, dimids_in, natts_in)
         if (retval .ne. nf_noerr) stop 1
         if (ndims_in .ne. 1 .or. xtype_in .ne. NF_INT .or. dimids_in(1)
     $        .ne. dimid_in) stop 8
         if (x .eq. 3 .and. natts_in .ne. 1) stop 9
         if (x .lt. 3 .and. natts_in .ne. 0) stop 10
      end do

C     Check the fill value for the first var. Nothing was set, so
C     no_fill should be off, and fill_value should be the default fill
C     value for this type.
      retval = nf_inq_var_fill(ncid, varid_in(1), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 0 .or. fill_value_in .ne. nf_fill_int) stop 11

C     Check that no_fill mode is on for the second variable.
      retval = nf_inq_var_fill(ncid, varid_in(2), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 1 .or. fill_value_in .ne. nf_fill_int) stop 12

C     Check that a non-default fill value is in use for the third variable.
      retval = nf_inq_var_fill(ncid, varid_in(3), no_fill_in,
     $     fill_value_in)
      if (retval .ne. nf_noerr) stop 1
      if (no_fill_in .ne. 0 .or. fill_value_in .ne. MY_FILL_VALUE) stop
     $     2

C     Get the data in var1. It will be all the default fill value.
      retval = nf_get_var_int(ncid, varid_in(1), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. nf_fill_int) stop 13
      end do

C     Get the data in var2. What will it be?
      retval = nf_get_var_int(ncid, varid_in(2), int_data_in)
      if (retval .ne. nf_noerr) stop 1
C$$$      do x = 1, DIM_LEN
C$$$         print *, int_data_in(x)
C$$$      end do

C     Get the data in var3. It will be all the default fill value.
      retval = nf_get_var_int(ncid, varid_in(3), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
C         print *, int_data_in(x)
         if (int_data_in(x) .ne. MY_FILL_VALUE) stop 14
      end do

      check_file = 0
      end 

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example program which writes some 4D pressure and
C     temperatures. It is intended to illustrate the use of the netCDF
C     fortran 77 API. The companion program pres_temp_4D_rd.f shows how
C     to read the netCDF data file created by this program.

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program pres_temp_4D_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME = 'pres_temp_4D.nc')
      integer ncid

C     We are writing 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
C     timesteps of data.
      integer NDIMS, NRECS
      parameter (NDIMS = 4, NRECS = 2)
      integer NLVLS, NLATS, NLONS
      parameter (NLVLS = 2, NLATS = 6, NLONS = 12)
      character*(*) LVL_NAME, LAT_NAME, LON_NAME, REC_NAME
      parameter (LVL_NAME = 'level')
      parameter (LAT_NAME = 'latitude', LON_NAME = 'longitude')
      parameter (REC_NAME = 'time')
      integer lvl_dimid, lon_dimid, lat_dimid, rec_dimid

C     The start and count arrays will tell the netCDF library where to
C     write our data.
      integer start(NDIMS), count(NDIMS)

C     These program variables hold the latitudes and longitudes.
      real lats(NLATS), lons(NLONS)
      integer lon_varid, lat_varid

C     We will create two netCDF variables, one each for temperature and
C     pressure fields.
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     We recommend that each variable carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     Program variables to hold the data we will write out. We will only
C     need enough space to hold one timestep of data; one record.
      real pres_out(NLONS, NLATS, NLVLS)
      real temp_out(NLONS, NLATS, NLVLS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Use these to construct some latitude and longitude data for this
C     example.
      integer START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     Loop indices.
      integer lvl, lat, lon, rec, i

C     Error handling.
      integer retval

C     Create pretend data. If this wasn't an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      i = 0
      do lvl = 1, NLVLS
         do lat = 1, NLATS
            do lon = 1, NLONS
               pres_out(lon, lat, lvl) = SAMPLE_PRESSURE + i
               temp_out(lon, lat, lvl) = SAMPLE_TEMP + i
               i = i + 1
            end do
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions. The record dimension is defined to have
C     unlimited length - it can grow as needed. In this example it is
C     the time dimension.
      retval = nf_def_dim(ncid, LVL_NAME, NLVLS, lvl_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, REC_NAME, NF_UNLIMITED, rec_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. We will only define coordinate
C     variables for lat and lon.  Ordinarily we would need to provide
C     an array of dimension IDs for each variable's dimensions, but
C     since coordinate variables only have one dimension, we can
C     simply provide the address of that dimension ID (lat_dimid) and
C     similarly for (lon_dimid).
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate variables.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     The dimids array is used to pass the dimids of the dimensions of
C     the netCDF variables. Both of the netCDF variables we are creating
C     share the same four dimensions. In Fortran, the unlimited
C     dimension must come last on the list of dimids.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      dimids(3) = lvl_dimid
      dimids(4) = rec_dimid

C     Define the netCDF variables for the pressure and temperature data.
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the netCDF variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     These settings tell netcdf to write one timestep of data. (The
C     setting of start(4) inside the loop below tells netCDF which
C     timestep to write.)
      count(1) = NLONS
      count(2) = NLATS
      count(3) = NLVLS
      count(4) = 1
      start(1) = 1
      start(2) = 1
      start(3) = 1

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays only hold one timestep worth
C     of data. We will just rewrite the same data for each timestep. In
C     a real application, the data would change between timesteps.
      do rec = 1, NRECS
         start(4) = rec
         retval = nf_put_vara_real(ncid, pres_varid, start, count, 
     +        pres_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
         retval = nf_put_vara_real(ncid, temp_varid, start, count,
     +        temp_out)
         if (retval .ne. nf_noerr) call handle_err(retval)
      end do

C     Close the file. This causes netCDF to flush all buffers and make
C     sure your data are really written to disk.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
      print *,'*** SUCCESS writing example file', FILE_NAME, '!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

  ! Overload fill value functions

  interface nf90_def_var_fill
    module procedure nf90_def_var_fill_OneByteInt,   &
                     nf90_def_var_fill_TwoByteInt,   &
                     nf90_def_var_fill_FourByteInt,  &
                     nf90_def_var_fill_EightByteInt, &
                     nf90_def_var_fill_FourByteReal, &
                     nf90_def_var_fill_EightByteReal
   end interface

  interface nf90_inq_var_fill
    module procedure nf90_inq_var_fill_OneByteInt,   &
                     nf90_inq_var_fill_TwoByteInt,   &
                     nf90_inq_var_fill_FourByteInt,  &
                     nf90_inq_var_fill_EightByteInt, &
                     nf90_inq_var_fill_FourByteReal, &
                     nf90_inq_var_fill_EightByteReal
   end interface
  

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This example writes some surface pressure and temperatures. It is
C     intended to illustrate the use of the netCDF fortran 77 API. The
C     companion program sfc_pres_temp_rd.f shows how to read the netCDF
C     data file created by this program.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: sfc_pres_temp_wr.f,v 1.10 2007/02/14 20:59:20 ed Exp $

      program sfc_pres_temp_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
C     netCDF dimensions.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')
      integer lon_dimid, lat_dimid

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude netCDF variables which will hold the
C     actual latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     We will write surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     It's good practice for each variable to carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     We will create some pressure and temperature data to write out.
      real pres_out(NLONS, NLATS), temp_out(NLONS, NLATS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Loop indices.
      integer lat, lon

C     Error handling.
      integer retval

C     Create pretend data. If this were not an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      do lon = 1, NLONS
         do lat = 1, NLATS
            pres_out(lon, lat) = SAMPLE_PRESSURE + 
     +           (lon - 1) * NLATS + (lat - 1)
            temp_out(lon, lat) = SAMPLE_TEMP + 
     +           .25 * ((lon - 1) * NLATS + (lat - 1))
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. They will hold the coordinate
C     information, that is, the latitudes and longitudes. A varid is
C     returned for each.
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate var data. This attaches a
C     text attribute to each of the coordinate variables, containing the
C     units.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the netCDF variables. The dimids array is used to pass the
C     dimids of the dimensions of the netCDF variables.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the pressure and temperature netCDF
C     variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays of data are the same size as
C     the netCDF variables we have defined.
      retval = nf_put_var_real(ncid, pres_varid, pres_out)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, temp_varid, temp_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS writing example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF-4 fortran 90 API.
! Copyright 2006, UCAR
! $Id: netcdf4_visibility.f90,v 1.15 2009/09/28 17:53:00 ed Exp $
  
public :: nf90_create_par, nf90_open_par, nf90_var_par_access, &
     nf90_inq_ncid, nf90_inq_grps, nf90_inq_grp_ncid, nf90_inq_grp_full_ncid, nf90_inq_grpname, &
     nf90_inq_grpname_full, nf90_inq_grpname_len, nf90_inq_varids, nf90_inq_grp_parent, &
     nf90_inq_dimids, nf90_inq_typeids, nf90_def_grp, nf90_def_compound, &
     nf90_insert_compound, nf90_insert_array_compound, nf90_inq_type, &
     nf90_inq_compound, nf90_inq_compound_name, nf90_inq_compound_size, &
     nf90_inq_compound_nfields, nf90_inq_compound_field, &
     nf90_inq_compound_fieldname, nf90_inq_compound_fieldindex, &
     nf90_inq_compound_fieldoffset, nf90_inq_compound_fieldtype, &
     nf90_inq_compound_fieldndims, nf90_inq_cmp_fielddim_sizes, nf90_def_vlen, nf90_inq_vlen, &
     nf90_def_enum, nf90_insert_enum, nf90_inq_enum, nf90_inq_enum_member, nf90_inq_enum_ident, &
     nf90_def_opaque, nf90_inq_opaque, nf90_def_var_deflate, nf90_inq_var_deflate, &
     nf90_def_var_fletcher32, nf90_inq_var_fletcher32, nf90_def_var_chunking, &
     nf90_inq_var_chunking, &
     nf90_def_var_fill, nf90_inq_var_fill, &
     nf90_def_var_endian, nf90_inq_var_endian, nf90_inq_user_type, &
     nf90_put_att_any, nf90_get_att_any, nf90_get_var_any, nf90_put_var_any, &
     nf90_rename_grp, nf90_def_var_filter, nf90_inq_var_filter
     
  

C     Copyright 1996-2019, UCAR/Unidata
C     See COPYRIGHT file for copying and redistribution conditions.

C     Test driver for netCDF-3 interface.  This program performs tests against
C     the netCDF-3 specification for all user-level functions in an
C     implementation of the netCDF library.

C     Steve Emmerson, Ed Hartnett

      subroutine test(name, func)
      implicit none
#include "tests.inc"
      character*(*)   name
      external        func

      write(*, 1) name
 1    format(' *** testing ', a, ' ... ')
      nfails = 0
      call func()
      nfailsTotal = nfailsTotal + nfails
      if ( nfails .ne. 0) then
         print *, ' '
         print *, '  ### ', nfails, ' FAILURES TESTING ', name,
     +        '! ###'
C     continue the remaining tests, uncomment below to stop now
C     stop 2
      end if

      end

      program nf_test
      implicit none
#include "tests.inc"

      integer         status
      integer         i, num_cmode, err, dft_fmt
      integer         cmode(3)

      external        test_nf_strerror
      external        test_nf_open
      external        test_nf_close
      external        test_nf_inq
      external        test_nf_inq_dimid
      external        test_nf_inq_dim
      external        test_nf_inq_dimlen
      external        test_nf_inq_dimname
      external        test_nf_inq_varid
      external        test_nf_inq_var
      external        test_nf_inq_natts
      external        test_nf_inq_ndims
      external        test_nf_inq_nvars
      external        test_nf_inq_unlimdim
      external        test_nf_inq_format
      external        test_nf_inq_vardimid
      external        test_nf_inq_varname
      external        test_nf_inq_varnatts
      external        test_nf_inq_varndims
      external        test_nf_inq_vartype
      external        test_nf_get_var1_text
#if defined(NF_INT1_T)
      external        test_nf_get_var1_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_var1_int2
#endif
      external        test_nf_get_var1_int
      external        test_nf_get_var1_real
      external        test_nf_get_var1_double
      external        test_nf_get_var_text
#if defined(NF_INT1_T)
      external        test_nf_get_var_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_var_int2
#endif
      external        test_nf_get_var_int
      external        test_nf_get_var_real
      external        test_nf_get_var_double
      external        test_nf_get_vara_text
#if defined(NF_INT1_T)
      external        test_nf_get_vara_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_vara_int2
#endif
      external        test_nf_get_vara_int
      external        test_nf_get_vara_real
      external        test_nf_get_vara_double
      external        test_nf_get_vars_text
#if defined(NF_INT1_T)
      external        test_nf_get_vars_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_vars_int2
#endif
      external        test_nf_get_vars_int
      external        test_nf_get_vars_real
      external        test_nf_get_vars_double
      external        test_nf_get_varm_text
#if defined(NF_INT1_T)
      external        test_nf_get_varm_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_varm_int2
#endif
      external        test_nf_get_varm_int
      external        test_nf_get_varm_real
      external        test_nf_get_varm_double
      external        test_nf_get_att_text
#if defined(NF_INT1_T)
      external        test_nf_get_att_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_att_int2
#endif
      external        test_nf_get_att_int
      external        test_nf_get_att_real
      external        test_nf_get_att_double
      external        test_nf_inq_att
      external        test_nf_inq_attname
      external        test_nf_inq_attid
      external        test_nf_inq_attlen
      external        test_nf_inq_atttype
      external        test_nf_create
      external        test_nf_redef
      external        test_nf_enddef
      external        test_nf_sync
      external        test_nf_abort
      external        test_nf_def_dim
      external        test_nf_rename_dim
      external        test_nf_def_var
      external        test_nf_put_var1_text
#if defined(NF_INT1_T)
      external        test_nf_put_var1_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_var1_int2
#endif
      external        test_nf_put_var1_int
      external        test_nf_put_var1_real
      external        test_nf_put_var1_double
      external        test_nf_put_var_text
#if defined(NF_INT1_T)
      external        test_nf_put_var_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_var_int2
#endif
      external        test_nf_put_var_int
      external        test_nf_put_var_real
      external        test_nf_put_var_double
      external        test_nf_put_vara_text
#if defined(NF_INT1_T)
      external        test_nf_put_vara_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_vara_int2
#endif
      external        test_nf_put_vara_int
      external        test_nf_put_vara_real
      external        test_nf_put_vara_double
      external        test_nf_put_vars_text
#if defined(NF_INT1_T)
      external        test_nf_put_vars_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_vars_int2
#endif
      external        test_nf_put_vars_int
      external        test_nf_put_vars_real
      external        test_nf_put_vars_double
      external        test_nf_put_varm_text
#if defined(NF_INT1_T)
      external        test_nf_put_varm_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_varm_int2
#endif
      external        test_nf_put_varm_int
      external        test_nf_put_varm_real
      external        test_nf_put_varm_double
      external        test_nf_rename_var
      external        test_nf_put_att_text
#if defined(NF_INT1_T)
      external        test_nf_put_att_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_att_int2
#endif
      external        test_nf_put_att_int
      external        test_nf_put_att_real
      external        test_nf_put_att_double
      external        test_nf_copy_att
      external        test_nf_rename_att
      external        test_nf_del_att
      external        test_nf_set_fill
      external        test_nf_set_default_format
      external        ignorefpe

      print *, ''
      print *, '*** Testing netCDF-3 Fortran 77 API.'
      call ignorefpe(1)

      testfile = 'test.nc'
      scratch = 'scratch.nc'

      nfailsTotal = 0
      progname = 'nf_test'
      max_nmpt = 8

      write(*, *) 'NetCDF version: ', nf_inq_libvers()

      num_cmode = 1
      cmode(1) = 0
#ifdef ENABLE_CDF5
      num_cmode = num_cmode + 1
      cmode(num_cmode) = nf_cdf5
#endif
#ifdef USE_NETCDF4
      num_cmode = num_cmode + 1
      cmode(num_cmode) = nf_netcdf4
#endif

      do i = 1, num_cmode

         if (cmode(i) .EQ. 0) then
            print*,"testing classic CDF-1 format"
#ifdef ENABLE_CDF5
         elseif (cmode(i) .EQ. nf_cdf5) then
            print*,"testing CDF-5 format"
#endif
#ifdef USE_NETCDF4
         elseif (cmode(i) .EQ. nf_netcdf4) then
            print*,"testing NetCDF-4 format"
#endif
         endif

C     /* Initialize global variables defining test file */
         call init_gvars

         call write_file(testfile)
         if (nfailsTotal .gt. 0) call udexit(1)

C     /* delete any existing scratch netCDF file */
         status = nf_delete(scratch)

C     /* Test read-only functions, using pregenerated test-file */
         call test('nf_strerror', test_nf_strerror)
         call test('nf_open', test_nf_open)
         call test('nf_close', test_nf_close)
         call test('nf_inq', test_nf_inq)
         call test('nf_inq_dimid', test_nf_inq_dimid)
         call test('nf_inq_dim', test_nf_inq_dim)
         call test('nf_inq_dimlen', test_nf_inq_dimlen)
         call test('nf_inq_dimname', test_nf_inq_dimname)
         call test('nf_inq_varid', test_nf_inq_varid)
         call test('nf_inq_var', test_nf_inq_var)
         call test('nf_inq_natts', test_nf_inq_natts)
         call test('nf_inq_ndims', test_nf_inq_ndims)
         call test('nf_inq_nvars', test_nf_inq_nvars)
         call test('nf_inq_unlimdim', test_nf_inq_unlimdim)
         call test('nf_inq_format', test_nf_inq_format)
         call test('nf_inq_vardimid', test_nf_inq_vardimid)
         call test('nf_inq_varname', test_nf_inq_varname)
         call test('nf_inq_varnatts', test_nf_inq_varnatts)
         call test('nf_inq_varndims', test_nf_inq_varndims)
         call test('nf_inq_vartype', test_nf_inq_vartype)
         call test('nf_get_var1_text', test_nf_get_var1_text)
#if defined(NF_INT1_T)
         call test('nf_get_var1_int1', test_nf_get_var1_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_var1_int2', test_nf_get_var1_int2)
#endif
         call test('nf_get_var1_int', test_nf_get_var1_int)
         call test('nf_get_var1_real', test_nf_get_var1_real)
         call test('nf_get_var1_double', test_nf_get_var1_double)
         call test('nf_get_var_text', test_nf_get_var_text)
#if defined(NF_INT1_T)
         call test('nf_get_var_int1', test_nf_get_var_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_var_int2', test_nf_get_var_int2)
#endif
         call test('nf_get_var_int', test_nf_get_var_int)
         call test('nf_get_var_real', test_nf_get_var_real)
         call test('nf_get_var_double', test_nf_get_var_double)
         call test('nf_get_vara_text', test_nf_get_vara_text)
#if defined(NF_INT1_T)
         call test('nf_get_vara_int1', test_nf_get_vara_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_vara_int2', test_nf_get_vara_int2)
#endif
         call test('nf_get_vara_int', test_nf_get_vara_int)
         call test('nf_get_vara_real', test_nf_get_vara_real)
         call test('nf_get_vara_double', test_nf_get_vara_double)
         call test('nf_get_vars_text', test_nf_get_vars_text)
#if defined(NF_INT1_T)
         call test('nf_get_vars_int1', test_nf_get_vars_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_vars_int2', test_nf_get_vars_int2)
#endif
         call test('nf_get_vars_int', test_nf_get_vars_int)
         call test('nf_get_vars_real', test_nf_get_vars_real)
         call test('nf_get_vars_double', test_nf_get_vars_double)
         call test('nf_get_varm_text', test_nf_get_varm_text)
#if defined(NF_INT1_T)
         call test('nf_get_varm_int1', test_nf_get_varm_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_varm_int2', test_nf_get_varm_int2)
#endif
         call test('nf_get_varm_int', test_nf_get_varm_int)
         call test('nf_get_varm_real', test_nf_get_varm_real)
         call test('nf_get_varm_double', test_nf_get_varm_double)
         call test('nf_get_att_text', test_nf_get_att_text)
#if defined(NF_INT1_T)
         call test('nf_get_att_int1', test_nf_get_att_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_att_int2', test_nf_get_att_int2)
#endif
         call test('nf_get_att_int', test_nf_get_att_int)
         call test('nf_get_att_real', test_nf_get_att_real)
         call test('nf_get_att_double', test_nf_get_att_double)
         call test('nf_inq_att', test_nf_inq_att)
         call test('nf_inq_attname', test_nf_inq_attname)
         call test('nf_inq_attid', test_nf_inq_attid)
         call test('nf_inq_attlen', test_nf_inq_attlen)
         call test('nf_inq_atttype', test_nf_inq_atttype)

C     /* Test write functions */
         call test('nf_create', test_nf_create)
         call test('nf_redef', test_nf_redef)
         call test('nf_enddef', test_nf_enddef)
         call test('nf_sync', test_nf_sync)
         call test('nf_abort', test_nf_abort)
         call test('nf_def_dim', test_nf_def_dim)
         call test('nf_rename_dim', test_nf_rename_dim)
         call test('nf_def_var', test_nf_def_var)
         call test('nf_put_var1_text', test_nf_put_var1_text)
#if defined(NF_INT1_T)
         call test('nf_put_var1_int1', test_nf_put_var1_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_var1_int2', test_nf_put_var1_int2)
#endif
         call test('nf_put_var1_int', test_nf_put_var1_int)
         call test('nf_put_var1_real', test_nf_put_var1_real)
         call test('nf_put_var1_double', test_nf_put_var1_double)
         call test('nf_put_var_text', test_nf_put_var_text)
#if defined(NF_INT1_T)
         call test('nf_put_var_int1', test_nf_put_var_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_var_int2', test_nf_put_var_int2)
#endif
         call test('nf_put_var_int', test_nf_put_var_int)
         call test('nf_put_var_real', test_nf_put_var_real)
         call test('nf_put_var_double', test_nf_put_var_double)
         call test('nf_put_vara_text', test_nf_put_vara_text)
#if defined(NF_INT1_T)
         call test('nf_put_vara_int1', test_nf_put_vara_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_vara_int2', test_nf_put_vara_int2)
#endif
         call test('nf_put_vara_int', test_nf_put_vara_int)
         call test('nf_put_vara_real', test_nf_put_vara_real)
         call test('nf_put_vara_double', test_nf_put_vara_double)
         call test('nf_put_vars_text', test_nf_put_vars_text)
#if defined(NF_INT1_T)
         call test('nf_put_vars_int1', test_nf_put_vars_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_vars_int2', test_nf_put_vars_int2)
#endif
         call test('nf_put_vars_int', test_nf_put_vars_int)
         call test('nf_put_vars_real', test_nf_put_vars_real)
         call test('nf_put_vars_double', test_nf_put_vars_double)
         call test('nf_put_varm_text', test_nf_put_varm_text)
#if defined(NF_INT1_T)
         call test('nf_put_varm_int1', test_nf_put_varm_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_varm_int2', test_nf_put_varm_int2)
#endif
         call test('nf_put_varm_int', test_nf_put_varm_int)
         call test('nf_put_varm_real', test_nf_put_varm_real)
         call test('nf_put_varm_double', test_nf_put_varm_double)
         call test('nf_rename_var', test_nf_rename_var)
         call test('nf_put_att_text', test_nf_put_att_text)
#if defined(NF_INT1_T)
         call test('nf_put_att_int1', test_nf_put_att_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_att_int2', test_nf_put_att_int2)
#endif
         call test('nf_put_att_int', test_nf_put_att_int)
         call test('nf_put_att_real', test_nf_put_att_real)
         call test('nf_put_att_double', test_nf_put_att_double)
         call test('nf_copy_att', test_nf_copy_att)
         call test('nf_rename_att', test_nf_rename_att)
         call test('nf_del_att', test_nf_del_att)
         call test('nf_set_fill', test_nf_set_fill)
         call test('nf_set_default_format',
     +        test_nf_set_default_format)

! reset default format, otherwise the remaining tests will use
! the one set in the last test
         err = nf_set_default_format(NF_FORMAT_CLASSIC, dft_fmt)
      enddo

      print *,'Total number of failures: ', nfailsTotal
      if (nfailsTotal .ne. 0) stop 2
      print *,'*** SUCCESS!'

      end

!     This is part of the netCDF package.
!     Copyright 2007 University Corporation for Atmospheric Research/Unidata.
!     See COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 new types from fortran 90.

!     Ed Hartnett, 2009

program f90tst_types
  use typeSizes
  use netcdf
  implicit none
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_types.nc"

  ! Information for the types we create.
  character (len = *), parameter :: OPAQUE_TYPE_NAME = "Odessyus"
  character (len = *), parameter :: var_name = "Polyphemus"
  character (len = 80) :: name_in
  character (len = 10), parameter :: opaque_data = "0123456789"
  character (len = *), parameter :: att_name = "att1"

  integer, parameter :: OPAQUE_SIZE = 10
  integer (kind = EightByteInt) BIG_NUMBER, num_in
  parameter (BIG_NUMBER = 4294967295_EightByteInt)
  integer :: ncid, opaque_typeid, varid
  integer :: size_in, base_typeid_in, nfields_in, class_in

  print *, ''
  print *,'*** Testing new netCDF-4 types from Fortran 90.'
  
  ! Create the netCDF file. 
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid))

  ! Create an opaque type.
  call check(nf90_def_opaque(ncid, OPAQUE_SIZE, OPAQUE_TYPE_NAME, opaque_typeid))

  ! Write an (global) opaque attribute.
  call check(nf90_put_att_any(ncid, NF90_GLOBAL, att_name, opaque_typeid, 1, opaque_data))

  ! Create an int64 scalar variable.
  call check(nf90_def_var(ncid, var_name, nf90_int64, varid))

  ! Write a large integer (too large to fit in 32-bit ints).
  call check(nf90_put_var(ncid, varid, BIG_NUMBER))

  ! Close the file. 
  call check(nf90_close(ncid))

  ! Reopen the netCDF file. 
  call check(nf90_open(FILE_NAME, 0, ncid))

  ! Check the opaque type.
  call check(nf90_inq_user_type(ncid, opaque_typeid, name_in, size_in, &
       base_typeid_in, nfields_in, class_in))
  if (name_in(1:len(OPAQUE_TYPE_NAME)) .ne. OPAQUE_TYPE_NAME .or. &
       size_in .ne. OPAQUE_SIZE .or. base_typeid_in .ne. 0 .or. &
       nfields_in .ne. 0 .or. class_in .ne. NF90_OPAQUE) stop 2

  ! Check it again with the inq_opaque call.
  call check(nf90_inq_opaque(ncid, opaque_typeid, name_in, size_in))
  if (name_in(1:len(OPAQUE_TYPE_NAME)) .ne. OPAQUE_TYPE_NAME .or. &
       size_in .ne. OPAQUE_SIZE) stop 2

  ! Check it again with the inq_type call
!!  call check(nf90_inq_type(ncid, opaque_typeid, name_in, size_in))
  if (name_in(1:len(OPAQUE_TYPE_NAME)) .ne. OPAQUE_TYPE_NAME .or. &
       size_in .ne. OPAQUE_SIZE) stop 2

  ! Read in the large number.
  call check(nf90_get_var(ncid, varid, num_in))
  if (num_in .ne. BIG_NUMBER) stop 2

  ! Close the file. 
  call check(nf90_close(ncid))
  
  print *,'*** SUCCESS!'

!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  

end program f90tst_types

program testEightByteGet
  use typeSizes
  use netcdf
  implicit none
  
  ! netcdf related variables
  integer :: ncFileID, dimId, varId
             
  ! Local variables
  integer, parameter :: numLats = 10
  character (len = *), parameter :: fileName = "eightByteIntExample.nc"
  integer            :: counter
  !integer(kind = FourByteInt), dimension(numLats) :: lats  
  integer(kind = EightByteInt), dimension(numLats) :: lats  

! -----  
  call check(nf90_create(path = trim(fileName), cmode = nf90_clobber, ncid = ncFileID))
  
  ! Define the dimensions
  call check(nf90_def_dim(ncid = ncFileID, name = "lat", len = numLats, dimid = dimID))
  ! Define the variable
  call check(nf90_def_var(ncFileID, "lat", nf90_int, dimids = dimID, varID = varID) )
  ! Leave define mode
  call check(nf90_enddef(ncfileID))
  ! Write the variable
  lats(:) = (/ (counter, counter = 1, numLats) /)
  print *, lats
  call check(nf90_put_var(ncFileID, varId, lats ))
  call check(nf90_close(ncFileID))

  ! Now read it back in... 
  lats(:) = 0
  call check(nf90_open(path = trim(fileName), mode = nf90_nowrite, ncid = ncFileID))
  call check(nf90_inq_varid(ncFileId, "lat", varId))
  call check(nf90_get_var(ncFileID, varId, lats))
  print *, lats
  call check(nf90_close(ncFileID))  
  
contains
  ! Internal subroutine - checks error status after each netcdf, prints out text message each time
  !   an error code is returned. 
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
    end if
  end subroutine check  
end program testEightByteGet

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.
      
! This is a simple example which reads a small dummy array, from a
! netCDF data file created by the companion program simple_xy_wr.f90.
      
! This is intended to illustrate the use of the netCDF fortran 90
! API. This example program is part of the netCDF tutorial, which can
! be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial
      
! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: simple_xy_rd.f90,v 1.11 2010/04/06 19:32:09 ed Exp $

program simple_xy_rd
  use netcdf
  implicit none

  ! This is the name of the data file we will read. 
  character (len = *), parameter :: FILE_NAME = "simple_xy.nc"

  ! We are reading 2D data, a 12 x 6 grid. 
  integer, parameter :: NX = 6, NY = 12
  integer, dimension(:,:), allocatable :: data_in

  ! This will be the netCDF ID for the file and data variable.
  integer :: ncid, varid

  ! Loop indexes, and error handling.
  integer :: x, y

  ! Allocate memory for data.
  allocate(data_in(NY, NX))

  ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
  ! the file.
  call check( nf90_open(FILE_NAME, NF90_NOWRITE, ncid) )

  ! Get the varid of the data variable, based on its name.
  call check( nf90_inq_varid(ncid, "data", varid) )

  ! Read the data.
  call check( nf90_get_var(ncid, varid, data_in) )

  ! Check the data.
  do x = 1, NX
     do y = 1, NY
        if (data_in(y, x) /= (x - 1) * NY + (y - 1)) then
           print *, "data_in(", y, ", ", x, ") = ", data_in(y, x)
           stop "Stopped"
        end if
     end do
  end do

  ! Close the file, freeing all resources.
  call check( nf90_close(ncid) )

  print *,"*** SUCCESS reading example file ", FILE_NAME, "! "

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program simple_xy_rd

!*********************************************************************
!   Copyright 1996, UCAR/Unidata
!   See netcdf/COPYRIGHT file for copying and redistribution conditions.
!   $Id: util.F,v 1.16 2008/12/31 17:54:10 ed Exp $
!********************************************************************/

! Implementation of util.F for F03 interfaces

      SUBROUTINE PRINT_NOK(NOK)
      use tests, ONLY: NFAILS, VERBOSE
      IMPLICIT  NONE
      INTEGER   NOK

      IF (VERBOSE .OR. NFAILS .GT. 0) PRINT *, ' '
      IF (VERBOSE) PRINT *, NOK, ' good comparisons.'
      END


! Is value within external type range? */
      FUNCTION INRANGE(VALUE, DATATYPE)
      use tests, ONLY: NF_CHAR, NF_BYTE, NF_SHORT, NF_INT, NF_FLOAT,    &
     &                 NF_DOUBLE, X_CHAR_MIN, X_CHAR_MAX, X_BYTE_MIN,   &
     &                 X_BYTE_MAX, X_SHORT_MIN, X_SHORT_MAX, X_INT_MIN, &
     &                 X_INT_MAX, X_FLOAT_MIN, X_FLOAT_MAX,             &
     &                 X_DOUBLE_MIN, X_DOUBLE_MAX

      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
      LOGICAL           INRANGE

      DOUBLEPRECISION   MIN
      DOUBLEPRECISION   MAX

      IF (DATATYPE .EQ. NF_CHAR) THEN
          MIN = X_CHAR_MIN
          MAX = X_CHAR_MAX
      ELSE IF (DATATYPE .EQ. NF_BYTE) THEN
          MIN = X_BYTE_MIN
          MAX = X_BYTE_MAX
      ELSE IF (DATATYPE .EQ. NF_SHORT) THEN
          MIN = X_SHORT_MIN
          MAX = X_SHORT_MAX
      ELSE IF (DATATYPE .EQ. NF_INT) THEN
          MIN = X_INT_MIN
          MAX = X_INT_MAX
      ELSE IF (DATATYPE .EQ. NF_FLOAT) THEN
          MIN = X_FLOAT_MIN
          MAX = X_FLOAT_MAX
      ELSE IF (DATATYPE .EQ. NF_DOUBLE) THEN
          MIN = X_DOUBLE_MIN
          MAX = X_DOUBLE_MAX
      ELSE
          CALL UDABORT
      END IF

      INRANGE = (VALUE .GE. MIN) .AND. (VALUE .LE. MAX)
      END


      FUNCTION INRANGE_UCHAR(VALUE, DATATYPE)
      use tests, ONLY: NF_BYTE, INRANGE
      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
      LOGICAL INRANGE_UCHAR

      IF (DATATYPE .EQ. NF_BYTE) THEN
          INRANGE_UCHAR = (VALUE .GE. 0) .AND. (VALUE .LE. 255)
      ELSE
          INRANGE_UCHAR = INRANGE(VALUE, DATATYPE)
      END IF
      END


      FUNCTION INRANGE_FLOAT(VALUE, DATATYPE)
      use tests, ONLY: NF_CHAR, NF_BYTE, NF_SHORT, NF_INT, NF_FLOAT,    &
     &                 NF_DOUBLE, X_CHAR_MIN, X_CHAR_MAX, X_BYTE_MIN,   &
     &                 X_BYTE_MAX, X_SHORT_MIN, X_SHORT_MAX, X_INT_MIN, &
     &                 X_INT_MAX, X_FLOAT_MIN, X_FLOAT_MAX, NFT_REAL,   &
     &                 X_DOUBLE_MIN, X_DOUBLE_MAX, internal_max
      IMPLICIT  NONE
      DOUBLEPRECISION   VALUE
      INTEGER           DATATYPE
      LOGICAL INRANGE_FLOAT

      DOUBLEPRECISION   MIN
      DOUBLEPRECISION   MAX
      REAL              FVALUE

      IF (DATATYPE .EQ. NF_CHAR) THEN
          MIN = X_CHAR_MIN
          MAX = X_CHAR_MAX
      ELSE IF (DATATYPE .EQ. NF_BYTE) THEN
          MIN = X_BYTE_MIN
          MAX = X_BYTE_MAX
      ELSE IF (DATATYPE .EQ. NF_SHORT) THEN
          MIN = X_SHORT_MIN
          MAX = X_SHORT_MAX
      ELSE IF (DATATYPE .EQ. NF_INT) THEN
          MIN = X_INT_MIN
          MAX = X_INT_MAX
      ELSE IF (DATATYPE .EQ. NF_FLOAT) THEN
          IF (internal_max(NFT_REAL) .LT. X_FLOAT_MAX) THEN
              MIN = -internal_max(NFT_REAL)
              MAX = internal_max(NFT_REAL)
          ELSE
              MIN = X_FLOAT_MIN
              MAX = X_FLOAT_MAX
          END IF
      ELSE IF (DATATYPE .EQ. NF_DOUBLE) THEN
          IF (internal_max(NFT_REAL) .LT. X_DOUBLE_MAX) THEN
              MIN = -internal_max(NFT_REAL)
              MAX = internal_max(NFT_REAL)
          ELSE
              MIN = X_DOUBLE_MIN
              MAX = X_DOUBLE_MAX
          END IF
      ELSE
          CALL UDABORT
      END IF

      IF (.NOT.((VALUE .GE. MIN) .AND. (VALUE .LE. MAX))) THEN
          INRANGE_FLOAT = .FALSE.
      ELSE
          FVALUE = VALUE
          INRANGE_FLOAT = (FVALUE .GE. MIN) .AND. (FVALUE .LE. MAX)
      END IF
      END


! wrapper for inrange to handle special NF_BYTE/uchar adjustment */
      function inrange3(value, datatype, itype)
      use tests, ONLY: NFT_REAL, inrange, inrange_float
      implicit          none
      doubleprecision   value
      integer           datatype
      integer           itype
      logical inrange3

      if (itype .eq. NFT_REAL) then
          inrange3 = inrange_float(value, datatype)
      else
          inrange3 = inrange(value, datatype)
      end if
      end


!
!  Does x == y, where one is internal and other external (netCDF)?  
!  Use tolerant comparison based on IEEE FLT_EPSILON or DBL_EPSILON.
!
      function equal(x, y, extType, itype)
      use tests, ONLY: NF_REAL, NFT_REAL
      implicit  none
      doubleprecision   x
      doubleprecision   y
      integer           extType         !!/* external data type */
      integer           itype
      logical equal
      doubleprecision   epsilon

      if ((extType .eq. NF_REAL) .or. (itype .eq. NFT_REAL)) then
          epsilon = 1.19209290E-07
      else
          epsilon = 2.2204460492503131E-16
      end if
      equal = abs(x-y) .le. epsilon * max( abs(x), abs(y))
      end


! Test whether two int vectors are equal. If so return 1, else 0  */
        function int_vec_eq(v1, v2, n)
!        use tests
        implicit        none
        integer n
        integer v1(n)
        integer v2(n)

        integer i
        logical int_vec_eq

        int_vec_eq = .true.

        if (n .le. 0)
     +      return

        do 1, i=1, n
            if (v1(i) .ne. v2(i)) then
                int_vec_eq = .false.
                return
            end if
1       continue
        end


!
!  Generate random integer from 0 through n-1
!  Like throwing an n-sided dice marked 0, 1, 2, ..., n-1
!
      function roll(n)
!      use tests
      implicit  none
      integer   n
      integer roll
      doubleprecision   udrand
      external          udrand
      
1     roll = (udrand(0) * (n-1)) + 0.5
      if (roll .ge. n) goto 1
      end


!
!      Convert an origin-1 cumulative index to a netCDF index vector.
!       Grosset dimension first; finest dimension last.
!
!      Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!                Steve Emmerson, (same place)
!
        function index2ncindexes(index, rank, base, indexes)
!        use tests
        implicit        none
        integer         index           !!/* index to be converted */
        integer         rank            !/* number of dimensions */
        integer         base(rank)      !/* base(rank) ignored */
        integer         indexes(rank)   !/* returned FORTRAN indexes */

        integer i
        integer offset
        integer index2ncindexes

        if (rank .gt. 0) then
            offset = index - 1
            do 1, i = rank, 1, -1
                if (base(i) .eq. 0) then
                    index2ncindexes = 1
                    return
                end if
                indexes(i) = 1 + mod(offset, base(i))
                offset = offset / base(i)
1           continue
        end if
        index2ncindexes = 0
        end


!
!      Convert an origin-1 cumulative index to a FORTRAN index vector.
!       Finest dimension first; grossest dimension last.
!
!      Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!                Steve Emmerson, (same place)
!
        function index2indexes(index, rank, base, indexes)
!        use tests
        implicit        none
        integer         index           !/* index to be converted */
        integer         rank            !/* number of dimensions */
        integer         base(rank)      !/* base(rank) ignored */
        integer         indexes(rank)   !/* returned FORTRAN indexes */
        integer         index2indexes
        integer i
        integer offset

        if (rank .gt. 0) then
            offset = index - 1
            do 1, i = 1, rank
                if (base(i) .eq. 0) then
                    index2indexes = 1
                    return
                end if
                indexes(i) = 1 + mod(offset, base(i))
                offset = offset / base(i)
1           continue
        end if
        index2indexes = 0
        end


!
!      Convert a FORTRAN index vector to an origin-1 cumulative index.
!       Finest dimension first; grossest dimension last.
!
!      Authors: Harvey Davies, Unidata/UCAR, Boulder, Colorado
!                Steve Emmerson, (same place)
!
        function indexes2index(rank, indexes, base)
!        use tests
        implicit        none
        integer         rank            !/* number of dimensions */
        integer         indexes(rank)   !/* FORTRAN indexes */
        integer         base(rank)      !/* base(rank) ignored */
        integer  indexes2index
        integer i

        indexes2index = 0
        if (rank .gt. 0) then
            do 1, i = rank, 1, -1
                indexes2index = (indexes2index-1) * base(i) + indexes(i)
1           continue
        end if
        end


#ifdef USE_EXTREME_NUMBERS
! Generate data values as function of type, rank (-1 for attribute), index */
      function hash(type, rank, index) 
      use tests, ONLY: NF_CHAR, NF_BYTE, NF_SHORT, NF_INT, NF_FLOAT,    &
     &                 NF_DOUBLE, X_CHAR_MIN, X_CHAR_MAX, X_BYTE_MIN,   &
     &                 X_BYTE_MAX, X_SHORT_MIN, X_SHORT_MAX, X_INT_MIN, &
     &                 X_INT_MAX, X_FLOAT_MIN, X_FLOAT_MAX,             &
     &                 X_DOUBLE_MIN, X_DOUBLE_MAX, RK8
      implicit  none
      integer   type
      integer   rank
      integer   index(*)
      real(RK8) hash

      doubleprecision   base
      doubleprecision   result
      integer           d       !/* index of dimension */

        !/* If vector then elements 1 & 2 are min & max. Elements 3 & 4 are */
        !/* just < min & > max (except for NF_CHAR & NF_DOUBLE) */
      if (abs(rank) .eq. 1 .and. index(1) .le. 4) then
          if (index(1) .eq. 1) then
              if (type .eq. NF_CHAR) then
                  hash = X_CHAR_MIN
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MIN
              else if (type .eq. NF_SHORT) then
                  hash = X_SHORT_MIN
              else if (type .eq. NF_INT) then
                  hash = X_INT_MIN
              else if (type .eq. NF_FLOAT) then
                  hash = X_FLOAT_MIN
              else if (type .eq. NF_DOUBLE) then
                  hash = X_DOUBLE_MIN
              else
                  call udabort
              end if
          else if (index(1) .eq. 2) then
              if (type .eq. NF_CHAR) then
                  hash = X_CHAR_MAX
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MAX
              else if (type .eq. NF_SHORT) then
                  hash = X_SHORT_MAX
              else if (type .eq. NF_INT) then
                  hash = X_INT_MAX
              else if (type .eq. NF_FLOAT) then
                  hash = X_FLOAT_MAX
              else if (type .eq. NF_DOUBLE) then
                  hash = X_DOUBLE_MAX
              else
                  call udabort
              end if
          else if (index(1) .eq. 3) then
              if (type .eq. NF_CHAR) then
                  hash = ichar('A')
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MIN-1.0
              else if (type .eq. NF_SHORT) then
                  hash = X_SHORT_MIN-1.0
              else if (type .eq. NF_INT) then
                  hash = X_INT_MIN
              else if (type .eq. NF_FLOAT) then
                  hash = X_FLOAT_MIN
              else if (type .eq. NF_DOUBLE) then
                  hash = -1.0
              else
                  call udabort
              end if
          else if (index(1) .eq. 4) then
              if (type .eq. NF_CHAR) then
                  hash = ichar('Z')
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MAX+1.0
              else if (type .eq. NF_SHORT) then
                  hash = X_SHORT_MAX+1.0
              else if (type .eq. NF_INT) then
                  hash = X_INT_MAX+1.0
              else if (type .eq. NF_FLOAT) then
                  hash = X_FLOAT_MAX
              else if (type .eq. NF_DOUBLE) then
                  hash = 1.0
              else
                  call udabort
              end if
          end if
      else
          if (type .eq. NF_CHAR) then
              base = 2
          else if (type .eq. NF_BYTE) then
              base = -2
          else if (type .eq. NF_SHORT) then
              base = -5
          else if (type .eq. NF_INT) then
              base = -20
          else if (type .eq. NF_FLOAT) then
              base = -9
          else if (type .eq. NF_DOUBLE) then
              base = -10
          else
              stop 2
          end if

          if (rank .lt. 0) then
              result = base * 7
          else
              result = base * (rank + 1)
          end if

!         /*
!          * NB: Finest netCDF dimension assumed first.
!          */
          do 1, d = abs(rank), 1, -1
              result = base * (result + index(d) - 1)
1         continue
          hash = result
      end if
      end
#else /* USE_EXTREME_NUMBERS */
#define SANE_SHORT 3333
#define SANE_INT 2222
#define SANE_FLOAT 300.0
#define SANE_DOUBLE 1000.0

! Generate data values as function of type, rank (-1 for attribute), index */
      function hash(type, rank, index) 
      use tests, ONLY: NF_CHAR, NF_BYTE, NF_SHORT, NF_INT, NF_FLOAT,    &
     &                 NF_DOUBLE, X_CHAR_MIN, X_CHAR_MAX, X_BYTE_MIN,   &
     &                 X_BYTE_MAX, X_SHORT_MIN, X_SHORT_MAX, X_INT_MIN, &
     &                 X_INT_MAX, X_FLOAT_MIN, X_FLOAT_MAX,             &
     &                 X_DOUBLE_MIN, X_DOUBLE_MAX, RK8
      implicit  none
      integer   type
      integer   rank
      integer   index(*)

      real(RK8) hash
      doubleprecision   base
      doubleprecision   result
      integer           d       !/* index of dimension */

        !/* If vector then elements 1 & 2 are min & max. Elements 3 & 4 are */
        !/* just < min & > max (except for NF_CHAR & NF_DOUBLE) */
      if (abs(rank) .eq. 1 .and. index(1) .le. 4) then
          if (index(1) .eq. 1) then
              if (type .eq. NF_CHAR) then
                  hash = X_CHAR_MIN
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MIN
              else if (type .eq. NF_SHORT) then
                  hash = SANE_SHORT
              else if (type .eq. NF_INT) then
                  hash = SANE_INT
              else if (type .eq. NF_FLOAT) then
                  hash = SANE_FLOAT
              else if (type .eq. NF_DOUBLE) then
                  hash = SANE_DOUBLE
              else
                  call udabort
              end if
          else if (index(1) .eq. 2) then
              if (type .eq. NF_CHAR) then
                  hash = X_CHAR_MAX
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MAX
              else if (type .eq. NF_SHORT) then
                  hash = SANE_SHORT
              else if (type .eq. NF_INT) then
                  hash = SANE_INT
              else if (type .eq. NF_FLOAT) then
                  hash = SANE_FLOAT
              else if (type .eq. NF_DOUBLE) then
                  hash = SANE_DOUBLE
              else
                  call udabort
              end if
          else if (index(1) .eq. 3) then
              if (type .eq. NF_CHAR) then
                  hash = ichar('A')
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MIN-1.0
              else if (type .eq. NF_SHORT) then
                  hash = SANE_SHORT-1.0
              else if (type .eq. NF_INT) then
                  hash = SANE_INT
              else if (type .eq. NF_FLOAT) then
                  hash = SANE_FLOAT
              else if (type .eq. NF_DOUBLE) then
                  hash = -1.0
              else
                  call udabort
              end if
          else if (index(1) .eq. 4) then
              if (type .eq. NF_CHAR) then
                  hash = ichar('Z')
              else if (type .eq. NF_BYTE) then
                  hash = X_BYTE_MAX+1.0
              else if (type .eq. NF_SHORT) then
                  hash = SANE_SHORT+1.0
              else if (type .eq. NF_INT) then
                  hash = SANE_INT+1.0
              else if (type .eq. NF_FLOAT) then
                  hash = SANE_FLOAT
              else if (type .eq. NF_DOUBLE) then
                  hash = 1.0
              else
                  call udabort
              end if
          end if
      else
          if (type .eq. NF_CHAR) then
              base = 2
          else if (type .eq. NF_BYTE) then
              base = -2
          else if (type .eq. NF_SHORT) then
              base = -5
          else if (type .eq. NF_INT) then
              base = -20
          else if (type .eq. NF_FLOAT) then
              base = -9
          else if (type .eq. NF_DOUBLE) then
              base = -10
          else
              stop 2
          end if

          if (rank .lt. 0) then
              result = base * 7
          else
              result = base * (rank + 1)
          end if

!         /*
!          * NB: Finest netCDF dimension assumed first.
!          */
          do 1, d = abs(rank), 1, -1
              result = base * (result + index(d) - 1)
1         continue
          hash = result
      end if
      end
#endif

! wrapper for hash to handle special NC_BYTE/uchar adjustment */
      function hash4(type, rank, index, itype)
      use tests, ONLY: NFT_CHAR, NF_BYTE, RK8, hash
      implicit  none
      integer   type
      integer   rank
      integer   index(*)
      integer   itype
      real(RK8) hash4

      hash4 = hash( type, rank, index )
      if ((itype .eq. NFT_CHAR) .and. (type .eq. NF_BYTE) .and. 
     +    (hash4 .ge. -128) .and. (hash4 .lt. 0)) hash4 = hash4 + 256
      end


      integer function char2type(letter)
      use tests, ONLY: NF_CHAR, NF_SHORT, NF_BYTE, NF_INT, NF_FLOAT,    &
     &                 NF_DOUBLE
      implicit          none
      character*1       letter

      if (letter .eq. 'c') then
          char2type = NF_CHAR
      else if (letter .eq. 'b') then
          char2type = NF_BYTE
      else if (letter .eq. 's') then
          char2type = NF_SHORT
      else if (letter .eq. 'i') then
          char2type = NF_INT
      else if (letter .eq. 'f') then
          char2type = NF_FLOAT
      else if (letter .eq. 'd') then
          char2type = NF_DOUBLE
      else
        stop 2
      end if
      end


      subroutine init_dims(digit)
      use tests, ONLY: NDIMS, RECDIM, NRECS, DIM_LEN, DIM_NAME
      implicit          none
      character*1       digit(NDIMS)

      integer   dimid                   !/* index of dimension */
      do 1, dimid = 1, NDIMS
          if (dimid .eq. RECDIM) then
              dim_len(dimid) = NRECS
          else
              dim_len(dimid) = dimid - 1
          endif
          dim_name(dimid) = 'D' // digit(dimid)
1     continue
      end


      subroutine init_gatts(type_letter)
      use tests, ONLY: NTYPES, gatt_name, gatt_len, gatt_type
      implicit          none
      character*1       type_letter(NTYPES)

      integer   attid
      integer   char2type

      do 1, attid = 1, NTYPES
          gatt_name(attid) = 'G' // type_letter(attid)
          gatt_len(attid) = attid
          gatt_type(attid) = char2type(type_letter(attid))
1     continue
      end


      integer function prod(nn, sp)
      use tests, ONLY: MAX_RANK
      implicit  none
      integer   nn
      integer   sp(MAX_RANK)

      integer   i

      prod = 1
      do 1, i = 1, nn
          prod = prod * sp(i)
1     continue
      end


!
!   define global variables:
!   dim_name, dim_len, 
!   var_name, var_type, var_rank, var_shape, var_natts, var_dimid, var_nels
!   att_name, gatt_name, att_type, gatt_type, att_len, gatt_len
!
        subroutine init_gvars 
        use tests, NTYPESP=>NTYPES, MAX_DIM_LENP=>MAX_DIM_LEN,          &
     &             NVARSP=>NVARS
        implicit        none

        integer         max_dim_len(MAX_RANK)
        character*1     type_letter(NTYPESP)
        character*1     digit(10)

        integer rank
        integer vn              !/* var number */
        integer xtype           !/* index of type */
        integer an              !/* origin-0 cumulative attribute index */
        integer nvars
        integer jj
        integer ntypes
        integer tc
        integer tmp(MAX_RANK)
        integer ac              !/* attribute index */
        integer dn              !/* dimension number */
        integer prod            !/* function */
        integer char2type       !/* function */
        integer err

        data    max_dim_len     /0, MAX_DIM_LENP, MAX_DIM_LENP/
        data    type_letter     /'c', 'b', 's', 'i', 'f', 'd'/
        data    digit           /'r', '1', '2', '3', '4', '5',
     +                           '6', '7', '8', '9'/

        max_dim_len(1) = MAX_DIM_LENP + 1

        call init_dims(digit)

        vn = 1
        xtype = 1
        an = 0

!       /* Loop over variable ranks */
        do 1, rank = 0, MAX_RANK
            nvars = prod(rank, max_dim_len)

            !/* Loop over variable shape vectors */
            do 2, jj = 1, nvars                         !/* 1, 5, 20, 80 */
                !/* number types of this shape */
                if (rank .lt. 2) then
                    ntypes = NTYPESP                     !/* 6 */
                else
                    ntypes = 1
                end if

                !/* Loop over external data types */
                do 3, tc = 1, ntypes                    !/* 6, 1 */
                    var_name(vn) = type_letter(xtype)
                    var_type(vn) = char2type(type_letter(xtype))
                    var_rank(vn) = rank
                    if (rank .eq. 0) then
                        var_natts(vn) = mod(vn - 1, MAX_NATTS + 1)
                    else
                        var_natts(vn) = 0
                    end if

                    do 4, ac = 1, var_natts(vn)
                        attname(ac,vn) = 
     +                      type_letter(1+mod(an, NTYPESP))
                        attlen(ac,vn) = an
                        atttype(ac,vn) =
     +                      char2type(type_letter(1+mod(an, NTYPESP)))
                        an = an + 1
4                   continue

                    !/* Construct initial shape vector */
                    err = index2ncindexes(jj, rank, max_dim_len, tmp)
                    do 5, dn = 1, rank
                        var_dimid(dn,vn) = tmp(1+rank-dn)
5                   continue

                    var_nels(vn) = 1
                    do 6, dn = 1, rank
                        if (dn .lt. rank) then
                            var_dimid(dn,vn) = var_dimid(dn,vn) + 1
                        end if
                        if (var_dimid(dn,vn) .gt. 9) then
                            stop 2
                        end if
                        var_name(vn)(rank+2-dn:rank+2-dn) = 
     +                      digit(var_dimid(dn,vn))
                        if (var_dimid(dn,vn) .ne. RECDIM) then
                            var_shape(dn,vn) = var_dimid(dn,vn) - 1
                        else
                            var_shape(dn,vn) = NRECS
                        end if
                        var_nels(vn) = var_nels(vn) * var_shape(dn,vn)
6                   continue

                    vn = vn + 1
                    xtype = 1 + mod(xtype, NTYPESP)
3               continue
2           continue
1       continue

        call init_gatts(type_letter)
        end


! define dims defined by global variables */
        subroutine def_dims(ncid)
        use tests
        implicit        none
        integer         ncid

        integer         err             !/* status */
        integer         i
        integer         dimid           !/* dimension id */

        do 1, i = 1, NDIMS
            if (i .eq. RECDIM) then
                err = nf_def_dim(ncid, dim_name(i), NF_UNLIMITED,
     +                           dimid)
            else
                err = nf_def_dim(ncid, dim_name(i), dim_len(i),
     +                           dimid)
            end if
            if (err .ne. 0) then
                call errore('nf_def_dim: ', err)
            end if
1       continue
        end


! define vars defined by global variables */
        subroutine def_vars(ncid)
        use tests
        implicit        none
        integer         ncid

        integer         err             !/* status */
        integer         i
        integer         var_id

        do 1, i = 1, NVARS
            err = nf_def_var(ncid, var_name(i), var_type(i), 
     +                       var_rank(i), var_dimid(1,i), var_id)
            if (err .ne. 0) then
                call errore('nf_def_var: ', err)
            end if
1       continue
        end


! put attributes defined by global variables */
        subroutine put_atts(ncid)
        use tests
        implicit        none
        integer         ncid

        integer                 err             !/* netCDF status */
        integer                 i               !/* variable index (0 => global 
                                                ! * attribute */
        integer                 k               !/* attribute index */
        integer                 j               !/* index of attribute */
        integer                 ndx(1)
        logical                 allInRange

        doubleprecision         att(MAX_NELS)
        character*(MAX_NELS+2)  catt

        do 1, i = 0, NVARS      !/* var 0 => NF_GLOBAL attributes */
            do 2, j = 1, NATTS(i)
                if (NF_CHAR .eq. ATT_TYPE(j,i)) then
                    catt = ' '
                    do 3, k = 1, ATT_LEN(j,i)
                        ndx(1) = k
                        catt(k:k) = char(int(hash(ATT_TYPE(j,i), -1, 
     +                                   ndx)))
3                   continue
!                   /*
!                    * The following ensures that the text buffer doesn't
!                    * start with 4 zeros (which is a CFORTRAN NULL pointer
!                    * indicator) yet contains a zero (which causes the
!                    * CFORTRAN interface to pass the address of the
!                    * actual text buffer).
!                    */
                    catt(ATT_LEN(j,i)+1:ATT_LEN(j,i)+1) = char(1)
                    catt(ATT_LEN(j,i)+2:ATT_LEN(j,i)+2) = char(0)

                    err = nf_put_att_text(ncid, varid(i), 
     +                                    ATT_NAME(j,i),
     +                                    ATT_LEN(j,i), catt)
                    if (err .ne. 0) then
                        call errore('nf_put_att_text: ', err)
                    end if
                else
                    allInRange = .true.
                    do 4, k = 1, ATT_LEN(j,i)
                        ndx(1) = k
                        att(k) = hash(ATT_TYPE(j,i), -1, ndx)
                        allInRange = allInRange .and.
     +                               inRange(att(k), ATT_TYPE(j,i))
4                   continue
                    err = nf_put_att_double(ncid, varid(i),
     +                                      ATT_NAME(j,i),
     +                                      ATT_TYPE(j,i),
     +                                      ATT_LEN(j,i), att)
                    if (allInRange) then
                        if (err .ne. 0) then
                            call errore('nf_put_att_double: ', err)
                        end if
                    else
                        if (err .ne. NF_ERANGE) then
                            call errore(
     +                  'type-conversion range error: status = ',
     +                          err)
                        end if
                    end if
                end if
2           continue
1       continue
        end


! put variables defined by global variables */
        subroutine put_vars(ncid)
        use tests
        implicit        none
        integer                 ncid

        integer                 start(MAX_RANK)
        integer                 index(MAX_RANK)
        integer                 err             !/* netCDF status */
        integer                 i
        integer                 j
        doubleprecision         value(MAX_NELS)
        character*(MAX_NELS+2)  text
        logical                 allInRange

        do 1, j = 1, MAX_RANK
            start(j) = 1
1       continue

        do 2, i = 1, NVARS
            allInRange = .true.
            do 3, j = 1, var_nels(i)
                err = index2indexes(j, var_rank(i), var_shape(1,i), 
     +                              index)
                if (err .ne. 0) then
                    call errori(
     +                  'Error calling index2indexes() for var ', j)
                end if
                if (var_name(i)(1:1) .eq. 'c') then
                    text(j:j) = 
     +                  char(int(hash(var_type(i), var_rank(i), index)))
                else
                    value(j)  = hash(var_type(i), var_rank(i), index)
                    allInRange = allInRange .and.
     +                  inRange(value(j), var_type(i))
                end if
3           continue
            if (var_name(i)(1:1) .eq. 'c') then
!               /*
!                * The following statement ensures that the first 4
!                * characters in 'text' are not all zeros (which is
!                * a cfortran.h NULL indicator) and that the string
!                * contains a zero (which will cause the address of the
!                * actual string buffer to be passed).
!                */
                text(var_nels(i)+1:var_nels(i)+1) = char(1)
                text(var_nels(i)+2:var_nels(i)+2) = char(0)
                err = nf_put_vara_text(ncid, i, start, var_shape(1:,i), & 
     &                                 text)
                if (err .ne. 0) then
                    call errore('nf_put_vara_text: ', err)
                end if
            else
                err = nf_put_vara_double(ncid, i, start,var_shape(1:,i),&
     &                                   value)
                if (allInRange) then
                    if (err .ne. 0) then
                        call errore('nf_put_vara_double: ', err)
                    end if
                else
                    if (err .ne. NF_ERANGE) then                        &
                        call errore(                                    & 
     &                      'type-conversion range error: status = ',   & 
     &                      err)
                    end if
                end if
            end if
2       continue
        end


! Create & write all of specified file using global variables */
        subroutine write_file(filename) 
        use tests
        implicit        none
        character*(*)   filename

        integer ncid            !/* netCDF id */
        integer err             !/* netCDF status */

        err = nf_create(filename, NF_CLOBBER, ncid)
        if (err .ne. 0) then
            call errore('nf_create: ', err)
        end if

        call def_dims(ncid)
        call def_vars(ncid)
        call put_atts(ncid)
        err = nf_enddef(ncid)
        if (err .ne. 0) then
            call errore('nf_enddef: ', err)
        end if
        call put_vars(ncid)

        err = nf_close(ncid)
        if (err .ne. 0) then
            call errore('nf_close: ', err)
        end if
        end


!
! check dimensions of specified file have expected name & length
!
        subroutine check_dims(ncid)
        use tests
        implicit        none
        integer         ncid

        character*(NF_MAX_NAME) name
        integer                 length
        integer                 i
        integer                 err           !/* netCDF status */

        do 1, i = 1, NDIMS
            err = nf_inq_dim(ncid, i, name, length)
            if (err .ne. 0) then
                call errore('nf_inq_dim: ', err)
            end if
            if (name .ne. dim_name(i)) then
                call errori('Unexpected name of dimension ', i)
            end if
            if (length .ne. dim_len(i)) then
                call errori('Unexpected length of dimension ', i)
            end if
1       continue
        end


!
! check variables of specified file have expected name, type, shape & values
!
        subroutine check_vars(ncid)
        use tests, NDIMSP=>NDIMS
        implicit        none
        integer         ncid

        integer                 index(MAX_RANK)
        integer                 err             !/* netCDF status */
        integer                 i
        integer                 j
        character*1             text
        doubleprecision         value
        integer                 datatype
        integer                 ndims
        integer                 natt
        integer                 dimids(MAX_RANK)
        logical                 isChar
        doubleprecision         expect
        character*(NF_MAX_NAME) name
        integer                 length
        integer                 nok             !/* count of valid comparisons */

        nok = 0

        do 1, i = 1, NVARS
            isChar = var_type(i) .eq. NF_CHAR
            err = nf_inq_var(ncid, i, name, datatype, ndims, dimids, 
     +          natt)
            if (err .ne. 0) then
                call errore('nf_inq_var: ', err)
            end if
            if (name .ne. var_name(i)) then
                call errori('Unexpected var_name for variable ', i)
            end if
            if (datatype .ne. var_type(i))  then
                call errori('Unexpected type for variable ', i)
            end if
            if (ndims .ne. var_rank(i))  then
                call errori('Unexpected rank for variable ', i)
            end if
            do 2, j = 1, ndims
                err = nf_inq_dim(ncid, dimids(j), name, length)
                if (err .ne. 0) then
                    call errore('nf_inq_dim: ', err)
                end if
                if (length .ne. var_shape(j,i))  then
                    call errori('Unexpected shape for variable ', i)
                end if
2           continue
            do 3, j = 1, var_nels(i)
                err = index2indexes(j, var_rank(i), var_shape(1,i), 
     +                  index)
                if (err .ne. 0)  then
                    call errori('error in index2indexes() 2, variable ',
     +                          i)
                end if
                expect = hash(var_type(i), var_rank(i), index )
                if (isChar) then
                    err = nf_get_var1_text(ncid, i, index, text)
                    if (err .ne. 0) then
                        call errore('nf_get_var1_text: ', err)
                    end if
                    if (ichar(text) .ne. expect) then
                        call errori(
     +              'Var value read not that expected for variable ', i)
                    else
                        nok = nok + 1
                    end if
                else
                    err = nf_get_var1_double(ncid, i, index, value)
                    if (inRange(expect,var_type(i))) then
                        if (err .ne. 0) then
                            call errore('nf_get_var1_double: ', err)
                        else
                            if (.not. equal(value,expect,var_type(i),
     +                          NFT_DOUBLE)) then
                                call errori(
     +              'Var value read not that expected for variable ', i)
                            else
                                nok = nok + 1
                            end if
                        end if
                    end if
                end if
3           continue
1       continue
        call print_nok(nok)
        end


!
! check attributes of specified file have expected name, type, length & values
!
        subroutine check_atts(ncid) 
        use tests
        implicit        none
        integer         ncid

        integer                 err             !/* netCDF status */
        integer                 i
        integer                 j
        integer                 k
        integer                 vid             !/* "variable" ID */
        integer                 datatype
        integer                 ndx(1)
        character*(NF_MAX_NAME) name
        integer                 length
        character*(MAX_NELS)    text
        doubleprecision         value(MAX_NELS)
        doubleprecision         expect
        integer                 nok             !/* count of valid comparisons */

        nok = 0

        do 1, vid = 0, NVARS
            i = varid(vid)

            do 2, j = 1, NATTS(i)
                err = nf_inq_attname(ncid, i, j, name)
                if (err .ne. 0) then
                    call errore('nf_inq_attname: ', err)
                end if
                if (name .ne. ATT_NAME(j,i)) then
                    call errori(
     +                  'nf_inq_attname: unexpected name for var ', i)
                end if
                err = nf_inq_att(ncid, i, name, datatype, length)
                if (err .ne. 0) then
                    call errore('nf_inq_att: ', err)
                end if
                if (datatype .ne. ATT_TYPE(j,i)) then
                    call errori('nf_inq_att: unexpected type for var ',
     +                         i)
                end if
                if (length .ne. ATT_LEN(j,i)) then
                    call errori(
     +                  'nf_inq_att: unexpected length for var ', i)
                end if
                if (datatype .eq. NF_CHAR) then
                    err = nf_get_att_text(ncid, i, name, text)
                    if (err .ne. 0) then
                        call errore('nf_get_att_text: ', err)
                    end if
                    do 3, k = 1, ATT_LEN(j,i)
                        ndx(1) = k
                        if (ichar(text(k:k)) .ne. hash(datatype, -1, 
     +                                                 ndx))
     +                  then
                            call errori(
     +          'nf_get_att_text: unexpected value for var ', i)
                        else
                            nok = nok + 1
                        end if
3                   continue
                else
                    err = nf_get_att_double(ncid, i, name, value)
                    do 4, k = 1, ATT_LEN(j,i)
                        ndx(1) = k
                        expect = hash(datatype, -1, ndx)
                        if (inRange(expect,ATT_TYPE(j,i))) then
                            if (err .ne. 0) then
                                call errore('nf_get_att_double: ', err)
                            end if
                            if (.not. equal(value(k), expect,
     +                          ATT_TYPE(j,i), NFT_DOUBLE)) then
                                call errori(
     +                  'Att value read not that expected for var ', i)
                            else
                                nok = nok + 1
                            end if
                        end if
4                   continue
                end if
2           continue
1       continue
        call print_nok(nok)
        end


! Check file (dims, vars, atts) corresponds to global variables */
        subroutine check_file(filename) 
        use tests
        implicit        none
        character*(*)   filename

        integer ncid            !/* netCDF id */
        integer err             !/* netCDF status */

        err = nf_open(filename, NF_NOWRITE, ncid)
        if (err .ne. 0) then
            call errore('nf_open: ', err)
        else
            call check_dims(ncid)
            call check_vars(ncid)
            call check_atts(ncid)
            err = nf_close (ncid)
            if (err .ne. 0) then
                call errore('nf_close: ', err)
            end if
        end if
        end


!
! Functions for accessing attribute test data.
!
! NB: 'varid' is 0 for global attributes; thus, global attributes can
! be handled in the same loop as variable attributes.
!

      FUNCTION VARID(VID)
      use tests, ONLY: NF_GLOBAL 
      IMPLICIT NONE
      INTEGER VID
      INTEGER VARID
      IF (VID .LT. 1) THEN
          VARID = NF_GLOBAL
      ELSE
          VARID = VID
      ENDIF
      end


      FUNCTION NATTS(VID)
      use tests, ONLY: NGATTS, VAR_NATTS
      IMPLICIT  NONE
      INTEGER VID
      Integer NATTS

      IF (VID .LT. 1) THEN
          NATTS = NGATTS
      ELSE
          NATTS = VAR_NATTS(VID)
      ENDIF
      END


      FUNCTION ATT_NAME(J,VID)
      use tests, ONLY: GATT_NAME, ATTNAME
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
      CHARACTER*2 ATT_NAME
      IF (VID .LT. 1) THEN
          ATT_NAME = GATT_NAME(J)
      ELSE
          ATT_NAME = ATTNAME(J,VID)
      ENDIF
      END


      FUNCTION ATT_TYPE(J,VID)
      use tests, ONLY :GATT_TYPE, ATTTYPE
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
      INTEGER ATT_TYPE
      IF (VID .LT. 1) THEN
          ATT_TYPE = GATT_TYPE(J)
      ELSE
          ATT_TYPE = ATTTYPE(J,VID)
      ENDIF
      END


      FUNCTION ATT_LEN(J,VID)
      use tests, ONLY: GATT_LEN, ATTLEN
      IMPLICIT  NONE
      INTEGER J
      INTEGER VID
      INTEGER ATT_LEN
      IF (VID .LT. 1) THEN
          ATT_LEN = GATT_LEN(J)
      ELSE
          ATT_LEN = ATTLEN(J,VID)
      ENDIF
      END


!
! Return the minimum value of an internal type.
!
        function internal_min(type)
        use tests, ONLY: RK8, NFT_CHAR, NFT_INT1, NFT_INT2, NFT_INT,    &
     &                   NFT_REAL, NFT_DOUBLE
        implicit        none
        integer         type
        real(RK8) internal_min
        doubleprecision min_schar
        doubleprecision min_short
        doubleprecision min_int
        doubleprecision min_long
        doubleprecision max_float
        doubleprecision max_double
        if (type .eq. NFT_CHAR) then
            internal_min = 0
        else if (type .eq. NFT_INT1) then
#if NF_INT1_IS_C_SIGNED_CHAR
            internal_min = min_schar()
#endif
#if NF_INT1_IS_C_SHORT
            internal_min = min_short()
#endif
#if NF_INT1_IS_C_INT
            internal_min = min_int()
#endif
#if NF_INT1_IS_C_LONG
            internal_min = min_long()
#endif
        else if (type .eq. NFT_INT2) then
#if NF_INT2_IS_C_SHORT
            internal_min = min_short()
#endif            
#if NF_INT2_IS_C_INT
            internal_min = min_int()
#endif            
#if NF_INT2_IS_C_LONG
            internal_min = min_long()
#endif
        else if (type .eq. NFT_INT) then
#if NF_INT_IS_C_INT
            internal_min = min_int()
#endif            
#if NF_INT_IS_C_LONG
            internal_min = min_long()
#endif
        else if (type .eq. NFT_REAL) then
#if NF_REAL_IS_C_FLOAT
            internal_min = -max_float()
#endif
#if NF_REAL_IS_C_DOUBLE
            internal_min = -max_double()
#endif
        else if (type .eq. NFT_DOUBLE) then
#if NF_DOUBLEPRECISION_IS_C_DOUBLE
            internal_min = -max_double()
#endif
#if NF_DOUBLEPRECISION_IS_C_FLOAT
            internal_min = -max_float()
#endif
        else
            stop 2
        end if
        end


!
! Return the maximum value of an internal type.
!
        function internal_max(type)
        use tests, ONLY: RK8, NFT_CHAR, NFT_INT1, NFT_INT2, NFT_INT,    &
     &                   NFT_REAL, NFT_DOUBLE
        implicit        none
        integer         type
        doubleprecision max_schar
        doubleprecision max_short
        doubleprecision max_int
        doubleprecision max_long
        doubleprecision max_float
        doubleprecision max_double
        real(RK8) internal_max
        if (type .eq. NFT_CHAR) then
            internal_max = 255
        else if (type .eq. NFT_INT1) then
#if NF_INT1_IS_C_SIGNED_CHAR
            internal_max = max_schar()
#endif
#if NF_INT1_IS_C_SHORT
            internal_max = max_short()
#endif
#if NF_INT1_IS_C_INT
            internal_max = max_int()
#endif
#if NF_INT1_IS_C_LONG
            internal_max = max_long()
#endif
        else if (type .eq. NFT_INT2) then
#if NF_INT2_IS_C_SHORT
            internal_max = max_short()
#endif
#if NF_INT2_IS_C_INT
            internal_max = max_int()
#endif
#if NF_INT2_IS_C_LONG
            internal_max = max_long()
#endif
        else if (type .eq. NFT_INT) then
#if NF_INT_IS_C_INT
            internal_max = max_int()
#endif
#if NF_INT_IS_C_LONG
            internal_max = max_long()
#endif
        else if (type .eq. NFT_REAL) then
#if NF_REAL_IS_C_FLOAT
            internal_max = max_float()
#endif
#if NF_REAL_IS_C_DOUBLE
            internal_max = max_double()
#endif
        else if (type .eq. NFT_DOUBLE) then
#if NF_DOUBLEPRECISION_IS_C_DOUBLE
            internal_max = max_double()
#endif            
#if NF_DOUBLEPRECISION_IS_C_FLOAT
            internal_max = max_float()
#endif
        else
            stop 2
        end if
        end


!
! Return the minimum value of an external type.
!
        function external_min(type)
        use tests, ONLY: RK8, NF_CHAR, NF_SHORT, NF_INT, NF_FLOAT,      &
     &                   NF_DOUBLE, X_BYTE_MIN, X_CHAR_MIN, X_SHORT_MIN,&
     &                   X_INT_MIN, X_FLOAT_MIN, X_DOUBLE_MIN , NF_BYTE
        implicit        none
        integer         type
        real(rk8) external_min

        if (type .eq. NF_BYTE) then
            external_min = X_BYTE_MIN
        else if (type .eq. NF_CHAR) then
            external_min = X_CHAR_MIN
        else if (type .eq. NF_SHORT) then
            external_min = X_SHORT_MIN
        else if (type .eq. NF_INT) then
            external_min = X_INT_MIN
        else if (type .eq. NF_FLOAT) then
            external_min = X_FLOAT_MIN
        else if (type .eq. NF_DOUBLE) then
            external_min = X_DOUBLE_MIN
        else
            stop 2
        end if
        end


!
! Return the maximum value of an internal type.
!
        function external_max(type)
        use tests, ONLY: RK8, NF_CHAR, NF_SHORT, NF_INT, NF_FLOAT,      &
     &                   NF_DOUBLE, X_BYTE_MAX, X_CHAR_MAX, X_SHORT_MAX,&
     &                   X_INT_MAX, X_FLOAT_MAX, X_DOUBLE_MAX, NF_BYTE
        implicit        none
        integer         type
        real(RK8) external_max
        if (type .eq. NF_BYTE) then
            external_max = X_BYTE_MAX
        else if (type .eq. NF_CHAR) then
            external_max = X_CHAR_MAX
        else if (type .eq. NF_SHORT) then
            external_max = X_SHORT_MAX
        else if (type .eq. NF_INT) then
            external_max = X_INT_MAX
        else if (type .eq. NF_FLOAT) then
            external_max = X_FLOAT_MAX
        else if (type .eq. NF_DOUBLE) then
            external_max = X_DOUBLE_MAX
        else
            stop 2
        end if
        end


!
! Indicate whether or not a value lies in the range of an internal type.
!
        function in_internal_range(itype, value)
        use tests, ONLY: RK8
        implicit        none
        integer         itype
        doubleprecision value
        logical in_internal_range
        real(rk8), external :: internal_min, internal_max

        in_internal_range = value .ge. internal_min(itype) .and.
     +                      value .le. internal_max(itype)
        end


!
! Return the length of a character variable minus any trailing blanks.
!  not needed for Fortran 90/95/2003 which have an intrinsic LEN_TRIM
!
!        function len_trim(string)
!        use tests
!        implicit        none
!        character*(*)   string

!        do 1, len_trim = len(string), 1, -1
!            if (string(len_trim:len_trim) .ne. ' ')
!     +          goto 2
!1       continue

!2       return
!        end

C     This is part of the netCDF package. Copyright 2006-2019 University
C     Corporation for Atmospheric Research/Unidata. See COPYRIGHT file
C     for conditions of use.

C     This program tests netCDF-4 variable functions from fortran.

C     Russ Rew, 2009

      program ftst_rengrps
      implicit none
      include "netcdf.inc"
      
C This is the name of the data file we will create.
      character (len = *), parameter :: FILE_NAME = "ftst_rengrps.nc"

C We are writing 2D data, a 6 x 12 grid. 
      integer, parameter :: MAX_DIMS = 2
      integer, parameter :: NX = 6, NY = 12
      integer :: chunksizes(MAX_DIMS), chunksizes_in(MAX_DIMS)
      integer, parameter :: CACHE_NELEMS = 10000, CACHE_SIZE = 1000000
      integer, parameter :: DEFLATE_LEVEL = 4
C We need these ids and other gunk for netcdf.
      integer :: ncid, varid1, varid2, dimids(MAX_DIMS)
      integer :: x_dimid, y_dimid
      integer :: nvars, ngatts, ndims, unlimdimid, file_format
      character (len = *), parameter :: VAR1_NAME = "VarName1"
      character (len = *), parameter :: VAR2_NAME = "VarName2"
      character (len = *), parameter :: GRP1_NAME = "Old_Grp1_name"
      character (len = *), parameter :: GRP2_NAME = "Old_Grp2_name"
      character (len = *), parameter :: NEW_GRP1_NAME = "new_Grp1_name"
      character (len = *), parameter :: NEW_GRP2_NAME = "new_Grp2_name"

      character (len = NF_MAX_NAME) :: grp1_full_name
      integer :: ilen

C Information read back from the file to check correctness.
      integer :: varid1_in, varid2_in
      integer :: grpid1, grpid2
      integer :: xtype_in, ndims_in, natts_in, dimids_in(MAX_DIMS)
      character (len = nf_max_name) :: name_in

      print *, ''
      print *,'*** Testing netCDF-4 rename groups from Fortran 90.'

C     Create the netCDF file.
      call check(nf_create(FILE_NAME, NF_NETCDF4, ncid))

C     Define the dimensions.
      call check(nf_def_dim(ncid, "x", NX, x_dimid))
      call check(nf_def_dim(ncid, "y", NY, y_dimid))
      dimids =  (/ y_dimid, x_dimid /)

C     Define some nested groups.
      call check(nf_def_grp(ncid, GRP1_NAME, grpid1))
      call check(nf_def_grp(grpid1, GRP2_NAME, grpid2))

C     Define some variables.
      chunksizes = (/ NY, NX /)
      call check(nf_def_var(ncid, VAR1_NAME, NF_INT, MAX_DIMS, dimids,  &
     &  varid1))
      call check(nf_def_var(grpid1, VAR2_NAME, NF_INT, MAX_DIMS, dimids,&
     & varid2))

C     Close the file.
      call check(nf_close(ncid))

C     Reopen the file.
      call check(nf_open(FILE_NAME, NF_WRITE, ncid))
      
C     Get the group ids for the newly reopened file.
      call check(nf_inq_grp_ncid(ncid, GRP1_NAME, grpid1))
      call check(nf_inq_grp_ncid(grpid1, GRP2_NAME, grpid2))

C     Check for the groups with full group names.
      write(grp1_full_name, '(A,A)') '/', GRP1_NAME
      call check(nf_inq_grp_full_ncid(ncid, grp1_full_name, grpid1))
      call check(nf_inq_grpname(grpid1, name_in))
      if (name_in .ne. GRP1_NAME) stop 61
      call check(nf_inq_grpname_full(grpid1, ilen, name_in))
      if (name_in .ne. grp1_full_name) stop 62

      Call check(nf_rename_grp(grpid1, NEW_GRP1_NAME))
      name_in=REPEAT(" ",LEN(name_in))
      Call check(nf_inq_grpname(grpid1, name_in))
      If (name_in /= NEW_GRP1_NAME) Call check(-1)

C     Close the file.
      call check(nf_close(ncid))

      print *,'*** SUCCESS!'

      contains
C     This subroutine handles errors by printing an error message and
C     exiting with a non-zero status.
      subroutine check(errcode)
        implicit none
        include "netcdf.inc"
        integer, intent(in) :: errcode
        
        if(errcode /= NF_NOERR) then
           print *, 'Error: ', trim(nf_strerror(errcode))
           stop 2
        endif
      end subroutine check

      end program ftst_rengrps

!
! This program tests Fortran 90 for adding attribute _FillValue to a variable
! of type NF90_INT64.
!
      subroutine check(err, message)
          use netcdf
          implicit none
          integer err
          character(len=*) message

          ! It is a good idea to check returned value for possible error
          if (err .NE. NF90_NOERR) then
              write(6,*) trim(message), trim(nf90_strerror(err))
              STOP 10
          end if
      end subroutine check

      integer function tst_fmt(filename, cmode)
          use netcdf
          implicit none

          character(LEN=256) filename
          integer i, err
          integer :: ncid, cmode, dimid(1), varid
          integer :: start(1)
          integer :: count(1)
          integer, parameter :: len = 3
          integer, parameter :: k = selected_int_kind(18)
          integer(kind=k) :: fourG, buf(len)

          tst_fmt = 0

          fourG = 1073741824
          fourG = fourG * 4

          do i=1,len
             buf(i) = i
          end do

          ! create netcdf file
          err = nf90_create(filename, IOR(cmode, NF90_CLOBBER), ncid)
          call check(err, 'In nf90_create: ')
          tst_fmt = tst_fmt + err

          err = nf90_def_dim(ncid, "dim", len, dimid(1))
          call check(err, 'In nf90_def_dim: ')
          tst_fmt = tst_fmt + err

          ! Make variable
          err = nf90_def_var(ncid, "var", NF90_INT64, dimid, varid)
          call check(err, 'In nf90_def_var: ')
          tst_fmt = tst_fmt + err

          ! new scalar attribute
          err = nf90_put_att(ncid, varid, 'att', fourG)
          call check(err, 'In nf90_put_att: ')

          ! add scalar attribute "_FillValue"
          err = nf90_put_att(ncid, varid, '_FillValue', fourG)
          call check(err, 'In nf90_put_att: ')
          tst_fmt = tst_fmt + err

          err = nf90_enddef(ncid)
          call check(err, 'In nf90_enddef: ')
          tst_fmt = tst_fmt + err

          ! Write buf
          start(1) = 1
          count(1) = len
          err = nf90_put_var(ncid, varid, buf, start, count)
          call check(err, 'In nf90_put_var: ')
          tst_fmt = tst_fmt + err

          err = nf90_close(ncid)
          call check(err, 'In nf90_close: ')
          tst_fmt = tst_fmt + err

      end function tst_fmt

      program main
          use netcdf
          implicit none
          character(LEN=256) filename
          integer err, nerrs, tst_fmt

          filename = 'tst_fill_int64.nc'

          nerrs = 0

#if defined(USE_NETCDF4) || defined(ENABLE_CDF5)
#ifdef USE_NETCDF4
          err = tst_fmt(filename, NF90_NETCDF4)
          nerrs = nerrs + err
#endif

#ifdef ENABLE_CDF5
          err = tst_fmt(filename, NF90_64BIT_DATA)
          nerrs = nerrs + err
#endif

          if (nerrs .eq. 0) then
              print *, '*** TESTING tst_fill passed'
          else
              print *, '*** TESTING tst_fill failed'
          endif
#else
          print *, '*** TESTING tst_fill skipped'
#endif
      end program main

C     Copyright 1996-2019, UCAR/Unidata
C     See netcdf/COPYRIGHT file for copying and redistribution conditions.

C     Steve Emmerson, Ed Hartnett

C     Test nf_create
C     For mode in NF_NOCLOBBER, NF_CLOBBER do:
C     create netcdf file 'scratch.nc' with no data, close it
C     test that it can be opened, do nf_inq to check nvars = 0, etc.
C     Try again in NF_NOCLOBBER mode, check error return
C     On exit, delete this file
      subroutine test_nf_create()
      implicit none
#include "tests.inc"

      integer clobber           !/* 0 for NF_NOCLOBBER, 1 for NF_CLOBBER */
      integer err
      integer ncid
      integer ndims1             !/* number of dimensions */
      integer nvars1             !/* number of variables */
      integer ngatts1            !/* number of global attributes */
      integer recdim1            !/* id of unlimited dimension */
      integer flags

      flags = NF_NOCLOBBER
      do 1, clobber = 0, 1
         err = nf_create(scratch, flags, ncid)
         if (err .ne. 0) then
            call errore('nf_create: ', err)
         end if
         err = nf_close(ncid)
         if (err .ne. 0) then
            call errore('nf_close: ', err)
         end if
         err = nf_open(scratch, NF_NOWRITE, ncid)
         if (err .ne. 0) then
            call errore('nf_open: ', err)
         end if
         err = nf_inq(ncid, ndims1, nvars1, ngatts1, recdim1)
         if (err .ne. 0) then
            call errore('nf_inq: ', err)
         else if (ndims1 .ne. 0) then
            call errori(
     +           'nf_inq: wrong number of dimensions returned, ',
     +           ndims1)
         else if (nvars1 .ne. 0) then
            call errori(
     +           'nf_inq: wrong number of variables returned, ',
     +           nvars1)
         else if (ngatts1 .ne. 0) then
            call errori(
     +           'nf_inq: wrong number of global atts returned, ',
     +           ngatts1)
         else if (recdim1 .ge. 1) then
            call errori(
     +           'nf_inq: wrong record dimension ID returned, ',
     +           recdim1)
         end if
         err = nf_close(ncid)
         if (err .ne. 0) then
            call errore('nf_close: ', err)
         end if

         flags = NF_CLOBBER
 1    continue

      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. NF_EEXIST) then
         call errore('attempt to overwrite file: ', err)
      end if
      err = nf_delete(scratch)
      if (err .ne. 0) then
         call errori('delete of scratch file failed: ', err)
      end if
      end


C     Test nf_redef
C     (In fact also tests nf_enddef - called from test_nf_enddef)
C     BAD_ID
C     attempt redef (error) & enddef on read-only file
C     create file, define dims & vars.
C     attempt put var (error)
C     attempt redef (error) & enddef.
C     put vars
C     attempt def new dims (error)
C     redef
C     def new dims, vars.
C     put atts
C     enddef
C     put vars
C     close
C     check file: vars & atts
      subroutine test_nf_redef()
      implicit none
#include "tests.inc"
      integer         title_len
      parameter       (title_len = 9)

      integer                 ncid !/* netcdf id */
      integer                 dimid !/* dimension id */
      integer                 vid !/* variable id */
      integer                 err
      character*(title_len)   title
      doubleprecision         var
      character*(NF_MAX_NAME) name
      integer                 length

      title = 'Not funny'

C     /* BAD_ID tests */
      err = nf_redef(BAD_ID)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_enddef(BAD_ID)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

C     /* read-only tests */
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_redef(ncid)
      if (err .ne. NF_EPERM)
     +     call errore('nf_redef in NF_NOWRITE mode: ', err)
      err = nf_enddef(ncid)
      if (err .ne. NF_ENOTINDEFINE)
     +     call errore('nf_redef in NF_NOWRITE mode: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* tests using scratch file */
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)
      err = nf_inq_varid(ncid, 'd', vid)
      if (err .ne. 0)
     +     call errore('nf_inq_varid: ', err)
      var = 1.0
      err = nf_put_var1_double(ncid, vid, (/0/), var)
      if (err .ne. NF_EINDEFINE)
     +     call errore('nf_put_var... in define mode: ', err)
      err = nf_redef(ncid)
      if (err .ne. NF_EINDEFINE)
     +     call errore('nf_redef in define mode: ', err)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      call put_vars(ncid)
      err = nf_def_dim(ncid, 'abc', 8, dimid)
      if (err .ne. NF_ENOTINDEFINE)
     +     call errore('nf_def_dim in define mode: ', err)
      err = nf_redef(ncid)
      if (err .ne. 0)
     +     call errore('nf_redef: ', err)
      err = nf_def_dim(ncid, 'abc', 8, dimid)
      if (err .ne. 0)
     +     call errore('nf_def_dim: ', err)
      err = nf_def_var(ncid, 'abc', NF_INT, 0, (/0/), vid)
      if (err .ne. 0)
     +     call errore('nf_def_var: ', err)
      err = nf_put_att_text(ncid, NF_GLOBAL, 'title', len(title),
     +     title)
      if (err .ne .0)
     +     call errore('nf_put_att_text: ', err)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      var = 1.0
      err = nf_put_var1_double(ncid, vid, (/0/), var)
      if (err .ne. 0)
     +     call errore('nf_put_var1_double: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* check scratch file written as expected */
      call check_file(scratch)
      err = nf_open(scratch, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_dim(ncid, dimid, name, length)
      if (err .ne. 0)
     +     call errore('nf_inq_dim: ', err)
      if (name .ne. "abc")
     +     call errori('Unexpected dim name in netCDF ', ncid)
      if (length .ne. 8)
     +     call errori('Unexpected dim length: ', length)
      err = nf_get_var1_double(ncid, vid, (/0/), var)
      if (err .ne. 0)
     +     call errore('nf_get_var1_double: ', err)
      if (var .ne. 1.0)
     +     call errori(
     +     'nf_get_var1_double: unexpected value in netCDF ', ncid)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete failed for netCDF: ', err)
      end

C     Test nf_enddef
C     Simply calls test_nf_redef which tests both nf_redef & nf_enddef

      subroutine test_nf_enddef()
      implicit none
#include "tests.inc"

      call test_nf_redef
      end


C     Test nf_sync
C     try with bad handle, check error
C     try in define mode, check error
C     try writing with one handle, reading with another on same netCDF
      subroutine test_nf_sync()
      implicit none
#include "tests.inc"

      integer ncidw             !/* netcdf id for writing */
      integer ncidr             !/* netcdf id for reading */
      integer err

C     /* BAD_ID test */
      err = nf_sync(BAD_ID)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

C     /* create scratch file & try nf_sync in define mode */
      err = nf_create(scratch, NF_NOCLOBBER, ncidw)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_sync(ncidw)
      if (err .ne. NF_EINDEFINE)
     +     call errore('nf_sync called in define mode: ', err)

C     /* write using same handle */
      call def_dims(ncidw)
      call def_vars(ncidw)
      call put_atts(ncidw)
      err = nf_enddef(ncidw)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      call put_vars(ncidw)
      err = nf_sync(ncidw)
      if (err .ne. 0)
     +     call errore('nf_sync of ncidw failed: ', err)

C     /* open another handle, nf_sync, read (check) */
      err = nf_open(scratch, NF_NOWRITE, ncidr)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_sync(ncidr)
      if (err .ne. 0)
     +     call errore('nf_sync of ncidr failed: ', err)
      call check_dims(ncidr)
      call check_atts(ncidr)
      call check_vars(ncidr)

C     /* close both handles */
      err = nf_close(ncidr)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_close(ncidw)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_abort
C     try with bad handle, check error
C     try in define mode before anything written, check that file was deleted
C     try after nf_enddef, nf_redef, define new dims, vars, atts
C     try after writing variable
      subroutine test_nf_abort()
      implicit none
#include "tests.inc"

      integer ncid              !/* netcdf id */
      integer err
      integer ndims1
      integer nvars1
      integer ngatts1
      integer recdim1

C     /* BAD_ID test */
      err = nf_abort(BAD_ID)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: status = ', err)

C     /* create scratch file & try nf_abort in define mode */
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)
      err = nf_abort(ncid)
      if (err .ne. 0)
     +     call errore('nf_abort of ncid failed: ', err)
      err = nf_close(ncid)      !/* should already be closed */
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_delete(scratch)  !/* should already be deleted */
      if (err .eq. 0)
     +     call errori('scratch file should not exist: ', err)

C     create scratch file
C     do nf_enddef & nf_redef
C     define new dims, vars, atts
C     try nf_abort: should restore previous state (no dims, vars, atts)
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      err = nf_redef(ncid)
      if (err .ne. 0)
     +     call errore('nf_redef: ', err)
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)
      err = nf_abort(ncid)
      if (err .ne. 0)
     +     call errore('nf_abort of ncid failed: ', err)
      err = nf_close(ncid)      !/* should already be closed */
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      err = nf_open(scratch, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq (ncid, ndims1, nvars1, ngatts1, recdim1)
      if (err .ne. 0)
     +     call errore('nf_inq: ', err)
      if (ndims1 .ne. 0)
     +     call errori('ndims1 should be ', 0)
      if (nvars1 .ne. 0)
     +     call errori('nvars1 should be ', 0)
      if (ngatts1 .ne. 0)
     +     call errori('ngatts1 should be ', 0)
      err = nf_close (ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* try nf_abort in data mode - should just close */
      err = nf_create(scratch, NF_CLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      call put_vars(ncid)
      err = nf_abort(ncid)
      if (err .ne. 0)
     +     call errore('nf_abort of ncid failed: ', err)
      err = nf_close(ncid)      !/* should already be closed */
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)
      call check_file(scratch)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_def_dim
C     try with bad netCDF handle, check error
C     try in data mode, check error
C     check that returned id is one more than previous id
C     try adding same dimension twice, check error
C     try with illegal sizes, check error
C     make sure unlimited size works, shows up in nf_inq_unlimdim
C     try to define a second unlimited dimension, check error
      subroutine test_nf_def_dim()
      implicit none
#include "tests.inc"

      integer ncid
      integer err               !/* status */
      integer i
      integer dimid             !/* dimension id */
      integer length

C     /* BAD_ID test */
      err = nf_def_dim(BAD_ID, 'abc', 8, dimid)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

C     /* data mode test */
      err = nf_create(scratch, NF_CLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      err = nf_def_dim(ncid, 'abc', 8, dimid)
      if (err .ne. NF_ENOTINDEFINE)
     +     call errore('bad ncid: ', err)

C     /* define-mode tests: unlimited dim */
      err = nf_redef(ncid)
      if (err .ne. 0)
     +     call errore('nf_redef: ', err)
      err = nf_def_dim(ncid, dim_name(1), NF_UNLIMITED, dimid)
      if (err .ne. 0)
     +     call errore('nf_def_dim: ', err)
      if (dimid .ne. 1)
     +     call errori('Unexpected dimid: ', dimid)
      err = nf_inq_unlimdim(ncid, dimid)
      if (err .ne. 0)
     +     call errore('nf_inq_unlimdim: ', err)
      if (dimid .ne. RECDIM)
     +     call error('Unexpected recdim1: ')
      err = nf_inq_dimlen(ncid, dimid, length)
      if (length .ne. 0)
     +     call errori('Unexpected length: ', 0)
      err = nf_def_dim(ncid, 'abc', NF_UNLIMITED, dimid)
      if (err .ne. NF_EUNLIMIT)
     +     call errore('2nd unlimited dimension: ', err)

C     /* define-mode tests: remaining dims */
      do 1, i = 2, NDIMS
         err = nf_def_dim(ncid, dim_name(i-1), dim_len(i),
     +        dimid)
         if (err .ne. NF_ENAMEINUSE)
     +        call errore('duplicate name: ', err)
         err = nf_def_dim(ncid, BAD_NAME, dim_len(i), dimid)
         if (err .ne. NF_EBADNAME)
     +        call errore('bad name: ', err)
         err = nf_def_dim(ncid, dim_name(i), NF_UNLIMITED-1,
     +        dimid)
         if (err .ne. NF_EDIMSIZE)
     +        call errore('bad size: ', err)
         err = nf_def_dim(ncid, dim_name(i), dim_len(i), dimid)
         if (err .ne. 0)
     +        call errore('nf_def_dim: ', err)
         if (dimid .ne. i)
     +        call errori('Unexpected dimid: ', 0)
 1    continue

C     /* Following just to expand unlimited dim */
      call def_vars(ncid)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      call put_vars(ncid)

C     /* Check all dims */
      call check_dims(ncid)

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_rename_dim
C     try with bad netCDF handle, check error
C     check that proper rename worked with nf_inq_dim
C     try renaming to existing dimension name, check error
C     try with bad dimension handle, check error
      subroutine test_nf_rename_dim()
      implicit none
#include "tests.inc"

      integer ncid
      integer err               !/* status */
      character*(NF_MAX_NAME) name

C     /* BAD_ID test */
      err = nf_rename_dim(BAD_ID, 1, 'abc')
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

C     /* main tests */
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      err = nf_rename_dim(ncid, BAD_DIMID, 'abc')
      if (err .ne. NF_EBADDIM)
     +     call errore('bad dimid: ', err)
      err = nf_rename_dim(ncid, 3, 'abc')
      if (err .ne. 0)
     +     call errore('nf_rename_dim: ', err)
      err = nf_inq_dimname(ncid, 3, name)
      if (name .ne. 'abc')
     +     call errorc('Unexpected name: ', name)
      err = nf_rename_dim(ncid, 1, 'abc')
      if (err .ne. NF_ENAMEINUSE)
     +     call errore('duplicate name: ', err)

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_def_var
C     try with bad netCDF handle, check error
C     try with bad name, check error
C     scalar tests:
C     check that proper define worked with nf_inq_var
C     try redefining an existing variable, check error
C     try with bad datatype, check error
C     try with bad number of dimensions, check error
C     try in data mode, check error
C     check that returned id is one more than previous id
C     try with bad dimension ids, check error
      subroutine test_nf_def_var()
      implicit none
#include "tests.inc"

      integer ncid
      integer vid
      integer err               !/* status */
      integer i
      integer ndims1
      integer na
      character*(NF_MAX_NAME) name
      integer dimids(MAX_RANK)
      integer datatype

C     /* BAD_ID test */
      err = nf_def_var(BAD_ID, 'abc', NF_SHORT, 0, dimids, vid)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: status = ', err)

C     /* scalar tests */
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_def_var(ncid, 'abc', NF_SHORT, 0, dimids, vid)
      if (err .ne. 0)
     +     call errore('nf_def_var: ', err)
      err = nf_inq_var(ncid, vid, name, datatype, ndims1, dimids,
     +     na)
      if (err .ne. 0)
     +     call errore('nf_inq_var: ', err)
      if (name .ne. 'abc')
     +     call errorc('Unexpected name: ', name)
      if (datatype .ne. NF_SHORT)
     +     call error('Unexpected datatype')
      if (ndims1 .ne. 0)
     +     call error('Unexpected rank')
      err = nf_def_var(ncid, BAD_NAME, NF_SHORT, 0, dimids, vid)
      if (err .ne. NF_EBADNAME)
     +     call errore('bad name: ', err)
      err = nf_def_var(ncid, 'abc', NF_SHORT, 0, dimids, vid)
      if (err .ne. NF_ENAMEINUSE)
     +     call errore('duplicate name: ', err)
      err = nf_def_var(ncid, 'ABC', BAD_TYPE, -1, dimids, vid)
      if (err .ne. NF_EBADTYPE)
     +     call errore('bad type: ', err)
      err = nf_def_var(ncid, 'ABC', NF_SHORT, -1, dimids, vid)
      if (err .ne. NF_EINVAL)
     +     call errore('bad rank: ', err)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      err = nf_def_var(ncid, 'ABC', NF_SHORT, 0, dimids, vid)
      if (err .ne. NF_ENOTINDEFINE)
     +     call errore('nf_def_var called in data mode: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errorc('delete of scratch file failed: ', scratch)

C     /* general tests using global vars */
      err = nf_create(scratch, NF_CLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      do 1, i = 1, NVARS
         err = nf_def_var(ncid, var_name(i), var_type(i),
     +        var_rank(i), var_dimid(1,i), vid)
         if (err .ne. 0)
     +        call errore('nf_def_var: ', err)
         if (vid .ne. i)
     +        call error('Unexpected varid')
 1    continue

C     /* try bad dim ids */
      dimids(1) = BAD_DIMID
      err = nf_def_var(ncid, 'abc', NF_SHORT, 1, dimids, vid)
      if (err .ne. NF_EBADDIM)
     +     call errore('bad dim ids: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errorc('delete of scratch file failed: ', scratch)
      end


C     Test nf_rename_var
C     try with bad netCDF handle, check error
C     try with bad variable handle, check error
C     try renaming to existing variable name, check error
C     check that proper rename worked with nf_inq_varid
C     try in data mode, check error
      subroutine test_nf_rename_var()
      implicit none
#include "tests.inc"

      integer ncid
      integer vid
      integer err
      integer i
      character*(NF_MAX_NAME) name

      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_rename_var(ncid, BAD_VARID, 'newName')
      if (err .ne. NF_ENOTVAR)
     +     call errore('bad var id: ', err)
      call def_dims(ncid)
      call def_vars(ncid)

C     /* Prefix "new_" to each name */
      do 1, i = 1, NVARS
         err = nf_rename_var(BAD_ID, i, 'newName')
         if (err .ne. NF_EBADID)
     +        call errore('bad ncid: ', err)
         err = nf_rename_var(ncid, i, var_name(NVARS))
         if (err .ne. NF_ENAMEINUSE)
     +        call errore('duplicate name: ', err)
         name = 'new_' // var_name(i)
         err = nf_rename_var(ncid, i, name)
         if (err .ne. 0)
     +        call errore('nf_rename_var: ', err)
         err = nf_inq_varid(ncid, name, vid)
         if (err .ne. 0)
     +        call errore('nf_inq_varid: ', err)
         if (vid .ne. i)
     +        call error('Unexpected varid')
 1    continue

C     /* Change to data mode */
C     /* Try making names even longer. Then restore original names */
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      do 2, i = 1, NVARS
         name = 'even_longer_' // var_name(i)
         err = nf_rename_var(ncid, i, name)
         if (err .ne. NF_ENOTINDEFINE)
     +        call errore('longer name in data mode: ', err)
         err = nf_rename_var(ncid, i, var_name(i))
         if (err .ne. 0)
     +        call errore('nf_rename_var: ', err)
         err = nf_inq_varid(ncid, var_name(i), vid)
         if (err .ne. 0)
     +        call errore('nf_inq_varid: ', err)
         if (vid .ne. i)
     +        call error('Unexpected varid')
 2    continue

      call put_vars(ncid)
      call check_vars(ncid)

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errorc('delete of scratch file failed: ', scratch)
      end


C     Test nf_copy_att
C     try with bad source or target netCDF handles, check error
C     try with bad source or target variable handle, check error
C     try with nonexisting attribute, check error
C     check that NF_GLOBAL variable for source or target works
C     check that new attribute put works with target in define mode
C     check that old attribute put works with target in data mode
C     check that changing type and length of an attribute work OK
C     try with same ncid for source and target, different variables
C     try with same ncid for source and target, same variable
      subroutine test_nf_copy_att()
      implicit none
#include "tests.inc"

      integer ncid_in
      integer ncid_out
      integer vid
      integer err
      integer i
      integer j
      character*(NF_MAX_NAME) name !/* of att */
      integer datatype          !/* of att */
      integer length            !/* of att */
      character*1     value

      err = nf_open(testfile, NF_NOWRITE, ncid_in)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_create(scratch, NF_NOCLOBBER, ncid_out)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid_out)
      call def_vars(ncid_out)

      do 1, i = 0, NVARS
         vid = VARID(i)
         do 2, j = 1, NATTS(i)
            name = ATT_NAME(j,i)
            err = nf_copy_att(ncid_in, BAD_VARID, name, ncid_out,
     +           vid)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad var id: ', err)
            err = nf_copy_att(ncid_in, vid, name, ncid_out,
     +           BAD_VARID)
            if (err .ne. NF_ENOTVAR)
     +           call errore('bad var id: ', err)
            err = nf_copy_att(BAD_ID, vid, name, ncid_out, vid)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_copy_att(ncid_in, vid, name, BAD_ID, vid)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_copy_att(ncid_in, vid, 'noSuch', ncid_out, vid)
            if (err .ne. NF_ENOTATT)
     +           call errore('bad attname: ', err)
            err = nf_copy_att(ncid_in, vid, name, ncid_out, vid)
            if (err .ne. 0)
     +           call errore('nf_copy_att: ', err)
            err = nf_copy_att(ncid_out, vid, name, ncid_out, vid)
            if (err .ne. 0)
     +           call errore('source = target: ', err)
 2       continue
 1    continue

      err = nf_close(ncid_in)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* Close scratch. Reopen & check attributes */
      err = nf_close(ncid_out)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_open(scratch, NF_WRITE, ncid_out)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      call check_atts(ncid_out)

C     change to define mode
C     define single char. global att. ':a' with value 'A'
C     This will be used as source for following copies
      err = nf_redef(ncid_out)
      if (err .ne. 0)
     +     call errore('nf_redef: ', err)
      err = nf_put_att_text(ncid_out, NF_GLOBAL, 'a', 1, 'A')
      if (err .ne. 0)
     +     call errore('nf_put_att_text: ', err)

C     change to data mode
C     Use scratch as both source & dest.
C     try copy to existing att. change type & decrease length
C     rename 1st existing att of each var (if any) 'a'
C     if this att. exists them copy ':a' to it
      err = nf_enddef(ncid_out)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      do 3, i = 1, NVARS
         if (NATTS(i) .gt. 0 .and. ATT_LEN(1,i) .gt. 0) then
            err = nf_rename_att(ncid_out, i, att_name(1,i), 'a')
            if (err .ne. 0)
     +           call errore('nf_rename_att: ', err)
            err = nf_copy_att(ncid_out, NF_GLOBAL, 'a', ncid_out,
     +           i)
            if (err .ne. 0)
     +           call errore('nf_copy_att: ', err)
         end if
 3    continue
      err = nf_close(ncid_out)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* Reopen & check */
      err = nf_open(scratch, NF_WRITE, ncid_out)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      do 4, i = 1, NVARS
         if (NATTS(i) .gt. 0 .and. ATT_LEN(1,i) .gt. 0) then
            err = nf_inq_att(ncid_out, i, 'a', datatype, length)
            if (err .ne. 0)
     +           call errore('nf_inq_att: ', err)
            if (datatype .ne. NF_CHAR)
     +           call error('Unexpected type')
            if (length .ne. 1)
     +           call error('Unexpected length')
            err = nf_get_att_text(ncid_out, i, 'a', value)
            if (err .ne. 0)
     +           call errore('nf_get_att_text: ', err)
            if (value .ne. 'A')
     +           call error('Unexpected value')
         end if
 4    continue

      err = nf_close(ncid_out)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errorc('delete of scratch file failed', scratch)
      end


C     Test nf_rename_att
C     try with bad netCDF handle, check error
C     try with bad variable handle, check error
C     try with nonexisting att name, check error
C     try renaming to existing att name, check error
C     check that proper rename worked with nf_inq_attid
C     try in data mode, check error
      subroutine test_nf_rename_att()
      implicit none
#include "tests.inc"

      integer ncid
      integer vid
      integer err
      integer i
      integer j
      integer  k
      integer attnum
      character*(NF_MAX_NAME) atnam
      character*(NF_MAX_NAME) name
      character*(NF_MAX_NAME) oldname
      character*(NF_MAX_NAME) newname
      integer nok               !/* count of valid comparisons */
      integer datatype
      integer attyp
      integer length
      integer attlength
      integer ndx(1)
      character*(MAX_NELS)    text
      doubleprecision value(MAX_NELS)
      doubleprecision expect

      nok = 0

      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_rename_att(ncid, BAD_VARID, 'abc', 'newName')
      if (err .ne. NF_ENOTVAR)
     +     call errore('bad var id: ', err)
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)

      do 1, i = 0, NVARS
         vid = VARID(i)
         do 2, j = 1, NATTS(i)
            atnam = ATT_NAME(j,i)
            err = nf_rename_att(BAD_ID, vid, atnam, 'newName')
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_rename_att(ncid, vid, 'noSuch', 'newName')
            if (err .ne. NF_ENOTATT)
     +           call errore('bad attname: ', err)
            newname = 'new_' // atnam
            err = nf_rename_att(ncid, vid, atnam, newname)
            if (err .ne. 0)
     +           call errore('nf_rename_att: ', err)
            err = nf_inq_attid(ncid, vid, newname, attnum)
            if (err .ne. 0)
     +           call errore('nf_inq_attid: ', err)
            if (attnum .ne. j)
     +           call error('Unexpected attnum')
 2       continue
 1    continue

C     /* Close. Reopen & check */
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_open(scratch, NF_WRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)

      do 3, i = 0, NVARS
         vid = VARID(i)
         do 4, j = 1, NATTS(i)
            atnam = ATT_NAME(j,i)
            attyp = ATT_TYPE(j,i)
            attlength = ATT_LEN(j,i)
            newname = 'new_' // atnam
            err = nf_inq_attname(ncid, vid, j, name)
            if (err .ne. 0)
     +           call errore('nf_inq_attname: ', err)
            if (name .ne. newname)
     +           call error('nf_inq_attname: unexpected name')
            err = nf_inq_att(ncid, vid, name, datatype, length)
            if (err .ne. 0)
     +           call errore('nf_inq_att: ', err)
            if (datatype .ne. attyp)
     +           call error('nf_inq_att: unexpected type')
            if (length .ne. attlength)
     +           call error('nf_inq_att: unexpected length')
            if (datatype .eq. NF_CHAR) then
               err = nf_get_att_text(ncid, vid, name, text)
               if (err .ne. 0)
     +              call errore('nf_get_att_text: ', err)
               do 5, k = 1, attlength
                  ndx(1) = k
                  expect = hash(datatype, -1, ndx)
                  if (ichar(text(k:k)) .ne. expect) then
                     call error(
     +                    'nf_get_att_text: unexpected value')
                  else
                     nok = nok + 1
                  end if
 5             continue
            else
               err = nf_get_att_double(ncid, vid, name, value)
               if (err .ne. 0)
     +              call errore('nf_get_att_double: ', err)
               do 6, k = 1, attlength
                  ndx(1) = k
                  expect = hash(datatype, -1, ndx)
                  if (inRange(expect, datatype)) then
                     if (.not. equal(value(k),expect,datatype,
     +                    NF_DOUBLE)) then
                        call error(
     +                       'nf_get_att_double: unexpected value')
                     else
                        nok = nok + 1
                     end if
                  end if
 6             continue
            end if
 4       continue
 3    continue
      call print_nok(nok)

C     /* Now in data mode */
C     /* Try making names even longer. Then restore original names */

      do 7, i = 0, NVARS
         vid = VARID(i)
         do 8, j = 1, NATTS(i)
            atnam = ATT_NAME(j,i)
            oldname = 'new_' // atnam
            newname = 'even_longer_' // atnam
            err = nf_rename_att(ncid, vid, oldname, newname)
            if (err .ne. NF_ENOTINDEFINE)
     +           call errore('longer name in data mode: ', err)
            err = nf_rename_att(ncid, vid, oldname, atnam)
            if (err .ne. 0)
     +           call errore('nf_rename_att: ', err)
            err = nf_inq_attid(ncid, vid, atnam, attnum)
            if (err .ne. 0)
     +           call errore('nf_inq_attid: ', err)
            if (attnum .ne. j)
     +           call error('Unexpected attnum')
 8       continue
 7    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_del_att
C     try with bad netCDF handle, check error
C     try with bad variable handle, check error
C     try with nonexisting att name, check error
C     check that proper delete worked using:
C     nf_inq_attid, nf_inq_natts, nf_inq_varnatts
      subroutine test_nf_del_att()
      implicit none
#include "tests.inc"

      integer ncid
      integer err
      integer i
      integer j
      integer attnum
      integer na
      integer numatts
      integer vid
      character*(NF_MAX_NAME)  name !/* of att */

      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      err = nf_del_att(ncid, BAD_VARID, 'abc')
      if (err .ne. NF_ENOTVAR)
     +     call errore('bad var id: ', err)
      call def_dims(ncid)
      call def_vars(ncid)
      call put_atts(ncid)

      do 1, i = 0, NVARS
         vid = VARID(i)
         numatts = NATTS(i)
         do 2, j = 1, numatts
            name = ATT_NAME(j,i)
            err = nf_del_att(BAD_ID, vid, name)
            if (err .ne. NF_EBADID)
     +           call errore('bad ncid: ', err)
            err = nf_del_att(ncid, vid, 'noSuch')
            if (err .ne. NF_ENOTATT)
     +           call errore('bad attname: ', err)
            err = nf_del_att(ncid, vid, name)
            if (err .ne. 0)
     +           call errore('nf_del_att: ', err)
            err = nf_inq_attid(ncid, vid, name, attnum)
            if (err .ne. NF_ENOTATT)
     +           call errore('bad attname: ', err)
            if (i .lt. 1) then
               err = nf_inq_natts(ncid, na)
               if (err .ne. 0)
     +              call errore('nf_inq_natts: ', err)
               if (na .ne. numatts-j) then
                  call errori('natts: expected: ', numatts-j)
                  call errori('natts: got:      ', na)
               end if
            end if
            err = nf_inq_varnatts(ncid, vid, na)
            if (err .ne. 0)
     +           call errore('nf_inq_natts: ', err)
            if (na .ne. numatts-j) then
               call errori('natts: expected: ', numatts-j)
               call errori('natts: got:      ', na)
            end if
 2       continue
 1    continue

C     /* Close. Reopen & check no attributes left */
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_open(scratch, NF_WRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_inq_natts(ncid, na)
      if (err .ne. 0)
     +     call errore('nf_inq_natts: ', err)
      if (na .ne. 0)
     +     call errori('natts: expected 0, got ', na)
      do 3, i = 0, NVARS
         vid = VARID(i)
         err = nf_inq_varnatts(ncid, vid, na)
         if (err .ne. 0)
     +        call errore('nf_inq_natts: ', err)
         if (na .ne. 0)
     +        call errori('natts: expected 0, got ', na)
 3    continue

C     /* restore attributes. change to data mode. try to delete */
      err = nf_redef(ncid)
      if (err .ne. 0)
     +     call errore('nf_redef: ', err)
      call put_atts(ncid)
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)

      do 4, i = 0, NVARS
         vid = VARID(i)
         numatts = NATTS(i)
         do 5, j = 1, numatts
            name = ATT_NAME(j,i)
            err = nf_del_att(ncid, vid, name)
            if (err .ne. NF_ENOTINDEFINE)
     +           call errore('in data mode: ', err)
 5       continue
 4    continue

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end


C     Test nf_set_fill
C     try with bad netCDF handle, check error
C     try in read-only mode, check error
C     try with bad new_fillmode, check error
C     try in data mode, check error
C     check that proper set to NF_FILL works for record & non-record variables
C     (note that it is not possible to test NF_NOFILL mode!)
C     close file & create again for test using attribute _FillValue
      subroutine test_nf_set_fill()
      implicit none
#include "tests.inc"

      integer ncid
      integer vid
      integer err
      integer i
      integer j
      integer old_fillmode
      integer nok               !/* count of valid comparisons */
      character*1 text
      doubleprecision value
      doubleprecision fill
      doubleprecision fill_array(1)
      integer index(MAX_RANK)

      nok = 0
      value = 0

C     /* bad ncid */
      err = nf_set_fill(BAD_ID, NF_NOFILL, old_fillmode)
      if (err .ne. NF_EBADID)
     +     call errore('bad ncid: ', err)

C     /* try in read-only mode */
      err = nf_open(testfile, NF_NOWRITE, ncid)
      if (err .ne. 0)
     +     call errore('nf_open: ', err)
      err = nf_set_fill(ncid, NF_NOFILL, old_fillmode)
      if (err .ne. NF_EPERM)
     +     call errore('read-only: ', err)
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)

C     /* create scratch */
      err = nf_create(scratch, NF_NOCLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if

C     /* BAD_FILLMODE */
      err = nf_set_fill(ncid, BAD_FILLMODE, old_fillmode)
      if (err .ne. NF_EINVAL)
     +     call errore('bad fillmode: ', err)

C     /* proper calls */
      err = nf_set_fill(ncid, NF_NOFILL, old_fillmode)
      if (err .ne. 0)
     +     call errore('nf_set_fill: ', err)
      if (old_fillmode .ne. NF_FILL)
     +     call errori('Unexpected old fill mode: ', old_fillmode)
      err = nf_set_fill(ncid, NF_FILL, old_fillmode)
      if (err .ne. 0)
     +     call errore('nf_set_fill: ', err)
      if (old_fillmode .ne. NF_NOFILL)
     +     call errori('Unexpected old fill mode: ', old_fillmode)

C     /* define dims & vars */
      call def_dims(ncid)
      call def_vars(ncid)

C     /* Change to data mode. Set fillmode again */
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      err = nf_set_fill(ncid, NF_FILL, old_fillmode)
      if (err .ne. 0)
     +     call errore('nf_set_fill: ', err)
      if (old_fillmode .ne. NF_FILL)
     +     call errori('Unexpected old fill mode: ', old_fillmode)

C     /* Write record number NRECS to force writing of preceding records */
C     /* Assumes variable cr is char vector with UNLIMITED dimension */
      err = nf_inq_varid(ncid, 'cr', vid)
      if (err .ne. 0)
     +     call errore('nf_inq_varid: ', err)
      index(1) = NRECS
      text = char(NF_FILL_CHAR)
      err = nf_put_var1_text(ncid, vid, index, text)
      if (err .ne. 0)
     +     call errore('nf_put_var1_text: ', err)

C     /* get all variables & check all values equal default fill */
      do 1, i = 1, NVARS
         if (var_type(i) .eq. NF_CHAR) then
            fill = NF_FILL_CHAR
         else if (var_type(i) .eq. NF_BYTE) then
            fill = NF_FILL_BYTE
         else if (var_type(i) .eq. NF_SHORT) then
            fill = NF_FILL_SHORT
         else if (var_type(i) .eq. NF_INT) then
            fill = NF_FILL_INT
         else if (var_type(i) .eq. NF_FLOAT) then
            fill = NF_FILL_FLOAT
         else if (var_type(i) .eq. NF_DOUBLE) then
            fill = NF_FILL_DOUBLE
         else
            stop 2
         end if

         do 2, j = 1, var_nels(i)
            err = index2indexes(j, var_rank(i), var_shape(1,i),
     +           index)
            if (err .ne. 0)
     +           call error('error in index2indexes()')
            if (var_type(i) .eq. NF_CHAR) then
               err = nf_get_var1_text(ncid, i, index, text)
               if (err .ne. 0)
     +              call errore('nf_get_var1_text failed: ',err)
               value = ichar(text)
            else
               err = nf_get_var1_double(ncid, i, index, value)
               if (err .ne. 0)
     +              call errore('nf_get_var1_double failed: ',err)
            end if
            if (value .ne. fill .and.
     +           abs((fill - value)/fill) .gt. 1.0e-9) then
               call errord('Unexpected fill value: ', value)
            else
               nok = nok + 1
            end if
 2       continue
 1    continue

C     /* close scratch & create again for test using attribute _FillValue */
      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_create(scratch, NF_CLOBBER, ncid)
      if (err .ne. 0) then
         call errore('nf_create: ', err)
         return
      end if
      call def_dims(ncid)
      call def_vars(ncid)

C     /* set _FillValue = 42 for all vars */
      fill = 42
      fill_array(1) = fill
      text = char(int(fill))
      do 3, i = 1, NVARS
         if (var_type(i) .eq. NF_CHAR) then
            err = nf_put_att_text(ncid, i, '_FillValue', 1, text)
            if (err .ne. 0)
     +           call errore('nf_put_att_text: ', err)
         else
            err = nf_put_att_double(ncid, i, '_FillValue',
     +           var_type(i),1,fill_array)
            if (err .ne. 0)
     +           call errore('nf_put_att_double: ', err)
         end if
 3    continue

C     /* data mode. write records */
      err = nf_enddef(ncid)
      if (err .ne. 0)
     +     call errore('nf_enddef: ', err)
      index(1) = NRECS
      err = nf_put_var1_text(ncid, vid, index, text)
      if (err .ne. 0)
     +     call errore('nf_put_var1_text: ', err)

C     /* get all variables & check all values equal 42 */
      do 4, i = 1, NVARS
         do 5, j = 1, var_nels(i)
            err = index2indexes(j, var_rank(i), var_shape(1,i),
     +           index)
            if (err .ne. 0)
     +           call error('error in index2indexes')
            if (var_type(i) .eq. NF_CHAR) then
               err = nf_get_var1_text(ncid, i, index, text)
               if (err .ne. 0)
     +              call errore('nf_get_var1_text failed: ',err)
               value = ichar(text)
            else
               err = nf_get_var1_double(ncid, i, index, value)
               if (err .ne. 0)
     +              call errore('nf_get_var1_double failed: ', err)
            end if
            if (value .ne. fill) then
               call errord(' Value expected: ', fill)
               call errord(' Value read:     ', value)
            else
               nok = nok + 1
            end if
 5       continue
 4    continue
      call print_nok(nok)

      err = nf_close(ncid)
      if (err .ne. 0)
     +     call errore('nf_close: ', err)
      err = nf_delete(scratch)
      if (err .ne. 0)
     +     call errori('delete of scratch file failed: ', err)
      end

C     * Test nc_set_default_format
C     *    try with bad default format
C     *    try with NULL old_formatp
C     *    try in data mode, check error
C     *    check that proper set to NC_FILL works for record & non-record variables
C     *    (note that it is not possible to test NC_NOFILL mode!)
C     *    close file & create again for test using attribute _FillValue
      subroutine test_nf_set_default_format()
      implicit none
#include "tests.inc"

      integer ncid
      integer err
      integer i
      integer version
      integer old_format
      integer nf_get_file_version

C     /* bad format */
      err = nf_set_default_format(99, old_format)
      IF (err .ne. NF_EINVAL)
     +     call errore("bad default format: status = %d", err)

C     /* Cycle through available formats. (actually netcdf-4 formats are
C     ignored for the moment - ed 5/15/5) */
      do 1 i=1, 2
         err = nf_set_default_format(i, old_format)
         if (err .ne. 0)
     +        call errore("setting classic format: status = %d", err)
         err = nf_create(scratch, NF_CLOBBER, ncid)
         if (err .ne. 0) call errore("bad nf_create: status = %d", err)
         err = nf_put_att_text(ncid, NF_GLOBAL, "testatt",
     +        4, "blah")
         if (err .ne. 0) call errore("bad put_att: status = %d", err)
         err = nf_close(ncid)
         if (err .ne. 0) call errore("bad close: status = %d", err)
         err = nf_get_file_version(scratch, version)
         if (err .ne. 0) call errore("bad file version = %d", err)
         if (version .ne. i)
     +        call errore("bad file version = %d", err)
 1    continue

C     /* Remove the left-over file. */
C     err = nf_delete(scratch)
      if (err .ne. 0) call errore("remove failed", err)
      end

C     This function looks in a file for the netCDF magic number.
      integer function nf_get_file_version(path, version)
      implicit none
#include "tests.inc"

      character*(*) path
      integer version, iosnum
      character magic*4
      integer ver
      integer f
      parameter (f = 10)

      open(f, file=path, status='OLD', form='UNFORMATTED',
     +     access='DIRECT', recl=4)

C     Assume this is not a netcdf file.
      nf_get_file_version = NF_ENOTNC
      version = 0

C     Read the magic number, the first 4 bytes of the file.
      read(f, rec=1, err = 1) magic

C     If the first three characters are not "CDF" we're done.
      if (index(magic, 'CDF') .eq. 1) then
         ver = ichar(magic(4:4))
         if (ver .eq. 1) then
            version = 1
            nf_get_file_version = NF_NOERR
         elseif (ver .eq. 2) then
            version = 2
            nf_get_file_version = NF_NOERR
         endif
      endif

 1    close(f)
      return
      end

! This program provides an elementary check of some of the parts of the 
!   Fortran 90 interface to netCDF 3.5. It is a Fortran 90 implementation
!   of the nctst.cpp program provided with the C++ interface to netcdf
!   (in the src/cxx directory of the netcdf distribution). 
!
program netcdfTest
  use typeSizes
  use netcdf
  implicit none
  
  ! netcdf related variables
  integer :: ncFileID,                                   &
             latDimID, lonDimID, frTimeDimID, timeDimID, mxStrDimID, &
             pressVarID, latVarID, lonVarID, frTimeVarID, refTimeVarID, &
             scalarVarID, scalarStrVarID
             
  ! Local variables
  integer, parameter :: numLats = 4, numLons = 3, &
                        numFrTimes = 2, timeStringLen = 20, mxStrLen=80
  character (len = *), parameter :: fileName = "tst_f90.nc"
  integer :: counter, i
  real, dimension(numLons, numLats, numFrTimes) :: pressure
  integer (kind = FourByteInt), dimension(numFrTimes) :: frTimeVals
  real (kind = FourByteReal) fillVal;
  real (kind = FourByteReal), dimension(2) :: validRange;
  character (len = 20) frTimeUnits
  character(len=mxStrLen) :: scalarString, scalarStrRead

  print *, ''
  print *,'*** Testing netCDF-3 Fortran 90 API.'

! --------------------
  ! Code begins
  ! --------------------
  if(.not. byteSizesOK()) then
    print *, "Compiler does not appear to support required kinds of variables."
    stop
  end if
    
  ! Create the file
  call check(nf90_create(path = trim(fileName), cmode = nf90_clobber, ncid = ncFileID))
  
  ! Define the dimensions
  call check(nf90_def_dim(ncid = ncFileID, name = "lat",     len = numLats,        dimid = latDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "lon",     len = numLons,        dimid = lonDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "frtime",  len = nf90_unlimited, dimid = frTimeDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "timelen", len = timeStringLen,  dimid = timeDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "mxstrlen",len = mxStrLen,       dimid = mxStrDimID))

  ! Create variables and attributes
  call check(nf90_def_var(ncid = ncFileID, name = "P", xtype = nf90_float,     &
                     dimids = (/ lonDimID, latDimID, frTimeDimID /), varID = pressVarID) )
  call check(nf90_put_att(ncFileID, pressVarID, "long_name",   "pressure at maximum wind"))
  call check(nf90_put_att(ncFileID, pressVarID, "units",       "hectopascals") )
  ! Use 4-byte reals explicitly, to match 4-byte attribute type in test file
  validRange(1) = 0.
  validRange(2) = 1500
  call check(nf90_put_att(ncFileID, pressVarID, "valid_range", validRange))
  ! Use a 4-byte float constant, to match variable type
  fillVal = -9999.0
  call check(nf90_put_att(ncFileID, pressVarID,  "_FillValue", fillVal ) )
                      
  call check(nf90_def_var(ncFileID, "lat", nf90_float, dimids = latDimID, varID = latVarID) )
  call check(nf90_put_att(ncFileID, latVarID, "long_name", "latitude"))
  call check(nf90_put_att(ncFileID, latVarID, "units", "degrees_north"))

  call check(nf90_def_var(ncFileID, "lon", nf90_float, lonDimID, lonVarID) )
  call check(nf90_put_att(ncFileID, lonVarID, "long_name", "longitude"))
  call check(nf90_put_att(ncFileID, lonVarID, "units",     "degrees_east"))

  call check(nf90_def_var(ncFileID, "frtime", nf90_int, frTimeDimID, frTimeVarID) )
  call check(nf90_put_att(ncFileID, frTimeVarID, "long_name", "forecast time"))
  call check(nf90_put_att(ncFileID, frTimeVarID, "units",     "hours"))

  call check(nf90_def_var(ncFileID, "reftime", nf90_char, timeDimID, refTimeVarID) )
  call check(nf90_put_att(ncFileID, refTimeVarID, "long_name", "reference time"))
  call check(nf90_put_att(ncFileID, refTimeVarID, "units",     "text_time"))
                     
  ! In the C++ interface the define a scalar variable - do we know how to do this? 
  call check(nf90_def_var(ncFileID, "ScalarVariable", nf90_real, scalarVarID))

  ! Define a scalar string -- in a netCDF file it's a 1-D character array
  call check(nf90_def_var(ncFileID, "ScalarString", nf90_char, (/mxStrDimID/), scalarStrVarID))
  
  ! Global attributes
  call check(nf90_put_att(ncFileID, nf90_global, "history", &
                     "created by Unidata LDM from NPS broadcast"))
  call check(nf90_put_att(ncFileID, nf90_global, "title", &
                     "NMC Global Product Set: Pressure at Maximum Wind"))
  
  ! Leave define mode
  call check(nf90_enddef(ncfileID))
  
  ! Write the dimension variables
  call check(nf90_put_var(ncFileID, latVarId,     (/ -90., -87.5, -85., -82.5 /)) )
  call check(nf90_put_var(ncFileID, lonVarId,     (/ -180, -175, -170 /)      ) )
  ! Don't use anonymous array here, in case platform has 8-byte integers
  frTimeVals(1) = 12
  frTimeVals(2) = 18
  call check(nf90_put_var(ncFileID, frTimeVarId,  frTimeVals                  ) )
  call check(nf90_put_var(ncFileID, reftimeVarID, "1992-3-21 12:00"           ) )
  
  ! Write the pressure variable. Write a slab at a time to check incrementing.
  pressure = 949. + real(reshape( (/ (counter, counter = 1, numLats * numLons * numFrTimes) /),  &
                                    (/ numLons, numLats, numFrTimes /) ) )
  call check(nf90_put_var(ncFileID, pressVarID, pressure(:, :, 1:1)) )
  call check(nf90_put_var(ncFileID, pressVarID, pressure(:, :, 2:2), start = (/ 1, 1, 2 /)) )
  
  call check(nf90_put_var(ncFileID, scalarVarID, 10))

  ! Write a scalar string -- note that Fortran assignement adds blank fill
  scalarString = 'this is a blank padded string'
  call check(nf90_put_var(ncFileID, scalarStrVarID, scalarString))

  call check(nf90_close(ncFileID))

  ! Now open the file to read and check a few values
  call check(nf90_open(trim(fileName), NF90_NOWRITE, ncFileID))
  call check(nf90_inq_varid(ncFileID,"frtime",frTimeVarID))
  call check(nf90_get_att(ncFileID,frTimeVarID,"units",frTimeUnits))
  if(frTimeUnits .ne. "hours") then
     print *, 'Attribute value not what was written:', frTimeUnits
     stop 2
  endif
  call check(nf90_get_var(ncFileID, scalarStrVarID, scalarStrRead))
  if(scalarStrRead .ne. scalarString) then
     do i = 1, len(scalarString)
        if (scalarStrRead(i:i) .ne. scalarString(i:i)) exit
     end do
     print *, 'String written to file does not match string read from file.'
     print *, 'Position of first difference:', i, ' character written:', '"'//scalarString(i:i)//'"', &
                                                  ' character read:', '"'//scalarStrRead(i:i)//'"'
     stop 2
  endif

  call check(nf90_close(ncFileID))

  print *,'*** SUCCESS!'

contains
  ! Internal subroutine - checks error status after each netcdf, prints out text message each time
  !   an error code is returned. 
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program netcdfTest

function nf90_get_var_1D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_OneByteInt = cstatus

end function nf90_get_var_1D_OneByteInt

function nf90_get_var_2D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_OneByteInt = cstatus

end function nf90_get_var_2D_OneByteInt

function nf90_get_var_3D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_OneByteInt = cstatus

end function nf90_get_var_3D_OneByteInt

function nf90_get_var_4D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_OneByteInt = cstatus

end function nf90_get_var_4D_OneByteInt

function nf90_get_var_5D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_OneByteInt = cstatus

end function nf90_get_var_5D_OneByteInt

function nf90_get_var_6D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_OneByteInt = cstatus

end function nf90_get_var_6D_OneByteInt

function nf90_get_var_7D_OneByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_OneByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int8_t), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_schar(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_schar

    function my_get_varm_schar(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_schar

    function my_get_vars_schar(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_schar')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_schar
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_schar

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int8_t), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_schar(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_schar(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_schar(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_OneByteInt = cstatus

end function nf90_get_var_7D_OneByteInt

function nf90_get_var_1D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_TwoByteInt = cstatus

end function nf90_get_var_1D_TwoByteInt

function nf90_get_var_2D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_TwoByteInt = cstatus

end function nf90_get_var_2D_TwoByteInt

function nf90_get_var_3D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_TwoByteInt = cstatus

end function nf90_get_var_3D_TwoByteInt

function nf90_get_var_4D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_TwoByteInt = cstatus

end function nf90_get_var_4D_TwoByteInt

function nf90_get_var_5D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_TwoByteInt = cstatus

end function nf90_get_var_5D_TwoByteInt

function nf90_get_var_6D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_TwoByteInt = cstatus

end function nf90_get_var_6D_TwoByteInt

function nf90_get_var_7D_TwoByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_TwoByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int16_t), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_short(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_short

    function my_get_varm_short(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_short

    function my_get_vars_short(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_short')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_short
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_short

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int16_t), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_short(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_short(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_short(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_TwoByteInt = cstatus

end function nf90_get_var_7D_TwoByteInt

function nf90_get_var_1D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_FourByteInt = cstatus

end function nf90_get_var_1D_FourByteInt

function nf90_get_var_2D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_FourByteInt = cstatus

end function nf90_get_var_2D_FourByteInt

function nf90_get_var_3D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_FourByteInt = cstatus

end function nf90_get_var_3D_FourByteInt

function nf90_get_var_4D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_FourByteInt = cstatus

end function nf90_get_var_4D_FourByteInt

function nf90_get_var_5D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_FourByteInt = cstatus

end function nf90_get_var_5D_FourByteInt

function nf90_get_var_6D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_FourByteInt = cstatus

end function nf90_get_var_6D_FourByteInt

function nf90_get_var_7D_FourByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_FourByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int32_t), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_int(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_int

    function my_get_varm_int(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_int

    function my_get_vars_int(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_int')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_int
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_int

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int32_t), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_int(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_int(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_int(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_FourByteInt = cstatus

end function nf90_get_var_7D_FourByteInt

function nf90_get_var_1D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_EightByteInt = cstatus

end function nf90_get_var_1D_EightByteInt

function nf90_get_var_2D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_EightByteInt = cstatus

end function nf90_get_var_2D_EightByteInt

function nf90_get_var_3D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_EightByteInt = cstatus

end function nf90_get_var_3D_EightByteInt

function nf90_get_var_4D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_EightByteInt = cstatus

end function nf90_get_var_4D_EightByteInt

function nf90_get_var_5D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_EightByteInt = cstatus

end function nf90_get_var_5D_EightByteInt

function nf90_get_var_6D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_EightByteInt = cstatus

end function nf90_get_var_6D_EightByteInt

function nf90_get_var_7D_EightByteInt(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_EightByteInt

  integer, intent(in) :: ncid, varid
  integer(c_int64_t), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_long(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_long

    function my_get_varm_long(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_long

    function my_get_vars_long(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_long')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_long
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_long

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  integer(c_int64_t), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_long(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_long(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_long(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_EightByteInt = cstatus

end function nf90_get_var_7D_EightByteInt

function nf90_get_var_1D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_FourByteReal = cstatus

end function nf90_get_var_1D_FourByteReal

function nf90_get_var_2D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_FourByteReal = cstatus

end function nf90_get_var_2D_FourByteReal

function nf90_get_var_3D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_FourByteReal = cstatus

end function nf90_get_var_3D_FourByteReal

function nf90_get_var_4D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_FourByteReal = cstatus

end function nf90_get_var_4D_FourByteReal

function nf90_get_var_5D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_FourByteReal = cstatus

end function nf90_get_var_5D_FourByteReal

function nf90_get_var_6D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_FourByteReal = cstatus

end function nf90_get_var_6D_FourByteReal

function nf90_get_var_7D_FourByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_FourByteReal

  integer, intent(in) :: ncid, varid
  real(c_float), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_float(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_float

    function my_get_varm_float(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_float

    function my_get_vars_float(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_float')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_float
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_float

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_float), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_float(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_float(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_float(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_FourByteReal = cstatus

end function nf90_get_var_7D_FourByteReal

function nf90_get_var_1D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_1D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_1D_EightByteReal = cstatus

end function nf90_get_var_1D_EightByteReal

function nf90_get_var_2D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_2D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_2D_EightByteReal = cstatus

end function nf90_get_var_2D_EightByteReal

function nf90_get_var_3D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_3D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_3D_EightByteReal = cstatus

end function nf90_get_var_3D_EightByteReal

function nf90_get_var_4D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_4D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_4D_EightByteReal = cstatus

end function nf90_get_var_4D_EightByteReal

function nf90_get_var_5D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_5D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_5D_EightByteReal = cstatus

end function nf90_get_var_5D_EightByteReal

function nf90_get_var_6D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_6D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_6D_EightByteReal = cstatus

end function nf90_get_var_6D_EightByteReal

function nf90_get_var_7D_EightByteReal(ncid, varid, values, start, count, stride, map)

  use, intrinsic :: iso_c_binding

  implicit none

  integer :: nf90_get_var_7D_EightByteReal

  integer, intent(in) :: ncid, varid
  real(c_double), target, dimension(:,:,:,:,:,:,:), intent(out) :: values
  integer, dimension(:), optional, intent(in) :: start, count, stride, map

  interface

    function my_get_vara_double(ncid, varid, startp, countp, ip) bind(c, name='nc_get_vara_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: ip
    end function my_get_vara_double

    function my_get_varm_double(ncid, varid, startp, countp, stridep, mapp, ip) bind(c, name='nc_get_varm_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vara_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: mapp
      type(c_ptr), value    :: ip
    end function my_get_varm_double

    function my_get_vars_double(ncid, varid, startp, countp, stridep, ip) bind(c, name='nc_get_vars_double')
      use, intrinsic :: iso_c_binding, only: c_int, c_ptr
      integer(c_int)        :: my_get_vars_double
      integer(c_int), value :: ncid
      integer(c_int), value :: varid
      type(c_ptr), value    :: startp
      type(c_ptr), value    :: countp
      type(c_ptr), value    :: stridep
      type(c_ptr), value    :: ip
    end function my_get_vars_double

  end interface

  integer(c_int) :: cncid, cvarid, cstatus

  real(c_double), dimension(:,:,:,:,:,:,:), pointer :: farrayp
  type(c_ptr) :: carrayp

  integer(c_size_t), target, dimension(7) :: localStart, localCount
  integer(c_ptrdiff_t), target, dimension(7) :: localStride, localMap

  type(c_ptr) :: startp, countp, stridep, mapp

  integer :: numDims, numSize, numSizeP1, counter

  integer(c_size_t) :: totalLocalCount
  integer :: i, j
  integer(c_size_t) :: t1
  integer(c_ptrdiff_t) :: t2

  cstatus = 0

  cncid  = ncid
  cvarid = varid - 1 ! subtract 1 to get c varid

  ! Set local arguments to default values
  numDims = size(shape(values))
  if (present(start)) numDims = size(start)
  localStart(:) = 0
  localCount(:numDims) = shape(values)
  localCount(numDims+1:) = 1
  localStride(:) = 1

  totalLocalCount = 1
  do counter = 1, numDims
    localMap(counter) = totalLocalCount
    if (counter == numDims) exit
    totalLocalCount = totalLocalCount * localCount(counter)
  enddo

  if (present(start))  localStart (:numDims) = start(:)-1
  if (present(count))  localCount (:numDims) = count(:)
  if (present(stride)) localStride(:numDims) = stride(:)
  if (present(map))    localMap(:numDims) = map(:)

  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localStart(i)
    localStart(i) = localStart(j)
    localStart(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t1 = localCount(i)
    localCount(i) = localCount(j)
    localCount(j) = t1
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localStride(i)
    localStride(i) = localStride(j)
    localStride(j) = t2
  enddo
  do i = 1, numDims/2
    j = numDims - i + 1
    t2 = localMap(i)
    localMap(i) = localmap(j)
    localMap(j) = t2
  enddo

  farrayp => values
  carrayp = c_loc(farrayp) 

  startp = c_loc(localStart)
  countp = c_loc(localCount)

  if (present(stride)) then
    stridep = c_loc(localStride)
    if (present(map)) then
      mapp = c_loc(localMap)
      cstatus = my_get_varm_double(cncid, cvarid, startp, countp, stridep, mapp, carrayp)
    else
      cstatus = my_get_vars_double(cncid, cvarid, startp, countp, stridep, carrayp)
    endif
  else
    cstatus = my_get_vara_double(cncid, cvarid, startp, countp, carrayp)
  end if

  call c_f_pointer(carrayp, farrayp, shape(values))

  nf90_get_var_7D_EightByteReal = cstatus

end function nf90_get_var_7D_EightByteReal

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some 4D pressure and
! temperatures. The data file read by this program is produced by
! the companion program pres_temp_4D_wr.f90. It is intended to
! illustrate the use of the netCDF Fortran 90 API.

! This program is part of the netCDF tutorial:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

! Full documentation of the netCDF Fortran 90 API can be found at:
! http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f90

! $Id: pres_temp_4D_rd.f90,v 1.9 2010/04/06 19:32:09 ed Exp $

program pres_temp_4D_rd
  use netcdf
  implicit none
  
  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "pres_temp_4D.nc"
  integer :: ncid

  ! We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"

  ! The start and count arrays will tell the netCDF library where to
  ! read our data.
  integer :: start(NDIMS), count(NDIMS)

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude variables which will hold the actual
  ! latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will read surface temperature and pressure fields. In netCDF
  ! terminology these are called "variables."
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa", TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will read in. We will only
  ! need enough space to hold one timestep of data; one record.
  ! Allocate memory for data.
  real, dimension(:,:,:), allocatable :: pres_in
  real, dimension(:,:,:), allocatable :: temp_in
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS, NLVLS))
  allocate(temp_in(NLONS, NLATS, NLVLS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )
  
  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read 1 record of NLONS*NLATS*NLVLS values, starting at the beginning 
  ! of the record (the (1, 1, 1, rec) element in the netCDF file).
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Read the surface pressure and temperature data from the file, one
  ! record at a time.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_get_var(ncid, pres_varid, pres_in, start = start, &
                              count = count) )
     call check( nf90_get_var(ncid, temp_varid, temp_in, start, count) )
     
     i = 0
     do lvl = 1, NLVLS
        do lat = 1, NLATS
           do lon = 1, NLONS
              if (pres_in(lon, lat, lvl) /= SAMPLE_PRESSURE + i) stop 2
              if (temp_in(lon, lat, lvl) /= SAMPLE_TEMP + i) stop 2
              i = i + 1
           end do
        end do
     end do
     ! next record
  end do
         
  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program pres_temp_4D_rd

C     This is part of the netCDF package.
C     Copyright 2007 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 user defined types from fortran.

C     Ed Hartnett, 2009

      program ftst_types3
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_types3.nc')

C     We are writing 2D data, a 3 x 2 grid. 
      integer NDIMS
      parameter (NDIMS = 2)
      integer dim_sizes(NDIMS)
      integer NX, NY
      parameter (NX = 3, NY = 2)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer cmp_typeid, typeid_in
      integer x_dimid, y_dimid
      integer typeids(1)
      integer grpid, sub_grpid

C     Info about the groups we'll create.
      character*(*) group_name, sub_group_name
      parameter (group_name = 'you_drive_me_crazy')
      parameter (sub_group_name = 'baby_Im_so_into_you')

C     Info about the type we'll create.
      integer size_in, base_type_in, nfields_in, class_in
      character*80 name_in
      character*(*) type_name, field_name
      parameter (type_name = 'I_just_want_to_have_some_fun')
      parameter (field_name = 'Ill_tell_it_to_the_world')
      integer ntypes
      integer cmp_size
      parameter (cmp_size = 4)
      integer offset_in, field_typeid_in, ndims_in, dim_sizes_in(NDIMS)

C     Loop indexes, and error handling.
      integer x, y, retval

      print *, ''
      print *,'*** Testing netCDF-4 user-defined types and groups.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a group and a subgroup.
      retval = nf_def_grp(ncid, group_name, grpid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_grp(grpid, sub_group_name, sub_grpid)
      if (retval .ne. nf_noerr) stop 1

C     Define a compound type in the root group.
      retval = nf_def_compound(ncid, cmp_size, type_name, 
     &     cmp_typeid)
      if (retval .ne. nf_noerr) stop 1

C     Include a float.
      retval = nf_insert_compound(ncid, cmp_typeid, field_name, 0, 
     &     NF_FLOAT)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find the type.
      retval = nf_inq_typeids(ncid, ntypes, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (ntypes .ne. 1 .or. typeids(1) .ne. cmp_typeid) stop 2
      
C     Check the type.
      retval = nf_inq_user_type(ncid, typeids(1), name_in, size_in, 
     &     base_type_in, nfields_in, class_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. cmp_size .or. nfields_in .ne. 1 .or. 
     &     class_in .ne. NF_COMPOUND) stop 31

C     Check the first field of the compound type.
      retval = nf_inq_compound_field(ncid, typeids(1), 1, name_in, 
     &     offset_in, field_typeid_in, ndims_in, dim_sizes_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(field_name)) .ne. field_name .or. 
     &     offset_in .ne. 0 .or. field_typeid_in .ne. NF_FLOAT .or. 
     &     ndims_in .ne. 0) stop 19

C     Go to a child group and find the id of our type.
      retval = nf_inq_grp_ncid(ncid, group_name, sub_grpid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_inq_typeid(sub_grpid, type_name, typeid_in)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_inq_user_type(sub_grpid, typeid_in, name_in, size_in, 
     &     base_type_in, nfields_in, class_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. cmp_size .or. nfields_in .ne. 1 .or. 
     &     class_in .ne. NF_COMPOUND) stop 22
      


C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     Tests new nf90_inq_path function
!     Mimics tests in C tst_files5.c code

!     Ed Hartnett, 2011
program f90tst_nc4
  use typeSizes
  use netcdf
  implicit none
  integer :: fh, dimid, varid, ndim, nvar
  character (len = *), parameter :: FILE_NAME = "f90tst_nc4.nc"

  print *, ''
  print *,'*** testing simple netCDF-4 file.'

  call check(nf90_create(FILE_NAME, NF90_NETCDF4, fh))
  call check(nf90_def_dim(fh, 'fred', 10, dimid))
  call check(nf90_def_var(fh, 'john', NF90_INT, (/dimid/), varid))
  call check(nf90_close(fh))
  
  ! Check the file.
  call check(nf90_open(FILE_NAME, NF90_WRITE, fh))
  call check(nf90_inquire(fh, nDimensions = ndim, nVariables = nvar))
  if (nvar .ne. 1 .or. ndim .ne. 1) stop 3
  call check(nf90_close(fh))
  print *,'*** OK!'

  print *,'*** Testing simple classic file.'

  call check(nf90_create(FILE_NAME, NF90_CLOBBER, fh))
  call check(nf90_def_dim(fh, 'fred', 10, dimid))
  call check(nf90_def_var(fh, 'john', NF90_INT, (/dimid/), varid))
  call check(nf90_close(fh))
  
  ! Check the file.
  call check(nf90_open(FILE_NAME, NF90_WRITE, fh))
  call check(nf90_inquire(fh, nDimensions = ndim, nVariables = nvar))
  if (nvar .ne. 1 .or. ndim .ne. 1) stop 3
  call check(nf90_close(fh))
  print *,'*** OK!'

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_nc4

C     This is part of the netCDF package.
C     Copyright 2007 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 user defined types from fortran.

C     Ed Hartnett, 2009

      program ftst_types
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_types.nc')

C     We are writing 2D data, a 6 x 12 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer wind_typeid
      integer x_dimid, y_dimid
      integer typeids(1)

C     Info about the type we'll create.
      integer size_in, base_type_in, nfields_in, class_in
      character*80 name_in
      character*(*) type_name, u_name, v_name
      parameter (type_name = 'wind_t', u_name = 'U', v_name = 'V')
      integer ntypes
      integer WIND_T_SIZE
      parameter (WIND_T_SIZE = 8)
      integer offset_in, field_typeid_in, ndims_in, dim_sizes_in(1)

C     This is the data array we will write, and a place to store it when
C     we read it back in.
      integer data_out(NY, NX), data_in(NY, NX)

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = (x - 1) * NY + (y - 1)
         end do
      end do

      print *, ''
      print *,'*** Testing netCDF-4 compound type from F77.'

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) stop 1

C     Define a compound type.
      retval = nf_def_compound(ncid, WIND_T_SIZE, type_name, 
     &     wind_typeid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_insert_compound(ncid, wind_typeid, u_name, 0, NF_INT)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_insert_compound(ncid, wind_typeid, v_name, 4, NF_INT)
      if (retval .ne. nf_noerr) stop 1

C     Check out my new type.
      retval = nf_inq_typeids(ncid, ntypes, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (ntypes .ne. 1) stop 2
      if (typeids(1) .ne. wind_typeid) stop 2

C     Define the variable. 
      dimids(2) = x_dimid
      dimids(1) = y_dimid
      retval = nf_def_var(ncid, "data", NF_INT, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) stop 1

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find the type.
      retval = nf_inq_typeids(ncid, ntypes, typeids)
      if (retval .ne. nf_noerr) stop 1
      if (ntypes .ne. 1 .or. typeids(1) .ne. wind_typeid) stop 2
      
C     Check the type.
      retval = nf_inq_user_type(ncid, typeids(1), name_in, size_in, 
     &     base_type_in, nfields_in, class_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. WIND_T_SIZE .or. nfields_in .ne. 2 .or.
     &     class_in .ne. NF_COMPOUND) stop 2

C     Check it differently.
      retval = nf_inq_compound(ncid, typeids(1), name_in, size_in, 
     &     nfields_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name .or. 
     &     size_in .ne. WIND_T_SIZE .or. nfields_in .ne. 2) stop 2

C     Check it one piece at a time.
      retval = nf_inq_compound_nfields(ncid, typeids(1), nfields_in)
      if (retval .ne. nf_noerr) stop 1
      if (nfields_in .ne. 2) stop 2
      retval = nf_inq_compound_size(ncid, typeids(1), size_in)
      if (retval .ne. nf_noerr) stop 1
      if (size_in .ne. WIND_T_SIZE) stop 2
      retval = nf_inq_compound_name(ncid, typeids(1), name_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(type_name)) .ne. type_name) stop 2

C     Check the first field of the compound type.
      retval = nf_inq_compound_field(ncid, typeids(1), 1, name_in, 
     &     offset_in, field_typeid_in, ndims_in, dim_sizes_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(u_name)) .ne. u_name .or. offset_in .ne. 0 .or.
     &     field_typeid_in .ne. NF_INT .or. ndims_in .ne. 0) stop 2
      retval = nf_inq_compound_fieldname(ncid, typeids(1), 1, name_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(u_name)) .ne. u_name) stop 2
      retval = nf_inq_compound_fieldoffset(ncid, typeids(1), 1, 
     &     offset_in)
      if (retval .ne. nf_noerr) stop 1
      if (offset_in .ne. 0) stop 2
      retval = nf_inq_compound_fieldtype(ncid, typeids(1), 1, 
     &     field_typeid_in)
      if (retval .ne. nf_noerr) stop 1
      if (field_typeid_in .ne. NF_INT) stop 2
      retval = nf_inq_compound_fieldndims(ncid, typeids(1), 1, 
     &     ndims_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 0) stop 2
      
C     Check the second field of the compound type.
      retval = nf_inq_compound_field(ncid, typeids(1), 2, name_in, 
     &     offset_in, field_typeid_in, ndims_in, dim_sizes_in)
      if (retval .ne. nf_noerr) stop 1
      if (name_in(1:len(v_name)) .ne. v_name .or. offset_in .ne. 4 .or.
     &     field_typeid_in .ne. NF_INT .or. ndims_in .ne. 0) stop 2
      
C     Find our variable.
      retval = nf_inq_varid(ncid, "data", varid)
      if (retval .ne. nf_noerr) stop 1
      if (varid .ne. 1) stop 2

C     Read the data and check it.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. data_out(y, x)) stop 2
         end do
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This example writes some surface pressure and temperatures. It is
C     intended to illustrate the use of the netCDF fortran 77 API. The
C     companion program sfc_pres_temp_rd.f shows how to read the netCDF
C     data file created by this program.

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program sfc_pres_temp_wr
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are writing 2D data, a 12 x 6 lon-lat grid. We will need two
C     netCDF dimensions.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')
      integer lon_dimid, lat_dimid

C     In addition to the latitude and longitude dimensions, we will also
C     create latitude and longitude netCDF variables which will hold the
C     actual latitudes and longitudes. Since they hold data about the
C     coordinate system, the netCDF term for these is: "coordinate
C     variables."
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)

C     We will write surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     It's good practice for each variable to carry a "units" attribute.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')

C     We will create some pressure and temperature data to write out.
      real pres_out(NLONS, NLATS), temp_out(NLONS, NLATS)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     Loop indices.
      integer lat, lon

C     Error handling.
      integer retval

C     Create pretend data. If this were not an example program, we would
C     have some real data to write, for example, model output.
      do lat = 1, NLATS
         lats(lat) = START_LAT + (lat - 1) * 5.0
      end do
      do lon = 1, NLONS
         lons(lon) = START_LON + (lon - 1) * 5.0
      end do
      do lon = 1, NLONS
         do lat = 1, NLATS
            pres_out(lon, lat) = SAMPLE_PRESSURE + 
     +           (lon - 1) * NLATS + (lat - 1)
            temp_out(lon, lat) = SAMPLE_TEMP + 
     +           .25 * ((lon - 1) * NLATS + (lat - 1))
         end do
      end do

C     Create the file. 
      retval = nf_create(FILE_NAME, nf_clobber, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the dimensions.
      retval = nf_def_dim(ncid, LAT_NAME, NLATS, lat_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_dim(ncid, LON_NAME, NLONS, lon_dimid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the coordinate variables. They will hold the coordinate
C     information, that is, the latitudes and longitudes. A varid is
C     returned for each.
      retval = nf_def_var(ncid, LAT_NAME, NF_REAL, 1, lat_dimid, 
     +     lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, LON_NAME, NF_REAL, 1, lon_dimid, 
     +     lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to coordinate var data. This attaches a
C     text attribute to each of the coordinate variables, containing the
C     units.
      retval = nf_put_att_text(ncid, lat_varid, UNITS, len(LAT_UNITS), 
     +     LAT_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, lon_varid, UNITS, len(LON_UNITS), 
     +     LON_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Define the netCDF variables. The dimids array is used to pass the
C     dimids of the dimensions of the netCDF variables.
      dimids(1) = lon_dimid
      dimids(2) = lat_dimid
      retval = nf_def_var(ncid, PRES_NAME, NF_REAL, NDIMS, dimids, 
     +     pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_def_var(ncid, TEMP_NAME, NF_REAL, NDIMS, dimids, 
     +     temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Assign units attributes to the pressure and temperature netCDF
C     variables.
      retval = nf_put_att_text(ncid, pres_varid, UNITS, len(PRES_UNITS), 
     +     PRES_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_att_text(ncid, temp_varid, UNITS, len(TEMP_UNITS), 
     +     TEMP_UNITS)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     End define mode.
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the coordinate variable data. This will put the latitudes
C     and longitudes of our data grid into the netCDF file.
      retval = nf_put_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Write the pretend data. This will write our surface pressure and
C     surface temperature data. The arrays of data are the same size as
C     the netCDF variables we have defined.
      retval = nf_put_var_real(ncid, pres_varid, pres_out)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_put_var_real(ncid, temp_varid, temp_out)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)
   
C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS writing example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

C     Copyright 1996-2019, UCAR/Unidata
C     See COPYRIGHT file for copying and redistribution conditions.

C     Test driver for netCDF-3 interface.  This program performs tests against
C     the netCDF-3 specification for all user-level functions in an
C     implementation of the netCDF library.

C     Steve Emmerson, Ed Hartnett

      subroutine test(name, func)
      USE tests
      implicit none
      character*(*)   name
      external        func

      write(*, 1) name
 1    format(' *** testing ', a, ' ... ')
      nfails = 0
      call func()
      nfailsTotal = nfailsTotal + nfails
      if ( nfails .ne. 0) then
         print *, ' '
         print *, '  ### ', nfails, ' FAILURES TESTING ', name,
     +        '! ###'
C     continue the remaining tests, uncomment below to stop now
C     stop 2
      end if

      end

      program nf_test
      USE tests
      implicit none

      integer         status
      integer         i, num_cmode, err, dft_fmt
      integer         cmode(3)

      external        test_nf_strerror
      external        test_nf_open
      external        test_nf_close
      external        test_nf_inq
      external        test_nf_inq_dimid
      external        test_nf_inq_dim
      external        test_nf_inq_dimlen
      external        test_nf_inq_dimname
      external        test_nf_inq_varid
      external        test_nf_inq_var
      external        test_nf_inq_natts
      external        test_nf_inq_ndims
      external        test_nf_inq_nvars
      external        test_nf_inq_unlimdim
      external        test_nf_inq_format
      external        test_nf_inq_vardimid
      external        test_nf_inq_varname
      external        test_nf_inq_varnatts
      external        test_nf_inq_varndims
      external        test_nf_inq_vartype
      external        test_nf_get_var1_text
#if defined(NF_INT1_T)
      external        test_nf_get_var1_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_var1_int2
#endif
      external        test_nf_get_var1_int
      external        test_nf_get_var1_real
      external        test_nf_get_var1_double
      external        test_nf_get_var_text
#if defined(NF_INT1_T)
      external        test_nf_get_var_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_var_int2
#endif
      external        test_nf_get_var_int
      external        test_nf_get_var_real
      external        test_nf_get_var_double
      external        test_nf_get_vara_text
#if defined(NF_INT1_T)
      external        test_nf_get_vara_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_vara_int2
#endif
      external        test_nf_get_vara_int
      external        test_nf_get_vara_real
      external        test_nf_get_vara_double
      external        test_nf_get_vars_text
#if defined(NF_INT1_T)
      external        test_nf_get_vars_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_vars_int2
#endif
      external        test_nf_get_vars_int
      external        test_nf_get_vars_real
      external        test_nf_get_vars_double
      external        test_nf_get_varm_text
#if defined(NF_INT1_T)
      external        test_nf_get_varm_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_varm_int2
#endif
      external        test_nf_get_varm_int
      external        test_nf_get_varm_real
      external        test_nf_get_varm_double
      external        test_nf_get_att_text
#if defined(NF_INT1_T)
      external        test_nf_get_att_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_get_att_int2
#endif
      external        test_nf_get_att_int
      external        test_nf_get_att_real
      external        test_nf_get_att_double
      external        test_nf_inq_att
      external        test_nf_inq_attname
      external        test_nf_inq_attid
      external        test_nf_inq_attlen
      external        test_nf_inq_atttype
      external        test_nf_create
      external        test_nf_redef
      external        test_nf_enddef
      external        test_nf_sync
      external        test_nf_abort
      external        test_nf_def_dim
      external        test_nf_rename_dim
      external        test_nf_def_var
      external        test_nf_put_var1_text
#if defined(NF_INT1_T)
      external        test_nf_put_var1_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_var1_int2
#endif
      external        test_nf_put_var1_int
      external        test_nf_put_var1_real
      external        test_nf_put_var1_double
      external        test_nf_put_var_text
#if defined(NF_INT1_T)
      external        test_nf_put_var_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_var_int2
#endif
      external        test_nf_put_var_int
      external        test_nf_put_var_real
      external        test_nf_put_var_double
      external        test_nf_put_vara_text
#if defined(NF_INT1_T)
      external        test_nf_put_vara_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_vara_int2
#endif
      external        test_nf_put_vara_int
      external        test_nf_put_vara_real
      external        test_nf_put_vara_double
      external        test_nf_put_vars_text
#if defined(NF_INT1_T)
      external        test_nf_put_vars_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_vars_int2
#endif
      external        test_nf_put_vars_int
      external        test_nf_put_vars_real
      external        test_nf_put_vars_double
      external        test_nf_put_varm_text
#if defined(NF_INT1_T)
      external        test_nf_put_varm_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_varm_int2
#endif
      external        test_nf_put_varm_int
      external        test_nf_put_varm_real
      external        test_nf_put_varm_double
      external        test_nf_rename_var
      external        test_nf_put_att_text
#if defined(NF_INT1_T)
      external        test_nf_put_att_int1
#endif
#if defined(NF_INT2_T)
      external        test_nf_put_att_int2
#endif
      external        test_nf_put_att_int
      external        test_nf_put_att_real
      external        test_nf_put_att_double
      external        test_nf_copy_att
      external        test_nf_rename_att
      external        test_nf_del_att
      external        test_nf_set_fill
      external        test_nf_set_default_format
      external        ignorefpe

      print *, ''
      print *, '*** Testing netCDF-3 Fortran 77 API.'
      call ignorefpe(1)

      testfile = 'test03.nc'
      scratch = 'scratch03.nc'

      nfailsTotal = 0
      progname = 'nf_test'
      max_nmpt = 8

      write(*, *) 'NetCDF version: ', nf_inq_libvers()

      num_cmode = 1
      cmode(1) = 0
#ifdef ENABLE_CDF5
      num_cmode = num_cmode + 1
      cmode(num_cmode) = nf_cdf5
#endif
#ifdef USE_NETCDF4
      num_cmode = num_cmode + 1
      cmode(num_cmode) = nf_netcdf4
#endif

      do i = 1, num_cmode

         if (cmode(i) .EQ. 0) then
            print*,"testing classic CDF-1 format"
#ifdef ENABLE_CDF5
         elseif (cmode(i) .EQ. nf_cdf5) then
            print*,"testing CDF-5 format"
#endif
#ifdef USE_NETCDF4
         elseif (cmode(i) .EQ. nf_netcdf4) then
            print*,"testing NetCDF-4 format"
#endif
         endif

C     /* Initialize global variables defining test file */
         call init_gvars

         call write_file(testfile)
         if (nfailsTotal .gt. 0) call udexit(1)

C     /* delete any existing scratch netCDF file */
         status = nf_delete(scratch)

C     /* Test read-only functions, using pregenerated test-file */
         call test('nf_strerror', test_nf_strerror)
         call test('nf_open', test_nf_open)
         call test('nf_close', test_nf_close)
         call test('nf_inq', test_nf_inq)
         call test('nf_inq_dimid', test_nf_inq_dimid)
         call test('nf_inq_dim', test_nf_inq_dim)
         call test('nf_inq_dimlen', test_nf_inq_dimlen)
         call test('nf_inq_dimname', test_nf_inq_dimname)
         call test('nf_inq_varid', test_nf_inq_varid)
         call test('nf_inq_var', test_nf_inq_var)
         call test('nf_inq_natts', test_nf_inq_natts)
         call test('nf_inq_ndims', test_nf_inq_ndims)
         call test('nf_inq_nvars', test_nf_inq_nvars)
         call test('nf_inq_unlimdim', test_nf_inq_unlimdim)
         call test('nf_inq_format', test_nf_inq_format)
         call test('nf_inq_vardimid', test_nf_inq_vardimid)
         call test('nf_inq_varname', test_nf_inq_varname)
         call test('nf_inq_varnatts', test_nf_inq_varnatts)
         call test('nf_inq_varndims', test_nf_inq_varndims)
         call test('nf_inq_vartype', test_nf_inq_vartype)
         call test('nf_get_var1_text', test_nf_get_var1_text)
#if defined(NF_INT1_T)
         call test('nf_get_var1_int1', test_nf_get_var1_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_var1_int2', test_nf_get_var1_int2)
#endif
         call test('nf_get_var1_int', test_nf_get_var1_int)
         call test('nf_get_var1_real', test_nf_get_var1_real)
         call test('nf_get_var1_double', test_nf_get_var1_double)
         call test('nf_get_var_text', test_nf_get_var_text)
#if defined(NF_INT1_T)
         call test('nf_get_var_int1', test_nf_get_var_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_var_int2', test_nf_get_var_int2)
#endif
         call test('nf_get_var_int', test_nf_get_var_int)
         call test('nf_get_var_real', test_nf_get_var_real)
         call test('nf_get_var_double', test_nf_get_var_double)
         call test('nf_get_vara_text', test_nf_get_vara_text)
#if defined(NF_INT1_T)
         call test('nf_get_vara_int1', test_nf_get_vara_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_vara_int2', test_nf_get_vara_int2)
#endif
         call test('nf_get_vara_int', test_nf_get_vara_int)
         call test('nf_get_vara_real', test_nf_get_vara_real)
         call test('nf_get_vara_double', test_nf_get_vara_double)
         call test('nf_get_vars_text', test_nf_get_vars_text)
#if defined(NF_INT1_T)
         call test('nf_get_vars_int1', test_nf_get_vars_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_vars_int2', test_nf_get_vars_int2)
#endif
         call test('nf_get_vars_int', test_nf_get_vars_int)
         call test('nf_get_vars_real', test_nf_get_vars_real)
         call test('nf_get_vars_double', test_nf_get_vars_double)
         call test('nf_get_varm_text', test_nf_get_varm_text)
#if defined(NF_INT1_T)
         call test('nf_get_varm_int1', test_nf_get_varm_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_varm_int2', test_nf_get_varm_int2)
#endif
         call test('nf_get_varm_int', test_nf_get_varm_int)
         call test('nf_get_varm_real', test_nf_get_varm_real)
         call test('nf_get_varm_double', test_nf_get_varm_double)
         call test('nf_get_att_text', test_nf_get_att_text)
#if defined(NF_INT1_T)
         call test('nf_get_att_int1', test_nf_get_att_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_get_att_int2', test_nf_get_att_int2)
#endif
         call test('nf_get_att_int', test_nf_get_att_int)
         call test('nf_get_att_real', test_nf_get_att_real)
         call test('nf_get_att_double', test_nf_get_att_double)
         call test('nf_inq_att', test_nf_inq_att)
         call test('nf_inq_attname', test_nf_inq_attname)
         call test('nf_inq_attid', test_nf_inq_attid)
         call test('nf_inq_attlen', test_nf_inq_attlen)
         call test('nf_inq_atttype', test_nf_inq_atttype)

C     /* Test write functions */
         call test('nf_create', test_nf_create)
         call test('nf_redef', test_nf_redef)
         call test('nf_enddef', test_nf_enddef)
         call test('nf_sync', test_nf_sync)
         call test('nf_abort', test_nf_abort)
         call test('nf_def_dim', test_nf_def_dim)
         call test('nf_rename_dim', test_nf_rename_dim)
         call test('nf_def_var', test_nf_def_var)
         call test('nf_put_var1_text', test_nf_put_var1_text)
#if defined(NF_INT1_T)
         call test('nf_put_var1_int1', test_nf_put_var1_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_var1_int2', test_nf_put_var1_int2)
#endif
         call test('nf_put_var1_int', test_nf_put_var1_int)
         call test('nf_put_var1_real', test_nf_put_var1_real)
         call test('nf_put_var1_double', test_nf_put_var1_double)
         call test('nf_put_var_text', test_nf_put_var_text)
#if defined(NF_INT1_T)
         call test('nf_put_var_int1', test_nf_put_var_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_var_int2', test_nf_put_var_int2)
#endif
         call test('nf_put_var_int', test_nf_put_var_int)
         call test('nf_put_var_real', test_nf_put_var_real)
         call test('nf_put_var_double', test_nf_put_var_double)
         call test('nf_put_vara_text', test_nf_put_vara_text)
#if defined(NF_INT1_T)
         call test('nf_put_vara_int1', test_nf_put_vara_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_vara_int2', test_nf_put_vara_int2)
#endif
         call test('nf_put_vara_int', test_nf_put_vara_int)
         call test('nf_put_vara_real', test_nf_put_vara_real)
         call test('nf_put_vara_double', test_nf_put_vara_double)
         call test('nf_put_vars_text', test_nf_put_vars_text)
#if defined(NF_INT1_T)
         call test('nf_put_vars_int1', test_nf_put_vars_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_vars_int2', test_nf_put_vars_int2)
#endif
         call test('nf_put_vars_int', test_nf_put_vars_int)
         call test('nf_put_vars_real', test_nf_put_vars_real)
         call test('nf_put_vars_double', test_nf_put_vars_double)
         call test('nf_put_varm_text', test_nf_put_varm_text)
#if defined(NF_INT1_T)
         call test('nf_put_varm_int1', test_nf_put_varm_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_varm_int2', test_nf_put_varm_int2)
#endif
         call test('nf_put_varm_int', test_nf_put_varm_int)
         call test('nf_put_varm_real', test_nf_put_varm_real)
         call test('nf_put_varm_double', test_nf_put_varm_double)
         call test('nf_rename_var', test_nf_rename_var)
         call test('nf_put_att_text', test_nf_put_att_text)
#if defined(NF_INT1_T)
         call test('nf_put_att_int1', test_nf_put_att_int1)
#endif
#if defined(NF_INT2_T)
         call test('nf_put_att_int2', test_nf_put_att_int2)
#endif
         call test('nf_put_att_int', test_nf_put_att_int)
         call test('nf_put_att_real', test_nf_put_att_real)
         call test('nf_put_att_double', test_nf_put_att_double)
         call test('nf_copy_att', test_nf_copy_att)
         call test('nf_rename_att', test_nf_rename_att)
         call test('nf_del_att', test_nf_del_att)
         call test('nf_set_fill', test_nf_set_fill)
         call test('nf_set_default_format',
     +        test_nf_set_default_format)

! reset default format, otherwise the remaining tests will use
! the one set in the last test
         err = nf_set_default_format(NF_FORMAT_CLASSIC, dft_fmt)
      enddo

      print *,'Total number of failures: ', nfailsTotal
      if (nfailsTotal .ne. 0) stop 2
      print *,'*** SUCCESS!'

      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some surface pressure and
C     temperatures. The data file read by this program is produced
C     comapnion program sfc_pres_temp_wr.f. It is intended to illustrate
C     the use of the netCDF fortran 77 API.

C     This program is part of the netCDF tutorial:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-tutorial

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     http://www.unidata.ucar.edu/software/netcdf/docs/netcdf-f77

C     $Id: sfc_pres_temp_rd.f,v 1.9 2007/02/14 20:59:20 ed Exp $

      program sfc_pres_temp_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are reading 2D data, a 12 x 6 lon-lat grid.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')
      integer lat_dimid, lon_dimid

C     For the lat lon coordinate netCDF variables.
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid

C     We will read surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid
      integer dimids(NDIMS)

C     To check the units attributes.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')
      integer MAX_ATT_LEN
      parameter (MAX_ATT_LEN = 80)
      character*(MAX_ATT_LEN) pres_units_in, temp_units_in
      character*(MAX_ATT_LEN) lat_units_in, lon_units_in
      integer att_len

C     Read the data into these arrays.
      real pres_in(NLONS, NLATS), temp_in(NLONS, NLATS)

C     These are used to calculate the values we expect to find.
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     We will learn about the data file and store results in these
C     program variables.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in

C     Loop indices
      integer lat, lon

C     Error handling
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     There are a number of inquiry functions in netCDF which can be
C     used to learn about an unknown netCDF file. NF_INQ tells how many
C     netCDF variables, dimensions, and global attributes are in the
C     file; also the dimension id of the unlimited dimension, if there
C     is one.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in, 
     +     unlimdimid_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     In this case we know that there are 2 netCDF dimensions, 4 netCDF
C     variables, no global attributes, and no unlimited dimension.
      if (ndims_in .ne. 2 .or. nvars_in .ne. 4 .or. ngatts_in .ne. 0 
     +     .or. unlimdimid_in .ne. -1) stop 2

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the surface pressure and temperature data from the file.
C     Since we know the contents of the file we know that the data
C     arrays in this program are the correct size to hold all the data.
      retval = nf_get_var_real(ncid, pres_varid, pres_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, temp_varid, temp_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data. It should be the same as the data we wrote.
      do lon = 1, NLONS
         do lat = 1, NLATS
             if (pres_in(lon, lat) .ne. SAMPLE_PRESSURE +
     +           (lon - 1) * NLATS + (lat - 1)) stop 2
             if (temp_in(lon, lat) .ne. SAMPLE_TEMP +
     +           .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
         end do
      end do

C     Each of the netCDF variables has a "units" attribute. Let's read
C     them and check them.

      retval = nf_get_att_text(ncid, lat_varid, UNITS, lat_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lat_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lat_units_in(1:att_len) .ne. LAT_UNITS) stop 2
 
      retval = nf_get_att_text(ncid, lon_varid, UNITS, lon_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lon_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lon_units_in(1:att_len) .ne. LON_UNITS) stop 2

      retval = nf_get_att_text(ncid, pres_varid, UNITS, pres_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, pres_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (pres_units_in(1:att_len) .ne. PRES_UNITS) stop 2

      retval = nf_get_att_text(ncid, temp_varid, UNITS, temp_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, temp_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (temp_units_in(1:att_len) .ne. TEMP_UNITS) stop 2

C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

! This is part of the netCDF-4 fortran 90 API. Copyright 2020, UCAR
!
! This file makes visible all the public functions added for
! netCDF-4.
!
! Ed Hartnett, Dennis Heimbigner
  
public :: nf90_create_par, nf90_open_par, nf90_var_par_access, &
     nf90_inq_ncid, nf90_inq_grps, nf90_inq_grp_ncid, nf90_inq_grp_full_ncid, nf90_inq_grpname, &
     nf90_inq_grpname_full, nf90_inq_grpname_len, nf90_inq_varids, nf90_inq_grp_parent, &
     nf90_inq_dimids, nf90_inq_typeids, nf90_def_grp, nf90_def_compound, &
     nf90_insert_compound, nf90_insert_array_compound, nf90_inq_type, &
     nf90_inq_compound, nf90_inq_compound_name, nf90_inq_compound_size, &
     nf90_inq_compound_nfields, nf90_inq_compound_field, &
     nf90_inq_compound_fieldname, nf90_inq_compound_fieldindex, &
     nf90_inq_compound_fieldoffset, nf90_inq_compound_fieldtype, &
     nf90_inq_compound_fieldndims, nf90_inq_cmp_fielddim_sizes, nf90_def_vlen, nf90_inq_vlen, &
     nf90_def_enum, nf90_insert_enum, nf90_inq_enum, nf90_inq_enum_member, nf90_inq_enum_ident, &
     nf90_def_opaque, nf90_inq_opaque, nf90_def_var_deflate, nf90_inq_var_deflate, &
     nf90_def_var_fletcher32, nf90_inq_var_fletcher32, nf90_def_var_chunking, &
     nf90_inq_var_chunking, &
     nf90_def_var_fill, nf90_inq_var_fill, &
     nf90_def_var_endian, nf90_inq_var_endian, nf90_inq_user_type, &
     nf90_put_att_any, nf90_get_att_any, nf90_get_var_any, nf90_put_var_any, &
     nf90_rename_grp, nf90_def_var_filter, nf90_inq_var_filter, &
     nf90_def_var_szip, nf90_inq_var_szip, nf90_def_var_quantize, nf90_inq_var_quantize, &
     nf90_def_var_zstandard, nf90_inq_var_zstandard

      Module tests
!/*********************************************************************
! *   Copyright 1996, UCAR/Unidata
! *   See netcdf/COPYRIGHT file for copying and redistribution conditions.
! *   $Id: tests.inc,v 1.15 2007/01/19 16:08:47 ed Exp $
! *********************************************************************/

! Implementation of test.inc in a module
! Modified by: Richard Weed,Ph.D
!              Center for Advanced Vehicular Systems
!              Mississippi State University
!              rweed@cavs.msstate.edu

!!!!
! Do not tabify this unless you like hitting the 72 char limit !!!
!!!
#ifndef UD_TESTS_INC
#define UD_TESTS_INC


!/* The following prevents non-FORTRAN code from appearing in the output. */
#if defined(__osf__)
#   undef _POSIX_SOURCE
#   define _POSIX_SOURCE
#endif

#if defined(NO_NETCDF_2)
#  undef NO_NETCDF_2
#  define NO_NETCDF_2 1
#else
#define NO_NETCDF_2 1
#endif

#ifdef USE_NETCDF4
       USE netcdf4_f03
#else
       USE netcdf_f03
#endif
 
       Implicit NONE

       SAVE
!/* Parameters of test data */

#ifdef  NF_INT1_T
#   define NF_B 1
#else
#   define NF_B 0
#endif
#ifdef  NF_INT2_T
#   define NF_S 1
#else
#   define NF_S 0
#endif
! Total number of FORTRAN types:
       Integer, Parameter :: NUM_FORTRAN_TYPES = (3 + NF_S + NF_B)
#undef NF_B
#undef NF_S

      Integer, Parameter :: NTYPES=6
      Integer, Parameter :: NDIMS=5
      Integer, Parameter :: NVARS=136
      Integer, Parameter :: NRECS=2
      Integer, Parameter :: NGATTS=NTYPES
      Integer, Parameter :: RECDIM=1
      Integer, Parameter :: MAX_RANK=3
      Integer, Parameter :: MAX_NELS=64
      Integer, Parameter :: MAX_DIM_LEN=4
      Integer, Parameter :: MAX_NATTS=3


!/*
! * Limits of external types (based on those in ncx.h):
! */
      Integer, Parameter :: X_CHAR_MIN=0
      Integer, Parameter :: X_CHAR_MAX=127
      Integer, Parameter :: X_INT1_MIN=(-128)
      Integer, Parameter :: X_INT1_MAX=127
      Integer, Parameter :: X_INT2_MIN=(-32768)
      Integer, Parameter :: X_INT2_MAX=32767
      Integer, Parameter :: X_INT_MIN=(-2147483647-1)
      Integer, Parameter :: X_INT_MAX=2147483647
#if 0
      Real(RK4), Parameter :: X_REAL_MAX=3.4028234663852886e+38
#else
      Real(RK4), Parameter :: X_REAL_MAX=3.4028234663852886e+37
#endif
      Real(RK4), Parameter :: X_REAL_MIN=(-X_REAL_MAX)
#if 0
      Real(RK8), Parameter :: X_DOUBLE_MAX=1.7976931348623157E+308
#else
      Real(RK8), Parameter :: X_DOUBLE_MAX=1.7976931348623157D+200
#endif
      Real(RK8), Parameter :: X_DOUBLE_MIN=(-X_DOUBLE_MAX)

      Integer, Parameter :: X_BYTE_MIN=X_INT1_MIN
      Integer, Parameter :: X_BYTE_MAX=X_INT1_MAX
      Integer, Parameter :: X_SHORT_MIN=X_INT2_MIN
      Integer, Parameter :: X_SHORT_MAX=X_INT2_MAX
      Real(RK4), Parameter :: X_FLOAT_MIN=X_REAL_MIN
      Real(RK4), Parameter :: X_FLOAT_MAX=X_REAL_MAX


!/*
! * Examples of invalid argument values:
! */
      Integer, Parameter :: BAD_ID=-1
      Integer, Parameter :: BAD_DIMID=-1
      Integer, Parameter :: BAD_VARID=-2
      Integer, Parameter :: BAD_ATTNUM=-1
      Integer, Parameter :: BAD_TYPE=0
      Integer, Parameter :: BAD_FILLMODE=-1
      Character*3, Parameter :: BAD_NAME='a/b'


!/*
! * Internal data types:
! */
      Integer, Parameter :: NFT_UNSPECIFIED=0
      Integer, Parameter :: NFT_TEXT=16
      Integer, Parameter :: NFT_CHAR=NFT_TEXT
      Integer, Parameter :: NFT_INT1=17
      Integer, Parameter :: NFT_INT2=18
      Integer, Parameter :: NFT_INT=20
      Integer, Parameter :: NFT_REAL=36
      Integer, Parameter :: NFT_DOUBLE=40


!/*
! * Define a macro for trimming trailing blanks from character variables.
! */
#define TRIM(string) string(1:len_trim(string))


!
! FORTRAN GETARG() subroutine:
!
#ifdef __hpux
#   define      getarg  getarg_
#endif


#endif /* UD_TESTS_INC */


! #include "../fortran/netcdf.inc"


!    /* Global variables - filenames */

      CHARACTER(LEN=80) ::   testfile   !/* netCDF read-only test data */
      CHARACTER(LEN=80) ::   scratch    !/* netCDF test file for writing */

!    /* Global variables - command-line arguments */

      LOGICAL :: CREATE_FILE
      LOGICAL :: READONLY
      LOGICAL :: VERBOSE
      INTEGER :: NFAILS
      INTEGER :: MAX_NMPT        !/* max num messages per test */

!    /* Global variables - test data */

      CHARACTER(LEN=2)            :: DIM_NAME(NDIMS)
      INTEGER                     :: DIM_LEN(NDIMS)
      CHARACTER(LEN=(2+MAX_RANK)) :: VAR_NAME(NVARS)
      INTEGER                     :: VAR_TYPE(NVARS)
      INTEGER                     :: VAR_RANK(NVARS)
      INTEGER                     :: VAR_DIMID(MAX_RANK,NVARS)
      INTEGER                     :: VAR_SHAPE(MAX_RANK,NVARS)
      INTEGER                     :: VAR_NELS(NVARS)
      INTEGER                     :: VAR_NATTS(NVARS)
      CHARACTER(LEN=2)            :: ATTNAME(MAX_NATTS,NVARS)
      CHARACTER(LEN=2)            :: GATT_NAME(NGATTS)
      INTEGER                     :: ATTTYPE(NGATTS,NVARS)
      INTEGER                     :: GATT_TYPE(NGATTS)
      INTEGER                     :: ATTLEN(MAX_NATTS,NVARS)
      INTEGER                     :: GATT_LEN(NGATTS)

!    /* Miscellaneous global variables: */
      CHARACTER(LEN=80) :: PROGNAME        !/* name of the program */
      INTEGER           :: NFAILSTOTAL

!    /* Common blocks for global variables: */

!     COMMON    /LOGCOM/        CREATE_FILE,                            &
!    &                          READONLY,                               & 
!    &                          VERBOSE        

!     COMMON    /TXTCOM/        TESTFILE,                               &
!    &                          SCRATCH,                                &
!    &                          DIM_NAME,                               &
!    &                          VAR_NAME,                               &
!    &                          ATTNAME,                                &
!    &                          GATT_NAME,                              &
!    &                          PROGNAME

!     COMMON    /INTCOM/        NFAILS,                                 &  
!    &                          DIM_LEN,                                &
!    &                          VAR_TYPE,                               &
!    &                          VAR_RANK,                               &
!    &                          VAR_DIMID,                              &
!    &                          VAR_SHAPE,                              &
!    &                          VAR_NELS,                               &
!    &                          VAR_NATTS,                              &
!    &                          ATTTYPE,                                &
!    &                          GATT_TYPE,                              &
!    &                          ATTLEN,                                 &
!    &                          GATT_LEN,                               &
!    &                          MAX_NMPT,                               &
!    &                          NFAILSTOTAL


!    /* Functions for accessing attribute test data */
!    /* varid is -1 for NC_GLOBAL so can do global atts in same loop */

!/*      EXTERNAL       ATT_NAME */

      INTEGER, EXTERNAL           :: VARID
      INTEGER, EXTERNAL           :: NATTS
      CHARACTER(LEN=2), EXTERNAL  :: ATT_NAME
      INTEGER, EXTERNAL           :: ATT_TYPE
      INTEGER, EXTERNAL           :: ATT_LEN


      LOGICAL, EXTERNAL   :: INRANGE
      LOGICAL, EXTERNAL   :: INRANGE_UCHAR
      LOGICAL, EXTERNAL   :: INRANGE_FLOAT
      LOGICAL, EXTERNAL   :: INRANGE3
      LOGICAL, EXTERNAL   :: IN_INTERNAL_RANGE
      LOGICAL, EXTERNAL   :: EQUAL
      LOGICAL, EXTERNAL   :: INT_VEC_EQ

      INTEGER, EXTERNAL   :: ROLL
      INTEGER, EXTERNAL   :: INDEX2INDEXES
      INTEGER, EXTERNAL   :: INDEX2NCINDEXES
      INTEGER, EXTERNAL   :: INDEXES2INDEX
      INTEGER, EXTERNAL   :: NC2DBL
      INTEGER, EXTERNAL   :: DBL2NC
!      INTEGER, EXTERNAL   :: LEN_TRIM
      REAL(RK8), EXTERNAL :: HASH
      REAL(RK8), EXTERNAL :: HASH4
      REAL(RK8), EXTERNAL :: HASH_TEXT
      REAL(RK8), EXTERNAL :: HASH_INT1
      REAL(RK8), EXTERNAL :: HASH_INT2
      REAL(RK8), EXTERNAL :: HASH_INT
      REAL(RK8), EXTERNAL :: HASH_REAL
      REAL(RK8), EXTERNAL :: HASH_DOUBLE
      REAL(RK8), EXTERNAL :: INTERNAL_MIN
      REAL(RK8), EXTERNAL :: INTERNAL_MAX
      REAL(RK8), EXTERNAL :: EXTERNAL_MIN
      REAL(RK8), EXTERNAL :: EXTERNAL_MAX

      End Module tests

C     This is part of the netCDF package.
C     Copyright 2020 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 szip compression. This test is only
C     run if nc_def_var_szip() is found in netcdf-c, and also the HDF5
C     instance upon which the netcdf-c depends was built with szip.

C     Ed Hartnett, 1/31/20

      program ftst_var_szip
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='ftst_var_szip.nc')
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer check_file

      integer ncid, varid(NVARS), dimids(NDIMS)
      integer data_len_in, offset
      parameter (offset = 20)
      integer data1(DATA_LEN), data1_in(DATA_LEN)
      character*(4) var_name(NVARS)
      character*(4) dim_name
      parameter (dim_name = 'dim1')
      integer NO_FILL, MY_FILL_VALUE
      parameter (NO_FILL = 1)
      parameter (MY_FILL_VALUE = 42)

C     Loop index and error handling.
      integer x, retval

      print *, ''
      print *,'*** Testing szip compression.'

C     Prepare some data to write.
      do x = 1, DATA_LEN
         data1(x) = x
      end do

C     Set up var names.
      var_name(1) = 'var1'
      var_name(2) = 'var2'
      var_name(3) = 'var3'

C      retval = nf_set_log_level(3)

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Create a dimension.
      retval = nf_def_dim(ncid, dim_name, DIM_LEN, dimids(1))
      if (retval .ne. nf_noerr) stop 1

C     Create a few integer variables.
      do x = 1, NVARS      
         retval = nf_def_var(ncid, var_name(x), NF_INT, NDIMS, dimids,
     $        varid(x))
         if (retval .ne. nf_noerr) stop 1
      end do

C     Set an alternative fill value for the third variable.
      retval = nf_def_var_fill(ncid, varid(3), 0, MY_FILL_VALUE)
      if (retval .ne. 0) stop 3

C     Turn on szip compression for var 1.
      retval = nf_def_var_szip(ncid, varid(1),
     $     nf_szip_ec_option_mask, 4)
      if (retval .ne. 0) stop 3

C     Turn on szip compression for var 3.
      retval = nf_def_var_szip(ncid, varid(3),
     $     nf_szip_nn_option_mask, 4)
      if (retval .ne. 0) stop 3

C     Write some data.
      retval = nf_put_var_int(ncid, varid(1), data1)
      if (retval .ne. nf_noerr) stop 1

C     Close the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Check it out. 
      retval = check_file(ncid, var_name, dim_name)
      if (retval .ne. 0) stop 4

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This function check the file to make sure everything is OK.
      integer function check_file(ncid, var_name, dim_name)
      implicit none
      include 'netcdf.inc'

C     I need these in both here and the main program.
      integer NDIMS
      parameter (NDIMS = 1)
      integer DIM_LEN
      parameter (DIM_LEN = 22)
      integer NVARS
      parameter (NVARS = 3)
      integer DATA_LEN
      parameter (DATA_LEN = 22)
      integer MY_FILL_VALUE
      parameter (MY_FILL_VALUE = 42)

C     Parameters
      integer ncid
      character*(4) var_name(NVARS)
      character*(4) dim_name

C     Values that are read in, to check the file.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in
      integer xtype_in, dimids_in(NDIMS), natts_in
      integer varid_in(NVARS), dimid_in, no_fill_in, fill_value_in
      character*(4) var_name_in
      integer int_data_in(DIM_LEN)
      integer options_mask_in, pixels_per_block_in

      integer x, retval

C     Check it out.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in,
     $     unlimdimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (ndims_in .ne. 1 .or. nvars_in .ne. NVARS .or. ngatts_in .ne. 0
     $     .or. unlimdimid_in .ne. -1) stop 5

C     Get the varids and the dimid.
      do x = 1, NVARS      
         retval = nf_inq_varid(ncid, var_name(x), varid_in(x))
         if (retval .ne. nf_noerr) stop 1
         if (varid_in(x) .ne. x) stop 6
      end do
      retval = nf_inq_dimid(ncid, dim_name, dimid_in)
      if (retval .ne. nf_noerr) stop 1
      if (dimid_in .ne. 1) stop 7

C     Get the data in var1. It will be values we have set.
      retval = nf_get_var_int(ncid, varid_in(1), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. x) stop 13
      end do

C     Get the szip settings for var1. H5Zszip code will sometimes bump
C     the bits_per_pixel from 32 to 64 and may add other flags to the
C     options_mask, so we don't check these values in this test.
      retval = nf_inq_var_szip(ncid, varid_in(1), options_mask_in,
     $     pixels_per_block_in)

C     Get the data in var2. It will be default fill value.
      retval = nf_get_var_int(ncid, varid_in(2), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. NF_FILL_INT) stop 13
      end do

C     Get the data in var3. It will be all the assigned fill value.
      retval = nf_get_var_int(ncid, varid_in(3), int_data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, DIM_LEN
         if (int_data_in(x) .ne. MY_FILL_VALUE) stop 14
      end do

      check_file = 0
      end 

! This program provides an elementary check of some of the parts of
! the Fortran 90 interface to netCDF 3.5. It is a Fortran 90
! implementation of the nctst.cpp program provided with the C++
! interface to netcdf (in the src/cxx directory of the netcdf
! distribution).
!
! Russ Rew
!
program netcdfTest
  use typeSizes
  use netcdf
  implicit none
  
  ! netcdf related variables
  integer :: ncFileID,                                   &
             latDimID, lonDimID, frTimeDimID, timeDimID, mxStrDimID, &
             pressVarID, latVarID, lonVarID, frTimeVarID, refTimeVarID, &
             scalarVarID, scalarStrVarID
             
  ! Local variables
  integer, parameter :: numLats = 4, numLons = 3, &
                        numFrTimes = 2, timeStringLen = 20, mxStrLen=80
  character (len = *), parameter :: fileName = "tst_f90.nc"
  integer :: fmt
  integer :: counter, i
  real, dimension(numLons, numLats, numFrTimes) :: pressure
  integer (kind = FourByteInt), dimension(numFrTimes) :: frTimeVals
  real (kind = FourByteReal) fillVal;
  real (kind = FourByteReal), dimension(2) :: validRange;
  character (len = 20) frTimeUnits
  character(len=mxStrLen) :: scalarString, scalarStrRead

  print *, ''
  print *,'*** Testing netCDF-3 Fortran 90 API.'

! --------------------
  ! Code begins
  ! --------------------
  if(.not. byteSizesOK()) then
    print *, "Compiler does not appear to support required kinds of variables."
    stop
  end if
    
  ! Create the file
  call check(nf90_create(path = trim(fileName), cmode = nf90_clobber, ncid = ncFileID))

  ! Check the format.
  call check(nf90_inq_format(ncFileID, fmt))
  if (fmt .ne. nf90_format_classic) stop 2
  
  ! Define the dimensions
  call check(nf90_def_dim(ncid = ncFileID, name = "lat",     len = numLats,        dimid = latDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "lon",     len = numLons,        dimid = lonDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "frtime",  len = nf90_unlimited, dimid = frTimeDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "timelen", len = timeStringLen,  dimid = timeDimID))
  call check(nf90_def_dim(ncid = ncFileID, name = "mxstrlen",len = mxStrLen,       dimid = mxStrDimID))

  ! Create variables and attributes
  call check(nf90_def_var(ncid = ncFileID, name = "P", xtype = nf90_float,     &
                     dimids = (/ lonDimID, latDimID, frTimeDimID /), varID = pressVarID) )
  call check(nf90_put_att(ncFileID, pressVarID, "long_name",   "pressure at maximum wind"))
  call check(nf90_put_att(ncFileID, pressVarID, "units",       "hectopascals") )
  ! Use 4-byte reals explicitly, to match 4-byte attribute type in test file
  validRange(1) = 0.
  validRange(2) = 1500
  call check(nf90_put_att(ncFileID, pressVarID, "valid_range", validRange))
  ! Use a 4-byte float constant, to match variable type
  fillVal = -9999.0
  call check(nf90_put_att(ncFileID, pressVarID,  "_FillValue", fillVal ) )
                      
  call check(nf90_def_var(ncFileID, "lat", nf90_float, dimids = latDimID, varID = latVarID) )
  call check(nf90_put_att(ncFileID, latVarID, "long_name", "latitude"))
  call check(nf90_put_att(ncFileID, latVarID, "units", "degrees_north"))

  call check(nf90_def_var(ncFileID, "lon", nf90_float, lonDimID, lonVarID) )
  call check(nf90_put_att(ncFileID, lonVarID, "long_name", "longitude"))
  call check(nf90_put_att(ncFileID, lonVarID, "units",     "degrees_east"))

  call check(nf90_def_var(ncFileID, "frtime", nf90_int, frTimeDimID, frTimeVarID) )
  call check(nf90_put_att(ncFileID, frTimeVarID, "long_name", "forecast time"))
  call check(nf90_put_att(ncFileID, frTimeVarID, "units",     "hours"))

  call check(nf90_def_var(ncFileID, "reftime", nf90_char, timeDimID, refTimeVarID) )
  call check(nf90_put_att(ncFileID, refTimeVarID, "long_name", "reference time"))
  call check(nf90_put_att(ncFileID, refTimeVarID, "units",     "text_time"))
                     
  ! In the C++ interface the define a scalar variable - do we know how to do this? 
  call check(nf90_def_var(ncFileID, "ScalarVariable", nf90_real, scalarVarID))

  ! Define a scalar string -- in a netCDF file it's a 1-D character array
  call check(nf90_def_var(ncFileID, "ScalarString", nf90_char, (/mxStrDimID/), scalarStrVarID))
  
  ! Global attributes
  call check(nf90_put_att(ncFileID, nf90_global, "history", &
                     "created by Unidata LDM from NPS broadcast"))
  call check(nf90_put_att(ncFileID, nf90_global, "title", &
                     "NMC Global Product Set: Pressure at Maximum Wind"))
  
  ! Leave define mode
  call check(nf90_enddef(ncfileID))
  
  ! Write the dimension variables
  call check(nf90_put_var(ncFileID, latVarId,     (/ -90., -87.5, -85., -82.5 /)) )
  call check(nf90_put_var(ncFileID, lonVarId,     (/ -180, -175, -170 /)      ) )
  ! Don't use anonymous array here, in case platform has 8-byte integers
  frTimeVals(1) = 12
  frTimeVals(2) = 18
  call check(nf90_put_var(ncFileID, frTimeVarId,  frTimeVals                  ) )
  call check(nf90_put_var(ncFileID, reftimeVarID, "1992-3-21 12:00"           ) )
  
  ! Write the pressure variable. Write a slab at a time to check incrementing.
  pressure = 949. + real(reshape( (/ (counter, counter = 1, numLats * numLons * numFrTimes) /),  &
                                    (/ numLons, numLats, numFrTimes /) ) )
  call check(nf90_put_var(ncFileID, pressVarID, pressure(:, :, 1:1)) )
  call check(nf90_put_var(ncFileID, pressVarID, pressure(:, :, 2:2), start = (/ 1, 1, 2 /)) )
  
  call check(nf90_put_var(ncFileID, scalarVarID, 10))

  ! Write a scalar string -- note that Fortran assignement adds blank fill
  scalarString = 'this is a blank padded string'
  call check(nf90_put_var(ncFileID, scalarStrVarID, scalarString))

  call check(nf90_close(ncFileID))

  ! Now open the file to read and check a few values
  call check(nf90_open(trim(fileName), NF90_NOWRITE, ncFileID))
  call check(nf90_inq_varid(ncFileID,"frtime",frTimeVarID))
  call check(nf90_get_att(ncFileID,frTimeVarID,"units",frTimeUnits))
  if(frTimeUnits .ne. "hours") then
     print *, 'Attribute value not what was written:', frTimeUnits
     stop 2
  endif
  call check(nf90_get_var(ncFileID, scalarStrVarID, scalarStrRead))
  if(scalarStrRead .ne. scalarString) then
     do i = 1, len(scalarString)
        if (scalarStrRead(i:i) .ne. scalarString(i:i)) exit
     end do
     print *, 'String written to file does not match string read from file.'
     print *, 'Position of first difference:', i, ' character written:', '"'//scalarString(i:i)//'"', &
                                                  ' character read:', '"'//scalarStrRead(i:i)//'"'
     stop 2
  endif

  call check(nf90_close(ncFileID))

  print *,'*** SUCCESS!'

contains
  ! Internal subroutine - checks error status after each netcdf, prints out text message each time
  !   an error code is returned. 
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program netcdfTest

! This is part of the netCDF package.
! Copyright 2006 University Corporation for Atmospheric Research/Unidata.
! See COPYRIGHT file for conditions of use.

! This is an example which reads some 4D pressure and
! temperatures. The data file read by this program is produced by
! the companion program pres_temp_4D_wr.f90. It is intended to
! illustrate the use of the netCDF Fortran 90 API.

! This program is part of the netCDF tutorial:
! https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

! Full documentation of the netCDF Fortran 90 API can be found at:
! https://docs.unidata.ucar.edu/netcdf-fortran/current/f90_The-NetCDF-Fortran-90-Interface-Guide.html

! Ed Hartnett

program pres_temp_4D_rd
  use netcdf
  implicit none
  
  ! This is the name of the data file we will read.
  character (len = *), parameter :: FILE_NAME = "pres_temp_4D.nc"
  integer :: ncid

  ! We are reading 4D data, a 12 x 6 x 2 lon-lat-lvl grid, with 2
  ! timesteps of data.
  integer, parameter :: NDIMS = 4, NRECS = 2
  integer, parameter :: NLVLS = 2, NLATS = 6, NLONS = 12
  character (len = *), parameter :: LVL_NAME = "level"
  character (len = *), parameter :: LAT_NAME = "latitude"
  character (len = *), parameter :: LON_NAME = "longitude"
  character (len = *), parameter :: REC_NAME = "time"

  ! The start and count arrays will tell the netCDF library where to
  ! read our data.
  integer :: start(NDIMS), count(NDIMS)

  ! In addition to the latitude and longitude dimensions, we will also
  ! create latitude and longitude variables which will hold the actual
  ! latitudes and longitudes. Since they hold data about the
  ! coordinate system, the netCDF term for these is: "coordinate
  ! variables."
  real :: lats(NLATS), lons(NLONS)
  integer :: lon_varid, lat_varid

  ! We will read surface temperature and pressure fields. In netCDF
  ! terminology these are called "variables."
  character (len = *), parameter :: PRES_NAME="pressure"
  character (len = *), parameter :: TEMP_NAME="temperature"
  integer :: pres_varid, temp_varid

  ! We recommend that each variable carry a "units" attribute.
  character (len = *), parameter :: UNITS = "units"
  character (len = *), parameter :: PRES_UNITS = "hPa", TEMP_UNITS = "celsius"
  character (len = *), parameter :: LAT_UNITS = "degrees_north"
  character (len = *), parameter :: LON_UNITS = "degrees_east"

  ! Program variables to hold the data we will read in. We will only
  ! need enough space to hold one timestep of data; one record.
  ! Allocate memory for data.
  real, dimension(:,:,:), allocatable :: pres_in
  real, dimension(:,:,:), allocatable :: temp_in
  real, parameter :: SAMPLE_PRESSURE = 900.0
  real, parameter :: SAMPLE_TEMP = 9.0

  ! Use these to calculate the values we expect to find.
  real, parameter :: START_LAT = 25.0, START_LON = -125.0

  ! Loop indices
  integer :: lvl, lat, lon, rec, i

  ! Allocate memory.
  allocate(pres_in(NLONS, NLATS, NLVLS))
  allocate(temp_in(NLONS, NLATS, NLVLS))

  ! Open the file. 
  call check( nf90_open(FILE_NAME, nf90_nowrite, ncid) )

  ! Get the varids of the latitude and longitude coordinate variables.
  call check( nf90_inq_varid(ncid, LAT_NAME, lat_varid) )
  call check( nf90_inq_varid(ncid, LON_NAME, lon_varid) )

  ! Read the latitude and longitude data.
  call check( nf90_get_var(ncid, lat_varid, lats) )
  call check( nf90_get_var(ncid, lon_varid, lons) )
  
  ! Check to make sure we got what we expected.
  do lat = 1, NLATS
     if (lats(lat) /= START_LAT + (lat - 1) * 5.0) stop 2
  end do
  do lon = 1, NLONS
     if (lons(lon) /= START_LON + (lon - 1) * 5.0) stop 2
  end do

  ! Get the varids of the pressure and temperature netCDF variables.
  call check( nf90_inq_varid(ncid, PRES_NAME, pres_varid) )
  call check( nf90_inq_varid(ncid, TEMP_NAME, temp_varid) )

  ! Read 1 record of NLONS*NLATS*NLVLS values, starting at the beginning 
  ! of the record (the (1, 1, 1, rec) element in the netCDF file).
  count = (/ NLONS, NLATS, NLVLS, 1 /)
  start = (/ 1, 1, 1, 1 /)

  ! Read the surface pressure and temperature data from the file, one
  ! record at a time.
  do rec = 1, NRECS
     start(4) = rec
     call check( nf90_get_var(ncid, pres_varid, pres_in, start = start, &
                              count = count) )
     call check( nf90_get_var(ncid, temp_varid, temp_in, start, count) )
     
     i = 0
     do lvl = 1, NLVLS
        do lat = 1, NLATS
           do lon = 1, NLONS
              if (pres_in(lon, lat, lvl) /= SAMPLE_PRESSURE + i) stop 2
              if (temp_in(lon, lat, lvl) /= SAMPLE_TEMP + i) stop 2
              i = i + 1
           end do
        end do
     end do
     ! next record
  end do
         
  ! Close the file. This frees up any internal netCDF resources
  ! associated with the file.
  call check( nf90_close(ncid) )

  ! If we got this far, everything worked as expected. Yipee! 
  print *,"*** SUCCESS reading example file ", FILE_NAME, "!"

contains
  subroutine check(status)
    integer, intent ( in) :: status
    
    if(status /= nf90_noerr) then 
      print *, trim(nf90_strerror(status))
      stop 2
    end if
  end subroutine check  
end program pres_temp_4D_rd

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     Tests new nf90_inq_path function
!     Mimics tests in C tst_files5.c code

!     Ed Hartnett, 2011
program f90tst_nc4
  use typeSizes
  use netcdf
  implicit none
  integer :: fh, dimid, varid, ndim, nvar, fmt
  character (len = *), parameter :: FILE_NAME = "f90tst_nc4.nc"

  print *, ''
  print *,'*** testing simple netCDF-4 file.'

  call check(nf90_create(FILE_NAME, NF90_NETCDF4, fh))
  call check(nf90_inq_format(fh, fmt))
  if (fmt .ne. nf90_format_netcdf4) stop 4
  call check(nf90_def_dim(fh, 'fred', 10, dimid))
  call check(nf90_def_var(fh, 'john', NF90_INT, (/dimid/), varid))
  call check(nf90_close(fh))
  
  ! Check the file.
  call check(nf90_open(FILE_NAME, NF90_WRITE, fh))
  call check(nf90_inq_format(fh, fmt))
  if (fmt .ne. nf90_format_netcdf4) stop 5
  call check(nf90_inquire(fh, nDimensions = ndim, nVariables = nvar))
  if (nvar .ne. 1 .or. ndim .ne. 1) stop 3
  call check(nf90_close(fh))
  print *,'*** OK!'

  print *,'*** Testing simple classic file.'

  call check(nf90_create(FILE_NAME, NF90_CLOBBER, fh))
  call check(nf90_inq_format(fh, fmt))
  if (fmt .ne. nf90_format_classic) stop 6
  call check(nf90_def_dim(fh, 'fred', 10, dimid))
  call check(nf90_def_var(fh, 'john', NF90_INT, (/dimid/), varid))
  call check(nf90_close(fh))
  
  ! Check the file.
  call check(nf90_open(FILE_NAME, NF90_WRITE, fh))
  call check(nf90_inq_format(fh, fmt))
  if (fmt .ne. nf90_format_classic) stop 6
  call check(nf90_inquire(fh, nDimensions = ndim, nVariables = nvar))
  if (nvar .ne. 1 .or. ndim .ne. 1) stop 3
  call check(nf90_close(fh))
  print *,'*** OK!'

  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_nc4

!     This program tests reading NF90_STRING & NF90_CHAR attributes from fortran.
!     The ref input data structure is shown in ref_att.cdl
!     The ref input data can be generated by running "ncgen -o ref_att.nc ref_att.cdl"
!     For the input of this program, rename ref input data as "att.nc"
!
!     Cheng Da   2025/08/30
!
program f90tst_att
  use netcdf, only: NF90_NOWRITE,NF90_GLOBAL,nf90_open,nf90_close,&
                    nf90_inq_ncid, nf90_inq_varid,nf90_get_att
  implicit none

  integer :: fid, gid, vid
  integer :: ierr
  character(len=256) :: fname, str
  
  fname = "att.nc"
  call check(NF90_Open(TRIM(fname), NF90_NOWRITE, fid))
! read global att
  str=""; call check(nf90_get_att(fid, NF90_GLOBAL, "agency", str)) !NF90_CHAR att
  call verify_results(trim(str), "fake_agency", "get wrong global attr: agency", 10)
  str=""; call check(nf90_get_att(fid, NF90_GLOBAL, "author", str)) !NF90_STRING att
  call verify_results(trim(str), "fake_author", "get wrong global attr: author", 11)

! read var att
  call check(nf90_inq_varid(fid, "obstype", vid))
  str=""; call check(nf90_get_att(fid, vid, "long_name", str)) !NF90_STRING att
  call verify_results(trim(str), "observation type", "get wrong obstype attr: long_name", 12)
  str=""; call check(nf90_get_att(fid, vid, "units", str)) !NF90_CHAR att
  call verify_results(trim(str), "N/A", "get wrong obstype attr: units", 13)

! read var atts under group MetaData
  call check(nf90_inq_ncid(fid, "MetaData", gid))
  call check(nf90_inq_varid(gid,"latitude", vid))
  str=""; call check(nf90_get_att(gid, vid, "units", str)) ! NF90_STRING att
  call verify_results(trim(str), "degrees_north", "get wrong MetaData/latitude attr: units", 14)

! read var atts group yobs
  call check(nf90_inq_ncid(fid, "yobs", gid))
  call check(nf90_inq_varid(gid,"sst", vid))
  str=""; call check(nf90_get_att(gid, vid, "units", str)) ! NF90_STRING att
  call verify_results(trim(str), "C", "get wrong yobs/sst attr: units", 15)

! read var atts group Hx
  call check(nf90_inq_ncid(fid, "Hx", gid))
  call check(nf90_inq_varid(gid,"sst", vid))
  str=""; call check(nf90_get_att(gid, vid, "units", str)) ! NF90_CHAR att
  call verify_results(trim(str), "C", "get wrong Hx/sst attr: units", 16)
  call check(nf90_close(fid))
  print *,"*** SUCCESS!"

contains
subroutine check(errcode)
  use netcdf, only: NF90_NOERR, nf90_strerror
  implicit none
  integer, intent(in) :: errcode
  if(errcode /= NF90_NOERR) then
     print*, "Error: ", trim(nf90_strerror(errcode))
     stop (1)
   endif
end subroutine check

subroutine verify_results(input, ref, errmsg, errcode)
  implicit none 
  character(*),intent(in) :: input, ref, errmsg
  integer,intent(in) :: errcode
  if (trim(input) .ne. trim(ref)) then
     print*, "Error: "//trim(errmsg)
     print*, "       expect to get:"//trim(ref)
     print*, "        actually get:"//trim(input)
     stop (errcode)
  end if
end subroutine verify_results

end program f90tst_att

!     This is part of the netCDF package. Copyright 2006-2019
!     University Corporation for Atmospheric Research/Unidata. See
!     COPYRIGHT file for conditions of use.

!     This program tests netCDF-4 variable functions from fortran.

!     Ed Hartnett 2010/01/25

program f90tst_vars5
  use typeSizes
  use netcdf
  implicit none
  include "netcdf.inc"
  
  ! This is the name of the data file we will create.
  character (len = *), parameter :: FILE_NAME = "f90tst_vars5.nc"

  ! We are writing 2D data, a 6 x 12 grid. 
  integer, parameter :: NDIM1 = 1
  integer, parameter :: DIM_LEN_5 = 5
  integer start(NDIM1), count(NDIM1)
  real real_data(DIM_LEN_5)
  real*8 double_data(DIM_LEN_5)

  ! We need these ids and other gunk for netcdf.
  integer :: ncid, varid1, varid2, varid3, varid4, varid5, dimids(NDIM1)
  integer :: chunksizes(NDIM1), chunksizes_in(NDIM1)
  integer :: x_dimid, y_dimid
  integer :: nvars, ngatts, ndims, unlimdimid, file_format
  integer :: x, y
  integer, parameter :: DEFLATE_LEVEL = 4
  integer (kind = EightByteInt), parameter :: TOE_SAN_VALUE = 2147483648_EightByteInt
  character (len = *), parameter :: VAR1_NAME = "Chon-Ji"
  character (len = *), parameter :: VAR2_NAME = "Tan-Gun"
  character (len = *), parameter :: VAR3_NAME = "Toe-San"
  character (len = *), parameter :: VAR4_NAME = "Won-Hyo"
  character (len = *), parameter :: VAR5_NAME = "Yul-Guk"
  integer, parameter :: CACHE_SIZE = 8, CACHE_NELEMS = 571
  integer, parameter :: CACHE_PREEMPTION = 66
  integer :: ierr

  ! Information read back from the file to check correctness.
  integer :: varid1_in, varid2_in, varid3_in, varid4_in, varid5_in
  integer :: xtype_in, ndims_in, natts_in, dimids_in(NDIM1)
  character (len = nf90_max_name) :: name_in
  integer :: endianness_in, deflate_level_in
  logical :: shuffle_in, fletcher32_in, contiguous_in
  integer (kind = EightByteInt) :: toe_san_in
  integer :: cache_size_in, cache_nelems_in, cache_preemption_in
  integer :: quantize_mode_in, nsd_in
  real real_data_in(DIM_LEN_5)
  real*8 double_data_in(DIM_LEN_5)
  real diff
  real, parameter :: EPSILON  = .01
  ! Because values 4 and 5 of our data array are so large, a large
  ! epsilon is needed.
  real, parameter :: EPSILON_LARGE  = 1450000
  integer :: t, qmode, qnsd

  print *, ''
  print *,'*** Testing use of quantize feature on netCDF-4 vars from Fortran 90.'

  ! Create some pretend data.
  real_data(1) = 1.11111111
  real_data(2) = 1.0
  real_data(3) = 9.99999999
  real_data(4) = 12345.67
  real_data(5) = .1234567
  double_data(1) = 1.1111111
  double_data(2) = 1.0
  double_data(3) = 9.999999999
  double_data(4) = 1234567890.12345
  double_data(5) = 1234567890
  
  do t = 1, 3
     
     ! Create the netCDF file. 
     call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid, cache_nelems = CACHE_NELEMS, &
          cache_size = CACHE_SIZE))

     ! Define the dimension.
     call check(nf90_def_dim(ncid, "x", DIM_LEN_5, x_dimid))
     dimids =  (/ x_dimid /)

     ! Test with all three quantize modes.
     if (t .eq. 1) then
        qmode = nf90_quantize_bitgroom
        qnsd = 3
     else if (t .eq. 2) then
        qmode = nf90_quantize_granularbr
        qnsd = 3
     else
        qmode = nf90_quantize_bitround
        qnsd = 10
     endif

     print *,'\t*** testing with quantize_mode ',qmode
     
     ! Define some variables.
     call check(nf90_def_var(ncid, VAR1_NAME, NF90_FLOAT, dimids, varid1&
          &, deflate_level = DEFLATE_LEVEL, quantize_mode =&
          & qmode, nsd = qnsd))
     call check(nf90_def_var(ncid, VAR2_NAME, NF90_DOUBLE, dimids,&
          & varid2, contiguous = .TRUE., quantize_mode =&
          & qmode, nsd = qnsd))

     ! Write the pretend data to the file.
     call check(nf90_put_var(ncid, varid1, real_data))
     call check(nf90_put_var(ncid, varid2, double_data))

     ! Close the file. 
     call check(nf90_close(ncid))

     ! Reopen the file.
     call check(nf90_open(FILE_NAME, nf90_nowrite, ncid))

     ! Check some stuff out.
     call check(nf90_inquire(ncid, ndims, nvars, ngatts, unlimdimid, file_format))
     if (ndims /= 1 .or. nvars /= 2 .or. ngatts /= 0 .or. unlimdimid /= -1 .or. &
          file_format /= nf90_format_netcdf4) stop 2

     ! Get varids.
     call check(nf90_inq_varid(ncid, VAR1_NAME, varid1_in))
     call check(nf90_inq_varid(ncid, VAR2_NAME, varid2_in))

     ! Check variable 1.
     call check(nf90_inquire_variable(ncid, varid1_in, name_in, xtype_in, ndims_in, dimids_in, &
          natts_in, chunksizes = chunksizes_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
          deflate_level = deflate_level_in, shuffle = shuffle_in, cache_size = cache_size_in, &
          cache_nelems = cache_nelems_in, cache_preemption = cache_preemption_in, &
          quantize_mode = quantize_mode_in, nsd = nsd_in))
     if (name_in .ne. VAR1_NAME .or. xtype_in .ne. NF90_FLOAT .or. ndims_in .ne. NDIM1 .or. &
          natts_in .ne. 1 .or. dimids_in(1) .ne. dimids(1)) stop 3
     if (quantize_mode_in .ne. qmode .or. nsd_in .ne. qnsd) stop 3

     ! Check variable 2.
     call check(nf90_inquire_variable(ncid, varid2_in, name_in, xtype_in, ndims_in, dimids_in, &
          natts_in, contiguous = contiguous_in, endianness = endianness_in, fletcher32 = fletcher32_in, &
          deflate_level = deflate_level_in, shuffle = shuffle_in, &
          quantize_mode = quantize_mode_in, nsd = nsd_in))
     if (name_in .ne. VAR2_NAME .or. xtype_in .ne. NF90_DOUBLE .or. ndims_in .ne. NDIM1 .or. &
          natts_in .ne. 1 .or. dimids_in(1) .ne. dimids(1)) stop 6
     if (deflate_level_in .ne. 0 .or. .not. contiguous_in .or. fletcher32_in .or. shuffle_in) stop 7
     if (quantize_mode_in .ne. qmode .or. nsd_in .ne. qnsd) stop 3

     ! Check the data.
     call check(nf90_get_var(ncid, varid1_in, real_data_in))
     call check(nf90_get_var(ncid, varid2_in, double_data_in))

     ! Check the data. 
     do x = 1, DIM_LEN_5
        ! Check the real.
        print *, 'real: ', real_data_in(x), real_data(x)
        diff = abs(real_data_in(x) - real_data(x))
        print *, 'x = ', x, ' diff = ', diff
        if (x < 4) then
           if (diff .gt. EPSILON) stop 23
        else
           if (diff .gt. EPSILON_LARGE) stop 24
        endif

        ! Check the double.
        diff = abs(double_data_in(x) - double_data(x))
        print *, 'double:', double_data_in(x), double_data(x)
        print *, 'x = ', x, ' diff = ', diff
        if (x < 4) then
           if (diff .gt. EPSILON) stop 25
        else
           if (diff .gt. EPSILON_LARGE) stop 26
        endif
     end do

     ! Close the file. 
     call check(nf90_close(ncid))
  end do
  
  print *,'*** SUCCESS!'

contains
!     This subroutine handles errors by printing an error message and
!     exiting with a non-zero status.
  subroutine check(errcode)
    use netcdf
    implicit none
    integer, intent(in) :: errcode
    
    if(errcode /= nf90_noerr) then
       print *, 'Error: ', trim(nf90_strerror(errcode))
       stop 2
    endif
  end subroutine check
end program f90tst_vars5

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This program tests netCDF-4 variable functions from fortran,
C     testing chunking and deflate settings.

C     Ed Hartnett

      program ftst_vars
      USE netcdf4_f03
      implicit none

C     This is the name of the data file we will create.
      character*(*) FILE_NAME
      parameter (FILE_NAME='f03tst_vars.nc')

C     We are writing 2D data, a 6 x 12 grid. 
      integer NDIMS
      parameter (NDIMS=2)
      integer NX, NY
      parameter (NX = 6, NY = 12)

C     NetCDF IDs.
      integer ncid, varid, dimids(NDIMS)
      integer x_dimid, y_dimid

C     This is the data array we will write, and a place to store it when
C     we read it back in.
      integer data_out(NY, NX), data_in(NY, NX)

C     For checking our data file to make sure it's correct.
      integer chunks(NDIMS), chunks_in(NDIMS)
      integer shuffle, deflate, deflate_level, checksum, contiguous
      integer endianness

C     Cache size stuff.
      integer DEFAULT_CACHE_SIZE, DEFAULT_CACHE_NELEMS_OLD
      integer DEFAULT_CACHE_NELEMS_NEW
      integer DEFAULT_CACHE_PREEMPTION
      parameter (DEFAULT_CACHE_SIZE = 67108864)
      parameter (DEFAULT_CACHE_NELEMS_OLD = 4133)
      parameter (DEFAULT_CACHE_NELEMS_NEW = 1000)
      parameter (DEFAULT_CACHE_PREEMPTION = 75)
      integer CACHE_SIZE, CACHE_NELEMS, CACHE_PREEMPTION
      parameter (CACHE_SIZE = 8000, CACHE_NELEMS = 500)
      parameter (CACHE_PREEMPTION = 50)
      integer cache_size_in, cache_nelems_in, cache_preemption_in

C     Loop indexes, and error handling.
      integer x, y, retval

C     Create some pretend data.
      do x = 1, NX
         do y = 1, NY
            data_out(y, x) = 2147483646 + x * y
         end do
      end do

      print *, ''
      print *,'*** Testing definition of netCDF-4 vars from Fortran 77.'

C     Check default chunk cache sizes.
      retval = nf_get_chunk_cache(cache_size_in, cache_nelems_in, 
     &     cache_preemption_in)
      if (retval .ne. nf_noerr) stop 1
      if (cache_size_in .ne. DEFAULT_CACHE_SIZE .or. 
     &     (cache_nelems_in .ne. DEFAULT_CACHE_NELEMS_OLD .and.
     &      cache_nelems_in .ne. DEFAULT_CACHE_NELEMS_NEW) .or. 
     &     cache_preemption_in .ne. DEFAULT_CACHE_PREEMPTION) stop 4

C     Change the cache size for the files created/opened in this program.
      retval = nf_set_chunk_cache(CACHE_SIZE, CACHE_NELEMS, 
     &     CACHE_PREEMPTION)
      if (retval .ne. nf_noerr) stop 1

C     Check chunk cache sizes.
      retval = nf_get_chunk_cache(cache_size_in, cache_nelems_in, 
     &     cache_preemption_in)
      if (retval .ne. nf_noerr) stop 1
      if (cache_size_in .ne. CACHE_SIZE .or. 
     &     cache_nelems_in .ne. CACHE_NELEMS .or. 
     &     cache_preemption_in .ne. CACHE_PREEMPTION) stop 4

C     Create the netCDF file.
      retval = nf_create(FILE_NAME, NF_NETCDF4, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Define the dimensions.
      retval = nf_def_dim(ncid, "x", NX, x_dimid)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_dim(ncid, "y", NY, y_dimid)
      if (retval .ne. nf_noerr) stop 1

C     Define the variable. 
      dimids(1) = y_dimid
      dimids(2) = x_dimid
      retval = nf_def_var(ncid, "data", NF_INT64, NDIMS, dimids, varid)
      if (retval .ne. nf_noerr) stop 1

C     Turn on chunking.
      chunks(1) = NY
      chunks(2) = NX
      retval = nf_def_var_chunking(ncid, varid, 0, chunks)
      if (retval .ne. nf_noerr) stop 1

C     Set variable to big-endian (default is whatever is native to
C     writing machine).
      retval = nf_def_var_endian(ncid, varid, NF_ENDIAN_BIG)
      if (retval .ne. nf_noerr) stop 1

C     Turn on deflate, fletcher32.
      retval = nf_def_var_deflate(ncid, varid, 0, 1, 4)
      if (retval .ne. nf_noerr) stop 1
      retval = nf_def_var_fletcher32(ncid, varid, NF_FLETCHER32)
      if (retval .ne. nf_noerr) stop 1

C     Is everything set that is supposed to be?
      retval = nf_inq_var_deflate(ncid, varid, shuffle, deflate, 
     +     deflate_level)
      if (retval .ne. nf_noerr) stop 1
      if (shuffle .ne. 0 .or. deflate .ne. 1 .or. 
     +     deflate_level .ne. 4) stop 2
      retval = nf_inq_var_fletcher32(ncid, varid, checksum)
      if (retval .ne. nf_noerr) stop 1
      if (checksum .ne. NF_FLETCHER32) stop 2
      retval = nf_inq_var_chunking(ncid, varid, contiguous, chunks_in)
      if (retval .ne. nf_noerr) stop 1
      if (contiguous .ne. 0) stop 2
      if (chunks(1) .ne. chunks_in(1) .or.
     +     chunks(2) .ne. chunks_in(2)) stop 2
      retval = nf_inq_var_endian(ncid, varid, endianness)
      if (retval .ne. nf_noerr) stop 1
      if (endianness .ne. NF_ENDIAN_BIG) stop 2

C     Since this is a classic model file, we must call enddef
      retval = nf_enddef(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Write the pretend data to the file.
      retval = nf_put_var_int(ncid, varid, data_out)
      if (retval .ne. nf_noerr) stop 1

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

C     Reopen the file and check again.
      retval = nf_open(FILE_NAME, NF_NOWRITE, ncid)
      if (retval .ne. nf_noerr) stop 1

C     Find our variable.
      retval = nf_inq_varid(ncid, "data", varid)
      if (retval .ne. nf_noerr) stop 1
      if (varid .ne. 1) stop 2

C     Check the deflate, fletcher32, chunking, and endianness.
      retval = nf_inq_var_deflate(ncid, varid, shuffle, deflate, 
     +     deflate_level)
      if (retval .ne. nf_noerr) stop 1
      if (shuffle .ne. 0 .or. deflate .ne. 1 .or. 
     +     deflate_level .ne. 4) stop 2
      retval = nf_inq_var_fletcher32(ncid, varid, checksum)
      if (retval .ne. nf_noerr) stop 1
      if (checksum .ne. NF_FLETCHER32) stop 2
      retval = nf_inq_var_chunking(ncid, varid, contiguous, chunks_in)
      if (retval .ne. nf_noerr) stop 1
      if (contiguous .ne. 0) stop 2
      if (chunks(1) .ne. chunks_in(1) .or.
     +     chunks(2) .ne. chunks_in(2)) stop 2
      retval = nf_inq_var_endian(ncid, varid, endianness)
      if (retval .ne. nf_noerr) stop 1
      if (endianness .ne. NF_ENDIAN_BIG) stop 2

C     Read the data and check it.
      retval = nf_get_var_int(ncid, varid, data_in)
      if (retval .ne. nf_noerr) stop 1
      do x = 1, NX
         do y = 1, NY
            if (data_in(y, x) .ne. data_out(y, x)) stop 2
         end do
      end do

C     Close the file. 
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) stop 1

      print *,'*** SUCCESS!'
      end

C     This is part of the netCDF package.
C     Copyright 2006 University Corporation for Atmospheric Research/Unidata.
C     See COPYRIGHT file for conditions of use.

C     This is an example which reads some surface pressure and
C     temperatures. The data file read by this program is produced
C     comapnion program sfc_pres_temp_wr.f. It is intended to illustrate
C     the use of the netCDF fortran 77 API.

C     This program is part of the netCDF tutorial:
C     https://docs.unidata.ucar.edu/netcdf-c/current/tutorial_8dox.html

C     Full documentation of the netCDF Fortran 77 API can be found at:
C     https://docs.unidata.ucar.edu/netcdf-fortran/current/nc_f77_interface_guide.html

C     Ed Hartnett

      program sfc_pres_temp_rd
      implicit none
      include 'netcdf.inc'

C     This is the name of the data file we will read.
      character*(*) FILE_NAME
      parameter (FILE_NAME='sfc_pres_temp.nc')
      integer ncid

C     We are reading 2D data, a 12 x 6 lon-lat grid.
      integer NDIMS
      parameter (NDIMS=2)
      integer NLATS, NLONS
      parameter (NLATS = 6, NLONS = 12)
      character*(*) LAT_NAME, LON_NAME
      parameter (LAT_NAME='latitude', LON_NAME='longitude')

C     For the lat lon coordinate netCDF variables.
      real lats(NLATS), lons(NLONS)
      integer lat_varid, lon_varid

C     We will read surface temperature and pressure fields. 
      character*(*) PRES_NAME, TEMP_NAME
      parameter (PRES_NAME='pressure')
      parameter (TEMP_NAME='temperature')
      integer pres_varid, temp_varid

C     To check the units attributes.
      character*(*) UNITS
      parameter (UNITS = 'units')
      character*(*) PRES_UNITS, TEMP_UNITS, LAT_UNITS, LON_UNITS
      parameter (PRES_UNITS = 'hPa', TEMP_UNITS = 'celsius')
      parameter (LAT_UNITS = 'degrees_north')
      parameter (LON_UNITS = 'degrees_east')
      integer MAX_ATT_LEN
      parameter (MAX_ATT_LEN = 80)
      character*(MAX_ATT_LEN) pres_units_in, temp_units_in
      character*(MAX_ATT_LEN) lat_units_in, lon_units_in
      integer att_len

C     Read the data into these arrays.
      real pres_in(NLONS, NLATS), temp_in(NLONS, NLATS)

C     These are used to calculate the values we expect to find.
      real START_LAT, START_LON
      parameter (START_LAT = 25.0, START_LON = -125.0)
      real SAMPLE_PRESSURE
      parameter (SAMPLE_PRESSURE = 900.0)
      real SAMPLE_TEMP
      parameter (SAMPLE_TEMP = 9.0)

C     We will learn about the data file and store results in these
C     program variables.
      integer ndims_in, nvars_in, ngatts_in, unlimdimid_in

C     Loop indices
      integer lat, lon

C     Error handling
      integer retval

C     Open the file. 
      retval = nf_open(FILE_NAME, nf_nowrite, ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     There are a number of inquiry functions in netCDF which can be
C     used to learn about an unknown netCDF file. NF_INQ tells how many
C     netCDF variables, dimensions, and global attributes are in the
C     file; also the dimension id of the unlimited dimension, if there
C     is one.
      retval = nf_inq(ncid, ndims_in, nvars_in, ngatts_in, 
     +     unlimdimid_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     In this case we know that there are 2 netCDF dimensions, 4 netCDF
C     variables, no global attributes, and no unlimited dimension.
      if (ndims_in .ne. 2 .or. nvars_in .ne. 4 .or. ngatts_in .ne. 0 
     +     .or. unlimdimid_in .ne. -1) stop 2

C     Get the varids of the latitude and longitude coordinate variables.
      retval = nf_inq_varid(ncid, LAT_NAME, lat_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, LON_NAME, lon_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the latitude and longitude data.
      retval = nf_get_var_real(ncid, lat_varid, lats)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, lon_varid, lons)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check to make sure we got what we expected.
      do lat = 1, NLATS
         if (lats(lat) .ne. START_LAT + (lat - 1) * 5.0) stop 2
      end do
      do lon = 1, NLONS
         if (lons(lon) .ne. START_LON + (lon - 1) * 5.0) stop 2
      end do

C     Get the varids of the pressure and temperature netCDF variables.
      retval = nf_inq_varid(ncid, PRES_NAME, pres_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_varid(ncid, TEMP_NAME, temp_varid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Read the surface pressure and temperature data from the file.
C     Since we know the contents of the file we know that the data
C     arrays in this program are the correct size to hold all the data.
      retval = nf_get_var_real(ncid, pres_varid, pres_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_get_var_real(ncid, temp_varid, temp_in)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     Check the data. It should be the same as the data we wrote.
      do lon = 1, NLONS
         do lat = 1, NLATS
             if (pres_in(lon, lat) .ne. SAMPLE_PRESSURE +
     +           (lon - 1) * NLATS + (lat - 1)) stop 2
             if (temp_in(lon, lat) .ne. SAMPLE_TEMP +
     +           .25 * ((lon - 1) * NLATS + (lat - 1))) stop 2
         end do
      end do

C     Each of the netCDF variables has a "units" attribute. Let's read
C     them and check them.

      retval = nf_get_att_text(ncid, lat_varid, UNITS, lat_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lat_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lat_units_in(1:att_len) .ne. LAT_UNITS) stop 2
 
      retval = nf_get_att_text(ncid, lon_varid, UNITS, lon_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, lon_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (lon_units_in(1:att_len) .ne. LON_UNITS) stop 2

      retval = nf_get_att_text(ncid, pres_varid, UNITS, pres_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, pres_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (pres_units_in(1:att_len) .ne. PRES_UNITS) stop 2

      retval = nf_get_att_text(ncid, temp_varid, UNITS, temp_units_in)
      if (retval .ne. nf_noerr) call handle_err(retval)
      retval = nf_inq_attlen(ncid, temp_varid, UNITS, att_len)
      if (retval .ne. nf_noerr) call handle_err(retval)
      if (temp_units_in(1:att_len) .ne. TEMP_UNITS) stop 2

C     Close the file. This frees up any internal netCDF resources
C     associated with the file.
      retval = nf_close(ncid)
      if (retval .ne. nf_noerr) call handle_err(retval)

C     If we got this far, everything worked as expected. Yipee!
      print *,'*** SUCCESS reading example file sfc_pres_temp.nc!'
      end

      subroutine handle_err(errcode)
      implicit none
      include 'netcdf.inc'
      integer errcode

      print *, 'Error: ', nf_strerror(errcode)
      stop 2
      end

#!/bin/sh
# Copyright 1993 - 2019, University Corporation for Atmospheric
# Research/Unidata. See netcdf-c/COPYRIGHT file for more info.

# This shell script runs the netCDF classic F90 examples.
# Ed Hartnett

echo "*** Running F90 examples."
set -e

echo "*** running simple_xy examples..."
./simple_xy_wr
./simple_xy_rd

echo "*** running sfc_pres_temp examples..."
./sfc_pres_temp_wr
./sfc_pres_temp_rd

echo "*** running pres_temp_4D examples..."
./pres_temp_4D_wr
./pres_temp_4D_rd

echo "*** Examples successful!"
exit 0

#!/bin/sh
# Copyright 1993 - 2019, University Corporation for Atmospheric
# Research/Unidata. See netcdf-c/COPYRIGHT file for more info.

# This shell script runs the netCDF classic F90 examples.
# Ed Hartnett

echo "*** Running F90 examples."
set -e

echo "*** running simple_xy examples..."
./nc4_simple_xy_wr
./simple_xy_rd

echo "*** running sfc_pres_temp examples..."
./nc4_sfc_pres_temp_wr
./sfc_pres_temp_rd

echo "*** running pres_temp_4D examples..."
./nc4_pres_temp_4D_wr
./pres_temp_4D_rd

echo "*** running simple_xy_nc4 examples..."
./simple_xy_nc4_wr
./simple_xy_nc4_rd

echo "*** Examples successful!"
exit 0

#!/bin/sh
# Copyright 1993 - 2019, University Corporation for Atmospheric
# Research/Unidata. See netcdf-c/COPYRIGHT file for more info.

# This shell script runs the netCDF-4 F77 examples.
# Ed Hartnett

echo "*** Running NetCDF-4 F77 examples."
set -e

echo "*** running simple_xy netCDF-4 examples..."
./simple_xy_nc4_wr
./simple_xy_nc4_rd

echo "*** Examples successful!"
exit 0

#!/bin/sh
# Copyright 2019, University Corporation for Atmospheric
# Research/Unidata. See netcdf-c/COPYRIGHT file for more info.

# This shell script runs the netCDF netCDF-4 parallel I/O F90
# examples.

# Ed Hartnett

echo "*** Running netCDF-4 F90 parallel I/O examples."
set -e
mpiexec -n 4 ./simple_xy_par_wr
mpiexec -n 4 ./simple_xy_par_rd
mpiexec -n 4 ./simple_xy_par_wr2

#!/bin/sh

# This shell runs some parallel I/O tests for the F77 API.

# Ed Hartnett, 2019

set -e
echo "Testing netCDF parallel I/O through the F77 API with 03 interface..."

mpiexec -n 4 ./f03tst_parallel

echo "SUCCESS!!!"
exit 0

#!/bin/sh

# This shell runs some parallel I/O tests for the F90 API.

# Ed Hartnett, 2009

set -e
echo "Testing netCDF parallel I/O through the F90 API."
mpiexec -n 4 ./f90tst_parallel
mpiexec -n 4 ./f90tst_parallel2
mpiexec -n 4 ./f90tst_parallel3
mpiexec -n 8 ./f90tst_nc4_par
mpiexec -n 4 ./f90tst_parallel_fill

echo "SUCCESS!!!"
exit 0

#!/bin/sh
# Copyright 1993 - 2019, University Corporation for Atmospheric
# Research/Unidata. See netcdf-c/COPYRIGHT file for more info.

# This shell script runs the netCDF classic F77 examples.
# Ed Hartnett

echo "*** Running F77 examples."
set -e

echo "*** running simple_xy examples..."
./simple_xy_wr
./simple_xy_rd

echo "*** running sfc_pres_temp examples..."
./sfc_pres_temp_wr
./sfc_pres_temp_rd

echo "*** running pres_temp_4D examples..."
./pres_temp_4D_wr
./pres_temp_4D_rd

echo "*** Examples successful!"
exit 0

#!/bin/sh

# This shell runs some parallel I/O tests for the F77 API.

# Ed Hartnett, 2009

set -e
echo "Testing netCDF parallel I/O through the F77 API..."

mpiexec -n 4 ./ftst_parallel
mpiexec -n 4 ./ftst_parallel_nasa

echo "SUCCESS!!!"
exit 0

5 User Defined Data Types {#f90-user-defined-data-types}
=========================

5.1 User Defined Types Introduction {#f90-user-defined-types-introduction}
=========================

[TOC]

NetCDF-4 has added support for four different user defined data types.

`compound type`

:   Like a C struct, a compound type is a collection of types, including
    other user defined types, in one package.

`variable length array type`

:   The variable length array may be used to store ragged arrays.

`opaque type`

:   This type has only a size per element, and no other
    type information.

`enum type`

:   Like an enumeration in C, this type lets you assign text values to
    integer values, and store the integer values.

Users may construct user defined type with the various NF90\_DEF\_\*
functions described in this section. They may learn about user defined
types by using the NF90\_INQ\_ functions defined in this section.

Once types are constructed, define variables of the new type with
NF90\_DEF\_VAR (see section [Create a Variable: `NF90_DEF_VAR`](#NF90_005fDEF_005fVAR)). Write to them with
NF90\_PUT\_VAR (see section [Writing Data Values: `NF90_PUT_VAR`](#NF90_005fPUT_005fVAR)). Read data of user-defined type
with NF90\_GET\_VAR (see section [Reading Data Values: `NF90_GET_VAR`](#NF90_005fGET_005fVAR)).

Create attributes of the new type with NF90\_PUT\_ATT (see section
[Create an Attribute: NF90\_PUT\_ATT](#NF90_005fPUT_005fATT)). Read
attributes of the new type with NF90\_GET\_ATT (see section [Get
Attribute’s Values: NF90\_GET\_ATT](#NF90_005fGET_005fATT)).


5.2 Learn the IDs of All Types in Group: NF90_INQ_TYPEIDS {#f90-learn-the-ids-of-all-types-in-group-nf90_inq_typeids}
=========================



Learn the number of types defined in a group, and their IDs.



## Usage



~~~~.fortran

  function nf90_inq_typeids(ncid, ntypes, typeids)
    integer, intent(in) :: ncid
    integer, intent(out) :: ntypes
    integer, intent(out) :: typeids
    integer :: nf90_inq_typeids



~~~~

`NCID`

:   The group id.

`NTYPES`

:   A pointer to int which will get the number of types defined in
    the group. If NULL, ignored.

`TYPEIDS`

:   A pointer to an int array which will get the typeids. If
    NULL, ignored.



## Errors

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.



## Example


5.3 Find a Typeid from Group and Name: nf90_inq_typeid {#f90-find-a-typeid-from-group-and-name-nf90_inq_typeid}
=========================



Given a group ID and a type name, find the ID of the type. If the type
is not found in the group, then the parents are searched. If still not
found, the entire file is searched.



## Usage




~~~~.fortran
int nf90_inq_typeid(int ncid, char *name, nf90_type *typeidp);


~~~~


`ncid`

:   The group id.

`name`

:   The name of a type.

`typeidp`

:   The typeid, if found.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad ncid.

`NF90_EBADTYPE`

:   Can’t find type.



## Example


5.4 Learn About a User Defined Type: NF90_INQ_TYPE {#f90-learn-about-a-user-defined-type-nf90_inq_type}
=========================


Given an ncid and a typeid, get the information about a type. This
function will work on any type, including atomic and any user defined
type, whether compound, opaque, enumeration, or variable length array.

For even more information about a user defined type [Learn About a User
Defined Type: NF90\_INQ\_USER\_TYPE](#NF90_005fINQ_005fUSER_005fTYPE).



## Usage

~~~~.fortran



  function nf90_inq_type(ncid, xtype, name, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer :: nf90_inq_type



~~~~

`NCID`

:   The ncid for the group containing the type (ignored for
    atomic types).

`XTYPE`

:   The typeid for this type, as returned by NF90\_DEF\_COMPOUND,
    NF90\_DEF\_OPAQUE, NF90\_DEF\_ENUM, NF90\_DEF\_VLEN, or
    NF90\_INQ\_VAR, or as found in netcdf.inc in the list of atomic
    types (NF90\_CHAR, NF90\_INT, etc.).

`NAME`

:   The name of the user defined type will be copied here. It will be
    NF90\_MAX\_NAME bytes or less. For atomic types, the type name from
    CDL will be given.

`SIZEP`

:   The (in-memory) size of the type (in bytes) will be copied here.
    VLEN type size is the size of one element of the VLEN. String size
    is returned as the size of one char.



## Return Codes


`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad typeid.

`NF90_ENOTNC4`

:   Seeking a user-defined type in a netCDF-3 file.

`NF90_ESTRICTNC3`

:   Seeking a user-defined type in a netCDF-4 file for which classic
    model has been turned on.

`NF90_EBADGRPID`

:   Bad group ID in ncid.

`NF90_EBADID`

:   Type ID not found.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example


5.5 Learn About a User Defined Type: NF90_INQ_USER_TYPE {#f90-learn-about-a-user-defined-type-nf90_inq_user_type}
=========================

Given an ncid and a typeid, get the information about a user defined
type. This function will work on any user defined type, whether
compound, opaque, enumeration, or variable length array.



## Usage



~~~~.fortran

  function nf90_inq_user_type(ncid, xtype, name, size, base_typeid, nfields, class)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer, intent(out) :: base_typeid
    integer, intent(out) :: nfields
    integer, intent(out) :: class
    integer :: nf90_inq_user_type
~~~~

`NCID`

:   The ncid for the group containing the user defined type.

`XTYPE`

:   The typeid for this type, as returned by NF90\_DEF\_COMPOUND,
    NF90\_DEF\_OPAQUE, NF90\_DEF\_ENUM, NF90\_DEF\_VLEN,
    or NF90\_INQ\_VAR.

`NAME`

:   The name of the user defined type will be copied here. It will be
    NF90\_MAX\_NAME bytes or less.

`SIZE`

:   The (in-memory) size of the user defined type will be copied here.

`BASE_NF90_TYPE`

:   The base typeid will be copied here for vlen and enum types.

`NFIELDS`

:   The number of fields will be copied here for enum and
    compound types.

`CLASS`

:   The class of the user defined type, NF90\_VLEN, NF90\_OPAQUE,
    NF90\_ENUM, or NF90\_COMPOUND, will be copied here.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad typeid.

`NF90_EBADFIELDID`

:   Bad fieldid.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

## 5.5.1 Set a Variable Length Array with NF90_PUT_VLEN_ELEMENT {#f90-set-a-variable-length-array-with-nf90_put_vlen_element}



Use this to set the element of the (potentially) n-dimensional array of
VLEN. That is, this sets the data in one variable length array.



### Usage


~~~~.fortran


INTEGER FUNCTION NF90_PUT_VLEN_ELEMENT(INTEGER NCID, INTEGER XTYPE,
        CHARACTER*(*) VLEN_ELEMENT, INTEGER LEN, DATA)



~~~~

`NCID`

:   The ncid of the file that contains the VLEN type.

`XTYPE`

:   The type of the VLEN.

`VLEN_ELEMENT`

:   The VLEN element to be set.

`LEN`

:   The number of entries in this array.

`DATA`

:   The data to be stored. Must match the base type of this VLEN.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPE`

:   Can’t find the typeid.

`NF90_EBADID`

:   ncid invalid.

`NF90_EBADGRPID`

:   Group ID part of ncid was invalid.



### Example

This example is from nf90\_test/ftst\_vars4.F.



~~~~.fortran

C     Set up the vlen with this helper function, since F90 can't deal
C     with pointers.
      retval = nf90_put_vlen_element(ncid, vlen_typeid, vlen,
     &     vlen_len, data1)
      if (retval .ne. nf90_noerr) call handle_err(retval)



~~~~


## 5.5.2 Set a Variable Length Array with NF90_GET_VLEN_ELEMENT {#f90-set-a-variable-length-array-with-nf90_get_vlen_element}



Use this to set the element of the (potentially) n-dimensional array of
VLEN. That is, this sets the data in one variable length array.



### Usage



~~~~.fortran

INTEGER FUNCTION NF90_GET_VLEN_ELEMENT(INTEGER NCID, INTEGER XTYPE,
        CHARACTER*(*) VLEN_ELEMENT, INTEGER LEN, DATA)


~~~~


`NCID`

:   The ncid of the file that contains the VLEN type.

`XTYPE`

:   The type of the VLEN.

`VLEN_ELEMENT`

:   The VLEN element to be set.

`LEN`

:   This will be set to the number of entries in this array.

`DATA`

:   The data will be copied here. Sufficient storage must be available
    or bad things will happen to you.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPE`

:   Can’t find the typeid.

`NF90_EBADID`

:   ncid invalid.

`NF90_EBADGRPID`

:   Group ID part of ncid was invalid.



### Example


5.6 Compound Types Introduction {#f90-compound-types-introduction}
=========================



NetCDF-4 added support for compound types, which allow users to
construct a new type - a combination of other types, like a C struct.

Compound types are not supported in classic or 64-bit offset format
files.

To write data in a compound type, first use nf90\_def\_compound to
create the type, multiple calls to nf90\_insert\_compound to add to the
compound type, and then write data with the appropriate nf90\_put\_var1,
nf90\_put\_vara, nf90\_put\_vars, or nf90\_put\_varm call.

To read data written in a compound type, you must know its structure.
Use the NF90\_INQ\_COMPOUND functions to learn about the compound type.

In Fortran a character buffer must be used for the compound data. The
user must read the data from within that buffer in the same way that the
C compiler which compiled netCDF would store the structure.

The use of compound types introduces challenges and portability issues
for Fortran users.

## 5.6.1 Creating a Compound Type: NF90_DEF_COMPOUND {#f90-creating-a-compound-type-nf90_def_compound}



Create a compound type. Provide an ncid, a name, and a total size (in
bytes) of one element of the completed compound type.

After calling this function, fill out the type with repeated calls to
NF90\_INSERT\_COMPOUND (see section [Inserting a Field into a Compound
Type: NF90\_INSERT\_COMPOUND](#NF90_005fINSERT_005fCOMPOUND)). Call
NF90\_INSERT\_COMPOUND once for each field you wish to insert into the
compound type.

Note that there does not seem to be a fully portable way to read such
types into structures in Fortran 90 (and there are no structures in
Fortran 77). Dozens of top-notch programmers are swarming over this
problem in a sub-basement of Unidata’s giant underground bunker in
Wyoming.

Fortran users may use character buffers to read and write compound
types. User are invited to try classic Fortran features such as the
equivilence and the common block statment.

### Usage



~~~~.fortran

  function nf90_def_compound(ncid, size, name, typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: size
    character (len = *), intent(in) :: name
    integer, intent(out) :: typeid
    integer :: nf90_def_compound

~~~~



`NCID`

:   The groupid where this compound type will be created.

`SIZE`

:   The size, in bytes, of the compound type.

`NAME`

:   The name of the new compound type.

`TYPEIDP`

:   The typeid of the new type will be placed here.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Compound type names must be unique in the
    data file.

`NF90_EMAXNAME`

:   Name exceeds max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag NF90\_NETCDF4. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_EPERM`

:   Attempt to write to a read-only file.

`NF90_ENOTINDEFINE`

:   Not in define mode.



### Example

## 5.6.2 Inserting a Field into a Compound Type: NF90_INSERT_COMPOUND {#f90-inserting-a-field-into-a-compound-type-nf90_insert_compound}



Insert a named field into a compound type.



### Usage



~~~~.fortran

  function nf90_insert_compound(ncid, xtype, name, offset, field_typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: offset
    integer, intent(in) :: field_typeid
    integer :: nf90_insert_compound


~~~~


`TYPEID`

:   The typeid for this compound type, as returned by
    NF90\_DEF\_COMPOUND, or NF90\_INQ\_VAR.

`NAME`

:   The name of the new field.

`OFFSET`

:   Offset in byte from the beginning of the compound type for
    this field.

`FIELD_TYPEID`

:   The type of the field to be inserted.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Field names must be unique within a
    compound type.

`NF90_EMAXNAME`

:   Name exceed max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag NF90\_NETCDF4. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_ENOTINDEFINE`

:   Not in define mode.



### Example





## 5.6.3 Inserting an Array Field into a Compound Type: NF90_INSERT_ARRAY_COMPOUND {#f90-inserting-an-array-field-into-a-compound-type-nf90_insert_array_compound}



Insert a named array field into a compound type.



### Usage



~~~~.fortran

  function nf90_insert_array_compound(ncid, xtype, name, offset, field_typeid, &
       ndims, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: offset
    integer, intent(in) :: field_typeid
    integer, intent(in) :: ndims
    integer, intent(in) :: dim_sizes
    integer :: nf90_insert_array_compound



~~~~

`NCID`

:   The ID of the file that contains the array type and the
    compound type.

`XTYPE`

:   The typeid for this compound type, as returned by
    nf90\_def\_compound, or nf90\_inq\_var.

`NAME`

:   The name of the new field.

`OFFSET`

:   Offset in byte from the beginning of the compound type for
    this field.

`FIELD_TYPEID`

:   The base type of the array to be inserted.

`NDIMS`

:   The number of dimensions for the array to be inserted.

`DIM_SIZES`

:   An array containing the sizes of each dimension.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Field names must be unique within a
    compound type.

`NF90_EMAXNAME`

:   Name exceed max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag NF90\_NETCDF4. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_ENOTINDEFINE`

:   Not in define mode.

`NF90_ETYPEDEFINED`

:   Attempt to change type that has already been committed. The first
    time the file leaves define mode, all defined types are committed,
    and can’t be changed. If you wish to add an array to a compound
    type, you must do so before the compound type is committed.



### Example

## 5.6.4 Learn About a Compound Type: NF90_INQ_COMPOUND {#f90-learn-about-a-compound-type-nf90_inq_compound}



Get the number of fields, length in bytes, and name of a compound type.

In addtion to the NF90\_INQ\_COMPOUND function, three additional
functions are provided which get only the name, size, and number of
fields.



### Usage


~~~~.fortran


  function nf90_inq_compound(ncid, xtype, name, size, nfields)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer, intent(out) :: nfields
    integer :: nf90_inq_compound

  function nf90_inq_compound_name(ncid, xtype, name)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer :: nf90_inq_compound_name

  function nf90_inq_compound_size(ncid, xtype, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(out) :: size
    integer :: nf90_inq_compound_size

  function nf90_inq_compound_nfields(ncid, xtype, nfields)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(out) :: nfields
    integer :: nf90_inq_compound_nfields



~~~~

`NCID`

:   The ID of any group in the file that contains the compound type.

`XTYPE`

:   The typeid for this compound type, as returned by
    NF90\_DEF\_COMPOUND, or NF90\_INQ\_VAR.

`NAME`

:   Character array which will get the name of the compound type. It
    will have a maximum length of NF90\_MAX\_NAME.

`SIZEP`

:   The size of the compound type in bytes will be put here.

`NFIELDSP`

:   The number of fields in the compound type will be placed here.



### Return Codes

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Couldn’t find this ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4/HDF5 file.

`NF90_ESTRICTNC3`

:   A netCDF-4/HDF5 file, but with CLASSIC\_MODEL. No user defined types
    are allowed in the classic model.

`NF90_EBADTYPE`

:   This type not a compound type.

`NF90_EBADTYPEID`

:   Bad type id.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example

## 5.6.5 Learn About a Field of a Compound Type: NF90_INQ_COMPOUND_FIELD {#f90-learn-about-a-field-of-a-compound-type-nf90_inq_compound_field}



Get information about one of the fields of a compound type.



### Usage


~~~~.fortran


  function nf90_inq_compound_field(ncid, xtype, fieldid, name, offset, &
       field_typeid, ndims, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    character (len = *), intent(out) :: name
    integer, intent(out) :: offset
    integer, intent(out) :: field_typeid
    integer, intent(out) :: ndims
    integer, intent(out) :: dim_sizes
    integer :: nf90_inq_compound_field

  function nf90_inq_compound_fieldname(ncid, xtype, fieldid, name)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    character (len = *), intent(out) :: name
    integer :: nf90_inq_compound_fieldname

  function nf90_inq_compound_fieldindex(ncid, xtype, name, fieldid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(out) :: fieldid
    integer :: nf90_inq_compound_fieldindex

  function nf90_inq_compound_fieldoffset(ncid, xtype, fieldid, offset)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: offset
    integer :: nf90_inq_compound_fieldoffset

  function nf90_inq_compound_fieldtype(ncid, xtype, fieldid, field_typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: field_typeid
    integer :: nf90_inq_compound_fieldtype

  function nf90_inq_compound_fieldndims(ncid, xtype, fieldid, ndims)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: ndims
    integer :: nf90_inq_compound_fieldndims

  function nf90_inq_cmp_fielddim_sizes(ncid, xtype, fieldid, dim_sizes)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: fieldid
    integer, intent(out) :: dim_sizes
    integer :: nf90_inq_cmp_fielddim_sizes


~~~~


`NCID`

:   The groupid where this compound type exists.

`XTYPE`

:   The typeid for this compound type, as returned by
    NF90\_DEF\_COMPOUND, or NF90\_INQ\_VAR.

`FIELDID`

:   A one-based index number specifying a field in the compound type.

`NAME`

:   A character array which will get the name of the field. The name
    will be NF90\_MAX\_NAME characters, at most.

`OFFSETP`

:   An integer which will get the offset of the field.

`FIELD_TYPEID`

:   An integer which will get the typeid of the field.

`NDIMSP`

:   An integer which will get the number of dimensions of the field.

`DIM_SIZESP`

:   An integer array which will get the dimension sizes of the field.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad type id.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example

5.7 Variable Length Array Introduction {#f90-variable-length-array-introduction}
=========================



NetCDF-4 added support for a variable length array type. This is not
supported in classic or 64-bit offset files, or in netCDF-4 files which
were created with the NF90\_CLASSIC\_MODEL flag.

A variable length array is represented in C as a structure from HDF5,
the nf90\_vlen\_t structure. It contains a len member, which contains
the length of that array, and a pointer to the array.

So an array of VLEN in C is an array of nc\_vlen\_t structures. The only
way to handle this in Fortran is with a character buffer sized correctly
for the platform.

VLEN arrays are handled differently with respect to allocation of
memory. Generally, when reading data, it is up to the user to malloc
(and subsequently free) the memory needed to hold the data. It is up to
the user to ensure that enough memory is allocated.

With VLENs, this is impossible. The user cannot know the size of an
array of VLEN until after reading the array. Therefore when reading VLEN
arrays, the netCDF library will allocate the memory for the data within
each VLEN.

It is up to the user, however, to eventually free this memory. This is
not just a matter of one call to free, with the pointer to the array of
VLENs; each VLEN contains a pointer which must be freed.

Compression is permitted but may not be effective for VLEN data, because
the compression is applied to the nc\_vlen\_t structures, rather than
the actual data.

## 5.7.1 Define a Variable Length Array (VLEN): NF90_DEF_VLEN {#f90-define-a-variable-length-array-vlen-nf90_def_vlen}



Use this function to define a variable length array type.



### Usage


~~~~.fortran


  function nf90_def_vlen(ncid, name, base_typeid, xtypeid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(in) :: base_typeid
    integer, intent(out) :: xtypeid
    integer :: nf90_def_vlen


~~~~


`NCID`

:   The ncid of the file to create the VLEN type in.

`NAME`

:   A name for the VLEN type.

`BASE_TYPEID`

:   The typeid of the base type of the VLEN. For example, for a VLEN of
    shorts, the base type is NF90\_SHORT. This can be a user
    defined type.

`XTYPEP`

:   The typeid of the new VLEN type will be set here.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EMAXNAME`

:   NF90\_MAX\_NAME exceeded.

`NF90_ENAMEINUSE`

:   Name is already in use.

`NF90_EBADNAME`

:   Attribute or variable name contains illegal characters.

`NF90_EBADID`

:   ncid invalid.

`NF90_EBADGRPID`

:   Group ID part of ncid was invalid.

`NF90_EINVAL`

:   Size is invalid.

`NF90_ENOMEM`

:   Out of memory.



### Example

## 5.7.2 Learning about a Variable Length Array (VLEN) Type: NF90_INQ_VLEN {#f90-learning-about-a-variable-length-array-vlen-type-nf90_inq_vlen}



Use this type to learn about a vlen.



### Usage


~~~~.fortran


  function nf90_inq_vlen(ncid, xtype, name, datum_size, base_nc_type)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: datum_size
    integer, intent(out) :: base_nc_type
    integer :: nf90_inq_vlen


~~~~


`NCID`

:   The ncid of the file that contains the VLEN type.

`XTYPE`

:   The type of the VLEN to inquire about.

`NAME`

:   The name of the VLEN type. The name will be NF90\_MAX\_NAME
    characters or less.

`DATUM_SIZEP`

:   A pointer to a size\_t, this will get the size of one element of
    this vlen.

`BASE_NF90_TYPEP`

:   An integer that will get the type of the VLEN base type. (In other
    words, what type is this a VLEN of?)



#### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPE`

:   Can’t find the typeid.

`NF90_EBADID`

:   ncid invalid.

`NF90_EBADGRPID`

:   Group ID part of ncid was invalid.



### Example


## 5.7.3 Releasing Memory for a Variable Length Array (VLEN) Type: NF90_FREE_VLEN {#f90-releasing-memory-for-a-variable-length-array-vlen-type-nf90_free_vlen}



When a VLEN is read into user memory from the file, the HDF5 library
performs memory allocations for each of the variable length arrays
contained within the VLEN structure. This memory must be freed by the
user to avoid memory leaks.

This violates the normal netCDF expectation that the user is responsible
for all memory allocation. But, with VLEN arrays, the underlying HDF5
library allocates the memory for the user, and the user is responsible
for deallocating that memory.



### Usage


~~~~.fortran


  function nf90_free_vlen(vl)
    character (len = *), intent(in) :: vlen
    integer :: nf90_free_vlen
  end function nf90_free_vlen


~~~~


`VL`

:   The variable length array structure which is to be freed.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPE`

:   Can’t find the typeid.



### Example


5.8 Opaque Type Introduction {#f90-opaque-type-introduction}
=========================



NetCDF-4 added support for the opaque type. This is not supported in
classic or 64-bit offset files.

The opaque type is a type which is a collection of objects of a known
size. (And each object is the same size). Nothing is known to netCDF
about the contents of these blobs of data, except their size in bytes,
and the name of the type.

To use an opaque type, first define it with [Creating Opaque Types:
NF90\_DEF\_OPAQUE](#NF90_005fDEF_005fOPAQUE). If encountering an enum
type in a new data file, use [Learn About an Opaque Type:
NF90\_INQ\_OPAQUE](#NF90_005fINQ_005fOPAQUE) to learn its name and size.

## 5.8.1 Creating Opaque Types: NF90_DEF_OPAQUE {#f90-creating-opaque-types-nf90_def_opaque}



Create an opaque type. Provide a size and a name.



### Usage



~~~~.fortran

  function nf90_def_opaque(ncid, size, name, xtype)
    integer, intent(in) :: ncid
    integer, intent(in) :: size
    character (len = *), intent(in) :: name
    integer, intent(out) :: xtype
    integer :: nf90_def_opaque


~~~~


`NCID`

:   The groupid where the type will be created. The type may be used
    anywhere in the file, no matter what group it is in.

`NAME`

:   The name for this type. Must be shorter than NF90\_MAX\_NAME.

`SIZE`

:   The size of each opaque object.

`TYPEIDP`

:   Pointer where the new typeid for this type is returned. Use this
    typeid when defining variables of this type with [Create a Variable:
    `NF90_DEF_VAR`](#NF90_005fDEF_005fVAR).



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad typeid.

`NF90_EBADFIELDID`

:   Bad fieldid.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example

## 5.8.2 Learn About an Opaque Type: NF90_INQ_OPAQUE {#f90-learn-about-an-opaque-type-nf90_inq_opaque}



Given a typeid, get the information about an opaque type.



### Usage



~~~~.fortran

  function nf90_inq_opaque(ncid, xtype, name, size)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: size
    integer :: nf90_inq_opaque



~~~~

`NCID`

:   The ncid for the group containing the opaque type.

`XTYPE`

:   The typeid for this opaque type, as returned by NF90\_DEF\_COMPOUND,
    or NF90\_INQ\_VAR.

`NAME`

:   The name of the opaque type will be copied here. It will be
    NF90\_MAX\_NAME bytes or less.

`SIZEP`

:   The size of the opaque type will be copied here.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad typeid.

`NF90_EBADFIELDID`

:   Bad fieldid.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example

5.9 Enum Type Introduction {#f90-enum-type-introduction}
=========================



NetCDF-4 added support for the enum type. This is not supported in
classic or 64-bit offset files.


## 5.9.1 Creating a Enum Type: NF90_DEF_ENUM {#f90-creating-a-enum-type-nf90_def_enum}



Create an enum type. Provide an ncid, a name, and a base integer type.

After calling this function, fill out the type with repeated calls to
NF90\_INSERT\_ENUM (see section [Inserting a Field into a Enum Type:
NF90\_INSERT\_ENUM](#NF90_005fINSERT_005fENUM)). Call NF90\_INSERT\_ENUM
once for each value you wish to make part of the enumeration.



### Usage



~~~~.fortran

  function nf90_def_enum(ncid, base_typeid, name, typeid)
    integer, intent(in) :: ncid
    integer, intent(in) :: base_typeid
    character (len = *), intent(in) :: name
    integer, intent(out) :: typeid
    integer :: nf90_def_enum


~~~~


`NCID`

:   The groupid where this compound type will be created.

`BASE_TYPEID`

:   The base integer type for this enum. Must be one of: NF90\_BYTE,
    NF90\_UBYTE, NF90\_SHORT, NF90\_USHORT, NF90\_INT, NF90\_UINT,
    NF90\_INT64, NF90\_UINT64.

`NAME`

:   The name of the new enum type.

`TYPEIDP`

:   The typeid of the new type will be placed here.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Compound type names must be unique in the
    data file.

`NF90_EMAXNAME`

:   Name exceeds max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag NF90\_NETCDF4. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_EPERM`

:   Attempt to write to a read-only file.

`NF90_ENOTINDEFINE`

:   Not in define mode.



### Example



## 5.9.2 Inserting a Field into a Enum Type: NF90_INSERT_ENUM {#f90-inserting-a-field-into-a-enum-type-nf90_insert_enum}



Insert a named member into a enum type.



### Usage



~~~~.fortran

  function nf90_insert_enum(ncid, xtype, name, value)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(in) :: name
    integer, intent(in) :: value
    integer :: nf90_insert_enum


~~~~


`NCID`

:   The ncid of the group which contains the type.

`TYPEID`

:   The typeid for this enum type, as returned by nf90\_def\_enum,
    or nf90\_inq\_var.

`IDENTIFIER`

:   The identifier of the new member.

`VALUE`

:   The value that is to be associated with this member.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Field names must be unique within a enum type.

`NF90_EMAXNAME`

:   Name exceed max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag NF90\_NETCDF4. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90\_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_ENOTINDEFINE`

:   Not in define mode.



### Example

## 5.9.3 Learn About a Enum Type: NF90_INQ_ENUM {#f90-learn-about-a-enum-type-nf90_inq_enum}



Get information about a user-defined enumeration type.



### Usage


~~~~.fortran


  function nf90_inq_enum(ncid, xtype, name, base_nc_type, base_size, num_members)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    character (len = *), intent(out) :: name
    integer, intent(out) :: base_nc_type
    integer, intent(out) :: base_size
    integer, intent(out) :: num_members
    integer :: nf90_inq_enum



~~~~

`NCID`

:   The group ID of the group which holds the enum type.

`XTYPE`

:   The typeid for this enum type, as returned by NF90\_DEF\_ENUM,
    or NF90\_INQ\_VAR.

`NAME`

:   Character array which will get the name. It will have a maximum
    length of NF90\_MAX\_NAME.

`BASE_NF90_TYPE`

:   An integer which will get the base integer type of this enum.

`BASE_SIZE`

:   An integer which will get the size (in bytes) of the base integer
    type of this enum.

`NUM_MEMBERS`

:   An integer which will get the number of members defined for this
    enumeration type.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad type id.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example


## 5.9.4 Learn the Name of a Enum Type: nf90_inq_enum_member {#f90-learn-the-name-of-a-enum-type-nf90_inq_enum_member}



Get information about a member of an enum type.



### Usage




~~~~.fortran
  function nf90_inq_enum_member(ncid, xtype, idx, name, value)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: idx
    character (len = *), intent(out) :: name
    integer, intent(in) :: value
    integer :: nf90_inq_enum_member

~~~~



`NCID`

:   The groupid where this enum type exists.

`XTYPE`

:   The typeid for this enum type.

`IDX`

:   The one-based index number for the member of interest.

`NAME`

:   A character array which will get the name of the member. It will
    have a maximum length of NF90\_MAX\_NAME.

`VALUE`

:   An integer that will get the value associated with this member.



### Errors

`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad type id.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



### Example



## 5.9.5 Learn the Name of a Enum Type: NF90_INQ_ENUM_IDENT {#f90-learn-the-name-of-a-enum-type-nf90_inq_enum_ident}



Get the name which is associated with an enum member value.

This is similar to NF90\_INQ\_ENUM\_MEMBER, but instead of using the
index of the member, you use the value of the member.



### Usage



~~~~.fortran

  function nf90_inq_enum_ident(ncid, xtype, value, idx)
    integer, intent(in) :: ncid
    integer, intent(in) :: xtype
    integer, intent(in) :: value
    integer, intent(out) :: idx
    integer :: nf90_inq_enum_ident


~~~~


`NCID`

:   The groupid where this enum type exists.

`XTYPE`

:   The typeid for this enum type.

`VALUE`

:   The value for which an identifier is sought.

`IDENTIFIER`

:   A character array that will get the identifier. It will have a
    maximum length of NF90\_MAX\_NAME.



### Return Code


`NF90_NOERR`

:   No error.

`NF90_EBADTYPEID`

:   Bad type id, or not an enum type.

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_EINVAL`

:   The value was not found in the enum.



### Example

1 Use of the NetCDF Library {#f90-use-of-the-netcdf-library}
=====================

[TOC]

In this chapter we provide templates of common sequences of netCDF calls
needed for common uses. For clarity we present only the names of
routines; omit declarations and error checking; omit the type-specific
suffixes of routine names for variables and attributes; indent
statements that are typically invoked multiple times; and use ... to
represent arbitrary sequences of other statements. Full parameter lists
are described in later chapters.

1.1 Creating a NetCDF Dataset {#f90-creating-a-netcdf-dataset}
=====================

Here is a typical sequence of netCDF calls used to create a new netCDF
dataset:

~~~~.fortran


     NF90_CREATE           ! create netCDF dataset: enter define mode
          ...
        NF90_DEF_DIM       ! define dimensions: from name and length
          ...
        NF90_DEF_VAR       ! define variables: from name, type, dims
          ...
        NF90_PUT_ATT       ! assign attribute values
          ...
     NF90_ENDDEF           ! end definitions: leave define mode
          ...
        NF90_PUT_VAR       ! provide values for variable
          ...
     NF90_CLOSE            ! close: save new netCDF dataset

~~~~


Only one call is needed to create a netCDF dataset, at which point you
will be in the first of two netCDF modes. When accessing an open netCDF
dataset, it is either in define mode or data mode. In define mode, you
can create dimensions, variables, and new attributes, but you cannot
read or write variable data. In data mode, you can access data and
change existing attributes, but you are not permitted to create new
dimensions, variables, or attributes.

One call to NF90\_DEF\_DIM is needed for each dimension created.
Similarly, one call to NF90\_DEF\_VAR is needed for each variable
creation, and one call to a member of the NF90\_PUT\_ATT family is
needed for each attribute defined and assigned a value. To leave define
mode and enter data mode, call NF90\_ENDDEF.

Once in data mode, you can add new data to variables, change old values,
and change values of existing attributes (so long as the attribute
changes do not require more storage space). Data of all types is written
to a netCDF variable using the NF90\_PUT\_VAR subroutine. Single values,
arrays, or array sections may be supplied to NF90\_PUT\_VAR; optional
arguments allow the writing of subsampled or mapped portions of the
variable. (Subsampled and mapped access are general forms of data access
that are explained later.)

Finally, you should explicitly close all netCDF datasets that have been
opened for writing by calling NF90\_CLOSE. By default, access to the
file system is buffered by the netCDF library. If a program terminates
abnormally with netCDF datasets open for writing, your most recent
modifications may be lost. This default buffering of data is disabled by
setting the NF90\_SHARE flag when opening the dataset. But even if this
flag is set, changes to attribute values or changes made in define mode
are not written out until NF90\_SYNC or NF90\_CLOSE is called.

1.2 Reading a NetCDF Dataset with Known Names {#f90-reading-a-netcdf-dataset-with-known-names}
=====================
Here we consider the case where you know the names of not only the
netCDF datasets, but also the names of their dimensions, variables, and
attributes. (Otherwise you would have to do "inquire" calls.) The order
of typical C calls to read data from those variables in a netCDF dataset
is:

~~~~.fortran




     NF90_OPEN               ! open existing netCDF dataset
          ...
        NF90_INQ_DIMID       ! get dimension IDs
          ...
        NF90_INQ_VARID       ! get variable IDs
          ...
        NF90_GET_ATT         ! get attribute values
          ...
        NF90_GET_VAR         ! get values of variables
          ...
     NF90_CLOSE              ! close netCDF dataset



~~~~


First, a single call opens the netCDF dataset, given the dataset name,
and returns a netCDF ID that is used to refer to the open netCDF dataset
in all subsequent calls.

Next, a call to NF90\_INQ\_DIMID for each dimension of interest gets the
dimension ID from the dimension name. Similarly, each required variable
ID is determined from its name by a call to NF90\_INQ\_VARID. Once
variable IDs are known, variable attribute values can be retrieved using
the netCDF ID, the variable ID, and the desired attribute name as input
to NF90\_GET\_ATT for each desired attribute. Variable data values can
be directly accessed from the netCDF dataset with calls to
NF90\_GET\_VAR.

Finally, the netCDF dataset is closed with NF90\_CLOSE. There is no need
to close a dataset open only for reading.

1.3 Reading a netCDF Dataset with Unknown Names {#f90-reading-a-netcdf-dataset-with-unknown-names}
=====================

It is possible to write programs (e.g., generic software) which do such
things as processing every variable, without needing to know in advance
the names of these variables. Similarly, the names of dimensions and
attributes may be unknown.

Names and other information about netCDF objects may be obtained from
netCDF datasets by calling inquire functions. These return information
about a whole netCDF dataset, a dimension, a variable, or an attribute.
The following template illustrates how they are used:



~~~~.fortran

     NF90_OPEN                 ! open existing netCDF dataset
       ...
     NF90_INQUIRE              ! find out what is in it
          ...
        NF90_INQUIRE_DIMENSION ! get dimension names, lengths
          ...
        NF90_INQUIRE_VARIABLE  ! get variable names, types, shapes
             ...
           NF90_INQ_ATTNAME    ! get attribute names
             ...
           NF90_INQUIRE_ATTRIBUTE ! get other attribute information
             ...
           NF90_GET_ATT        ! get attribute values
             ...
        NF90_GET_VAR           ! get values of variables
          ...
     NF90_CLOSE                ! close netCDF dataset


~~~~


As in the previous example, a single call opens the existing netCDF
dataset, returning a netCDF ID. This netCDF ID is given to the
NF90\_INQUIRE routine, which returns the number of dimensions, the
number of variables, the number of global attributes, and the ID of the
unlimited dimension, if there is one.

All the inquire functions are inexpensive to use and require no I/O,
since the information they provide is stored in memory when a netCDF
dataset is first opened.

Dimension IDs use consecutive integers, beginning at 1. Also dimensions,
once created, cannot be deleted. Therefore, knowing the number of
dimension IDs in a netCDF dataset means knowing all the dimension IDs:
they are the integers 1, 2, 3, ...up to the number of dimensions. For
each dimension ID, a call to the inquire function
NF90\_INQUIRE\_DIMENSION returns the dimension name and length.

Variable IDs are also assigned from consecutive integers 1, 2, 3, ... up
to the number of variables. These can be used in NF90\_INQUIRE\_VARIABLE
calls to find out the names, types, shapes, and the number of attributes
assigned to each variable.

Once the number of attributes for a variable is known, successive calls
to NF90\_INQ\_ATTNAME return the name for each attribute given the
netCDF ID, variable ID, and attribute number. Armed with the attribute
name, a call to NF90\_INQUIRE\_ATTRIBUTE returns its type and length.
Given the type and length, you can allocate enough space to hold the
attribute values. Then a call to NF90\_GET\_ATT returns the attribute
values.

Once the IDs and shapes of netCDF variables are known, data values can
be accessed by calling NF90\_GET\_VAR.


1.4 Writing Data in an Existing NetCDF Dataset {#f90-writing-data-in-an-existing-netcdf-dataset}
=====================

With write access to an existing netCDF dataset, you can overwrite data
values in existing variables or append more data to record variables
along the unlimited (record) dimension. To append more data to
non-record variables requires changing the shape of such variables,
which means creating a new netCDF dataset, defining new variables with
the desired shape, and copying data. The netCDF data model was not
designed to make such "schema changes" efficient or easy, so it is best
to specify the shapes of variables correctly when you create a netCDF
dataset, and to anticipate which variables will later grow by using the
unlimited dimension in their definition.

The following code template lists a typical sequence of calls to
overwrite some existing values and add some new records to record
variables in an existing netCDF dataset with known variable names:


~~~~.fortran


     NF90_OPEN             ! open existing netCDF dataset
       ...
       NF90_INQ_VARID      ! get variable IDs
       ...
       NF90_PUT_VAR        ! provide new values for variables, if any
       ...
       NF90_PUT_ATT        ! provide new values for attributes, if any
         ...
     NF90_CLOSE            ! close netCDF dataset



~~~~

A netCDF dataset is first opened by the NF90\_OPEN call. This call puts
the open dataset in data mode, which means existing data values can be
accessed and changed, existing attributes can be changed, but no new
dimensions, variables, or attributes can be added.

Next, calls to NF90\_INQ\_VARID get the variable ID from the name, for
each variable you want to write. Then each call to NF90\_PUT\_VAR writes
data into a specified variable, either a single value at a time, or a
whole set of values at a time, depending on which variant of the
interface is used. The calls used to overwrite values of non-record
variables are the same as are used to overwrite values of record
variables or append new data to record variables. The difference is
that, with record variables, the record dimension is extended by writing
values that don’t yet exist in the dataset. This extends all record
variables at once, writing "fill values" for record variables for which
the data has not yet been written (but see section [Fill
Values](#Fill-Values) to specify different behavior).

Calls to NF90\_PUT\_ATT may be used to change the values of existing
attributes, although data that changes after a file is created is
typically stored in variables rather than attributes.

Finally, you should explicitly close any netCDF datasets into which data
has been written by calling NF90\_CLOSE before program termination.
Otherwise, modifications to the dataset may be lost.

1.5 Adding New Dimensions, Variables, Attributes {#f90-adding-new-dimensions-variables-attributes}
=====================

An existing netCDF dataset can be extensively altered. New dimensions,
variables, and attributes can be added or existing ones renamed, and
existing attributes can be deleted. Existing dimensions, variables, and
attributes can be renamed. The following code template lists a typical
sequence of calls to add new netCDF components to an existing dataset:


~~~~.fortran


     NF90_OPEN             ! open existing netCDF dataset
       ...
     NF90_REDEF            ! put it into define mode
         ...
       NF90_DEF_DIM        ! define additional dimensions (if any)
         ...
       NF90_DEF_VAR        ! define additional variables (if any)
         ...
       NF90_PUT_ATT        ! define other attributes (if any)
         ...
     NF90_ENDDEF           ! check definitions, leave define mode
         ...
       NF90_PUT_VAR        ! provide new variable values
         ...
     NF90_CLOSE            ! close netCDF dataset


~~~~


A netCDF dataset is first opened by the NF90\_OPEN call. This call puts
the open dataset in data mode, which means existing data values can be
accessed and changed, existing attributes can be changed (so long as
they do not grow), but nothing can be added. To add new netCDF
dimensions, variables, or attributes you must enter define mode, by
calling NF90\_REDEF. In define mode, call NF90\_DEF\_DIM to define new
dimensions, NF90\_DEF\_VAR to define new variables, and NF90\_PUT\_ATT
to assign new attributes to variables or enlarge old attributes.

You can leave define mode and reenter data mode, checking all the new
definitions for consistency and committing the changes to disk, by
calling NF90\_ENDDEF. If you do not wish to reenter data mode, just call
NF90\_CLOSE, which will have the effect of first calling NF90\_ENDDEF.

Until the NF90\_ENDDEF call, you may back out of all the redefinitions
made in define mode and restore the previous state of the netCDF dataset
by calling NF90\_ABORT. You may also use the NF90\_ABORT call to restore
the netCDF dataset to a consistent state if the call to NF90\_ENDDEF
fails. If you have called NF90\_CLOSE from definition mode and the
implied call to NF90\_ENDDEF fails, NF90\_ABORT will automatically be
called to close the netCDF dataset and leave it in its previous
consistent state (before you entered define mode).

At most one process should have a netCDF dataset open for writing at one
time. The library is designed to provide limited support for multiple
concurrent readers with one writer, via disciplined use of the
NF90\_SYNC function and the NF90\_SHARE flag. If a writer makes changes
in define mode, such as the addition of new variables, dimensions, or
attributes, some means external to the library is necessary to prevent
readers from making concurrent accesses and to inform readers to call
NF90\_SYNC before the next access.


1.6 Error Handling {#f90-error-handling}
=====================

The netCDF library provides the facilities needed to handle errors in a
flexible way. Each netCDF function returns an integer status value. If
the returned status value indicates an error, you may handle it in any
way desired, from printing an associated error message and exiting to
ignoring the error indication and proceeding (not recommended!). For
simplicity, the examples in this guide check the error status and call a
separate function to handle any errors.

The NF90\_STRERROR function is available to convert a returned integer
error status into an error message string.

Occasionally, low-level I/O errors may occur in a layer below the netCDF
library. For example, if a write operation causes you to exceed disk
quotas or to attempt to write to a device that is no longer available,
you may get an error from a layer below the netCDF library, but the
resulting write error will still be reflected in the returned status
value.

1.7 Compiling and Linking with the NetCDF Library {#f90-compiling-and-linking-with-the-netcdf-library}
=====================
Details of how to compile and link a program that uses the netCDF C or
Fortran interfaces differ, depending on the operating system, the
available compilers, and where the netCDF library and include files are
installed. Nevertheless, we provide here examples of how to compile and
link a program that uses the netCDF library on a Unix platform, so that
you can adjust these examples to fit your installation.

Every Fortran 90 procedure or module which references netCDF constants
or procedures must have access to the module information created when
the netCDF module was compiled. The suffix for this file is “MOD” (or
sometimes “mod”).

Most F90 compilers allow the user to specify the location of .MOD files,
usually with the -I flag.




    $ f90 -c -I/usr/local/include mymodule.f90




Starting with version 3.6.2, another method of building the netCDF
fortran libraries became available. With the –enable-separate-fortran
option to configure, the user can specify that the C library should not
contain the fortran functions. In these cases an additional library,
libnetcdff.a (note the extra “f”) will be built. This library contains
the Fortran functions. Since verion 4.1.3, the netCDF Fortran software
and library is always distinct from the netCDF C library, but depends on
it. If it is installed as a shared library, you need only use
‘-lnetcdff’ to specify the Fortran library for linking.

For more information about configure options, See [Specifying the
Environment for Building](netcdf-install.html#Specifying-the-Environment-for-Building)
in {No value for ‘i-man’}.

If installed as a shared library, link, using something like:




    $ f90 -o myprogram myprogram.o -L/usr/local/lib -lnetcdff




If installed as a static library, you will at least need to mention the
netCDF C library and perhaps other libraries, such as hdf5 or curl,
depending on how the C library was built. For example:




    $ f90 -o myprogram myprogram.o -L/usr/local/lib -lnetcdff -lnetcdf




Use of the nf-config utility program, installed as part of the
netcdf-fortran software, provides an easier way to compile and link,
without needing to know the details of where the library has been
installed, or whether it is installed as a shared or static library.

To see all the options for ‘nf-config’, invoke it with the ‘–help’
argument.

Here’s an example of how you could use ‘nf-config’ to compile and link a
Fortran program in one step:




    $ f90 myprogram.f90 -o myprogram `nf-config --fflags --flibs`




If it is installed on your system, you could also use the ‘pkg-config’
utility to compile and link Fortran programs with the netCDF libraries.
This is especially useful in Makefiles, to insulate them from changes to
library versions and dependencies. Here is an example of how you could
compile and link a Fortran program with netCDF libraries using
pkg-config:




    $ export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig
    $ f90 myprogram.f90 -o myprogram `pkg-config --cflags --libs netcdf-fortran`




where here ‘–cflags’ means compiler flags and ‘libs’ requests that the
approriate libraries be linked in.

6 Variables {#f90-variables}
===========

[TOC]

6.1 Variables Introduction {#f90-variables-introduction}
===========

Variables for a netCDF dataset are defined when the dataset is created,
while the netCDF dataset is in define mode. Other variables may be added
later by reentering define mode. A netCDF variable has a name, a type,
and a shape, which are specified when it is defined. A variable may also
have values, which are established later in data mode.

Ordinarily, the name, type, and shape are fixed when the variable is
first defined. The name may be changed, but the type and shape of a
variable cannot be changed. However, a variable defined in terms of the
unlimited dimension can grow without bound in that dimension.

A netCDF variable in an open netCDF dataset is referred to by a small
integer called a variable ID.

Variable IDs reflect the order in which variables were defined within a
netCDF dataset. Variable IDs are 1, 2, 3,..., in the order in which the
variables were defined. A function is available for getting the variable
ID from the variable name and vice-versa.

Attributes (see [Attributes](#Attributes)) may be associated with a
variable to specify such properties as units.

Operations supported on variables are:

-   Create a variable, given its name, data type, and shape.
-   Get a variable ID from its name.
-   Get a variable’s name, data type, shape, and number of attributes
    from its ID.
-   Put a data value into a variable, given variable ID, indices,
    and value.
-   Put an array of values into a variable, given variable ID, corner
    indices, edge lengths, and a block of values.
-   Put a subsampled or mapped array-section of values into a variable,
    given variable ID, corner indices, edge lengths, stride vector,
    index mapping vector, and a block of values.
-   Get a data value from a variable, given variable ID and indices.
-   Get an array of values from a variable, given variable ID, corner
    indices, and edge lengths.
-   Get a subsampled or mapped array-section of values from a variable,
    given variable ID, corner indices, edge lengths, stride vector, and
    index mapping vector.
-   Rename a variable.


6.2 Language Types Corresponding to netCDF external data types {#f90-language-types-corresponding-to-netcdf-external-data-types}
===========

The following table gives the netCDF external data types and the
corresponding type constants for defining variables in the FORTRAN
interface:

Type   |  FORTRAN API Mnemonic |  Bits
-------| ----------------------| ------
byte   |  NF90_BYTE           |  8
char   |  NF90_CHAR           |  8
short  |  NF90_SHORT          |  16
int    |  NF90_INT            |  32
float  |  NF90_FLOAT          |  32
double |  NF90_DOUBLE         |  64


The first column gives the netCDF external data type, which is the same
as the CDL data type. The next column gives the corresponding Fortran 90
parameter for use in netCDF functions (the parameters are defined in the
netCDF Fortran 90 module netcdf.f90). The last column gives the number
of bits used in the external representation of values of the
corresponding type.

Note that there are no netCDF types corresponding to 64-bit integers or
to characters wider than 8 bits in the current version of the netCDF
library.


6.3 Create a Variable: `NF90_DEF_VAR` {#f90-create-a-variable-nf90_def_var}
===========



The function NF90\_DEF\_VAR adds a new variable to an open netCDF
dataset in define mode. It returns (as an argument) a variable ID, given
the netCDF ID, the variable name, the variable type, the number of
dimensions, and a list of the dimension IDs.

Optional arguments allow additional settings for variables in
netCDF-4/HDF5 files. These parameters allow data compression and control
of the layout of the data on disk for performance tuning. These
parameters may also be used to set the chunk sizes to get chunked
storage, or to set the contiguous flag to get contiguous storage.

Variables that make use of one or more unlimited dimensions,
compression, or checksums must use chunking. Such variables are created
with default chunk sizes of 1 for each unlimited dimension and the
dimension length for other dimensions, except that if the resulting
chunks are too large, the default chunk sizes for non-record dimensions
are reduced.

All parameters after the varid are optional, and only supported if
netCDF was built with netCDF-4 features enabled, and if the variable is
in a netCDF-4/HDF5 file.



## Usage


~~~~.fortran


 function nf90_def_var(ncid, name, xtype, dimids, varid, contiguous, &
       chunksizes, deflate_level, shuffle, fletcher32, endianness, &
       cache_size, cache_nelems, cache_preemption)
   integer, intent(in) :: ncid
   character (len = *), intent(in) :: name
   integer, intent( in) :: xtype
   integer, scalar or dimension(:), intent(in), optional :: dimids
   integer, intent(out) :: varid
   logical, optional, intent(in) :: contiguous
   integer, optional, dimension(:), intent(in) :: chunksizes
   integer, optional, intent(in) :: deflate_level
   logical, optional, intent(in) :: shuffle, fletcher32
   integer, optional, intent(in) :: endianness
    integer, optional, intent(in) :: cache_size, cache_nelems, cache_preemption
   integer                                      :: nf90_def_var



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   Variable name.

`xtype`

:   One of the set of predefined netCDF external data types. The type of
    this parameter, is defined in the netCDF header file.
    
    The valid netCDF external data types are NF90\_BYTE, NF90\_CHAR,
    NF90\_SHORT, NF90\_INT, NF90\_FLOAT, and NF90\_DOUBLE. If the file
    is a NetCDF-4/HDF5 file, the additional types NF90\_UBYTE,
    NF90\_USHORT, NF90\_UINT, NF90\_INT64, NF90\_UINT64, and
    NF90\_STRING may be used, as well as a user defined type ID.

`dimids`

:   Scalar or vector of dimension IDs corresponding to the
    variable dimensions. For example, a vector of 2 dimension IDs
    specifies a 2-dimensional matrix.

    If an integer is passed for this parameter, a 1-D variable
    is created.

    If this parameter is not passed (or is a 1D array of size zero) it
    means the variable is a scalar with no dimensions.

    For classic data model files, if the ID of the unlimited dimension
    is included, it must be first. In expanded model netCDF4/HDF5 files,
    there may be any number of unlimited dimensions, and they may be
    used in any element of the dimids array.

    This argument is optional, and if absent specifies a scalar with
    no dimensions.

`varid`

:   Returned variable ID.

`storage`

:   If NF90\_CONTIGUOUS, then contiguous storage is used for
    this variable. Variables that use deflation, shuffle filter, or
    checksums, or that have one or more unlimited dimensions cannot use
    contiguous storage.

    If NF90\_CHUNKED, then chunked storage is used for this variable.
    Chunk sizes may be specified with the chunksizes parameter. Default
    sizes will be used if chunking is required and this function is
    not called.

    If NF90\_COMPACT, then compact storage is used for this variable.
    Compact storage may only be used on fix-sized variables with a
    total data size 64 MB or less. Compact datasets are stored with
    the file metadata, and can be read very quickly on a large number
    of parallel processors.

    By default contiguous storage is used for fix-sized variables when
    conpression, chunking, shuffle, and checksums are not used.

`chunksizes`

:   An array of chunk number of elements. This array has the number of
    elements along each dimension of the data chunk. The array must have
    the one chunksize for each dimension in the variable.

    The total size of a chunk must be less than 4 GiB. That is, the
    product of all chunksizes and the size of the data (or the size of
    nc\_vlen\_t for VLEN types) must be less than 4 GiB. (This is a very
    large chunk size in any case.)

    If not provided, but chunked data are needed, then default
    chunksizes will be chosen. For more information see [{No value for
    ‘n-man’}](netcdf.html#Chunking) in {No value for ‘n-man’}.

`shuffle`

:   If non-zero, turn on the shuffle filter.

`deflate_level`

:   If the deflate parameter is non-zero, set the deflate level to
    this value. Must be between 1 and 9.

`fletcher32`

:   Set to true to turn on fletcher32 checksums for this variable.

`endianness`

:   Set to NF90\_ENDIAN\_LITTLE for little-endian format,
    NF90\_ENDIAN\_BIG for big-endian format, and NF90\_ENDIAN\_NATIVE
    (the default) for the native endianness of the platform.

`cache_size`

:   The size of the per-variable cache in MegaBytes.

`cache_nelems`

:   The number slots in the per-variable chunk cache (should be a prime
    number larger than the number of chunks in the cache).

`cache_preemption`

:   The preemtion value must be between 0 and 100 inclusive and
    indicates how much chunks that have been fully read are favored
    for preemption. A value of zero means fully read chunks are treated
    no differently than other chunks (the preemption is strictly LRU)
    while a value of 100 means fully read chunks are always preempted
    before other chunks.



## Return Codes

NF90\_DEF\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error.

-   NF90\_EBADNAME The specified variable name is the name of another
    existing variable.
-   NF90\_EBADTYPE The specified type is not a valid netCDF type.
-   NF90\_EMAXDIMS The specified number of dimensions is negative or
    more than the constant NF90\_MAX\_VAR\_DIMS, the maximum number of
    dimensions permitted for a netCDF variable. (Does not apply to
    netCDF-4/HDF5 files unless they were created with the
    CLASSIC\_MODE flag.)
-   NF90\_EBADDIM One or more of the dimension IDs in the list of
    dimensions is not a valid dimension ID for the netCDF dataset.
-   NF90\_EMAXVARS The number of variables would exceed the constant
    NF90\_MAX\_VARS, the maximum number of variables permitted in a
    classic netCDF dataset. (Does not apply to netCDF-4/HDF5 files
    unless they were created with the CLASSIC\_MODE flag.)
-   NF90\_BADID The specified netCDF ID does not refer to an open
    netCDF dataset.
-   NF90\_ENOTNC4 NetCDF-4 operation attempted on a files that is not a
    netCDF-4/HDF5 file. Only variables in NetCDF-4/HDF5 files may use
    compression, chunking, and endianness control.
-   NF90\_ENOTVAR Can’t find this variable.
-   NF90\_EINVAL Invalid input. This may be because contiguous storage
    is requested for a variable that has compression, checksums,
    chunking, or one or more unlimited dimensions.
-   NF90\_ELATEDEF This variable has already been the subject of a
    NF90\_ENDDEF call. Once enddef has been called, it is impossible to
    set the chunking for a variable. (In netCDF-4/HDF5 files
    NF90\_ENDDEF will be called automatically for any data read
    or write.)
-   NF90\_ENOTINDEFINE Not in define mode. This is returned for netCDF
    classic or 64-bit offset files, or for netCDF-4 files, when they
    were been created with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).
-   NF90\_ESTRICTNC3 Trying to create a var some place other than the
    root group in a netCDF file with NF90\_STRICT\_NC3 turned on.



### Example

Here is an example using NF90\_DEF\_VAR to create a variable named rh of
type double with three dimensions, time, lat, and lon in a new netCDF
dataset named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: status, ncid
 integer :: LonDimId, LatDimId, TimeDimId
 integer :: RhVarId
 ...
 status = nf90_create("foo.nc", nf90_NoClobber, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 ! Define the dimensions
 status = nf90_def_dim(ncid, "lat", 5, LatDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 status = nf90_def_dim(ncid, "lon", 10, LonDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 status = nf90_def_dim(ncid, "time", nf90_unlimited, TimeDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 ! Define the variable
 status = nf90_def_var(ncid, "rh", nf90_double, &
                       (/ LonDimId, LatDimID, TimeDimID /), RhVarId)
 if(status /= nf90_NoErr) call handle_error(status)


~~~~


In the following example, from nf\_test/f90tst\_vars2.f90, chunking,
checksums, and endianness control are all used in a netCDF-4/HDF5 file.


~~~~.fortran


  ! Create the netCDF file.
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid, cache_nelems = CACHE_NELEMS, &
       cache_size = CACHE_SIZE))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define some variables.
  chunksizes = (/ NY, NX /)
  call check(nf90_def_var(ncid, VAR1_NAME, NF90_INT, dimids, varid1, chunksizes = chunksizes, &
       shuffle = .TRUE., fletcher32 = .TRUE., endianness = nf90_endian_big, deflate_level = DEFLATE_LEVEL))
  call check(nf90_def_var(ncid, VAR2_NAME, NF90_INT, dimids, varid2, contiguous = .TRUE.))
  call check(nf90_def_var(ncid, VAR3_NAME, NF90_INT64, varid3))
  call check(nf90_def_var(ncid, VAR4_NAME, NF90_INT, x_dimid, varid4, contiguous = .TRUE.))


~~~~


6.4 Define Fill Parameters for a Variable: `nf90_def_var_fill` {#f90-define-fill-parameters-for-a-variable-nf90_def_var_fill}
===========



The function NF90\_DEF\_VAR\_FILL sets the fill parameters for a
variable in a netCDF-4 file.

This function must be called after the variable is defined, but before
NF90\_ENDDEF is called.



## Usage



~~~~.fortran

NF90_DEF_VAR_FILL(INTEGER NCID, INTEGER VARID, INTEGER NO_FILL, FILL_VALUE);

~~~~



`NCID`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`VARID`

:   Variable ID.

`NO_FILL`

:   Set to non-zero value to set no\_fill mode on a variable. When this
    mode is on, fill values will not be written for the variable. This
    is helpful in high performance applications. For netCDF-4/HDF5 files
    (whether classic model or not), this may only be changed after the
    variable is defined, but before it is committed to disk (i.e. before
    the first NF90\_ENDDEF after the NF90\_DEF\_VAR.) For classic and
    64-bit offset file, the no\_fill mode may be turned on and off at
    any time.

`FILL_VALUE`

:   A value which will be used as the fill value for the variable. Must
    be the same type as the variable. This will be written to a
    \_FillValue attribute, created for this purpose. If NULL, this
    argument will be ignored.



## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.



## Example


6.5 Learn About Fill Parameters for a Variable: `NF90_INQ_VAR_FILL` {#f90-learn-about-fill-parameters-for-a-variable-nf90_inq_var_fill}
===========



The function NF90\_INQ\_VAR\_FILL returns the fill settings for a
variable in a netCDF-4 file.



## Usage



~~~~.fortran

NF90_INQ_VAR_FILL(INTEGER NCID, INTEGER VARID, INTEGER NO_FILL, FILL_VALUE)

~~~~



`NCID`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`VARID`

:   Variable ID.

`NO_FILL`

:   An integer which will get a 1 if no\_fill mode is set for this
    variable, and a zero if it is not set

`FILL_VALUE`

:   This will get the fill value for this variable. This parameter will
    be ignored if it is NULL.



## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.



## Example

6.6 Define Filter Parameters for a Variable: `nf90_def_var_filter` {#f90-define-filter-parameters-for-a-variable-nf90_def_var_filter}
===========



The function nf90\_def\_var\_filter sets the filter parameters for a
variable in a netCDF-4 file.

This function must be called after the variable is defined, but before
nf90\_enddef is called.



## Usage


~~~~.fortran

function nf90_def_var_filter(ncid, varid, filterid, nparams, params);
   integer, intent(in) :: ncid, varid, filterid, nparams
   integer, dimension(:), intent(in) :: params

~~~~


`ncid`

:   NetCDF ID, from a previous call to nf90\_open or nf90\_create.

`varid`

:   Variable ID.

`filterid`

:   The HDFGroup assigned filter id (e.g. 307 for bzip2).

`nparams`

:   The number of parameters for the filter

`params`

:   A vector of parameters of size nparams.


## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.

`NF90_EFILTER`

:   Invalid filter id or parameters


## Example

6.7 Get information about any Filter associated with a variable: `nf90_inq_var_filter` {#f90-get-information-about-a-variable-from-its-id-nf90_inq_var_filter}
===========


The function nf90\_inq\_var\_filter gets the filter id and parameters for a
variable in a netCDF-4 file.


## Usage


~~~~.fortran

function nf90_inq_var_filter(ncid, varid, filterid, nparams, params);
   integer, intent(in) :: ncid, varid, filterid, nparams
   integer, intent(out) :: filterid, nparams
   integer, dimension(:), intent(out) :: params

~~~~


`ncid`

:   NetCDF ID, from a previous call to nf90\_open or nf90\_create.

`varid`

:   Variable ID.

`filterid`

:   Store the the HDFGroup assigned filter id

`nparams`

:   Stor the number of parameters for the filter

`params`

:   Store the vector of parameters of size nparams.

## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.

`NF90_EFILTER`

:   Invalid filter id or parameters


## Example


6.8 Get Information about a Variable from Its ID: NF90_INQUIRE_VARIABLE {#f90-get-information-about-a-variable-from-its-id-nf90_inquire_variable}
===========

NF90\_INQUIRE\_VARIABLE returns information about a netCDF variable
given its ID. Information about a variable includes its name, type,
number of dimensions, a list of dimension IDs describing the shape of
the variable, and the number of variable attributes that have been
assigned to the variable.

All parameters after nAtts are optional, and only supported if netCDF
was built with netCDF-4 features enabled, and if the variable is in a
netCDF-4/HDF5 file.



## Usage


~~~~.fortran


  function nf90_inquire_variable(ncid, varid, name, xtype, ndims, dimids, nAtts, &
       contiguous, chunksizes, deflate_level, shuffle, fletcher32, endianness)
    integer, intent(in) :: ncid, varid
    character (len = *), optional, intent(out) :: name
    integer, optional, intent(out) :: xtype, ndims
    integer, dimension(:), optional, intent(out) :: dimids
    integer, optional, intent(out) :: nAtts
    logical, optional, intent(out) :: contiguous
    integer, optional, dimension(:), intent(out) :: chunksizes
    integer, optional, intent(out) :: deflate_level
    logical, optional, intent(out) :: shuffle, fletcher32
    integer, optional, intent(out) :: endianness
    integer :: nf90_inquire_variable



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`name`

:   Returned variable name. The caller must allocate space for the
    returned name. The maximum possible length, in characters, of a
    variable name is given by the predefined constant NF90\_MAX\_NAME.

`xtype`

:   Returned variable type, one of the set of predefined netCDF external
    data types. The valid netCDF external data types are NF90\_BYTE,
    NF90\_CHAR, NF90\_SHORT, NF90\_INT, NF90\_FLOAT, AND NF90\_DOUBLE.

`ndims`

:   Returned number of dimensions the variable was defined as using. For
    example, 2 indicates a matrix, 1 indicates a vector, and 0 means the
    variable is a scalar with no dimensions.

`dimids`

:   Returned vector of \*ndimsp dimension IDs corresponding to the
    variable dimensions. The caller must allocate enough space for a
    vector of at least \*ndimsp integers to be returned. The maximum
    possible number of dimensions for a variable is given by the
    predefined constant NF90\_MAX\_VAR\_DIMS.

`natts`

:   Returned number of variable attributes assigned to this variable.

`contiguous`

:   On return, set to NF90\_CONTIGUOUS if this variable uses contiguous
    storage, NF90\_CHUNKED if it uses chunked storage.

`chunksizes`

:   An array of chunk sizes. The array must have the one element for
    each dimension in the variable.

`shuffle`

:   True if the shuffle filter is turned on for this variable.

`deflate_level`

:   The deflate\_level from 0 to 9. A value of zero indicates no
    deflation is in use.

`fletcher32`

:   Set to true if the fletcher32 checksum filter is turned on for
    this variable.

`endianness`

:   Will be set to NF90\_ENDIAN\_LITTLE if this variable is stored in
    little-endian format, NF90\_ENDIAN\_BIG if it is stored in
    big-endian format, and NF90\_ENDIAN\_NATIVE if the endianness is not
    set, and the variable is not created yet.

These functions return the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_VAR to find out about a variable
named rh in an existing netCDF dataset named foo.nc:


~~~~.fortran


    use netcdf
    implicit none
    integer                            :: status, ncid, &
                                          RhVarId       &
                                          numDims, numAtts
 integer, dimension(nf90_max_var_dims) :: rhDimIds
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 status = nf90_inq_varid(ncid, "rh", RhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, ndims = numDims, natts = numAtts)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, dimids = rhDimIds(:numDims))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


6.9 Get the ID of a variable from the name: NF90_INQ_VARID {#f90-get-the-id-of-a-variable-from-the-name-nf90_inq_varid}
===========



Given the name of a varaible, nf90\_inq\_varid finds the variable ID.



## Usage


~~~~.fortran


  function nf90_inq_varid(ncid, name, varid)
    integer, intent(in) :: ncid
    character (len = *), intent( in) :: name
    integer, intent(out) :: varid
    integer :: nf90_inq_varid


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   The variable name. The maximum possible length, in characters, of a
    variable name is given by the predefined constant NF90\_MAX\_NAME.

`varid`

:   Variable ID.

These functions return the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   Variable not found.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_VARID to find out about a variable
named rh in an existing netCDF dataset named foo.nc:



~~~~.fortran

    use netcdf
    implicit none
    integer                            :: status, ncid, &
                                          RhVarId       &
                                          numDims, numAtts
 integer, dimension(nf90_max_var_dims) :: rhDimIds
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 status = nf90_inq_varid(ncid, "rh", RhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, ndims = numDims, natts = numAtts)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, dimids = rhDimIds(:numDims))
 if(status /= nf90_NoErr) call handle_err(status)



~~~~


6.10 Writing Data Values: NF90_PUT_VAR {#f90-writing-data-values-nf90_put_var}
===========



The function NF90\_PUT\_VAR puts one or more data values into the
variable of an open netCDF dataset that is in data mode. Required inputs
are the netCDF ID, the variable ID, and one or more data values.
Optional inputs may indicate the starting position of the data values in
the netCDF variable (argument start), the sampling frequency with which
data values are written into the netCDF variable (argument stride), and
a mapping between the dimensions of the data array and the netCDF
variable (argument map). The values to be written are associated with
the netCDF variable by assuming that the first dimension of the netCDF
variable varies fastest in the Fortran 90 interface. Data values are
converted to the external type of the variable, if necessary.

Take care when using the simplest forms of this interface with record
variables (variables that use the NF90\_UNLIMITED dimension) when you
don’t specify how many records are to be written. If you try to write
all the values of a record variable into a netCDF file that has no
record data yet (hence has 0 records), nothing will be written.
Similarly, if you try to write all the values of a record variable from
an array but there are more records in the file than you assume, more
in-memory data will be accessed than you expect, which may cause a
segmentation violation. To avoid such problems, it is better to specify
start and count arguments for variables that use the NF90\_UNLIMITED
dimension.



### Usage



~~~~.fortran

 function nf90_put_var(ncid, varid, values, start, count, stride, map)
   integer,                         intent( in) :: ncid, varid
   any valid type, scalar or array of any rank, &
                                    intent( in) :: values
   integer, dimension(:), optional, intent( in) :: start, count, stride, map
   integer                                      :: nf90_put_var


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`values`

:   The data value(s) to be written. The data may be of any type, and
    may be a scalar or an array of any rank. You cannot put CHARACTER
    data into a numeric variable or numeric data into a text variable.
    For numeric data, if the type of data differs from the netCDF
    variable type, type conversion will occur. See [Type
    Conversion](netcdf.html#Type-Conversion) in NetCDF Users Guide.

`start`

:   A vector of integers specifying the index in the variable where the
    first (or only) of the data values will be written. The indices are
    relative to 1, so for example, the first data value of a variable
    would have index (1, 1, ..., 1). The elements of start correspond,
    in order, to the variable’s dimensions. Hence, if the variable is a
    record variable, the last index would correspond to the starting
    record number for writing the data values.

    By default, start(:) = 1.

`count`

:   A vector of integers specifying the number of indices selected along
    each dimension. To write a single value, for example, specify count
    as (1, 1, ..., 1). The elements of count correspond, in order, to
    the variable’s dimensions. Hence, if the variable is a record
    variable, the last element of count corresponds to a count of the
    number of records to write.

    By default, count(:numDims) = shape(values) and count(numDims + 1:)
    = 1, where numDims = size(shape(values)).

`stride`

:   A vector of integers that specifies the sampling interval along each
    dimension of the netCDF variable. The elements of the stride vector
    correspond, in order, to the netCDF variable’s dimensions (stride(1)
    gives the sampling interval along the most rapidly varying dimension
    of the netCDF variable). Sampling intervals are specified in
    type-independent units of elements (a value of 1 selects consecutive
    elements of the netCDF variable along the corresponding dimension, a
    value of 2 selects every other element, etc.).

    By default, stride(:) = 1.

`imap`

:   A vector of integers that specifies the mapping between the
    dimensions of a netCDF variable and the in-memory structure of the
    internal data array. The elements of the index mapping vector
    correspond, in order, to the netCDF variable’s dimensions (map(1)
    gives the distance between elements of the internal array
    corresponding to the most rapidly varying dimension of the
    netCDF variable). Distances between elements are specified in units
    of elements.

    By default, edgeLengths = shape(values), and map = (/ 1,
    (product(edgeLengths(:i)), i = 1, size(edgeLengths) - 1) /), that
    is, there is no mapping.

    Use of Fortran 90 intrinsic functions (including reshape, transpose,
    and spread) may let you avoid using this argument.



## Errors

NF90\_PUT\_VAR1\_ type returns the value NF90\_NOERR if no errors
occurred. Otherwise, the returned status indicates an error. Possible
causes of errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified indices were out of range for the rank of the
    specified variable. For example, a negative index or an index that
    is larger than the corresponding dimension length will cause
    an error.
-   The specified value is out of the range of values representable by
    the external data type of the variable.
-   The specified netCDF is in define mode rather than data mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_PUT\_VAR to set the (4,3,2) element of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
For simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, so we want to set the value of rh
that corresponds to the fourth lon value, the third lat value, and the
second time value:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_put_var(ncid, rhVarId, 0.5, start = (/ 4, 3, 2 /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


In this example we use NF90\_PUT\_VAR to add or change all the values of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
We assume that we know that rh is dimensioned with lon, lat, and time.
In this example we query the netCDF file to discover the lengths of the
dimensions, then use the Fortran 90 intrinsic function reshape to create
a temporary array of data values which is the same shape as the netCDF
variable.


~~~~.fortran


 use netcdf
 implicit none
 integer                               :: ncId, rhVarId,status,          &
                                          lonDimID, latDimId, timeDimId, &
                                          numLons, numLats, numTimes,    &
                                          i
 integer, dimension(nf90_max_var_dims) :: dimIDs
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! How big is the netCDF variable, that is, what are the lengths of
 !   its constituent dimensions?
 status = nf90_inquire_variable(ncid, rhVarId, dimids = dimIDs)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(1), len = numLons)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(2), len = numLats)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(3), len = numTimes)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Make a temporary array the same shape as the netCDF variable.
 status = nf90_put_var(ncid, rhVarId, &
                       reshape( &
                         (/ (0.5, i = 1, numLons * numLats * numTimes) /) , &
                        shape = (/ numLons, numLats, numTimes /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example using NF90\_PUT\_VAR to add or change a section of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
For simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, that there are ten lon values, five
lat values, and three time values, and that we want to replace all the
values at the last time.



~~~~.fortran

 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 10, numLats = 5, numTimes = 3
 real, dimension(numLons, numLats) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! Fill in all values at the last time
 rhValues(:, :) = 0.5
 status = nf90_put_var(ncid, rhVarId,rhvalues,       &
                       start = (/ 1, 1, numTimes /), &
                       count = (/ numLats, numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example of using NF90\_PUT\_VAR to write every other point of
a netCDF variable named rh having dimensions (6, 4).



~~~~.fortran

 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) &
                    :: rhValues = 0.5
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Fill in every other value using an array section
 status = nf90_put_var(ncid, rhVarId, rhValues(::2, ::2), &
                       stride = (/ 2, 2 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The following map vector shows the default mapping between a 2x3x4
netCDF variable and an internal array of the same shape:


~~~~.fortran


 real,    dimension(2, 3, 4):: a  ! same shape as netCDF variable
 integer, dimension(3)      :: map  = (/ 1, 2, 6 /)
                     ! netCDF dimension inter-element distance
                     ! ---------------- ----------------------
                     ! most rapidly varying       1
                     ! intermediate               2 (= map(1)*2)
                     ! most slowly varying        6 (= map(2)*3)


~~~~


Using the map vector above obtains the same result as simply not passing
a map vector at all.

Here is an example of using nf90\_put\_var to write a netCDF variable
named rh whose dimensions are the transpose of the Fortran 90 array:


~~~~.fortran


 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 !Write transposed values: map vector would be (/ 1, numLats /) for
 !   no transposition
 status = nf90_put_var(ncid, rhVarId,rhValues, map = (/ numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The same effect can be obtained more simply using Fortran 90 intrinsic
functions:



~~~~.fortran

 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_put_var(ncid, rhVarId, transpose(rhValues))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~



6.11 Reading Data Values: NF90_GET_VAR {#f90-reading-data-values-nf90_get_var}
===========



The function NF90\_GET\_VAR gets one or more data values from a netCDF
variable of an open netCDF dataset that is in data mode. Required inputs
are the netCDF ID, the variable ID, and a specification for the data
values into which the data will be read. Optional inputs may indicate
the starting position of the data values in the netCDF variable
(argument start), the sampling frequency with which data values are read
from the netCDF variable (argument stride), and a mapping between the
dimensions of the data array and the netCDF variable (argument map). The
values to be read are associated with the netCDF variable by assuming
that the first dimension of the netCDF variable varies fastest in the
Fortran 90 interface. Data values are converted from the external type
of the variable, if necessary.

Take care when using the simplest forms of this interface with record
variables (variables that use the NF90\_UNLIMITED dimension) when you
don’t specify how many records are to be read. If you try to read all
the values of a record variable into an array but there are more records
in the file than you assume, more data will be read than you expect,
which may cause a segmentation violation. To avoid such problems, it is
better to specify the optional start and count arguments for variables
that use the NF90\_UNLIMITED dimension.

In netCDF classic model the maximum integer size is NF90\_INT, the
4-byte signed integer. Reading variables into an eight-byte integer
array from a classic model file will read from an NF90\_INT. Reading
variables into an eight-byte integer in a netCDF-4/HDF5 (without classic
model flag) will read from an NF90\_INT64



## Usage



~~~~.fortran

 function nf90_get_var(ncid, varid, values, start, count, stride, map)
   integer,                         intent( in) :: ncid, varid
   any valid type, scalar or array of any rank, &
                                    intent(out) :: values
   integer, dimension(:), optional, intent( in) :: start, count, stride, map
   integer                                      :: nf90_get_var


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`values`

:   The data value(s) to be read. The data may be of any type, and may
    be a scalar or an array of any rank. You cannot read CHARACTER data
    from a numeric variable or numeric data from a text variable. For
    numeric data, if the type of data differs from the netCDF variable
    type, type conversion will occur. See [Type
    Conversion](netcdf.html#Type-Conversion) in NetCDF Users Guide.

`start`

:   A vector of integers specifying the index in the variable from which
    the first (or only) of the data values will be read. The indices are
    relative to 1, so for example, the first data value of a variable
    would have index (1, 1, ..., 1). The elements of start correspond,
    in order, to the variable’s dimensions. Hence, if the variable is a
    record variable, the last index would correspond to the starting
    record number for writing the data values.

    By default, start(:) = 1.

`count`

:   A vector of integers specifying the number of indices selected along
    each dimension. To read a single value, for example, specify count
    as (1, 1, ..., 1). The elements of count correspond, in order, to
    the variable’s dimensions. Hence, if the variable is a record
    variable, the last element of count corresponds to a count of the
    number of records to read.

    By default, count(:numDims) = shape(values) and count(numDims + 1:)
    = 1, where numDims = size(shape(values)).

`stride`

:   A vector of integers that specifies the sampling interval along each
    dimension of the netCDF variable. The elements of the stride vector
    correspond, in order, to the netCDF variable’s dimensions (stride(1)
    gives the sampling interval along the most rapidly varying dimension
    of the netCDF variable). Sampling intervals are specified in
    type-independent units of elements (a value of 1 selects consecutive
    elements of the netCDF variable along the corresponding dimension, a
    value of 2 selects every other element, etc.).

    By default, stride(:) = 1.

`map`

:   A vector of integers that specifies the mapping between the
    dimensions of a netCDF variable and the in-memory structure of the
    internal data array. The elements of the index mapping vector
    correspond, in order, to the netCDF variable’s dimensions (map(1)
    gives the distance between elements of the internal array
    corresponding to the most rapidly varying dimension of the
    netCDF variable). Distances between elements are specified in units
    of elements.

    By default, edgeLengths = shape(values), and map = (/ 1,
    (product(edgeLengths(:i)), i = 1, size(edgeLengths) - 1) /), that
    is, there is no mapping.

    Use of Fortran 90 intrinsic functions (including reshape, transpose,
    and spread) may let you avoid using this argument.



## Errors

NF90\_GET\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The assumed or specified start, count, and stride generate an index
    which is out of range. Note that no error checking is possible on
    the map vector.
-   One or more of the specified values are out of the range of values
    representable by the desired type.
-   The specified netCDF is in define mode rather than data mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.

(As noted above, another possible source of error is using this
interface to read all the values of a record variable without specifying
the number of records. If there are more records in the file than you
assume, more data will be read than you expect!)



## Example

Here is an example using NF90\_GET\_VAR to read the (4,3,2) element of
the variable named rh from an existing netCDF dataset named foo.nc. For
simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, so we want to read the value of rh
that corresponds to the fourth lon value, the third lat value, and the
second time value:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 real    :: rhValue
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 -
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_get_var(ncid, rhVarId, rhValue, start = (/ 4, 3, 2 /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


In this example we use NF90\_GET\_VAR to read all the values of the
variable named rh from an existing netCDF dataset named foo.nc. We
assume that we know that rh is dimensioned with lon, lat, and time. In
this example we query the netCDF file to discover the lengths of the
dimensions, then allocate a Fortran 90 array the same shape as the
netCDF variable.




 use netcdf
 implicit none
 integer                               :: ncId, rhVarId, &
                                          lonDimID, latDimId, timeDimId, &
                                          numLons, numLats, numTimes,    &
                                          status
 integer, dimension(nf90_max_var_dims) :: dimIDs
 real, dimension(:, :, :), allocatable :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! How big is the netCDF variable, that is, what are the lengths of
 !   its constituent dimensions?
 status = nf90_inquire_variable(ncid, rhVarId, dimids = dimIDs)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(1), len = numLons)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(2), len = numLats)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(3), len = numTimes)
 if(status /= nf90_NoErr) call handle_err(status)
 allocate(rhValues(numLons, numLats, numTimes))
 ...
 status = nf90_get_var(ncid, rhVarId, rhValues)
 if(status /= nf90_NoErr) call handle_err(status)




Here is an example using NF90\_GET\_VAR to read a section of the
variable named rh from an existing netCDF dataset named foo.nc. For
simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, that there are ten lon values, five
lat values, and three time values, and that we want to replace all the
values at the last time.


~~~~.fortran


 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 10, numLats = 5, numTimes = 3
 real, dimension(numLons, numLats, numTimes) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 !Read the values at the last time by passing an array section
 status = nf90_get_var(ncid, rhVarId, rhValues(:, :, 3), &
                       start = (/ 1, 1, numTimes /),     &
                       count = (/ numLons, numLats, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example of using NF90\_GET\_VAR to read every other point of
a netCDF variable named rh having dimensions (6, 4).


~~~~.fortran


 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Read every other value into an array section
 status = nf90_get_var(ncid, rhVarId, rhValues(::2, ::2) &
                       stride = (/ 2, 2 /))
 if(status /= nf90_NoErr) call handle_err(status)



~~~~

The following map vector shows the default mapping between a 2x3x4
netCDF variable and an internal array of the same shape:


~~~~.fortran


 real,    dimension(2, 3, 4):: a  ! same shape as netCDF variable
 integer, dimension(3)      :: map  = (/ 1, 2, 6 /)
                     ! netCDF dimension inter-element distance
                     ! ---------------- ----------------------
                     ! most rapidly varying       1
                     ! intermediate               2 (= map(1)*2)
                     ! most slowly varying        6 (= map(2)*3)




~~~~

Using the map vector above obtains the same result as simply not passing
a map vector at all.

Here is an example of using nf90\_get\_var to read a netCDF variable
named rh whose dimensions are the transpose of the Fortran 90 array:



~~~~.fortran

 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Read transposed values: map vector would be (/ 1, numLats /) for
 !   no transposition
 status = nf90_get_var(ncid, rhVarId,rhValues, map = (/ numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The same effect can be obtained more simply, though using more memory,
using Fortran 90 intrinsic functions:


~~~~.fortran


 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 real, dimension(numLons, numLats) :: tempValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_get_var(ncid, rhVarId, tempValues))
 if(status /= nf90_NoErr) call handle_err(status)
 rhValues(:, :) = transpose(tempValues)


~~~~




6.12 Reading and Writing Character String Values {#f90-reading-and-writing-character-string-values}
===========

Character strings are not a primitive netCDF external data type under
the classic netCDF data model, in part because FORTRAN does not support
the abstraction of variable-length character strings (the FORTRAN LEN
function returns the static length of a character string, not its
dynamic length). As a result, a character string cannot be written or
read as a single object in the netCDF interface. Instead, a character
string must be treated as an array of characters, and array access must
be used to read and write character strings as variable data in netCDF
datasets. Furthermore, variable-length strings are not supported by the
netCDF classic interface except by convention; for example, you may
treat a zero byte as terminating a character string, but you must
explicitly specify the length of strings to be read from and written to
netCDF variables.

Character strings as attribute values are easier to use, since the
strings are treated as a single unit for access. However, the value of a
character-string attribute in the classic netCDF interface is still an
array of characters with an explicit length that must be specified when
the attribute is defined.

When you define a variable that will have character-string values, use a
character-position dimension as the most quickly varying dimension for
the variable (the first dimension for the variable in Fortran 90). The
length of the character-position dimension will be the maximum string
length of any value to be stored in the character-string variable. Space
for maximum-length strings will be allocated in the disk representation
of character-string variables whether you use the space or not. If two
or more variables have the same maximum length, the same
character-position dimension may be used in defining the variable
shapes.

To write a character-string value into a character-string variable, use
either entire variable access or array access. The latter requires that
you specify both a corner and a vector of edge lengths. The
character-position dimension at the corner should be one for Fortran 90.
If the length of the string to be written is n, then the vector of edge
lengths will specify n in the character-position dimension, and one for
all the other dimensions: (n, 1, 1, ..., 1).

In Fortran 90, fixed-length strings may be written to a netCDF dataset
without a terminating character, to save space. Variable-length strings
should follow the C convention of writing strings with a terminating
zero byte so that the intended length of the string can be determined
when it is later read by either C or Fortran 90 programs. It is the
users responsibility to provide such null termination.

If you are writing data in the default prefill mode (see next section),
you can ensure that simple strings represented as 1-dimensional
character arrays are null terminated in the netCDF file by writing fewer
characters than the length declared when the variable was defined. That
way, the extra unwritten characters will be filled with the default
character fill value, which is a null byte. The Fortran intrinsic TRIM
function can be used to trim trailing blanks from the character string
argument to NF90\_PUT\_VAR to make the argument shorter than the
declared length. If prefill is not on, the data writer must explicitly
provide a null terminating byte.

Here is an example illustrating this way of writing strings to character
array variables:



~~~~.fortran

 use netcdf
 implicit none
 integer status
 integer                           :: ncid, oceanStrLenID, oceanId
 integer, parameter                :: MaxOceanNameLen = 20
 character, (len = MaxOceanNameLen):: ocean
 ...
 status = nf90_create("foo.nc", nf90_NoClobber, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_def_dim(ncid, "oceanStrLen", MaxOceanNameLen, oceanStrLenId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_def_var(ncid, "ocean", nf90_char, (/ oceanStrLenId /), oceanId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Leave define mode, which prefills netCDF variables with fill values
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Note that this assignment adds blank fill
 ocean = "Pacific"
 ! Using trim removes trailing blanks, prefill provides null
 ! termination, so C programs can later get intended string.
 status = nf90_put_var(ncid, oceanId, trim(ocean))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


6.13 Fill Values {#f90-fill-values}
===========

What happens when you try to read a value that was never written in an
open netCDF dataset? You might expect that this should always be an
error, and that you should get an error message or an error status
returned. You do get an error if you try to read data from a netCDF
dataset that is not open for reading, if the variable ID is invalid for
the specified netCDF dataset, or if the specified indices are not
properly within the range defined by the dimension lengths of the
specified variable. Otherwise, reading a value that was not written
returns a special fill value used to fill in any undefined values when a
netCDF variable is first written.

You may ignore fill values and use the entire range of a netCDF external
data type, but in this case you should make sure you write all data
values before reading them. If you know you will be writing all the data
before reading it, you can specify that no prefilling of variables with
fill values will occur by calling writing. This may provide a
significant performance gain for netCDF writes.

The variable attribute \_FillValue may be used to specify the fill value
for a variable. There are default fill values for each type, defined in
module netcdf: NF90\_FILL\_CHAR, NF90\_FILL\_INT1 (same as
NF90\_FILL\_BYTE), NF90\_FILL\_INT2 (same as NF90\_FILL\_SHORT),
NF90\_FILL\_INT, NF90\_FILL\_REAL (same as NF90\_FILL\_FLOAT), and
NF90\_FILL\_DOUBLE

The netCDF byte and character types have different default fill values.
The default fill value for characters is the zero byte, a useful value
for detecting the end of variable-length C character strings. If you
need a fill value for a byte variable, it is recommended that you
explicitly define an appropriate \_FillValue attribute, as generic
utilities such as ncdump will not assume a default fill value for byte
variables.

Type conversion for fill values is identical to type conversion for
other values: attempting to convert a value from one type to another
type that can’t represent the value results in a range error. Such
errors may occur on writing or reading values from a larger type (such
as double) to a smaller type (such as float), if the fill value for the
larger type cannot be represented in the smaller type.


6.14 NF90_RENAME_VAR {#f90-nf90_rename_var}
===========



The function NF90\_RENAME\_VAR changes the name of a netCDF variable in
an open netCDF dataset. If the new name is longer than the old name, the
netCDF dataset must be in define mode. You cannot rename a variable to
have the name of any existing variable.



## Usage



~~~~.fortran

 function nf90_rename_var(ncid, varid, newname)
   integer,             intent( in) :: ncid, varid
   character (len = *), intent( in) :: newname
   integer                          :: nf90_rename_var

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`newname`

:   New name for the specified variable.



## Errors

NF90\_RENAME\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The new name is in use as the name of another variable.
-   The variable ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_RENAME\_VAR to rename the variable rh to
rel\_hum in an existing netCDF dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_redef(ncid)  ! Enter define mode to change variable name
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_rename_var(ncid, rhVarId, "rel_hum")
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_enddef(ncid) ! Leave define mode
 if(status /= nf90_NoErr) call handle_err(status)



~~~~


6.15 Change between Collective and Independent Parallel Access: NF90_VAR_PAR_ACCESS {#f90-change-between-collective-and-independent-parallel-access-nf90_var_par_access}
===========



The function NF90\_VAR\_PAR\_ACCESS changes whether read/write
operations on a parallel file system are performed collectively or
independently (the default) on the variable. This function can only be
called if the file was created (see [NF90\_CREATE](#NF90_005fCREATE)) or
opened (see [NF90\_OPEN](#NF90_005fOPEN)) for parallel I/O.

This function is only available if the netCDF library was built with
parallel I/O enabled.

Calling this function affects only the open file - information about
whether a variable is to be accessed collectively or independently is
not written to the data file. Every time you open a file on a parallel
file system, all variables default to independent operations. The change
of a variable to collective access lasts only as long as that file is
open.

The variable can be changed from collective to independent, and back, as
often as desired.

Classic and 64-bit offset files, when opened for parallel access, use
the parallel-netcdf (a.k.a. pnetcdf) library, which does not allow
per-variable changes of access mode - the entire file must be access
independently or collectively. For classic and 64-bit offset files, the
nf90\_var\_par\_access function changes the access for all variables in
the file.



## Usage



~~~~.fortran

  function nf90_var_par_access(ncid, varid, access)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: access
    integer :: nf90_var_par_access
  end function nf90_var_par_access

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN (see
    [NF90\_OPEN](#NF90_005fOPEN)) or NF90\_CREATE (see
    [NF90\_CREATE](#NF90_005fCREATE)).

`varid`

:   Variable ID.

`access`

:   NF90\_INDEPENDENT to set this variable to independent operations.
    NF90\_COLLECTIVE to set it to collective operations.



## Return Values

`NF90_NOERR`

:   No error.

`NF90_ENOTVAR`

:   No variable found.

`NF90_NOPAR`

:   File not opened for parallel access.



## Example

This example comes from test program nf\_test/f90tst\_parallel.f90. For
this test to be run, netCDF must have been built with a parallel-enabled
HDF5, and –enable-parallel-tests must have been used when configuring
netcdf.



~~~~.fortran

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Set collective access on this variable. This will cause all
  ! reads/writes to happen together on every processor.
  call handle_err(nf90_var_par_access(ncid, varid, nf90_collective))

  ! Read this processor's data.
  call handle_err(nf90_get_var(ncid, varid, data_in, start = start, count = count))

~~~~

6 Variables {#f90-variables}
===========

[TOC]

6.1 Variables Introduction {#f90-variables-introduction}
===========

Variables for a netCDF dataset are defined when the dataset is created,
while the netCDF dataset is in define mode. Other variables may be added
later by reentering define mode. A netCDF variable has a name, a type,
and a shape, which are specified when it is defined. A variable may also
have values, which are established later in data mode.

Ordinarily, the name, type, and shape are fixed when the variable is
first defined. The name may be changed, but the type and shape of a
variable cannot be changed. However, a variable defined in terms of the
unlimited dimension can grow without bound in that dimension.

A netCDF variable in an open netCDF dataset is referred to by a small
integer called a variable ID.

Variable IDs reflect the order in which variables were defined within a
netCDF dataset. Variable IDs are 1, 2, 3,..., in the order in which the
variables were defined. A function is available for getting the variable
ID from the variable name and vice-versa.

Attributes (see [Attributes](#Attributes)) may be associated with a
variable to specify such properties as units.

Operations supported on variables are:

-   Create a variable, given its name, data type, and shape.
-   Get a variable ID from its name.
-   Get a variable’s name, data type, shape, and number of attributes
    from its ID.
-   Put a data value into a variable, given variable ID, indices,
    and value.
-   Put an array of values into a variable, given variable ID, corner
    indices, edge lengths, and a block of values.
-   Put a subsampled or mapped array-section of values into a variable,
    given variable ID, corner indices, edge lengths, stride vector,
    index mapping vector, and a block of values.
-   Get a data value from a variable, given variable ID and indices.
-   Get an array of values from a variable, given variable ID, corner
    indices, and edge lengths.
-   Get a subsampled or mapped array-section of values from a variable,
    given variable ID, corner indices, edge lengths, stride vector, and
    index mapping vector.
-   Rename a variable.


6.2 Language Types Corresponding to netCDF external data types {#f90-language-types-corresponding-to-netcdf-external-data-types}
===========

The following table gives the netCDF external data types and the
corresponding type constants for defining variables in the FORTRAN
interface:

Type   |  FORTRAN API Mnemonic |  Bits
-------| ----------------------| ------
byte   |  NF90_BYTE           |  8
char   |  NF90_CHAR           |  8
short  |  NF90_SHORT          |  16
int    |  NF90_INT            |  32
float  |  NF90_FLOAT          |  32
double |  NF90_DOUBLE         |  64


The first column gives the netCDF external data type, which is the same
as the CDL data type. The next column gives the corresponding Fortran 90
parameter for use in netCDF functions (the parameters are defined in the
netCDF Fortran 90 module netcdf.f90). The last column gives the number
of bits used in the external representation of values of the
corresponding type.

Note that there are no netCDF types corresponding to 64-bit integers or
to characters wider than 8 bits in the current version of the netCDF
library.


6.3 Create a Variable: `NF90_DEF_VAR` {#f90-create-a-variable-nf90_def_var}
===========



The function NF90\_DEF\_VAR adds a new variable to an open netCDF
dataset in define mode. It returns (as an argument) a variable ID, given
the netCDF ID, the variable name, the variable type, the number of
dimensions, and a list of the dimension IDs.

Optional arguments allow additional settings for variables in
netCDF-4/HDF5 files. These parameters allow data compression and control
of the layout of the data on disk for performance tuning. These
parameters may also be used to set the chunk sizes to get chunked
storage, or to set the contiguous flag to get contiguous storage.

Variables that make use of one or more unlimited dimensions,
compression, or checksums must use chunking. Such variables are created
with default chunk sizes of 1 for each unlimited dimension and the
dimension length for other dimensions, except that if the resulting
chunks are too large, the default chunk sizes for non-record dimensions
are reduced.

All parameters after the varid are optional, and only supported if
netCDF was built with netCDF-4 features enabled, and if the variable is
in a netCDF-4/HDF5 file.



## Usage


~~~~.fortran


 function nf90_def_var(ncid, name, xtype, dimids, varid, contiguous, &
       chunksizes, deflate_level, shuffle, fletcher32, endianness, &
       cache_size, cache_nelems, cache_preemption)
   integer, intent(in) :: ncid
   character (len = *), intent(in) :: name
   integer, intent( in) :: xtype
   integer, scalar or dimension(:), intent(in), optional :: dimids
   integer, intent(out) :: varid
   logical, optional, intent(in) :: contiguous
   integer, optional, dimension(:), intent(in) :: chunksizes
   integer, optional, intent(in) :: deflate_level
   logical, optional, intent(in) :: shuffle, fletcher32
   integer, optional, intent(in) :: endianness
   integer, optional, intent(in) :: cache_size, cache_nelems, cache_preemption
   integer, optional, intent(in) :: quantize_mode, nsd
   integer                                      :: nf90_def_var



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   Variable name.

`xtype`

:   One of the set of predefined netCDF external data types. The type of
    this parameter, is defined in the netCDF header file.
    
    The valid netCDF external data types are NF90\_BYTE, NF90\_CHAR,
    NF90\_SHORT, NF90\_INT, NF90\_FLOAT, and NF90\_DOUBLE. If the file
    is a NetCDF-4/HDF5 file, the additional types NF90\_UBYTE,
    NF90\_USHORT, NF90\_UINT, NF90\_INT64, NF90\_UINT64, and
    NF90\_STRING may be used, as well as a user defined type ID.

`dimids`

:   Scalar or vector of dimension IDs corresponding to the
    variable dimensions. For example, a vector of 2 dimension IDs
    specifies a 2-dimensional matrix.

    If an integer is passed for this parameter, a 1-D variable
    is created.

    If this parameter is not passed (or is a 1D array of size zero) it
    means the variable is a scalar with no dimensions.

    For classic data model files, if the ID of the unlimited dimension
    is included, it must be first. In expanded model netCDF4/HDF5 files,
    there may be any number of unlimited dimensions, and they may be
    used in any element of the dimids array.

    This argument is optional, and if absent specifies a scalar with
    no dimensions.

`varid`

:   Returned variable ID.

`storage`

:   If NF90\_CONTIGUOUS, then contiguous storage is used for
    this variable. Variables that use deflation, shuffle filter, or
    checksums, or that have one or more unlimited dimensions cannot use
    contiguous storage.

    If NF90\_CHUNKED, then chunked storage is used for this variable.
    Chunk sizes may be specified with the chunksizes parameter. Default
    sizes will be used if chunking is required and this function is
    not called.

    If NF90\_COMPACT, then compact storage is used for this variable.
    Compact storage may only be used on fix-sized variables with a
    total data size 64 MB or less. Compact datasets are stored with
    the file metadata, and can be read very quickly on a large number
    of parallel processors.

    By default contiguous storage is used for fix-sized variables when
    conpression, chunking, shuffle, and checksums are not used.

`chunksizes`

:   An array of chunk number of elements. This array has the number of
    elements along each dimension of the data chunk. The array must have
    the one chunksize for each dimension in the variable.

    The total size of a chunk must be less than 4 GiB. That is, the
    product of all chunksizes and the size of the data (or the size of
    nc\_vlen\_t for VLEN types) must be less than 4 GiB. (This is a very
    large chunk size in any case.)

    If not provided, but chunked data are needed, then default
    chunksizes will be chosen. For more information see [{No value for
    ‘n-man’}](netcdf.html#Chunking) in {No value for ‘n-man’}.

`shuffle`

:   If non-zero, turn on the shuffle filter.

`deflate_level`

:   If the deflate parameter is non-zero, set the deflate level to
    this value. Must be between 1 and 9.

`fletcher32`

:   Set to true to turn on fletcher32 checksums for this variable.

`endianness`

:   Set to NF90\_ENDIAN\_LITTLE for little-endian format,
    NF90\_ENDIAN\_BIG for big-endian format, and NF90\_ENDIAN\_NATIVE
    (the default) for the native endianness of the platform.

`cache_size`

:   The size of the per-variable cache in MegaBytes.

`cache_nelems`

:   The number slots in the per-variable chunk cache (should be a prime
    number larger than the number of chunks in the cache).

`cache_preemption`

:   The preemtion value must be between 0 and 100 inclusive and
    indicates how much chunks that have been fully read are favored
    for preemption. A value of zero means fully read chunks are treated
    no differently than other chunks (the preemption is strictly LRU)
    while a value of 100 means fully read chunks are always preempted
    before other chunks.

`quantize_mode`

:   Set to nf90_noquantize (0) for no quantization (the default), or
    nf90_quantize_bitgroom (1) for bitgroom quantization. Quantization
    allows users to specify a number of significant digits (NSD) in
    nf90_float and nf90_double variables. Bits beyond those needed to
    maintain the NSD are set to zero or one (alternating). This causes
    the data to compress better when compression is applied.

`nsd`

:   If quantize_mode is set to nf90_quantize_bitgroom, then this is the
    number of significant digits to be maintained in the data.

## Return Codes

NF90\_DEF\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error.

-   NF90\_EBADNAME The specified variable name is the name of another
    existing variable.
-   NF90\_EBADTYPE The specified type is not a valid netCDF type.
-   NF90\_EMAXDIMS The specified number of dimensions is negative or
    more than the constant NF90\_MAX\_VAR\_DIMS, the maximum number of
    dimensions permitted for a netCDF variable. (Does not apply to
    netCDF-4/HDF5 files unless they were created with the
    CLASSIC\_MODE flag.)
-   NF90\_EBADDIM One or more of the dimension IDs in the list of
    dimensions is not a valid dimension ID for the netCDF dataset.
-   NF90\_EMAXVARS The number of variables would exceed the constant
    NF90\_MAX\_VARS, the maximum number of variables permitted in a
    classic netCDF dataset. (Does not apply to netCDF-4/HDF5 files
    unless they were created with the CLASSIC\_MODE flag.)
-   NF90\_BADID The specified netCDF ID does not refer to an open
    netCDF dataset.
-   NF90\_ENOTNC4 NetCDF-4 operation attempted on a files that is not a
    netCDF-4/HDF5 file. Only variables in NetCDF-4/HDF5 files may use
    compression, chunking, and endianness control.
-   NF90\_ENOTVAR Can’t find this variable.
-   NF90\_EINVAL Invalid input. This may be because contiguous storage
    is requested for a variable that has compression, checksums,
    chunking, or one or more unlimited dimensions.
-   NF90\_ELATEDEF This variable has already been the subject of a
    NF90\_ENDDEF call. Once enddef has been called, it is impossible to
    set the chunking for a variable. (In netCDF-4/HDF5 files
    NF90\_ENDDEF will be called automatically for any data read
    or write.)
-   NF90\_ENOTINDEFINE Not in define mode. This is returned for netCDF
    classic or 64-bit offset files, or for netCDF-4 files, when they
    were been created with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).
-   NF90\_ESTRICTNC3 Trying to create a var some place other than the
    root group in a netCDF file with NF90\_STRICT\_NC3 turned on.



### Example

Here is an example using NF90\_DEF\_VAR to create a variable named rh of
type double with three dimensions, time, lat, and lon in a new netCDF
dataset named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: status, ncid
 integer :: LonDimId, LatDimId, TimeDimId
 integer :: RhVarId
 ...
 status = nf90_create("foo.nc", nf90_NoClobber, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 ! Define the dimensions
 status = nf90_def_dim(ncid, "lat", 5, LatDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 status = nf90_def_dim(ncid, "lon", 10, LonDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 status = nf90_def_dim(ncid, "time", nf90_unlimited, TimeDimId)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 ! Define the variable
 status = nf90_def_var(ncid, "rh", nf90_double, &
                       (/ LonDimId, LatDimID, TimeDimID /), RhVarId)
 if(status /= nf90_NoErr) call handle_error(status)


~~~~


In the following example, from nf\_test/f90tst\_vars2.f90, chunking,
checksums, and endianness control are all used in a netCDF-4/HDF5 file.


~~~~.fortran


  ! Create the netCDF file.
  call check(nf90_create(FILE_NAME, nf90_netcdf4, ncid, cache_nelems = CACHE_NELEMS, &
       cache_size = CACHE_SIZE))

  ! Define the dimensions.
  call check(nf90_def_dim(ncid, "x", NX, x_dimid))
  call check(nf90_def_dim(ncid, "y", NY, y_dimid))
  dimids =  (/ y_dimid, x_dimid /)

  ! Define some variables.
  chunksizes = (/ NY, NX /)
  call check(nf90_def_var(ncid, VAR1_NAME, NF90_INT, dimids, varid1, chunksizes = chunksizes, &
       shuffle = .TRUE., fletcher32 = .TRUE., endianness = nf90_endian_big, deflate_level = DEFLATE_LEVEL))
  call check(nf90_def_var(ncid, VAR2_NAME, NF90_INT, dimids, varid2, contiguous = .TRUE.))
  call check(nf90_def_var(ncid, VAR3_NAME, NF90_INT64, varid3))
  call check(nf90_def_var(ncid, VAR4_NAME, NF90_INT, x_dimid, varid4, contiguous = .TRUE.))


~~~~


6.4 Define Fill Parameters for a Variable: `nf90_def_var_fill` {#f90-define-fill-parameters-for-a-variable-nf90_def_var_fill}
===========



The function NF90\_DEF\_VAR\_FILL sets the fill parameters for a
variable in a netCDF-4 file.

This function must be called after the variable is defined, but before
NF90\_ENDDEF is called.



## Usage



~~~~.fortran

NF90_DEF_VAR_FILL(INTEGER NCID, INTEGER VARID, INTEGER NO_FILL, FILL_VALUE);

~~~~



`NCID`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`VARID`

:   Variable ID.

`NO_FILL`

:   Set to non-zero value to set no\_fill mode on a variable. When this
    mode is on, fill values will not be written for the variable. This
    is helpful in high performance applications. For netCDF-4/HDF5 files
    (whether classic model or not), this may only be changed after the
    variable is defined, but before it is committed to disk (i.e. before
    the first NF90\_ENDDEF after the NF90\_DEF\_VAR.) For classic and
    64-bit offset file, the no\_fill mode may be turned on and off at
    any time.

`FILL_VALUE`

:   A value which will be used as the fill value for the variable. Must
    be the same type as the variable. This will be written to a
    \_FillValue attribute, created for this purpose. If NULL, this
    argument will be ignored.



## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.



## Example


6.5 Learn About Fill Parameters for a Variable: `NF90_INQ_VAR_FILL` {#f90-learn-about-fill-parameters-for-a-variable-nf90_inq_var_fill}
===========



The function NF90\_INQ\_VAR\_FILL returns the fill settings for a
variable in a netCDF-4 file.



## Usage



~~~~.fortran

NF90_INQ_VAR_FILL(INTEGER NCID, INTEGER VARID, INTEGER NO_FILL, FILL_VALUE)

~~~~



`NCID`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`VARID`

:   Variable ID.

`NO_FILL`

:   An integer which will get a 1 if no\_fill mode is set for this
    variable, and a zero if it is not set

`FILL_VALUE`

:   This will get the fill value for this variable. This parameter will
    be ignored if it is NULL.



## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.



## Example

6.6 Define Filter Parameters for a Variable: `nf90_def_var_filter` {#f90-define-filter-parameters-for-a-variable-nf90_def_var_filter}
===========



The function nf90\_def\_var\_filter sets the filter parameters for a
variable in a netCDF-4 file.

This function must be called after the variable is defined, but before
nf90\_enddef is called.



## Usage


~~~~.fortran

function nf90_def_var_filter(ncid, varid, filterid, nparams, params);
   integer, intent(in) :: ncid, varid, filterid, nparams
   integer, dimension(:), intent(in) :: params

~~~~


`ncid`

:   NetCDF ID, from a previous call to nf90\_open or nf90\_create.

`varid`

:   Variable ID.

`filterid`

:   The HDFGroup assigned filter id (e.g. 307 for bzip2).

`nparams`

:   The number of parameters for the filter

`params`

:   A vector of parameters of size nparams.


## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.

`NF90_EFILTER`

:   Invalid filter id or parameters


## Example

6.7 Get information about any Filter associated with a variable: `nf90_inq_var_filter` {#f90-get-information-about-a-variable-from-its-id-nf90_inq_var_filter}
===========


The function nf90\_inq\_var\_filter gets the filter id and parameters for a
variable in a netCDF-4 file.


## Usage


~~~~.fortran

function nf90_inq_var_filter(ncid, varid, filterid, nparams, params);
   integer, intent(in) :: ncid, varid, filterid, nparams
   integer, intent(out) :: filterid, nparams
   integer, dimension(:), intent(out) :: params

~~~~


`ncid`

:   NetCDF ID, from a previous call to nf90\_open or nf90\_create.

`varid`

:   Variable ID.

`filterid`

:   Store the the HDFGroup assigned filter id

`nparams`

:   Stor the number of parameters for the filter

`params`

:   Store the vector of parameters of size nparams.

## Return Codes

`NF90_NOERR`

:   No error.

`NF90_BADID`

:   Bad ncid.

`NF90_ENOTNC4`

:   Not a netCDF-4 file.

`NF90_ENOTVAR`

:   Can’t find this variable.

`NF90_ELATEDEF`

:   This variable has already been the subject of a NF90\_ENDDEF call.
    In netCDF-4 files NF90\_ENDDEF will be called automatically for any
    data read or write. Once enddef has been called, it is impossible to
    set the fill for a variable.

`NF90_ENOTINDEFINE`

:   Not in define mode. This is returned for netCDF classic or 64-bit
    offset files, or for netCDF-4 files, when they were been created
    with NF90\_STRICT\_NC3 flag. (see section
    [NF90\_CREATE](#NF90_005fCREATE)).

`NF90_EPERM`

:   Attempt to create object in read-only file.

`NF90_EFILTER`

:   Invalid filter id or parameters


## Example


6.8 Get Information about a Variable from Its ID: NF90_INQUIRE_VARIABLE {#f90-get-information-about-a-variable-from-its-id-nf90_inquire_variable}
===========

NF90\_INQUIRE\_VARIABLE returns information about a netCDF variable
given its ID. Information about a variable includes its name, type,
number of dimensions, a list of dimension IDs describing the shape of
the variable, and the number of variable attributes that have been
assigned to the variable.

All parameters after nAtts are optional, and only supported if netCDF
was built with netCDF-4 features enabled, and if the variable is in a
netCDF-4/HDF5 file.



## Usage


~~~~.fortran


  function nf90_inquire_variable(ncid, varid, name, xtype, ndims, dimids, nAtts, &
       contiguous, chunksizes, deflate_level, shuffle, fletcher32, endianness)
    integer, intent(in) :: ncid, varid
    character (len = *), optional, intent(out) :: name
    integer, optional, intent(out) :: xtype, ndims
    integer, dimension(:), optional, intent(out) :: dimids
    integer, optional, intent(out) :: nAtts
    logical, optional, intent(out) :: contiguous
    integer, optional, dimension(:), intent(out) :: chunksizes
    integer, optional, intent(out) :: deflate_level
    logical, optional, intent(out) :: shuffle, fletcher32
    integer, optional, intent(out) :: endianness
    integer, optional, intent(in) :: quantize_mode, nsd
    integer :: nf90_inquire_variable



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`name`

:   Returned variable name. The caller must allocate space for the
    returned name. The maximum possible length, in characters, of a
    variable name is given by the predefined constant NF90\_MAX\_NAME.

`xtype`

:   Returned variable type, one of the set of predefined netCDF external
    data types. The valid netCDF external data types are NF90\_BYTE,
    NF90\_CHAR, NF90\_SHORT, NF90\_INT, NF90\_FLOAT, AND NF90\_DOUBLE.

`ndims`

:   Returned number of dimensions the variable was defined as using. For
    example, 2 indicates a matrix, 1 indicates a vector, and 0 means the
    variable is a scalar with no dimensions.

`dimids`

:   Returned vector of \*ndimsp dimension IDs corresponding to the
    variable dimensions. The caller must allocate enough space for a
    vector of at least \*ndimsp integers to be returned. The maximum
    possible number of dimensions for a variable is given by the
    predefined constant NF90\_MAX\_VAR\_DIMS.

`natts`

:   Returned number of variable attributes assigned to this variable.

`contiguous`

:   On return, set to NF90\_CONTIGUOUS if this variable uses contiguous
    storage, NF90\_CHUNKED if it uses chunked storage.

`chunksizes`

:   An array of chunk sizes. The array must have the one element for
    each dimension in the variable.

`shuffle`

:   True if the shuffle filter is turned on for this variable.

`deflate_level`

:   The deflate\_level from 0 to 9. A value of zero indicates no
    deflation is in use.

`fletcher32`

:   Set to true if the fletcher32 checksum filter is turned on for
    this variable.

`endianness`

:   Will be set to NF90\_ENDIAN\_LITTLE if this variable is stored in
    little-endian format, NF90\_ENDIAN\_BIG if it is stored in
    big-endian format, and NF90\_ENDIAN\_NATIVE if the endianness is not
    set, and the variable is not created yet.

`quantize_mode`

:   Will be set to nf90_noquantize (0) for no quantization, or
    nf90_quantize_bitgroom (1) for bitgroom quantization. Quantization
    allows users to specify a number of significant digits (NSD) in
    nf90_float and nf90_double variables. Bits beyond those needed to
    maintain the NSD are set to zero or one (alternating). This causes
    the data to compress better when compression is applied.

`nsd`

:   If quantize_mode is set to nf90_quantize_bitgroom, then this will be
    set to the number of significant digits to be maintained in the
    data.


These functions return the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_VAR to find out about a variable
named rh in an existing netCDF dataset named foo.nc:


~~~~.fortran


    use netcdf
    implicit none
    integer                            :: status, ncid, &
                                          RhVarId       &
                                          numDims, numAtts
 integer, dimension(nf90_max_var_dims) :: rhDimIds
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 status = nf90_inq_varid(ncid, "rh", RhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, ndims = numDims, natts = numAtts)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, dimids = rhDimIds(:numDims))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


6.9 Get the ID of a variable from the name: NF90_INQ_VARID {#f90-get-the-id-of-a-variable-from-the-name-nf90_inq_varid}
===========



Given the name of a varaible, nf90\_inq\_varid finds the variable ID.



## Usage


~~~~.fortran


  function nf90_inq_varid(ncid, name, varid)
    integer, intent(in) :: ncid
    character (len = *), intent( in) :: name
    integer, intent(out) :: varid
    integer :: nf90_inq_varid


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   The variable name. The maximum possible length, in characters, of a
    variable name is given by the predefined constant NF90\_MAX\_NAME.

`varid`

:   Variable ID.

These functions return the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   Variable not found.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_VARID to find out about a variable
named rh in an existing netCDF dataset named foo.nc:



~~~~.fortran

    use netcdf
    implicit none
    integer                            :: status, ncid, &
                                          RhVarId       &
                                          numDims, numAtts
 integer, dimension(nf90_max_var_dims) :: rhDimIds
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_error(status)
 ...
 status = nf90_inq_varid(ncid, "rh", RhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, ndims = numDims, natts = numAtts)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_variable(ncid, RhVarId, dimids = rhDimIds(:numDims))
 if(status /= nf90_NoErr) call handle_err(status)



~~~~


6.10 Writing Data Values: NF90_PUT_VAR {#f90-writing-data-values-nf90_put_var}
===========



The function NF90\_PUT\_VAR puts one or more data values into the
variable of an open netCDF dataset that is in data mode. Required inputs
are the netCDF ID, the variable ID, and one or more data values.
Optional inputs may indicate the starting position of the data values in
the netCDF variable (argument start), the sampling frequency with which
data values are written into the netCDF variable (argument stride), and
a mapping between the dimensions of the data array and the netCDF
variable (argument map). The values to be written are associated with
the netCDF variable by assuming that the first dimension of the netCDF
variable varies fastest in the Fortran 90 interface. Data values are
converted to the external type of the variable, if necessary.

Take care when using the simplest forms of this interface with record
variables (variables that use the NF90\_UNLIMITED dimension) when you
don’t specify how many records are to be written. If you try to write
all the values of a record variable into a netCDF file that has no
record data yet (hence has 0 records), nothing will be written.
Similarly, if you try to write all the values of a record variable from
an array but there are more records in the file than you assume, more
in-memory data will be accessed than you expect, which may cause a
segmentation violation. To avoid such problems, it is better to specify
start and count arguments for variables that use the NF90\_UNLIMITED
dimension.



### Usage



~~~~.fortran

 function nf90_put_var(ncid, varid, values, start, count, stride, map)
   integer,                         intent( in) :: ncid, varid
   any valid type, scalar or array of any rank, &
                                    intent( in) :: values
   integer, dimension(:), optional, intent( in) :: start, count, stride, map
   integer                                      :: nf90_put_var


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`values`

:   The data value(s) to be written. The data may be of any type, and
    may be a scalar or an array of any rank. You cannot put CHARACTER
    data into a numeric variable or numeric data into a text variable.
    For numeric data, if the type of data differs from the netCDF
    variable type, type conversion will occur. See [Type
    Conversion](netcdf.html#Type-Conversion) in NetCDF Users Guide.

`start`

:   A vector of integers specifying the index in the variable where the
    first (or only) of the data values will be written. The indices are
    relative to 1, so for example, the first data value of a variable
    would have index (1, 1, ..., 1). The elements of start correspond,
    in order, to the variable’s dimensions. Hence, if the variable is a
    record variable, the last index would correspond to the starting
    record number for writing the data values.

    By default, start(:) = 1.

`count`

:   A vector of integers specifying the number of indices selected along
    each dimension. To write a single value, for example, specify count
    as (1, 1, ..., 1). The elements of count correspond, in order, to
    the variable’s dimensions. Hence, if the variable is a record
    variable, the last element of count corresponds to a count of the
    number of records to write.

    By default, count(:numDims) = shape(values) and count(numDims + 1:)
    = 1, where numDims = size(shape(values)).

`stride`

:   A vector of integers that specifies the sampling interval along each
    dimension of the netCDF variable. The elements of the stride vector
    correspond, in order, to the netCDF variable’s dimensions (stride(1)
    gives the sampling interval along the most rapidly varying dimension
    of the netCDF variable). Sampling intervals are specified in
    type-independent units of elements (a value of 1 selects consecutive
    elements of the netCDF variable along the corresponding dimension, a
    value of 2 selects every other element, etc.).

    By default, stride(:) = 1.

`imap`

:   A vector of integers that specifies the mapping between the
    dimensions of a netCDF variable and the in-memory structure of the
    internal data array. The elements of the index mapping vector
    correspond, in order, to the netCDF variable’s dimensions (map(1)
    gives the distance between elements of the internal array
    corresponding to the most rapidly varying dimension of the
    netCDF variable). Distances between elements are specified in units
    of elements.

    By default, edgeLengths = shape(values), and map = (/ 1,
    (product(edgeLengths(:i)), i = 1, size(edgeLengths) - 1) /), that
    is, there is no mapping.

    Use of Fortran 90 intrinsic functions (including reshape, transpose,
    and spread) may let you avoid using this argument.



## Errors

NF90\_PUT\_VAR1\_ type returns the value NF90\_NOERR if no errors
occurred. Otherwise, the returned status indicates an error. Possible
causes of errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified indices were out of range for the rank of the
    specified variable. For example, a negative index or an index that
    is larger than the corresponding dimension length will cause
    an error.
-   The specified value is out of the range of values representable by
    the external data type of the variable.
-   The specified netCDF is in define mode rather than data mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_PUT\_VAR to set the (4,3,2) element of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
For simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, so we want to set the value of rh
that corresponds to the fourth lon value, the third lat value, and the
second time value:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_put_var(ncid, rhVarId, 0.5, start = (/ 4, 3, 2 /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


In this example we use NF90\_PUT\_VAR to add or change all the values of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
We assume that we know that rh is dimensioned with lon, lat, and time.
In this example we query the netCDF file to discover the lengths of the
dimensions, then use the Fortran 90 intrinsic function reshape to create
a temporary array of data values which is the same shape as the netCDF
variable.


~~~~.fortran


 use netcdf
 implicit none
 integer                               :: ncId, rhVarId,status,          &
                                          lonDimID, latDimId, timeDimId, &
                                          numLons, numLats, numTimes,    &
                                          i
 integer, dimension(nf90_max_var_dims) :: dimIDs
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! How big is the netCDF variable, that is, what are the lengths of
 !   its constituent dimensions?
 status = nf90_inquire_variable(ncid, rhVarId, dimids = dimIDs)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(1), len = numLons)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(2), len = numLats)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(3), len = numTimes)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Make a temporary array the same shape as the netCDF variable.
 status = nf90_put_var(ncid, rhVarId, &
                       reshape( &
                         (/ (0.5, i = 1, numLons * numLats * numTimes) /) , &
                        shape = (/ numLons, numLats, numTimes /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example using NF90\_PUT\_VAR to add or change a section of
the variable named rh to 0.5 in an existing netCDF dataset named foo.nc.
For simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, that there are ten lon values, five
lat values, and three time values, and that we want to replace all the
values at the last time.



~~~~.fortran

 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 10, numLats = 5, numTimes = 3
 real, dimension(numLons, numLats) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! Fill in all values at the last time
 rhValues(:, :) = 0.5
 status = nf90_put_var(ncid, rhVarId,rhvalues,       &
                       start = (/ 1, 1, numTimes /), &
                       count = (/ numLats, numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example of using NF90\_PUT\_VAR to write every other point of
a netCDF variable named rh having dimensions (6, 4).



~~~~.fortran

 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) &
                    :: rhValues = 0.5
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Fill in every other value using an array section
 status = nf90_put_var(ncid, rhVarId, rhValues(::2, ::2), &
                       stride = (/ 2, 2 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The following map vector shows the default mapping between a 2x3x4
netCDF variable and an internal array of the same shape:


~~~~.fortran


 real,    dimension(2, 3, 4):: a  ! same shape as netCDF variable
 integer, dimension(3)      :: map  = (/ 1, 2, 6 /)
                     ! netCDF dimension inter-element distance
                     ! ---------------- ----------------------
                     ! most rapidly varying       1
                     ! intermediate               2 (= map(1)*2)
                     ! most slowly varying        6 (= map(2)*3)


~~~~


Using the map vector above obtains the same result as simply not passing
a map vector at all.

Here is an example of using nf90\_put\_var to write a netCDF variable
named rh whose dimensions are the transpose of the Fortran 90 array:


~~~~.fortran


 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 !Write transposed values: map vector would be (/ 1, numLats /) for
 !   no transposition
 status = nf90_put_var(ncid, rhVarId,rhValues, map = (/ numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The same effect can be obtained more simply using Fortran 90 intrinsic
functions:



~~~~.fortran

 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_put_var(ncid, rhVarId, transpose(rhValues))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~



6.11 Reading Data Values: NF90_GET_VAR {#f90-reading-data-values-nf90_get_var}
===========



The function NF90\_GET\_VAR gets one or more data values from a netCDF
variable of an open netCDF dataset that is in data mode. Required inputs
are the netCDF ID, the variable ID, and a specification for the data
values into which the data will be read. Optional inputs may indicate
the starting position of the data values in the netCDF variable
(argument start), the sampling frequency with which data values are read
from the netCDF variable (argument stride), and a mapping between the
dimensions of the data array and the netCDF variable (argument map). The
values to be read are associated with the netCDF variable by assuming
that the first dimension of the netCDF variable varies fastest in the
Fortran 90 interface. Data values are converted from the external type
of the variable, if necessary.

Take care when using the simplest forms of this interface with record
variables (variables that use the NF90\_UNLIMITED dimension) when you
don’t specify how many records are to be read. If you try to read all
the values of a record variable into an array but there are more records
in the file than you assume, more data will be read than you expect,
which may cause a segmentation violation. To avoid such problems, it is
better to specify the optional start and count arguments for variables
that use the NF90\_UNLIMITED dimension.

In netCDF classic model the maximum integer size is NF90\_INT, the
4-byte signed integer. Reading variables into an eight-byte integer
array from a classic model file will read from an NF90\_INT. Reading
variables into an eight-byte integer in a netCDF-4/HDF5 (without classic
model flag) will read from an NF90\_INT64



## Usage



~~~~.fortran

 function nf90_get_var(ncid, varid, values, start, count, stride, map)
   integer,                         intent( in) :: ncid, varid
   any valid type, scalar or array of any rank, &
                                    intent(out) :: values
   integer, dimension(:), optional, intent( in) :: start, count, stride, map
   integer                                      :: nf90_get_var


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`values`

:   The data value(s) to be read. The data may be of any type, and may
    be a scalar or an array of any rank. You cannot read CHARACTER data
    from a numeric variable or numeric data from a text variable. For
    numeric data, if the type of data differs from the netCDF variable
    type, type conversion will occur. See [Type
    Conversion](netcdf.html#Type-Conversion) in NetCDF Users Guide.

`start`

:   A vector of integers specifying the index in the variable from which
    the first (or only) of the data values will be read. The indices are
    relative to 1, so for example, the first data value of a variable
    would have index (1, 1, ..., 1). The elements of start correspond,
    in order, to the variable’s dimensions. Hence, if the variable is a
    record variable, the last index would correspond to the starting
    record number for writing the data values.

    By default, start(:) = 1.

`count`

:   A vector of integers specifying the number of indices selected along
    each dimension. To read a single value, for example, specify count
    as (1, 1, ..., 1). The elements of count correspond, in order, to
    the variable’s dimensions. Hence, if the variable is a record
    variable, the last element of count corresponds to a count of the
    number of records to read.

    By default, count(:numDims) = shape(values) and count(numDims + 1:)
    = 1, where numDims = size(shape(values)).

`stride`

:   A vector of integers that specifies the sampling interval along each
    dimension of the netCDF variable. The elements of the stride vector
    correspond, in order, to the netCDF variable’s dimensions (stride(1)
    gives the sampling interval along the most rapidly varying dimension
    of the netCDF variable). Sampling intervals are specified in
    type-independent units of elements (a value of 1 selects consecutive
    elements of the netCDF variable along the corresponding dimension, a
    value of 2 selects every other element, etc.).

    By default, stride(:) = 1.

`map`

:   A vector of integers that specifies the mapping between the
    dimensions of a netCDF variable and the in-memory structure of the
    internal data array. The elements of the index mapping vector
    correspond, in order, to the netCDF variable’s dimensions (map(1)
    gives the distance between elements of the internal array
    corresponding to the most rapidly varying dimension of the
    netCDF variable). Distances between elements are specified in units
    of elements.

    By default, edgeLengths = shape(values), and map = (/ 1,
    (product(edgeLengths(:i)), i = 1, size(edgeLengths) - 1) /), that
    is, there is no mapping.

    Use of Fortran 90 intrinsic functions (including reshape, transpose,
    and spread) may let you avoid using this argument.



## Errors

NF90\_GET\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The assumed or specified start, count, and stride generate an index
    which is out of range. Note that no error checking is possible on
    the map vector.
-   One or more of the specified values are out of the range of values
    representable by the desired type.
-   The specified netCDF is in define mode rather than data mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.

(As noted above, another possible source of error is using this
interface to read all the values of a record variable without specifying
the number of records. If there are more records in the file than you
assume, more data will be read than you expect!)



## Example

Here is an example using NF90\_GET\_VAR to read the (4,3,2) element of
the variable named rh from an existing netCDF dataset named foo.nc. For
simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, so we want to read the value of rh
that corresponds to the fourth lon value, the third lat value, and the
second time value:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 real    :: rhValue
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 -
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_get_var(ncid, rhVarId, rhValue, start = (/ 4, 3, 2 /) )
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


In this example we use NF90\_GET\_VAR to read all the values of the
variable named rh from an existing netCDF dataset named foo.nc. We
assume that we know that rh is dimensioned with lon, lat, and time. In
this example we query the netCDF file to discover the lengths of the
dimensions, then allocate a Fortran 90 array the same shape as the
netCDF variable.




 use netcdf
 implicit none
 integer                               :: ncId, rhVarId, &
                                          lonDimID, latDimId, timeDimId, &
                                          numLons, numLats, numTimes,    &
                                          status
 integer, dimension(nf90_max_var_dims) :: dimIDs
 real, dimension(:, :, :), allocatable :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ! How big is the netCDF variable, that is, what are the lengths of
 !   its constituent dimensions?
 status = nf90_inquire_variable(ncid, rhVarId, dimids = dimIDs)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(1), len = numLons)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(2), len = numLats)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_inquire_dimension(ncid, dimIDs(3), len = numTimes)
 if(status /= nf90_NoErr) call handle_err(status)
 allocate(rhValues(numLons, numLats, numTimes))
 ...
 status = nf90_get_var(ncid, rhVarId, rhValues)
 if(status /= nf90_NoErr) call handle_err(status)




Here is an example using NF90\_GET\_VAR to read a section of the
variable named rh from an existing netCDF dataset named foo.nc. For
simplicity in this example, we assume that we know that rh is
dimensioned with lon, lat, and time, that there are ten lon values, five
lat values, and three time values, and that we want to replace all the
values at the last time.


~~~~.fortran


 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 10, numLats = 5, numTimes = 3
 real, dimension(numLons, numLats, numTimes) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 !Read the values at the last time by passing an array section
 status = nf90_get_var(ncid, rhVarId, rhValues(:, :, 3), &
                       start = (/ 1, 1, numTimes /),     &
                       count = (/ numLons, numLats, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


Here is an example of using NF90\_GET\_VAR to read every other point of
a netCDF variable named rh having dimensions (6, 4).


~~~~.fortran


 use netcdf
 implicit none
 integer            :: ncId, rhVarId, status
 integer, parameter :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) &
                    :: rhValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Read every other value into an array section
 status = nf90_get_var(ncid, rhVarId, rhValues(::2, ::2) &
                       stride = (/ 2, 2 /))
 if(status /= nf90_NoErr) call handle_err(status)



~~~~

The following map vector shows the default mapping between a 2x3x4
netCDF variable and an internal array of the same shape:


~~~~.fortran


 real,    dimension(2, 3, 4):: a  ! same shape as netCDF variable
 integer, dimension(3)      :: map  = (/ 1, 2, 6 /)
                     ! netCDF dimension inter-element distance
                     ! ---------------- ----------------------
                     ! most rapidly varying       1
                     ! intermediate               2 (= map(1)*2)
                     ! most slowly varying        6 (= map(2)*3)




~~~~

Using the map vector above obtains the same result as simply not passing
a map vector at all.

Here is an example of using nf90\_get\_var to read a netCDF variable
named rh whose dimensions are the transpose of the Fortran 90 array:



~~~~.fortran

 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Read transposed values: map vector would be (/ 1, numLats /) for
 !   no transposition
 status = nf90_get_var(ncid, rhVarId,rhValues, map = (/ numLons, 1 /))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


The same effect can be obtained more simply, though using more memory,
using Fortran 90 intrinsic functions:


~~~~.fortran


 use netcdf
 implicit none
 integer                           :: ncId, rhVarId, status
 integer, parameter                :: numLons = 6, numLats = 4
 real, dimension(numLons, numLats) :: rhValues
 ! netCDF variable has dimensions (numLats, numLons)
 real, dimension(numLons, numLats) :: tempValues
 ...
 status = nf90_open("foo.nc", nf90_NoWrite, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_get_var(ncid, rhVarId, tempValues))
 if(status /= nf90_NoErr) call handle_err(status)
 rhValues(:, :) = transpose(tempValues)


~~~~




6.12 Reading and Writing Character String Values {#f90-reading-and-writing-character-string-values}
===========

Character strings are not a primitive netCDF external data type under
the classic netCDF data model, in part because FORTRAN does not support
the abstraction of variable-length character strings (the FORTRAN LEN
function returns the static length of a character string, not its
dynamic length). As a result, a character string cannot be written or
read as a single object in the netCDF interface. Instead, a character
string must be treated as an array of characters, and array access must
be used to read and write character strings as variable data in netCDF
datasets. Furthermore, variable-length strings are not supported by the
netCDF classic interface except by convention; for example, you may
treat a zero byte as terminating a character string, but you must
explicitly specify the length of strings to be read from and written to
netCDF variables.

Character strings as attribute values are easier to use, since the
strings are treated as a single unit for access. However, the value of a
character-string attribute in the classic netCDF interface is still an
array of characters with an explicit length that must be specified when
the attribute is defined.

When you define a variable that will have character-string values, use a
character-position dimension as the most quickly varying dimension for
the variable (the first dimension for the variable in Fortran 90). The
length of the character-position dimension will be the maximum string
length of any value to be stored in the character-string variable. Space
for maximum-length strings will be allocated in the disk representation
of character-string variables whether you use the space or not. If two
or more variables have the same maximum length, the same
character-position dimension may be used in defining the variable
shapes.

To write a character-string value into a character-string variable, use
either entire variable access or array access. The latter requires that
you specify both a corner and a vector of edge lengths. The
character-position dimension at the corner should be one for Fortran 90.
If the length of the string to be written is n, then the vector of edge
lengths will specify n in the character-position dimension, and one for
all the other dimensions: (n, 1, 1, ..., 1).

In Fortran 90, fixed-length strings may be written to a netCDF dataset
without a terminating character, to save space. Variable-length strings
should follow the C convention of writing strings with a terminating
zero byte so that the intended length of the string can be determined
when it is later read by either C or Fortran 90 programs. It is the
users responsibility to provide such null termination.

If you are writing data in the default prefill mode (see next section),
you can ensure that simple strings represented as 1-dimensional
character arrays are null terminated in the netCDF file by writing fewer
characters than the length declared when the variable was defined. That
way, the extra unwritten characters will be filled with the default
character fill value, which is a null byte. The Fortran intrinsic TRIM
function can be used to trim trailing blanks from the character string
argument to NF90\_PUT\_VAR to make the argument shorter than the
declared length. If prefill is not on, the data writer must explicitly
provide a null terminating byte.

Here is an example illustrating this way of writing strings to character
array variables:



~~~~.fortran

 use netcdf
 implicit none
 integer status
 integer                           :: ncid, oceanStrLenID, oceanId
 integer, parameter                :: MaxOceanNameLen = 20
 character, (len = MaxOceanNameLen):: ocean
 ...
 status = nf90_create("foo.nc", nf90_NoClobber, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_def_dim(ncid, "oceanStrLen", MaxOceanNameLen, oceanStrLenId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_def_var(ncid, "ocean", nf90_char, (/ oceanStrLenId /), oceanId)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 ! Leave define mode, which prefills netCDF variables with fill values
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Note that this assignment adds blank fill
 ocean = "Pacific"
 ! Using trim removes trailing blanks, prefill provides null
 ! termination, so C programs can later get intended string.
 status = nf90_put_var(ncid, oceanId, trim(ocean))
 if(status /= nf90_NoErr) call handle_err(status)


~~~~


6.13 Fill Values {#f90-fill-values}
===========

What happens when you try to read a value that was never written in an
open netCDF dataset? You might expect that this should always be an
error, and that you should get an error message or an error status
returned. You do get an error if you try to read data from a netCDF
dataset that is not open for reading, if the variable ID is invalid for
the specified netCDF dataset, or if the specified indices are not
properly within the range defined by the dimension lengths of the
specified variable. Otherwise, reading a value that was not written
returns a special fill value used to fill in any undefined values when a
netCDF variable is first written.

You may ignore fill values and use the entire range of a netCDF external
data type, but in this case you should make sure you write all data
values before reading them. If you know you will be writing all the data
before reading it, you can specify that no prefilling of variables with
fill values will occur by calling writing. This may provide a
significant performance gain for netCDF writes.

The variable attribute \_FillValue may be used to specify the fill value
for a variable. There are default fill values for each type, defined in
module netcdf: NF90\_FILL\_CHAR, NF90\_FILL\_INT1 (same as
NF90\_FILL\_BYTE), NF90\_FILL\_INT2 (same as NF90\_FILL\_SHORT),
NF90\_FILL\_INT, NF90\_FILL\_REAL (same as NF90\_FILL\_FLOAT), and
NF90\_FILL\_DOUBLE

The netCDF byte and character types have different default fill values.
The default fill value for characters is the zero byte, a useful value
for detecting the end of variable-length C character strings. If you
need a fill value for a byte variable, it is recommended that you
explicitly define an appropriate \_FillValue attribute, as generic
utilities such as ncdump will not assume a default fill value for byte
variables.

Type conversion for fill values is identical to type conversion for
other values: attempting to convert a value from one type to another
type that can’t represent the value results in a range error. Such
errors may occur on writing or reading values from a larger type (such
as double) to a smaller type (such as float), if the fill value for the
larger type cannot be represented in the smaller type.


6.14 NF90_RENAME_VAR {#f90-nf90_rename_var}
===========



The function NF90\_RENAME\_VAR changes the name of a netCDF variable in
an open netCDF dataset. If the new name is longer than the old name, the
netCDF dataset must be in define mode. You cannot rename a variable to
have the name of any existing variable.



## Usage



~~~~.fortran

 function nf90_rename_var(ncid, varid, newname)
   integer,             intent( in) :: ncid, varid
   character (len = *), intent( in) :: newname
   integer                          :: nf90_rename_var

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID.

`newname`

:   New name for the specified variable.



## Errors

NF90\_RENAME\_VAR returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The new name is in use as the name of another variable.
-   The variable ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_RENAME\_VAR to rename the variable rh to
rel\_hum in an existing netCDF dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncId, rhVarId, status
 ...
 status = nf90_open("foo.nc", nf90_Write, ncid)
 if(status /= nf90_NoErr) call handle_err(status)
 ...
 status = nf90_inq_varid(ncid, "rh", rhVarId)
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_redef(ncid)  ! Enter define mode to change variable name
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_rename_var(ncid, rhVarId, "rel_hum")
 if(status /= nf90_NoErr) call handle_err(status)
 status = nf90_enddef(ncid) ! Leave define mode
 if(status /= nf90_NoErr) call handle_err(status)



~~~~


6.15 Change between Collective and Independent Parallel Access: NF90_VAR_PAR_ACCESS {#f90-change-between-collective-and-independent-parallel-access-nf90_var_par_access}
===========



The function NF90\_VAR\_PAR\_ACCESS changes whether read/write
operations on a parallel file system are performed collectively or
independently (the default) on the variable. This function can only be
called if the file was created (see [NF90\_CREATE](#NF90_005fCREATE)) or
opened (see [NF90\_OPEN](#NF90_005fOPEN)) for parallel I/O.

This function is only available if the netCDF library was built with
parallel I/O enabled.

Calling this function affects only the open file - information about
whether a variable is to be accessed collectively or independently is
not written to the data file. Every time you open a file on a parallel
file system, all variables default to independent operations. The change
of a variable to collective access lasts only as long as that file is
open.

The variable can be changed from collective to independent, and back, as
often as desired.

Classic and 64-bit offset files, when opened for parallel access, use
the parallel-netcdf (a.k.a. pnetcdf) library, which does not allow
per-variable changes of access mode - the entire file must be access
independently or collectively. For classic and 64-bit offset files, the
nf90\_var\_par\_access function changes the access for all variables in
the file.



## Usage



~~~~.fortran

  function nf90_var_par_access(ncid, varid, access)
    integer, intent(in) :: ncid
    integer, intent(in) :: varid
    integer, intent(in) :: access
    integer :: nf90_var_par_access
  end function nf90_var_par_access

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN (see
    [NF90\_OPEN](#NF90_005fOPEN)) or NF90\_CREATE (see
    [NF90\_CREATE](#NF90_005fCREATE)).

`varid`

:   Variable ID.

`access`

:   NF90\_INDEPENDENT to set this variable to independent operations.
    NF90\_COLLECTIVE to set it to collective operations.



## Return Values

`NF90_NOERR`

:   No error.

`NF90_ENOTVAR`

:   No variable found.

`NF90_NOPAR`

:   File not opened for parallel access.



## Example

This example comes from test program nf\_test/f90tst\_parallel.f90. For
this test to be run, netCDF must have been built with a parallel-enabled
HDF5, and –enable-parallel-tests must have been used when configuring
netcdf.



~~~~.fortran

  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))

  ! Set collective access on this variable. This will cause all
  ! reads/writes to happen together on every processor.
  call handle_err(nf90_var_par_access(ncid, varid, nf90_collective))

  ! Read this processor's data.
  call handle_err(nf90_get_var(ncid, varid, data_in, start = start, count = count))

~~~~

The NetCDF Fortran 90 Interface Guide {#f90_The-NetCDF-Fortran-90-Interface-Guide}
========================

[TOC]

This document describes the Fortran 90 interface to the netCDF library.

You can use the netCDF library without knowing about all of the netCDF
interface. If you are creating a netCDF dataset, only a handful of
routines are required to define the necessary dimensions, variables, and
attributes, and to write the data to the netCDF dataset. Similarly, if you are
writing software to access data stored in a particular netCDF object,
only a small subset of the netCDF library is required to open the netCDF
dataset and access the data. Authors of generic applications that access
arbitrary netCDF datasets need to be familiar with more of the netCDF
library.


* \subpage f90-use-of-the-netcdf-library
* \subpage f90_datasets
* \subpage f90_groups
* \subpage f90_dimensions
* \subpage f90-user-defined-data-types
* \subpage f90-variables
* \subpage f90-attributes

4 Dimensions {#f90_dimensions}
============

[TOC]

4.1 Dimensions Introduction {#f90-dimensions-introduction}
============

Dimensions for a netCDF dataset are defined when it is created, while
the netCDF dataset is in define mode. Additional dimensions may be added
later by reentering define mode. A netCDF dimension has a name and a
length. At most one dimension in a netCDF dataset can have the unlimited
length, which means variables using this dimension can grow along this
dimension.

There is a suggested limit (512) to the number of dimensions that can be
defined in a single netCDF dataset. The limit is the value of the
constant NF90\_MAX\_DIMS. The purpose of the limit is to make writing
generic applications simpler. They need only provide an array of
NF90\_MAX\_DIMS dimensions to handle any netCDF dataset. The
implementation of the netCDF library does not enforce this advisory
maximum, so it is possible to use more dimensions, if necessary, but
netCDF utilities that assume the advisory maximums may not be able to
handle the resulting netCDF datasets.

Ordinarily, the name and length of a dimension are fixed when the
dimension is first defined. The name may be changed later, but the
length of a dimension (other than the unlimited dimension) cannot be
changed without copying all the data to a new netCDF dataset with a
redefined dimension length.

A netCDF dimension in an open netCDF dataset is referred to by a small
integer called a dimension ID. In the Fortran 90 interface, dimension
IDs are 1, 2, 3, ..., in the order in which the dimensions were defined.

Operations supported on dimensions are:

-   Create a dimension, given its name and length.
-   Get a dimension ID from its name.
-   Get a dimension’s name and length from its ID.
-   Rename a dimension.

4.2 NF90_DEF_DIM {#f90-nf90_def_dim}
============



The function NF90\_DEF\_DIM adds a new dimension to an open netCDF
dataset in define mode. It returns (as an argument) a dimension ID,
given the netCDF ID, the dimension name, and the dimension length. At
most one unlimited length dimension, called the record dimension, may be
defined for each netCDF dataset.



## Usage


~~~~.fortran

 function nf90_def_dim(ncid, name, len, dimid)
   integer,             intent( in) :: ncid
   character (len = *), intent( in) :: name
   integer,             intent( in) :: len
   integer,             intent(out) :: dimid
   integer                          :: nf90_def_dim

~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   Dimension name.

`len`

:   Length of dimension; that is, number of values for this dimension as
    an index to variables that use it. This should be either a positive
    integer or the predefined constant NF90\_UNLIMITED.

`dimid`

:   Returned dimension ID.



## Errors

NF90\_DEF\_DIM returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The netCDF dataset is not in definition mode.
-   The specified dimension name is the name of another
    existing dimension.
-   The specified length is not greater than zero.
-   The specified length is unlimited, but there is already an unlimited
    length dimension defined for this netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_DEF\_DIM to create a dimension named lat
of length 18 and a unlimited dimension named rec in a new netCDF dataset
named foo.nc:


~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status, LatDimID, RecordDimID
 ...
 status = nf90_create("foo.nc", nf90_noclobber, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_def_dim(ncid, "Lat", 18, LatDimID)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_def_dim(ncid, "Record", nf90_unlimited, RecordDimID)
 if (status /= nf90_noerr) call handle_err(status)

~~~~



4.3 NF90_INQ_DIMID {#f90-nf90_inq_dimid}
============



The function NF90\_INQ\_DIMID returns (as an argument) the ID of a
netCDF dimension, given the name of the dimension. If ndims is the
number of dimensions defined for a netCDF dataset, each dimension has an
ID between 1 and ndims.



## Usage


~~~~.fortran

 function nf90_inq_dimid(ncid, name, dimid)
   integer,             intent( in) :: ncid
   character (len = *), intent( in) :: name
   integer,             intent(out) :: dimid
   integer                          :: nf90_inq_dimid

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`name`

:   Dimension name.

`dimid`

:   Returned dimension ID.



## Errors

NF90\_INQ\_DIMID returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The name that was specified is not the name of a dimension in the
    netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_DIMID to determine the dimension ID
of a dimension named lat, assumed to have been defined previously in an
existing netCDF dataset named foo.nc:


~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status, LatDimID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_inq_dimid(ncid, "Lat", LatDimID)
 if (status /= nf90_noerr) call handle_err(status)

~~~~


4.4 NF90_INQUIRE_DIMENSION {#f90-nf90_inquire_dimension}
============



This function information about a netCDF dimension. Information about a
dimension includes its name and its length. The length for the unlimited
dimension, if any, is the number of records written so far.



## Usage


~~~~.fortran

 function nf90_inquire_dimension(ncid, dimid, name, len)
   integer,                       intent( in) :: ncid, dimid
   character (len = *), optional, intent(out) :: name
   integer,             optional, intent(out) :: len
   integer                                    :: nf90_inquire_dimension

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`dimid`

:   Dimension ID, from a previous call to NF90\_INQ\_DIMID
    or NF90\_DEF\_DIM.

`name`

:   Returned dimension name. The caller must allocate space for the
    returned name. The maximum possible length, in characters, of a
    dimension name is given by the predefined constant NF90\_MAX\_NAME.

`len`

:   Returned length of dimension. For the unlimited dimension, this is
    the current maximum value used for writing any variables with this
    dimension, that is the maximum record number.



## Errors

These functions return the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The dimension ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_INQ\_DIM to determine the length of a
dimension named lat, and the name and current maximum length of the
unlimited dimension for an existing netCDF dataset named foo.nc:


~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status, LatDimID, RecordDimID
 integer :: nLats, nRecords
 character(len = nf90_max_name) :: RecordDimName
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ! Get ID of unlimited dimension
 status = nf90_inquire(ncid, unlimitedDimId = RecordDimID)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_inq_dimid(ncid, "Lat", LatDimID)
 if (status /= nf90_noerr) call handle_err(status)
 ! How many values of "lat" are there?
 status = nf90_inquire_dimension(ncid, LatDimID, len = nLats)
 if (status /= nf90_noerr) call handle_err(status)
 ! What is the name of the unlimited dimension, how many records are there?
 status = nf90_inquire_dimension(ncid, RecordDimID, &
                                 name = RecordDimName, len = Records)
 if (status /= nf90_noerr) call handle_err(status)

~~~~



4.5 NF90_RENAME_DIM {#f90-nf90_rename_dim}
============



The function NF90\_RENAME\_DIM renames an existing dimension in a netCDF
dataset open for writing. If the new name is longer than the old name,
the netCDF dataset must be in define mode. You cannot rename a dimension
to have the same name as another dimension.



## Usage


~~~~.fortran

 function nf90_rename_dim(ncid, dimid, name)
   integer,             intent( in) :: ncid
   character (len = *), intent( in) :: name
   integer,             intent( in) :: dimid
   integer                          :: nf90_rename_dim

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`dimid`

:   Dimension ID, from a previous call to NF90\_INQ\_DIMID
    or NF90\_DEF\_DIM.

`name`

:   New dimension name.



## Errors

NF90\_RENAME\_DIM returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The new name is the name of another dimension.
-   The dimension ID is invalid for the specified netCDF dataset.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The new name is longer than the old name and the netCDF dataset is
    not in define mode.



## Example

Here is an example using NF90\_RENAME\_DIM to rename the dimension lat
to latitude in an existing netCDF dataset named foo.nc:


~~~~~~.fortran

use netcdf
implicit none
integer :: ncid, status, LatDimID
...
status = nf90_open("foo.nc", nf90_write, ncid)
if (status /= nf90_noerr) call handle_err(status)
...
! Put in define mode so we can rename the dimension
status = nf90_redef(ncid)
if (status /= nf90_noerr) call handle_err(status)
! Get the dimension ID for "Lat"...
status = nf90_inq_dimid(ncid, "Lat", LatDimID)
if (status /= nf90_noerr) call handle_err(status)
! ... and change the name to "Latitude".
status = nf90_rename_dim(ncid, LatDimID, "Latitude")
if (status /= nf90_noerr) call handle_err(status)
! Leave define mode
status = nf90_enddef(ncid)
if (status /= nf90_noerr) call handle_err(status)

~~~~~~

# Extensions

[TOC]

On top of the base theme provided by `doxygen-awesome.css`, this repository comes with Javascript extensions that require additional setup steps to get them running.

The extensions require customizations in the header HTML template.
This is how you can create the default template with Doxygen:

1. Create default header template:
    ```sh
    doxygen -w html header.html delete_me.html delete_me.css
    ```

2. Reference the template  in your `Doxyfile`:
    ```
    HTML_HEADER            = header.html
    ```

[More details on header customization](https://www.doxygen.nl/manual/customize.html#minor_tweaks_header_css)

## Dark Mode Toggle {#extension-dark-mode-toggle}

Adds a button next to the search bar to enable and disable the dark theme variant manually:

<div class="darkmode_inverted_image bordered_image">

![](img/darkmode_toggle.png){width=250px}
</div>

### Installation

1. Add the required resources in your `Doxyfile`:
   - **HTML_EXTRA_FILES:** `doxygen-awesome-darkmode-toggle.js`
   - **HTML_EXTRA_STYLESHEET:** `doxygen-awesome-sidebar-only-darkmode-toggle.css`
        <em>(ONLY required for the sidebar-only theme variant!)</em>
2. In the `header.html` template, include `doxygen-awesome-darkmode-toggle.js` at the end of the `<head>` and then initialize it:
    ```html
   <html> 
       <head>
           <!-- ... other metadata & script includes ... -->
           <script type="text/javascript" src="$relpath^doxygen-awesome-darkmode-toggle.js"></script>
           <script type="text/javascript">
               DoxygenAwesomeDarkModeToggle.init()
           </script>
       </head>
       <body>
    ```

### Customizing

Changing the tooltip of the button:
```js
DoxygenAwesomeDarkModeToggle.title = "Zwischen hellem/dunklem Modus wechseln"
```

Changing Icons. Both Emoji or SVG icons are supported:
```js
DoxygenAwesomeDarkModeToggle.lightModeIcon = '🌞'
// icon from https://fonts.google.com/icons
DoxygenAwesomeDarkModeToggle.darkModeIcon = `<svg xmlns="http://www.w3.org/2000/svg" enable-background="new 0 0 24 24" height="24px" viewBox="0 0 24 24" width="24px" fill="#009793"><g><rect fill="none" height="24" width="24"/></g><g><g><path d="M8.1,14.15C9.77,14.63,11,16.17,11,18c0,0.68-0.19,1.31-0.48,1.87c0.48,0.09,0.97,0.14,1.48,0.14 c1.48,0,2.9-0.41,4.13-1.15c-2.62-0.92-5.23-2.82-6.8-5.86C7.74,9.94,7.78,7.09,8.29,4.9c-2.57,1.33-4.3,4.01-4.3,7.1c0,0,0,0,0,0 c0.01,0,0.01,0,0.02,0C5.66,12,7.18,12.83,8.1,14.15z" opacity=".3"/><path d="M19.78,17.51c-2.47,0-6.57-1.33-8.68-5.43C8.77,7.57,10.6,3.6,11.63,2.01C6.27,2.2,1.98,6.59,1.98,12 c0,0.14,0.02,0.28,0.02,0.42C2.61,12.16,3.28,12,3.98,12c0,0,0,0,0,0c0-3.09,1.73-5.77,4.3-7.1C7.78,7.09,7.74,9.94,9.32,13 c1.57,3.04,4.18,4.95,6.8,5.86c-1.23,0.74-2.65,1.15-4.13,1.15c-0.5,0-1-0.05-1.48-0.14c-0.37,0.7-0.94,1.27-1.64,1.64 c0.98,0.32,2.03,0.5,3.11,0.5c3.5,0,6.58-1.8,8.37-4.52C20.18,17.5,19.98,17.51,19.78,17.51z"/><path d="M7,16l-0.18,0C6.4,14.84,5.3,14,4,14c-1.66,0-3,1.34-3,3s1.34,3,3,3c0.62,0,2.49,0,3,0c1.1,0,2-0.9,2-2 C9,16.9,8.1,16,7,16z"/></g></g></svg>`
```

All customizations must be applied before calling `DoxygenAwesomeDarkModeToggle.init()`!


## Fragment Copy Button {#extension-copy-button}

Shows a copy button when the user hovers over a code fragment:

<div class="darkmode_inverted_image bordered_image">

![](img/fragment_copy_button.png){width=490}
</div>

### Installation

1. Add the required resources in your `Doxyfile`:
   - **HTML_EXTRA_FILES:** `doxygen-awesome-fragment-copy-button.js`
2. In the `header.html` template, include `doxygen-awesome-fragment-copy-button.js` at the end of the `<head>` and then initialize it:
    ```html
   <html>
       <head>
           <!-- ... other metadata & script includes ... -->
           <script type="text/javascript" src="$relpath^doxygen-awesome-fragment-copy-button.js"></script>
           <script type="text/javascript">
               DoxygenAwesomeFragmentCopyButton.init()
           </script>
       </head>
       <body>
    ```

### Customizing

The tooltip of the button can be changed:
```js
DoxygenAwesomeFragmentCopyButton.title = "In die Zwischenablage kopieren"
```

The icon can be changed. It must be an SVG:
```js
DoxygenAwesomeFragmentCopyButton.copyIcon = `<svg ...>`
DoxygenAwesomeFragmentCopyButton.successIcon = `<svg ...>`
```

All customizations must be applied before calling `DoxygenAwesomeDarkModeToggle.init()`!

## Paragraph Linking {#extension-para}

Provides a button on hover behind every headline to allow easy creation of a permanent link to the headline:

<div class="darkmode_inverted_image bordered_image">

![](img/paragraph_link.png){width=220}
</div>

Works for all headlines and for many documentation section titles.

### Installation

1. Add the required resources in your `Doxyfile`:
   - **HTML_EXTRA_FILES:** `doxygen-awesome-paragraph-link.js`
2. In the `header.html` template, include `doxygen-awesome-paragraph-link.js` at the end of the `<head>` and then initialize it:
    ```html
   <html>
       <head>
           <!-- ... other metadata & script includes ... -->
           <script type="text/javascript" src="$relpath^doxygen-awesome-paragraph-link.js"></script>
           <script type="text/javascript">
               DoxygenAwesomeParagraphLink.init()
           </script>
       </head>
       <body>
    ```

### Customizing

The button tooltip can be changed:
```js
DoxygenAwesomeParagraphLink.title = "Abschnitt verknüpfen"
```

The icon of the button can be changed. Both plain characters or SVG icons are supported:
```js
DoxygenAwesomeParagraphLink.icon = "¶"
```

All customizations must be applied before calling `DoxygenAwesomeParagraphLink.init()`!

## Interactive TOC {#extension-toc}

On large screens, the Table of Contents (TOC) is anchored on the top right of the page. This extension visualizes the reading progress by dynamically highlighting the currently active section.

On small screens, the extension hides the TOC by default. The user can open it manually when needed:


<div class="darkmode_inverted_image bordered_image">

![](img/interactive_toc_mobile.png){width=380}
</div>

### Installation

1. Add the required resources in your `Doxyfile`:
   - **HTML_EXTRA_FILES:** `doxygen-awesome-interactive-toc.js`
2. In the `header.html` template, include `doxygen-awesome-interactive-toc.js` at the end of the `<head>` and then initialize it:
    ```html
   <html>
       <head>
           <!-- ... other metadata & script includes ... -->
           <script type="text/javascript" src="$relpath^doxygen-awesome-interactive-toc.js"></script>
           <script type="text/javascript">
               DoxygenAwesomeInteractiveToc.init()
           </script>
       </head>
       <body>
    ```

### Customizing

The offset for when a headline is considered active can be changed. A smaller value means that the headline of the section must be closer to the top of the viewport before it is highlighted in the TOC:
```js
DoxygenAwesomeInteractiveToc.topOffset = 45
```

Hiding the TOC on small screens can be disabled. It is still interactive and can be hidden by the user but will now be open by default:
```js
DoxygenAwesomeInteractiveToc.hideMobileMenu = false
```

## Tabs {#extension-tabs}

@warning Experimental feature! Please report bugs [here](https://github.com/jothepro/doxygen-awesome-css/issues).

This extension allows to arrange list content in tabs:

<div class="tabbed">

- <b class="tab-title">Tab 1</b> This is the content of tab 1
- <b class="tab-title">Tab 2</b> This is the content of tab 2

</div>


### Installation

1. Add the required resources in your `Doxyfile`:
   - **HTML_EXTRA_FILES:** `doxygen-awesome-tabs.js`
2. In the `header.html` template, include `doxygen-awesome-tabs.js` at the end of the `<head>` and then initialize it:
    ```html
   <html>
       <head>
           <!-- ... other metadata & script includes ... -->
           <script type="text/javascript" src="$relpath^doxygen-awesome-tabs.js"></script>
           <script type="text/javascript">
               DoxygenAwesomeTabs.init()
           </script>
       </head>
       <body>
    ```

### Usage

Each list that is supposed to be displayed as tabs has to be wrapped with the `tabbed` CSS class.
Each item in the list must start with an element that has the class `tab-title`. It will then be used as tab title.

```md
<div class="tabbed">

- <b class="tab-title">Tab 1</b> This is the content of tab 1
- <b class="tab-title">Tab 2</b> This is the content of tab 2

</div>
```

## Page Navigation {#extension-page-navigation}

@warning Experimental feature! Please report bugs [here](https://github.com/jothepro/doxygen-awesome-css/issues).

To allow the user to easily navigate from one document to another, "Next" and "Previous" buttons can be added at the end of a Markdown document.

### Installation

The feature is shipped inside the default `doxygen-awesome.css`. No additional stylesheets or scripts need to be added.

### Usage

The following conditions must be met for the feature to work properly:
- The navigation must be inside a Markdown table with 1-2 columns.
- The alignment of the column defines the alignment of the arrow on the navigation button.
- the table must be wrapped inside a `<div>` with the class `section_buttons`.

<div class="tabbed">

- <span class="tab-title">Code</span>
    ```md
    <div class="section_buttons">

    | Previous          |                              Next |
    |:------------------|----------------------------------:|
    | [Home](README.md) | [Customization](customization.md) |

    </div>
    ```
- <span class="tab-title">Result</span>
    <div class="section_buttons">
    | Previous          |                              Next |
    |:------------------|----------------------------------:|
    | [Home](README.md) | [Customization](customization.md) |
    </div>

</div>

<div class="section_buttons">

| Previous          |                              Next |
|:------------------|----------------------------------:|
| [Home](README.md) | [Customization](customization.md) |
</div>

2 Datasets {#f90_datasets}
===========================

[TOC]

2.1 Datasets Introduction {#f90-datasets-introduction}
=========================

This chapter presents the interfaces of the netCDF functions that deal
with a netCDF dataset or the whole netCDF library.

A netCDF dataset that has not yet been opened can only be referred to by
its dataset name. Once a netCDF dataset is opened, it is referred to by
a netCDF ID, which is a small nonnegative integer returned when you
create or open the dataset. A netCDF ID is much like a file descriptor
in C or a logical unit number in FORTRAN. In any single program, the
netCDF IDs of distinct open netCDF datasets are distinct. A single
netCDF dataset may be opened multiple times and will then have multiple
distinct netCDF IDs; however at most one of the open instances of a
single netCDF dataset should permit writing. When an open netCDF dataset
is closed, the ID is no longer associated with a netCDF dataset.

Functions that deal with the netCDF library include:

-   Get version of library.
-   Get error message corresponding to a returned error code.

The operations supported on a netCDF dataset as a single object are:

-   Create, given dataset name and whether to overwrite or not.
-   Open for access, given dataset name and read or write intent.
-   Put into define mode, to add dimensions, variables, or attributes.
-   Take out of define mode, checking consistency of additions.
-   Close, writing to disk if required.
-   Inquire about the number of dimensions, number of variables, number
    of global attributes, and ID of the unlimited dimension, if any.
-   Synchronize to disk to make sure it is current.
-   Set and unset nofill mode for optimized sequential writes.
-   After a summary of conventions used in describing the netCDF
    interfaces, the rest of this chapter presents a detailed description
    of the interfaces for these operations.

2.2 NetCDF Library Interface Descriptions {#f90-netcdf-library-interface-descriptions}
=========================

Each interface description for a particular netCDF function in this and
later chapters contains:

-   a description of the purpose of the function;
-   a Fortran 90 interface block that presents the type and order of the
    formal parameters to the function;
-   a description of each formal parameter in the C interface;
-   a list of possible error conditions; and
-   an example of a Fortran 90 program fragment calling the netCDF
    function (and perhaps other netCDF functions).

The examples follow a simple convention for error handling, always
checking the error status returned from each netCDF function call and
calling a handle\_error function in case an error was detected. For an
example of such a function, see Section 5.2 "Get error message
corresponding to error status: nf90\_strerror".

2.3 NF90_STRERROR {#f90-nf90_strerror}
=========================

The function NF90\_STRERROR returns a static reference to an error
message string corresponding to an integer netCDF error status or to a
system error number, presumably returned by a previous call to some
other netCDF function. The list of netCDF error status codes is
available in the appropriate include file for each language binding.



## Usage


~~~~.fortran


 function nf90_strerror(ncerr)
   integer, intent( in) :: ncerr
   character(len = 80)  :: nf90_strerror

~~~~



`NCERR`

:   An error status that might have been returned from a previous call
    to some netCDF function.

## Errors

If you provide an invalid integer error status that does not correspond
to any netCDF error message or or to any system error message (as
understood by the system strerror function), NF90\_STRERROR returns a
string indicating that there is no such error status.

## Example

Here is an example of a simple error handling function that uses
NF90\_STRERROR to print the error message corresponding to the netCDF
error status returned from any netCDF function call and then exit:


~~~~.fortran


 subroutine handle_err(status)
   integer, intent ( in) :: status

   if(status /= nf90_noerr) then
     print *, trim(nf90_strerror(status))
     stop "Stopped"
   end if
 end subroutine handle_err



~~~~

2.4 Get netCDF library version: NF90_INQ_LIBVERS {#f90-get-netcdf-library-version-nf90_inq_libvers}
=========================

The function NF90\_INQ\_LIBVERS returns a string identifying the version
of the netCDF library, and when it was built.



## Usage




~~~~.fortran

 function nf90_inq_libvers()
   character(len = 80) :: nf90_inq_libvers



~~~~



## Errors

This function takes no arguments, and returns no error status.



## Example

Here is an example using nf90\_inq\_libvers to print the version of the
netCDF library with which the program is linked:



~~~~.fortran
print *, trim(nf90_inq_libvers())

~~~~




2.5 NF90_CREATE {#f90-nf90_create}
=========================



This function creates a new netCDF dataset, returning a netCDF ID that
can subsequently be used to refer to the netCDF dataset in other netCDF
function calls. The new netCDF dataset opened for write access and
placed in define mode, ready for you to add dimensions, variables, and
attributes.

A creation mode flag specifies whether to overwrite any existing dataset
with the same name and whether access to the dataset is shared.



## Usage



~~~~.fortran

  function nf90_create(path, cmode, ncid, initialsize, bufrsize, cache_size, &
       cache_nelems, cache_preemption, comm, info)
    implicit none
    character (len = *), intent(in) :: path
    integer, intent(in) :: cmode
    integer, intent(out) :: ncid
    integer, optional, intent(in) :: initialsize
    integer, optional, intent(inout) :: bufrsize
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer, optional, intent(in) :: comm, info
    integer :: nf90_create


~~~~


`path`

:   The file name of the new netCDF dataset.

`cmode`

:   The creation mode flag. The following flags are available:
    NF90\_CLOBBER, NF90\_NOCLOBBER, NF90\_SHARE, NF90\_64BIT\_OFFSET,
    NF90\_NETCDF4, and NF90\_CLASSIC\_MODEL. (NF90\_HDF5 is deprecated,
    use NF90\_NETCDF4 instead).

    A zero value (defined for convenience as NF90\_CLOBBER) specifies:
    overwrite any existing dataset with the same file name, and buffer
    and cache accesses for efficiency. The dataset will be in netCDF
    classic format. See [NetCDF Classic Format
    Limitations](netcdf.html#NetCDF-Classic-Format-Limitations) in
    NetCDF Users’ Guide.

    Setting NF90\_NOCLOBBER means you do not want to clobber (overwrite)
    an existing dataset; an error (NF90\_EEXIST) is returned if the
    specified dataset already exists.

    The NF90\_SHARE flag is appropriate when one process may be writing
    the dataset and one or more other processes reading the dataset
    concurrently; it means that dataset accesses are not buffered and
    caching is limited. Since the buffering scheme is optimized for
    sequential access, programs that do not access data sequentially may
    see some performance improvement by setting the NF90\_SHARE flag.
    (This only applies to netCDF-3 classic or 64-bit offset files.)

    Setting NF90\_64BIT\_OFFSET causes netCDF to create a 64-bit offset
    format file, instead of a netCDF classic format file. The 64-bit
    offset format imposes far fewer restrictions on very large (i.e.
    over 2 GB) data files. See [Large File
    Support](netcdf.html#Large-File-Support) in NetCDF Users’ Guide.

    Setting the NF90\_NETCDF4 flag causes netCDF to create a
    netCDF-4/HDF5 format output file.

    Oring the NF90\_CLASSIC\_MODEL flag with the NF90\_NETCDF4 flag
    causes the resulting netCDF-4/HDF5 file to restrict itself to the
    classic model - none of the new netCDF-4 data model features, such
    as groups or user-defined types, are allowed in such a file.

`ncid`

:   Returned netCDF ID.

The following optional arguments allow additional performance tuning.

`initialsize`

:   The initial size of the file (in bytes) at creation time. A value of
    0 causes the file size to be computed when nf90\_enddef is called.
    This is ignored for NetCDF-4/HDF5 files.

`bufrsize`

:   Controls a space versus time trade-off, memory allocated in the
    netcdf library versus number of system calls. Because of internal
    requirements, the value may not be set to exactly the
    value requested. The actual value chosen is returned.

    The library chooses a system-dependent default value if
    NF90\_SIZEHINT\_DEFAULT is supplied as input. If the "preferred I/O
    block size" is available from the stat() system call as member
    st\_blksize this value is used. Lacking that, twice the system
    pagesize is used. Lacking a call to discover the system pagesize,
    the default bufrsize is set to 8192 bytes.

    The bufrsize is a property of a given open netcdf descriptor ncid,
    it is not a persistent property of the netcdf dataset.

    This is ignored for NetCDF-4/HDF5 files.

`cache_size`

:   If the cache\_size is provided when creating a netCDF-4/HDF5 file,
    it will be used instead of the default (32000000) as the size, in
    bytes, of the HDF5 chunk cache.

`cache_nelems`

:   If cache\_nelems is provided when creating a netCDF-4/HDF5 file, it
    will be used instead of the default (1000) as the maximum number of
    elements in the HDF5 chunk cache.

`cache_preemption`

:   If cache\_preemption is provided when creating a netCDF-4/HDF5 file,
    it will be used instead of the default (0.75) as the preemption
    value for the HDF5 chunk cache.

`comm`

:   If the comm and info parameters are provided the file is created and
    opened for parallel I/O. Set the comm parameter to the MPI
    communicator (of type MPI\_Comm). If this parameter is provided the
    info parameter must also be provided.

`info`

:   If the comm and info parameters are provided the file is created and
    opened for parallel I/O. Set the comm parameter to the MPI
    information value (of type MPI\_Info). If this parameter is provided
    the comm parameter must also be provided.



## Errors

NF90\_CREATE returns the value NF90\_NOERR if no errors occurred.
Possible causes of errors include:

-   Passing a dataset name that includes a directory that does
    not exist.
-   Specifying a dataset name of a file that exists and also
    specifying NF90\_NOCLOBBER.
-   Specifying a meaningless value for the creation mode.
-   Attempting to create a netCDF dataset in a directory where you don’t
    have permission to create files.



## Example

In this example we create a netCDF dataset named foo.nc; we want the
dataset to be created in the current directory only if a dataset with
that name does not already exist:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create(path = "foo.nc", cmode = nf90_noclobber, ncid = ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~



2.6 NF90_OPEN {#f90-nf90_open}
=========================

The function NF90\_OPEN opens an existing netCDF dataset for access.

## Usage


~~~~.fortran


  function nf90_open(path, mode, ncid, bufrsize, cache_size, cache_nelems, &
                     cache_preemption, comm, info)
    implicit none
    character (len = *), intent(in) :: path
    integer, intent(in) :: mode
    integer, intent(out) :: ncid
    integer, optional, intent(inout) :: bufrsize
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer, optional, intent(in) :: comm, info
    integer :: nf90_open


~~~~


`path`

:   File name for netCDF dataset to be opened. This may be an OPeNDAP
    URL if DAP support is enabled.

`mode`

:   A zero value (or NF90\_NOWRITE) specifies: open the dataset with
    read-only access, buffering and caching accesses for efficiency

    Otherwise, the open mode is NF90\_WRITE, NF90\_SHARE,
    or NF90\_WRITE|NF90\_SHARE. Setting the NF90\_WRITE flag opens the
    dataset with read-write access. ("Writing" means any kind of change
    to the dataset, including appending or changing data, adding or
    renaming dimensions, variables, and attributes, or
    deleting attributes.) The NF90\_SHARE flag is appropriate when one
    process may be writing the dataset and one or more other processes
    reading the dataset concurrently (note that this is not the same as
    parallel I/O); it means that dataset accesses are not buffered and
    caching is limited. Since the buffering scheme is optimized for
    sequential access, programs that do not access data sequentially may
    see some performance improvement by setting the NF90\_SHARE flag.

`ncid`

:   Returned netCDF ID.

The following optional argument allows additional performance tuning.

`bufrsize`

:   This parameter applies only when opening classic format or 64-bit
    offset files. It is ignored for netCDF-4/HDF5 files.

    It Controls a space versus time trade-off, memory allocated in the
    netcdf library versus number of system calls. Because of internal
    requirements, the value may not be set to exactly the
    value requested. The actual value chosen is returned.

    The library chooses a system-dependent default value if
    NF90\_SIZEHINT\_DEFAULT is supplied as input. If the "preferred I/O
    block size" is available from the stat() system call as member
    st\_blksize this value is used. Lacking that, twice the system
    pagesize is used. Lacking a call to discover the system pagesize,
    the default bufrsize is set to 8192 bytes.

    The bufrsize is a property of a given open netcdf descriptor ncid,
    it is not a persistent property of the netcdf dataset.

`cache_size`

:   If the cache\_size is provided when opening a netCDF-4/HDF5 file, it
    will be used instead of the default (32000000) as the size, in
    bytes, of the HDF5 chunk cache.

`cache_nelems`

:   If cache\_nelems is provided when opening a netCDF-4/HDF5 file, it
    will be used instead of the default (1000) as the maximum number of
    elements in the HDF5 chunk cache.

`cache_preemption`

:   If cache\_preemption is provided when opening a netCDF-4/HDF5 file,
    it will be used instead of the default (0.75) as the preemption
    value for the HDF5 chunk cache.

`comm`

:   If the comm and info parameters are provided the file is opened for
    parallel I/O. Set the comm parameter to the MPI communicator (of
    type MPI\_Comm). If this parameter is provided the info parameter
    must also be provided.

`info`

:   If the comm and info parameters are provided the file is opened for
    parallel I/O. Set the comm parameter to the MPI information value
    (of type MPI\_Info). If this parameter is provided the comm
    parameter must also be provided.



## Errors

NF90\_OPEN returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset does not exist.
-   A meaningless mode was specified.

## Example

Here is an example using NF90\_OPEN to open an existing netCDF dataset
named foo.nc for read-only, non-shared access:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open(path = "foo.nc", mode = nf90_nowrite, ncid = ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


## Example

Here is an example using NF90\_OPEN to open an existing netCDF dataset
for parallel I/O access. (Note the use of the comm and info parameters).
This example is from test program nf\_test/f90tst\_parallel.f90.


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))



~~~~

2.7 NF90_REDEF {#f90-nf90_redef}
=========================



The function NF90\_REDEF puts an open netCDF dataset into define mode,
so dimensions, variables, and attributes can be added or renamed and
attributes can be deleted.



## Usage


~~~~.fortran


 function nf90_redef(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_redef



~~~~

`ncid`

:   netCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_REDEF returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset is already in define mode.
-   The specified netCDF dataset was opened for read-only.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_REDEF to open an existing netCDF dataset
named foo.nc and put it into define mode:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open("foo.nc", nf90_write, ncid) ! Open dataset
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_redef(ncid)                       ! Put the file in define mode
 if (status /= nf90_noerr) call handle_err(status)



~~~~

2.8 NF90_ENDDEF {#f90-nf90_enddef}
=========================



The function NF90\_ENDDEF takes an open netCDF dataset out of define
mode. The changes made to the netCDF dataset while it was in define mode
are checked and committed to disk if no problems occurred. Non-record
variables may be initialized to a "fill value" as well (see section
[NF90_SET_FILL](#NF90_005fSET_005fFILL)). The netCDF dataset is then
placed in data mode, so variable data can be read or written.

This call may involve copying data under some circumstances. For a more
extensive discussion See [File Structure and
Performance](netcdf.html#File-Structure-and-Performance) in NetCDF Users
Guide.

## Usage


~~~~.fortran


 function nf90_enddef(ncid, h_minfree, v_align, v_minfree, r_align)
   integer,           intent( in) :: ncid
   integer, optional, intent( in) :: h_minfree, v_align, v_minfree, r_align
   integer                        :: nf90_enddef

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

The following arguments allow additional performance tuning. Note: these
arguments expose internals of the netcdf version 1 file format, and may
not be available in future netcdf implementations.

The current netcdf file format has three sections: the "header" section,
the data section for fixed size variables, and the data section for
variables which have an unlimited dimension (record variables). The
header begins at the beginning of the file. The index (offset) of the
beginning of the other two sections is contained in the header.
Typically, there is no space between the sections. This causes copying
overhead to accrue if one wishes to change the size of the sections, as
may happen when changing the names of things, text attribute values,
adding attributes or adding variables. Also, for buffered i/o, there may
be advantages to aligning sections in certain ways.

The minfree parameters allow one to control costs of future calls to
nf90\_redef or nf90\_enddef by requesting that some space be available
at the end of the section. The default value for both h\_minfree and
v\_minfree is 0.

The align parameters allow one to set the alignment of the beginning of
the corresponding sections. The beginning of the section is rounded up
to an index which is a multiple of the align parameter. The flag value
NF90\_ALIGN\_CHUNK tells the library to use the bufrsize (see above) as
the align parameter. The default value for both v\_align and r\_align is
4 bytes.

`h_minfree`

:   Size of the pad (in bytes) at the end of the "header" section.

`v_minfree`

:   Size of the pad (in bytes) at the end of the data section for fixed
    size variables.

`v_align`

:   The alignment of the beginning of the data section for fixed
    size variables.

`r_align`

:   The alignment of the beginning of the data section for variables
    which have an unlimited dimension (record variables).

## Errors

NF90\_ENDDEF returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset is not in define mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The size of one or more variables exceed the size constraints for
    whichever variant of the file format is in use).

## Example

Here is an example using NF90\_ENDDEF to finish the definitions of a new
netCDF dataset named foo.nc and put it into data mode:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create("foo.nc", nf90_noclobber, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  !  create dimensions, variables, attributes
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~




2.9 NF90_CLOSE {#f90-nf90_close}
=========================

The function NF90\_CLOSE closes an open netCDF dataset. If the dataset
is in define mode, NF90\_ENDDEF will be called before closing. (In this
case, if NF90\_ENDDEF returns an error, NF90\_ABORT will automatically
be called to restore the dataset to the consistent state before define
mode was last entered.) After an open netCDF dataset is closed, its
netCDF ID may be reassigned to the next netCDF dataset that is opened or
created.



## Usage



~~~~.fortran

 function nf90_close(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_close


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_CLOSE returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   Define mode was entered and the automatic call made to
    NF90\_ENDDEF failed.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_CLOSE to finish the definitions of a new
netCDF dataset named foo.nc and release its netCDF ID:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create("foo.nc", nf90_noclobber, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  !  create dimensions, variables, attributes
 status = nf90_close(ncid)
 if (status /= nf90_noerr) call handle_err(status)

~~~~



2.10 NF90_INQUIRE Family {#f90-nf90_inquire-family}
=========================

The NF90\_INQUIRE subroutine returns information about an open netCDF
dataset, given its netCDF ID. The subroutine can be called from either
define mode or data mode, and returns values for any or all of the
following: the number of dimensions, the number of variables, the number
of global attributes, and the dimension ID of the dimension defined with
unlimited length, if any. An additional function, NF90\_INQ\_FORMAT,
returns the (rarely needed) format version.

No I/O is performed when NF90\_INQUIRE is called, since the required
information is available in memory for each open netCDF dataset.

## Usage


~~~~.fortran


 function nf90_inquire(ncid, nDimensions, nVariables, nAttributes, &
                       unlimitedDimId, formatNum)
   integer,           intent( in) :: ncid
   integer, optional, intent(out) :: nDimensions, nVariables, &
                                     nAttributes, unlimitedDimId, &
                                     formatNum
   integer                        :: nf90_inquire



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`nDimensions`

:   Returned number of dimensions defined for this netCDF dataset.

`nVariables`

:   Returned number of variables defined for this netCDF dataset.

`nAttributes`

:   Returned number of global attributes defined for this
    netCDF dataset.

`unlimitedDimID`

:   Returned ID of the unlimited dimension, if there is one for this
    netCDF dataset. If no unlimited length dimension has been defined,
    -1 is returned.

`format`

:   Returned integer indicating format version for this dataset, one of
    nf90\_format\_classic, nf90\_format\_64bit, nf90\_format\_netcdf4,
    or nf90\_format\_netcdf4\_classic. These are rarely needed by users
    or applications, since thhe library recognizes the format of a file
    it is accessing and handles it accordingly.



## Errors

Function NF90\_INQUIRE returns the value NF90\_NOERR if no errors
occurred. Otherwise, the returned status indicates an error. Possible
causes of errors include:

-   The specified netCDF ID does not refer to an open netCDF dataset.

## Example

Here is an example using NF90\_INQUIRE to find out about a netCDF
dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, nDims, nVars, nGlobalAtts, unlimDimID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_inquire(ncid, nDims, nVars, nGlobalAtts, unlimdimid)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_inquire(ncid, nDimensions = nDims, &
                       unlimitedDimID = unlimdimid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


2.11 NF90_SYNC {#f90-nf90_sync}
=========================



The function NF90\_SYNC offers a way to synchronize the disk copy of a
netCDF dataset with in-memory buffers. There are two reasons you might
want to synchronize after writes:

-   To minimize data loss in case of abnormal termination, or
-   To make data available to other processes for reading immediately
    after it is written. But note that a process that already had the
    dataset open for reading would not see the number of records
    increase when the writing process calls NF90\_SYNC; to accomplish
    this, the reading process must call NF90\_SYNC.

This function is backward-compatible with previous versions of the
netCDF library. The intent was to allow sharing of a netCDF dataset
among multiple readers and one writer, by having the writer call
NF90\_SYNC after writing and the readers call NF90\_SYNC before each
read. For a writer, this flushes buffers to disk. For a reader, it makes
sure that the next read will be from disk rather than from previously
cached buffers, so that the reader will see changes made by the writing
process (e.g., the number of records written) without having to close
and reopen the dataset. If you are only accessing a small amount of
data, it can be expensive in computer resources to always synchronize to
disk after every write, since you are giving up the benefits of
buffering.

An easier way to accomplish sharing (and what is now recommended) is to
have the writer and readers open the dataset with the NF90\_SHARE flag,
and then it will not be necessary to call NF90\_SYNC at all. However,
the NF90\_SYNC function still provides finer granularity than the
NF90\_SHARE flag, if only a few netCDF accesses need to be synchronized
among processes.

It is important to note that changes to the ancillary data, such as
attribute values, are not propagated automatically by use of the
NF90\_SHARE flag. Use of the NF90\_SYNC function is still required for
this purpose.

Sharing datasets when the writer enters define mode to change the data
schema requires extra care. In previous releases, after the writer left
define mode, the readers were left looking at an old copy of the
dataset, since the changes were made to a new copy. The only way readers
could see the changes was by closing and reopening the dataset. Now the
changes are made in place, but readers have no knowledge that their
internal tables are now inconsistent with the new dataset schema. If
netCDF datasets are shared across redefinition, some mechanism external
to the netCDF library must be provided that prevents access by readers
during redefinition and causes the readers to call NF90\_SYNC before any
subsequent access.

When calling NF90\_SYNC, the netCDF dataset must be in data mode. A
netCDF dataset in define mode is synchronized to disk only when
NF90\_ENDDEF is called. A process that is reading a netCDF dataset that
another process is writing may call NF90\_SYNC to get updated with the
changes made to the data by the writing process (e.g., the number of
records written), without having to close and reopen the dataset.

Data is automatically synchronized to disk when a netCDF dataset is
closed, or whenever you leave define mode.


## Usage


~~~~.fortran


 function nf90_sync(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_sync



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_SYNC returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The netCDF dataset is in define mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_SYNC to synchronize the disk writes of a
netCDF dataset named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 ! write data or change attributes
 ...  
 status = NF90_SYNC(ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


2.12 NF90_ABORT {#f90-nf90_abort}
=========================



You no longer need to call this function, since it is called
automatically by NF90\_CLOSE in case the dataset is in define mode and
something goes wrong with committing the changes. The function
NF90\_ABORT just closes the netCDF dataset, if not in define mode. If
the dataset is being created and is still in define mode, the dataset is
deleted. If define mode was entered by a call to NF90\_REDEF, the netCDF
dataset is restored to its state before definition mode was entered and
the dataset is closed.



## Usage


~~~~.fortran


 function nf90_abort(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_abort


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_ABORT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   When called from define mode while creating a netCDF dataset,
    deletion of the dataset failed.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_ABORT to back out of redefinitions of a
dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, LatDimID
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_redef(ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_def_dim(ncid, "Lat", 18, LatDimID)
 if (status /= nf90_noerr) then ! Dimension definition failed
   call handle_err(status)
   status = nf90_abort(ncid) ! Abort redefinitions
   if (status /= nf90_noerr) call handle_err(status)
 end if
...


~~~~



2.13 NF90_SET_FILL {#f90-nf90_set_fill}
=========================



This function is intended for advanced usage, to optimize writes under
some circumstances described below. The function NF90\_SET\_FILL sets
the fill mode for a netCDF dataset open for writing and returns the
current fill mode in a return parameter. The fill mode can be specified
as either NF90\_FILL or NF90\_NOFILL. The default behavior corresponding
to NF90\_FILL is that data is pre-filled with fill values, that is fill
values are written when you create non-record variables or when you
write a value beyond data that has not yet been written. This makes it
possible to detect attempts to read data before it was written. See
section [Fill Values](#Fill-Values), for more information on the use of
fill values. See [Attribute
Conventions](netcdf.html#Attribute-Conventions) in {No value for
‘n-man’}, for information about how to define your own fill values.

The behavior corresponding to NF90\_NOFILL overrides the default
behavior of prefilling data with fill values. This can be used to
enhance performance, because it avoids the duplicate writes that occur
when the netCDF library writes fill values that are later overwritten
with data.

A value indicating which mode the netCDF dataset was already in is
returned. You can use this value to temporarily change the fill mode of
an open netCDF dataset and then restore it to the previous mode.

After you turn on NF90\_NOFILL mode for an open netCDF dataset, you must
be certain to write valid data in all the positions that will later be
read. Note that nofill mode is only a transient property of a netCDF
dataset open for writing: if you close and reopen the dataset, it will
revert to the default behavior. You can also revert to the default
behavior by calling NF90\_SET\_FILL again to explicitly set the fill
mode to NF90\_FILL.

There are three situations where it is advantageous to set nofill mode:

1.  Creating and initializing a netCDF dataset. In this case, you should
    set nofill mode before calling NF90\_ENDDEF and then write
    completely all non-record variables and the initial records of all
    the record variables you want to initialize.
2.  Extending an existing record-oriented netCDF dataset. Set nofill
    mode after opening the dataset for writing, then append the
    additional records to the dataset completely, leaving no intervening
    unwritten records.
3.  Adding new variables that you are going to initialize to an existing
    netCDF dataset. Set nofill mode before calling NF90\_ENDDEF then
    write all the new variables completely.

If the netCDF dataset has an unlimited dimension and the last record was
written while in nofill mode, then the dataset may be shorter than if
nofill mode was not set, but this will be completely transparent if you
access the data only through the netCDF interfaces.

The use of this feature may not be available (or even needed) in future
releases. Programmers are cautioned against heavy reliance upon this
feature.



## Usage


~~~~.fortran


 function nf90_set_fill(ncid, fillmode, old_mode)
   integer, intent( in) :: ncid, fillmode
   integer, intent(out) :: old_mode
   integer              :: nf90_set_fill



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`fillmode`

:   Desired fill mode for the dataset, either NF90\_NOFILL
    or NF90\_FILL.

`old_mode`

:   Returned current fill mode of the dataset before this call, either
    NF90\_NOFILL or NF90\_FILL.



## Errors

NF90\_SET\_FILL returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The specified netCDF ID refers to a dataset open for
    read-only access.
-   The fill mode argument is neither NF90\_NOFILL nor NF90\_FILL..

## Example

Here is an example using NF90\_SET\_FILL to set nofill mode for
subsequent writes of a netCDF dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, oldMode
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 ! Write data with prefilling behavior
 ...  
 status = nf90_set_fill(ncid, nf90_nofill, oldMode)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 !  Write data with no prefilling
 ...

~~~~

2 Datasets {#f90_datasets}
===========================

[TOC]

2.1 Datasets Introduction {#f90-datasets-introduction}
=========================

This chapter presents the interfaces of the netCDF functions that deal
with a netCDF dataset or the whole netCDF library.

A netCDF dataset that has not yet been opened can only be referred to by
its dataset name. Once a netCDF dataset is opened, it is referred to by
a netCDF ID, which is a small nonnegative integer returned when you
create or open the dataset. A netCDF ID is much like a file descriptor
in C or a logical unit number in FORTRAN. In any single program, the
netCDF IDs of distinct open netCDF datasets are distinct. A single
netCDF dataset may be opened multiple times and will then have multiple
distinct netCDF IDs; however at most one of the open instances of a
single netCDF dataset should permit writing. When an open netCDF dataset
is closed, the ID is no longer associated with a netCDF dataset.

Functions that deal with the netCDF library include:

-   Get version of library.
-   Get error message corresponding to a returned error code.

The operations supported on a netCDF dataset as a single object are:

-   Create, given dataset name and whether to overwrite or not.
-   Open for access, given dataset name and read or write intent.
-   Put into define mode, to add dimensions, variables, or attributes.
-   Take out of define mode, checking consistency of additions.
-   Close, writing to disk if required.
-   Inquire about the number of dimensions, number of variables, number
    of global attributes, and ID of the unlimited dimension, if any.
-   Synchronize to disk to make sure it is current.
-   Set and unset nofill mode for optimized sequential writes.
-   After a summary of conventions used in describing the netCDF
    interfaces, the rest of this chapter presents a detailed description
    of the interfaces for these operations.

2.2 NetCDF Library Interface Descriptions {#f90-netcdf-library-interface-descriptions}
=========================

Each interface description for a particular netCDF function in this and
later chapters contains:

-   a description of the purpose of the function;
-   a Fortran 90 interface block that presents the type and order of the
    formal parameters to the function;
-   a description of each formal parameter in the C interface;
-   a list of possible error conditions; and
-   an example of a Fortran 90 program fragment calling the netCDF
    function (and perhaps other netCDF functions).

The examples follow a simple convention for error handling, always
checking the error status returned from each netCDF function call and
calling a handle\_error function in case an error was detected. For an
example of such a function, see Section 5.2 "Get error message
corresponding to error status: nf90\_strerror".

2.3 NF90_STRERROR {#f90-nf90_strerror}
=========================

The function NF90\_STRERROR returns a static reference to an error
message string corresponding to an integer netCDF error status or to a
system error number, presumably returned by a previous call to some
other netCDF function. The list of netCDF error status codes is
available in the appropriate include file for each language binding.



## Usage


~~~~.fortran


 function nf90_strerror(ncerr)
   integer, intent( in) :: ncerr
   character(len = 80)  :: nf90_strerror

~~~~



`NCERR`

:   An error status that might have been returned from a previous call
    to some netCDF function.

## Errors

If you provide an invalid integer error status that does not correspond
to any netCDF error message or or to any system error message (as
understood by the system strerror function), NF90\_STRERROR returns a
string indicating that there is no such error status.

## Example

Here is an example of a simple error handling function that uses
NF90\_STRERROR to print the error message corresponding to the netCDF
error status returned from any netCDF function call and then exit:


~~~~.fortran


 subroutine handle_err(status)
   integer, intent ( in) :: status

   if(status /= nf90_noerr) then
     print *, trim(nf90_strerror(status))
     stop "Stopped"
   end if
 end subroutine handle_err



~~~~

2.4 Get netCDF library version: NF90_INQ_LIBVERS {#f90-get-netcdf-library-version-nf90_inq_libvers}
=========================

The function NF90\_INQ\_LIBVERS returns a string identifying the version
of the netCDF library, and when it was built.



## Usage




~~~~.fortran

 function nf90_inq_libvers()
   character(len = 80) :: nf90_inq_libvers



~~~~



## Errors

This function takes no arguments, and returns no error status.



## Example

Here is an example using nf90\_inq\_libvers to print the version of the
netCDF library with which the program is linked:



~~~~.fortran
print *, trim(nf90_inq_libvers())

~~~~




2.5 NF90_CREATE {#f90-nf90_create}
=========================



This function creates a new netCDF dataset, returning a netCDF ID that
can subsequently be used to refer to the netCDF dataset in other netCDF
function calls. The new netCDF dataset opened for write access and
placed in define mode, ready for you to add dimensions, variables, and
attributes.

A creation mode flag specifies whether to overwrite any existing dataset
with the same name and whether access to the dataset is shared.



## Usage



~~~~.fortran

  function nf90_create(path, cmode, ncid, initialsize, bufrsize, cache_size, &
       cache_nelems, cache_preemption, comm, info)
    implicit none
    character (len = *), intent(in) :: path
    integer, intent(in) :: cmode
    integer, intent(out) :: ncid
    integer, optional, intent(in) :: initialsize
    integer, optional, intent(inout) :: bufrsize
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer, optional, intent(in) :: comm, info
    integer :: nf90_create


~~~~


`path`

:   The file name of the new netCDF dataset.

`cmode`

:   The creation mode flag. The following flags are available:
    NF90\_CLOBBER, NF90\_NOCLOBBER, NF90\_SHARE, NF90\_64BIT\_OFFSET,
    NF90\_NETCDF4, and NF90\_CLASSIC\_MODEL. (NF90\_HDF5 is deprecated,
    use NF90\_NETCDF4 instead).

    A zero value (defined for convenience as NF90\_CLOBBER) specifies:
    overwrite any existing dataset with the same file name, and buffer
    and cache accesses for efficiency. The dataset will be in netCDF
    classic format. See [NetCDF Classic Format
    Limitations](netcdf.html#NetCDF-Classic-Format-Limitations) in
    NetCDF Users’ Guide.

    Setting NF90\_NOCLOBBER means you do not want to clobber (overwrite)
    an existing dataset; an error (NF90\_EEXIST) is returned if the
    specified dataset already exists.

    The NF90\_SHARE flag is appropriate when one process may be writing
    the dataset and one or more other processes reading the dataset
    concurrently; it means that dataset accesses are not buffered and
    caching is limited. Since the buffering scheme is optimized for
    sequential access, programs that do not access data sequentially may
    see some performance improvement by setting the NF90\_SHARE flag.
    (This only applies to netCDF-3 classic or 64-bit offset files.)

    Setting NF90\_64BIT\_OFFSET causes netCDF to create a 64-bit offset
    format file, instead of a netCDF classic format file. The 64-bit
    offset format imposes far fewer restrictions on very large (i.e.
    over 2 GB) data files. See [Large File
    Support](netcdf.html#Large-File-Support) in NetCDF Users’ Guide.

    Setting the NF90\_NETCDF4 flag causes netCDF to create a
    netCDF-4/HDF5 format output file.

    Oring the NF90\_CLASSIC\_MODEL flag with the NF90\_NETCDF4 flag
    causes the resulting netCDF-4/HDF5 file to restrict itself to the
    classic model - none of the new netCDF-4 data model features, such
    as groups or user-defined types, are allowed in such a file.

`ncid`

:   Returned netCDF ID.

The following optional arguments allow additional performance tuning.

`initialsize`

:   The initial size of the file (in bytes) at creation time. A value of
    0 causes the file size to be computed when nf90\_enddef is called.
    This is ignored for NetCDF-4/HDF5 files.

`bufrsize`

:   Controls a space versus time trade-off, memory allocated in the
    netcdf library versus number of system calls. Because of internal
    requirements, the value may not be set to exactly the
    value requested. The actual value chosen is returned.

    The library chooses a system-dependent default value if
    NF90\_SIZEHINT\_DEFAULT is supplied as input. If the "preferred I/O
    block size" is available from the stat() system call as member
    st\_blksize this value is used. Lacking that, twice the system
    pagesize is used. Lacking a call to discover the system pagesize,
    the default bufrsize is set to 8192 bytes.

    The bufrsize is a property of a given open netcdf descriptor ncid,
    it is not a persistent property of the netcdf dataset.

    This is ignored for NetCDF-4/HDF5 files.

`cache_size`

:   If the cache\_size is provided when creating a netCDF-4/HDF5 file,
    it will be used instead of the default (32000000) as the size, in
    bytes, of the HDF5 chunk cache.

`cache_nelems`

:   If cache\_nelems is provided when creating a netCDF-4/HDF5 file, it
    will be used instead of the default (1000) as the maximum number of
    elements in the HDF5 chunk cache.

`cache_premtion`

:   If cache\_preemption is provided when creating a netCDF-4/HDF5 file,
    it will be used instead of the default (0.75) as the preemption
    value for the HDF5 chunk cache.

`comm`

:   If the comm and info parameters are provided the file is created and
    opened for parallel I/O. Set the comm parameter to the MPI
    communicator (of type MPI\_Comm). If this parameter is provided the
    info parameter must also be provided.

`info`

:   If the comm and info parameters are provided the file is created and
    opened for parallel I/O. Set the comm parameter to the MPI
    information value (of type MPI\_Info). If this parameter is provided
    the comm parameter must also be provided.



## Errors

NF90\_CREATE returns the value NF90\_NOERR if no errors occurred.
Possible causes of errors include:

-   Passing a dataset name that includes a directory that does
    not exist.
-   Specifying a dataset name of a file that exists and also
    specifying NF90\_NOCLOBBER.
-   Specifying a meaningless value for the creation mode.
-   Attempting to create a netCDF dataset in a directory where you don’t
    have permission to create files.



## Example

In this example we create a netCDF dataset named foo.nc; we want the
dataset to be created in the current directory only if a dataset with
that name does not already exist:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create(path = "foo.nc", cmode = nf90_noclobber, ncid = ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~



2.6 NF90_OPEN {#f90-nf90_open}
=========================

The function NF90\_OPEN opens an existing netCDF dataset for access.

## Usage


~~~~.fortran


  function nf90_open(path, mode, ncid, bufrsize, cache_size, cache_nelems, &
                     cache_preemption, comm, info)
    implicit none
    character (len = *), intent(in) :: path
    integer, intent(in) :: mode
    integer, intent(out) :: ncid
    integer, optional, intent(inout) :: bufrsize
    integer, optional, intent(in) :: cache_size, cache_nelems
    real, optional, intent(in) :: cache_preemption
    integer, optional, intent(in) :: comm, info
    integer :: nf90_open


~~~~


`path`

:   File name for netCDF dataset to be opened. This may be an OPeNDAP
    URL if DAP support is enabled.

`mode`

:   A zero value (or NF90\_NOWRITE) specifies: open the dataset with
    read-only access, buffering and caching accesses for efficiency

    Otherwise, the open mode is NF90\_WRITE, NF90\_SHARE,
    or NF90\_WRITE|NF90\_SHARE. Setting the NF90\_WRITE flag opens the
    dataset with read-write access. ("Writing" means any kind of change
    to the dataset, including appending or changing data, adding or
    renaming dimensions, variables, and attributes, or
    deleting attributes.) The NF90\_SHARE flag is appropriate when one
    process may be writing the dataset and one or more other processes
    reading the dataset concurrently (note that this is not the same as
    parallel I/O); it means that dataset accesses are not buffered and
    caching is limited. Since the buffering scheme is optimized for
    sequential access, programs that do not access data sequentially may
    see some performance improvement by setting the NF90\_SHARE flag.

`ncid`

:   Returned netCDF ID.

The following optional argument allows additional performance tuning.

`bufrsize`

:   This parameter applies only when opening classic format or 64-bit
    offset files. It is ignored for netCDF-4/HDF5 files.

    It Controls a space versus time trade-off, memory allocated in the
    netcdf library versus number of system calls. Because of internal
    requirements, the value may not be set to exactly the
    value requested. The actual value chosen is returned.

    The library chooses a system-dependent default value if
    NF90\_SIZEHINT\_DEFAULT is supplied as input. If the "preferred I/O
    block size" is available from the stat() system call as member
    st\_blksize this value is used. Lacking that, twice the system
    pagesize is used. Lacking a call to discover the system pagesize,
    the default bufrsize is set to 8192 bytes.

    The bufrsize is a property of a given open netcdf descriptor ncid,
    it is not a persistent property of the netcdf dataset.

`cache_size`

:   If the cache\_size is provided when opening a netCDF-4/HDF5 file, it
    will be used instead of the default (32000000) as the size, in
    bytes, of the HDF5 chunk cache.

`cache_nelems`

:   If cache\_nelems is provided when opening a netCDF-4/HDF5 file, it
    will be used instead of the default (1000) as the maximum number of
    elements in the HDF5 chunk cache.

`cache_premtion`

:   If cache\_preemption is provided when opening a netCDF-4/HDF5 file,
    it will be used instead of the default (0.75) as the preemption
    value for the HDF5 chunk cache.

`comm`

:   If the comm and info parameters are provided the file is opened for
    parallel I/O. Set the comm parameter to the MPI communicator (of
    type MPI\_Comm). If this parameter is provided the info parameter
    must also be provided.

`info`

:   If the comm and info parameters are provided the file is opened for
    parallel I/O. Set the comm parameter to the MPI information value
    (of type MPI\_Info). If this parameter is provided the comm
    parameter must also be provided.



## Errors

NF90\_OPEN returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset does not exist.
-   A meaningless mode was specified.

## Example

Here is an example using NF90\_OPEN to open an existing netCDF dataset
named foo.nc for read-only, non-shared access:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open(path = "foo.nc", mode = nf90_nowrite, ncid = ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


## Example

Here is an example using NF90\_OPEN to open an existing netCDF dataset
for parallel I/O access. (Note the use of the comm and info parameters).
This example is from test program nf\_test/f90tst\_parallel.f90.


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
  ! Reopen the file.
  call handle_err(nf90_open(FILE_NAME, nf90_nowrite, ncid, comm = MPI_COMM_WORLD, &
       info = MPI_INFO_NULL))



~~~~

2.7 NF90_REDEF {#f90-nf90_redef}
=========================



The function NF90\_REDEF puts an open netCDF dataset into define mode,
so dimensions, variables, and attributes can be added or renamed and
attributes can be deleted.



## Usage


~~~~.fortran


 function nf90_redef(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_redef



~~~~

`ncid`

:   netCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_REDEF returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset is already in define mode.
-   The specified netCDF dataset was opened for read-only.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_REDEF to open an existing netCDF dataset
named foo.nc and put it into define mode:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open("foo.nc", nf90_write, ncid) ! Open dataset
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_redef(ncid)                       ! Put the file in define mode
 if (status /= nf90_noerr) call handle_err(status)



~~~~

2.8 NF90_ENDDEF {#f90-nf90_enddef}
=========================



The function NF90\_ENDDEF takes an open netCDF dataset out of define
mode. The changes made to the netCDF dataset while it was in define mode
are checked and committed to disk if no problems occurred. Non-record
variables may be initialized to a "fill value" as well (see section
[NF90_SET_FILL](#NF90_005fSET_005fFILL)). The netCDF dataset is then
placed in data mode, so variable data can be read or written.

This call may involve copying data under some circumstances. For a more
extensive discussion See [File Structure and
Performance](netcdf.html#File-Structure-and-Performance) in NetCDF Users
Guide.

## Usage


~~~~.fortran


 function nf90_enddef(ncid, h_minfree, v_align, v_minfree, r_align)
   integer,           intent( in) :: ncid
   integer, optional, intent( in) :: h_minfree, v_align, v_minfree, r_align
   integer                        :: nf90_enddef

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

The following arguments allow additional performance tuning. Note: these
arguments expose internals of the netcdf version 1 file format, and may
not be available in future netcdf implementations.

The current netcdf file format has three sections: the "header" section,
the data section for fixed size variables, and the data section for
variables which have an unlimited dimension (record variables). The
header begins at the beginning of the file. The index (offset) of the
beginning of the other two sections is contained in the header.
Typically, there is no space between the sections. This causes copying
overhead to accrue if one wishes to change the size of the sections, as
may happen when changing the names of things, text attribute values,
adding attributes or adding variables. Also, for buffered i/o, there may
be advantages to aligning sections in certain ways.

The minfree parameters allow one to control costs of future calls to
nf90\_redef or nf90\_enddef by requesting that some space be available
at the end of the section. The default value for both h\_minfree and
v\_minfree is 0.

The align parameters allow one to set the alignment of the beginning of
the corresponding sections. The beginning of the section is rounded up
to an index which is a multiple of the align parameter. The flag value
NF90\_ALIGN\_CHUNK tells the library to use the bufrsize (see above) as
the align parameter. The default value for both v\_align and r\_align is
4 bytes.

`h_minfree`

:   Size of the pad (in bytes) at the end of the "header" section.

`v_minfree`

:   Size of the pad (in bytes) at the end of the data section for fixed
    size variables.

`v_align`

:   The alignment of the beginning of the data section for fixed
    size variables.

`r_align`

:   The alignment of the beginning of the data section for variables
    which have an unlimited dimension (record variables).

## Errors

NF90\_ENDDEF returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF dataset is not in define mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The size of one or more variables exceed the size constraints for
    whichever variant of the file format is in use).

## Example

Here is an example using NF90\_ENDDEF to finish the definitions of a new
netCDF dataset named foo.nc and put it into data mode:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create("foo.nc", nf90_noclobber, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  !  create dimensions, variables, attributes
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~




2.9 NF90_CLOSE {#f90-nf90_close}
=========================

The function NF90\_CLOSE closes an open netCDF dataset. If the dataset
is in define mode, NF90\_ENDDEF will be called before closing. (In this
case, if NF90\_ENDDEF returns an error, NF90\_ABORT will automatically
be called to restore the dataset to the consistent state before define
mode was last entered.) After an open netCDF dataset is closed, its
netCDF ID may be reassigned to the next netCDF dataset that is opened or
created.



## Usage



~~~~.fortran

 function nf90_close(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_close


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_CLOSE returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   Define mode was entered and the automatic call made to
    NF90\_ENDDEF failed.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_CLOSE to finish the definitions of a new
netCDF dataset named foo.nc and release its netCDF ID:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_create("foo.nc", nf90_noclobber, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  !  create dimensions, variables, attributes
 status = nf90_close(ncid)
 if (status /= nf90_noerr) call handle_err(status)

~~~~



2.10 NF90_INQUIRE Family {#f90-nf90_inquire-family}
=========================

The NF90\_INQUIRE subroutine returns information about an open netCDF
dataset, given its netCDF ID. The subroutine can be called from either
define mode or data mode, and returns values for any or all of the
following: the number of dimensions, the number of variables, the number
of global attributes, and the dimension ID of the dimension defined with
unlimited length, if any. An additional function, NF90\_INQ\_FORMAT,
returns the (rarely needed) format version.

No I/O is performed when NF90\_INQUIRE is called, since the required
information is available in memory for each open netCDF dataset.

## Usage


~~~~.fortran


 function nf90_inquire(ncid, nDimensions, nVariables, nAttributes, &
                       unlimitedDimId, formatNum)
   integer,           intent( in) :: ncid
   integer, optional, intent(out) :: nDimensions, nVariables, &
                                     nAttributes, unlimitedDimId, &
                                     formatNum
   integer                        :: nf90_inquire



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`nDimensions`

:   Returned number of dimensions defined for this netCDF dataset.

`nVariables`

:   Returned number of variables defined for this netCDF dataset.

`nAttributes`

:   Returned number of global attributes defined for this
    netCDF dataset.

`unlimitedDimID`

:   Returned ID of the unlimited dimension, if there is one for this
    netCDF dataset. If no unlimited length dimension has been defined,
    -1 is returned.

`format`

:   Returned integer indicating format version for this dataset, one of
    nf90\_format\_classic, nf90\_format\_64bit, nf90\_format\_netcdf4,
    or nf90\_format\_netcdf4\_classic. These are rarely needed by users
    or applications, since thhe library recognizes the format of a file
    it is accessing and handles it accordingly.



## Errors

Function NF90\_INQUIRE returns the value NF90\_NOERR if no errors
occurred. Otherwise, the returned status indicates an error. Possible
causes of errors include:

-   The specified netCDF ID does not refer to an open netCDF dataset.

## Example

Here is an example using NF90\_INQUIRE to find out about a netCDF
dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, nDims, nVars, nGlobalAtts, unlimDimID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_inquire(ncid, nDims, nVars, nGlobalAtts, unlimdimid)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_inquire(ncid, nDimensions = nDims, &
                       unlimitedDimID = unlimdimid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


2.11 NF90_SYNC {#f90-nf90_sync}
=========================



The function NF90\_SYNC offers a way to synchronize the disk copy of a
netCDF dataset with in-memory buffers. There are two reasons you might
want to synchronize after writes:

-   To minimize data loss in case of abnormal termination, or
-   To make data available to other processes for reading immediately
    after it is written. But note that a process that already had the
    dataset open for reading would not see the number of records
    increase when the writing process calls NF90\_SYNC; to accomplish
    this, the reading process must call NF90\_SYNC.

This function is backward-compatible with previous versions of the
netCDF library. The intent was to allow sharing of a netCDF dataset
among multiple readers and one writer, by having the writer call
NF90\_SYNC after writing and the readers call NF90\_SYNC before each
read. For a writer, this flushes buffers to disk. For a reader, it makes
sure that the next read will be from disk rather than from previously
cached buffers, so that the reader will see changes made by the writing
process (e.g., the number of records written) without having to close
and reopen the dataset. If you are only accessing a small amount of
data, it can be expensive in computer resources to always synchronize to
disk after every write, since you are giving up the benefits of
buffering.

An easier way to accomplish sharing (and what is now recommended) is to
have the writer and readers open the dataset with the NF90\_SHARE flag,
and then it will not be necessary to call NF90\_SYNC at all. However,
the NF90\_SYNC function still provides finer granularity than the
NF90\_SHARE flag, if only a few netCDF accesses need to be synchronized
among processes.

It is important to note that changes to the ancillary data, such as
attribute values, are not propagated automatically by use of the
NF90\_SHARE flag. Use of the NF90\_SYNC function is still required for
this purpose.

Sharing datasets when the writer enters define mode to change the data
schema requires extra care. In previous releases, after the writer left
define mode, the readers were left looking at an old copy of the
dataset, since the changes were made to a new copy. The only way readers
could see the changes was by closing and reopening the dataset. Now the
changes are made in place, but readers have no knowledge that their
internal tables are now inconsistent with the new dataset schema. If
netCDF datasets are shared across redefinition, some mechanism external
to the netCDF library must be provided that prevents access by readers
during redefinition and causes the readers to call NF90\_SYNC before any
subsequent access.

When calling NF90\_SYNC, the netCDF dataset must be in data mode. A
netCDF dataset in define mode is synchronized to disk only when
NF90\_ENDDEF is called. A process that is reading a netCDF dataset that
another process is writing may call NF90\_SYNC to get updated with the
changes made to the data by the writing process (e.g., the number of
records written), without having to close and reopen the dataset.

Data is automatically synchronized to disk when a netCDF dataset is
closed, or whenever you leave define mode.


## Usage


~~~~.fortran


 function nf90_sync(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_sync



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_SYNC returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The netCDF dataset is in define mode.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_SYNC to synchronize the disk writes of a
netCDF dataset named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 ! write data or change attributes
 ...  
 status = NF90_SYNC(ncid)
 if (status /= nf90_noerr) call handle_err(status)


~~~~


2.12 NF90_ABORT {#f90-nf90_abort}
=========================



You no longer need to call this function, since it is called
automatically by NF90\_CLOSE in case the dataset is in define mode and
something goes wrong with committing the changes. The function
NF90\_ABORT just closes the netCDF dataset, if not in define mode. If
the dataset is being created and is still in define mode, the dataset is
deleted. If define mode was entered by a call to NF90\_REDEF, the netCDF
dataset is restored to its state before definition mode was entered and
the dataset is closed.



## Usage


~~~~.fortran


 function nf90_abort(ncid)
   integer, intent( in) :: ncid
   integer              :: nf90_abort


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.



## Errors

NF90\_ABORT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   When called from define mode while creating a netCDF dataset,
    deletion of the dataset failed.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_ABORT to back out of redefinitions of a
dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, LatDimID
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_redef(ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 status = nf90_def_dim(ncid, "Lat", 18, LatDimID)
 if (status /= nf90_noerr) then ! Dimension definition failed
   call handle_err(status)
   status = nf90_abort(ncid) ! Abort redefinitions
   if (status /= nf90_noerr) call handle_err(status)
 end if
...


~~~~



2.13 NF90_SET_FILL {#f90-nf90_set_fill}
=========================



This function is intended for advanced usage, to optimize writes under
some circumstances described below. The function NF90\_SET\_FILL sets
the fill mode for a netCDF dataset open for writing and returns the
current fill mode in a return parameter. The fill mode can be specified
as either NF90\_FILL or NF90\_NOFILL. The default behavior corresponding
to NF90\_FILL is that data is pre-filled with fill values, that is fill
values are written when you create non-record variables or when you
write a value beyond data that has not yet been written. This makes it
possible to detect attempts to read data before it was written. See
section [Fill Values](#Fill-Values), for more information on the use of
fill values. See [Attribute
Conventions](netcdf.html#Attribute-Conventions) in {No value for
‘n-man’}, for information about how to define your own fill values.

The behavior corresponding to NF90\_NOFILL overrides the default
behavior of prefilling data with fill values. This can be used to
enhance performance, because it avoids the duplicate writes that occur
when the netCDF library writes fill values that are later overwritten
with data.

A value indicating which mode the netCDF dataset was already in is
returned. You can use this value to temporarily change the fill mode of
an open netCDF dataset and then restore it to the previous mode.

After you turn on NF90\_NOFILL mode for an open netCDF dataset, you must
be certain to write valid data in all the positions that will later be
read. Note that nofill mode is only a transient property of a netCDF
dataset open for writing: if you close and reopen the dataset, it will
revert to the default behavior. You can also revert to the default
behavior by calling NF90\_SET\_FILL again to explicitly set the fill
mode to NF90\_FILL.

There are three situations where it is advantageous to set nofill mode:

1.  Creating and initializing a netCDF dataset. In this case, you should
    set nofill mode before calling NF90\_ENDDEF and then write
    completely all non-record variables and the initial records of all
    the record variables you want to initialize.
2.  Extending an existing record-oriented netCDF dataset. Set nofill
    mode after opening the dataset for writing, then append the
    additional records to the dataset completely, leaving no intervening
    unwritten records.
3.  Adding new variables that you are going to initialize to an existing
    netCDF dataset. Set nofill mode before calling NF90\_ENDDEF then
    write all the new variables completely.

If the netCDF dataset has an unlimited dimension and the last record was
written while in nofill mode, then the dataset may be shorter than if
nofill mode was not set, but this will be completely transparent if you
access the data only through the netCDF interfaces.

The use of this feature may not be available (or even needed) in future
releases. Programmers are cautioned against heavy reliance upon this
feature.



## Usage


~~~~.fortran


 function nf90_set_fill(ncid, fillmode, old_mode)
   integer, intent( in) :: ncid, fillmode
   integer, intent(out) :: old_mode
   integer              :: nf90_set_fill



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`fillmode`

:   Desired fill mode for the dataset, either NF90\_NOFILL
    or NF90\_FILL.

`old_mode`

:   Returned current fill mode of the dataset before this call, either
    NF90\_NOFILL or NF90\_FILL.



## Errors

NF90\_SET\_FILL returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The specified netCDF ID refers to a dataset open for
    read-only access.
-   The fill mode argument is neither NF90\_NOFILL nor NF90\_FILL..

## Example

Here is an example using NF90\_SET\_FILL to set nofill mode for
subsequent writes of a netCDF dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, oldMode
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...  
 ! Write data with prefilling behavior
 ...  
 status = nf90_set_fill(ncid, nf90_nofill, oldMode)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 !  Write data with no prefilling
 ...

~~~~

3 Groups {#f90_groups}
========

[TOC]

NetCDF-4 added support for hierarchical groups within netCDF datasets.

Groups are identified with a ncid, which identifies both the open file,
and the group within that file. When a file is opened with NF90\_OPEN or
NF90\_CREATE, the ncid for the root group of that file is provided.
Using that as a starting point, users can add new groups, or list and
navigate existing groups.

All netCDF calls take a ncid which determines where the call will take
its action. For example, the NF90\_DEF\_VAR function takes a ncid as its
first parameter. It will create a variable in whichever group its ncid
refers to. Use the root ncid provided by NF90\_CREATE or NF90\_OPEN to
create a variable in the root group. Or use NF90\_DEF\_GRP to create a
group and use its ncid to define a variable in the new group.

Variable are only visible in the group in which they are defined. The
same applies to attributes. “Global” attributes are defined in whichever
group is refered to by the ncid.

Dimensions are visible in their groups, and all child groups.

Group operations are only permitted on netCDF-4 files - that is, files
created with the HDF5 flag in nf90\_create. (see section
[NF90_CREATE](#NF90_005fCREATE)). Groups are not compatible with the
netCDF classic data model, so files created with the
NF90\_CLASSIC\_MODEL file cannot contain groups (except the root group).


3.1 Find a Group ID: NF90_INQ_NCID {#f90-find-a-group-id-nf90_inq_ncid}
=========================

Given an ncid and group name (NULL or "" gets root group), return ncid
of the named group.

## Usage


~~~~.fortran


  function nf90_inq_ncid(ncid, name, grp_ncid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: grp_ncid
    integer :: nf90_inq_ncid


~~~~


`NCID`

:   The group id for this operation.

`NAME`

:   A character array that holds the name of the desired group. Must be
    less then NF90\_MAX\_NAME.

`GRPID`

:   The ID of the group will go here.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

This example is from nf90\_test/ftst\_groups.F.


3.2 Get a List of Groups in a Group: NF90_INQ_GRPS {#f90-get-a-list-of-groups-in-a-group-nf90_inq_grps}
=========================



Given a location id, return the number of groups it contains, and an
array of their ncids.



## Usage

~~~~.fortran



  function nf90_inq_grps(ncid, numgrps, ncids)
    integer, intent(in) :: ncid
    integer, intent(out) :: numgrps
    integer, intent(out) :: ncids
    integer :: nf90_inq_grps



~~~~

`NCID`

:   The group id for this operation.

`NUMGRPS`

:   An integer which will get number of groups in this group.

`NCIDS`

:   An array of ints which will receive the IDs of all the groups in
    this group.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

3.3 Find all the Variables in a Group: NF90_INQ_VARIDS {#f90-find-all-the-variables-in-a-group-nf90_inq_varids}
=========================

Find all varids for a location.



## Usage


~~~~.fortran


  function nf90_inq_varids(ncid, nvars, varids)
    integer, intent(in) :: ncid
    integer, intent(out) :: nvars
    integer, intent(out) :: varids
    integer :: nf90_inq_varids


~~~~


`NCID`

:   The group id for this operation.

`VARIDS`

:   An already allocated array to store the list of varids. Use
    nf90\_inq\_nvars to find out how many variables there are. (see
    section [Get Information about a Variable from Its ID:
    NF90_INQUIRE_VARIABLE](#NF90_005fINQUIRE_005fVARIABLE)).



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

3.4 Find all Dimensions Visible in a Group: NF90_INQ_DIMIDS {#f90-find-all-dimensions-visible-in-a-group-nf90_inq_dimids}
=========================



Find all dimids for a location. This finds all dimensions in a group, or
any of its parents.



## Usage


~~~~.fortran


  function nf90_inq_dimids(ncid, ndims, dimids, include_parents)
    integer, intent(in) :: ncid
    integer, intent(out) :: ndims
    integer, intent(out) :: dimids
    integer, intent(out) :: include_parents
    integer :: nf90_inq_dimids


~~~~


`NCID`

:   The group id for this operation.

`NDIMS`

:   Returned number of dimensions for this location. If include\_parents
    is non-zero, number of dimensions visible from this group, which
    includes dimensions in parent groups.

`DIMIDS`

:   An array of ints when the dimids of the visible dimensions will
    be stashed. Use nf90\_inq\_ndims to find out how many dims are
    visible from this group. (see section [Get Information about a Variable from Its ID: NF90_INQUIRE_VARIABLE](#f90-get-information-about-a-variable-from-its-id-nf90_inquire_variable) ).

`INCLUDE_PARENTS`

:   If zero, only the group specified by NCID will be searched
    for dimensions. Otherwise parent groups will be searched too.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

3.5 Find the Length of a Group’s Full Name: NF90_INQ_GRPNAME_LEN {#f90-find-the-length-of-a-groups-full-name-nf90_inq_grpname_len}
=========================

Given ncid, find length of the full name. (Root group is named "/", with
length 1.)

## Usage


~~~~.fortran


  function nf90_inq_grpname_len(ncid, len)
    integer, intent(in) :: ncid
    integer, intent(out) :: len
    integer :: nf90_inq_grpname_len
  end function nf90_inq_grpname_len


~~~~


`NCID`

:   The group id for this operation.

`LEN`

:   An integer where the length will be placed.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example


3.6 Find a Group’s Name: NF90_INQ_GRPNAME {#f90-find-a-groups-name-nf90_inq_grpname}
=========================



Given ncid, find relative name of group. (Root group is named "/").

The name provided by this function is relative to the parent group. For
a full path name for the group is, with all parent groups included,
separated with a forward slash (as in Unix directory names) See section
[Find a Group’s Full Name:
NF90_INQ_GRPNAME_FULL](#f90-find-a-groups-full-name-nf90_inq_grpname_full).



## Usage



~~~~.fortran

  function nf90_inq_grpname(ncid, name)
    integer, intent(in) :: ncid
    character (len = *), intent(out) :: name
    integer :: nf90_inq_grpname


~~~~


`NCID`

:   The group id for this operation.

`NAME`

:   The name of the group will be copied to this character array. The
    name will be less than NF90\_MAX\_NAME in length.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example


3.7 Find a Group’s Full Name: NF90_INQ_GRPNAME_FULL {#f90-find-a-groups-full-name-nf90_inq_grpname_full}
=========================



Given ncid, find complete name of group. (Root group is named "/").

The name provided by this function is a full path name for the group is,
with all parent groups included, separated with a forward slash (as in
Unix directory names). For a name relative to the parent group See
section [Find a Group’s Name:
NF90_INQ_GRPNAME](#f90-find-a-groups-name-nf90_inq_grpname).

## Usage


~~~~.fortran


  function nf90_inq_grpname_full(ncid, len, name)
    integer, intent(in) :: ncid
    integer, intent(out) :: len
    character (len = *), intent(out) :: name
    integer :: nf90_inq_grpname_full


~~~~


`NCID`

:   The group id for this operation.

`LEN`

:   The length of the full group name will go here.

`NAME`

:   The name of the group will be copied to this character array.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

This example is from test program nf\_test/f90tst\_grps.f90.


~~~~.fortran


  call check(nf90_inq_grpname_full(grpid1, len, name_in))
  if (name_in .ne. grp1_full_name) stop 62

~~~~



3.8 Find a Group’s Parent: NF90_INQ_GRP_PARENT {#f90-find-a-groups-parent-nf90_inq_grp_parent}
=========================



Given ncid, find the ncid of the parent group.

When used with the root group, this function returns the NF90\_ENOGRP
error (since the root group h has no parent.)



## Usage

~~~~.fortran



  function nf90_inq_grp_parent(ncid, parent_ncid)
    integer, intent(in) :: ncid
    integer, intent(out) :: parent_ncid
    integer :: nf90_inq_grp_parent


~~~~


`NCID`

:   The group id.

`PARENT_NCID`

:   The ncid of the parent group will be copied here.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENOGRP`

:   No parent group found (i.e. this is the root group).

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

3.9 Find a Group by Name: NF90_INQ_GRP_NCID {#f90-find-a-group-by-name-nf90_inq_grp_ncid}
=========================

Given a group name an an ncid, find the ncid of the group id.

## Usage


~~~~.fortran


  function nf90_inq_grp_ncid(ncid, name, grpid)
    integer, intent(in) :: ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: grpid
    integer :: nf90_inq_grp_ncid

    nf90_inq_grp_ncid = nf_inq_grp_ncid(ncid, name, grpid)
  end function nf90_inq_grp_ncid

~~~~



`NCID`

:   The group id to look in.

`GRP_NAME`

:   The name of the group that should be found.

`GRP_NCID`

:   This will get the group id, if it is found.



## Return Codes


The following return codes may be returned by this function.

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_EINVAL`

:   No name provided or name longer than NF90\_MAX\_NAME.

`NF90_ENOGRP`

:   Named group not found.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

This example is from test program nf\_test/f90tst\_grps.f90.


~~~~.fortran


  ! Get the group ids for the newly reopened file.
  call check(nf90_inq_grp_ncid(ncid, GRP1_NAME, grpid1))
  call check(nf90_inq_grp_ncid(grpid1, GRP2_NAME, grpid2))
  call check(nf90_inq_grp_ncid(grpid2, GRP3_NAME, grpid3))
  call check(nf90_inq_grp_ncid(grpid3, GRP4_NAME, grpid4))


~~~~


3.10 Find a Group by its Fully-qualified Name: NF90_INQ_GRP_FULL_NCID {#f90-find-a-group-by-its-fully-qualified-name-nf90_inq_grp_full_ncid}
=========================
Given a fully qualified group name an an ncid, find the ncid of the
group id.



## Usage


~~~~.fortran


  function nf90_inq_grpname_full(ncid, len, name)
    integer, intent(in) :: ncid
    integer, intent(out) :: len
    character (len = *), intent(out) :: name
    integer :: nf90_inq_grpname_full

    nf90_inq_grpname_full = nf_inq_grpname_full(ncid, len, name)
  end function nf90_inq_grpname_full


~~~~


`NCID`

:   The group id to look in.

`FULL_NAME`

:   The fully-qualified group name.

`GRP_NCID`

:   This will get the group id, if it is found.



## Return Codes

The following return codes may be returned by this function.

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_EINVAL`

:   No name provided or name longer than NF90\_MAX\_NAME.

`NF90_ENOGRP`

:   Named group not found.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.



## Example

This example is from test program nf\_test/tstf90\_grps.f90.


~~~~.fortran


  ! Check for the groups with full group names.
  write(grp1_full_name, '(AA)') '/', GRP1_NAME
  call check(nf90_inq_grp_full_ncid(ncid, grp1_full_name, grpid1))


~~~~


3.11 Create a New Group: NF90_DEF_GRP {#f90-create-a-new-group-nf90_def_grp}
=========================



Create a group. Its location id is returned in new\_ncid.



## Usage


~~~~.fortran


  function nf90_def_grp(parent_ncid, name, new_ncid)
    integer, intent(in) :: parent_ncid
    character (len = *), intent(in) :: name
    integer, intent(out) :: new_ncid
    integer :: nf90_def_grp



~~~~

`PARENT_NCID`

:   The group id of the parent group.

`NAME`

:   The name of the new group, which must be different from the name of
    any variable within the same parent group.

`NEW_NCID`

:   The ncid of the new group will be placed there.



## Errors

`NF90_NOERR`

:   No error.

`NF90_EBADID`

:   Bad group id.

`NF90_ENAMEINUSE`

:   That name is in use. Group names must be unique within a group.

`NF90_EMAXNAME`

:   Name exceed max length NF90\_MAX\_NAME.

`NF90_EBADNAME`

:   Name contains illegal characters.

`NF90_ENOTNC4`

:   Attempting a netCDF-4 operation on a netCDF-3 file. NetCDF-4
    operations can only be performed on files defined with a create mode
    which includes flag HDF5. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_ESTRICTNC3`

:   This file was created with the strict netcdf-3 flag, therefore
    netcdf-4 operations are not allowed. (see section
    [NF90_OPEN](#NF90_005fOPEN)).

`NF90_EHDFERR`

:   An error was reported by the HDF5 layer.

`NF90_EPERM`

:   Attempt to write to a read-only file.

`NF90_ENOTINDEFINE`

:   Not in define mode.



## Example


~~~~.fortran


C     Create the netCDF file.
      retval = nf90_create(file_name, NF90_NETCDF4, ncid)
      if (retval .ne. nf90_noerr) call handle_err(retval)

C     Create a group and a subgroup.
      retval = nf90_def_grp(ncid, group_name, grpid)
      if (retval .ne. nf90_noerr) call handle_err(retval)
      retval = nf90_def_grp(grpid, sub_group_name, sub_grpid)
      if (retval .ne. nf90_noerr) call handle_err(retval)

~~~~

7 Attributes {#f90-attributes}
============

[TOC]

7.1 Attributes Introduction {#f90-attributes-introduction}
============

Attributes may be associated with each netCDF variable to specify such
properties as units, special values, maximum and minimum valid values,
scaling factors, and offsets. Attributes for a netCDF dataset are
defined when the dataset is first created, while the netCDF dataset is
in define mode. Additional attributes may be added later by reentering
define mode. A netCDF attribute has a netCDF variable to which it is
assigned, a name, a type, a length, and a sequence of one or more
values. An attribute is designated by its variable ID and name. When an
attribute name is not known, it may be designated by its variable ID and
number in order to determine its name, using the function
NF90\_INQ\_ATTNAME.

The attributes associated with a variable are typically defined
immediately after the variable is created, while still in define mode.
The data type, length, and value of an attribute may be changed even
when in data mode, as long as the changed attribute requires no more
space than the attribute as originally defined.

It is also possible to have attributes that are not associated with any
variable. These are called global attributes and are identified by using
NF90\_GLOBAL as a variable pseudo-ID. Global attributes are usually
related to the netCDF dataset as a whole and may be used for purposes
such as providing a title or processing history for a netCDF dataset.

Attributes are much more useful when they follow established community
conventions. See [Attribute
Conventions](netcdf.html#Attribute-Conventions) in {No value for
‘n-man’}.

Operations supported on attributes are:

-   Create an attribute, given its variable ID, name, data type, length,
    and value.
-   Get attribute’s data type and length from its variable ID and name.
-   Get attribute’s value from its variable ID and name.
-   Copy attribute from one netCDF variable to another.
-   Get name of attribute from its number.
-   Rename an attribute.
-   Delete an attribute.



7.2 Create an Attribute: NF90_PUT_ATT {#f90-create-an-attribute-nf90_put_att}
============



The function NF90\_PUT\_ATTadds or changes a variable attribute or
global attribute of an open netCDF dataset. If this attribute is new, or
if the space required to store the attribute is greater than before, the
netCDF dataset must be in define mode.



## Usage

Although it’s possible to create attributes of all types, text and
double attributes are adequate for most purposes.


~~~~.fortran


 function nf90_put_att(ncid, varid, name, values)
   integer,            intent( in) :: ncid, varid
   character(len = *), intent( in) :: name
   scalar character string or any numeric type, scalar, or array of rank 1, &
                       intent( in) :: values
   integer                         :: nf90_put_att


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID of the variable to which the attribute will be assigned
    or NF90\_GLOBAL for a global attribute.

`name`

:   Attribute name. Attribute name conventions are assumed by some
    netCDF generic applications, e.g., ‘units’ as the name for a string
    attribute that gives the units for a netCDF variable. See [Attribute
    Conventions](netcdf.html#Attribute-Conventions) in {No value
    for ‘n-man’}.

`values`

:   A numeric rank 1 array of attribute values or a scalar. The external
    data type of the attribute is set to match the internal
    representation of the argument, that is if values is a two byte
    integer array, the attribute will be of type NF90\_INT2. Fortran 90
    intrinsic functions can be used to convert attributes to the
    desired type.



## Errors

NF90\_PUT\_ATT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified netCDF type is invalid.
-   The specified length is negative.
-   The specified open netCDF dataset is in data mode and the specified
    attribute would expand.
-   The specified open netCDF dataset is in data mode and the specified
    attribute does not already exist.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   The number of attributes for this variable exceeds NF90\_MAX\_ATTRS.



## Example

Here is an example using NF90\_PUT\_ATT to add a variable attribute
named valid\_range for a netCDF variable named rh and a global attribute
named title to an existing netCDF dataset named foo.nc:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid, status, RHVarID
 ...
 status = nf90_open("foo.nc", nf90_write, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Enter define mode so we can add the attribute
 status = nf90_redef(ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ! Get the variable ID for "rh"...
 status = nf90_inq_varid(ncid, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 ! ...  put the range attribute, setting it to eight byte reals...
 status = nf90_put_att(ncid, RHVarID, "valid_range", real((/ 0, 100 /))
 ! ... and the title attribute.
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_put_att(ncid, RHVarID, "title", "example netCDF dataset") )
 if (status /= nf90_noerr) call handle_err(status)
 ! Leave define mode
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)



~~~~


7.3 Get Information about an Attribute: NF90_INQUIRE_ATTRIBUTE and NF90_INQ_ATTNAME {#f90-get-information-about-an-attribute-nf90_inquire_attribute-and-nf90_inq_attname}
============



The function NF90\_INQUIRE\_ATTRIBUTE returns information about a netCDF
attribute given the variable ID and attribute name. Information about an
attribute includes its type, length, name, and number. See
NF90\_GET\_ATT for getting attribute values.

The function NF90\_INQ\_ATTNAME gets the name of an attribute, given its
variable ID and number. This function is useful in generic applications
that need to get the names of all the attributes associated with a
variable, since attributes are accessed by name rather than number in
all other attribute functions. The number of an attribute is more
volatile than the name, since it can change when other attributes of the
same variable are deleted. This is why an attribute number is not called
an attribute ID.



## Usage



~~~~.fortran

 function nf90_inquire_attribute(ncid, varid, name, xtype, len, attnum)
   integer,             intent( in)           :: ncid, varid
   character (len = *), intent( in)           :: name
   integer,             intent(out), optional :: xtype, len, attnum
   integer                                    :: nf90_inquire_attribute
 function nf90_inq_attname(ncid, varid, attnum, name)
   integer,             intent( in) :: ncid, varid, attnum
   character (len = *), intent(out) :: name
   integer                          :: nf90_inq_attname


~~~~


`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID of the attribute’s variable, or NF90\_GLOBAL for a
    global attribute.

`name`

:   Attribute name. For NF90\_INQ\_ATTNAME, this is a pointer to the
    location for the returned attribute name.

`xtype`

:   Returned attribute type, one of the set of predefined netCDF
    external data types. The valid netCDF external data types are
    NF90\_BYTE, NF90\_CHAR, NF90\_SHORT, NF90\_INT, NF90\_FLOAT,
    and NF90\_DOUBLE.

`len`

:   Returned number of values currently stored in the attribute. For a
    string-valued attribute, this is the number of characters in
    the string.

`attnum`

:   For NF90\_INQ\_ATTNAME, the input attribute number; for
    NF90\_INQ\_ATTID, the returned attribute number. The attributes for
    each variable are numbered from 1 (the first attribute) to NATTS,
    where NATTS is the number of attributes for the variable, as
    returned from a call to NF90\_INQ\_VARNATTS.

    (If you already know an attribute name, knowing its number is not
    very useful, because accessing information about an attribute
    requires its name.)



## Errors

Each function returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified attribute does not exist.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   For NF90\_INQ\_ATTNAME, the specified attribute number is negative
    or more than the number of attributes defined for the
    specified variable.



## Example

Here is an example using NF90\_INQUIRE\_ATTRIBUTE to inquire about the
lengths of an attribute named valid\_range for a netCDF variable named
rh and a global attribute named title in an existing netCDF dataset
named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid, status
 integer :: RHVarID                       ! Variable ID
 integer :: validRangeLength, titleLength ! Attribute lengths
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Get the variable ID for "rh"...
 status = nf90_inq_varid(ncid, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 ! ...  get the length of the "valid_range" attribute...
 status = nf90_inquire_attribute(ncid, RHVarID, "valid_range", &
                           len = validRangeLength)
 if (status /= nf90_noerr) call handle_err(status)
 ! ... and the global title attribute.
 status = nf90_inquire_attribute(ncid, nf90_global, "title", len = titleLength)
 if (status /= nf90_noerr) call handle_err(status)



~~~~

7.4 Get Attribute’s Values: NF90_GET_ATT {#f90-get-attributes-values-nf90_get_att}
============



Function nf90\_get\_att gets the value(s) of a netCDF attribute, given
its variable ID and name.



## Usage



~~~~.fortran

 function nf90_get_att(ncid, varid, name, values)
   integer,            intent( in) :: ncid, varid
   character(len = *), intent( in) :: name
   any valid type, scalar or array of rank 1, &
                       intent(out) :: values
   integer                         :: nf90_get_att



~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   Variable ID of the attribute’s variable, or NF90\_GLOBAL for a
    global attribute.

`name`

:   Attribute name.

`values`

:   Returned attribute values. All elements of the vector of attribute
    values are returned, so you must provide enough space to hold them.
    If you don’t know how much space to reserve, call
    NF90\_INQUIRE\_ATTRIBUTE first to find out the length of
    the attribute. If there is only a single attribute values may be
    a scalar. If the attribute is of type character values should be a
    varble of type character with the len Fortran 90 attribute set to
    an appropriate value (i.e. character (len = 80) :: values). You
    cannot read character data from a numeric variable or numeric data
    from a text variable. For numeric data, if the type of data differs
    from the netCDF variable type, type conversion will occur. See [Type
    Conversion](netcdf.html#Type-Conversion) in NetCDF Users Guide.



## Errors

~~~~.fortran

NF90\_GET\_ATT\_ type returns the value NF90\_NOERR if no errors
occurred. Otherwise, the returned status indicates an error. Possible
causes of errors include:

-   The variable ID is invalid for the specified netCDF dataset.
-   The specified attribute does not exist.
-   The specified netCDF ID does not refer to an open netCDF dataset.
-   One or more of the attribute values are out of the range of values
    representable by the desired type.

~~~~


## Example

Here is an example using NF90\_GET\_ATT to determine the values of an
attribute named valid\_range for a netCDF variable named rh and a global
attribute named title in an existing netCDF dataset named foo.nc. In
this example, it is assumed that we don’t know how many values will be
returned, so we first inquire about the length of the attributes to make
sure we have enough space to store them:


~~~~.fortran


 use netcdf
 implicit none
 integer              :: ncid, status
 integer              :: RHVarID                       ! Variable ID
 integer              :: validRangeLength, titleLength ! Attribute lengths
 real, dimension(:), allocatable, &
                      :: validRange
 character (len = 80) :: title
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Find the lengths of the attributes
 status = nf90_inq_varid(ncid, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_inquire_attribute(ncid, RHVarID, "valid_range", &
                           len = validRangeLength)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_inquire_attribute(ncid, nf90_global, "title", len = titleLength)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 !Allocate space to hold attribute values, check string lengths
 allocate(validRange(validRangeLength), stat = status)
 if(status /= 0 .or. len(title) < titleLength)
   print *, "Not enough space to put attribute values."
   exit
 end if
 ! Read the attributes.
 status = nf90_get_att(ncid, RHVarID, "valid_range", validRange)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_get_att(ncid, nf90_global, "title", title)
 if (status /= nf90_noerr) call handle_err(status)


~~~~



7.5 Copy Attribute from One NetCDF to Another: NF90_COPY_ATT {#f90-copy-attribute-from-one-netcdf-to-another-nf90_copy_att}
============



The function NF90\_COPY\_ATT copies an attribute from one open netCDF
dataset to another. It can also be used to copy an attribute from one
variable to another within the same netCDF dataset.

If used to copy an attribute of user-defined type, then that
user-defined type must already be defined in the target file. In the
case of user-defined attributes, enddef/redef is called for ncid\_in and
ncid\_out if they are in define mode. (This is the ensure that all
user-defined types are committed to the file(s) before the copy is
attempted.)



## Usage

~~~~.fortran

 function nf90_copy_att(ncid_in, varid_in, name, ncid_out, varid_out)
   integer,             intent( in) :: ncid_in,  varid_in
   character (len = *), intent( in) :: name
   integer,             intent( in) :: ncid_out, varid_out
   integer                          :: nf90_copy_att




~~~~

`ncid_in`

:   The netCDF ID of an input netCDF dataset from which the attribute
    will be copied, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid_in`

:   ID of the variable in the input netCDF dataset from which the
    attribute will be copied, or NF90\_GLOBAL for a global attribute.

`name`

:   Name of the attribute in the input netCDF dataset to be copied.

`ncid_out`

:   The netCDF ID of the output netCDF dataset to which the attribute
    will be copied, from a previous call to NF90\_OPEN or NF90\_CREATE.
    It is permissible for the input and output netCDF IDs to be
    the same. The output netCDF dataset should be in define mode if the
    attribute to be copied does not already exist for the target
    variable, or if it would cause an existing target attribute to grow.

`varid_out`

:   ID of the variable in the output netCDF dataset to which the
    attribute will be copied, or NF90\_GLOBAL to copy to a
    global attribute.



## Errors

NF90\_COPY\_ATT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The input or output variable ID is invalid for the specified
    netCDF dataset.
-   The specified attribute does not exist.
-   The output netCDF is not in define mode and the attribute is new for
    the output dataset is larger than the existing attribute.
-   The input or output netCDF ID does not refer to an open
    netCDF dataset.



## Example

Here is an example using NF90\_COPY\_ATT to copy the variable attribute
units from the variable rh in an existing netCDF dataset named foo.nc to
the variable avgrh in another existing netCDF dataset named bar.nc,
assuming that the variable avgrh already exists, but does not yet have a
units attribute:


~~~~.fortran


 use netcdf
 implicit none
 integer :: ncid1, ncid2, status
 integer :: RHVarID, avgRHVarID    ! Variable ID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid1)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_open("bar.nc", nf90_write, ncid2)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Find the IDs of the variables
 status = nf90_inq_varid(ncid1, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_inq_varid(ncid1, "avgrh", avgRHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_redef(ncid2)   ! Enter define mode
 if (status /= nf90_noerr) call handle_err(status)
 ! Copy variable attribute from "rh" in file 1 to "avgrh" in file 1
 status = nf90_copy_att(ncid1, RHVarID, "units", ncid2, avgRHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_enddef(ncid2)
 if (status /= nf90_noerr) call handle_err(status)



~~~~

7.6 Rename an Attribute: NF90_RENAME_ATT {#f90-rename-an-attribute-nf90_rename_att}
============



The function NF90\_RENAME\_ATT changes the name of an attribute. If the
new name is longer than the original name, the netCDF dataset must be in
define mode. You cannot rename an attribute to have the same name as
another attribute of the same variable.



## Usage


~~~~.fortran


 function nf90_rename_att(ncid, varid, curname, newname)
   integer,             intent( in) :: ncid,  varid
   character (len = *), intent( in) :: curname, newname
   integer                          :: nf90_rename_att




~~~~

`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE

`varid`

:   ID of the attribute’s variable, or NF90\_GLOBAL for a global
    attribute

`curname`

:   The current attribute name.

`newname`

:   The new name to be assigned to the specified attribute. If the new
    name is longer than the current name, the netCDF dataset must be in
    define mode.



## Errors

NF90\_RENAME\_ATT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified variable ID is not valid.
-   The new attribute name is already in use for another attribute of
    the specified variable.
-   The specified netCDF dataset is in data mode and the new name is
    longer than the old name.
-   The specified attribute does not exist.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_RENAME\_ATT to rename the variable
attribute units to Units for a variable rh in an existing netCDF dataset
named foo.nc:

~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid1, status
 integer :: RHVarID         ! Variable ID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Find the IDs of the variables
 status = nf90_inq_varid(ncid, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_rename_att(ncid, RHVarID, "units", "Units")
 if (status /= nf90_noerr) call handle_err(status)


~~~~


7.7 NF90_DEL_ATT {#f90-nf90_del_att}
============



The function NF90\_DEL\_ATT deletes a netCDF attribute from an open
netCDF dataset. The netCDF dataset must be in define mode.



## Usage


~~~~.fortran


 function nf90_del_att(ncid, varid, name)
   integer,             intent( in) :: ncid, varid
   character (len = *), intent( in) :: name
   integer                          :: nf90_del_att

~~~~



`ncid`

:   NetCDF ID, from a previous call to NF90\_OPEN or NF90\_CREATE.

`varid`

:   ID of the attribute’s variable, or NF90\_GLOBAL for a
    global attribute.

`name`

:   The name of the attribute to be deleted.



## Errors

NF90\_DEL\_ATT returns the value NF90\_NOERR if no errors occurred.
Otherwise, the returned status indicates an error. Possible causes of
errors include:

-   The specified variable ID is not valid.
-   The specified netCDF dataset is in data mode.
-   The specified attribute does not exist.
-   The specified netCDF ID does not refer to an open netCDF dataset.



## Example

Here is an example using NF90\_DEL\_ATT to delete the variable attribute
Units for a variable rh in an existing netCDF dataset named foo.nc:



~~~~.fortran

 use netcdf
 implicit none
 integer :: ncid1, status
 integer :: RHVarID         ! Variable ID
 ...
 status = nf90_open("foo.nc", nf90_nowrite, ncid)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 ! Find the IDs of the variables
 status = nf90_inq_varid(ncid, "rh", RHVarID)
 if (status /= nf90_noerr) call handle_err(status)
 ...
 status = nf90_redef(ncid)   ! Enter define mode
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_del_att(ncid, RHVarID, "Units")
 if (status /= nf90_noerr) call handle_err(status)
 status = nf90_enddef(ncid)
 if (status /= nf90_noerr) call handle_err(status)

~~~~
